/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","vs/base/common/strings","vs/base/node/pfs","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/id","vs/base/node/extpath","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],Z=function(q){for(var e=[],v=0,t=q.length;v<t;v++)e[v]=J[q[v]];return e};define(J[119],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function v(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=v;function t(k,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(J[120],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(M){return M?M.replace(/\$\((.*?)\)/g,(S,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(S,l,m){this.id=S,this.definition=l,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(M,S){const l=["codicon","codicon-"+M];return S&&l.push("codicon-modifier-"+S),l}e.getClassNamesArray=k;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function l(I){if(I instanceof t)return["codicon","codicon-"+I.id];const w=S.exec(I.id);if(!w)return l(t.error);const[,g,f]=w,C=["codicon","codicon-"+g];return f&&C.push("codicon-modifier-"+f.substr(1)),C}M.asClassNameArray=l;function m(I){return l(I).join(" ")}M.asClassName=m;function E(I){return"."+l(I).join(".")}M.asCSSSelector=E})(R=e.CSSIcon||(e.CSSIcon={}))}),define(J[121],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(S,l){const m=Math.pow(10,l);return Math.round(S*m)/m}class t{constructor(l,m,E,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,E))|0,this.a=v(Math.max(Math.min(1,I),0),3)}static equals(l,m){return l.r===m.r&&l.g===m.g&&l.b===m.b&&l.a===m.a}}e.RGBA=t;class k{constructor(l,m,E,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.l=v(Math.max(Math.min(1,E),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.l===m.l&&l.a===m.a}static fromRGBA(l){const m=l.r/255,E=l.g/255,I=l.b/255,w=l.a,g=Math.max(m,E,I),f=Math.min(m,E,I);let C=0,b=0;const p=(f+g)/2,y=g-f;if(y>0){switch(b=Math.min(p<=.5?y/(2*p):y/(2-2*p),1),g){case m:C=(E-I)/y+(E<I?6:0);break;case E:C=(I-m)/y+2;break;case I:C=(m-E)/y+4;break}C*=60,C=Math.round(C)}return new k(C,b,p,w)}static _hue2rgb(l,m,E){return E<0&&(E+=1),E>1&&(E-=1),E<1/6?l+(m-l)*6*E:E<1/2?m:E<2/3?l+(m-l)*(2/3-E)*6:l}static toRGBA(l){const m=l.h/360,{s:E,l:I,a:w}=l;let g,f,C;if(E===0)g=f=C=I;else{const b=I<.5?I*(1+E):I+E-I*E,p=2*I-b;g=k._hue2rgb(p,b,m+1/3),f=k._hue2rgb(p,b,m),C=k._hue2rgb(p,b,m-1/3)}return new t(Math.round(g*255),Math.round(f*255),Math.round(C*255),w)}}e.HSLA=k;class R{constructor(l,m,E,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.v=v(Math.max(Math.min(1,E),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.v===m.v&&l.a===m.a}static fromRGBA(l){const m=l.r/255,E=l.g/255,I=l.b/255,w=Math.max(m,E,I),g=Math.min(m,E,I),f=w-g,C=w===0?0:f/w;let b;return f===0?b=0:w===m?b=((E-I)/f%6+6)%6:w===E?b=(I-m)/f+2:b=(m-E)/f+4,new R(Math.round(b*60),C,w,l.a)}static toRGBA(l){const{h:m,s:E,v:I,a:w}=l,g=I*E,f=g*(1-Math.abs(m/60%2-1)),C=I-g;let[b,p,y]=[0,0,0];return m<60?(b=g,p=f):m<120?(b=f,p=g):m<180?(p=g,y=f):m<240?(p=f,y=g):m<300?(b=f,y=g):m<=360&&(b=g,y=f),b=Math.round((b+C)*255),p=Math.round((p+C)*255),y=Math.round((y+C)*255),new t(b,p,y,w)}}e.HSVA=R;class M{constructor(l){if(l)if(l instanceof t)this.rgba=l;else if(l instanceof k)this._hsla=l,this.rgba=k.toRGBA(l);else if(l instanceof R)this._hsva=l,this.rgba=R.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(l){return M.Format.CSS.parseHex(l)||M.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(l){return!!l&&t.equals(this.rgba,l.rgba)&&k.equals(this.hsla,l.hsla)&&R.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=M._relativeLuminanceForComponent(this.rgba.r),m=M._relativeLuminanceForComponent(this.rgba.g),E=M._relativeLuminanceForComponent(this.rgba.b),I=.2126*l+.7152*m+.0722*E;return v(I,4)}static _relativeLuminanceForComponent(l){const m=l/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(l){const m=this.getRelativeLuminance(),E=l.getRelativeLuminance();return m>E?(m+.05)/(E+.05):(E+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const m=this.getRelativeLuminance(),E=l.getRelativeLuminance();return m>E}isDarkerThan(l){const m=this.getRelativeLuminance(),E=l.getRelativeLuminance();return m<E}lighten(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:m,g:E,b:I,a:w}=this.rgba;return new M(new t(m,E,I,w*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const m=l.rgba,E=this.rgba.a,I=m.a,w=E+I*(1-E);if(w<1e-6)return M.transparent;const g=this.rgba.r*E/w+m.r*I*(1-E)/w,f=this.rgba.g*E/w+m.g*I*(1-E)/w,C=this.rgba.b*E/w+m.b*I*(1-E)/w;return new M(new t(g,f,C,w))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:m,g:E,b:I,a:w}=this.rgba;return new M(new t(l.rgba.r-w*(l.rgba.r-m),l.rgba.g-w*(l.rgba.g-E),l.rgba.b-w*(l.rgba.b-I),1))}flatten(...l){const m=l.reduceRight((E,I)=>M._flatten(I,E));return M._flatten(this,m)}static _flatten(l,m){const E=1-l.rgba.a;return new M(new t(E*m.rgba.r+l.rgba.a*l.rgba.r,E*m.rgba.g+l.rgba.a*l.rgba.g,E*m.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(l,m,E){if(l.isLighterThan(m))return l;E=E||.5;const I=l.getRelativeLuminance(),w=m.getRelativeLuminance();return E=E*(w-I)/w,l.lighten(E)}static getDarkerColor(l,m,E){if(l.isDarkerThan(m))return l;E=E||.5;const I=l.getRelativeLuminance(),w=m.getRelativeLuminance();return E=E*(I-w)/I,l.darken(E)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(S){let l;(function(m){let E;(function(I){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:S.Format.CSS.formatRGBA(i)}I.formatRGB=w;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}I.formatRGBA=g;function f(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(i)}I.formatHSL=f;function C(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}I.formatHSLA=C;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function p(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}I.formatHex=p;function y(i,o=!1){return o&&i.rgba.a===1?S.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}I.formatHexA=y;function d(i){return i.isOpaque()?S.Format.CSS.formatHex(i):S.Format.CSS.formatRGBA(i)}I.format=d;function h(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),n=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),s=16*a(i.charCodeAt(5))+a(i.charCodeAt(6));return new S(new t(r,n,s,1))}if(o===9){const r=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),n=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),s=16*a(i.charCodeAt(5))+a(i.charCodeAt(6)),c=16*a(i.charCodeAt(7))+a(i.charCodeAt(8));return new S(new t(r,n,s,c/255))}if(o===4){const r=a(i.charCodeAt(1)),n=a(i.charCodeAt(2)),s=a(i.charCodeAt(3));return new S(new t(16*r+r,16*n+n,16*s+s))}if(o===5){const r=a(i.charCodeAt(1)),n=a(i.charCodeAt(2)),s=a(i.charCodeAt(3)),c=a(i.charCodeAt(4));return new S(new t(16*r+r,16*n+n,16*s+s,(16*c+c)/255))}return null}I.parseHex=h;function a(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(E=m.CSS||(m.CSS={}))})(l=S.Format||(S.Format={}))}(M=e.Color||(e.Color={}))}),define(J[52],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(M){return(S,l,m)=>{let E=null,I=null;if(typeof m.value=="function"?(E="value",I=m.value):typeof m.get=="function"&&(E="get",I=m.get),!I)throw new Error("not supported");m[E]=M(I,l)}}e.createDecorator=v;function t(M,S,l){let m=null,E=null;if(typeof l.value=="function"?(m="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",E=l.get),!E)throw new Error("not supported");const I=`$memoize$${S}`;l[m]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[I]}}e.memoize=t;function k(M,S,l){return v((m,E)=>{const I=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...g){this[w]||(this[w]=l?l():void 0),clearTimeout(this[I]),S&&(this[w]=S(this[w],...g),g=[this[w]]),this[I]=setTimeout(()=>{m.apply(this,g),this[w]=l?l():void 0},M)}})}e.debounce=k;function R(M,S,l){return v((m,E)=>{const I=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,g=`$throttle$lastRun$${E}`,f=`$throttle$pending$${E}`;return function(...C){if(this[w]||(this[w]=l?l():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),S&&(this[w]=S(this[w],...C)),this[f])return;const b=this[g]+M;b<=Date.now()?(this[g]=Date.now(),m.apply(this,[this[w]]),this[w]=l?l():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[g]=Date.now(),m.apply(this,[this[w]]),this[w]=l?l():void 0},b-Date.now()))}})}e.throttle=R}),define(J[18],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function t(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=t;function k(a){l(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=k;function R(a){l(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=R;function M(a){if(a instanceof Error){const{name:i,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:d.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=M;const S="Canceled";function l(a){return a instanceof m?!0:a instanceof Error&&a.name===S&&a.message===S}e.isCancellationError=l;class m extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=m;function E(){const a=new Error(S);return a.name=a.message,a}e.canceled=E;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function w(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=w;function g(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function f(a){const i=new Error(`${a} has been disposed`);return i.name="DISPOSED",i}e.disposed=f;function C(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=C;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class h extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(J[23],Z([0,1,18]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,te=0){return j[j.length-(1+te)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,te,ie=(ae,de)=>ae===de){if(j===te)return!0;if(!j||!te||j.length!==te.length)return!1;for(let ae=0,de=j.length;ae<de;ae++)if(!ie(j[ae],te[ae]))return!1;return!0}e.equals=R;function M(j,te){const ie=j.length-1;te<ie&&(j[te]=j[ie]),j.pop()}e.removeFastWithoutKeepingOrder=M;function S(j,te,ie){return l(j.length,ae=>ie(j[ae],te))}e.binarySearch=S;function l(j,te){let ie=0,ae=j-1;for(;ie<=ae;){const de=(ie+ae)/2|0,ge=te(de);if(ge<0)ie=de+1;else if(ge>0)ae=de-1;else return de}return-(ie+1)}e.binarySearch2=l;function m(j,te){let ie=0,ae=j.length;if(ae===0)return 0;for(;ie<ae;){const de=Math.floor((ie+ae)/2);te(j[de])?ae=de:ie=de+1}return ie}e.findFirstInSorted=m;function E(j,te,ie){if(j=j|0,j>=te.length)throw new TypeError("invalid index");const ae=te[Math.floor(te.length*Math.random())],de=[],ge=[],we=[];for(const Se of te){const Ee=ie(Se,ae);Ee<0?de.push(Se):Ee>0?ge.push(Se):we.push(Se)}return j<de.length?E(j,de,ie):j<de.length+we.length?we[0]:E(j-(de.length+we.length),ge,ie)}e.quickSelect=E;function I(j,te){const ie=[];let ae;for(const de of j.slice(0).sort(te))!ae||te(ae[0],de)!==0?(ae=[de],ie.push(ae)):ae.push(de);return ie}e.groupBy=I;function w(j,te,ie){const ae=[];function de(Se,Ee,We){if(Ee===0&&We.length===0)return;const Re=ae[ae.length-1];Re&&Re.start+Re.deleteCount===Se?(Re.deleteCount+=Ee,Re.toInsert.push(...We)):ae.push({start:Se,deleteCount:Ee,toInsert:We})}let ge=0,we=0;for(;;){if(ge===j.length){de(ge,0,te.slice(we));break}if(we===te.length){de(ge,j.length-ge,[]);break}const Se=j[ge],Ee=te[we],We=ie(Se,Ee);We===0?(ge+=1,we+=1):We<0?(de(ge,1,[]),ge+=1):We>0&&(de(ge,0,[Ee]),we+=1)}return ae}e.sortedDiff=w;function g(j,te,ie){const ae=w(j,te,ie),de=[],ge=[];for(const we of ae)de.push(...j.slice(we.start,we.start+we.deleteCount)),ge.push(...we.toInsert);return{removed:de,added:ge}}e.delta=g;function f(j,te,ie){if(ie===0)return[];const ae=j.slice(0,ie).sort(te);return b(j,te,ae,ie,j.length),ae}e.top=f;function C(j,te,ie,ae,de){return ie===0?Promise.resolve([]):new Promise((ge,we)=>{(async()=>{const Se=j.length,Ee=j.slice(0,ie).sort(te);for(let We=ie,Re=Math.min(ie+ae,Se);We<Se;We=Re,Re=Math.min(Re+ae,Se)){if(We>ie&&await new Promise(Ie=>setTimeout(Ie)),de&&de.isCancellationRequested)throw new v.CancellationError;b(j,te,Ee,We,Re)}return Ee})().then(ge,we)})}e.topAsync=C;function b(j,te,ie,ae,de){for(const ge=ie.length;ae<de;ae++){const we=j[ae];if(te(we,ie[ge-1])<0){ie.pop();const Se=m(ie,Ee=>te(we,Ee)<0);ie.splice(Se,0,we)}}}function p(j){return j.filter(te=>!!te)}e.coalesce=p;function y(j){let te=0;for(let ie=0;ie<j.length;ie++)j[ie]&&(j[te]=j[ie],te+=1);j.length=te}e.coalesceInPlace=y;function d(j,te,ie){j.splice(ie,0,j.splice(te,1)[0])}e.move=d;function h(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=h;function a(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=a;function i(j,te=ie=>ie){const ie=new Set;return j.filter(ae=>{const de=te(ae);return ie.has(de)?!1:(ie.add(de),!0)})}e.distinct=i;function o(j){const te=new Set;return ie=>{const ae=j(ie);return te.has(ae)?!1:(te.add(ae),!0)}}e.uniqueFilter=o;function r(j,te){const ie=n(j,te);if(ie!==-1)return j[ie]}e.findLast=r;function n(j,te){for(let ie=j.length-1;ie>=0;ie--){const ae=j[ie];if(te(ae))return ie}return-1}e.lastIndex=n;function s(j,te){return j.length>0?j[0]:te}e.firstOrDefault=s;function c(j,te){return j.length>0?j[j.length-1]:te}e.lastOrDefault=c;function u(j,te,ie=(ae,de)=>ae===de){let ae=0;for(let de=0,ge=Math.min(j.length,te.length);de<ge&&ie(j[de],te[de]);de++)ae++;return ae}e.commonPrefixLength=u;function P(j){return[].concat(...j)}e.flatten=P;function D(j,te){let ie=typeof te=="number"?j:0;typeof te=="number"?ie=j:(ie=0,te=j);const ae=[];if(ie<=te)for(let de=ie;de<te;de++)ae.push(de);else for(let de=ie;de>te;de--)ae.push(de);return ae}e.range=D;function T(j,te,ie){return j.reduce((ae,de)=>(ae[te(de)]=ie?ie(de):de,ae),Object.create(null))}e.index=T;function _(j,te){return j.push(te),()=>U(j,te)}e.insert=_;function U(j,te){const ie=j.indexOf(te);if(ie>-1)return j.splice(ie,1),te}e.remove=U;function Q(j,te,ie){const ae=j.slice(0,te),de=j.slice(te);return ae.concat(ie,de)}e.arrayInsert=Q;function re(j,te){let ie;if(typeof te=="number"){let ae=te;ie=()=>{const de=Math.sin(ae++)*179426549;return de-Math.floor(de)}}else ie=Math.random;for(let ae=j.length-1;ae>0;ae-=1){const de=Math.floor(ie()*(ae+1)),ge=j[ae];j[ae]=j[de],j[de]=ge}}e.shuffle=re;function le(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.unshift(te))}e.pushToStart=le;function ue(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.push(te))}e.pushToEnd=ue;function se(j,te){for(const ie of te)j.push(ie)}e.pushMany=se;function fe(j,te){return Array.isArray(j)?j.map(te):te(j)}e.mapArrayOrNot=fe;function K(j){return Array.isArray(j)?j:[j]}e.asArray=K;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function F(j,te){for(const ie of j){const ae=te(ie);if(ae!==void 0)return ae}}e.mapFind=F;function A(j,te,ie){const ae=z(j,te),de=j.length,ge=ie.length;j.length=de+ge;for(let we=de-1;we>=ae;we--)j[we+ge]=j[we];for(let we=0;we<ge;we++)j[we+ae]=ie[we]}e.insertInto=A;function W(j,te,ie,ae){const de=z(j,te),ge=j.splice(de,ie);return A(j,de,ae),ge}e.splice=W;function z(j,te){return te<0?Math.max(te+j.length,0):Math.min(te,j.length)}var ee;(function(j){function te(de){return de<0}j.isLessThan=te;function ie(de){return de>0}j.isGreaterThan=ie;function ae(de){return de===0}j.isNeitherLessOrGreaterThan=ae,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function B(j,te){return(ie,ae)=>te(j(ie),j(ae))}e.compareBy=B;function H(...j){return(te,ie)=>{for(const ae of j){const de=ae(te,ie);if(!ee.isNeitherLessOrGreaterThan(de))return de}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const L=(j,te)=>j-te;e.numberComparator=L;function O(j,te){if(j.length===0)return;let ie=j[0];for(let ae=1;ae<j.length;ae++){const de=j[ae];te(de,ie)>0&&(ie=de)}return ie}e.findMaxBy=O;function N(j,te){if(j.length===0)return;let ie=j[0];for(let ae=1;ae<j.length;ae++){const de=j[ae];te(de,ie)>=0&&(ie=de)}return ie}e.findLastMaxBy=N;function V(j,te){return O(j,(ie,ae)=>-te(ie,ae))}e.findMinBy=V;class x{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ie=this.firstIdx;for(;ie<this.items.length&&te(this.items[ie]);)ie++;const ae=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,ae}takeFromEndWhile(te){let ie=this.lastIdx;for(;ie>=0&&te(this.items[ie]);)ie--;const ae=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ie=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ie}}e.ArrayQueue=x;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(ie=>(te(ie),!0))}toArray(){const te=[];return this.iterate(ie=>(te.push(ie),!0)),te}filter(te){return new ne(ie=>this.iterate(ae=>te(ae)?ie(ae):!0))}map(te){return new ne(ie=>this.iterate(ae=>ie(te(ae))))}some(te){let ie=!1;return this.iterate(ae=>(ie=te(ae),!ie)),ie}findFirst(te){let ie;return this.iterate(ae=>te(ae)?(ie=ae,!1):!0),ie}findLast(te){let ie;return this.iterate(ae=>(te(ae)&&(ie=ae),!0)),ie}findLastMaxBy(te){let ie,ae=!0;return this.iterate(de=>((ae||ee.isGreaterThan(te(de,ie)))&&(ae=!1,ie=de),!0)),ie}}e.CallbackIterable=ne,ne.empty=new ne(j=>{})}),define(J[47],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const k=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(k,arguments)),M}}e.once=v}),define(J[65],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function M(){return R}t.empty=M;function*S(o){yield o}t.single=S;function l(o){return o||R}t.from=l;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function E(o){return o[Symbol.iterator]().next().value}t.first=E;function I(o,r){for(const n of o)if(r(n))return!0;return!1}t.some=I;function w(o,r){for(const n of o)if(r(n))return n}t.find=w;function*g(o,r){for(const n of o)r(n)&&(yield n)}t.filter=g;function*f(o,r){let n=0;for(const s of o)yield r(s,n++)}t.map=f;function*C(...o){for(const r of o)for(const n of r)yield n}t.concat=C;function*b(o){for(const r of o)for(const n of r)yield n}t.concatNested=b;function p(o,r,n){let s=n;for(const c of o)s=r(s,c);return s}t.reduce=p;function y(o,r){let n=0;for(const s of o)r(s,n++)}t.forEach=y;function*d(o,r,n=o.length){for(r<0&&(r+=o.length),n<0?n+=o.length:n>o.length&&(n=o.length);r<n;r++)yield o[r]}t.slice=d;function h(o,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,o];const s=o[Symbol.iterator]();for(let c=0;c<r;c++){const u=s.next();if(u.done)return[n,t.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return s}}]}t.consume=h;function a(o){return h(o)[0]}t.collect=a;function i(o,r,n=(s,c)=>s===c){const s=o[Symbol.iterator](),c=r[Symbol.iterator]();for(;;){const u=s.next(),P=c.next();if(u.done!==P.done)return!1;if(u.done)return!0;if(!n(u.value,P.value))return!1}}t.equals=i})(v=e.Iterable||(e.Iterable={}))}),define(J[48],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(i,o=!1){let r=0;const n=i.length;let s="",c=0,u=16,P=0;function D(ue){let se=0,fe=0;for(;se<ue;){const K=i.charCodeAt(r);if(K>=48&&K<=57)fe=fe*16+K-48;else if(K>=65&&K<=70)fe=fe*16+K-65+10;else if(K>=97&&K<=102)fe=fe*16+K-97+10;else break;r++,se++}return se<ue&&(fe=-1),fe}function T(ue){r=ue,s="",c=0,u=16,P=0}function _(){const ue=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&m(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&m(i.charCodeAt(r)))for(r++;r<i.length&&m(i.charCodeAt(r));)r++;else return P=3,i.substring(ue,r);let se=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&m(i.charCodeAt(r))){for(r++;r<i.length&&m(i.charCodeAt(r));)r++;se=r}else P=3;return i.substring(ue,se)}function U(){let ue="",se=r;for(;;){if(r>=n){ue+=i.substring(se,r),P=2;break}const fe=i.charCodeAt(r);if(fe===34){ue+=i.substring(se,r),r++;break}if(fe===92){if(ue+=i.substring(se,r),r++,r>=n){P=2;break}switch(i.charCodeAt(r++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const $=D(4);$>=0?ue+=String.fromCharCode($):P=4;break}default:P=5}se=r;continue}if(fe>=0&&fe<=31)if(l(fe)){ue+=i.substring(se,r),P=2;break}else P=6;r++}return ue}function Q(){if(s="",P=0,c=r,r>=n)return c=n,u=17;let ue=i.charCodeAt(r);if(S(ue)){do r++,s+=String.fromCharCode(ue),ue=i.charCodeAt(r);while(S(ue));return u=15}if(l(ue))return r++,s+=String.fromCharCode(ue),ue===13&&i.charCodeAt(r)===10&&(r++,s+=`
`),u=14;switch(ue){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,s=U(),u=10;case 47:{const se=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!l(i.charCodeAt(r));)r++;return s=i.substring(se,r),u=12}if(i.charCodeAt(r+1)===42){r+=2;const fe=n-1;let K=!1;for(;r<fe;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,K=!0;break}r++}return K||(r++,P=1),s=i.substring(se,r),u=13}return s+=String.fromCharCode(ue),r++,u=16}case 45:if(s+=String.fromCharCode(ue),r++,r===n||!m(i.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=_(),u=11;default:for(;r<n&&re(ue);)r++,ue=i.charCodeAt(r);if(c!==r){switch(s=i.substring(c,r),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ue),r++,u=16}}function re(ue){if(S(ue)||l(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ue;do ue=Q();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>r,scan:o?le:Q,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>P}}e.createScanner=M;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function l(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var E;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(E||(E={}));function I(i,o){const r=[],n=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function P(D,T,_,U){c.value=D,c.offset=T,c.length=_,c.type=U,c.colonOffset=void 0,s=c}try{d(i,{onObjectBegin:(D,T)=>{if(o<=D)throw n;s=void 0,u=o>D,r.push("")},onObjectProperty:(D,T,_)=>{if(o<T||(P(D,T,_,"property"),r[r.length-1]=D,o<=T+_))throw n},onObjectEnd:(D,T)=>{if(o<=D)throw n;s=void 0,r.pop()},onArrayBegin:(D,T)=>{if(o<=D)throw n;s=void 0,r.push(0)},onArrayEnd:(D,T)=>{if(o<=D)throw n;s=void 0,r.pop()},onLiteralValue:(D,T,_)=>{if(o<T||(P(D,T,_,a(D)),o<=T+_))throw n},onSeparator:(D,T,_)=>{if(o<=T)throw n;if(D===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(D===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(u=!0,r[r.length-1]=""),s=void 0}}})}catch(D){if(D!==n)throw D}return{path:r,previousNode:s,isAtPropertyKey:u,matches:D=>{let T=0;for(let _=0;T<D.length&&_<r.length;_++)if(D[T]===r[_]||D[T]==="*")T++;else if(D[T]!=="**")return!1;return T===D.length}}}e.getLocation=I;function w(i,o=[],r=R.DEFAULT){let n=null,s=[];const c=[];function u(D){Array.isArray(s)?s.push(D):n!==null&&(s[n]=D)}return d(i,{onObjectBegin:()=>{const D={};u(D),c.push(s),s=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const D=[];u(D),c.push(s),s=D,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(D,T,_)=>{o.push({error:D,offset:T,length:_})}},r),s[0]}e.parse=w;function g(i,o=[],r=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function c(D){return n.children.push(D),D}d(i,{onObjectBegin:D=>{n=c({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,T,_)=>{n=c({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:T,length:_,parent:n})},onObjectEnd:(D,T)=>{n.length=D+T-n.offset,n=n.parent,s(D+T)},onArrayBegin:(D,T)=>{n=c({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,T)=>{n.length=D+T-n.offset,n=n.parent,s(D+T)},onLiteralValue:(D,T,_)=>{c({type:a(D),offset:T,length:_,parent:n,value:D}),s(T+_)},onSeparator:(D,T,_)=>{n.type==="property"&&(D===":"?n.colonOffset=T:D===","&&s(T))},onError:(D,T,_)=>{o.push({error:D,offset:T,length:_})}},r);const P=n.children[0];return P&&delete P.parent,P}e.parseTree=g;function f(i,o){if(!i)return;let r=i;for(const n of o)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===n){r=c.children[1],s=!0;break}if(!s)return}else{const s=n;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=f;function C(i){if(!i.parent||!i.parent.children)return[];const o=C(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.getNodePath=C;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const o=Object.create(null);for(const r of i.children){const n=r.children[1];n&&(o[r.children[0].value]=b(n))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function p(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.contains=p;function y(i,o,r=!1){if(p(i,o,r)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const c=y(n[s],o,r);if(c)return c}return i}}e.findNodeAtOffset=y;function d(i,o,r=R.DEFAULT){const n=M(i,!1);function s(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(B){return B?H=>B(H,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),P=c(o.onObjectProperty),D=s(o.onObjectEnd),T=s(o.onArrayBegin),_=s(o.onArrayEnd),U=c(o.onLiteralValue),Q=c(o.onSeparator),re=s(o.onComment),le=c(o.onError),ue=r&&r.disallowComments,se=r&&r.allowTrailingComma;function fe(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:ue||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(B){case 12:case 13:ue?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return B}}}function K(B,H=[],L=[]){if(le(B),H.length+L.length>0){let O=n.getToken();for(;O!==17;){if(H.indexOf(O)!==-1){fe();break}else if(L.indexOf(O)!==-1)break;O=fe()}}}function $(B){const H=n.getTokenValue();return B?U(H):P(H),fe(),!0}function F(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(K(2),B=0)}catch{K(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return fe(),!0}function A(){return n.getToken()!==10?(K(3,[],[2,5]),!1):($(!1),n.getToken()===6?(Q(":"),fe(),ee()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function W(){u(),fe();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||K(4,[],[]),Q(","),fe(),n.getToken()===2&&se)break}else B&&K(6,[],[]);A()||K(4,[],[2,5]),B=!0}return D(),n.getToken()!==2?K(7,[2],[]):fe(),!0}function z(){T(),fe();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||K(4,[],[]),Q(","),fe(),n.getToken()===4&&se)break}else B&&K(6,[],[]);ee()||K(4,[],[4,5]),B=!0}return _(),n.getToken()!==4?K(8,[4],[]):fe(),!0}function ee(){switch(n.getToken()){case 3:return z();case 1:return W();case 10:return $(!0);default:return F()}}return fe(),n.getToken()===17?r.allowEmptyContent?!0:(K(4,[],[]),!1):ee()?(n.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=d;function h(i,o){const r=M(i),n=[];let s,c=0,u;do switch(u=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:c!==u&&n.push(i.substring(c,u)),o!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(s!==17);return n.join("")}e.stripComments=h;function a(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(J[122],Z([0,1,48]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,E,I){let w,g,f,C,b;if(E){for(C=E.offset,b=C+E.length,f=C;f>0&&!l(m,f-1);)f--;let u=b;for(;u<m.length&&!l(m,u);)u++;g=m.substring(f,u),w=M(g,I)}else g=m,w=0,f=0,C=0,b=m.length;const p=S(I,m);let y=!1,d=0,h;I.insertSpaces?h=R(" ",I.tabSize||4):h="	";const a=(0,v.createScanner)(g,!1);let i=!1;function o(){return p+R(h,w+d)}function r(){let u=a.scan();for(y=!1;u===15||u===14;)y=y||u===14,u=a.scan();return i=u===16||a.getTokenError()!==0,u}const n=[];function s(u,P,D){!i&&P<b&&D>C&&m.substring(P,D)!==u&&n.push({offset:P,length:D-P,content:u})}let c=r();if(c!==17){const u=a.getTokenOffset()+f,P=R(h,w);s(P,f,u)}for(;c!==17;){let u=a.getTokenOffset()+a.getTokenLength()+f,P=r(),D="";for(;!y&&(P===12||P===13);){const _=a.getTokenOffset()+f;s(" ",u,_),u=a.getTokenOffset()+a.getTokenLength()+f,D=P===12?o():"",P=r()}if(P===2)c!==1&&(d--,D=o());else if(P===4)c!==3&&(d--,D=o());else{switch(c){case 3:case 1:d++,D=o();break;case 5:case 12:D=o();break;case 13:y?D=o():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}y&&(P===12||P===13)&&(D=o())}const T=a.getTokenOffset()+f;s(D,u,T),c=P}return n}e.format=t;function k(m,E){const I=JSON.stringify(m,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?I.replace(/\r\n|\r|\n/g,E.eol):I}e.toFormattedString=k;function R(m,E){let I="";for(let w=0;w<E;w++)I+=m;return I}function M(m,E){let I=0,w=0;const g=E.tabSize||4;for(;I<m.length;){const f=m.charAt(I);if(f===" ")w++;else if(f==="	")w+=g;else break;I++}return Math.floor(w/g)}function S(m,E){for(let I=0;I<E.length;I++){const w=E.charAt(I);if(w==="\r")return I+1<E.length&&E.charAt(I+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=S;function l(m,E){return`\r
`.indexOf(m.charAt(E))!==-1}e.isEOL=l}),define(J[123],Z([0,1,48,122]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,E,I){return R(m,E,void 0,I)}e.removeProperty=k;function R(m,E,I,w,g){const f=E.slice(),C=[],b=(0,v.parseTree)(m,C);let p,y;for(;f.length>0&&(y=f.pop(),p=(0,v.findNodeAtLocation)(b,f),p===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(p)if(p.type==="object"&&typeof y=="string"&&Array.isArray(p.children)){const d=(0,v.findNodeAtLocation)(p,[y]);if(d!==void 0)if(I===void 0){if(!d.parent)throw new Error("Malformed AST");const h=p.children.indexOf(d.parent);let a,i=d.parent.offset+d.parent.length;if(h>0){const o=p.children[h-1];a=o.offset+o.length}else a=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return M(m,{offset:a,length:i-a,content:""},w)}else return M(m,{offset:d.offset,length:d.length,content:JSON.stringify(I)},w);else{if(I===void 0)return[];const h=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,a=g?g(p.children.map(o=>o.children[0].value)):p.children.length;let i;if(a>0){const o=p.children[a-1];i={offset:o.offset+o.length,length:0,content:","+h}}else p.children.length===0?i={offset:p.offset+1,length:0,content:h}:i={offset:p.offset+1,length:0,content:h+","};return M(m,i,w)}}else if(p.type==="array"&&typeof y=="number"&&Array.isArray(p.children))if(I!==void 0){const d=`${JSON.stringify(I)}`;let h;if(p.children.length===0||y===0)h={offset:p.offset+1,length:0,content:p.children.length===0?d:d+","};else{const a=y===-1||y>p.children.length?p.children.length:y,i=p.children[a-1];h={offset:i.offset+i.length,length:0,content:","+d}}return M(m,h,w)}else{const d=y,h=p.children[d];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===d){const i=p.children[d-1],o=i.offset+i.length,r=p.offset+p.length;a={offset:o,length:r-2-o,content:""}}else a={offset:h.offset,length:p.children[d+1].offset-h.offset,content:""};return M(m,a,w)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return M(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},w)}}e.setProperty=R;function M(m,E,I){let w=S(m,E),g=E.offset,f=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;g>0&&!(0,t.isEOL)(w,g-1);)g--;for(;f<w.length&&!(0,t.isEOL)(w,f);)f++}const C=(0,t.format)(w,{offset:g,length:f-g},I);for(let p=C.length-1;p>=0;p--){const y=C[p];w=S(w,y),g=Math.min(g,y.offset),f=Math.max(f,y.offset+y.length),f+=y.content.length-y.length}const b=m.length-(w.length-f)-g;return[{offset:g,length:b,content:w.substring(g,f)}]}e.withFormatting=M;function S(m,E){return m.substring(0,E.offset)+E.content+m.substring(E.offset+E.length)}e.applyEdit=S;function l(m,E){const I=E.slice(0).sort((g,f)=>{const C=g.offset-f.offset;return C===0?g.length-f.length:C});let w=m.length;for(let g=I.length-1;g>=0;g--){const f=I[g];if(f.offset+f.length<=w)m=S(m,f);else throw new Error("Overlapping edit");w=f.offset}return m}e.applyEdits=l}),define(J[124],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(J[2],Z([0,1,47,65]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function M(s){R=s}if(e.setDisposableTracker=M,k){const s="__is_disposable_tracked__";M(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[s]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==y.None)try{c[s]=!0}catch{}}markAsDisposed(c){if(c&&c!==y.None)try{c[s]=!0}catch{}}markAsSingleton(c){}})}function S(s){return R?.trackDisposable(s),s}function l(s){R?.markAsDisposed(s)}function m(s,c){R?.setParent(s,c)}function E(s,c){if(!!R)for(const u of s)R.setParent(u,c)}function I(s){return R?.markAsSingleton(s),s}e.markAsSingleton=I;function w(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=w;function g(s){if(t.Iterable.is(s)){const c=[];for(const u of s)if(u)try{u.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=g;function f(s){for(const c of s)w(c)&&c.dispose();return[]}e.disposeIfDisposable=f;function C(...s){const c=b(()=>g(s));return E(s,c),c}e.combinedDisposable=C;function b(s){const c=S({dispose:(0,v.once)(()=>{l(c),s()})});return c}e.toDisposable=b;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return m(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new p,S(this),m(this._store,this)}dispose(){l(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&m(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&m(c,null),c}}e.MutableDisposable=d;class h{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,l(this))},this}}e.SafeDisposable=a;class i{constructor(){this.references=new Map}acquire(c,...u){let P=this.references.get(c);P||(P={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,P));const{object:D}=P,T=(0,v.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(c,P.object),this.references.delete(c))});return P.counter++,{object:D,dispose:T}}}e.ReferenceCollection=i;class o{constructor(c){this.referenceCollection=c}async acquire(c,...u){const P=this.referenceCollection.acquire(c,...u);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(D){throw P.dispose(),D}}}e.AsyncReferenceCollection=o;class r{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=r;function n(s){const c=new p;try{s(c)}finally{c.dispose()}}e.disposeOnReturn=n}),define(J[125],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const M=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=M}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const S=new v(R);if(this._first===v.Undefined)this._first=S,this._last=S;else if(M){const m=this._last;this._last=S,S.prev=m,m.next=S}else{const m=this._first;this._first=S,S.next=m,m.prev=S}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(S))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function M(l){R.push(l,Date.now())}function S(){const l=[];for(let m=0;m<R.length;m+=2)l.push({name:R[m],startTime:R[m+1]});return l}return{mark:M,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(k+M.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:q)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function v(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=q,v.c=e,v.d=function(t,k,R){v.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,k){if(1&k&&(t=v(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var M in t)v.d(R,M,function(S){return t[S]}.bind(null,M));return R},v.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(k,"a",k),k},v.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},v.p="",v(v.s=0)}([function(q,e,v){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],l=e.src=[],m=0,E=m++;l[E]="0|[1-9]\\d*";var I=m++;l[I]="[0-9]+";var w=m++;l[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=m++;l[g]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var f=m++;l[f]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var C=m++;l[C]="(?:"+l[E]+"|"+l[w]+")";var b=m++;l[b]="(?:"+l[I]+"|"+l[w]+")";var p=m++;l[p]="(?:-("+l[C]+"(?:\\."+l[C]+")*))";var y=m++;l[y]="(?:-?("+l[b]+"(?:\\."+l[b]+")*))";var d=m++;l[d]="[0-9A-Za-z-]+";var h=m++;l[h]="(?:\\+("+l[d]+"(?:\\."+l[d]+")*))";var a=m++,i="v?"+l[g]+l[p]+"?"+l[h]+"?";l[a]="^"+i+"$";var o="[v=\\s]*"+l[f]+l[y]+"?"+l[h]+"?",r=m++;l[r]="^"+o+"$";var n=m++;l[n]="((?:<|>)?=?)";var s=m++;l[s]=l[I]+"|x|X|\\*";var c=m++;l[c]=l[E]+"|x|X|\\*";var u=m++;l[u]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[p]+")?"+l[h]+"?)?)?";var P=m++;l[P]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[y]+")?"+l[h]+"?)?)?";var D=m++;l[D]="^"+l[n]+"\\s*"+l[u]+"$";var T=m++;l[T]="^"+l[n]+"\\s*"+l[P]+"$";var _=m++;l[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;l[U]="(?:~>?)";var Q=m++;l[Q]="(\\s*)"+l[U]+"\\s+",S[Q]=new RegExp(l[Q],"g");var re=m++;l[re]="^"+l[U]+l[u]+"$";var le=m++;l[le]="^"+l[U]+l[P]+"$";var ue=m++;l[ue]="(?:\\^)";var se=m++;l[se]="(\\s*)"+l[ue]+"\\s+",S[se]=new RegExp(l[se],"g");var fe=m++;l[fe]="^"+l[ue]+l[u]+"$";var K=m++;l[K]="^"+l[ue]+l[P]+"$";var $=m++;l[$]="^"+l[n]+"\\s*("+o+")$|^$";var F=m++;l[F]="^"+l[n]+"\\s*("+i+")$|^$";var A=m++;l[A]="(\\s*)"+l[n]+"\\s*("+o+"|"+l[u]+")",S[A]=new RegExp(l[A],"g");var W=m++;l[W]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var z=m++;l[z]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var ee=m++;l[ee]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,l[B]),S[B]||(S[B]=new RegExp(l[B]));function H(Y,ce){if(Y instanceof L)return Y;if(typeof Y!="string"||Y.length>R||!(ce?S[r]:S[a]).test(Y))return null;try{return new L(Y,ce)}catch{return null}}function L(Y,ce){if(Y instanceof L){if(Y.loose===ce)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(Y,ce);k("SemVer",Y,ce),this.loose=ce;var he=Y.trim().match(ce?S[r]:S[a]);if(!he)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var ke=+Pe;if(ke>=0&&ke<M)return ke}return Pe}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(Y,ce){var he=H(Y,ce);return he?he.version:null},e.clean=function(Y,ce){var he=H(Y.trim().replace(/^[=v]+/,""),ce);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(Y){return k("SemVer.compare",this.version,this.loose,Y),Y instanceof L||(Y=new L(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},L.prototype.compareMain=function(Y){return Y instanceof L||(Y=new L(Y,this.loose)),N(this.major,Y.major)||N(this.minor,Y.minor)||N(this.patch,Y.patch)},L.prototype.comparePre=function(Y){if(Y instanceof L||(Y=new L(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ce=0;do{var he=this.prerelease[ce],Pe=Y.prerelease[ce];if(k("prerelease compare",ce,he,Pe),he===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(he===void 0)return-1;if(he!==Pe)return N(he,Pe)}while(++ce)},L.prototype.inc=function(Y,ce){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ce,he,Pe){typeof he=="string"&&(Pe=he,he=void 0);try{return new L(Y,he).inc(ce,Pe).version}catch{return null}},e.diff=function(Y,ce){if(j(Y,ce))return null;var he=H(Y),Pe=H(ce);if(he.prerelease.length||Pe.prerelease.length){for(var ke in he)if((ke==="major"||ke==="minor"||ke==="patch")&&he[ke]!==Pe[ke])return"pre"+ke;return"prerelease"}for(var ke in he)if((ke==="major"||ke==="minor"||ke==="patch")&&he[ke]!==Pe[ke])return ke},e.compareIdentifiers=N;var O=/^[0-9]+$/;function N(Y,ce){var he=O.test(Y),Pe=O.test(ce);return he&&Pe&&(Y=+Y,ce=+ce),he&&!Pe?-1:Pe&&!he?1:Y<ce?-1:Y>ce?1:0}function V(Y,ce,he){return new L(Y,he).compare(new L(ce,he))}function x(Y,ce,he){return V(Y,ce,he)>0}function ne(Y,ce,he){return V(Y,ce,he)<0}function j(Y,ce,he){return V(Y,ce,he)===0}function te(Y,ce,he){return V(Y,ce,he)!==0}function ie(Y,ce,he){return V(Y,ce,he)>=0}function ae(Y,ce,he){return V(Y,ce,he)<=0}function de(Y,ce,he,Pe){var ke;switch(ce){case"===":typeof Y=="object"&&(Y=Y.version),typeof he=="object"&&(he=he.version),ke=Y===he;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof he=="object"&&(he=he.version),ke=Y!==he;break;case"":case"=":case"==":ke=j(Y,he,Pe);break;case"!=":ke=te(Y,he,Pe);break;case">":ke=x(Y,he,Pe);break;case">=":ke=ie(Y,he,Pe);break;case"<":ke=ne(Y,he,Pe);break;case"<=":ke=ae(Y,he,Pe);break;default:throw new TypeError("Invalid operator: "+ce)}return ke}function ge(Y,ce){if(Y instanceof ge){if(Y.loose===ce)return Y;Y=Y.value}if(!(this instanceof ge))return new ge(Y,ce);k("comparator",Y,ce),this.loose=ce,this.parse(Y),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Y,ce){return N(ce,Y)},e.major=function(Y,ce){return new L(Y,ce).major},e.minor=function(Y,ce){return new L(Y,ce).minor},e.patch=function(Y,ce){return new L(Y,ce).patch},e.compare=V,e.compareLoose=function(Y,ce){return V(Y,ce,!0)},e.rcompare=function(Y,ce,he){return V(ce,Y,he)},e.sort=function(Y,ce){return Y.sort(function(he,Pe){return e.compare(he,Pe,ce)})},e.rsort=function(Y,ce){return Y.sort(function(he,Pe){return e.rcompare(he,Pe,ce)})},e.gt=x,e.lt=ne,e.eq=j,e.neq=te,e.gte=ie,e.lte=ae,e.cmp=de,e.Comparator=ge;var we={};function Se(Y,ce){if(Y instanceof Se)return Y.loose===ce?Y:new Se(Y.raw,ce);if(Y instanceof ge)return new Se(Y.value,ce);if(!(this instanceof Se))return new Se(Y,ce);if(this.loose=ce,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Ee(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function We(Y,ce,he,Pe,ke,Ne,Ue,xe,Ve,Ye,Qe,$e,G){return((ce=Ee(he)?"":Ee(Pe)?">="+he+".0.0":Ee(ke)?">="+he+"."+Pe+".0":">="+ce)+" "+(xe=Ee(Ve)?"":Ee(Ye)?"<"+(+Ve+1)+".0.0":Ee(Qe)?"<"+Ve+"."+(+Ye+1)+".0":$e?"<="+Ve+"."+Ye+"."+Qe+"-"+$e:"<="+xe)).trim()}function Re(Y,ce){for(var he=0;he<Y.length;he++)if(!Y[he].test(ce))return!1;if(ce.prerelease.length){for(he=0;he<Y.length;he++)if(k(Y[he].semver),Y[he].semver!==we&&Y[he].semver.prerelease.length>0){var Pe=Y[he].semver;if(Pe.major===ce.major&&Pe.minor===ce.minor&&Pe.patch===ce.patch)return!0}return!1}return!0}function Ie(Y,ce,he){try{ce=new Se(ce,he)}catch{return!1}return ce.test(Y)}function De(Y,ce,he,Pe){var ke,Ne,Ue,xe,Ve;switch(Y=new L(Y,Pe),ce=new Se(ce,Pe),he){case">":ke=x,Ne=ae,Ue=ne,xe=">",Ve=">=";break;case"<":ke=ne,Ne=ie,Ue=x,xe="<",Ve="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(Y,ce,Pe))return!1;for(var Ye=0;Ye<ce.set.length;++Ye){var Qe=ce.set[Ye],$e=null,G=null;if(Qe.forEach(function(oe){oe.semver===we&&(oe=new ge(">=0.0.0")),$e=$e||oe,G=G||oe,ke(oe.semver,$e.semver,Pe)?$e=oe:Ue(oe.semver,G.semver,Pe)&&(G=oe)}),$e.operator===xe||$e.operator===Ve||(!G.operator||G.operator===xe)&&Ne(Y,G.semver)||G.operator===Ve&&Ue(Y,G.semver))return!1}return!0}ge.prototype.parse=function(Y){var ce=this.loose?S[$]:S[F],he=Y.match(ce);if(!he)throw new TypeError("Invalid comparator: "+Y);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=we},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(Y){return k("Comparator.test",Y,this.loose),this.semver===we||(typeof Y=="string"&&(Y=new L(Y,this.loose)),de(Y,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(Y,ce){if(!(Y instanceof ge))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Se(Y.value,ce),Ie(this.value,he,ce);if(Y.operator==="")return he=new Se(this.value,ce),Ie(Y.semver,he,ce);var Pe=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ne=this.semver.version===Y.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),xe=de(this.semver,"<",Y.semver,ce)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ve=de(this.semver,">",Y.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Pe||ke||Ne&&Ue||xe||Ve},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(Y){var ce=this.loose;Y=Y.trim(),k("range",Y,ce);var he=ce?S[z]:S[W];Y=Y.replace(he,We),k("hyphen replace",Y),Y=Y.replace(S[A],"$1$2$3"),k("comparator trim",Y,S[A]),Y=(Y=(Y=Y.replace(S[Q],"$1~")).replace(S[se],"$1^")).split(/\s+/).join(" ");var Pe=ce?S[$]:S[F],ke=Y.split(" ").map(function(Ne){return function(Ue,xe){return k("comp",Ue),Ue=function(Ve,Ye){return Ve.trim().split(/\s+/).map(function(Qe){return function($e,G){k("caret",$e,G);var oe=G?S[K]:S[fe];return $e.replace(oe,function(pe,me,ye,Le,Te){var Ke;return k("caret",$e,pe,me,ye,Le,Te),Ee(me)?Ke="":Ee(ye)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ee(Le)?Ke=me==="0"?">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0":">="+me+"."+ye+".0 <"+(+me+1)+".0.0":Te?(k("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Ke=me==="0"?ye==="0"?">="+me+"."+ye+"."+Le+Te+" <"+me+"."+ye+"."+(+Le+1):">="+me+"."+ye+"."+Le+Te+" <"+me+"."+(+ye+1)+".0":">="+me+"."+ye+"."+Le+Te+" <"+(+me+1)+".0.0"):(k("no pr"),Ke=me==="0"?ye==="0"?">="+me+"."+ye+"."+Le+" <"+me+"."+ye+"."+(+Le+1):">="+me+"."+ye+"."+Le+" <"+me+"."+(+ye+1)+".0":">="+me+"."+ye+"."+Le+" <"+(+me+1)+".0.0"),k("caret return",Ke),Ke})}(Qe,Ye)}).join(" ")}(Ue,xe),k("caret",Ue),Ue=function(Ve,Ye){return Ve.trim().split(/\s+/).map(function(Qe){return function($e,G){var oe=G?S[le]:S[re];return $e.replace(oe,function(pe,me,ye,Le,Te){var Ke;return k("tilde",$e,pe,me,ye,Le,Te),Ee(me)?Ke="":Ee(ye)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ee(Le)?Ke=">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0":Te?(k("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Ke=">="+me+"."+ye+"."+Le+Te+" <"+me+"."+(+ye+1)+".0"):Ke=">="+me+"."+ye+"."+Le+" <"+me+"."+(+ye+1)+".0",k("tilde return",Ke),Ke})}(Qe,Ye)}).join(" ")}(Ue,xe),k("tildes",Ue),Ue=function(Ve,Ye){return k("replaceXRanges",Ve,Ye),Ve.split(/\s+/).map(function(Qe){return function($e,G){$e=$e.trim();var oe=G?S[T]:S[D];return $e.replace(oe,function(pe,me,ye,Le,Te,Ke){k("xRange",$e,pe,me,ye,Le,Te,Ke);var tt=Ee(ye),He=tt||Ee(Le),Je=He||Ee(Te);return me==="="&&Je&&(me=""),tt?pe=me===">"||me==="<"?"<0.0.0":"*":me&&Je?(He&&(Le=0),Je&&(Te=0),me===">"?(me=">=",He?(ye=+ye+1,Le=0,Te=0):Je&&(Le=+Le+1,Te=0)):me==="<="&&(me="<",He?ye=+ye+1:Le=+Le+1),pe=me+ye+"."+Le+"."+Te):He?pe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Je&&(pe=">="+ye+"."+Le+".0 <"+ye+"."+(+Le+1)+".0"),k("xRange return",pe),pe})}(Qe,Ye)}).join(" ")}(Ue,xe),k("xrange",Ue),Ue=function(Ve,Ye){return k("replaceStars",Ve,Ye),Ve.trim().replace(S[ee],"")}(Ue,xe),k("stars",Ue),Ue}(Ne,ce)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(Ne){return!!Ne.match(Pe)})),ke=ke.map(function(Ne){return new ge(Ne,ce)})},Se.prototype.intersects=function(Y,ce){if(!(Y instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Pe){return Y.set.some(function(ke){return ke.every(function(Ne){return Pe.intersects(Ne,ce)})})})})},e.toComparators=function(Y,ce){return new Se(Y,ce).set.map(function(he){return he.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new L(Y,this.loose));for(var ce=0;ce<this.set.length;ce++)if(Re(this.set[ce],Y))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(Y,ce,he){var Pe=null,ke=null;try{var Ne=new Se(ce,he)}catch{return null}return Y.forEach(function(Ue){Ne.test(Ue)&&(Pe&&ke.compare(Ue)!==-1||(ke=new L(Pe=Ue,he)))}),Pe},e.minSatisfying=function(Y,ce,he){var Pe=null,ke=null;try{var Ne=new Se(ce,he)}catch{return null}return Y.forEach(function(Ue){Ne.test(Ue)&&(Pe&&ke.compare(Ue)!==1||(ke=new L(Pe=Ue,he)))}),Pe},e.validRange=function(Y,ce){try{return new Se(Y,ce).range||"*"}catch{return null}},e.ltr=function(Y,ce,he){return De(Y,ce,"<",he)},e.gtr=function(Y,ce,he){return De(Y,ce,">",he)},e.outside=De,e.prerelease=function(Y,ce){var he=H(Y,ce);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(Y,ce,he){return Y=new Se(Y,he),ce=new Se(ce,he),Y.intersects(ce)},e.coerce=function(Y){if(Y instanceof L)return Y;if(typeof Y!="string")return null;var ce=Y.match(S[_]);return ce==null?null:H((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,v(1))},function(q,e){var v,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function S(b){if(v===setTimeout)return setTimeout(b,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(b,0);try{return v(b,0)}catch{try{return v.call(null,b,0)}catch{return v.call(this,b,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch{v=R}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var l,m=[],E=!1,I=-1;function w(){E&&l&&(E=!1,l.length?m=l.concat(m):I=-1,m.length&&g())}function g(){if(!E){var b=S(w);E=!0;for(var p=m.length;p;){for(l=m,m=[];++I<p;)l&&l[I].run();I=-1,p=m.length}l=null,E=!1,function(y){if(t===clearTimeout)return clearTimeout(y);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(y);try{t(y)}catch{try{return t.call(null,y)}catch{return t.call(this,y)}}}(b)}}function f(b,p){this.fun=b,this.array=p}function C(){}k.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)p[y-1]=arguments[y];m.push(new f(b,p)),m.length!==1||E||S(g)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=C,k.addListener=C,k.once=C,k.off=C,k.removeListener=C,k.removeAllListeners=C,k.emit=C,k.prependListener=C,k.prependOnceListener=C,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(J[126],Z([0,1]),function(q,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(S,l,m){this.level=S,this.key=l,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(S,l=2**16){this.comparator=S,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(S){return Boolean(R._search(this,S,this.comparator))}get(S){return R._search(this,S,this.comparator)?.value}set(S,l){return R._insert(this,S,l,this.comparator)&&(this._size+=1),this}delete(S){const l=R._delete(this,S,this.comparator);return l&&(this._size-=1),l}forEach(S,l){let m=this._header.forward[0];for(;m;)S.call(l,m.value,m.key,this),m=m.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",l=this._header.forward[0];for(;l;)S+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return S}static _search(S,l,m){let E=S._header;for(let I=S._level-1;I>=0;I--)for(;E.forward[I]&&m(E.forward[I].key,l)<0;)E=E.forward[I];if(E=E.forward[0],E&&m(E.key,l)===0)return E}static _insert(S,l,m,E){const I=[];let w=S._header;for(let g=S._level-1;g>=0;g--){for(;w.forward[g]&&E(w.forward[g].key,l)<0;)w=w.forward[g];I[g]=w}if(w=w.forward[0],w&&E(w.key,l)===0)return w.value=m,!1;{const g=R._randomLevel(S);if(g>S._level){for(let f=S._level;f<g;f++)I[f]=S._header;S._level=g}w=new t(g,l,m);for(let f=0;f<g;f++)w.forward[f]=I[f].forward[f],I[f].forward[f]=w;return!0}}static _randomLevel(S,l=.5){let m=1;for(;Math.random()<l&&m<S._maxLevel;)m+=1;return m}static _delete(S,l,m){const E=[];let I=S._header;for(let w=S._level-1;w>=0;w--){for(;I.forward[w]&&m(I.forward[w].key,l)<0;)I=I.forward[w];E[w]=I}if(I=I.forward[0],!I||m(I.key,l)!==0)return!1;for(let w=0;w<S._level&&E[w].forward[w]===I;w++)E[w].forward[w]=I.forward[w];for(;S._level>0&&S._header.forward[S._level-1]===k;)S._level-=1;return!0}}e.SkipList=R}),define(J[57],Z([0,1,18,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const a=h;return a?typeof a.read=="function":!1}e.isReadable=k;function R(h){const a=h;return a?[a.on,a.pause,a.resume,a.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function M(h){const a=h;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function S(h,a){return new l(h,a)}e.newWriteableStream=S;class l{constructor(a,i){this.reducer=a,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(i=>i(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(i=>i(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,i){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(a,i){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(h,a){const i=[];let o;for(;(o=h.read())!==null;)i.push(o);return a(i)}e.consumeReadable=m;function E(h,a,i){const o=[];let r;for(;(r=h.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return h.read()}}}e.peekReadable=E;function I(h,a){return new Promise((i,o)=>{const r=[];w(h,{onData:n=>{a&&r.push(n)},onError:n=>{a?o(n):i(void 0)},onEnd:()=>{i(a?a(r):void 0)}})})}e.consumeStream=I;function w(h,a){let i=!1;return h.on("error",o=>{i||a.onError(o)}),h.on("end",()=>{i||a.onEnd()}),h.on("data",o=>{i||a.onData(o)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=w;function g(h,a){return new Promise((i,o)=>{const r=new t.DisposableStore,n=[],s=P=>{if(n.push(P),n.length>a)return r.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},c=P=>o(P),u=()=>i({stream:h,buffer:n,ended:!0});r.add((0,t.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),r.add((0,t.toDisposable)(()=>h.removeListener("end",u))),h.on("end",u),r.add((0,t.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=g;function f(h,a){const i=S(a);return i.end(h),i}e.toStream=f;function C(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=C;function b(h){let a=!1;return{read:()=>a?null:(a=!0,h)}}e.toReadable=b;function p(h,a,i){const o=S(i);return w(h,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}e.transform=p;function y(h,a,i){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?i([h,r]):h)}}}e.prefixedReadable=y;function d(h,a,i){let o=!1;const r=S(i);return w(a,{onData:n=>o?r.write(n):(o=!0,r.write(i([h,n]))),onError:n=>r.error(n),onEnd:()=>{o||(o=!0,r.write(h)),r.end()}}),r}e.prefixedStream=d}),define(J[17],Z([0,1,57]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class M{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new M(Buffer.allocUnsafe(P)):new M(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new M(P)}static fromString(P,D){return!(D?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(P)):(k||(k=new TextEncoder),new M(k.encode(P)))}static fromByteArray(P){const D=M.alloc(P.length);for(let T=0,_=P.length;T<_;T++)D.buffer[T]=P[T];return D}static concat(P,D){if(typeof D>"u"){D=0;for(let U=0,Q=P.length;U<Q;U++)D+=P[U].byteLength}const T=M.alloc(D);let _=0;for(let U=0,Q=P.length;U<Q;U++){const re=P[U];T.set(re,_),_+=re.byteLength}return T}clone(){const P=M.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,D){return new M(this.buffer.subarray(P,D))}set(P,D){if(P instanceof M)this.buffer.set(P.buffer,D);else if(P instanceof Uint8Array)this.buffer.set(P,D);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),D);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,D){E(this.buffer,P,D)}readUInt32LE(P){return I(this.buffer,P)}writeUInt32LE(P,D){w(this.buffer,P,D)}readUInt8(P){return g(this.buffer,P)}writeUInt8(P,D){f(this.buffer,P,D)}}e.VSBuffer=M;function S(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0}e.readUInt16LE=S;function l(u,P,D){u[D+0]=P&255,P=P>>>8,u[D+1]=P&255}e.writeUInt16LE=l;function m(u,P){return u[P]*2**24+u[P+1]*2**16+u[P+2]*2**8+u[P+3]}e.readUInt32BE=m;function E(u,P,D){u[D+3]=P,P=P>>>8,u[D+2]=P,P=P>>>8,u[D+1]=P,P=P>>>8,u[D]=P}e.writeUInt32BE=E;function I(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0|u[P+2]<<16>>>0|u[P+3]<<24>>>0}e.readUInt32LE=I;function w(u,P,D){u[D+0]=P&255,P=P>>>8,u[D+1]=P&255,P=P>>>8,u[D+2]=P&255,P=P>>>8,u[D+3]=P&255}e.writeUInt32LE=w;function g(u,P){return u[P]}e.readUInt8=g;function f(u,P,D){u[D]=P}e.writeUInt8=f;function C(u){return v.consumeReadable(u,P=>M.concat(P))}e.readableToBuffer=C;function b(u){return v.toReadable(u)}e.bufferToReadable=b;function p(u){return v.consumeStream(u,P=>M.concat(P))}e.streamToBuffer=p;async function y(u){return u.ended?M.concat(u.buffer):M.concat([...u.buffer,await p(u.stream)])}e.bufferedStreamToBuffer=y;function d(u){return v.toStream(u,P=>M.concat(P))}e.bufferToStream=d;function h(u){return v.transform(u,{data:P=>typeof P=="string"?M.fromString(P):M.wrap(P)},P=>M.concat(P))}e.streamToBufferReadableStream=h;function a(u){return v.newWriteableStream(P=>M.concat(P),u)}e.newWriteableBufferStream=a;function i(u,P){return v.prefixedReadable(u,P,D=>M.concat(D))}e.prefixedBufferReadable=i;function o(u,P){return v.prefixedStream(u,P,D=>M.concat(D))}e.prefixedBufferStream=o;function r(u){let P=0,D=0,T=0;const _=new Uint8Array(Math.floor(u.length/4*3)),U=re=>{switch(D){case 3:_[T++]=P|re,D=0;break;case 2:_[T++]=P|re>>>2,P=re<<6,D=3;break;case 1:_[T++]=P|re>>>4,P=re<<4,D=2;break;default:P=re<<2,D=1}};for(let re=0;re<u.length;re++){const le=u.charCodeAt(re);if(le>=65&&le<=90)U(le-65);else if(le>=97&&le<=122)U(le-97+26);else if(le>=48&&le<=57)U(le-48+52);else if(le===43||le===45)U(62);else if(le===47||le===95)U(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${u[re]}`)}}const Q=T;for(;D>0;)U(0);return M.wrap(_).slice(0,Q)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:u},P=!0,D=!1){const T=D?s:n;let _="";const U=u.byteLength%3;let Q=0;for(;Q<u.byteLength-U;Q+=3){const re=u[Q+0],le=u[Q+1],ue=u[Q+2];_+=T[re>>>2],_+=T[(re<<4|le>>>4)&63],_+=T[(le<<2|ue>>>6)&63],_+=T[ue&63]}if(U===1){const re=u[Q+0];_+=T[re>>>2],_+=T[re<<4&63],P&&(_+="==")}else if(U===2){const re=u[Q+0],le=u[Q+1];_+=T[re>>>2],_+=T[(re<<4|le>>>4)&63],_+=T[le<<2&63],P&&(_+="=")}return _}e.encodeBase64=c}),define(J[12],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function t(o){return Array.isArray(o)&&o.every(r=>v(r))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const r=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof r}e.isTypedArray=R;function M(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=M;function S(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=S;function l(o){return o===!0||o===!1}e.isBoolean=l;function m(o){return typeof o>"u"}e.isUndefined=m;function E(o){return!I(o)}e.isDefined=E;function I(o){return m(o)||o===null}e.isUndefinedOrNull=I;function w(o,r){if(!o)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=w;function g(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=g;function f(...o){const r=[];for(let n=0;n<o.length;n++){const s=o[n];if(I(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);r.push(s)}return r}e.assertAllDefined=f;const C=Object.prototype.hasOwnProperty;function b(o){if(!k(o))return!1;for(const r in o)if(C.call(o,r))return!1;return!0}e.isEmptyObject=b;function p(o){return typeof o=="function"}e.isFunction=p;function y(...o){return o.length>0&&o.every(p)}e.areFunctions=y;function d(o,r){const n=Math.min(o.length,r.length);for(let s=0;s<n;s++)h(o[s],r[s])}e.validateConstraints=d;function h(o,r){if(v(r)){if(typeof o!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(p(r)){try{if(o instanceof r)return}catch{}if(!I(o)&&o.constructor===r||r.length===1&&r.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(J[49],Z([0,1,12]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const y=Array.isArray(p)?[]:{};return Object.keys(p).forEach(d=>{p[d]&&typeof p[d]=="object"?y[d]=t(p[d]):y[d]=p[d]}),y}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const y=[p];for(;y.length>0;){const d=y.shift();Object.freeze(d);for(const h in d)if(R.call(d,h)){const a=d[h];typeof a=="object"&&!Object.isFrozen(a)&&!(0,v.isTypedArray)(a)&&y.push(a)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function M(p,y){return S(p,y,new Set)}e.cloneAndChange=M;function S(p,y,d){if((0,v.isUndefinedOrNull)(p))return p;const h=y(p);if(typeof h<"u")return h;if(Array.isArray(p)){const a=[];for(const i of p)a.push(S(i,y,d));return a}if((0,v.isObject)(p)){if(d.has(p))throw new Error("Cannot clone recursive data-structure");d.add(p);const a={};for(const i in p)R.call(p,i)&&(a[i]=S(p[i],y,d));return d.delete(p),a}return p}function l(p,y,d=!0){return(0,v.isObject)(p)?((0,v.isObject)(y)&&Object.keys(y).forEach(h=>{h in p?d&&((0,v.isObject)(p[h])&&(0,v.isObject)(y[h])?l(p[h],y[h],d):p[h]=y[h]):p[h]=y[h]}),p):y}e.mixin=l;function m(p,y){if(p===y)return!0;if(p==null||y===null||y===void 0||typeof p!=typeof y||typeof p!="object"||Array.isArray(p)!==Array.isArray(y))return!1;let d,h;if(Array.isArray(p)){if(p.length!==y.length)return!1;for(d=0;d<p.length;d++)if(!m(p[d],y[d]))return!1}else{const a=[];for(h in p)a.push(h);a.sort();const i=[];for(h in y)i.push(h);if(i.sort(),!m(a,i))return!1;for(d=0;d<a.length;d++)if(!m(p[a[d]],y[a[d]]))return!1}return!0}e.equals=m;function E(p){const y=new Set;return JSON.stringify(p,(d,h)=>{if((0,v.isObject)(h)||Array.isArray(h)){if(y.has(h))return"[Circular]";y.add(h)}return h})}e.safeStringify=E;function I(p,y){const d=Object.create(null);return!p||!y||Object.keys(y).forEach(a=>{const i=p[a],o=y[a];m(i,o)||(d[a]=o)}),d}e.distinct=I;function w(p,y){const d=y.toLowerCase(),h=Object.keys(p).find(a=>a.toLowerCase()===d);return h?p[h]:p[y]}e.getCaseInsensitive=w;function g(p,y){const d=Object.create(null);for(const[h,a]of Object.entries(p))y(h,a)&&(d[h]=a);return d}e.filter=g;function f(p){let y=[],d=Object.getPrototypeOf(p);for(;Object.prototype!==d;)y=y.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return y}e.getAllPropertyNames=f;function C(p){const y=[];for(const d of f(p))typeof p[d]=="function"&&y.push(d);return y}e.getAllMethodNames=C;function b(p,y){const d=a=>function(){const i=Array.prototype.slice.call(arguments,0);return y(a,i)},h={};for(const a of p)h[a]=d(a);return h}e.createProxyObject=b}),define(J[28],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return v.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let l=0;l<S.length;l++)S[l]=Math.floor(Math.random()*256);return S};const R=new Uint8Array(16),M=[];for(let S=0;S<256;S++)M.push(S.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let l=0,m="";return m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m}}()}),define(J[127],Z([0,1,74,29,47]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,S){if(await new Promise((E,I)=>{const w=t.createReadStream(M),g=v.createHash("sha1");w.pipe(g);const f=(0,k.once)((C,b)=>{w.removeAllListeners(),g.removeAllListeners(),C?I(C):E(b)});w.once("error",f),w.once("end",f),g.once("error",f),g.once("data",C=>f(void 0,C.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.checksum=R}),define(J[128],Z([0,1,30]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(M){const S=M.replace(/\-/g,":").toLowerCase();return!t.has(S)}function R(){const M=(0,v.networkInterfaces)();for(const S in M){const l=M[S];if(l){for(const{mac:m}of l)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(J[90],Z([0,1,75]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(S,l,m,E=1){let I=!1;return new Promise(w=>{const g=setTimeout(()=>{if(!I)return I=!0,w(0)},m);k(S,l,E,f=>{if(!I)return I=!0,clearTimeout(g),w(f)})})}e.findFreePort=t;function k(S,l,m,E){if(l===0)return E(0);const I=new v.Socket;I.once("connect",()=>(M(I),k(S+m,l-1,m,E))),I.once("data",()=>{}),I.once("error",w=>(M(I),w.code!=="ECONNREFUSED"?k(S+m,l-1,m,E):E(S))),I.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(S,l,m){let E=!1,I,w=1;const g=v.createServer({pauseOnConnect:!0});function f(C,b){E||(E=!0,g.removeAllListeners(),g.close(),I&&clearTimeout(I),b(C))}return new Promise(C=>{I=setTimeout(()=>{f(0,C)},m),g.on("listening",()=>{f(S,C)}),g.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<l?(S++,w++,g.listen(S,"127.0.0.1")):f(0,C)}),g.on("close",()=>{f(0,C)}),g.listen(S,"127.0.0.1")})}e.findFreePortFaster=R;function M(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(l){console.error(l)}}}),define(J[129],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[130],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(J[40],Z([0,1,15,18]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,S){const l=(m,...E)=>{this.validateEvent(M,m)&&S(m,...E)};return this.mapListenerToWrapper.set(S,l),v.ipcMain.on(M,l),this}once(M,S){return v.ipcMain.once(M,(l,...m)=>{this.validateEvent(M,l)&&S(l,...m)}),this}handle(M,S){return v.ipcMain.handle(M,(l,...m)=>this.validateEvent(M,l)?S(l,...m):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return v.ipcMain.removeHandler(M),this}removeListener(M,S){const l=this.mapListenerToWrapper.get(S);return l&&(v.ipcMain.removeListener(M,l),this.mapListenerToWrapper.delete(S)),this}validateEvent(M,S){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const l=S.senderFrame,m=l.url;if(!m)return!0;let E="unknown";try{E=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${m}'.`),!1}return E!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${E}'.`),!1):l.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${E}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(J[131],Z([0,1,15,40,12,129]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(l,m,E,I,w)=>{const g=S(l,I,E);g.popup({window:(0,k.withNullAsUndefined)(v.BrowserWindow.fromWebContents(l.sender)),x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{g&&l.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=M;function S(l,m,E){const I=new v.Menu;return E.forEach(w=>{let g;w.type==="separator"?g=new v.MenuItem({type:w.type}):Array.isArray(w.submenu)?g=new v.MenuItem({submenu:S(l,m,w.submenu),label:w.label}):g=new v.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(f,C,b)=>l.sender.send(m,w.id,b)}),I.append(g)}),I}}),define(J[132],Z([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[133],Z([0,1,132]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,M=R*7,S=R*30,l=R*365;function m(I,w,g){typeof I!="number"&&(I=I.getTime());const f=Math.round((new Date().getTime()-I)/1e3);if(f<-30)return(0,v.localize)(0,null,m(new Date().getTime()+f*1e3,!1));if(f<30)return(0,v.localize)(1,null);let C;return f<t?(C=f,w?C===1?g?(0,v.localize)(2,null,C):(0,v.localize)(3,null,C):g?(0,v.localize)(4,null,C):(0,v.localize)(5,null,C):C===1?g?(0,v.localize)(6,null,C):(0,v.localize)(7,null,C):g?(0,v.localize)(8,null,C):(0,v.localize)(9,null,C)):f<k?(C=Math.floor(f/t),w?C===1?g?(0,v.localize)(10,null,C):(0,v.localize)(11,null,C):g?(0,v.localize)(12,null,C):(0,v.localize)(13,null,C):C===1?g?(0,v.localize)(14,null,C):(0,v.localize)(15,null,C):g?(0,v.localize)(16,null,C):(0,v.localize)(17,null,C)):f<R?(C=Math.floor(f/k),w?C===1?g?(0,v.localize)(18,null,C):(0,v.localize)(19,null,C):g?(0,v.localize)(20,null,C):(0,v.localize)(21,null,C):C===1?g?(0,v.localize)(22,null,C):(0,v.localize)(23,null,C):g?(0,v.localize)(24,null,C):(0,v.localize)(25,null,C)):f<M?(C=Math.floor(f/R),w?C===1?(0,v.localize)(26,null,C):(0,v.localize)(27,null,C):C===1?(0,v.localize)(28,null,C):(0,v.localize)(29,null,C)):f<S?(C=Math.floor(f/M),w?C===1?g?(0,v.localize)(30,null,C):(0,v.localize)(31,null,C):g?(0,v.localize)(32,null,C):(0,v.localize)(33,null,C):C===1?g?(0,v.localize)(34,null,C):(0,v.localize)(35,null,C):g?(0,v.localize)(36,null,C):(0,v.localize)(37,null,C)):f<l?(C=Math.floor(f/S),w?C===1?g?(0,v.localize)(38,null,C):(0,v.localize)(39,null,C):g?(0,v.localize)(40,null,C):(0,v.localize)(41,null,C):C===1?g?(0,v.localize)(42,null,C):(0,v.localize)(43,null,C):g?(0,v.localize)(44,null,C):(0,v.localize)(45,null,C)):(C=Math.floor(f/l),w?C===1?g?(0,v.localize)(46,null,C):(0,v.localize)(47,null,C):g?(0,v.localize)(48,null,C):(0,v.localize)(49,null,C):C===1?g?(0,v.localize)(50,null,C):(0,v.localize)(51,null,C):g?(0,v.localize)(52,null,C):(0,v.localize)(53,null,C))}e.fromNow=m;function E(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(J[134],Z([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[43],Z([0,1,23,12,134]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,w){return w&&(I.stack||I.stacktrace)?k.localize(0,null,S(I),M(I.stack)||M(I.stacktrace)):S(I)}function M(I){return Array.isArray(I)?I.join(`
`):I}function S(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function l(I=null,w=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const g=v.coalesce(I),f=l(g[0],w);return g.length>1?k.localize(4,null,f,g.length):f}if(t.isString(I))return I;if(I.detail){const g=I.detail;if(g.error)return R(g.error,w);if(g.exception)return R(g.exception,w)}return I.stack?R(I,w):I.message?I.message:k.localize(5,null)}e.toErrorMessage=l;function m(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=m;function E(I,w){let g;return typeof I=="string"?g=new Error(I):g=I,g.actions=w,g}e.createErrorWithActions=E}),define(J[135],Z([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(J[136],Z([0,1,135]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(J[137],Z([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(J[5],Z([0,1,137]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,M=!1,S=!1,l=!1,m=!1,E=!1,I=!1,w=!1,g,f=t,C,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const y=typeof p?.versions?.electron=="string",d=y&&p?.type==="renderer";if(typeof navigator=="object"&&!d)b=navigator.userAgent,k=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,I=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=b.indexOf("Linux")>=0,m=!0,g=v.getConfiguredDefaultLocale(v.localize(0,null))||t,f=g;else if(typeof p=="object"){k=p.platform==="win32",R=p.platform==="darwin",M=p.platform==="linux",S=M&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,E=y,w=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,f=t;const u=p.env.VSCODE_NLS_CONFIG;if(u)try{const P=JSON.parse(u),D=P.availableLanguages["*"];g=P.locale,f=D||t,C=P._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");var h;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let i=0;R?i=1:k?i=3:M&&(i=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=S,e.isNative=l,e.isElectron=E,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isCI=w,e.platform=i,e.userAgent=b,e.language=f;var o;(function(u){function P(){return e.language}u.value=P;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=D;function T(){return e.language==="en"}u.isDefault=T})(o=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let T=0,_=u.length;T<_;T++){const U=u[T];if(U.id===D.data.vscodeScheduleAsyncWork){u.splice(T,1),U.callback();return}}});let P=0;return D=>{const T=++P;u.push({id:T,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return u=>setTimeout(u)})();var r;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:k?1:3;let n=!0,s=!1;function c(){if(!s){s=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,n=new Uint16Array(u.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[34],Z([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const k=v.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(J[9],Z([0,1,34]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,M=122,S=46,l=47,m=92,E=58,I=63;class w extends Error{constructor(h,a,i){let o;typeof a=="string"&&a.indexOf("not ")===0?(o="must not be",a=a.replace(/^not /,"")):o="must be";const r=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${r} ${o} of type ${a}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function g(d,h){if(typeof d!="string")throw new w(h,"string",d)}function f(d){return d===l||d===m}function C(d){return d===l}function b(d){return d>=t&&d<=R||d>=k&&d<=M}function p(d,h,a,i){let o="",r=0,n=-1,s=0,c=0;for(let u=0;u<=d.length;++u){if(u<d.length)c=d.charCodeAt(u);else{if(i(c))break;c=l}if(i(c)){if(!(n===u-1||s===1))if(s===2){if(o.length<2||r!==2||o.charCodeAt(o.length-1)!==S||o.charCodeAt(o.length-2)!==S){if(o.length>2){const P=o.lastIndexOf(a);P===-1?(o="",r=0):(o=o.slice(0,P),r=o.length-1-o.lastIndexOf(a)),n=u,s=0;continue}else if(o.length!==0){o="",r=0,n=u,s=0;continue}}h&&(o+=o.length>0?`${a}..`:"..",r=2)}else o.length>0?o+=`${a}${d.slice(n+1,u)}`:o=d.slice(n+1,u),r=u-n-1;n=u,s=0}else c===S&&s!==-1?++s:s=-1}return o}function y(d,h){if(h===null||typeof h!="object")throw new w("pathObject","Object",h);const a=h.dir||h.root,i=h.base||`${h.name||""}${h.ext||""}`;return a?a===h.root?`${a}${i}`:`${a}${d}${i}`:i}e.win32={resolve(...d){let h="",a="",i=!1;for(let o=d.length-1;o>=-1;o--){let r;if(o>=0){if(r=d[o],g(r,"path"),r.length===0)continue}else h.length===0?r=v.cwd():(r=v.env[`=${h}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==h.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${h}\\`));const n=r.length;let s=0,c="",u=!1;const P=r.charCodeAt(0);if(n===1)f(P)&&(s=1,u=!0);else if(f(P))if(u=!0,f(r.charCodeAt(1))){let D=2,T=D;for(;D<n&&!f(r.charCodeAt(D));)D++;if(D<n&&D!==T){const _=r.slice(T,D);for(T=D;D<n&&f(r.charCodeAt(D));)D++;if(D<n&&D!==T){for(T=D;D<n&&!f(r.charCodeAt(D));)D++;(D===n||D!==T)&&(c=`\\\\${_}\\${r.slice(T,D)}`,s=D)}}}else s=1;else b(P)&&r.charCodeAt(1)===E&&(c=r.slice(0,2),s=2,n>2&&f(r.charCodeAt(2))&&(u=!0,s=3));if(c.length>0)if(h.length>0){if(c.toLowerCase()!==h.toLowerCase())continue}else h=c;if(i){if(h.length>0)break}else if(a=`${r.slice(s)}\\${a}`,i=u,u&&h.length>0)break}return a=p(a,!i,"\\",f),i?`${h}\\${a}`:`${h}${a}`||"."},normalize(d){g(d,"path");const h=d.length;if(h===0)return".";let a=0,i,o=!1;const r=d.charCodeAt(0);if(h===1)return C(r)?"\\":d;if(f(r))if(o=!0,f(d.charCodeAt(1))){let s=2,c=s;for(;s<h&&!f(d.charCodeAt(s));)s++;if(s<h&&s!==c){const u=d.slice(c,s);for(c=s;s<h&&f(d.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&!f(d.charCodeAt(s));)s++;if(s===h)return`\\\\${u}\\${d.slice(c)}\\`;s!==c&&(i=`\\\\${u}\\${d.slice(c,s)}`,a=s)}}}else a=1;else b(r)&&d.charCodeAt(1)===E&&(i=d.slice(0,2),a=2,h>2&&f(d.charCodeAt(2))&&(o=!0,a=3));let n=a<h?p(d.slice(a),!o,"\\",f):"";return n.length===0&&!o&&(n="."),n.length>0&&f(d.charCodeAt(h-1))&&(n+="\\"),i===void 0?o?`\\${n}`:n:o?`${i}\\${n}`:`${i}${n}`},isAbsolute(d){g(d,"path");const h=d.length;if(h===0)return!1;const a=d.charCodeAt(0);return f(a)||h>2&&b(a)&&d.charCodeAt(1)===E&&f(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let h,a;for(let r=0;r<d.length;++r){const n=d[r];g(n,"path"),n.length>0&&(h===void 0?h=a=n:h+=`\\${n}`)}if(h===void 0)return".";let i=!0,o=0;if(typeof a=="string"&&f(a.charCodeAt(0))){++o;const r=a.length;r>1&&f(a.charCodeAt(1))&&(++o,r>2&&(f(a.charCodeAt(2))?++o:i=!1))}if(i){for(;o<h.length&&f(h.charCodeAt(o));)o++;o>=2&&(h=`\\${h.slice(o)}`)}return e.win32.normalize(h)},relative(d,h){if(g(d,"from"),g(h,"to"),d===h)return"";const a=e.win32.resolve(d),i=e.win32.resolve(h);if(a===i||(d=a.toLowerCase(),h=i.toLowerCase(),d===h))return"";let o=0;for(;o<d.length&&d.charCodeAt(o)===m;)o++;let r=d.length;for(;r-1>o&&d.charCodeAt(r-1)===m;)r--;const n=r-o;let s=0;for(;s<h.length&&h.charCodeAt(s)===m;)s++;let c=h.length;for(;c-1>s&&h.charCodeAt(c-1)===m;)c--;const u=c-s,P=n<u?n:u;let D=-1,T=0;for(;T<P;T++){const U=d.charCodeAt(o+T);if(U!==h.charCodeAt(s+T))break;U===m&&(D=T)}if(T!==P){if(D===-1)return i}else{if(u>P){if(h.charCodeAt(s+T)===m)return i.slice(s+T+1);if(T===2)return i.slice(s+T)}n>P&&(d.charCodeAt(o+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let _="";for(T=o+D+1;T<=r;++T)(T===r||d.charCodeAt(T)===m)&&(_+=_.length===0?"..":"\\..");return s+=D,_.length>0?`${_}${i.slice(s,c)}`:(i.charCodeAt(s)===m&&++s,i.slice(s,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const h=e.win32.resolve(d);if(h.length<=2)return d;if(h.charCodeAt(0)===m){if(h.charCodeAt(1)===m){const a=h.charCodeAt(2);if(a!==I&&a!==S)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(b(h.charCodeAt(0))&&h.charCodeAt(1)===E&&h.charCodeAt(2)===m)return`\\\\?\\${h}`;return d},dirname(d){g(d,"path");const h=d.length;if(h===0)return".";let a=-1,i=0;const o=d.charCodeAt(0);if(h===1)return f(o)?d:".";if(f(o)){if(a=i=1,f(d.charCodeAt(1))){let s=2,c=s;for(;s<h&&!f(d.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&f(d.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&!f(d.charCodeAt(s));)s++;if(s===h)return d;s!==c&&(a=i=s+1)}}}}else b(o)&&d.charCodeAt(1)===E&&(a=h>2&&f(d.charCodeAt(2))?3:2,i=a);let r=-1,n=!0;for(let s=h-1;s>=i;--s)if(f(d.charCodeAt(s))){if(!n){r=s;break}}else n=!1;if(r===-1){if(a===-1)return".";r=a}return d.slice(0,r)},basename(d,h){h!==void 0&&g(h,"ext"),g(d,"path");let a=0,i=-1,o=!0,r;if(d.length>=2&&b(d.charCodeAt(0))&&d.charCodeAt(1)===E&&(a=2),h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,s=-1;for(r=d.length-1;r>=a;--r){const c=d.charCodeAt(r);if(f(c)){if(!o){a=r+1;break}}else s===-1&&(o=!1,s=r+1),n>=0&&(c===h.charCodeAt(n)?--n===-1&&(i=r):(n=-1,i=s))}return a===i?i=s:i===-1&&(i=d.length),d.slice(a,i)}for(r=d.length-1;r>=a;--r)if(f(d.charCodeAt(r))){if(!o){a=r+1;break}}else i===-1&&(o=!1,i=r+1);return i===-1?"":d.slice(a,i)},extname(d){g(d,"path");let h=0,a=-1,i=0,o=-1,r=!0,n=0;d.length>=2&&d.charCodeAt(1)===E&&b(d.charCodeAt(0))&&(h=i=2);for(let s=d.length-1;s>=h;--s){const c=d.charCodeAt(s);if(f(c)){if(!r){i=s+1;break}continue}o===-1&&(r=!1,o=s+1),c===S?a===-1?a=s:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||o===-1||n===0||n===1&&a===o-1&&a===i+1?"":d.slice(a,o)},format:y.bind(null,"\\"),parse(d){g(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const a=d.length;let i=0,o=d.charCodeAt(0);if(a===1)return f(o)?(h.root=h.dir=d,h):(h.base=h.name=d,h);if(f(o)){if(i=1,f(d.charCodeAt(1))){let D=2,T=D;for(;D<a&&!f(d.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&f(d.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&!f(d.charCodeAt(D));)D++;D===a?i=D:D!==T&&(i=D+1)}}}}else if(b(o)&&d.charCodeAt(1)===E){if(a<=2)return h.root=h.dir=d,h;if(i=2,f(d.charCodeAt(2))){if(a===3)return h.root=h.dir=d,h;i=3}}i>0&&(h.root=d.slice(0,i));let r=-1,n=i,s=-1,c=!0,u=d.length-1,P=0;for(;u>=i;--u){if(o=d.charCodeAt(u),f(o)){if(!c){n=u+1;break}continue}s===-1&&(c=!1,s=u+1),o===S?r===-1?r=u:P!==1&&(P=1):r!==-1&&(P=-1)}return s!==-1&&(r===-1||P===0||P===1&&r===s-1&&r===n+1?h.base=h.name=d.slice(n,s):(h.name=d.slice(n,r),h.base=d.slice(n,s),h.ext=d.slice(r,s))),n>0&&n!==i?h.dir=d.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let h="",a=!1;for(let i=d.length-1;i>=-1&&!a;i--){const o=i>=0?d[i]:v.cwd();g(o,"path"),o.length!==0&&(h=`${o}/${h}`,a=o.charCodeAt(0)===l)}return h=p(h,!a,"/",C),a?`/${h}`:h.length>0?h:"."},normalize(d){if(g(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===l,a=d.charCodeAt(d.length-1)===l;return d=p(d,!h,"/",C),d.length===0?h?"/":a?"./":".":(a&&(d+="/"),h?`/${d}`:d)},isAbsolute(d){return g(d,"path"),d.length>0&&d.charCodeAt(0)===l},join(...d){if(d.length===0)return".";let h;for(let a=0;a<d.length;++a){const i=d[a];g(i,"path"),i.length>0&&(h===void 0?h=i:h+=`/${i}`)}return h===void 0?".":e.posix.normalize(h)},relative(d,h){if(g(d,"from"),g(h,"to"),d===h||(d=e.posix.resolve(d),h=e.posix.resolve(h),d===h))return"";const a=1,i=d.length,o=i-a,r=1,n=h.length-r,s=o<n?o:n;let c=-1,u=0;for(;u<s;u++){const D=d.charCodeAt(a+u);if(D!==h.charCodeAt(r+u))break;D===l&&(c=u)}if(u===s)if(n>s){if(h.charCodeAt(r+u)===l)return h.slice(r+u+1);if(u===0)return h.slice(r+u)}else o>s&&(d.charCodeAt(a+u)===l?c=u:u===0&&(c=0));let P="";for(u=a+c+1;u<=i;++u)(u===i||d.charCodeAt(u)===l)&&(P+=P.length===0?"..":"/..");return`${P}${h.slice(r+c)}`},toNamespacedPath(d){return d},dirname(d){if(g(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===l;let a=-1,i=!0;for(let o=d.length-1;o>=1;--o)if(d.charCodeAt(o)===l){if(!i){a=o;break}}else i=!1;return a===-1?h?"/":".":h&&a===1?"//":d.slice(0,a)},basename(d,h){h!==void 0&&g(h,"ext"),g(d,"path");let a=0,i=-1,o=!0,r;if(h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,s=-1;for(r=d.length-1;r>=0;--r){const c=d.charCodeAt(r);if(c===l){if(!o){a=r+1;break}}else s===-1&&(o=!1,s=r+1),n>=0&&(c===h.charCodeAt(n)?--n===-1&&(i=r):(n=-1,i=s))}return a===i?i=s:i===-1&&(i=d.length),d.slice(a,i)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===l){if(!o){a=r+1;break}}else i===-1&&(o=!1,i=r+1);return i===-1?"":d.slice(a,i)},extname(d){g(d,"path");let h=-1,a=0,i=-1,o=!0,r=0;for(let n=d.length-1;n>=0;--n){const s=d.charCodeAt(n);if(s===l){if(!o){a=n+1;break}continue}i===-1&&(o=!1,i=n+1),s===S?h===-1?h=n:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||i===-1||r===0||r===1&&h===i-1&&h===a+1?"":d.slice(h,i)},format:y.bind(null,"/"),parse(d){g(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const a=d.charCodeAt(0)===l;let i;a?(h.root="/",i=1):i=0;let o=-1,r=0,n=-1,s=!0,c=d.length-1,u=0;for(;c>=i;--c){const P=d.charCodeAt(c);if(P===l){if(!s){r=c+1;break}continue}n===-1&&(s=!1,n=c+1),P===S?o===-1?o=c:u!==1&&(u=1):o!==-1&&(u=-1)}if(n!==-1){const P=r===0&&a?1:r;o===-1||u===0||u===1&&o===n-1&&o===r+1?h.base=h.name=d.slice(P,n):(h.name=d.slice(P,o),h.base=d.slice(P,n),h.ext=d.slice(o,n))}return r>0?h.dir=d.slice(0,r-1):a&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[76],Z([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(S,...l){const m=l.reduce((w,g)=>(w[g]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(w=>!m[w]).forEach(w=>{for(let g=0;g<E.length;g++)if(w.search(E[g])!==-1){delete S[w];break}})}e.sanitizeProcessEnvironment=R;function M(S){!S||(delete S.DEBUG,v.isMacintosh&&delete S.DYLD_LIBRARY_PATH,v.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(J[77],Z([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new k(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[3],Z([0,1,18,47,2,125,77]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const S=!1,l=!1;var m;(function(c){c.None=()=>k.Disposable.None;function u(O){if(l){const{onListenerDidAdd:N}=O,V=f.create();let x=0;O.onListenerDidAdd=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),N?.()}}}function P(O){return(N,V=null,x)=>{let ne=!1,j;return j=O(te=>{if(!ne)return j?j.dispose():ne=!0,N.call(V,te)},null,x),ne&&j.dispose(),j}}c.once=P;function D(O,N,V){return le((x,ne=null,j)=>O(te=>x.call(ne,N(te)),null,j),V)}c.map=D;function T(O,N,V){return le((x,ne=null,j)=>O(te=>{N(te),x.call(ne,te)},null,j),V)}c.forEach=T;function _(O,N,V){return le((x,ne=null,j)=>O(te=>N(te)&&x.call(ne,te),null,j),V)}c.filter=_;function U(O){return O}c.signal=U;function Q(...O){return(N,V=null,x)=>(0,k.combinedDisposable)(...O.map(ne=>ne(j=>N.call(V,j),null,x)))}c.any=Q;function re(O,N,V,x){let ne=V;return D(O,j=>(ne=N(ne,j),ne),x)}c.reduce=re;function le(O,N){let V;const x={onFirstListenerAdd(){V=O(ne.fire,ne)},onLastListenerRemove(){V?.dispose()}};N||u(x);const ne=new b(x);return N?.add(ne),ne.event}function ue(O,N,V=100,x=!1,ne,j){let te,ie,ae,de=0;const ge={leakWarningThreshold:ne,onFirstListenerAdd(){te=O(Se=>{de++,ie=N(ie,Se),x&&!ae&&(we.fire(ie),ie=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Ee=ie;ie=void 0,ae=void 0,(!x||de>1)&&we.fire(Ee),de=0},V)})},onLastListenerRemove(){te.dispose()}};j||u(ge);const we=new b(ge);return j?.add(we),we.event}c.debounce=ue;function se(O,N=(x,ne)=>x===ne,V){let x=!0,ne;return _(O,j=>{const te=x||!N(j,ne);return x=!1,ne=j,te},V)}c.latch=se;function fe(O,N,V){return[c.filter(O,N,V),c.filter(O,x=>!N(x),V)]}c.split=fe;function K(O,N=!1,V=[]){let x=V.slice(),ne=O(ie=>{x?x.push(ie):te.fire(ie)});const j=()=>{x?.forEach(ie=>te.fire(ie)),x=null},te=new b({onFirstListenerAdd(){ne||(ne=O(ie=>te.fire(ie)))},onFirstListenerDidAdd(){x&&(N?setTimeout(j):j())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return te.event}c.buffer=K;class ${constructor(N){this.event=N,this.disposables=new k.DisposableStore}map(N){return new $(D(this.event,N,this.disposables))}forEach(N){return new $(T(this.event,N,this.disposables))}filter(N){return new $(_(this.event,N,this.disposables))}reduce(N,V){return new $(re(this.event,N,V,this.disposables))}latch(){return new $(se(this.event,void 0,this.disposables))}debounce(N,V=100,x=!1,ne){return new $(ue(this.event,N,V,x,ne,this.disposables))}on(N,V,x){return this.event(N,V,x)}once(N,V,x){return P(this.event)(N,V,x)}dispose(){this.disposables.dispose()}}function F(O){return new $(O)}c.chain=F;function A(O,N,V=x=>x){const x=(...ie)=>te.fire(V(...ie)),ne=()=>O.on(N,x),j=()=>O.removeListener(N,x),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}c.fromNodeEventEmitter=A;function W(O,N,V=x=>x){const x=(...ie)=>te.fire(V(...ie)),ne=()=>O.addEventListener(N,x),j=()=>O.removeEventListener(N,x),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}c.fromDOMEventEmitter=W;function z(O){return new Promise(N=>P(O)(N))}c.toPromise=z;function ee(O,N){return N(void 0),O(V=>N(V))}c.runAndSubscribe=ee;function B(O,N){let V=null;function x(j){V?.dispose(),V=new k.DisposableStore,N(j,V)}x(void 0);const ne=O(j=>x(j));return(0,k.toDisposable)(()=>{ne.dispose(),V?.dispose()})}c.runAndSubscribeWithStore=B;class H{constructor(N,V){this.obs=N,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};V||u(x),this.emitter=new b(x),V&&V.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,V){this._hasChanged=!0}endUpdate(N){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,N){return new H(O,N).emitter.event}c.fromObservable=L})(m=e.Event||(e.Event={}));class E{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${E._idPool++}`}start(u){this._stopWatch=new M.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let I=-1;function w(c){const u=I;return I=c,{dispose(){I=u}}}e.setGlobalLeakWarningThreshold=w;class g{constructor(u,P=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,P){let D=I;if(typeof this.customThreshold=="number"&&(D=this.customThreshold),D<=0||P<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let _,U=0;for(const[Q,re]of this._stacks)(!_||U<re)&&(_=Q,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(_)}return()=>{const _=this._stacks.get(u.value)||0;this._stacks.set(u.value,_-1)}}}class f{constructor(u){this.value=u}static create(){return new f(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(u,P,D){this.callback=u,this.callbackThis=P,this.stack=D,this.subscription=new k.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class b{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=I>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const P of u)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,P,D)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let _,U;this._leakageMon&&this._listeners.size>=30&&(U=f.create(),_=this._leakageMon.check(U,this._listeners.size+1)),S&&(U=U??f.create());const Q=new C(u,P,U),re=this._listeners.push(Q);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,P);const le=Q.subscription.set(()=>{_?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return D instanceof k.DisposableStore?D.add(le):Array.isArray(D)&&D.push(le),le}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y);for(const P of this._listeners)this._deliveryQueue.push(this,P,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(u,P,D){this._queue.push(new d(u,P,D))}clear(u){const P=new R.LinkedList;for(const D of this._queue)D.emitter!==u&&P.push(D);this._queue=P}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(P){(0,v.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=p;class y extends p{clear(u){this._queue.clear()}}class d{constructor(u,P,D){this.emitter=u,this.listener=P,this.event=D}}class h extends b{async fireAsync(u,P,D){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,u]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,_]=this._asyncDeliveryQueue.shift(),U=[],Q={..._,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(re=D(re,T.callback)),U.push(re)}};try{T.invoke(Q)}catch(re){(0,v.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const le of re)le.status==="rejected"&&(0,v.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=h;class a extends b{constructor(u){super(u),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=a;class i extends a{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=i;class o extends b{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const P={event:u,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const D=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(P=>this.emitter.fire(P))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class n{constructor(){this.buffers=[]}wrapEvent(u){return(P,D,T)=>u(_=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(D,_)):P.call(D,_)},void 0,T)}bufferEvents(u){const P=[];this.buffers.push(P);const D=u();return this.buffers.pop(),P.forEach(T=>T()),D}}e.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(J[22],Z([0,1,3]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(S,l){const m=setTimeout(S.bind(l),0);return{dispose(){clearTimeout(m)}}});var k;(function(S){function l(m){return m===S.None||m===S.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}S.isCancellationToken=l,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=M}),define(J[138],Z([0,1,22]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new v.CancellationTokenSource,l=this.task(S.token);return this.result={promise:l,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=t;class k{constructor(S){this.fn=S,this.lastCache=void 0,this.lastArgKey=void 0}get(S){const l=JSON.stringify(S);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(S)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(S){this.fn=S,this._map=new Map}get cachedValues(){return this._map}get(S){if(this._map.has(S))return this._map.get(S);const l=this.fn(S);return this._map.set(S,l),l}}e.CachedFunction=R}),define(J[91],Z([0,1,3,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=M=>({onDidChange:v.Event.None,value:M});e.staticObservableValue=k;class R extends t.Disposable{constructor(S){super(),this._value=S,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(S){S!==this._value&&(this._value=S,this.changeEmitter.fire(S))}}e.MutableObservableValue=R}),define(J[24],Z([0,1,138,124]),function(q,e,v,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function S(G,...oe){return oe.length===0?G:G.replace(M,function(pe,me){const ye=parseInt(me,10);return isNaN(ye)||ye<0||ye>=oe.length?pe:oe[ye]})}e.format=S;const l=/{([^}]+)}/g;function m(G,oe){return G.replace(l,(pe,me)=>oe[me]??pe)}e.format2=m;function E(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=E;function I(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function w(G,oe){let pe=0;const me=oe.charCodeAt(0);for(let ye=G.length-1;ye>=0;ye--)G.charCodeAt(ye)===me&&pe++;return pe}e.count=w;function g(G,oe,pe="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${pe}`}e.truncate=g;function f(G,oe=" "){const pe=C(G,oe);return b(pe,oe)}e.trim=f;function C(G,oe){if(!G||!oe)return G;const pe=oe.length;if(pe===0||G.length===0)return G;let me=0;for(;G.indexOf(oe,me)===me;)me=me+pe;return G.substring(me)}e.ltrim=C;function b(G,oe){if(!G||!oe)return G;const pe=oe.length,me=G.length;if(pe===0||me===0)return G;let ye=me,Le=-1;for(;Le=G.lastIndexOf(oe,ye-1),!(Le===-1||Le+pe!==ye);){if(Le===0)return"";ye=Le}return G.substring(0,ye)}e.rtrim=b;function p(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function y(G){return G.replace(/\*/g,"")}e.stripWildcards=y;function d(G,oe,pe={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=I(G)),pe.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return pe.global&&(me+="g"),pe.matchCase||(me+="i"),pe.multiline&&(me+="m"),pe.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=d;function h(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function a(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=a;function i(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=i;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function r(G){for(let oe=0,pe=G.length;oe<pe;oe++){const me=G.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function n(G,oe=0,pe=G.length){for(let me=oe;me<pe;me++){const ye=G.charCodeAt(me);if(ye!==32&&ye!==9)return G.substring(oe,me)}return G.substring(oe,pe)}e.getLeadingWhitespace=n;function s(G,oe=G.length-1){for(let pe=oe;pe>=0;pe--){const me=G.charCodeAt(pe);if(me!==32&&me!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function c(G,oe,pe){const me=[];let ye=0;for(const Le of G.matchAll(oe)){if(me.push(G.slice(ye,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");ye=Le.index+Le[0].length,me.push(pe(Le[0],...Le.slice(1),Le.index,G,Le.groups))}return me.push(G.slice(ye)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function u(G,oe){return G<oe?-1:G>oe?1:0}e.compare=u;function P(G,oe,pe=0,me=G.length,ye=0,Le=oe.length){for(;pe<me&&ye<Le;pe++,ye++){const tt=G.charCodeAt(pe),He=oe.charCodeAt(ye);if(tt<He)return-1;if(tt>He)return 1}const Te=me-pe,Ke=Le-ye;return Te<Ke?-1:Te>Ke?1:0}e.compareSubstring=P;function D(G,oe){return T(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=D;function T(G,oe,pe=0,me=G.length,ye=0,Le=oe.length){for(;pe<me&&ye<Le;pe++,ye++){let tt=G.charCodeAt(pe),He=oe.charCodeAt(ye);if(tt===He)continue;if(tt>=128||He>=128)return P(G.toLowerCase(),oe.toLowerCase(),pe,me,ye,Le);U(tt)&&(tt-=32),U(He)&&(He-=32);const Je=tt-He;if(Je!==0)return Je}const Te=me-pe,Ke=Le-ye;return Te<Ke?-1:Te>Ke?1:0}e.compareSubstringIgnoreCase=T;function _(G){return G>=48&&G<=57}e.isAsciiDigit=_;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function Q(G){return G>=65&&G<=90}e.isUpperAsciiLetter=Q;function re(G,oe){return G.length===oe.length&&T(G,oe)===0}e.equalsIgnoreCase=re;function le(G,oe){const pe=oe.length;return oe.length>G.length?!1:T(G,oe,0,pe)===0}e.startsWithIgnoreCase=le;function ue(G,oe){const pe=Math.min(G.length,oe.length);let me;for(me=0;me<pe;me++)if(G.charCodeAt(me)!==oe.charCodeAt(me))return me;return pe}e.commonPrefixLength=ue;function se(G,oe){const pe=Math.min(G.length,oe.length);let me;const ye=G.length-1,Le=oe.length-1;for(me=0;me<pe;me++)if(G.charCodeAt(ye-me)!==oe.charCodeAt(Le-me))return me;return pe}e.commonSuffixLength=se;function fe(G){return 55296<=G&&G<=56319}e.isHighSurrogate=fe;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function $(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=$;function F(G,oe,pe){const me=G.charCodeAt(pe);if(fe(me)&&pe+1<oe){const ye=G.charCodeAt(pe+1);if(K(ye))return $(me,ye)}return me}e.getNextCodePoint=F;function A(G,oe){const pe=G.charCodeAt(oe-1);if(K(pe)&&oe>1){const me=G.charCodeAt(oe-2);if(fe(me))return $(me,pe)}return pe}class W{constructor(oe,pe=0){this._str=oe,this._len=oe.length,this._offset=pe}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=A(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=F(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class z{constructor(oe,pe=0){this._iterator=new W(oe,pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ke.getInstance(),pe=this._iterator,me=pe.offset;let ye=oe.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Le=pe.offset,Te=oe.getGraphemeBreakType(pe.nextCodePoint());if(he(ye,Te)){pe.setOffset(Le);break}ye=Te}return pe.offset-me}prevGraphemeLength(){const oe=ke.getInstance(),pe=this._iterator,me=pe.offset;let ye=oe.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Le=pe.offset,Te=oe.getGraphemeBreakType(pe.prevCodePoint());if(he(Te,ye)){pe.setOffset(Le);break}ye=Te}return me-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function ee(G,oe){return new z(G,oe).nextGraphemeLength()}e.nextCharLength=ee;function B(G,oe){return new z(G,oe).prevGraphemeLength()}e.prevCharLength=B;function H(G,oe){oe>0&&K(G.charCodeAt(oe))&&oe--;const pe=oe+ee(G,oe);return[pe-B(G,pe),pe]}e.getCharContainingOffset=H;let L;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(G){return L||(L=O()),L.test(G)}e.containsRTL=N;const V=/^[\t\n\r\x20-\x7E]*$/;function x(G){return V.test(G)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=ne;function j(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=j;function te(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=te;function ie(G,oe){if(G.length<oe)return G;const pe=/\b/g;let me=0;for(;pe.test(G)&&!(G.length-pe.lastIndex<oe);)me=pe.lastIndex,pe.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=ie;const ae=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function we(G){return G&&(G=G.replace(ae,""),G=G.replace(de,""),G=G.replace(ge,"")),G}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Ee(G){return Se(G)?G.substr(1):G}e.stripUTF8BOM=Ee;function We(G,oe){if(!G||!oe||G.length<oe.length)return!1;const pe=oe.length,me=G.toLowerCase();let ye=0,Le=-1;for(;ye<pe;){const Te=me.indexOf(oe[ye],Le+1);if(Te<0)return!1;Le=Te,ye++}return!0}e.fuzzyContains=We;function Re(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Re;function Ie(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Ie;function De(G,oe=1){if(oe===0)return"";let pe=-1;do pe=G.indexOf(`
`,pe+1),oe--;while(oe>0&&pe>=0);return pe===-1?G:(G[pe-1]==="\r"&&pe--,G.substr(0,pe))}e.getNLines=De;function Y(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=Y;function ce(G){return ke.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ce;function he(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}var Pe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ke{constructor(){this._data=Ne()}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const pe=this._data,me=pe.length/3;let ye=1;for(;ye<=me;)if(oe<pe[3*ye])ye=2*ye;else if(oe>pe[3*ye+1])ye=2*ye+1;else return pe[3*ye+2];return 0}}ke._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(G,oe){if(G===0)return 0;const pe=xe(G,oe);if(pe!==void 0)return pe;const me=new W(oe,G);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ue;function xe(G,oe){const pe=new W(oe,G);let me=pe.prevCodePoint();for(;Ve(me)||me===65039||me===8419;){if(pe.offset===0)return;me=pe.prevCodePoint()}if(!te(me))return;let ye=pe.offset;return ye>0&&pe.prevCodePoint()===8205&&(ye=pe.offset),ye}function Ve(G){return 127995<=G&&G<=127999}var Ye;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class Qe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Qe.cache.get(Array.from(oe))}static getLocales(){return Qe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Qe,k=Qe,Qe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Qe.cache=new v.LRUCachedFunction(G=>{function oe(He){const Je=new Map;for(let it=0;it<He.length;it+=2)Je.set(He[it],He[it+1]);return Je}function pe(He,Je){const it=new Map(He);for(const[ot,ut]of Je)it.set(ot,ut);return it}function me(He,Je){if(!He)return Je;const it=new Map;for(const[ot,ut]of He)Je.has(ot)&&it.set(ot,ut);return it}const ye=k.ambiguousCharacterData.getValue();let Le=G.filter(He=>!He.startsWith("_")&&He in ye);Le.length===0&&(Le=["_default"]);let Te;for(const He of Le){const Je=oe(ye[He]);Te=me(Te,Je)}const Ke=oe(ye._common),tt=pe(Ke,Te);return new Qe(tt)}),Qe._locales=new t.Lazy(()=>Object.keys(Qe.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class $e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set($e.getRawData())),this._data}static isInvisibleCharacter(oe){return $e.getData().has(oe)}static get codePoints(){return $e.getData()}}e.InvisibleCharacters=$e,$e._data=void 0}),define(J[31],Z([0,1,9,5,24,12]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function S(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=S;function l(s){return s.indexOf("/")===-1&&(s=S(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=l;function m(s,c=v.posix.sep){if(!s)return"";const u=s.length,P=s.charCodeAt(0);if(M(P)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let T=3;const _=T;for(;T<u&&!M(s.charCodeAt(T));T++);if(_!==T&&!M(s.charCodeAt(T+1))){for(T+=1;T<u;T++)if(M(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(p(P)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<u;D++)if(M(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=m;function E(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let u=2;const P=u;for(;u<s.length&&(c=s.charCodeAt(u),c!==92);u++);return!(P===u||(c=s.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=E;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,c=t.isWindows){const u=c?I:w;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||c&&g.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function C(s,c,u){const P=s===c;return!u||P?P:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=C;function b(s,c,u,P=v.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===P&&T--,s.charAt(T)===P}return c.charAt(c.length-1)!==P&&(c+=P),s.indexOf(c)===0}e.isEqualOrParent=b;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function y(s,c){return t.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(c,s)),s=(0,v.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,k.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=y;function d(s){const c=(0,v.normalize)(s);return t.isWindows?s.length>3?!1:h(c)&&(s.length===2||c.charCodeAt(2)===92):c===v.posix.sep}e.isRootOrDriveLetter=d;function h(s,c=t.isWindows){return c?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function a(s){return h(s)?s[0]:void 0}e.getDriveLetter=a;function i(s,c,u){return c.length>s.length?-1:s===c?0:(u&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=i;function o(s){const c=s.split(":");let u,P,D;for(const T of c){const _=Number(T);(0,R.isNumber)(_)?P===void 0?P=_:D===void 0&&(D=_):u=u?[u,T].join(":"):T}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:P!==void 0?P:void 0,column:D!==void 0?D:P!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,c,u=8){let P="";for(let T=0;T<u;T++)P+=r.charAt(Math.floor(Math.random()*r.length));let D;return c?D=`${c}-${P}`:D=P,s?(0,v.join)(s,D):D}e.randomPath=n}),define(J[66],Z([0,1,24]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,y){switch(typeof p){case"object":return p===null?R(349,y):Array.isArray(p)?l(p,y):m(p,y);case"string":return S(p,y);case"boolean":return M(p,y);case"number":return R(p,y);case"undefined":return R(937,y);default:return R(617,y)}}e.doHash=k;function R(p,y){return(y<<5)-y+p|0}e.numberHash=R;function M(p,y){return R(p?433:863,y)}function S(p,y){y=R(149417,y);for(let d=0,h=p.length;d<h;d++)y=R(p.charCodeAt(d),y);return y}e.stringHash=S;function l(p,y){return y=R(104579,y),p.reduce((d,h)=>k(h,d),y)}function m(p,y){return y=R(181387,y),Object.keys(p).sort().reduce((d,h)=>(d=S(h,d),k(p[h],d)),y)}class E{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=k(y,this._value),this._value}}e.Hasher=E;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(p,y,d=32){const h=d-y,a=~((1<<h)-1);return(p<<y|(a&p)>>>h)>>>0}function g(p,y=0,d=p.byteLength,h=0){for(let a=0;a<d;a++)p[y+a]=h}function f(p,y,d="0"){for(;p.length<y;)p=d+p;return p}function C(p,y=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(d=>d.toString(16).padStart(2,"0")).join(""):f((p>>>0).toString(16),y/4)}e.toHexString=C;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const d=y.length;if(d===0)return;const h=this._buff;let a=this._buffLen,i=this._leftoverHighSurrogate,o,r;for(i!==0?(o=i,r=-1,i=0):(o=y.charCodeAt(0),r=0);;){let n=o;if(v.isHighSurrogate(o))if(r+1<d){const s=y.charCodeAt(r+1);v.isLowSurrogate(s)?(r++,n=v.computeCodePoint(o,s)):n=65533}else{i=o;break}else v.isLowSurrogate(o)&&(n=65533);if(a=this._push(h,a,n),r++,r<d)o=y.charCodeAt(r);else break}this._buffLen=a,this._leftoverHighSurrogate=i}_push(y,d,h){return h<128?y[d++]=h:h<2048?(y[d++]=192|(h&1984)>>>6,y[d++]=128|(h&63)>>>0):h<65536?(y[d++]=224|(h&61440)>>>12,y[d++]=128|(h&4032)>>>6,y[d++]=128|(h&63)>>>0):(y[d++]=240|(h&1835008)>>>18,y[d++]=128|(h&258048)>>>12,y[d++]=128|(h&4032)>>>6,y[d++]=128|(h&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=b._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)y.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)y.setUint32(u,w(y.getUint32(u-12,!1)^y.getUint32(u-32,!1)^y.getUint32(u-56,!1)^y.getUint32(u-64,!1),1),!1);let h=this._h0,a=this._h1,i=this._h2,o=this._h3,r=this._h4,n,s,c;for(let u=0;u<80;u++)u<20?(n=a&i|~a&o,s=1518500249):u<40?(n=a^i^o,s=1859775393):u<60?(n=a&i|a&o|i&o,s=2400959708):(n=a^i^o,s=3395469782),c=w(h,5)+n+r+s+y.getUint32(u*4,!1)&4294967295,r=o,o=i,i=w(a,30),a=h,h=c;this._h0=this._h0+h&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[32],Z([0,1,23,24]),function(q,e,v,t){"use strict";var k,R,M;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(r,n,s){let c=r.get(n);return c===void 0&&(c=s,r.set(n,c)),c}e.getOrSet=S;function l(r){const n=[];return r.forEach((s,c)=>{n.push(`${c} => ${s}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=l;function m(r){const n=[];return r.forEach(s=>{n.push(s)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=m;class E{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=E;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class w{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var g;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(b||(b={}));class p{constructor(n){this._iter=n}static forUris(n=()=>!1,s=()=>!1){return new p(new f(n,s))}static forPaths(n=!1){return new p(new w(void 0,!n))}static forStrings(){return new p(new E)}static forConfigKeys(){return new p(new I)}clear(){this._root=void 0}fill(n,s){if(s){const c=s.slice(0);(0,v.shuffle)(c);for(const u of c)this.set(u,n)}else{const c=n.slice(0);(0,v.shuffle)(c);for(const u of c)this.set(u[0],u[1])}}set(n,s){const c=this._iter.reset(n);let u;this._root||(this._root=new C,this._root.segment=c.value());const P=[];for(u=this._root;;){const T=c.cmp(u.segment);if(T>0)u.left||(u.left=new C,u.left.segment=c.value()),P.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new C,u.right.segment=c.value()),P.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new C,u.mid.segment=c.value()),P.push([0,u]),u=u.mid;else break}const D=u.value;u.value=s,u.key=n;for(let T=P.length-1;T>=0;T--){const _=P[T][1];_.updateHeight();const U=_.balanceFactor();if(U<-1||U>1){const Q=P[T][0],re=P[T+1][0];if(Q===1&&re===1)P[T][1]=_.rotateLeft();else if(Q===-1&&re===-1)P[T][1]=_.rotateRight();else if(Q===1&&re===-1)_.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=_.rotateLeft();else if(Q===-1&&re===1)_.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=_.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return D}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const c=this._iter.reset(n),u=[];let P=this._root;for(;P;){const D=c.cmp(P.segment);if(D>0)u.push([-1,P]),P=P.left;else if(D<0)u.push([1,P]),P=P.right;else if(c.hasNext())c.next(),u.push([0,P]),P=P.mid;else break}if(!!P){if(s?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const D=this._min(P.right),{key:T,value:_,segment:U}=D;this._delete(D.key,!1),P.key=T,P.value=_,P.segment=U}else{const D=P.left??P.right;if(u.length>0){const[T,_]=u[u.length-1];switch(T){case-1:_.left=D;break;case 0:_.mid=D;break;case 1:_.right=D;break}}else this._root=D}for(let D=u.length-1;D>=0;D--){const T=u[D][1];T.updateHeight();const _=T.balanceFactor();if(_>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),u[D][1]=T.rotateLeft()):_<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),u[D][1]=T.rotateRight()),D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let c=this._root,u;for(;c;){const P=s.cmp(c.segment);if(P>0)c=c.left;else if(P<0)c=c.right;else if(s.hasNext())s.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[s,c]of this)n(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=p;class y{constructor(n,s){this.uri=n,this.value=s}}class d{constructor(n,s){this[k]="ResourceMap",n instanceof d?(this.map=new Map(n.map),this.toKey=s??d.defaultToKey):(this.map=new Map,this.toKey=n??d.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new y(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[c,u]of this.map)n(u.value,u.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=d,d.defaultToKey=r=>r.toString();class h{constructor(n,s){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new d(n):(this._map=new d(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((c,u)=>n.call(s,u,u,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class i{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const c=this._map.get(n);if(!!c)return s!==0&&this.touch(c,s),c.value}set(n,s,c=0){let u=this._map.get(n);if(u)u.value=s,c!==0&&this.touch(u,c);else{switch(u={key:n,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const c=this._state;let u=this._head;for(;u;){if(s?n.bind(s)(u.value,u.key,this):n(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:c.key,done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return u}values(){const n=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:c.value,done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return u}entries(){const n=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:[c.key,c.value],done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return u}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>n;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,c=n.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const c=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const c=n.next,u=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,c)=>{n.push([c,s])}),n}fromJSON(n){this.clear();for(const[s,c]of n)this.set(s,c)}}e.LinkedMap=i;class o extends i{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(J[78],Z([0,1,32]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function k(m){return l(m,"NFC",t)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function M(m){return l(m,"NFD",R)}e.normalizeNFD=M;const S=/[^\u0000-\u0080]/;function l(m,E,I){if(!m)return m;const w=I.get(m);if(w)return w;let g;return S.test(m)?g=m.normalize(E):g=m,I.set(m,g),g}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(E){return M(E).replace(m,"")}}()}),define(J[92],Z([0,1,24]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",M="warning",S="warn",l="info",m="ignore";function E(w){return w?v.equalsIgnoreCase(R,w)?k.Error:v.equalsIgnoreCase(M,w)||v.equalsIgnoreCase(S,w)?k.Warning:v.equalsIgnoreCase(l,w)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function I(w){switch(w){case k.Error:return R;case k.Warning:return M;case k.Info:return l;default:return m}}k.toString=I}(t||(t={})),e.default=t}),define(J[7],Z([0,1,9,5]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function S(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(r,n){return!r&&!n?"file":r}function m(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const E="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,s,c,u,P,D=!1){typeof n=="object"?(this.scheme=n.scheme||E,this.authority=n.authority||E,this.path=n.path||E,this.query=n.query||E,this.fragment=n.fragment||E):(this.scheme=l(n,D),this.authority=s||E,this.path=m(this.scheme,c||E),this.query=u||E,this.fragment=P||E,S(this,D))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:c,path:u,query:P,fragment:D}=n;return s===void 0?s=this.scheme:s===null&&(s=E),c===void 0?c=this.authority:c===null&&(c=E),u===void 0?u=this.path:u===null&&(u=E),P===void 0?P=this.query:P===null&&(P=E),D===void 0?D=this.fragment:D===null&&(D=E),s===this.scheme&&c===this.authority&&u===this.path&&P===this.query&&D===this.fragment?this:new C(s,c,u,P,D)}static parse(n,s=!1){const c=w.exec(n);return c?new C(c[2]||E,o(c[4]||E),o(c[5]||E),o(c[7]||E),o(c[9]||E),s):new C(E,E,E,E,E)}static file(n){let s=E;if(t.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const c=n.indexOf(I,2);c===-1?(s=n.substring(2),n=I):(s=n.substring(2,c),n=n.substring(c)||I)}return new C("file",s,n,E,E)}static from(n){const s=new C(n.scheme,n.authority,n.path,n.query,n.fragment);return S(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&n.scheme==="file"?c=g.file(v.win32.join(d(n,!0),...s)).path:c=v.posix.join(n.path,...s),n.with({path:c})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const s=new C(n);return s._formatted=n.external,s._fsPath=n._sep===f?n.fsPath:null,s}}else return n}}e.URI=g;const f=t.isWindows?1:void 0;class C extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=f),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,n){let s,c=-1;for(let u=0;u<r.length;u++){const P=r.charCodeAt(u);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47)c!==-1&&(s+=encodeURIComponent(r.substring(c,u)),c=-1),s!==void 0&&(s+=r.charAt(u));else{s===void 0&&(s=r.substr(0,u));const D=b[P];D!==void 0?(c!==-1&&(s+=encodeURIComponent(r.substring(c,u)),c=-1),s+=D):c===-1&&(c=u)}}return c!==-1&&(s+=encodeURIComponent(r.substring(c))),s!==void 0?s:r}function y(r){let n;for(let s=0;s<r.length;s++){const c=r.charCodeAt(s);c===35||c===63?(n===void 0&&(n=r.substr(0,s)),n+=b[c]):n!==void 0&&(n+=r[s])}return n!==void 0?n:r}function d(r,n){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function h(r,n){const s=n?y:p;let c="",{scheme:u,authority:P,path:D,query:T,fragment:_}=r;if(u&&(c+=u,c+=":"),(P||u==="file")&&(c+=I,c+=I),P){let U=P.indexOf("@");if(U!==-1){const Q=P.substr(0,U);P=P.substr(U+1),U=Q.indexOf(":"),U===-1?c+=s(Q,!1):(c+=s(Q.substr(0,U),!1),c+=":",c+=s(Q.substr(U+1),!1)),c+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?c+=s(P,!1):(c+=s(P.substr(0,U),!1),c+=P.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}c+=s(D,!0)}return T&&(c+="?",c+=s(T,!1)),_&&(c+="#",c+=n?_:p(_,!1)),c}function a(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+a(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(i)?r.replace(i,n=>a(n)):r}}),define(J[139],Z([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const E=m;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const E=[];let I;try{const w=JSON.parse(m.arguments),g=w[w.length-1];g&&g.__$stack&&(w.pop(),I=g.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",m.arguments)}return{args:E,stack:I}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const E=m;if(E){const I=M(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:v.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=R;function M(m){if(!m)return m;const E=m.indexOf(`
`);return E===-1?m:m.substring(0,E)}function S(m,E){const{args:I,stack:w}=k(m),g=typeof I[0]=="string"&&I.length===1;let f=M(w);f&&(f=`(${f.trim()})`);let C=[];if(typeof I[0]=="string"?f&&g?C=[`%c[${E}] %c${I[0]} %c${f}`,l("blue"),l(""),l("grey")]:C=[`%c[${E}] %c${I[0]}`,l("blue"),l(""),...I.slice(1)]:C=[`%c[${E}]%`,l("blue"),...I],f&&!g&&C.push(f),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,C)}e.log=S;function l(m){return`color: ${m}`}}),define(J[67],Z([0,1,17,24,7]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,S)}e.stringify=R;function M(m){let E=JSON.parse(m);return E=l(E),E}e.parse=M;function S(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,t.regExpFlags)(E)}:E}function l(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=l(m[I],E+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=l(m[I],E+1))}return m}e.revive=l}),define(J[13],Z([0,1,5,7]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(l){this._preferredWebSchema=l}setDelegate(l){this._delegate=l}setServerRootPath(l){this._remoteResourcesPath=`${l}/${k.vscodeRemoteResource}`}set(l,m,E){this._hosts[l]=m,this._ports[l]=E}setConnectionToken(l,m){this._connectionTokens[l]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(l){if(this._delegate)return this._delegate(l);const m=l.authority;let E=this._hosts[m];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const I=this._ports[m],w=this._connectionTokens[m];let g=`path=${encodeURIComponent(l.path)}`;return typeof w=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${E}:${I}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class M{asBrowserUri(l,m){const E=this.toUri(l,m);return E.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===k.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${k.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?E.with({scheme:k.vscodeFileResource,authority:E.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(l,m){const E=this.toUri(l,m);return E.scheme===k.vscodeFileResource?E.with({scheme:k.file,authority:E.authority!==M.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(l,m){return t.URI.isUri(l)?l:t.URI.parse(m.toUrl(l))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(J[16],Z([0,1,31,13,9,5,24,7]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function l(g){return(0,S.uriToFsPath)(g,!0)}e.originalFSPath=l;class m{constructor(f){this._ignorePathCasing=f}compare(f,C,b=!1){return f===C?0:(0,M.compare)(this.getComparisonKey(f,b),this.getComparisonKey(C,b))}isEqual(f,C,b=!1){return f===C?!0:!f||!C?!1:this.getComparisonKey(f,b)===this.getComparisonKey(C,b)}getComparisonKey(f,C=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,C,b=!1){if(f.scheme===C.scheme){if(f.scheme===t.Schemas.file)return v.isEqualOrParent(l(f),l(C),this._ignorePathCasing(f))&&f.query===C.query&&(b||f.fragment===C.fragment);if((0,e.isEqualAuthority)(f.authority,C.authority))return v.isEqualOrParent(f.path,C.path,this._ignorePathCasing(f),"/")&&f.query===C.query&&(b||f.fragment===C.fragment)}return!1}joinPath(f,...C){return S.URI.joinPath(f,...C)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let C;return f.scheme===t.Schemas.file?C=S.URI.file(k.dirname(l(f))).path:(C=k.posix.dirname(f.path),f.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),C="/")),f.with({path:C})}normalizePath(f){if(!f.path.length)return f;let C;return f.scheme===t.Schemas.file?C=S.URI.file(k.normalize(l(f))).path:C=k.posix.normalize(f.path),f.with({path:C})}relativePath(f,C){if(f.scheme!==C.scheme||!(0,e.isEqualAuthority)(f.authority,C.authority))return;if(f.scheme===t.Schemas.file){const y=k.relative(l(f),l(C));return R.isWindows?v.toSlashes(y):y}let b=f.path||"/";const p=C.path||"/";if(this._ignorePathCasing(f)){let y=0;for(const d=Math.min(b.length,p.length);y<d&&!(b.charCodeAt(y)!==p.charCodeAt(y)&&b.charAt(y).toLowerCase()!==p.charAt(y).toLowerCase());y++);b=p.substr(0,y)+b.substr(y)}return k.posix.relative(b,p)}resolvePath(f,C){if(f.scheme===t.Schemas.file){const b=S.URI.file(k.resolve(l(f),C));return f.with({authority:b.authority,path:b.path})}return C=v.toPosixPath(C),f.with({path:k.posix.resolve(f.path,C)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,C){return f===C||f!==void 0&&C!==void 0&&(0,M.equalsIgnoreCase)(f,C)}hasTrailingPathSeparator(f,C=k.sep){if(f.scheme===t.Schemas.file){const b=l(f);return b.length>v.getRoot(b).length&&b[b.length-1]===C}else{const b=f.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,C=k.sep){return(0,e.hasTrailingPathSeparator)(f,C)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,C=k.sep){let b=!1;if(f.scheme===t.Schemas.file){const p=l(f);b=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===C}else{C="/";const p=f.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(f,C)?f.with({path:f.path+"/"}):f}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(g,f){const C=[];for(let b=0;b<g.length;b++){const p=f(g[b]);g.some((y,d)=>d===b?!1:(0,e.isEqualOrParent)(p,f(y)))||C.push(g[b])}return C}e.distinctParents=E;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function f(C){const b=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(d=>{const[h,a]=d.split(":");h&&a&&b.set(h,a)});const y=C.path.substring(0,C.path.indexOf(";"));return y&&b.set(g.META_DATA_MIME,y),b}g.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function w(g,f,C){if(f){let b=g.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),g.with({scheme:C,authority:f,path:b})}return g.with({scheme:C})}e.toLocalResource=w}),define(J[8],Z([0,1,22,18,3,2,16,5]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(H){return!!H&&typeof H.then=="function"}e.isThenable=l;function m(H){const L=new v.CancellationTokenSource,O=H(L.token),N=new Promise((V,x)=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(O).then(j=>{ne.dispose(),L.dispose(),V(j)},j=>{ne.dispose(),L.dispose(),x(j)})});return new class{cancel(){L.cancel()}then(V,x){return N.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return N.finally(V)}}}e.createCancelablePromise=m;function E(H,L,O){return new Promise((N,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),N(O)});H.then(N,V).finally(()=>x.dispose())})}e.raceCancellation=E;function I(H,L){return new Promise((O,N)=>{const V=L.onCancellationRequested(()=>{V.dispose(),N(new t.CancellationError)});H.then(O,N).finally(()=>V.dispose())})}e.raceCancellationError=I;async function w(H){let L=-1;const O=H.map((V,x)=>V.then(ne=>(L=x,ne))),N=await Promise.race(O);return H.forEach((V,x)=>{x!==L&&V.cancel()}),N}e.raceCancellablePromises=w;function g(H,L,O){let N;const V=setTimeout(()=>{N?.(void 0),O?.()},L);return Promise.race([H.finally(()=>clearTimeout(V)),new Promise(x=>N=x)])}e.raceTimeout=g;function f(H){return new Promise((L,O)=>{const N=H();l(N)?N.then(L,O):L(N)})}e.asPromise=f;class C{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=L(),new Promise((O,N)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,N(V)})})}}e.Throttler=C;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class p{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=p;const y=(H,L)=>{let O=!0;const N=setTimeout(()=>{O=!1,L()},H);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},d=H=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,H())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(N):y(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class a{constructor(L){this.delayer=new h(L),this.throttler=new C}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class i{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function r(H,L){return L?new Promise((O,N)=>{const V=setTimeout(()=>{x.dispose(),O()},H),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),N(new t.CancellationError)})}):m(O=>r(H,O))}e.timeout=r;function n(H,L=0){const O=setTimeout(H,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function s(H){const L=[];let O=0;const N=H.length;function V(){return O<N?H[O++]():null}function x(ne){ne!=null&&L.push(ne);const j=V();return j?j.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=s;function c(H,L=N=>!!N,O=null){let N=0;const V=H.length,x=()=>{if(N>=V)return Promise.resolve(O);const ne=H[N++];return Promise.resolve(ne()).then(te=>L(te)?Promise.resolve(te):x())};return x()}e.first=c;function u(H,L=N=>!!N,O=null){if(H.length===0)return Promise.resolve(O);let N=H.length;const V=()=>{N=-1;for(const x of H)x.cancel?.()};return new Promise((x,ne)=>{for(const j of H)j.then(te=>{--N>=0&&L(te)?(V(),x(te)):N===0&&x(O)}).catch(te=>{--N>=0&&(V(),ne(te))})})}e.firstParallel=u;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:L,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class D extends P{constructor(){super(1)}}e.Queue=D;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=M.extUri){const N=O.getComparisonKey(L);let V=this.queues.get(N);return V||(V=new D,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class _{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=_;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class Q{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Q;class re{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends Q{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class ue extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,S.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(H,L)=>{const O=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function fe(H,L,O){let N;for(let V=0;V<O;V++)try{return await H()}catch(x){N=x,await r(L)}throw N}e.retry=fe;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,O,N){return this._pending={taskId:L,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,N;const V=new Promise((x,ne)=>{O=x,N=ne});this._next={run:L,promise:V,promiseResolve:O,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=K;class ${constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function(H){async function L(N){let V;const x=await Promise.all(N.map(ne=>ne.then(j=>j,j=>{V||(V=j)})));if(typeof V<"u")throw V;return x}H.settled=L;function O(N){return new Promise(async(V,x)=>{try{await N(V,x)}catch(ne){x(ne)}})}H.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(L(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async N=>O.emitOne(await N)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async N=>{for await(const V of N)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async N=>{for await(const V of L)N.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async N=>{for await(const V of L)O(V)&&N.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const N of L)O.push(N);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class ee extends z{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ee;function B(H){const L=new v.CancellationTokenSource,O=H(L.token);return new ee(L,async N=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),N.reject(new t.CancellationError)});try{for await(const x of O){if(L.token.isCancellationRequested)return;N.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),N.reject(x)}})}e.createCancelableAsyncIterable=B}),define(J[93],Z([0,1,23,8,31,32,9,5,24]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",I="[^/\\\\]",w=/\//g;function g(F,A){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${E}|${I}+${E}${A?`|${E}${I}+`:""})*?`}}function f(F,A){if(!F)return[];const W=[];let z=!1,ee=!1,B="";for(const H of F){switch(H){case A:if(!z&&!ee){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}B+=H}return B&&W.push(B),W}e.splitGlobAware=f;function C(F){if(!F)return"";let A="";const W=f(F,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;W.forEach((ee,B)=>{if(ee===e.GLOBSTAR){if(z)return;A+=g(2,B===W.length-1)}else{let H=!1,L="",O=!1,N="";for(const V of ee){if(V!=="}"&&H){L+=V;continue}if(O&&(V!=="]"||!N)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!N?x="^":V===e.GLOB_SPLIT?x="":x=(0,l.escapeRegExpCharacters)(V),N+=x;continue}switch(V){case"{":H=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${f(L,",").map(j=>C(j)).join("|")})`,H=!1,L="";break}case"]":{A+="["+N+"]",O=!1,N="";break}case"?":A+=I;continue;case"*":A+=g(1);continue;default:A+=(0,l.escapeRegExpCharacters)(V)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=E)}z=ee===e.GLOBSTAR})}return A}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},r=function(){return null};function n(F,A){if(!F)return r;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const z=`${W}_${!!A.trimForExclusions}`;let ee=i.get(z);if(ee)return s(ee,F);let B;return b.test(W)?ee=u(W.substr(4),W):(B=p.exec(c(W,A)))?ee=P(B[1],W):(A.trimForExclusions?d:y).test(W)?ee=D(W,A):(B=h.exec(c(W,A)))?ee=T(B[1].substr(1),W,!0):(B=a.exec(c(W,A)))?ee=T(B[1],W,!1):ee=_(W),i.set(z,ee),s(ee,F)}function s(F,A){if(typeof A=="string")return F;const W=function(z,ee){return(0,k.isEqualOrParent)(z,A.base,!S.isLinux)?F(z.substr(A.base.length+1),ee):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function c(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,A){return function(W,z){return typeof W=="string"&&W.endsWith(F)?A:null}}function P(F,A){const W=`/${F}`,z=`\\${F}`,ee=function(H,L){return typeof H!="string"?null:L?L===F?A:null:H===F||H.endsWith(W)||H.endsWith(z)?A:null},B=[F];return ee.basenames=B,ee.patterns=[A],ee.allBasenames=B,ee}function D(F,A){const W=K(F.slice(1,-1).split(",").map(L=>n(L,A)).filter(L=>L!==r),F),z=W.length;if(!z)return r;if(z===1)return W[0];const ee=function(L,O){for(let N=0,V=W.length;N<V;N++)if(W[N](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(ee.allPaths=H),ee}function T(F,A,W){const z=M.sep===M.posix.sep,ee=z?F:F.replace(w,M.sep),B=M.sep+ee,H=M.posix.sep+F;let L;return W?L=function(O,N){return typeof O=="string"&&(O===ee||O.endsWith(B)||!z&&(O===F||O.endsWith(H)))?A:null}:L=function(O,N){return typeof O=="string"&&(O===ee||!z&&O===F)?A:null},L.allPaths=[(W?"*/":"./")+F],L}function _(F){try{const A=new RegExp(`^${C(F)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?F:null}}catch{return r}}function U(F,A,W){return!F||typeof A!="string"?!1:Q(F)(A,void 0,W)}e.match=U;function Q(F,A={}){if(!F)return o;if(typeof F=="string"||re(F)){const W=n(F,A);if(W===r)return o;const z=function(ee,B){return!!W(ee,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return se(F,A)}e.parse=Q;function re(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=re;function le(F){return F.allBasenames||[]}e.getBasenameTerms=le;function ue(F){return F.allPaths||[]}e.getPathTerms=ue;function se(F,A){const W=K(Object.getOwnPropertyNames(F).map(L=>fe(L,F[L],A)).filter(L=>L!==r)),z=W.length;if(!z)return r;if(!W.some(L=>!!L.requiresSiblings)){if(z===1)return W[0];const L=function(V,x){let ne;for(let j=0,te=W.length;j<te;j++){const ie=W[j](V,x);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ne||(ne=[]),ne.push(ie))}return ne?(async()=>{for(const j of ne){const te=await j;if(typeof te=="string")return te}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const N=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return N.length&&(L.allPaths=N),L}const ee=function(L,O,N){let V,x;for(let ne=0,j=W.length;ne<j;ne++){const te=W[ne];te.requiresSiblings&&N&&(O||(O=(0,M.basename)(L)),V||(V=O.substr(0,O.length-(0,M.extname)(L).length)));const ie=te(L,O,V,N);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(x||(x=[]),x.push(ie))}return x?(async()=>{for(const ne of x){const j=await ne;if(typeof j=="string")return j}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(ee.allPaths=H),ee}function fe(F,A,W){if(A===!1)return r;const z=n(F,W);if(z===r)return r;if(typeof A=="boolean")return z;if(A){const ee=A.when;if(typeof ee=="string"){const B=(H,L,O,N)=>{if(!N||!z(H,L))return null;const V=ee.replace("$(basename)",O),x=N(V);return(0,t.isThenable)(x)?x.then(ne=>ne?F:null):x?F:null};return B.requiresSiblings=!0,B}}return z}function K(F,A){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const z=W.reduce((L,O)=>{const N=O.basenames;return N?L.concat(N):L},[]);let ee;if(A){ee=[];for(let L=0,O=z.length;L<O;L++)ee.push(A)}else ee=W.reduce((L,O)=>{const N=O.patterns;return N?L.concat(N):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}O=L.substr(V)}const N=z.indexOf(O);return N!==-1?ee[N]:null};B.basenames=z,B.patterns=ee,B.allBasenames=z;const H=F.filter(L=>!L.basenames);return H.push(B),H}function $(F,A){return(0,v.equals)(F,A,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=$}),define(J[35],Z([0,1,23,31,9,5,16,24]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function l(r,n){const{os:s,tildify:c,relative:u}=n;if(u){const T=m(r,u,s);if(typeof T=="string")return T}let P=r.fsPath;if(s===1&&!R.isWindows?P=P.replace(/\//g,"\\"):s!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let _;r.scheme!==c.userHome.scheme&&r.path.startsWith(k.posix.sep)?_=c.userHome.with({path:r.path}).fsPath:_=r.fsPath,P=w(_,T,s)}return(s===1?k.win32:k.posix).normalize(E(P,s===1))}e.getPathLabel=l;function m(r,n,s){const c=s===1?k.win32:k.posix,u=s===3?M.extUri:M.extUriIgnorePathCase,P=n.getWorkspace(),D=(0,v.firstOrDefault)(P.folders);if(!D)return;r.scheme!==D.uri.scheme&&r.path.startsWith(k.posix.sep)&&(r=D.uri.with({path:r.path}));const T=n.getWorkspaceFolder(r);if(!T)return;let _;if(u.isEqual(T.uri,r)?_="":_=u.relativePath(T.uri,r)??"",_&&(_=c.normalize(_)),P.folders.length>1&&!n.noPrefix){const U=T.name?T.name:u.basenameOrAuthority(T.uri);_=_?`${U} \u2022 ${_}`:U}return _}function E(r,n=R.isWindows){return(0,t.hasDriveLetter)(r,n)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=E;let I=Object.create(null);function w(r,n,s=R.OS){if(s===1||!r||!n)return r;let c=I.original===n?I.normalized:void 0;c||(c=n,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,S.rtrim)(c,k.posix.sep)}${k.posix.sep}`,I={original:n,normalized:c});let u=r;return R.isWindows&&(u=(0,t.toSlashes)(u)),(s===3?u.startsWith(c):(0,S.startsWithIgnoreCase)(u,c))?`~/${u.substr(c.length)}`:r}e.tildify=w;function g(r,n){return r.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=g;const f="\u2026",C="\\\\",b="~";function p(r,n=k.sep){const s=new Array(r.length);let c=!1;for(let u=0;u<r.length;u++){const P=r[u];if(P===""){s[u]=`.${n}`;continue}if(!P){s[u]=P;continue}c=!0;let D="",T=P;T.indexOf(C)===0?(D=T.substr(0,T.indexOf(C)+C.length),T=T.substr(T.indexOf(C)+C.length)):T.indexOf(n)===0?(D=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(b)===0&&(D=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const _=T.split(n);for(let U=1;c&&U<=_.length;U++)for(let Q=_.length-U;c&&Q>=0;Q--){c=!1;let re=_.slice(Q,Q+U).join(n);for(let le=0;!c&&le<r.length;le++)if(le!==u&&r[le]&&r[le].indexOf(re)>-1){const ue=Q+U===_.length,se=Q>0&&r[le].indexOf(n)>-1?n+re:re,fe=r[le].endsWith(se);c=!ue||fe}if(!c){let le="";(_[0].endsWith(":")||D!=="")&&(Q===1&&(Q=0,U++,re=_[0]+n+re),Q>0&&(le=_[0]+n),le=D+le),Q>0&&(le=le+f+n),le=le+re,Q+U<_.length&&(le=le+n+f),s[u]=le}}c&&(s[u]=P)}return s}e.shorten=p;var y;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(y||(y={}));function d(r,n=Object.create(null)){const s=[];let c=!1,u="";for(const P of r)if(P==="$"||c&&P==="{")u&&s.push({value:u,type:y.TEXT}),u="",c=!0;else if(P==="}"&&c){const D=n[u];if(typeof D=="string")D.length&&s.push({value:D,type:y.VARIABLE});else if(D){const T=s[s.length-1];(!T||T.type!==y.SEPARATOR)&&s.push({value:D.label,type:y.SEPARATOR})}u="",c=!1}else u+=P;return u&&!c&&s.push({value:u,type:y.TEXT}),s.filter((P,D)=>{if(P.type===y.SEPARATOR){const T=s[D-1],_=s[D+1];return[T,_].every(U=>U&&(U.type===y.VARIABLE||U.type===y.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=d;function h(r,n){return R.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function a(r,n){return R.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,s=>s==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(r){const n=r.indexOf("/")!==-1?k.posix:k.win32,s=n.basename(r),c=n.dirname(r);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(J[140],Z([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(E){return E.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const w=this._uriTransformer.transformIncoming(I);return w===I?I:t(v.URI.from(w))}transformOutgoing(I){const w=this._uriTransformer.transformOutgoing(I);return w===I?I:t(v.URI.from(w))}transformOutgoingURI(I){const w=this._uriTransformer.transformOutgoing(I);return w===I?I:v.URI.from(w)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function R(E,I,w){if(!E||w>200)return null;if(typeof E=="object"){if(E instanceof v.URI)return I.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const f=R(E[g],I,w+1);f!==null&&(E[g]=f)}}return null}function M(E,I){const w=R(E,I,0);return w===null?E:w}e.transformOutgoingURIs=M;function S(E,I,w,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return w?v.URI.revive(I.transformIncoming(E)):I.transformIncoming(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const C=S(E[f],I,w,g+1);C!==null&&(E[f]=C)}}return null}function l(E,I){const w=S(E,I,!1,0);return w===null?E:w}e.transformIncomingURIs=l;function m(E,I){const w=S(E,I,!0,0);return w===null?E:w}e.transformAndReviveIncomingURIs=m}),define(J[94],Z([0,1,30,18,32,28,128]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,I=0;const w=(0,v.networkInterfaces)();for(const g in w){const f=w[g];if(f)for(const{mac:C,internal:b}of f)b||(I+=1,this._isVirtualMachineMacAddress(C.toUpperCase())&&(E+=1))}this._value=I>0?E/I:0}return this._value}};let S;async function l(){return S||(S=(async()=>await m()||R.generateUuid())()),S}e.getMachineId=l;async function m(){try{const E=await new Promise((w,g)=>{q(["crypto"],w,g)}),I=(0,M.getMac)();return E.createHash("sha256").update(I,"utf8").digest("hex")}catch(E){t.onUnexpectedError(E);return}}}),define(J[25],Z([0,1,29,30,141,8,31,78,9,5,16,7]),function(q,e,v,t,k,R,M,S,l,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function g(se,fe=w.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return fe===w.UNLINK?C(se):f(se)}async function f(se){try{const fe=(0,M.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,fe)}catch{return C(se)}C(fe).catch(K=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function C(se){return(0,k.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function b(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function p(se,fe){return h(await(fe?y(se):(0,k.promisify)(v.readdir)(se)))}async function y(se){try{return await(0,k.promisify)(v.readdir)(se,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const fe=[],K=await p(se);for(const $ of K){let F=!1,A=!1,W=!1;try{const z=await e.Promises.lstat((0,l.join)(se,$));F=z.isFile(),A=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}fe.push({name:$,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>W})}return fe}function d(se){return h(v.readdirSync(se))}e.readdirSync=d;function h(se){return se.map(fe=>typeof fe=="string"?m.isMacintosh?(0,S.normalizeNFC)(fe):fe:(fe.name=m.isMacintosh?(0,S.normalizeNFC)(fe.name):fe.name,fe))}async function a(se){const fe=await p(se),K=[];for(const $ of fe)await o.existsDirectory((0,l.join)(se,$))&&K.push($);return K}function i(se,fe=1e3){return new Promise(K=>{let $=!1;const F=setInterval(()=>{$||($=!0,v.access(se,A=>{$=!1,A&&(clearInterval(F),K(void 0))}))},fe)})}e.whenDeleted=i;var o;(function(se){async function fe(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw W}}se.stat=fe;async function K(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=K;async function $(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=$})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function n(se,fe,K){return r.queueFor(I.URI.file(se),E.extUriBiasedIgnorePathCase).queue(()=>{const $=D(K);return new Promise((F,A)=>u(se,fe,$,W=>W?A(W):F()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function u(se,fe,K,$){if(!s)return v.writeFile(se,fe,{mode:K.mode,flag:K.flag},$);v.open(se,K.flag,K.mode,(F,A)=>{if(F)return $(F);v.writeFile(A,fe,W=>{if(W)return v.close(A,()=>$(W));v.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),v.close(A,ee=>$(ee))))})})}function P(se,fe,K){const $=D(K);if(!s)return v.writeFileSync(se,fe,{mode:$.mode,flag:$.flag});const F=v.openSync(se,$.flag,$.mode);try{v.writeFileSync(F,fe);try{v.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{v.closeSync(F)}}e.writeFileSync=P;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,fe){if(se!==fe)try{await e.Promises.rename(se,fe)}catch(K){if(se.toLowerCase()!==fe.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await _(se,fe,{preserveSymlinks:!1}),await g(se,w.MOVE);else throw K}}async function _(se,fe,K){return Q(se,fe,{root:{source:se,target:fe},options:K,handledSourcePaths:new Set})}const U=511;async function Q(se,fe,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:$,symbolicLink:F}=await o.stat(se);if(F){if(K.options.preserveSymlinks)try{return await ue(se,fe,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return $.isDirectory()?re(se,fe,$.mode&U,K):le(se,fe,$.mode&U)}async function re(se,fe,K,$){await e.Promises.mkdir(fe,{recursive:!0,mode:K});const F=await p(se);for(const A of F)await Q((0,l.join)(se,A),(0,l.join)(fe,A),$)}async function le(se,fe,K){await e.Promises.copyFile(se,fe),await e.Promises.chmod(fe,K)}async function ue(se,fe,K){let $=await e.Promises.readlink(se);(0,M.isEqualOrParent)($,K.root.source,!m.isLinux)&&($=(0,l.join)(K.root.target,$.substr(K.root.source.length+1))),await e.Promises.symlink($,fe)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(se,fe,K,$,F)=>new Promise((A,W)=>{v.read(se,fe,K,$,F,(z,ee,B)=>z?W(z):A({bytesRead:ee,buffer:B}))})}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(se,fe,K,$,F)=>new Promise((A,W)=>{v.write(se,fe,K,$,F,(z,ee,B)=>z?W(z):A({bytesWritten:ee,buffer:B}))})}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return g}get move(){return T}get copy(){return _}}}),define(J[95],Z([0,1,29,9,5,24,25]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(w){if(k.isLinux)return w;const g=(0,t.dirname)(w);if(w===g)return w;const f=((0,t.basename)(w)||w).toLowerCase();try{const b=(0,M.readdirSync)(g).filter(p=>p.toLowerCase()===f);if(b.length===1){const p=S(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(f);if(p>=0){const y=S(g);if(y)return(0,t.join)(y,b[p])}}}catch{}return null}e.realcaseSync=S;async function l(w){if(k.isLinux)return w;const g=(0,t.dirname)(w);if(w===g)return w;const f=((0,t.basename)(w)||w).toLowerCase();try{const b=(await M.Promises.readdir(g)).filter(p=>p.toLowerCase()===f);if(b.length===1){const p=await l(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(f);if(p>=0){const y=await l(g);if(y)return(0,t.join)(y,b[p])}}}catch{}return null}e.realcase=l;async function m(w){try{return await M.Promises.realpath(w)}catch{const f=I(w);return await M.Promises.access(f,v.constants.R_OK),f}}e.realpath=m;function E(w){try{return v.realpathSync(w)}catch{const f=I(w);return v.accessSync(f,v.constants.R_OK),f}}e.realpathSync=E;function I(w){return(0,R.rtrim)((0,t.normalize)(w),t.sep)}}),define(J[142],Z([0,1,30,9,25]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var l;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class I{constructor(a,i,o){this.exePath=a,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:h=!1}={}){return h?m===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:h=!1,findPreview:a=!1}={}){const i=w({useAlternateBitness:h});if(!i)return null;const o=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let r=-1,n=null;for(const u of await k.Promises.readdir(o)){let P=-1;if(a){const T=u.indexOf("-");if(T<0)continue;const _=u.substring(0,T);if(!R.test(_)||u.substring(T+1)!=="preview")continue;P=parseInt(_,10)}else{if(!R.test(u))continue;P=parseInt(u,10)}if(P<=r)continue;const D=t.join(o,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(n=D,r=P)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",c=a?" Preview":"";return new I(n,`PowerShell${c}${s}`,!0)}async function f({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const a=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(a))if(i.test(r)){const n=t.join(a,r,"pwsh.exe");return new I(n,o)}return null}function C(){const h=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new I(h,".NET Core PowerShell Global Tool")}function b(){const h=t.join(process.env.windir,m===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(h,"Windows PowerShell",!0)}async function*p(){let h=await g();h&&(yield h),h=await g({useAlternateBitness:!0}),h&&(yield h),h=await f(),h&&(yield h),h=C(),h&&(yield h),h=await g({findPreview:!0}),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await g({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=b(),h&&(yield h)}async function*y(){for await(const h of p())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=y;async function d(){for await(const h of y())return h;return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[79],Z([0,1,9,5,34,76,12,25]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function l(I=k.env){return I.comspec||"cmd.exe"}e.getWindowsShell=l;function m(I){let w=[],g=!1;const f=function(C){if(g){w.push(C);return}(!I.send(C,p=>{if(p&&console.error(p),g=!1,w.length>0){const y=w.slice(0);w=[],y.forEach(d=>f(d))}})||t.isWindows)&&(g=!0)};return{send:f}}e.createQueuedSender=m;var E;(function(I){async function w(g,f,C){if(v.isAbsolute(g))return g;if(f===void 0&&(f=k.cwd()),v.dirname(g)!=="."||(C===void 0&&M.isString(k.env.PATH)&&(C=k.env.PATH.split(v.delimiter)),C===void 0||C.length===0))return v.join(f,g);async function p(y){if(await S.Promises.exists(y)){let d;try{d=await S.Promises.stat(y)}catch(h){h.message.startsWith("EACCES")&&(d=await S.Promises.lstat(y))}return d?!d.isDirectory():!1}return!1}for(const y of C){let d;if(v.isAbsolute(y)?d=v.join(y,g):d=v.join(f,y,g),await p(d))return d;let h=d+".com";if(await p(h)||(h=d+".exe",await p(h)))return h}return v.join(f,g)}I.findExecutable=w})(E=e.win32||(e.win32={}))}),define(J[143],Z([0,1,50,13]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(M){return new Promise((S,l)=>{let m;const E=new Map;function I(g,f,C,b,p){const y=E.get(f);if(g===M||y){const d={name:w(C),cmd:C,pid:g,ppid:f,load:b,mem:p};E.set(g,d),g===M&&(m=d),y&&(y.children||(y.children=[]),y.children.push(d),y.children.length>1&&(y.children=y.children.sort((h,a)=>h.pid-a.pid)))}}function w(g){const f=/--vscode-window-kind=shared-process/,C=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,y=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,h=/\\pipe\\winpty-control/,a=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(d.exec(g))return"electron-crash-reporter";if(h.exec(g))return"winpty-process";if(a.exec(g))return"console-window-host (Windows internal process)";let o=i.exec(g);if(o&&o.length===2){if(o[1]==="renderer")return f.exec(g)?"shared-process":C.exec(g)?"issue-reporter":b.exec(g)?"process-explorer":"window";if(o[1]==="utility"){if(p.exec(g))return"utility-network-service";if(y.exec(g))return"extension-host"}return o[1]}const r=/[a-zA-Z-]+\.js/g;let n="";do o=r.exec(g),o&&(n+=o+" ");while(o);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${n}`:g}if(process.platform==="win32"){const g=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,C)=>{q(["windows-process-tree"],f,C)}).then(f=>{f.getProcessList(M,C=>{if(!C){l(new Error(`Root process ${M} not found`));return}f.getProcessCpuUsage(C,b=>{const p=new Map;b.forEach(y=>{const d=g(y.commandLine||"");p.set(y.pid,{name:w(d),cmd:d,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),m=p.get(M),m?(p.forEach(y=>{const d=p.get(y.ppid);d&&(d.children||(d.children=[]),d.children.push(y))}),p.forEach(y=>{y.children&&(y.children=y.children.sort((d,h)=>d.pid-h.pid))}),S(m)):l(new Error(`Root process ${M} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let g=function(){let f=[m];const C=[];for(;f.length;){const p=f.shift();p&&(C.push(p.pid),p.children&&(f=f.concat(p.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);b+=" "+C.join(" "),(0,v.exec)(b,{},(p,y,d)=>{if(p||d)l(p||new Error(d.toString()));else{const h=y.toString().split(`
`);for(let a=0;a<C.length;a++){const i=E.get(C[a]);i.load=parseFloat(h[a])}if(!m){l(new Error(`Root process ${M} not found`));return}S(m)}})};(0,v.exec)("which ps",{},(f,C,b)=>{if(f||b)if(process.platform!=="linux")l(f||new Error(b.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,v.exec)(p,{},(y,d,h)=>{y||h?l(y||new Error(h.toString())):(R(d,I),g())})}else{const p=C.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,h,a)=>{d||a&&!a.includes("screen size is bogus")?l(d||new Error(a.toString())):(R(h,I),process.platform==="linux"?g():m?S(m):l(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=k;function R(M,S){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=M.toString().split(`
`);for(const E of m){const I=l.exec(E.trim());I&&I.length===6&&S(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[144],Z([0,1,30,5,142,79]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(g,f){return g===1?t.isWindows?I():R.getWindowsShell(f):m(g,f)}e.getSystemShell=M;function S(g,f){return g===1?t.isWindows?w(f):R.getWindowsShell(f):m(g,f)}e.getSystemShellSync=S;let l=null;function m(g,f){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!l){let C;if(t.isWindows)C="/bin/bash";else{if(C=f.SHELL,!C)try{C=(0,v.userInfo)().shell}catch{}C||(C="sh"),C==="/bin/false"&&(C="/bin/bash")}l=C}return l}let E=null;async function I(){return E||(E=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),E}function w(g){if(E)return E;const f=t.isWindows&&parseFloat((0,v.release)())>=10,C=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${g.windir}\\${C?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?b:R.getWindowsShell(g)}});var ve=this&&this.__decorate||function(q,e,v,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,v,t);else for(var S=q.length-1;S>=0;S--)(M=q[S])&&(R=(k<3?M(R):k>3?M(e,v,R):M(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R};define(J[51],Z([0,1,23,8,17,22,52,18,3,2,67,24,12]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function f(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function b(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(p||(p={}));class y{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function a(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function i(F){return F.read(4).readUInt32BE(0)}function o(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const r={Undefined:o(h.Undefined),String:o(h.String),Buffer:o(h.Buffer),VSBuffer:o(h.VSBuffer),Array:o(h.Array),Object:o(h.Object)},n=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(r.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);F.write(r.String),F.write(a(W.byteLength)),F.write(W)}else if(n&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);F.write(r.Buffer),F.write(a(W.byteLength)),F.write(W)}else if(A instanceof k.VSBuffer)F.write(r.VSBuffer),F.write(a(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(r.Array),F.write(a(A.length));for(const W of A)s(F,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));F.write(r.Object),F.write(a(W.byteLength)),F.write(W)}}function c(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(i(F)).toString();case h.Buffer:return F.read(i(F)).buffer;case h.VSBuffer:return F.read(i(F));case h.Array:{const W=i(F),z=[];for(let ee=0;ee<W;ee++)z.push(c(F));return z}case h.Object:return JSON.parse(F.read(i(F)).toString())}}class u{constructor(A,W,z=null,ee=1e3){this.protocol=A,this.ctx=W,this.logger=z,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,b(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,b(A.type),A.data);return}}}send(A,W=void 0){const z=new d;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new y(A),z=c(W),ee=c(W),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${f(B)}: ${z[2]}.${z[3]}`,ee),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${f(B)}: ${z[2]}.${z[3]}`,ee),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let ee;try{ee=W.call(this.ctx,A.name,A.arg,z.token)}catch(L){ee=Promise.reject(L)}const B=A.id;ee.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const H=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,H)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=A.id,B=W.listen(this.ctx,A.name,A.arg)(H=>this.sendResponse({id:z,data:H,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var P;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(A){const W=this;return{call(z,ee,B){return W.isDisposed?Promise.reject(new S.CancellationError):W.requestPromise(A,z,ee,B)},listen(z,ee){return W.isDisposed?l.Event.None:W.requestEvent(A,z,ee)}}}requestPromise(A,W,z,ee=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:z};if(ee.isCancellationRequested)return Promise.reject(new S.CancellationError);let O;return new Promise((V,x)=>{if(ee.isCancellationRequested)return x(new S.CancellationError);const ne=()=>{const ae=de=>{switch(de.type){case 201:this.handlers.delete(B),V(de.data);break;case 202:{this.handlers.delete(B);const ge=new Error(de.data.message);ge.stack=de.data.stack,ge.name=de.data.name,x(ge);break}case 203:this.handlers.delete(B),x(de.data);break}};this.handlers.set(B,ae),this.sendRequest(L)};let j=null;this.state===p.Idle?ne():(j=(0,t.createCancelablePromise)(ae=>this.whenInitialized()),j.then(()=>{j=null,ne()}));const te=()=>{j?(j.cancel(),j=null):this.sendRequest({id:B,type:101}),x(new S.CancellationError)},ie=ee.onCancellationRequested(te);O=(0,m.combinedDisposable)((0,m.toDisposable)(te),ie),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,z){const ee=this.lastRequestId++,H={id:ee,type:102,channelName:A,name:W,arg:z};let L=null;const O=new l.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(H)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:ee,type:103}))}}),N=V=>O.fire(V.data);return this.handlers.set(ee,N),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${f(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,f(A.type));return}}}send(A,W=void 0){const z=new d;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new y(A),z=c(W),ee=c(W),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,b(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,b(B),ee),this.onResponse({type:z[0],id:z[1],data:ee})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([M.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:z})=>{l.Event.once(W.onMessage)(B=>{const H=new y(B),L=c(H),O=new u(W,L),N=new D(W);this.channels.forEach((x,ne)=>O.registerChannel(ne,x));const V={channelServer:O,channelClient:N,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),N.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const z=this;return{call(ee,B,H){let L;if((0,w.isFunction)(W)){const N=(0,v.getRandomElement)(z.connections.filter(W));L=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,W))}else L=W.routeCall(z,ee,B);const O=L.then(N=>N.channelClient.getChannel(A));return U(O).call(ee,B,H)},listen(ee,B){if((0,w.isFunction)(W))return z.getMulticastEvent(A,W,ee,B);const H=W.routeEvent(z,ee,B).then(L=>L.channelClient.getChannel(A));return U(H).listen(ee,B)}}}getMulticastEvent(A,W,z,ee){const B=this;let H=new m.DisposableStore;const L=new l.Emitter({onFirstListenerAdd:()=>{H=new m.DisposableStore;const O=new l.EventMultiplexer,N=new Map,V=ne=>{const te=ne.channelClient.getChannel(A).listen(z,ee),ie=O.add(te);N.set(ne,ie)},x=ne=>{const j=N.get(ne);!j||(j.dispose(),N.delete(ne))};B.connections.filter(W).forEach(V),l.Event.filter(B.onDidAddConnection,W)(V,void 0,H),B.onDidRemoveConnection(x,void 0,H),O.event(L.fire,L,H),H.add(O)},onLastListenerRemove:()=>{H.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(z=>{z.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class _{constructor(A,W,z=null){const ee=new d;s(ee,W),A.send(ee.buffer),this.channelClient=new D(A,z),this.channelServer=new u(A,W,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function U(F){return{call(A,W,z){return F.then(ee=>ee.call(A,W,z))},listen(A,W){const z=new l.Relay;return F.then(ee=>z.input=ee.listen(A,W)),z.event}}}e.getDelayedChannel=U;function Q(F){let A=!1;return{call(W,z,ee){return A?F.call(W,z,ee):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(W,z,ee))},listen(W,z){if(A)return F.listen(W,z);const ee=new l.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>ee.input=F.listen(W,z)),ee.event}}}e.getNextTickChannel=Q;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=re;var le;(function(F){function A(B,H){const L=B,O=H&&H.disableMarshalling,N=new Map;for(const V in L)z(V)&&N.set(V,l.Event.buffer(L[V],!0));return new class{listen(V,x,ne){const j=N.get(x);if(j)return j;if(ee(x)){const te=L[x];if(typeof te=="function")return te.call(L,ne)}throw new Error(`Event not found: ${x}`)}call(V,x,ne){const j=L[x];if(typeof j=="function"){if(!O&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,E.revive)(ne[te]);return j.apply(L,ne)}throw new Error(`Method not found: ${x}`)}}}F.fromService=A;function W(B,H){const L=H&&H.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return H?.properties?.has(N)?H.properties.get(N):ee(N)?function(V){return B.listen(N,V)}:z(N)?B.listen(N):async function(...V){let x;H&&!(0,w.isUndefinedOrNull)(H.context)?x=[H.context,...V]:x=V;const ne=await B.call(N,x);return L?ne:(0,E.revive)(ne)};throw new Error(`Property not found: ${String(N)}`)}})}F.toService=W;function z(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function ee(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function fe(F){return Array.isArray(F)?F.map(se):se(F)}function K(F,A,W,z,ee,B,H){H=fe(H);const L=ue[ee],O=L[z%L.length];let N=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(N=N.concat(H),N.push(")")):N.push(H),console.log.apply(console,N)}e.logWithColors=K;class ${constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,z,ee,B){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,W,z,ee,B)}logIncoming(A,W,z,ee,B){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,W,z,ee,B)}}e.IPCLogger=$}),define(J[145],Z([0,1,17,3,51]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(l){this.port=l,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),l.start()}send(l){this.port.postMessage(l.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends k.IPCClient{constructor(l,m){const E=new R(l);super(E,m),this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=M}),define(J[96],Z([0,1,17,3,2,51]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let c=0;function u(D,T){if(!s.has(D)){const _=String(++c);s.set(D,_)}return s.get(D)}function P(D,T,_,U){if(!n.enableDiagnostics)return;const Q=u(D,T);if(U instanceof v.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=v.VSBuffer.alloc(U.byteLength);re.set(U),n.records.push({timestamp:Date.now(),id:Q,label:T,type:_,buff:re})}else n.records.push({timestamp:Date.now(),id:Q,label:T,type:_,data:U})}n.traceSocketEvent=P})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var l;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function E(){return m||(m=v.VSBuffer.alloc(0)),m}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return E();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const u=v.VSBuffer.alloc(s);let P=0,D=0;for(;s>0;){const T=this._chunks[D];if(T.byteLength>s){const _=T.slice(0,s);u.set(_,P),P+=s,c&&(this._chunks[D]=T.slice(s),this._totalLength-=s),s-=s}else u.set(T,P),P+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):D++,s-=T.byteLength}return u}}e.ChunkStream=I;var w;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(w||(w={}));function g(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class C{constructor(s,c,u,P){this.type=s,this.id=c,this.ack=u,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,P=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new C(u,P,D,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=v.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const u=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,u}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class y extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new C(1,0,0,s))}}e.Protocol=y;class d extends R.IPCClient{constructor(s,c,u=null){super(s,c,u),this.protocol=s}static fromSocket(s,c){return new d(new y(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=d;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class a{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,u=this._first;for(;u;)s[c++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new a(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let P=0;P<o._HISTORY_LENGTH;P++)s-this.lastRuns[P]<=c&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class r{constructor(s,c=null,u=o.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new C(5,0,0,E());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new C(7,0,0,E());this._socketWriter.write(s)}sendResume(){const s=new C(8,0,0,E());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new C(3,0,this._incomingAckId,E());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let u=0,P=c.length;u<P;u++)this._socketWriter.write(c[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new C(6,0,0,E())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let u=0,P=c.length;u<P;u++)this._socketWriter.write(c[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new C(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const c=new C(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&u>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:u});return}const D=Math.max(2e4-c,2e4-u,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},D)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new C(3,0,this._incomingAckId,E());this._socketWriter.write(s)}_sendKeepAlive(){const s=new C(9,0,0,E());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(J[146],Z([0,1,40,17,3,2,51,130]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function l(E,I){const w=k.Event.fromNodeEventEmitter(v.validatedIpcMain,I,(f,C)=>({event:f,message:C})),g=k.Event.filter(w,({event:f})=>f.sender.id===E);return k.Event.map(g,({message:f})=>f&&t.VSBuffer.wrap(f))}class m extends M.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const I=k.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:w})=>w);return k.Event.map(I,w=>{const g=w.id;m.Clients.get(g)?.dispose();const C=new k.Emitter;m.Clients.set(g,(0,R.toDisposable)(()=>C.fire()));const b=l(g,"vscode:message"),p=k.Event.any(k.Event.signal(l(g,"vscode:disconnect")),C.event);return{protocol:new S.Protocol(w,b),onDidClientDisconnect:p}})}}e.Server=m,m.Clients=new Map}),define(J[97],Z([0,1,40,3,28,145]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(m,E){super({addEventListener:(I,w)=>m.addListener(I,w),removeEventListener:(I,w)=>m.removeListener(I,w),postMessage:I=>m.postMessage(I),start:()=>m.start(),close:()=>m.close()},E)}}e.Client=M;async function S(l){if(l.isDestroyed()||l.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();l.webContents.send("vscode:createMessageChannel",m);const E=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(w,g)=>({nonce:g,port:w.ports[0]})),{port:I}=await t.Event.toPromise(t.Event.once(t.Event.filter(E,w=>w.nonce===m)));return I}e.connect=S}),define(J[147],Z([0,1,50,8,17,22,139,18,3,2,49,79,76,51]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends g.ChannelServer{constructor(p){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",y=>k.VSBuffer.wrap(Buffer.from(y,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=f;class C{constructor(p,y){this.modulePath=p,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new t.Delayer(d),this.child=null,this._client=null}getChannel(p){const y=this;return{call(d,h,a){return y.requestPromise(p,d,h,a)},listen(d,h){return y.requestEvent(p,d,h)}}}requestPromise(p,y,d,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(p),i=(0,t.createCancelablePromise)(n=>a.call(y,d,n)),o=h.onCancellationRequested(()=>i.cancel()),r=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{o.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,y,d){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let h;const a=new l.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(p).listen(y,d)(a.fire,a),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,w.removeDangerousEnvVariables)(y.env),this.child=(0,v.fork)(this.modulePath,p,y);const d=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,M.isRemoteConsoleLog)(s)){(0,M.log)(s,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const a=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&a.send(s.buffer.toString("base64")),o=d.event,r={send:i,onMessage:o};this._client=new g.ChannelClient(r);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(u=>(0,m.dispose)(u)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(p){let y=this.channels.get(p);return y||(y=this.client.getChannel(p),this.channels.set(p,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(J[80],Z([0,1,17,18,3,2,9,5,28,51,96]),function(q,e,v,t,k,R,M,S,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class w{constructor(u,P=""){this.debugLabel=P,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,P){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const P=D=>{this.traceSocketEvent("read",D),u(v.VSBuffer.wrap(D))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(u){const P=D=>{this.traceSocketEvent("close",{hadError:D}),u({type:0,hadError:D,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(u){const P=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=w;var g;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var f;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(f||(f={}));class C extends R.Disposable{constructor(u,P,D,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new b(this,P,D,T,this._onData,(_,U)=>this._write(_,U))),this._register(this._flowManager.onError(_=>{console.error(_),(0,t.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,P){this.socket.traceSocketEvent(u,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let D=2;u.byteLength<126?D+=0:u.byteLength<2**16?D+=2:D+=8;const T=v.VSBuffer.alloc(D);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(u.byteLength>>>8&255,++_),T.writeUInt8(u.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(u.byteLength>>>24&255,++_),T.writeUInt8(u.byteLength>>>16&255,++_),T.writeUInt8(u.byteLength>>>8&255,++_),T.writeUInt8(u.byteLength>>>0&255,++_)}this.socket.write(v.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),D=P.readUInt8(0),T=(D&128)>>>7,_=(D&64)>>>6,U=P.readUInt8(1),Q=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),D=P.readUInt8(1),T=(D&128)>>>7;let _=D&127,U=1;_===126?_=P.readUInt8(++U)*2**8+P.readUInt8(++U):_===127&&(_=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let Q=0;T&&(Q=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=_,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),d(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class b extends R.Disposable{constructor(u,P,D,T,_,U){super(),this._tracer=u,this._onData=_,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new p(this._tracer,T,D,{windowBits:15})),this._zlibDeflateStream=this._register(new y(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(P,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,P){return new Promise((D,T)=>{u.write(P),u.flush(_=>D(_))})}acceptFrame(u,P,D){this._readQueue.push({data:u,isCompressed:P,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,P,D){return new Promise((T,_)=>{u.write(P),D&&u.write(v.VSBuffer.fromByteArray([0,0,255,255])),u.flush(U=>T(U))})}}class p extends R.Disposable{constructor(u,P,D,T){super(),this._tracer=u,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(T),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(v.VSBuffer.wrap(_))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(P)})}}class y extends R.Disposable{constructor(u,P){super(),this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(v.VSBuffer.wrap(D))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),u(P)})}}function d(c,u){if(u===0)return;const P=c.byteLength>>>2;for(let re=0;re<P;re++){const le=c.readUInt32BE(re*4);c.writeUInt32BE(le^u,re*4)}const D=P*4,T=c.byteLength-D,_=u>>>24&255,U=u>>>16&255,Q=u>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(D)^_,D),T>=2&&c.writeUInt8(c.readUInt8(D+1)^U,D+1),T>=3&&c.writeUInt8(c.readUInt8(D+2)^Q,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function a(){const c=(0,l.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,M.join)(I().os.tmpdir(),`vscode-ipc-${c}.sock`),o(u),u}e.createRandomIPCHandle=a;function i(c,u,P){const D=I().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${P}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${P}-${u}.sock`):T=(0,M.join)(c,`${P}-${u}.sock`),o(T),T}e.createStaticIPCHandle=i;function o(c){const u=h[S.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends m.IPCServer{constructor(u){super(r.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const P=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(P,D=>({protocol:new E.Protocol(new w(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(c){return new Promise((u,P)=>{const D=I().net.createServer();D.on("error",P),D.listen(c,()=>{D.removeListener("error",P),u(new r(D))})})}e.serve=n;function s(c,u){return new Promise((P,D)=>{const T=I().net.createConnection(c,()=>{T.removeListener("error",D),P(E.Client.fromSocket(new w(T,`ipc-client${u}`),u))});T.once("error",D)})}e.connect=s}),define(J[98],Z([0,1,8,3,2,12]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function S(I){const w=I;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var l;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(l=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(w,g=Object.create(null)){super(),this.database=w,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((g,f)=>this.accept(f,g)),w.deleted?.forEach(g=>this.accept(g,void 0))}accept(w,g){if(this.state===l.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(g)?f=this.cache.delete(w):this.cache.get(w)!==g&&(this.cache.set(w,g),f=!0),f&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,g){const f=this.cache.get(w);return(0,R.isUndefinedOrNull)(f)?g:f}getBoolean(w,g){const f=this.get(w);return(0,R.isUndefinedOrNull)(f)?g:f==="true"}getNumber(w,g){const f=this.get(w);return(0,R.isUndefinedOrNull)(f)?g:parseInt(f,10)}async set(w,g){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(w);const f=String(g);if(this.cache.get(w)!==f)return this.cache.set(w,f),this.pendingInserts.set(w,f),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async delete(w){if(!(this.state===l.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(!!this.hasPending)return this.doFlush(w)}async doFlush(w){return this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert?.forEach((g,f)=>this.items.set(f,g)),w.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=E}),define(J[148],Z([0,1,8,3,32,9,25]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(E,I=Object.create(null)){this.path=E,this.options=I,this.name=(0,R.basename)(this.path),this.logger=new l(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const E=await this.whenConnected,I=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(g=>I.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(E){const I=await this.whenConnected;return this.doUpdateItems(I,E)}doUpdateItems(E,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,k.mapToString)(I.insert):"0"}), delete(${I.delete?(0,k.setToString)(I.delete):"0"})`),this.transaction(E,()=>{const w=I.insert,g=I.delete;if(w&&w.size>0){const f=[];f.push([]);let C=0;w.forEach((b,p)=>{let y=f[C];y.length>S.MAX_HOST_PARAMETERS&&(C++,y=[],f.push(y)),y.push(p,b)}),f.forEach(b=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let y=0;return w.forEach((d,h)=>{p.push(h),y+=d.length}),`Keys: ${p.join(", ")} Length: ${y}`})})}if(g&&g.size){const f=[];f.push([]);let C=0;g.forEach(b=>{let p=f[C];p.length>S.MAX_HOST_PARAMETERS&&(C++,p=[],f.push(p)),p.push(b)}),f.forEach(b=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return g.forEach(y=>{p.push(y)}),`Keys: ${p.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,E)}doClose(E,I){return new Promise((w,g)=>{E.db.close(f=>(f&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${f}`),this.path===S.IN_MEMORY_PATH?w():!E.isErroneous&&!E.isInMemory?this.backup().then(w,C=>(this.logger.error(`[storage ${this.name}] backup(): ${C}`),w())):typeof I=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(C=>{const b=()=>this.doClose(C,void 0);return this.doUpdateItems(C,{insert:I()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(w,g):g(f||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return M.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const I=await this.whenConnected,w=await this.get(I,E?"PRAGMA integrity_check":"PRAGMA quick_check"),g=E?w.integrity_check:w.quick_check;return I.isErroneous?`${g} (last error: ${I.lastError})`:I.isInMemory?`${g} (in-memory!)`:g}async connect(E,I=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${I})`);try{return await this.doConnect(E)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&I)return await(0,v.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await M.Promises.unlink(E);try{await M.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(E,I){E.isErroneous=!0,E.lastError=I,this.logger.error(I)}doConnect(E){return new Promise((I,w)=>{new Promise((g,f)=>{q(["@vscode/sqlite3"],g,f)}).then(g=>{const f={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(E,C=>C?f.db&&C.code!=="SQLITE_CANTOPEN"?f.db.close(()=>w(C)):w(C):this.exec(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(f),b=>f.db.close(()=>w(b)))),isInMemory:E===S.IN_MEMORY_PATH};f.db.on("error",C=>this.handleSQLiteError(f,`[storage ${this.name}] Error (event): ${C}`)),this.logger.isTracing&&f.db.on("trace",C=>this.logger.trace(`[storage ${this.name}] Trace (event): ${C}`))},w)})}exec(E,I){return new Promise((w,g)=>{E.db.exec(I,f=>f?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${f}`),g(f)):w())})}get(E,I){return new Promise((w,g)=>{E.db.get(I,(f,C)=>f?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${f}`),g(f)):w(C))})}all(E,I){return new Promise((w,g)=>{E.db.all(I,(f,C)=>f?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${f}`),g(f)):w(C))})}transaction(E,I){return new Promise((w,g)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),I(),E.db.run("END TRANSACTION",f=>f?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${f}`),g(f)):w())})})}prepare(E,I,w,g){const f=E.db.prepare(I),C=b=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${b} (${I}). Details: ${g()}`)};f.on("error",C),w(f),f.finalize(b=>{b&&C(b),f.removeListener("error",C)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class l{constructor(E){E&&typeof E.logTrace=="function"&&process.env[l.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace?.(E)}error(E){this.logError?.(E)}}l.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[149],Z([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[150],Z([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[151],Z([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[152],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[153],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[154],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[155],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(J[156],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(J[157],Z([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[158],Z([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[159],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[160],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[161],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[162],Z([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[163],Z([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[164],Z([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[165],Z([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[166],Z([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[167],Z([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[168],Z([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(J[169],Z([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[170],Z([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[171],Z([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(J[172],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(J[173],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[174],Z([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(J[175],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[176],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[177],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(J[178],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(J[179],Z([0,1,3,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(S,l,m){switch(l){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(S,l,m){switch(l){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(S){super(),this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,l,m){this.channel.call("attach",[S,l,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,l){this.channel.call("terminate",[S,l])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,l){return this.channel.call("openExtensionDevelopmentHostWindow",[S,l])}}e.ExtensionHostDebugChannelClient=R}),define(J[180],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=v}),define(J[181],Z([0,1,133,52,13,9,34,16,7]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(C,b,p){this._args=C,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const C=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",C)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const C=M.env.VSCODE_PORTABLE;return C?l.URI.file((0,R.join)(C,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const C=this.args["builtin-extensions-dir"];return C?(0,R.resolve)(C):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const C=this.args["extensions-download-dir"];return C?(0,R.resolve)(C):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const C=this.args["extensions-dir"];if(C)return(0,R.resolve)(C);const b=M.env.VSCODE_EXTENSIONS;if(b)return b;const p=M.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const C=this.args.extensionDevelopmentPath;if(Array.isArray(C))return C.map(b=>/^[^:/?#]+?:\/\//.test(b)?l.URI.parse(b):l.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const C=this.args.extensionTestsPath;if(C)return/^[^:/?#]+?:\/\//.test(C)?l.URI.parse(C):l.URI.file((0,R.normalize)(C))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const C=this.args["disable-extension"];if(C){if(typeof C=="string")return[C];if(Array.isArray(C)&&C.length>0)return C}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const C=M.env.VSCODE_PORTABLE;return C?l.URI.file((0,R.join)(C,"policy.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function E(f,C){return g(f["inspect-extensions"],f["inspect-brk-extensions"],5870,C,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=E;function I(f,C){return g(f["inspect-search"],f["inspect-brk-search"],5876,C,f.extensionEnvironment)}e.parseSearchPort=I;function w(f,C){return g(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,C,f.extensionEnvironment)}e.parsePtyHostPort=w;function g(f,C,b,p,y,d){const a=Number(C||f)||(p?null:b),i=a?Boolean(!!C):!1;let o;if(d)try{o=JSON.parse(d)}catch{}return{port:a,break:i,debugId:y,env:o}}}),define(J[99],Z([0,1,271,5,152]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(f,C,b=M){const p={},y=["_"],d=[];for(const o in C){const r=C[o];r.alias&&(p[o]=r.alias),r.type==="string"||r.type==="string[]"?(y.push(o),r.deprecates&&y.push(...r.deprecates)):r.type==="boolean"&&(d.push(o),r.deprecates&&d.push(...r.deprecates))}const h=v(f,{string:y,boolean:d,alias:p}),a={},i=h;a._=h._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in C){const r=C[o];r.alias&&delete i[r.alias];let n=i[o];if(r.deprecates)for(const s of r.deprecates)i.hasOwnProperty(s)&&(n||(n=i[s],n&&b.onDeprecatedOption(s,r.deprecationMessage||(0,k.localize)(35,null,o))),delete i[s]);if(typeof n<"u"){if(r.type==="string[]"){if(Array.isArray(n)||(n=[n]),!r.allowEmptyValue){const s=n.filter(c=>c.length>0);s.length!==n.length&&(b.onEmptyValue(o),n=s.length>0?s:void 0)}}else r.type==="string"&&(Array.isArray(n)?(n=n.pop(),b.onMultipleValues(o,n)):!n&&!r.allowEmptyValue&&(b.onEmptyValue(o),n=void 0));a[o]=n,r.deprecationMessage&&b.onDeprecatedOption(o,r.deprecationMessage)}delete i[o]}for(const o in i)b.onUnknownOption(o);return a}e.parseArgs=S;function l(f,C){let b="";return C.args&&(Array.isArray(C.args)?b=` <${C.args.join("> <")}>`:b=` <${C.args}>`),C.alias?`-${C.alias} --${f}${b}`:`--${f}${b}`}function m(f,C){let b=0;const p=[];for(const a in f){const i=f[a],o=l(a,i);b=Math.max(b,o.length),p.push([o,i.description])}const y=b+2+1;if(C-y<25)return p.reduce((a,i)=>a.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const d=C-y-1,h=[];for(const a of p){const i=a[0],o=I(a[1],d),r=E(y-i.length-2);h.push("  "+i+r+o[0]);for(let n=1;n<o.length;n++)h.push(E(y)+o[n])}return h}e.formatOptions=m;function E(f){return" ".repeat(f)}function I(f,C){const b=[];for(;f.length;){const p=f.length<C?f.length:f.lastIndexOf(" ",C),y=f.slice(0,p).trim();f=f.slice(p),b.push(y)}return b}function w(f,C,b,p,y){const d=process.stdout.isTTY&&process.stdout.columns||80,h=y?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",a=[`${f} ${b}`];a.push(""),a.push(`${(0,k.localize)(37,null)}: ${C} [${(0,k.localize)(38,null)}]${h}`),a.push(""),y?.noPipe!==!0&&(t.isWindows?a.push((0,k.localize)(39,null,C)):a.push((0,k.localize)(40,null,C)),a.push(""));const i={};for(const o in p){const r=p[o];if(r.description&&r.cat){let n=i[r.cat];n||(i[r.cat]=n={}),n[o]=r}}for(const o in i){const r=o,n=i[r];n&&(a.push(R[r]),a.push(...m(n,d)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=w;function g(f,C){return`${f||(0,k.localize)(41,null)}
${C||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=g}),define(J[182],Z([0,1,75,179,99]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(S,l){super(),this.windowsMainService=S,this.userDataProfilesMainService=l}call(S,l,m){return l==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(S,l,m)}async openExtensionDevelopmentHostWindow(S,l){const m=(0,k.parseArgs)(S,k.OPTIONS);m.debugRenderer=l;const E=m.extensionDevelopmentPath;if(!E)return{success:!1};const I=this.userDataProfilesMainService.checkAndCreateProfileFromCli(m);I&&await I;const[w]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:m});if(!l)return{success:!0};const g=w.win;if(!g)return{success:!0};const f=g.webContents.debugger;let C=f.isAttached()?1/0:0;const b=(0,v.createServer)(p=>{C++===0&&f.attach();let y=!1;const d=i=>{y||p.write(JSON.stringify(i)+"\0")},h=(i,o,r,n)=>d({method:o,params:r,sessionId:n});g.on("close",()=>{f.removeListener("message",h),p.end(),y=!0}),f.addListener("message",h);let a=Buffer.alloc(0);p.on("data",i=>{a=Buffer.concat([a,i]);for(let o=a.indexOf(0);o!==-1;o=a.indexOf(0)){let r;try{const n=a.slice(0,o).toString("utf8");a=a.slice(o+1),r=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(r.method,r.params,r.sessionId).then(n=>d({id:r.id,sessionId:r.sessionId,result:n})).catch(n=>d({id:r.id,sessionId:r.sessionId,error:{code:0,message:n.message}}))}}),p.on("error",i=>{console.error("error on cdp pipe:",i)}),p.on("close",()=>{y=!0,--C===0&&f.detach()})});return await new Promise(p=>b.listen(0,p)),g.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(J[58],Z([0,1,272,153,99]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(w,g){const f={onUnknownOption:b=>{console.warn((0,t.localize)(0,null,b))},onMultipleValues:(b,p)=>{console.warn((0,t.localize)(1,null,b,p))},onEmptyValue:b=>{console.warn((0,t.localize)(2,null,b))},onDeprecatedOption:(b,p)=>{console.warn((0,t.localize)(3,null,b,p))}},C=(0,k.parseArgs)(w,k.OPTIONS,g?f:void 0);return C.goto&&C._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,t.localize)(4,null))),C["max-memory"]&&v(parseInt(C["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),C}function S(w){const g=w.findIndex(f=>!/^-/.test(f));if(g>-1)return[...w.slice(0,g),...w.slice(g+1)]}function l(w){let[,...g]=w;process.env.VSCODE_DEV&&(g=S(g)||[]);const f=!I(process.env);return M(g,f)}e.parseMainProcessArgv=l;function m(w){const[,,...g]=w;return M(g,!0)}e.parseCLIProcessArgv=m;function E(w,...g){const f=w.indexOf("--");return f===-1?w.push(...g):w.splice(f,0,...g),w}e.addArg=E;function I(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function q(e,v,t,k){function R(S){const l=M(S),m=[l];return e.isAbsolute(l)||m.unshift(k),e.resolve(...m)}function M(S){const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const E=S["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(I,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(J[183],Z([0,273,30,13,16,34]),function(e,v,t,k,R,M){const S=R.dirname(k.FileAccess.asFileUri("",e)),l=e.__$__nodeRequire(R.joinPath(S,"package.json").fsPath);return q(v,t,l.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=q(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[184],Z([0,1,30,181,183]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(S,l){super(S,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(S)},l)}}e.NativeEnvironmentService=R}),define(J[185],Z([0,1,29,30,31]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(M){const S=(0,k.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(S,""),M&&console.log(`Marker file for --wait created: ${S}`),S}catch(l){M&&console.error(`Failed to create marker file for --wait: ${l}`);return}}e.createWaitMarkerFile=R}),define(J[186],Z([0,1,12,155]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(M,S,l){try{R(M,S,l)}catch{}return M}e.localizeManifest=k;function R(M,S,l){const m=(E,I,w)=>{const g=E[I];if((0,v.isString)(g)){const f=g,C=f.length;if(C>1&&f[0]==="%"&&f[C-1]==="%"){const b=f.substr(1,C-2);let p=S[b];p===void 0&&l&&(p=l[b]);const y=typeof p=="string"?p:p.message;if(y!==void 0){const d=l?.[b],h=typeof d=="string"?d:d?.message;if(w&&(I==="title"||I==="category")&&h&&h!==y){const a={value:y,original:h};E[I]=a}else E[I]=y}else console.warn(`[${M.name}]: ${(0,t.localize)(0,null,b)}`)}}else if((0,v.isObject)(g))for(const f in g)g.hasOwnProperty(f)&&(f==="commands"?m(g,f,!0):m(g,f,w));else if(Array.isArray(g))for(let f=0;f<g.length;f++)m(g,f,w)};for(const E in M)M.hasOwnProperty(E)&&m(M,E)}}),define(J[187],Z([0,1,16,92,157,188]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function l(p){return p=p.trim(),p==="*"||M.test(p)}e.isValidVersionStr=l;function m(p){if(!l(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=p.match(M);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=m;function E(p){if(!p)return null;const y=p.majorBase,d=p.majorMustEqual,h=p.minorBase;let a=p.minorMustEqual;const i=p.patchBase;let o=p.patchMustEqual;p.hasCaret&&(y===0||(a=!1),o=!1);let r=0;if(p.preRelease){const n=S.exec(p.preRelease);if(n){const[,s,c,u]=n;r=Date.UTC(Number(s),Number(c)-1,Number(u))}}return{majorBase:y,majorMustEqual:d,minorBase:h,minorMustEqual:a,patchBase:i,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:r}}e.normalizeVersion=E;function I(p,y,d){let h;typeof p=="string"?h=E(m(p)):h=p;let a;y instanceof Date?a=y.getTime():typeof y=="string"&&(a=new Date(y).getTime());let i;if(typeof d=="string"?i=E(m(d)):i=d,!h||!i)return!1;const o=h.majorBase,r=h.minorBase,n=h.patchBase;let s=i.majorBase,c=i.minorBase,u=i.patchBase;const P=i.notBefore;let D=i.majorMustEqual,T=i.minorMustEqual,_=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:r>c?!0:r<c||a&&a<P?!1:n>=u:(o===1&&s===0&&(!D||!T||!_)&&(s=1,c=0,u=0,D=!0,T=!1,_=!1),o<s?!1:o>s?!D:r<c?!1:r>c?!T:n<u?!1:n>u?!_:!(a&&a<P))}e.isValidVersion=I;function w(p,y,d,h,a){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!b(h.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!b(h.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const n=(0,v.joinPath)(d,h.main);(0,v.isEqualOrParent)(n,d)||i.push([t.default.Warning,k.localize(10,null,n.path,d.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const n=(0,v.joinPath)(d,h.browser);(0,v.isEqualOrParent)(n,d)||i.push([t.default.Warning,k.localize(13,null,n.path,d.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(h.version))return i.push([t.default.Error,k.localize(15,null)]),i;const o=[];if(!g(p,y,h,a,o))for(const n of o)i.push([t.default.Error,n]);return i}e.validateExtensionManifest=w;function g(p,y,d,h,a){return h||typeof d.main>"u"&&typeof d.browser>"u"?!0:C(p,y,d.engines.vscode,a)}e.isValidExtensionVersion=g;function f(p,y,d){return p==="*"||C(y,d,p)}e.isEngineValid=f;function C(p,y,d,h=[]){const a=E(m(d));if(!a)return h.push(k.localize(16,null,d)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return h.push(k.localize(17,null,d)),!1}else if(!a.majorMustEqual)return h.push(k.localize(18,null,d)),!1;return I(p,y,a)?!0:(h.push(k.localize(19,null,p,d)),!1)}function b(p){if(!Array.isArray(p))return!1;for(let y=0,d=p.length;y<d;y++)if(typeof p[y]!="string")return!1;return!0}}),define(J[189],Z([0,1,17,28]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,M,S){let l=S&&S.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const E=(await M.readFile(R.serviceMachineIdResource)).value.toString();l=(0,t.isUUID)(E)?E:null}catch{l=null}if(!l){l=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(l))}catch{}}return S?.store("storage.serviceMachineId",l,-1,1),l}e.getServiceMachineId=k}),define(J[68],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,R=[],M=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=v}),define(J[190],Z([0,1,68]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(M,S,l){S instanceof v.SyncDescriptor||(S=new v.SyncDescriptor(S,[],l)),t.push([M,S])}e.registerSingleton=k;function R(){return t}e.getSingletonServiceDescriptors=R}),define(J[191],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const S=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(M);S.outgoing.set(this._hashFn(M),l),l.incoming.set(this._hashFn(R),S)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const S of this._nodes.values())S.outgoing.delete(M),S.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let S=this._nodes.get(M);return S||(S=new v(R),this._nodes.set(M,S)),S}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,S]of this._nodes)R.push(`${M}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const S=new Set([R]),l=this._findCycle(M,S);if(l)return l}}_findCycle(R,M){for(const[S,l]of R.outgoing){if(M.has(S))return[...M,S].join(" -> ");M.add(S);const m=this._findCycle(l,M);if(m)return m;M.delete(S)}}}e.Graph=t}),define(J[4],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function S(l){return l[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(M,S,l){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:M,index:l}):(S[v.DI_DEPENDENCIES]=[{id:M,index:l}],S[v.DI_TARGET]=S)}function k(M){if(v.serviceIds.has(M))return v.serviceIds.get(M);const S=function(l,m,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(S,l,E)};return S.toString=()=>M,v.serviceIds.set(M,S),S}e.createDecorator=k;function R(M){return M}e.refineServiceDecorator=R}),define(J[59],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(J[19],Z([0,1,12,7,4]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var S;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function l(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=l;function m(p,y){const d=Object.create(null);for(const h in p)E(d,h,p[h],y);return d}e.toValuesTree=m;function E(p,y,d,h){const a=y.split("."),i=a.pop();let o=p;for(let r=0;r<a.length;r++){const n=a[r];let s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${y} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{h(`Ignoring ${y} as ${a.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${y} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=E;function I(p,y){const d=y.split(".");w(p,d)}e.removeFromValueTree=I;function w(p,y){const d=y.shift();if(y.length===0){delete p[d];return}if(Object.keys(p).indexOf(d)!==-1){const h=p[d];typeof h=="object"&&!Array.isArray(h)&&(w(h,y),Object.keys(h).length===0&&delete p[d])}}function g(p,y,d){function h(o,r){let n=o;for(const s of r){if(typeof n!="object"||n===null)return;n=n[s]}return n}const a=y.split("."),i=h(p,a);return typeof i>"u"?d:i}e.getConfigurationValue=g;function f(p,y,d){Object.keys(y).forEach(h=>{h!=="__proto__"&&(h in p?v.isObject(p[h])&&v.isObject(y[h])?f(p[h],y[h],d):d&&(p[h]=y[h]):p[h]=y[h])})}e.merge=f;function C(p,y,d){const h=p.inspect(y),a=p.inspect(d);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:h.defaultValue}e.getMigratedSettingValue=C;function b(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(J[69],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,S){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=S}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const S of Object.keys(this.secretVault[R]||{}))M.push({account:S,password:this.secretVault[R][S]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(J[100],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(M,S){return{}}async getSystemInfo(M,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,S){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=k}),define(J[101],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(J[36],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(J[26],Z([0,1,52,9,80,36,184,4]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,S.refineServiceDecorator)(R.IEnvironmentService);class l extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([v.memoize],l.prototype,"cachedLanguagesPath",null),ve([v.memoize],l.prototype,"backupHome",null),ve([v.memoize],l.prototype,"backupWorkspacesPath",null),ve([v.memoize],l.prototype,"mainIPCHandle",null),ve([v.memoize],l.prototype,"mainLockfile",null),ve([v.memoize],l.prototype,"disableUpdates",null),ve([v.memoize],l.prototype,"disableKeytar",null),ve([v.memoize],l.prototype,"codeCachePath",null),ve([v.memoize],l.prototype,"useCodeCache",null),e.EnvironmentMainService=l}),define(J[192],Z([0,1,154,4]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(p,y){switch(p){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function S(p,y){return y==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function l(p,y,d){return S(y,d)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===d?!0:m(d).includes(p)}e.isTargetPlatformCompatible=l;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function E(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=E;var I;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var w;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var g;(function(p){p.Install="install",p.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var f;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var C;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(C=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(y,d){super(y),this.code=d,this.name=d}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(J[193],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(J[194],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[102],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(J[195],Z([0,1,50,13,9,5,76,25,79,158,102]),function(q,e,v,t,k,R,M,S,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=m.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await C.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends w{openTerminal(h,a){return this.spawnTerminal(v,h,l.getWindowsShell(),a)}spawnTerminal(h,a,i,o){const r=a.windowsExec||g.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const n=k.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(n==="wt"||n==="wt.exe")&&s.push("-d ."),new Promise((c,u)=>{const P=b(process),D=h.spawn(i,s,{cwd:o,env:P});D.on("error",u),D.on("exit",()=>c())})}runInTerminal(h,a,i,o,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:g.getDefaultTerminalWindows();return new Promise((s,c)=>{const u=`"${a} - ${I}"`,P=`""${i.join('" "')}" & pause"`,D=["/c","start",u,"/wait",n,"/c",P],T=Object.assign({},b(process),o);Object.keys(T).filter(Q=>T[Q]===null).forEach(Q=>delete T[Q]);const _={cwd:a,env:T,windowsVerbatimArguments:!0};v.spawn(g.CMD,D,_).on("error",Q=>{c(p(Q))}),s(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class f extends w{openTerminal(h,a){return this.spawnTerminal(v,h,a)}runInTerminal(h,a,i,o,r){const n=r.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(n===E.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const u=n===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,q).fsPath,"-t",h||I,"-w",a];for(const U of i)D.push("-a"),D.push(U);if(o){const U=Object.assign({},b(process),o);for(const Q in U){const re=U[Q];re===null?(D.push("-u"),D.push(Q)):(D.push("-e"),D.push(`${Q}=${re}`))}}let T="";const _=v.spawn(f.OSASCRIPT,D);_.on("error",U=>{c(p(U))}),_.stderr.on("data",U=>{T+=U.toString()}),_.on("exit",U=>{if(U===0)s(void 0);else if(T){const Q=T.split(`
`,1);c(new Error(Q[0]))}else c(new Error(m.localize(1,null,u,U)))})}else c(new Error(m.localize(2,null,n)))})}spawnTerminal(h,a,i){const o=a.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const s=["-a",o];i&&s.push(i);const c=b(process),u=h.spawn("/usr/bin/open",s,{cwd:i,env:c});u.on("error",n),u.on("exit",()=>r())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class C extends w{openTerminal(h,a){return this.spawnTerminal(v,h,a)}runInTerminal(h,a,i,o,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):C.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const u=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const D=`${y(i)}; echo; read -p "${C.WAIT_MESSAGE}" -n1;`;u.push(`''${D}''`);const T=Object.assign({},b(process),o);Object.keys(T).filter(re=>T[re]===null).forEach(re=>delete T[re]);const _={cwd:a,env:T};let U="";const Q=v.spawn(P,u,_);Q.on("error",re=>{c(p(re))}),Q.stderr.on("data",re=>{U+=re.toString()}),Q.on("exit",re=>{if(re===0)s(void 0);else if(U){const le=U.split(`
`,1);c(new Error(le[0]))}else c(new Error(m.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!C._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)C._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await S.Promises.exists("/etc/debian_version");C._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{h?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return C._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,a,i){const o=a.linuxExec?Promise.resolve(a.linuxExec):C.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{o.then(s=>{const c=b(process),u=h.spawn(s,[],{cwd:i,env:c});u.on("error",n),u.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=C,C.WAIT_MESSAGE=m.localize(3,null);function b(d){const h={...d.env};return(0,M.sanitizeProcessEnvironment)(h),h}function p(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(m.localize(5,null,d.path)):d}function y(d){let h="";for(const a of d)a.indexOf(" ")>=0?h+='"'+a+'"':h+=a,h+=" ";return h}}),define(J[14],Z([0,1,32,9,24,12,7,160,4]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,l.createDecorator)("fileService");function m(K){return K.create===!0}e.isFileOpenForWriteOptions=m;var E;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var I;(function(K){K[K.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var w;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=g;function f(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=f;function C(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=C;function b(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function p(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=p;function y(K){return g(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var d;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor($,F){super($),this.code=F}}e.FileSystemProviderError=h;function a(K,$){const F=new h(K.toString(),$);return o(F,$),F}e.createFileSystemProviderError=a;function i(K){return K||a((0,S.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=i;function o(K,$){return K.name=$?`${$} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=o;function r(K){if(!K)return d.Unknown;if(K instanceof h)return K.code;const $=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!$)return d.Unknown;switch($[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=r;function n(K){if(K instanceof T)return K.fileOperationResult;switch(r(K)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor($,F,A){this.resource=$,this.operation=F,this.target=A}isOperation($){return this.operation===$}}e.FileOperationEvent=c;var u;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class P{constructor($,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const A=new Map;for(const W of $){const z=A.get(W.type);switch(z?z.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,z]of A)switch(W){case 1:this.added=v.TernarySearchTree.forUris(()=>F),this.added.fill(z);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>F),this.updated.fill(z);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>F),this.deleted.fill(z);break}}contains($,...F){return this.doContains($,{includeChildren:!1},...F)}affects($,...F){return this.doContains($,{includeChildren:!0},...F)}doContains($,F,...A){if(!$)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get($)||F.includeChildren&&this.added?.findSuperstr($))||(!W||A.includes(0))&&(this.updated?.get($)||F.includeChildren&&this.updated?.findSuperstr($))||(!W||A.includes(2))&&(this.deleted?.findSubstr($)||F.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function D(K,$,F){return!K||!$||K===$||$.length>K.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),F?(0,k.startsWithIgnoreCase)(K,$):K.indexOf($)===0)}e.isParent=D;class T extends Error{constructor($,F,A){super($),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class _ extends T{constructor($,F,A){super($,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=_;var U;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Q;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=re;async function le(K,$){if(!$.hasProvider(M.URI.from({scheme:K.scheme})))return new Promise(F=>{const A=$.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===K.scheme&&W.added&&(A.dispose(),F())})})}e.whenProviderRegistered=le,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize($){return(0,R.isNumber)($)||($=0),$<ue.KB?(0,S.localize)(1,null,$.toFixed(0)):$<ue.MB?(0,S.localize)(2,null,($/ue.KB).toFixed(2)):$<ue.GB?(0,S.localize)(3,null,($/ue.MB).toFixed(2)):$<ue.TB?(0,S.localize)(4,null,($/ue.GB).toFixed(2)):(0,S.localize)(5,null,($/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function fe(K){return{maxFileSize:K===0?300*ue.MB:16*ue.GB,maxHeapSize:K===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=fe}),define(J[196],Z([0,1,17,43,18,3,2,57,7,28,14]),function(q,e,v,t,k,R,M,S,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends M.Disposable{constructor(g,f){super(),this.channel=g,this.extraCapabilities=f,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,f){const{buffer:C}=await this.channel.call("readFile",[g,f]);return C}readFileStream(g,f,C){const b=(0,S.newWriteableStream)(y=>v.VSBuffer.concat(y.map(d=>v.VSBuffer.wrap(d))).buffer),p=this.channel.listen("readFileStream",[g,f])(y=>{if(y instanceof v.VSBuffer)b.write(y.buffer);else{if(y==="end")b.end();else{let d=y;d instanceof Error||(d=(0,E.createFileSystemProviderError)((0,t.toErrorMessage)(d),E.FileSystemProviderErrorCode.Unknown)),b.error(d),b.end()}p.dispose()}});return C.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),p.dispose()}),b}writeFile(g,f,C){return this.channel.call("writeFile",[g,v.VSBuffer.wrap(f),C])}open(g,f){return this.channel.call("open",[g,f])}close(g){return this.channel.call("close",[g])}async read(g,f,C,b,p){const[y,d]=await this.channel.call("read",[g,f,p]);return C.set(y.buffer.slice(0,d),b),d}write(g,f,C,b,p){return this.channel.call("write",[g,f,v.VSBuffer.wrap(C),b,p])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,f){return this.channel.call("delete",[g,f])}rename(g,f,C){return this.channel.call("rename",[g,f,C])}copy(g,f,C){return this.channel.call("copy",[g,f,C])}cloneFile(g,f){return this.channel.call("cloneFile",[g,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const f=g;this._onDidChange.fire(f.map(C=>({resource:l.URI.revive(C.resource),type:C.type})))}else{const f=g;this._onDidWatchError.fire(f)}}))}watch(g,f){const C=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,C,g,f]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,C]))}}e.DiskFileSystemProviderClient=I}),define(J[103],Z([0,1,17,18,161,14]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(E,I,w,g,f,C){let b;try{await S(E,I,w,g,f,C)}catch(p){b=p}finally{b&&f.errorTransformer&&(b=f.errorTransformer(b)),typeof b<"u"&&w.error(b),w.end()}}e.readFileIntoStream=M;async function S(E,I,w,g,f,C){l(C);const b=await E.open(I,{create:!1});try{l(C);let p=0,y=0,d=f&&typeof f.length=="number"?f.length:void 0,h=v.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,i=0;do y=await E.read(b,a,h.buffer,i,h.byteLength-i),a+=y,i+=y,p+=y,typeof d=="number"&&(d-=y),i===h.byteLength&&(await w.write(g(h)),h=v.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),i=0);while(y>0&&(typeof d!="number"||d>0)&&l(C)&&m(p,f));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),w.write(g(h.slice(0,o)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await E.close(b)}}function l(E){if(E.isCancellationRequested)throw(0,t.canceled)();return!0}function m(E,I){if(I?.limits){if(typeof I.limits.memory=="number"&&E>I.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&E>I.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[70],Z([0,1,93,2,9,5,7,14]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function l(p){return p.recursive===!0}e.isRecursiveWatchRequest=l;class m extends t.Disposable{constructor(y,d,h,a){super(),this.onFileChanges=y,this.onLogMessage=d,this.verboseLogging=h,this.options=a,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const y=new t.DisposableStore;this.watcherDisposables.value=y,this.watcher=this.createWatcher(y),this.watcher.setVerboseLogging(this.verboseLogging),y.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),y.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),y.add(this.watcher.onDidError(d=>this.onError(d)))}onError(y){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${y}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${y}`):this.error(y)}restart(y){this.restartCounter++,this.init(),this.watch(y)}async watch(y){this.requests=y,await this.watcher?.watch(y)}async setVerboseLogging(y){this.verboseLogging=y,await this.watcher?.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${y}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class E extends m{constructor(y,d,h){super(y,d,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class I extends m{constructor(y,d,h){super(y,d,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function w(p){return p.map(y=>({type:y.type,resource:M.URI.file(y.path)}))}e.toFileChanges=w;function g(p){const y=new b;for(const d of p)y.processEvent(d);return y.coalesce()}e.coalesceEvents=g;function f(p,y){return typeof y=="string"&&!y.startsWith(v.GLOBSTAR)&&!(0,k.isAbsolute)(y)?{base:p,pattern:y}:y}e.normalizeWatcherPattern=f;function C(p,y){const d=[];for(const h of y)d.push((0,v.parse)(f(p,h)));return d}e.parseWatcherPatterns=C;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(y){return R.isLinux?y.path:y.path.toLowerCase()}processEvent(y){const d=this.mapPathToChange.get(this.toKey(y));let h=!1;if(d){const a=d.type,i=y.type;d.path!==y.path&&(y.type===2||y.type===1)?h=!0:a===1&&i===2?(this.mapPathToChange.delete(this.toKey(y)),this.coalesced.delete(d)):a===2&&i===1?d.type=0:a===1&&i===0||(d.type=i)}else h=!0;h&&(this.coalesced.add(y),this.mapPathToChange.set(this.toKey(y),y))}coalesce(){const y=[],d=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(y.push(h),!1):!0).sort((h,a)=>h.path.length-a.path.length).filter(h=>d.some(a=>(0,S.isParent)(h.path,a,!R.isLinux))?!1:(d.push(h.path),!0)).concat(y)}}}),define(J[197],Z([0,1,29,8,22,31,2,78,9,5,95,25,70]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends M.Disposable{constructor(b,p,y,d){super(),this.request=b,this.onDidFilesChange=p,this.onLogMessage=y,this.verboseLogging=d,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await I.Promises.stat(b);this._register(await this.doWatch(b,p.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let p=b.path;try{p=await I.Promises.realpath(b.path),b.path===p&&(p=await(0,E.realcase)(b.path)??b.path),b.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${p})`)}catch{}return p}async doWatch(b,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const y=new k.CancellationTokenSource(this.cts.token),d=new M.DisposableStore;try{const h=(0,l.basename)(b),a=(0,v.watch)(b);d.add((0,M.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${b}'`);const i=new Set;if(p)try{for(const r of await I.Promises.readdir(b))i.add(r)}catch(r){this.error(r)}const o=new Map;d.add((0,M.toDisposable)(()=>{for(const[,r]of o)r.dispose();o.clear()})),a.on("error",(r,n)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${r}, ${n})`),this.dispose()}),a.on("change",(r,n)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${n}`);let s="";if(n&&(s=n.toString(),m.isMacintosh&&(s=(0,S.normalizeNFC)(s))),!(!s||r!=="change"&&r!=="rename"))if(p)if(r==="rename"){o.get(s)?.dispose();const c=setTimeout(async()=>{if(o.delete(s),s===h&&!await I.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,l.join)(b,s));if(y.token.isCancellationRequested)return;let P;u?i.has(s)?P=0:(P=1,i.add(s)):(i.delete(s),P=2),this.onFileChange({path:(0,l.join)(this.request.path,s),type:P})},g.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(s)?c=0:(c=1,i.add(s)),this.onFileChange({path:(0,l.join)(this.request.path,s),type:c})}else if(r==="rename"||s!==h){const c=setTimeout(async()=>{const u=await I.Promises.exists(b);y.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await I.Promises.exists(b)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${h.toString()})`)}return(0,M.toDisposable)(()=>{y.dispose(!0),d.dispose()})}async onFileChange(b,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!p&&this.excludes.some(y=>y(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(y=>y(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,w.coalesceEvents)(y);if(d.length>0){if(this.verboseLogging)for(const a of d)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(m.isLinux)return I.Promises.exists(b);try{const p=(0,l.basename)(b);return(await I.Promises.readdir((0,l.dirname)(b))).some(d=>d===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function f(C,b,p,y,d=512){const h=await I.Promises.open(C,"r"),a=Buffer.allocUnsafe(d),i=new k.CancellationTokenSource(y);let o,r=!1;const n={path:C,excludes:[],recursive:!1},s=new g(n,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(r)return;r=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:P}=await I.Promises.read(h,a,0,d,null);if(!P||i.token.isCancellationRequested)break;b(a.slice(0,P))}}catch(P){o=new Error(P),i.dispose(!0)}finally{r=!1}}})()});return await s.ready,p(),new Promise((c,u)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await I.Promises.close(h)}catch(P){o=new Error(P)}o?u(o):c()})})}e.watchFileContents=f}),define(J[198],Z([0,1,3,93,2,5,197]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const E=this.normalizeRequests(m),I=E.filter(g=>{const f=this.watchers.get(g.path);return f?!(0,t.patternsEquals)(f.request.excludes,g.excludes)||!(0,t.patternsEquals)(f.request.includes,g.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:g})=>!E.find(f=>f.path===g.path&&(0,t.patternsEquals)(f.excludes,g.excludes)&&(0,t.patternsEquals)(f.includes,g.includes))).map(({request:g})=>g.path);I.length&&this.trace(`Request to start watching: ${I.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const g of w)this.stopWatching(g);for(const g of I)this.startWatching(g)}startWatching(m){const E=new M.NodeJSFileWatcherLibrary(m,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),I={request:m,instance:E};this.watchers.set(m.path,I)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const E=this.watchers.get(m);E&&(this.watchers.delete(m),E.instance.dispose())}normalizeRequests(m){const E=new Map;for(const I of m){const w=R.isLinux?I.path:I.path.toLowerCase();E.set(w,I)}return Array.from(E.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,E]of this.watchers)E.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,E){return E?`[File Watcher (node.js)] ${m} (path: ${E.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=S}),define(J[199],Z([0,1,70,198]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends v.AbstractNonRecursiveWatcherClient{constructor(M,S,l){super(M,S,l),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(J[200],Z([0,1,13,51,147,70]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(l,m,E){super(l,m,E),this.init()}createWatcher(l){const m=l.add(new k.Client(v.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:E,signal:I})=>this.onError(`terminated by itself with code ${E}, signal: ${I}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(J[81],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(const[R,M]of k)this.set(R,M)}set(k,R){const M=this._entries.get(k);return this._entries.set(k,R),M}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(J[201],Z([0,1,8,18,68,191,4,81]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const l=!1;class m extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class E{constructor(f=new S.ServiceCollection,C=!1,b){this._activeInstantiations=new Set,this._services=f,this._strict=C,this._parent=b,this._services.set(M.IInstantiationService,this)}createChild(f){return new E(f,this._strict,this)}invokeFunction(f,...C){const b=w.traceInvocation(f);let p=!1;try{return f({get:d=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(d,b);if(!h)throw new Error(`[invokeFunction] unknown service '${d}'`);return h}},...C)}finally{p=!0,b.stop()}}createInstance(f,...C){let b,p;return f instanceof k.SyncDescriptor?(b=w.traceCreation(f.ctor),p=this._createInstance(f.ctor,f.staticArguments.concat(C),b)):(b=w.traceCreation(f),p=this._createInstance(f,C,b)),b.stop(),p}_createInstance(f,C=[],b){const p=M._util.getServiceDependencies(f).sort((h,a)=>h.index-a.index),y=[];for(const h of p){const a=this._getOrCreateServiceInstance(h.id,b);a||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${h.id}.`,!1),y.push(a)}const d=p.length>0?p[0].index:C.length;if(C.length!==d){console.trace(`[createInstance] First service dependency of ${f.name} at position ${d+1} conflicts with ${C.length} static arguments`);const h=d-C.length;h>0?C=C.concat(new Array(h)):C=C.slice(0,d)}return new f(...C,...y)}_setServiceInstance(f,C){if(this._services.get(f)instanceof k.SyncDescriptor)this._services.set(f,C);else if(this._parent)this._parent._setServiceInstance(f,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const C=this._services.get(f);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):C}_getOrCreateServiceInstance(f,C){const b=this._getServiceInstanceOrDescriptor(f);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,b,C.branch(f,!0)):(C.branch(f,!1),b)}_safeCreateAndCacheServiceInstance(f,C,b){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,C,b)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,C,b){const p=new R.Graph(h=>h.id.toString());let y=0;const d=[{id:f,desc:C,_trace:b}];for(;d.length;){const h=d.pop();if(p.lookupOrInsertNode(h),y++>1e3)throw new m(p);for(const a of M._util.getServiceDependencies(h.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${f} depends on ${a.id} which is NOT registered.`,!0),i instanceof k.SyncDescriptor){const o={id:a.id,desc:i,_trace:h._trace.branch(a.id,!0)};p.insertEdge(h,o),d.push(o)}}}for(;;){const h=p.roots();if(h.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:a}of h){if(this._getServiceInstanceOrDescriptor(a.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,C,b=[],p,y){if(this._services.get(f)instanceof k.SyncDescriptor)return this._createServiceInstance(C,b,p,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,C,b,p,y);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(f,C=[],b,p){if(b){const y=new v.IdleValue(()=>this._createInstance(f,C,p));return new Proxy(Object.create(null),{get(d,h){if(h in d)return d[h];const a=y.value;let i=a[h];return typeof i!="function"||(i=i.bind(a),d[h]=i),i},set(d,h,a){return y.value[h]=a,!0}})}else return this._createInstance(f,C,p)}_throwIfStrict(f,C){if(C&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=E;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class w{constructor(f,C){this.type=f,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return l?new w(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(f){return l?new w(0,f.name):w._None}branch(f,C){const b=new w(2,f.toString());return this._dep.push([f,C,b]),b}stop(){const f=Date.now()-this._start;w._totals+=f;let C=!1;function b(y,d){const h=[],a=new Array(y+1).join("	");for(const[i,o,r]of d._dep)if(o&&r){C=!0,h.push(`${a}CREATES -> ${i}`);const n=b(y+1,r);n&&h.push(n)}else h.push(`${a}uses -> ${i}`);return h.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(f>2||C)&&console.log(p.join(`
`))}}e.Trace=w,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(J[6],Z([0,1,43,3,2,5,4]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function S(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function m(o,r,n){switch(r){case l.Trace:o.trace(n);break;case l.Debug:o.debug(n);break;case l.Info:o.info(n);break;case l.Warning:o.warn(n);break;case l.Error:o.error(n);break;case l.Critical:o.critical(n);break;default:throw new Error("Invalid log level")}}e.log=m;function E(o){let r="";for(let n=0;n<o.length;n++){let s=o[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(n>0?" ":"")+s}return r}e.format=E;class I extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class w extends I{constructor(r){super(),this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,E([r,...n]))}debug(r,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,E([r,...n]))}info(r,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,E([r,...n]))}warn(r,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,E([r,...n]))}error(r,...n){if(this.checkLogLevel(l.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(l.Error,E(s))}else this.log(l.Error,E([r,...n]))}critical(r,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,E([r,...n]))}flush(){}}e.AbstractMessageLogger=w;class g extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.useColors=!R.isWindows}trace(r,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,r,...n):console.log(`[main ${S()}]`,r,...n))}debug(r,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,r,...n):console.log(`[main ${S()}]`,r,...n))}info(r,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,r,...n):console.log(`[main ${S()}]`,r,...n))}warn(r,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,r,...n):console.warn(`[main ${S()}]`,r,...n))}error(r,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,r,...n):console.error(`[main ${S()}]`,r,...n))}critical(r,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${S()}]\x1B[0m`,r,...n):console.error(`[main ${S()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class f extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class C extends I{constructor(r,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,v.toErrorMessage)(r,this.getLevel()<=l.Trace)}dispose(){}flush(){}}e.AdapterLogger=C;class b extends I{constructor(r){super(),this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const s of this.logServices)s.trace(r,...n)}debug(r,...n){for(const s of this.logServices)s.debug(r,...n)}info(r,...n){for(const s of this.logServices)s.info(r,...n)}warn(r,...n){for(const s of this.logServices)s.warn(r,...n)}error(r,...n){for(const s of this.logServices)s.error(r,...n)}critical(r,...n){for(const s of this.logServices)s.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=b;class p extends k.Disposable{constructor(r){super(),this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=p;class y extends k.Disposable{constructor(r,n){super(),this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,n?.always?l.Trace:this.logLevel,n),this.loggers.set(r.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return l.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=d;function h(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const r=a(o.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function a(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}e.parseLogLevel=a;function i(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}e.LogLevelToString=i});var X=this&&this.__param||function(q,e){return function(v,t){e(v,t,q)}};define(J[202],Z([0,1,69,3,2,6,5]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let S=class yt extends k.Disposable{constructor(m){super(),this.logService=m,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(m,E){let I;try{I=await this.withKeytar()}catch{return null}const w=await I.getPassword(m,E);if(w)try{let{content:g,hasNextChunk:f}=JSON.parse(w);if(!g||!f)return w;let C=1;for(;f;){const b=await I.getPassword(m,`${E}-${C}`),p=JSON.parse(b);g+=p.content,f=p.hasNextChunk,C++}return g}catch{return w}return w}async setPassword(m,E,I){let w;try{w=await this.withKeytar()}catch(C){throw this.surfaceKeytarLoadError?.(C),C}const g=3,f=async(C,b,p)=>{let y=0,d;for(;y<g;)try{await w.setPassword(C,b,p);return}catch(h){d=h,this.logService.warn("Error attempting to set a password: ",h?.message??h),y++,await new Promise(a=>setTimeout(a,200))}throw d};if(M.isWindows&&I.length>yt.MAX_PASSWORD_LENGTH){let C=0,b=0,p=!0;for(;p;){const y=I.substring(C,C+yt.PASSWORD_CHUNK_SIZE);C+=yt.PASSWORD_CHUNK_SIZE,p=I.length-C>0;const d={content:y,hasNextChunk:p};await f(m,b?`${E}-${b}`:E,JSON.stringify(d)),b++}}else await f(m,E,I);this._onDidChangePassword.fire({service:m,account:E})}async deletePassword(m,E){let I;try{I=await this.withKeytar()}catch(f){throw this.surfaceKeytarLoadError?.(f),f}const w=await I.getPassword(m,E);if(!w)return!1;const g=await I.deletePassword(m,E);try{let{content:f,hasNextChunk:C}=JSON.parse(w);if(f&&C){let b=1;for(;C;){const p=`${E}-${b}`,y=await I.getPassword(m,p);await I.deletePassword(m,p),C=JSON.parse(y).hasNextChunk,b++}}}catch{}return g&&this._onDidChangePassword.fire({service:m,account:E}),g}async findPassword(m){let E;try{E=await this.withKeytar()}catch{return null}return E.findPassword(m)}async findCredentials(m){let E;try{E=await this.withKeytar()}catch{return[]}return E.findCredentials(m)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};S.MAX_PASSWORD_LENGTH=2500,S.PASSWORD_CHUNK_SIZE=S.MAX_PASSWORD_LENGTH-100,S=ve([X(0,R.ILogService)],S),e.BaseCredentialsMainService=S}),define(J[203],Z([0,1,23,8,18,3,2,9,70,6]),function(q,e,v,t,k,R,M,S,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends M.Disposable{constructor(w,g){super(),this.logService=w,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(w,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,g):this.watchNonRecursive(w,g)}watchUniversal(w,g){const f={path:this.toFilePath(w),excludes:g.excludes,includes:g.includes,recursive:g.recursive},C=(0,v.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{C(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,k.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,l.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const g of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const g of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(g)&&w.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,g){const f={path:this.toFilePath(w),excludes:g.excludes,includes:g.includes,recursive:!1},C=(0,v.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{C(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,k.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,l.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,S.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(J[204],Z([0,1,23,8,17,22,3,66,65,2,32,13,82,16,57,159,14,103,6]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends m.Disposable{constructor(a){super(),this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(a,i){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${a}`);const o=new m.DisposableStore;return this.provider.set(a,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:i}),o.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:a}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:i}),this.provider.delete(a),(0,m.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){i.push(o)}}),!this.provider.has(a)&&await t.Promises.settled(i)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,i){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return l.Iterable.map(this.provider,([a,i])=>({scheme:a,capabilities:i.capabilities}))}async withProvider(a){if(!(0,g.isAbsolutePath)(a))throw new b.FileOperationError((0,C.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const i=this.provider.get(a.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,C.localize)(1,null,a.toString()),o}return i}async withReadProvider(a){const i=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)||(0,b.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const i=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,i){try{return await this.doResolveFile(a,i)}catch(o){throw(0,b.toFileSystemProviderErrorCode)(o)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,C.localize)(2,null,this.resourceForError(a)),1):(0,b.ensureFileSystemProviderError)(o)}}async doResolveFile(a,i){const o=await this.withProvider(a),r=this.isPathCaseSensitive(o),n=i?.resolveTo,s=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,u=await o.stat(a);let P;return this.toFileStat(o,a,u,void 0,!!c,(D,T)=>(P||(P=E.TernarySearchTree.forUris(()=>!r),P.set(a,!0),n&&P.fill(!0,n)),P.get(D.resource)||P.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?T===1:!1))}async toFileStat(a,i,o,r,n,s){const{providerExtUri:c}=this.getExtUri(a),u={resource:i,name:c.basename(i),isFile:(o.type&b.FileType.File)!==0,isDirectory:(o.type&b.FileType.Directory)!==0,isSymbolicLink:(o.type&b.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&b.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,b.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&s(u,r)){try{const P=await a.readdir(i),D=await t.Promises.settled(P.map(async([T,_])=>{try{const U=c.joinPath(i,T),Q=n?await a.stat(U):{type:_};return await this.toFileStat(a,U,Q,P.length,n,s)}catch(U){return this.logService.trace(U),null}}));u.children=(0,v.coalesce)(D)}catch(P){this.logService.trace(P),u.children=[]}return u}return u}async resolveAll(a){return t.Promises.settled(a.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(a){const i=await this.withProvider(a),o=await i.stat(a);return this.toFileStat(i,a,o,void 0,!0,()=>!1)}async exists(a){const i=await this.withProvider(a);try{return!!await i.stat(a)}catch{return!1}}async canCreateFile(a,i){try{await this.doValidateCreateFile(a,i)}catch(o){return o}return!0}async doValidateCreateFile(a,i){if(!i?.overwrite&&await this.exists(a))throw new b.FileOperationError((0,C.localize)(3,null,this.resourceForError(a)),3,i)}async createFile(a,i=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const r=await this.writeFile(a,i);return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,r)),r}async writeFile(a,i,o){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,a,o)||await this.mkdirp(r,n.dirname(a));let c;if((0,b.hasReadWriteCapability)(r)&&!(i instanceof k.VSBuffer))if((0,f.isReadableStream)(i)){const u=await(0,f.peekStream)(i,3);u.ended?c=k.VSBuffer.concat(u.buffer):c=u}else c=(0,f.peekReadable)(i,u=>k.VSBuffer.concat(u),3);else c=i;!(0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(r,a,o,c):await this.doWriteBuffered(r,a,o,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new b.FileOperationEvent(a,4))}catch(s){throw new b.FileOperationError((0,C.localize)(4,null,this.resourceForError(a),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,i,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,C.localize)(5,null,this.resourceForError(i)));let n;try{n=await a.stat(i)}catch{return}if((n.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,C.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,n),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==b.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&o.mtime<n.mtime&&o.etag!==(0,b.etag)({mtime:o.mtime,size:n.size}))throw new b.FileOperationError((0,C.localize)(7,null),3,o);return n}async readFile(a,i,o){const r=await this.withReadProvider(a);return i?.atomic?this.doReadFileAtomic(r,a,i,o):this.doReadFile(r,a,i,o)}async doReadFileAtomic(a,i,o,r){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(a,i,o,r);n(c)}catch(c){s(c)}})})}async doReadFile(a,i,o,r){const n=await this.doReadFileStream(a,i,{...o,preferUnbuffered:!0},r);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(a,i,o){const r=await this.withReadProvider(a);return this.doReadFileStream(r,a,i,o)}async doReadFileStream(a,i,o,r){const n=new R.CancellationTokenSource(r),s=this.validateReadFile(i,o).then(u=>u,u=>{throw n.cancel(),u});let c;try{return typeof o?.etag=="string"&&o.etag!==b.ETAG_DISABLED&&await s,o?.atomic&&(0,b.hasFileAtomicReadCapability)(a)||!((0,b.hasOpenReadWriteCloseCapability)(a)||(0,b.hasFileReadStreamCapability)(a))||(0,b.hasReadWriteCapability)(a)&&o?.preferUnbuffered?c=this.readFileUnbuffered(a,i,o):(0,b.hasFileReadStreamCapability)(a)?c=this.readFileStreamed(a,i,n.token,o):c=this.readFileBuffered(a,i,n.token,o),{...await s,value:c}}catch(u){c&&await(0,f.consumeStream)(c);const P=(0,C.localize)(8,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(u).toString());throw u instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(P,u.stat,o):new b.FileOperationError(P,(0,b.toFileOperationResult)(u),o)}}readFileStreamed(a,i,o,r=Object.create(null)){const n=a.readFileStream(i,r,o);return(0,f.transform)(n,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new b.FileOperationError((0,C.localize)(9,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),r)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,i,o,r=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(a,i,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new b.FileOperationError((0,C.localize)(10,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),r)},o),n}readFileUnbuffered(a,i,o){const r=(0,f.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;o?.atomic&&(0,b.hasFileAtomicReadCapability)(a)?n=await a.readFile(i,{atomic:!0}):n=await a.readFile(i),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.validateReadFileLimits(i,n.byteLength,o),r.end(k.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(a,i){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new b.FileOperationError((0,C.localize)(11,null,this.resourceForError(a)),0,i);if(typeof i?.etag=="string"&&i.etag!==b.ETAG_DISABLED&&i.etag===o.etag)throw new b.NotModifiedSinceFileOperationError((0,C.localize)(12,null),o,i);return this.validateReadFileLimits(a,o.size,i),o}validateReadFileLimits(a,i,o){if(o?.limits){let r;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(r=9),typeof o.limits.size=="number"&&i>o.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError((0,C.localize)(13,null,this.resourceForError(a)),r)}}async canMove(a,i,o){return this.doCanMoveCopy(a,i,"move",o)}async canCopy(a,i,o){return this.doCanMoveCopy(a,i,"copy",o)}async doCanMoveCopy(a,i,o,r){if(a.toString()!==i.toString())try{const n=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,a,s,i,o,r)}catch(n){return n}return!0}async move(a,i,o){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(r,a,n,i,"move",!!o),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,s==="move"?2:3,c)),c}async copy(a,i,o){const r=await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(r,a,n,i,"copy",!!o),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,s==="copy"?3:2,c)),c}async doMoveCopy(a,i,o,r,n,s){if(i.toString()===r.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,i,o,r,n,s);if(c&&!u&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(r)),n==="copy"){if(a===o&&(0,b.hasFileFolderCopyCapability)(a))await a.copy(i,r,{overwrite:s});else{const P=await this.resolve(i);P.isDirectory?await this.doCopyFolder(a,P,o,r):await this.doCopyFile(a,i,o,r)}return n}else return a===o?(await a.rename(i,r,{overwrite:s}),n):(await this.doMoveCopy(a,i,o,r,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(a,i,o,r){if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,i,o,r);if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,i,o,r);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,i,o,r);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,i,o,r)}async doCopyFolder(a,i,o,r){await o.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async n=>{const s=this.getExtUri(o).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(a,await this.resolve(n.resource),o,s):this.doCopyFile(a,n.resource,o,s)}))}async doValidateMoveCopy(a,i,o,r,n,s){let c=!1;if(a===o){const{providerExtUri:P,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(c=P.isEqual(i,r)),c&&n==="copy")throw new Error((0,C.localize)(14,null,this.resourceForError(i),this.resourceForError(r)));if(!c&&P.isEqualOrParent(r,i))throw new Error((0,C.localize)(15,null,this.resourceForError(i),this.resourceForError(r)))}const u=await this.exists(r);if(u&&!c){if(!s)throw new b.FileOperationError((0,C.localize)(16,null,this.resourceForError(i),this.resourceForError(r)),4);if(a===o){const{providerExtUri:P}=this.getExtUri(a);if(P.isEqualOrParent(i,r))throw new Error((0,C.localize)(17,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:u,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const i=this.isPathCaseSensitive(a);return{providerExtUri:i?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(i,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,o)),o}async mkdirp(a,i){const o=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(i,r.dirname(i));)try{if(((await a.stat(i)).type&b.FileType.Directory)===0)throw new Error((0,C.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(r.basename(i)),i=r.dirname(i)}for(let n=o.length-1;n>=0;n--){i=r.joinPath(i,o[n]);try{await a.mkdir(i)}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,i){try{await this.doValidateDelete(a,i)}catch(o){return o}return!0}async doValidateDelete(a,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,C.localize)(19,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch{}if(n)this.throwIfFileIsReadonly(a,n);else throw new b.FileOperationError((0,C.localize)(20,null,this.resourceForError(a)),1);if(!!!i?.recursive){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,C.localize)(21,null,this.resourceForError(a)))}return o}async del(a,i){const o=await this.doValidateDelete(a,i),r=!!i?.useTrash,n=!!i?.recursive;await o.delete(a,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(a,1))}async cloneFile(a,i){const o=await this.withProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===r&&this.getExtUri(o).providerExtUri.isEqual(a,i))return;if(o===r&&(0,b.hasFileCloneCapability)(o))return o.cloneFile(a,i);await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i));const n=this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri);return o===r&&(0,b.hasFileFolderCopyCapability)(o)?n.queue(()=>o.copy(a,i,{overwrite:!0})):n.queue(()=>this.doCopyFile(o,a,r,i))}watch(a,i={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let r=!1,n=()=>{r=!0};return o.add((0,m.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(a,i);r?(0,m.dispose)(s):n=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(a,i){const o=await this.withProvider(a),r=(0,S.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(a),i]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:o.watch(a,i)},this.activeWatchers.set(r,n)),n.count+=1,(0,m.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,m.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,i,o,r){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{const n=await a.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,f.isReadableStream)(r)||(0,f.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(a,n,r):await this.doWriteReadableBufferedQueued(a,n,r)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await a.close(n)}})}async doWriteStreamBufferedQueued(a,i,o){let r=0,n;if((0,f.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,i,s,s.byteLength,r,0),r+=s.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((s,c)=>{(0,f.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(a,i,u,u.byteLength,r,0)}catch(P){return c(P)}r+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>c(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,i,o){let r=0,n;for(;(n=o.read())!==null;)await this.doWriteBuffer(a,i,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(a,i,o,r,n,s){let c=0;for(;c<r;)c+=await a.write(i,n+c,o.buffer,s+c,r-c)}async doWriteUnbuffered(a,i,o,r){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,i,o,r))}async doWriteUnbufferedQueued(a,i,o,r){let n;r instanceof k.VSBuffer?n=r:(0,f.isReadableStream)(r)?n=await(0,k.streamToBuffer)(r):(0,f.isReadableBufferedStream)(r)?n=await(0,k.bufferedStreamToBuffer)(r):n=(0,k.readableToBuffer)(r),await a.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,i,o,r){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,i,o,r))}async doPipeBufferedQueued(a,i,o,r){let n,s;try{n=await a.open(i,{create:!1}),s=await o.open(r,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,P=0,D=0;do D=await a.read(n,u,c.buffer,P,c.byteLength-P),await this.doWriteBuffer(o,s,c,D,u,P),u+=D,P+=D,P===c.byteLength&&(P=0);while(D>0)}catch(c){throw(0,b.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,i,o,r){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,i,o,r))}async doPipeUnbufferedQueued(a,i,o,r){return o.writeFile(r,await a.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,i,o,r){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,i,o,r))}async doPipeUnbufferedToBufferedQueued(a,i,o,r){const n=await o.open(r,{create:!0,unlock:!1});try{const s=await a.readFile(i);await this.doWriteBuffer(o,n,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await o.close(n)}}async doPipeBufferedToUnbuffered(a,i,o,r){const n=await(0,k.streamToBuffer)(this.readFileBuffered(a,i,R.CancellationToken.None));await this.doWriteUnbuffered(o,r,void 0,n)}throwIfFileSystemIsReadonly(a,i){if(a.capabilities&2048)throw new b.FileOperationError((0,C.localize)(22,null,this.resourceForError(i)),6);return a}throwIfFileIsReadonly(a,i){if((i.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,C.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===I.Schemas.file?a.fsPath:a.toString(!0)}};d=ve([X(0,y.ILogService)],d),e.FileService=d}),define(J[83],Z([0,1,29,274,8,32,17,3,31,2,9,5,16,57,25,163,14,103,203,43,200,199]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class i extends y.AbstractDiskFileSystemProvider{constructor(r,n){super(r,n),this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new R.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:n,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(r){try{const n=await f.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async c=>{try{let u;c.isSymbolicLink()?u=(await this.stat((0,w.joinPath)(r,c.name))).type:u=this.toType(c),s.push([c.name,u])}catch(u){this.logService.trace(u)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(r,n){let s;return n?.dangling?s=b.FileType.Unknown:r.isFile()?s=b.FileType.File:r.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,n&&(s|=b.FileType.SymbolicLink),s}async createResourceLock(r){const n=this.toFilePath(r);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const c=new k.Barrier;return this.resourceLocks.set(r,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(r)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(r,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const c=this.toFilePath(r);return await f.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}readFileStream(r,n,s){const c=(0,g.newWriteableStream)(u=>M.VSBuffer.concat(u.map(P=>M.VSBuffer.wrap(P))).buffer);return(0,p.readFileIntoStream)(this,r,c,u=>u.buffer,{...n,bufferSize:256*1024},s),c}async writeFile(r,n,s){let c;try{const u=this.toFilePath(r);if(!s.create||!s.overwrite){if(await f.Promises.exists(u)){if(!s.overwrite)throw(0,b.createFileSystemProviderError)((0,C.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.createFileSystemProviderError)((0,C.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(r,u)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){i.canFlush=r}async open(r,n){const s=this.toFilePath(r);let c;(0,b.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(r));let u;try{if((0,b.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:D}=await f.SymlinkSupport.stat(s);D.mode&128||await f.Promises.chmod(s,D.mode|128)}catch(D){this.logService.trace(D)}let P;if((0,b.isFileOpenForWriteOptions)(n)){if(I.isWindows)try{await f.Promises.truncate(s,0),P="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}P||(P="w")}else P="r";u=await f.Promises.open(s,P)}catch(P){throw c?.dispose(),(0,b.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(r,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(u,0),(0,b.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(u,r),c){const P=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,c),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),P.dispose())}return u}async close(r){const n=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&i.canFlush)try{await f.Promises.fdatasync(r)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(r)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(r)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,s,c,u){const P=this.normalizePos(r,n);let D=null;try{D=(await f.Promises.read(r,s,c,u,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(r,P,D)}return D}normalizePos(r,n){return n===this.mapHandleToPos.get(r)?null:n}updatePos(r,n,s){const c=this.mapHandleToPos.get(r);typeof c=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,c+s):this.mapHandleToPos.delete(r)))}async write(r,n,s,c,u){return(0,k.retry)(()=>this.doWrite(r,n,s,c,u),100,3)}async doWrite(r,n,s,c,u){const P=this.normalizePos(r,n);let D=null;try{D=(await f.Promises.write(r,s,c,u,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),T)}finally{this.updatePos(r,P,D)}return D}async mkdir(r){try{await f.Promises.mkdir(this.toFilePath(r))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(r,n){try{const s=this.toFilePath(r);n.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,n,s){const c=this.toFilePath(r),u=this.toFilePath(n);if(c!==u)try{await this.validateTargetDeleted(r,n,"move",s.overwrite),await f.Promises.move(c,u)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,C.localize)(2,null,(0,E.basename)(c),(0,E.basename)((0,E.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(r,n,s){const c=this.toFilePath(r),u=this.toFilePath(n);if(c!==u)try{await this.validateTargetDeleted(r,n,"copy",s.overwrite),await f.Promises.copy(c,u,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,C.localize)(3,null,(0,E.basename)(c),(0,E.basename)((0,E.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(r,n,s,c){const u=this.toFilePath(r),P=this.toFilePath(n);let D=!1;if(!!(this.capabilities&1024)||(D=(0,l.isEqual)(u,P,!0)),D&&s==="copy")throw(0,b.createFileSystemProviderError)((0,C.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!D&&await f.Promises.exists(P)){if(!c)throw(0,b.createFileSystemProviderError)((0,C.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(r,n){return this.doCloneFile(r,n,!1)}async doCloneFile(r,n,s){const c=this.toFilePath(r),u=this.toFilePath(n),P=!!(this.capabilities&1024);if((0,l.isEqual)(c,u,!P))return;const D=new m.DisposableStore;try{const[T,_]=await Promise.all([this.createResourceLock(r),this.createResourceLock(n)]);D.add(T),D.add(_),s&&await f.Promises.mkdir((0,E.dirname)(u),{recursive:!0}),await f.Promises.copyFile(c,u)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(r,n,!0);throw this.toFileSystemProviderError(T)}finally{D.dispose()}}createUniversalWatcher(r,n,s){return new h.UniversalWatcherClient(c=>r(c),c=>n(c),s)}createNonRecursiveWatcher(r,n,s){return new a.NodeJSWatcherClient(c=>r(c),c=>n(c),s)}toFileSystemProviderError(r){if(r instanceof b.FileSystemProviderError)return r;let n;switch(r.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(r,n){let s=this.toFileSystemProviderError(n);if(r&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.toFilePath(r));c.mode&128||(s=(0,b.createFileSystemProviderError)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(J[205],Z([0,1,3,83,2,17,57,22]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class l extends k.Disposable{constructor(I,w){super(),this.provider=I,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(I,w,g){const f=this.getUriTransformer(I);switch(w){case"stat":return this.stat(f,g[0]);case"readdir":return this.readdir(f,g[0]);case"open":return this.open(f,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(f,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(f,g[0],g[1],g[2]);case"rename":return this.rename(f,g[0],g[1],g[2]);case"copy":return this.copy(f,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(f,g[0],g[1]);case"mkdir":return this.mkdir(f,g[0]);case"delete":return this.delete(f,g[0],g[1]);case"watch":return this.watch(f,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${w} not found`)}listen(I,w,g){const f=this.getUriTransformer(I);switch(w){case"fileChange":return this.onFileChange(f,g[0]);case"readFileStream":return this.onReadFileStream(f,g[0],g[1])}throw new Error(`Unknown event ${w}`)}stat(I,w){const g=this.transformIncoming(I,w,!0);return this.provider.stat(g)}readdir(I,w){const g=this.transformIncoming(I,w);return this.provider.readdir(g)}async readFile(I,w,g){const f=this.transformIncoming(I,w,!0),C=await this.provider.readFile(f,g);return R.VSBuffer.wrap(C)}onReadFileStream(I,w,g){const f=this.transformIncoming(I,w,!0),C=new S.CancellationTokenSource,b=new v.Emitter({onLastListenerRemove:()=>{C.cancel()}}),p=this.provider.readFileStream(f,g,C.token);return(0,M.listenStream)(p,{onData:y=>b.fire(R.VSBuffer.wrap(y)),onError:y=>b.fire(y),onEnd:()=>{b.fire("end"),b.dispose(),C.dispose()}}),b.event}writeFile(I,w,g,f){const C=this.transformIncoming(I,w);return this.provider.writeFile(C,g.buffer,f)}open(I,w,g){const f=this.transformIncoming(I,w,!0);return this.provider.open(f,g)}close(I){return this.provider.close(I)}async read(I,w,g){const f=R.VSBuffer.alloc(g),C=0,b=await this.provider.read(I,w,f.buffer,C,g);return[f,b]}write(I,w,g,f,C){return this.provider.write(I,w,g.buffer,f,C)}mkdir(I,w){const g=this.transformIncoming(I,w);return this.provider.mkdir(g)}delete(I,w,g){const f=this.transformIncoming(I,w);return this.provider.delete(f,g)}rename(I,w,g,f){const C=this.transformIncoming(I,w),b=this.transformIncoming(I,g);return this.provider.rename(C,b,f)}copy(I,w,g,f){const C=this.transformIncoming(I,w),b=this.transformIncoming(I,g);return this.provider.copy(C,b,f)}cloneFile(I,w,g){const f=this.transformIncoming(I,w),C=this.transformIncoming(I,g);return this.provider.cloneFile(f,C)}onFileChange(I,w){const g=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(I,g))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return g.event}async watch(I,w,g,f,C){const b=this.sessionToWatcher.get(w);if(b){const p=this.transformIncoming(I,f),y=b.watch(g,p,C);this.watchRequests.set(w+g,y)}}async unwatch(I,w){const g=I+w,f=this.watchRequests.get(g);f&&((0,k.dispose)(f),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,I]of this.watchRequests)I.dispose();this.watchRequests.clear();for(const[,I]of this.sessionToWatcher)I.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=l;class m extends k.Disposable{constructor(I,w,g,f){super(),this.uriTransformer=I,this.logService=g,this.environmentService=f,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(I){const w=this._register(new v.Emitter);this._register(w.event(g=>{I.fire(g.map(f=>({resource:this.uriTransformer.transformOutgoingURI(f.resource),type:f.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>w.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>I.fire(g)))}getRecursiveWatcherOptions(I){}getExtraExcludes(I){}watch(I,w,g){const f=this.getExtraExcludes(this.environmentService);return Array.isArray(f)&&(g.excludes=[...g.excludes,...f]),this.watcherRequests.set(I,this.fileWatcher.watch(w,g)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(I)),this.watcherRequests.delete(I)})}dispose(){super.dispose();for(const[,I]of this.watcherRequests)I.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(J[206],Z([0,1,15,162,5,7,14,9,205,140]),function(q,e,v,t,k,R,M,S,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class E extends l.AbstractDiskFileSystemProviderChannel{constructor(g,f,C){super(g,f),this.environmentService=C}getUriTransformer(g){return m.DefaultURITransformer}transformIncoming(g,f){return R.URI.revive(f)}async delete(g,f,C){if(!C.useTrash)return super.delete(g,f,C);const b=this.transformIncoming(g,f),p=(0,S.normalize)(b.fsPath);try{await v.shell.trashItem(p)}catch{throw(0,M.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,S.basename)(p)):(0,t.localize)(1,null,(0,S.basename)(p)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,f){return new I(g,f,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=E;class I extends l.AbstractSessionFileWatcher{watch(g,f,C){if(C.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(g,f,C)}}}),define(J[104],Z([0,1,6]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(M=v.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(S=>{this._logger?.setLevel(S)}))}set logger(M){this._logger=M;for(const{level:S,args:l}of this.buffer)t(M,S).apply(M,l);this.buffer=[]}_log(M,...S){this._logger?t(this._logger,M).apply(this._logger,S):this.getLevel()<=M&&this.buffer.push({level:M,args:S})}trace(M,...S){this._log(v.LogLevel.Trace,M,...S)}debug(M,...S){this._log(v.LogLevel.Debug,M,...S)}info(M,...S){this._log(v.LogLevel.Info,M,...S)}warn(M,...S){this._log(v.LogLevel.Warning,M,...S)}error(M,...S){this._log(v.LogLevel.Error,M,...S)}critical(M,...S){this._log(v.LogLevel.Critical,M,...S)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(J[207],Z([0,1,8,17,16,14,4,104,6]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let E=class extends l.AbstractLogger{constructor(g,f,C,b,p){super(),this.name=g,this.resource=f,this.donotUseFormatters=b,this.fileService=p,this.backupIndex=1,this.setLevel(C),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=l.LogLevel.Trace&&this._log(l.LogLevel.Trace,(0,l.format)(arguments))}debug(){this.getLevel()<=l.LogLevel.Debug&&this._log(l.LogLevel.Debug,(0,l.format)(arguments))}info(){this.getLevel()<=l.LogLevel.Info&&this._log(l.LogLevel.Info,(0,l.format)(arguments))}warn(){this.getLevel()<=l.LogLevel.Warning&&this._log(l.LogLevel.Warning,(0,l.format)(arguments))}error(){if(this.getLevel()<=l.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=g.stack,this._log(l.LogLevel.Error,(0,l.format)(f))}else this._log(l.LogLevel.Error,(0,l.format)(arguments))}}critical(){this.getLevel()<=l.LogLevel.Critical&&this._log(l.LogLevel.Critical,(0,l.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,f){this.queue.queue(async()=>{await this.initializePromise;let C=await this.loadContent();C.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(C)),C=""),this.donotUseFormatters?C+=f:C+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${f}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(C))})}getCurrentTimestamp(){const g=b=>b<10?`0${b}`:b,f=b=>b<10?`00${b}`:b<100?`0${b}`:b,C=new Date;return`${C.getFullYear()}-${g(C.getMonth()+1)}-${g(C.getDate())} ${g(C.getHours())}:${g(C.getMinutes())}:${g(C.getSeconds())}.${f(C.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case l.LogLevel.Critical:return"critical";case l.LogLevel.Debug:return"debug";case l.LogLevel.Error:return"error";case l.LogLevel.Info:return"info";case l.LogLevel.Trace:return"trace";case l.LogLevel.Warning:return"warning"}return""}};E=ve([X(4,R.IFileService)],E),e.FileLogger=E;let I=class extends l.AbstractLoggerService{constructor(g,f,C){super(g.getLevel(),g.onDidChangeLogLevel),this.instantiationService=f,this.fileService=C}doCreateLogger(g,f,C){const b=new S.BufferLogService(f);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(E,C?.name||(0,k.basename)(g),g,b.getLevel(),!!C?.donotUseFormatters)),b}};I=ve([X(0,l.ILogService),X(1,M.IInstantiationService),X(2,R.IFileService)],I),e.FileLoggerService=I}),define(J[208],Z([0,1,3,7,6]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(w){this.service=w,this.onDidChangeLogLevel=v.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(w,g,f){switch(g){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class M{constructor(w){this.channel=w}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(w){M.setLevel(this.channel,w)}static setLevel(w,g){return w.call("setLevel",g)}}e.LogLevelChannelClient=M;class S{constructor(w){this.loggerService=w,this.loggers=new Map}listen(w,g){throw new Error(`Event not found: ${g}`)}async call(w,g,f){switch(g){case"createLogger":this.createLogger(t.URI.revive(f[0]),f[1]);return;case"log":return this.log(t.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${g}`)}createLogger(w,g){this.loggers.set(w.toString(),this.loggerService.createLogger(w,g))}consoleLog(w,g){let f=console.log;switch(w){case k.LogLevel.Error:f=console.error;break;case k.LogLevel.Warning:f=console.warn;break;case k.LogLevel.Info:f=console.info;break}f.call(console,...g)}log(w,g){const f=this.loggers.get(w.toString());if(!f)throw new Error("Create the logger before logging");for(const[C,b]of g)(0,k.log)(f,C,b)}}e.LoggerChannel=S;class l extends k.AbstractLoggerService{constructor(w,g,f){super(w,g),this.channel=f}createConsoleMainLogger(){return new k.AdapterLogger({log:(w,g)=>{this.channel.call("consoleLog",[w,g])}})}doCreateLogger(w,g,f){return new m(this.channel,w,g,f)}}e.LoggerChannelClient=l;class m extends k.AbstractMessageLogger{constructor(w,g,f,C){super(C?.always),this.channel=w,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[g,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,g){const f=[[w,g]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(w){this.channel.call("log",[this.file,w])}}class E extends k.LogService{constructor(w,g){super(g),this.parent=w,this._register(w.onDidChangeLogLevel(f=>g.setLevel(f)))}setLevel(w){super.setLevel(w),this.parent.setLevel(w)}}e.FollowerLogService=E}),define(J[105],Z([0,1,14,6]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(S,l,m,E,I){try{const w=await new Promise((f,C)=>{q(["spdlog"],f,C)});w.setFlushOn(t.LogLevel.Trace);const g=await w.createAsyncRotatingLogger(S,l,m,E);return I&&g.clearFormatters(),g}catch(w){console.error(w)}return null}function R(S,l,m){switch(l){case t.LogLevel.Trace:S.trace(m);break;case t.LogLevel.Debug:S.debug(m);break;case t.LogLevel.Info:S.info(m);break;case t.LogLevel.Warning:S.warn(m);break;case t.LogLevel.Error:S.error(m);break;case t.LogLevel.Critical:S.critical(m);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(l,m,E,I,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(l,m,E,I),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(l,m,E,I){const w=E?6:1,g=30/w*v.ByteSize.MB,f=await k(l,m,g,w,I);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:C,message:b}of this.buffer)R(this._logger,C,b);this.buffer=[]}}log(l,m){this._logger?R(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(J[209],Z([0,1,13,16,28,14,207,6,105]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends S.AbstractLoggerService{constructor(I,w){super(I.getLevel(),I.onDidChangeLogLevel),this.fileService=w}doCreateLogger(I,w,g){return I.scheme===v.Schemas.file?new l.SpdLogLogger(g?.name||(0,k.generateUuid)(),I.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,w):new M.FileLogger(g?.name??(0,t.basename)(I),I,w,!!g?.donotUseFormatters,this.fileService)}};m=ve([X(0,S.ILogService),X(1,R.IFileService)],m),e.LoggerService=m}),define(J[210],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(M){return!v(M)&&!t(M)&&!k(M)}e.isMenubarMenuItemAction=R}),define(J[37],Z([0,1,3,65,2,4]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(I,[w,g])=>({...I,[w]:g}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[E,I])=>({...m,[E]:{definition:I,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=M;class S{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(J[211],Z([0,1,8,3,65,12,14,6,37]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(I,w){const g=[];for(const f of k.Iterable.concat(I.keys(),w.keys()))I.get(f)!==w.get(f)&&g.push(f);return g}let E=class extends l.AbstractPolicyService{constructor(w,g,f){super(),this.file=w,this.fileService=g,this.logService=f,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const C=t.Event.filter(g.onDidFilesChange,b=>b.affects(w));this._register(g.watch(w)),this._register(C(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(w){await this.refresh()}async read(){const w=new Map;try{const g=await this.fileService.readFile(this.file),f=JSON.parse(g.value.toString());if(!(0,R.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const C of Object.keys(f))this.policyDefinitions[C]&&w.set(C,f[C])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return w}async refresh(){const w=await this.read(),g=m(this.policies,w);this.policies=w,g.length>0&&this._onDidChange.fire(g)}};E=ve([X(1,M.IFileService),X(2,S.ILogService)],E),e.FilePolicyService=E}),define(J[212],Z([0,1,3,2,37]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(l){this.service=l,this.disposables=new t.DisposableStore}listen(l,m){switch(m){case"onDidChange":return v.Event.map(this.service.onDidChange,E=>E.reduce((I,w)=>({...I,[w]:this.service.getPolicyValue(w)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(l,m,E){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends k.AbstractPolicyService{constructor(l,m){super(),this.channel=m;for(const E in l){const{definition:I,value:w}=l[E];this.policyDefinitions[E]=I,w!==void 0&&this.policies.set(E,w)}this.channel.listen("onDidChange")(E=>{for(const I in E){const w=E[I];w===null?this.policies.delete(I):this.policies.set(I,w)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(l){const m=await this.channel.call("registerPolicyDefinitions",l);for(const E in m)this.policies.set(E,m[E])}}e.PolicyChannelClient=M}),define(J[53],Z([0,1,13,5,34,16]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const S=t.globals.vscode.context.configuration();if(S)M=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const S=(0,R.dirname)(v.FileAccess.asFileUri("",q));M=q.__$__nodeRequire((0,R.joinPath)(S,"product.json").fsPath);const l=q.__$__nodeRequire((0,R.joinPath)(S,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:l.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(J[20],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[213],Z([0,1,74,6,20]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(S,l){this.productService=S,this.logService=l,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(S,l){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(l);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",l),!1;const[,E,I]=m;let w=this.trustedExtensionUrlPublicKeys.get(S);if(!w){if(w=this.productService.trustedExtensionUrlPublicKeys[S],!w||w.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.trustedExtensionUrlPublicKeys.set(S,[...w])}const g=Buffer.from(decodeURIComponent(I),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",l),!1;const f=g.slice(0,6),C=g.readUIntBE(0,6),b=Date.now()-C;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",l),!1;const p=g.slice(6),y=v.createVerify("SHA256");y.write(f),y.write(Buffer.from(E)),y.end();for(let d=0;d<w.length;d++){let h=w[d];if(h!==null){if(typeof h=="string")try{h=v.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),w[d]=h}catch(a){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${S}:`,a),w[d]=null;continue}if(y.verify(h,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",l),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",l),!1}};R=ve([X(0,k.IProductService),X(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(J[60],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(J[44],Z([0,1,119,12]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(M,S){v.ok(t.isString(M)),v.ok(t.isObject(S)),v.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,S)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new k}),define(J[214],Z([0,1,3,44]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[k(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(J[61],Z([0,1,23,3,12,150,19,214,44]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=l.Registry.as(S.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=this.doRegisterConfigurations(i,o);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=[];r.push(...this.doDeregisterConfigurations(o)),r.push(...this.doRegisterConfigurations(i,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(r)})}registerDefaultConfigurations(i){const o=[],r=[];for(const{overrides:n,source:s}of i)for(const c in n)if(o.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const u=this.configurationDefaultsOverrides.get(c),P=u?.valuesSources??new Map;if(s)for(const U of Object.keys(n[c]))P.set(U,s);const D={...u?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:D,valuesSources:P});const T=(0,M.getLanguageTagSettingPlainKey)(c),_={type:"object",default:D,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(s)?void 0:s,defaultValueSource:s};r.push(...C(c)),this.configurationProperties[c]=_,this.defaultLanguageConfigurationOverridesNode.properties[c]=_}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:s});const u=this.configurationProperties[c];u&&(this.updatePropertyDefaultValue(c,u),this.updateSchema(c,u))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:r,source:n}of i)for(const s in r){const c=this.configurationDefaultsOverrides.get(s),u=k.isString(n)?n:n?.id,P=k.isString(c?.source)?c?.source:c?.source?.id;if(u===P)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const D=this.configurationProperties[s];D&&(this.updatePropertyDefaultValue(s,D),this.updateSchema(s,D))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const r=[];return i.forEach(n=>{r.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),r}doDeregisterConfigurations(i){const o=[],r=n=>{if(n.properties)for(const s in n.properties){o.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>r(s))};for(const n of i){r(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,r,n,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const c=[],u=i.properties;if(u)for(const D in u){const T=u[D];if(o&&d(D,T)){delete u[D];continue}if(T.source=r,T.defaultDefaultValue=u[D].default,this.updatePropertyDefaultValue(D,T),e.OVERRIDE_PROPERTY_REGEX.test(D)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!n?.includes(D):T.restricted),u[D].hasOwnProperty("included")&&!u[D].included){this.excludedConfigurationProperties[D]=u[D],delete u[D];continue}else this.configurationProperties[D]=u[D],u[D].policy?.name&&this.policyConfigurations.set(u[D].policy.name,D);!u[D].deprecationMessage&&u[D].markdownDeprecationMessage&&(u[D].deprecationMessage=u[D].markdownDeprecationMessage),c.push(D)}const P=i.allOf;if(P)for(const D of P)c.push(...this.validateAndRegisterProperties(D,o,r,n,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=r=>{const n=r.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);r.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,r),e.allSettings.properties[o]=r,e.applicationSettings.properties[o]=r,e.machineSettings.properties[o]=r,e.machineOverridableSettings.properties[o]=r,e.windowSettings.properties[o]=r,e.resourceSettings.properties[o]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const r=this.configurationDefaultsOverrides.get(i);let n=r?.value,s=r?.source;k.isUndefined(n)&&(n=o.defaultDefaultValue,s=void 0),k.isUndefined(n)&&(n=p(o.type)),o.default=n,o.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",f=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(a){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=f.exec(a);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=f.exec(a)}}return(0,v.distinct)(i)}e.overrideIdentifiersFromKey=C;function b(a){return a.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=b;function p(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const y=new w;l.Registry.add(e.Extensions.Configuration,y);function d(a,i){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?R.localize(7,null,a):y.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):i.policy?.name&&y.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,a,i.policy?.name,y.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=d;function h(){const a=[],i=y.getConfigurationProperties();for(const o of Object.keys(i))a.push([o,i[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=h}),define(J[106],Z([0,1,23,3,48,2,32,49,12,7,19,61,44]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(i={},o=[],r=[]){this._contents=i,this._keys=o,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,E.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const r=this.getContentsForOverrideIdentifer(o);return r?i?(0,E.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const r of this.overrides)r.identifiers.includes(i)&&o.push(...r.keys);return v.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return v.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=S.deepClone(this.contents),r=S.deepClone(this.overrides),n=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const c of s.overrides){const[u]=r.filter(P=>v.equals(P.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=v.distinct(u.keys)):r.push(S.deepClone(c))}for(const c of s.keys)n.indexOf(c)===-1&&n.push(c)}return new g(o,n,r)}freeze(){return this.frozen=!0,this}clone(){return new g(S.deepClone(this.contents),[...this.keys],S.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const r={};for(const n of v.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[n];const c=o[n];c&&(typeof s=="object"&&typeof c=="object"?(s=S.deepClone(s),this.mergeContents(s,c)):s=c),r[n]=s}return new g(r,this.keys,this.overrides)}mergeContents(i,o){for(const r of Object.keys(o)){if(r in i&&l.isObject(i[r])&&l.isObject(o[r])){this.mergeContents(i[r],o[r]);continue}i[r]=S.deepClone(o[r])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?S.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,r=null;const n=s=>{s&&(r?this.mergeContents(r,s):r=S.deepClone(s))};for(const s of this.overrides)v.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&n(s.contents);return n(o),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,E.addToValueTree)(this.contents,i,o,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,E.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let r=0;r<o;r++)i.indexOf(this.keys[r])===0&&(o=r);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=g;class f{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!l.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:r,keys:n,overrides:s,restricted:c}=this.doParseRaw(i,o);this._configurationModel=new g(r,n,s),this._restrictedConfigurations=c||[]}doParseContent(i){let o={},r=null,n=[];const s=[],c=[];function u(D){Array.isArray(n)?n.push(D):r!==null&&(n[r]=D)}const P={onObjectBegin:()=>{const D={};u(D),s.push(n),n=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const D=[];u(D),s.push(n),n=D,r=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:u,onError:(D,T,_)=>{c.push({error:D,offset:T,length:_})}};if(i)try{k.visit(i,P),o=n[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return o}doParseRaw(i,o){const r=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,r,!0,o);i=n.raw;const s=(0,E.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(i),u=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:c,overrides:u,restricted:n.restricted}}filter(i,o,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[]};const s={},c=[];for(const u in i)if(I.OVERRIDE_PROPERTY_REGEX.test(u)&&r){const P=this.filter(i[u],o,!1,n);s[u]=P.raw,c.push(...P.restricted)}else{const P=o[u],D=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&c.push(u),(D===void 0||n.scopes===void 0||n.scopes.includes(D))&&(n.skipRestricted&&P?.restricted||(s[u]=i[u]))}return{raw:s,restricted:c}}toOverrides(i,o){const r=[];for(const n of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const c in i[n])s[c]=i[n][c];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,E.toValuesTree)(s,o)})}return r}}e.ConfigurationModelParser=f;class C extends R.Disposable{constructor(i,o,r,n){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=n,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=C;class b{constructor(i,o,r,n,s=new g,c=new g,u=new M.ResourceMap,P=new g,D=new M.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=P,this._memoryConfigurationByResource=D,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(i,o,r){return this.getConsolidatedConfigurationModel(i,o,r).getValue(i)}updateValue(i,o,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new g,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,o===void 0?n.removeValue(i):n.setValue(i,o),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,r){const n=this.getConsolidatedConfigurationModel(i,o,r),s=this.getFolderConfigurationModelForResource(o.resource,r),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,u=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),D=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),T=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),Q=r?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,re=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,le=o.overrideIdentifier?c.override(o.overrideIdentifier).getValue(i):c.getValue(i),ue=n.getValue(i),se=v.distinct(n.overrides.map(fe=>fe.identifiers).flat()).filter(fe=>n.getOverrideValue(i,fe)!==void 0);return{defaultValue:u,policyValue:P,applicationValue:D,userValue:T,userLocalValue:_,userRemoteValue:U,workspaceValue:Q,workspaceFolderValue:re,memoryValue:le,value:ue,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:D!==void 0?{value:D,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:s?.freeze().getValue(i),override:o.overrideIdentifier?s?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:le!==void 0?{value:c.getValue(i),override:o.overrideIdentifier?c.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const r=[];if(!o){const{added:n,updated:s,removed:c}=d(this._defaultConfiguration,i);o=[...n,...s,...c]}for(const n of o)for(const s of(0,I.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=i.getKeysForOverrideIdentifier(s),P=[...u.filter(D=>c.indexOf(D)===-1),...c.filter(D=>u.indexOf(D)===-1),...c.filter(D=>!S.equals(this._defaultConfiguration.override(s).getValue(D),i.override(s).getValue(D)))];r.push([s,P])}return this.updateDefaultConfiguration(i),{keys:o,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:r,removed:n}=d(this._policyConfiguration,i),s=[...o,...r,...n];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:r,removed:n,overrides:s}=d(this.applicationConfiguration,i),c=[...o,...r,...n];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:r,removed:n,overrides:s}=d(this.localUserConfiguration,i),c=[...o,...r,...n];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:r,removed:n,overrides:s}=d(this.remoteUserConfiguration,i),c=[...o,...r,...n];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:r,removed:n,overrides:s}=d(this.workspaceConfiguration,i),c=[...o,...r,...n];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const r=this.folderConfigurations.get(i),{added:n,updated:s,removed:c,overrides:u}=d(r,o),P=[...n,...s,...c];return(P.length||!r)&&this.updateFolderConfiguration(i,o),{keys:P,overrides:u}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:n,removed:s,overrides:c}=d(o,void 0);return{keys:[...r,...n,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,r){let n=this.getConsolidatedConfigurationModelForResource(o,r);return o.overrideIdentifier&&(n=n.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},o){let r=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const n=o.getFolder(i);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const s=this._memoryConfigurationByResource.get(i);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(o=r.merge(n),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=r}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const r=o.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:r,overrides:n,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:r,overrides:n,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((P,D)=>(P.set(m.URI.revive(D[0]),this.parseConfigurationModel(D[1])),P),new M.ResourceMap);return new b(o,r,n,s,new g,c,u,new g,new M.ResourceMap,!1)}static parseConfigurationModel(i){return new g(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=b;function p(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,o=new Map;for(const n of a)n.keys.forEach(s=>i.add(s)),n.overrides.forEach(([s,c])=>{const u=(0,M.getOrSet)(o,s,new Set);c.forEach(P=>u.add(P))});const r=[];return o.forEach((n,s)=>r.push([s,[...n.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class y{constructor(i,o,r,n){this.change=i,this.previous=o,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(u=>s.add(u)),i.overrides.forEach(([,u])=>u.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const c=new g;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!S.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let r=(0,E.toValuesTree)({[o]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(i=i[n],!i)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=y;function d(a,i){const{added:o,removed:r,updated:n}=h(i,a),s=[],c=a?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const P=u.filter(D=>!c.includes(D));for(const D of P)s.push([D,i.getKeysForOverrideIdentifier(D)])}if(a){const P=c.filter(D=>!u.includes(D));for(const D of P)s.push([D,a.getKeysForOverrideIdentifier(D)])}if(i&&a){for(const P of c)if(u.includes(P)){const D=h({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});s.push([P,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:r,updated:n,overrides:s}}function h(a,i){const o=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],r=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],n=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const c=(0,E.getConfigurationValue)(i.contents,s),u=(0,E.getConfigurationValue)(a.contents,s);S.equals(c,u)||n.push(s)}}return{added:o,removed:r,updated:n}}}),define(J[215],Z([0,1,23,3,2,49,12,19,106,61,6,37,44]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(w.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:d})=>this.onDidUpdateConfiguration(y,d))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(y,d){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:y})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class f extends l.ConfigurationModel{constructor(y={}){const d=w.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(d),a=Object.create(null),i=[];for(const o in d){const r=y[o],n=r!==void 0?r:d[o].default;(0,S.addToValueTree)(a,o,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(a))m.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(a[o]),contents:(0,S.toValuesTree)(a[o],r=>console.error(`Conflict in default settings file: ${r}`))});super(a,h,i)}}e.DefaultConfigurationModel=f;class C{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=C;let b=class extends k.Disposable{constructor(y,d,h){super(),this.defaultConfiguration=y,this.policyService=d,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(y=>this.onDidChangePolicies(y))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:y})=>this.update(await this.registerPolicyDefinitions(y),!0))),this._configurationModel}async registerPolicyDefinitions(y){const d={},h=[],a=w.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of y){const o=a[i];if(!o){h.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}h.push(i),d[o.policy.name]={type:o.type}}}return(0,M.isEmptyObject)(d)||await this.policyService.registerPolicyDefinitions(d),h}onDidChangePolicies(y){const d=w.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),h=(0,v.coalesce)(y.map(a=>d.get(a)));this.update(h,!0)}update(y,d){const h=w.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),a=[],i=this._configurationModel.isEmpty();for(const o of y){const r=h[o]?.policy?.name;if(r){const n=this.policyService.getPolicyValue(r);(i?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),n))&&a.push([o,n])}else this._configurationModel.getValue(o)!==void 0&&a.push([o,void 0])}if(a.length){const o=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const r of o.keys)this._configurationModel.setValue(r,o.getValue(r));for(const[r,n]of a)n===void 0?this._configurationModel.removeValue(r):this._configurationModel.setValue(r,n);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=ve([X(1,I.IPolicyService),X(2,E.ILogService)],b),e.PolicyConfiguration=b}),define(J[216],Z([0,1,8,3,2,16,19,106,215,37]),function(q,e,v,t,k,R,M,S,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends k.Disposable{constructor(w,g,f,C){super(),this.settingsResource=w,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=f instanceof m.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,f,C)),this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new S.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:p})=>this.onDidDefaultConfigurationChange(b,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[w,g,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new S.Configuration(w,g,new S.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(w,g){const f=typeof w=="string"?w:void 0,C=(0,M.isConfigurationOverrides)(w)?w:(0,M.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(f,C,void 0)}updateValue(w,g,f,C){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const g=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(f,g,2)}onDidDefaultConfigurationChange(w,g){const f=this.configuration.toData(),C=this.configuration.compareAndUpdateDefaultConfiguration(w,g);this.trigger(C,f,7)}onDidPolicyConfigurationChange(w){const g=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(w);this.trigger(f,g,7)}trigger(w,g,f){const C=new S.ConfigurationChangeEvent(w,{data:g},this.configuration);C.source=f,C.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(w){switch(w){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(J[217],Z([0,1,18,4]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{constructor(S,l=k.Unknown,m){super(S),this._message=S,this._code=l,this._detail=m,this.isHandled=l===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(S){return S instanceof R&&S._code===k.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof R&&S._code===k.NoResolverFound}static isHandled(S){return S instanceof R&&S.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[62],Z([0,1,13]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(m){const{host:E,port:I}=l(m);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:I}}e.parseAuthorityWithPort=M;function S(m,E){let{host:I,port:w}=l(m);return typeof w>"u"&&(w=E),{host:I,port:w}}e.parseAuthorityWithOptionalPort=S;function l(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=m.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:m,port:void 0}}}),define(J[107],Z([0,1,24,4,62]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=R;function M(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var l;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(l=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,b){if(typeof C>"u"||C===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof C=="string"||typeof b=="string"){const p=typeof C=="string"?C:C.value,y=typeof b=="string"?b:b.value;return v.equalsIgnoreCase(p,y)}return C._lower===b._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=m;function E(f){return I(f)}e.isApplicationScopedExtension=E;function I(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function w(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function g(f,C){if(C){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(C)}`;return f.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[108],Z([0,1,24,192,107,5,7,18,34]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,r){return o.uuid&&r.uuid?o.uuid===r.uuid:o.id===r.id?!0:(0,v.compareIgnoreCase)(o.id,r.id)===0}e.areSameExtensions=m;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(r,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=r.id}static create(r){const n=r.manifest?r.manifest.version:r.version,s=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new I(r.identifier,n,s)}static parse(r){const n=E.exec(r);return n&&n[1]&&n[2]?new I({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof I?m(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=I;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const r=w.exec(o);return r&&r[1]?[C(r[1]),r[2]]:[C(o),void 0]}e.getIdAndVersion=g;function f(o,r){return`${o}.${r}`}e.getExtensionId=f;function C(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function b(o,r){return C(f(o,r))}e.getGalleryExtensionId=b;function p(o,r){const n=[],s=c=>{for(const u of n)if(u.some(P=>m(r(P),r(c))))return u;return null};for(const c of o){const u=s(c);u?u.push(c):n.push([c])}return n}e.groupByExtension=p;function y(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function d(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(o,r){const n=[],s=r.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&n.every(u=>!m(u.identifier,{id:c}))){const u=o.filter(P=>m(P.identifier,{id:c}));u.length===1&&(n.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=h;async function a(o,r){if(!R.isLinux)return!1;let n;try{n=(await o.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){r.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function i(o,r){const n=await a(o,r),s=(0,t.getTargetPlatform)(n?"alpine":R.platform,l.arch);return r.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(J[71],Z([0,1,8,17,2,32,7,108,14,4,6]),function(q,e,v,t,k,R,M,S,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let I=class extends k.Disposable{constructor(g,f){super(),this.fileService=g,this.logService=f,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,f){return this.withProfileExtensions(f,C=>(C=C.filter(b=>g.some(([p])=>!(0,S.areSameExtensions)(b.identifier,p.identifier))),C.push(...g.map(([b,p])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p}))),C))}removeExtensionFromProfile(g,f){return this.withProfileExtensions(f,C=>C.filter(b=>!(0,S.areSameExtensions)(b.identifier,g)))}async withProfileExtensions(g,f){return this.getResourceAccessQueue(g).queue(async()=>{let C=[];try{const b=await this.fileService.readFile(g),p=JSON.parse(b.value.toString());for(const y of p){if(!y.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",y);continue}if(!y.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",y);continue}if(!y.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",y);continue}C.push({identifier:y.identifier,location:M.URI.revive(y.location),version:y.version,metadata:y.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(f){C=f(C);const b=C.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(g,t.VSBuffer.fromString(JSON.stringify(b)))}return C})}getResourceAccessQueue(g){let f=this.resourcesAccessQueueMap.get(g);return f||(f=new v.Queue,this.resourcesAccessQueueMap.set(g,f)),f}};I=ve([X(0,l.IFileService),X(1,E.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(J[218],Z([0,1,8,17,22,18,3,2,28,96,217,62]),function(q,e,v,t,k,R,M,S,l,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var g;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function f(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function C(B){const H=new k.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function b(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class p{constructor(H){this._state="pending",this._disposables=new S.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function y(B,H){const L=new p(H);return L.registerDisposable(B.onControlMessage(O=>{const N=JSON.parse(O.toString()),V=F(N);V?L.reject(V):L.resolve(N)})),L.promise}function d(B,H,L,O,N,V,x,ne){const j=new p(ne);return H.connect(L,O,N,V,x,(te,ie)=>{j.didTimeout?(te&&B.error(te),ie?.dispose()):te||!ie?j.reject(te):j.resolve(ie)}),j.promise}function h(B,H){const L=new p(H);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function a(B,H,L,O){const N=z(B,H);B.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await d(B.logService,B.socketFactory,B.host,B.port,(0,I.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${f(H)}-${B.reconnectionToken}`,O)}catch(ie){throw B.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ie),ie}B.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let x,ne;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),x=B.reconnectionProtocol,ne=!1):(x=new m.PersistentProtocol(V,null),ne=!0),B.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const j=await h(B.signService.createNewMessage((0,l.generateUuid)()),O),te={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ie=await y(x,b(O,C(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(B.logService.trace(`${N} 4/6. received SignRequest control message.`),!await h(B.signService.validate(j,ie.signedData),O)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const de=await h(B.signService.sign(ie.data),O),ge={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:H};return L&&(ge.args=L),B.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(ge))),{protocol:x,ownsProtocol:ne}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(B.logService.error(`${N} the handshake timed out. Error:`),B.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${N} received error control message when negotiating connection. Error:`),B.logService.error(ie)),ne&&$(x),ie}}async function i(B,H,L,O){const N=Date.now(),V=z(B,H),{protocol:x,ownsProtocol:ne}=await a(B,H,L,O),j=new p(O);return j.registerDisposable(x.onControlMessage(te=>{const ie=JSON.parse(te.toString()),ae=F(ie);ae?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ae),ne&&$(x),j.reject(ae)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ee(N)}!`),j.resolve({protocol:x,firstMessage:ie}))})),j.promise}async function o(B,H){const{protocol:L}=await i(B,1,void 0,H);return{protocol:L}}async function r(B,H,L){const{protocol:O,firstMessage:N}=await i(B,2,H,L),V=N&&N.debugPort;return{protocol:O,debugPort:V}}async function n(B,H,L){const O=Date.now(),N=z(B,3),{protocol:V}=await a(B,3,H,L);return B.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ee(O)}!`),V}async function s(B,H,L){const{host:O,port:N,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:N,connectionToken:V,reconnectionToken:H,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,H,L){return P(B,async O=>{const{protocol:N}=await o(O,k.CancellationToken.None);return new fe(B,H,L,O.reconnectionToken,N)})}e.connectRemoteAgentManagement=c;async function u(B,H){return P(B,async L=>{const{protocol:O,debugPort:N}=await r(L,H,k.CancellationToken.None);return new K(B,H,L.reconnectionToken,O,N)})}e.connectRemoteAgentExtensionHost=u;async function P(B,H){for(let O=1;;O++)try{const N=(0,l.generateUuid)(),V=await s(B,N,null);return await H(V)}catch(N){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(N);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(N),se.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(N)),N}}async function D(B,H,L){const O=await s(B,(0,l.generateUuid)(),null);return await n(O,{host:H,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function T(B){return(0,v.createCancelablePromise)(H=>new Promise((L,O)=>{const N=setTimeout(L,B*1e3);H.onCancellationRequested(()=>{clearTimeout(N),L()})}))}var _;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class Q{constructor(H,L,O,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=Q;class re{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=re;class le{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=le;class ue{constructor(H,L,O,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends S.Disposable{constructor(H,L,O,N,V){super(),this._connectionType=H,this._options=L,this.reconnectionToken=O,this.protocol=N,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(N.onSocketClose(x=>{const ne=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(x=>{const ne=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,S.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(H,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const N=O<L.length?L[O]:L[L.length-1];try{if(N>0){const x=T(N);this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,x)),this._options.logService.info(`${H} waiting for ${N} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${H} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,C(w)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,E.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(H,L,O):this._gotoPermanentFailure(H,L,O)}_gotoPermanentFailure(H,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,H,L,O)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class fe extends se{constructor(H,L,O,N,V){super(1,H,N,V,!0),this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:O},H.ipcLogger))}async _reconnect(H,L){await o(H,L)}}e.ManagementPersistentConnection=fe;class K extends se{constructor(H,L,O,N,V){super(2,H,O,N,!1),this._startArguments=L,this.debugPort=V}async _reconnect(H,L){await r(H,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function $(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,R.onUnexpectedError)(H)}}function F(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function A(B,H){for(;B.length<H;)B+=" ";return B}function W(B,H,L){return`[remote-connection][${A(f(B),13)}][${H.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,H){return`${W(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ee(B){return`${Date.now()-B} ms`}}),define(J[219],Z([0,1,75,80]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,M,S,l,m){const E=w=>m(w,void 0),I=v.createConnection({host:k,port:R},()=>{I.removeListener("error",E);const w=Buffer.alloc(16);for(let b=0;b<16;b++)w[b]=Math.round(Math.random()*256);const g=w.toString("base64"),f=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${M}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];I.write(f.join(`\r
`)+`\r
\r
`);const C=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",C),m(void 0,new t.NodeSocket(I,l)))};I.on("data",C)});I.setNoDelay(!0),I.once("error",E)}}}),define(J[54],Z([0,1,17,167,61,4,44]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function S(C){return C.res.statusCode&&C.res.statusCode>=200&&C.res.statusCode<300||C.res.statusCode===1223}e.isSuccess=S;function l(C){return C.res.statusCode===204}async function m(C){return l(C)?null:(await(0,v.streamToBuffer)(C.stream)).toString()}e.asText=m;async function E(C){if(!S(C))throw new Error("Server returned "+C.res.statusCode);return m(C)}e.asTextOrError=E;async function I(C){if(!S(C))throw new Error("Server returned "+C.res.statusCode);if(l(C))return null;const p=(await(0,v.streamToBuffer)(C.stream)).toString();try{return JSON.parse(p)}catch(y){throw y.message+=`:
`+p,y}}e.asJson=I;function w(C){f(C)}e.updateProxyConfigurationsScope=w;let g;function f(C){const b=M.Registry.as(k.Extensions.Configuration),p=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:C,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[g],remove:p?[p]:[]})}f(2)}),define(J[220],Z([0,1,17,22]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(S){this.service=S}listen(S,l){throw new Error("Invalid listen")}call(S,l,m,E=t.CancellationToken.None){switch(l){case"request":return this.service.request(m[0],E).then(async({res:I,stream:w})=>{const g=await(0,v.streamToBuffer)(w);return[{statusCode:I.statusCode,headers:I.headers},g]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(S){this.channel=S}async request(S,l){const[m,E]=await this.channel.call("request",[S],l);return{res:m,stream:(0,v.bufferToStream)(E)}}async resolveProxy(S){return this.channel.call("resolveProxy",[S])}}e.RequestChannelClient=R}),define(J[221],Z([0,1,222,12]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(M,S){return M.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:M.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function R(M,S,l={}){const m=(0,v.parse)(M),E=l.proxyUrl||k(m,S);if(!E)return null;const I=(0,v.parse)(E);if(!/^https?:$/.test(I.protocol||""))return null;const w={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,t.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((g,f)=>{q(["http-proxy-agent"],g,f)}))(w):new(await new Promise((g,f)=>{q(["https-proxy-agent"],g,f)}))(w)}e.getProxyAgent=R}),define(J[109],Z([0,1,50,9,168,22,43,18,5,28,144,58,8]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let f;async function C(p,y,d){return y["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(d)&&!y["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(d)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=w.Promises.withAsyncBody(async(h,a)=>{const i=new R.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),a(new Error((0,k.localize)(0,null)))},g);try{h(await b(p,i.token))}catch(r){!(0,S.isCancellationError)(r)&&!i.token.isCancellationRequested?a(new Error((0,k.localize)(1,null,(0,M.toErrorMessage)(r)))):h({})}finally{clearTimeout(o),i.dispose()}})),f)}e.getResolvedShellEnv=C;async function b(p,y){const d=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",d);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",h);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const r=await(0,E.getSystemShell)(l.OS,o);return p.trace("getUnixShellEnvironment#shell",r),new Promise((n,s)=>{if(y.isCancellationRequested)return s((0,S.canceled)());const c=(0,t.basename)(r);let u,P;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):(u=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?P=["-ic"]:P=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),u);const T=(0,v.spawn)(r,[...P,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});y.onCancellationRequested(()=>(T.kill(),s((0,S.canceled)()))),T.on("error",Q=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(Q)),s(Q)});const _=[];T.stdout.on("data",Q=>_.push(Q));const U=[];T.stderr.on("data",Q=>U.push(Q)),T.on("close",(Q,re)=>{const le=Buffer.concat(_).toString("utf8");p.trace("getUnixShellEnvironment#raw",le);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&p.trace("getUnixShellEnvironment#stderr",ue),Q||re)return s(new Error((0,k.localize)(2,null,Q,re)));const se=i.exec(le),fe=se?se[1]:"{}";try{const K=JSON.parse(fe);d?K.ELECTRON_RUN_AS_NODE=d:delete K.ELECTRON_RUN_AS_NODE,h?K.ELECTRON_NO_ATTACH_CONSOLE=h:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",K),n(K)}catch(K){p.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(K)),s(K)}})})}}),define(J[84],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[223],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),M=new R.validator;if(M){const S=String(v._nextId++);return this.validators.set(S,M),{id:S,data:M.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const M=this.validators.get(k.id);if(!M)return!1;this.validators.delete(k.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(k)}catch{}return k}}e.SignService=v,v._nextId=1}),define(J[41],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(J[21],Z([0,1,15,40,8,3,2,5,34,12,4,6,41,26]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var f;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(f=e.ShutdownReason||(e.ShutdownReason={}));var C;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(C=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class bt extends M.Disposable{constructor(y,d,h){super(),this.logService=y,this.stateMainService=d,this.environmentMainService=h,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(bt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(bt.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",y);const d=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",d),v.app.once("will-quit",h=>{this.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",y),v.app.removeListener("window-all-closed",d),v.app.quit()})})}fireOnWillShutdown(y){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const d=[];return this._onWillShutdown.fire({reason:y,join(h){d.push(h)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(d)}catch(h){this.logService.error(h)}try{await this.stateMainService.close()}catch(h){this.logService.error(h)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const d=this.phaseWhen.get(this._phase);d&&(d.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let d=this.phaseWhen.get(y);d||(d=new k.Barrier,this.phaseWhen.set(y,d)),await d.wait()}registerWindow(y){const d=new M.DisposableStore;this.windowCounter++,d.add(y.onWillLoad(a=>this._onWillLoadWindow.fire({window:y,workspace:a.workspace,reason:a.reason})));const h=(0,m.assertIsDefined)(y.win);h.on("close",a=>{const i=y.id;if(this.windowToCloseRequest.has(i)){this.windowToCloseRequest.delete(i);return}this.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),a.preventDefault(),this.unload(y,1).then(o=>{if(o){this.windowToCloseRequest.delete(i);return}this.windowToCloseRequest.add(i),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this._onBeforeCloseWindow.fire(y),y.close()})}),h.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,d.dispose(),this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(y,d){await this.unload(y,3)||y.reload(d)}unload(y,d){const h=this.mapWindowIdToPendingUnload.get(y.id);if(h)return h;const a=this.doUnload(y,d).finally(()=>{this.mapWindowIdToPendingUnload.delete(y.id)});return this.mapWindowIdToPendingUnload.set(y.id,a),a}async doUnload(y,d){if(!y.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${y.id}`);const h=this._quitRequested?2:d,a=await this.onBeforeUnloadWindowInRenderer(y,h);return a?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(a)):(await this.onWillUnloadWindowInRenderer(y,h),!1)}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,d){return new Promise(h=>{const a=this.oneTimeListenerTokenGenerator++,i=`vscode:ok${a}`,o=`vscode:cancel${a}`;t.validatedIpcMain.once(i,()=>{h(!1)}),t.validatedIpcMain.once(o,()=>{h(!0)}),y.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:o,reason:d})})}onWillUnloadWindowInRenderer(y,d){return new Promise(h=>{const i=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(i,()=>h()),y.send("vscode:onWillUnload",{replyChannel:i,reason:d})})}quit(y){return this.trace(`Lifecycle#quit() - begin (willRestart: ${y})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(y&&this.stateMainService.setItem(bt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(d=>{this.pendingQuitPromiseResolve=d,this.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}trace(y){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(y):this.logService.trace(y)}async relaunch(y){this.trace("Lifecycle#relaunch()");const d=process.argv.slice(1);if(y?.addArgs&&d.push(...y.addArgs),y?.removeArgs)for(const i of y.removeArgs){const o=d.indexOf(i);o>=0&&d.splice(o,1)}const h=()=>{try{if(S.isWindows){const i=(0,l.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.logService.error(i)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:d})};v.app.once("quit",h),await this.quit(!0)&&v.app.removeListener("quit",h)}async kill(y){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const d of v.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let h;d.webContents&&!d.webContents.isDestroyed()?h=new Promise(a=>d.once("closed",a)):h=Promise.resolve(),d.destroy(),await h}})()]),v.app.exit(y)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=ve([X(0,I.ILogService),X(1,w.IStateMainService),X(2,g.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(J[224],Z([0,1,5,3,2,4,21]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let S=class extends k.Disposable{constructor(E){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,E.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const E=await new Promise((I,w)=>{q(["native-keymap"],I,w)});this._keyboardLayoutData=l(E),v.isCI||E.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=l(E),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};S=ve([X(0,M.ILifecycleMainService)],S),e.KeyboardLayoutMainService=S;function l(m){const E=m.getKeyMap(),I=m.getCurrentKeyboardLayout();return{keyboardMapping:E,keyboardLayoutInfo:I}}}),define(J[225],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(J[226],Z([0,1,8,17,12,36,14,6]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class l{constructor(I,w,g){this.storagePath=I,this.logService=w,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,w){const g=this.storage[I];return(0,k.isUndefinedOrNull)(g)?w:g}setItem(I,w){this.setItems([{key:I,data:w}])}setItems(I){let w=!1;for(const{key:g,data:f}of I)this.storage[g]!==f&&((0,k.isUndefinedOrNull)(f)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,w=!0):(this.storage[g]=f,w=!0));w&&this.save()}removeItem(I){(0,k.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(I){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),I)}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(I)),this.lastSavedStorageContents=I}catch(w){this.logService.error(w)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=l;let m=class{constructor(I,w,g){this.fileStorage=new l(I.stateResource,w,g)}async init(){await this.fileStorage.init()}getItem(I,w){return this.fileStorage.getItem(I,w)}};m=ve([X(0,R.IEnvironmentService),X(1,S.ILogService),X(2,M.IFileService)],m),e.StateService=m}),define(J[227],Z([0,1,226]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(J[110],Z([0,1,5,34,7,28]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function S(m,E,I,w,g,f,C,b,p,y){const d=Object.create(null);d["common.machineId"]=C,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=g,d.version=f,d["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,v.PlatformToString)(v.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=w,d["common.product"]=y||"desktop",b&&(d["common.msftInternal"]=b);let h=0;const a=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),v.isLinuxSnap&&(d["common.snap"]="true");const i=M(I);i&&(d["common.platformDetail"]=i);try{const o=await m.readFile(k.URI.file(p));d["common.source"]=o.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=S;function l(m){const E=t.env.USERDNSDOMAIN;if(!E)return!1;const I=E.toLowerCase();return m.some(w=>I===w)}e.verifyMicrosoftInternalDomain=l}),define(J[38],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[228],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:S,data:l}){return this.appenders.forEach(m=>m.log(S,l)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(J[85],Z([0,1,49,91,12,19,110,38]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class m{async publicLog(i,o,r){}async publicLogError(i,o,r){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(a,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:p(o.sourceConfig)})})}e.configurationTelemetry=E;function I(a,i){return!(i.disableTelemetry||!a.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=I;function w(a){const i=a.getValue(S.TELEMETRY_SETTING_ID),o=a.getValue("telemetry.enableCrashReporter");if(a.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function g(a){const i={},o={},r={};b(a,r);for(let n in r){n=n.length>150?n.substr(n.length-149):n;const s=r[n];typeof s=="number"?o[n]=s:typeof s=="boolean"?o[n]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${s.length}`),i[n]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[n]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=g;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function C(a){if(!a)return"none";for(const i of f)if(a.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=C;function b(a,i,o=0,r){if(!!a)for(const n of Object.getOwnPropertyNames(a)){const s=a[n],c=r?r+n:n;Array.isArray(s)?i[c]=(0,v.safeStringify)(s):s instanceof Date?i[c]=s.toISOString():(0,k.isObject)(s)?o<2?b(s,i,o+1,c+"."):i[c]=(0,v.safeStringify)(s):i[c]=s}}function p(a){if(!a)return[];const i=[];return y(i,"",a),i}function y(a,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(r=>y(a,i?`${i}.${r}`:r,o[r])):a.push(i)}function d(a,i){const o=a.msftInternalDomains||[],r=i.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(o)||r}e.isInternalTelemetry=d;function h(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=h}),define(J[229],Z([0,1,189,85]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,M,S,l,m,E,I){const w={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`},g=await(0,v.getServiceMachineId)(S,m,E),{sessionId:f}=await I.getTelemetryInfo();return(0,t.supportsTelemetry)(M,S)&&(0,t.getTelemetryLevel)(l)===3&&(w["X-Market-User-Id"]=g,w["VSCode-SessionId"]=f),w}e.resolveMarketplaceHeaders=k}),define(J[230],Z([0,1,2,49,91,5,24,169,19,61,53,20,44,38,85]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let C=class{constructor(y,d,h){this._configurationService=d,this._productService=h,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const a of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(a),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(y,d){this._experimentProperties[y]=d}_updateTelemetryLevel(){let y=(0,f.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;y=Math.min(y,h)}this.telemetryLevel.value=y}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const y=await this._commonProperties,d=y.sessionID,h=y["common.machineId"],a=y["common.firstSessionDate"],i=y["common.msftInternal"];return{sessionId:d,machineId:h,firstSessionDate:a,msftInternal:i}}dispose(){this._disposables.dispose()}_log(y,d,h,a){return this.telemetryLevel.value<d?Promise.resolve(void 0):this._commonProperties.then(i=>{h=(0,t.mixin)(h,i),h=(0,t.mixin)(h,this._experimentProperties),h=(0,t.cloneAndChange)(h,o=>{if(typeof o=="string")return this._cleanupInfo(o,a)}),this._appenders.forEach(o=>o.log(y,h))},i=>{console.error(i)})}publicLog(y,d,h){return this._log(y,3,d,h)}publicLog2(y,d,h){return this.publicLog(y,d,h)}publicLogError(y,d){return this._sendErrorTelemetry?this._log(y,2,d,!0):Promise.resolve(void 0)}publicLogError2(y,d){return this.publicLogError(y,d)}_anonymizeFilePaths(y){let d=y;const h=[];for(const r of this._cleanupPatterns)for(;;){const n=r.exec(y);if(!n)break;h.push([n.index,r.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(d="";;){const r=i.exec(y);if(!r)break;!a.test(r[0])&&h.every(([n,s])=>r.index<n||r.index>=s)&&(d+=y.substring(o,r.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<y.length&&(d+=y.substr(o)),d}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const d=y.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const a of h)if(a.regex.test(d))return`<REDACTED: ${a.label}>`;return y}_cleanupInfo(y,d){let h=y;d&&(h=this._anonymizeFilePaths(h));for(const a of this._cleanupPatterns)h=h.replace(a,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};C.IDLE_START_EVENT_NAME="UserIdleStart",C.IDLE_STOP_EVENT_NAME="UserIdleStop",C=ve([X(1,l.IConfigurationService),X(2,I.IProductService)],C),e.TelemetryService=C;function b(){const p=(0,S.localize)(0,null,E.default.nameLong),y=E.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=R.isWeb?"":(0,S.localize)(3,null),h=(0,S.localize)(4,null),a=(0,S.localize)(5,null),i=(0,S.localize)(6,null),o=(0,S.localize)(7,null),r=`
|       | ${h} | ${a} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,S.localize)(8,null);return`
${p} ${y} ${d}

&nbsp;

${o}
${r}

&nbsp;

${n}
`}w.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,S.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,S.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[231],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=k}),define(J[232],Z([0,1,120,3,2,4,44,231]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var l;(function(b){function p(y){return y&&typeof y=="object"&&typeof y.id=="string"}b.isThemeColor=p})(l=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var E;(function(b){function p(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||l.isThemeColor(n.color))}b.isThemeIcon=p;const y=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function d(n){const s=y.exec(n);if(!s)return;const[,c]=s;return{id:c}}b.fromString=d;function h(n){return{id:n}}b.fromId=h;function a(n,s){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),s&&(c=`${c}~${s}`),{id:c}}b.modify=a;function i(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}b.getModifier=i;function o(n,s){return n.id===s.id&&n.color?.id===s.color?.id}b.isEqual=o;function r(n,s){return{id:n.id,color:s?m(s):void 0}}b.asThemeIcon=r,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function I(b){switch(b){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case S.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const y=this.themingParticipants.indexOf(p);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new w;M.Registry.add(e.Extensions.ThemingContribution,g);function f(b){return g.onColorThemeChange(b)}e.registerThemingParticipant=f;class C extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,y){let d=this.theme.getColor(p);return d&&y&&(d=y(d,this.theme)),d?d.toString():null}}e.Themable=C}),define(J[63],Z([0,1,15,3,2,5,19,4,41]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",E="#1E1E1E",I="#000000",w="#FFFFFF",g="theme",f="themeBackground",C="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(y,d){super(),this.stateMainService=y,this.configurationService=d,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const y=this.getColorScheme();if(y.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return y.dark?I:w;let d=this.stateMainService.getItem(f,null);if(!d)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":d=m;break;case"hc-black":d=I;break;case"hc-light":d=w;break;default:d=E}return R.isMacintosh&&d.toUpperCase()===E&&(d="#171717"),d}saveWindowSplash(y,d){this.stateMainService.setItems([{key:g,data:d.baseTheme},{key:f,data:d.colorInfo.background},{key:C,data:d}]),typeof y=="number"&&this.updateBackgroundColor(y,d)}updateBackgroundColor(y,d){for(const h of v.BrowserWindow.getAllWindows())if(h.id===y){h.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(C)}};b=ve([X(0,l.IStateMainService),X(1,M.IConfigurationService)],b),e.ThemeMainService=b}),define(J[111],Z([0,1,3,5,4,6]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var M;(function(C){C.Http="http",C.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(C){C.ConstantPrivate="constantPrivate",C.Private="private",C.Public="public"})(S=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var l;(function(C){C[C.Notify=1]="Notify",C[C.OpenBrowser=2]="OpenBrowser",C[C.OpenPreview=3]="OpenPreview",C[C.Silent=4]="Silent",C[C.Ignore=5]="Ignore",C[C.OpenBrowserOnce=6]="OpenBrowserOnce"})(l=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(C){if(C.scheme!=="http"&&C.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(C.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(C){return e.LOCALHOST_ADDRESSES.indexOf(C)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(C){return e.ALL_INTERFACES_ADDRESSES.indexOf(C)>=0}e.isAllInterfaces=I;function w(C,b){return b?b!==1&&C<1024:!t.isWindows&&C<1024}e.isPortPrivileged=w;class g{constructor(b,p,y){this.remoteAddress=b,this.localAddress=p,this._dispose=y,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let f=class{constructor(b){this.logService=b,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],p=Array.from(this._tunnels.values());for(const y of p){const d=Array.from(y.values());for(const h of d){const a=await h.value;a&&b.push(a)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:p}of b.values())await p.then(y=>y?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,p,y,d,h=!1,a,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${y} on local port ${d}.`),!b)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(y)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(b,p,y,d,h,a,i);return o?o.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(r);return(r.tunnelRemoteHost!==p||r.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const p=this._tunnels.get(b.tunnelRemoteHost);if(p){const y=p.get(b.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,y))}}}}async tryDisposeTunnel(b,p,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${p}.`);const d=y.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(p),d}}async closeTunnel(b,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${p} `);const y=this._tunnels.get(b);if(y&&y.has(p)){const d=y.get(p);d.refcount=0,await this.tryDisposeTunnel(b,p,d)}}addTunnelToMap(b,p,y){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(p,{refcount:1,value:y})}async removeEmptyTunnelFromMap(b,p){const y=this._tunnels.get(b);y&&(await y.get(p)||y.delete(p),y.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,p){const y=[b];E(b)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):I(b)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const d=y.map(h=>this._tunnels.get(h));for(const h of d){const a=h?.get(p);if(a)return a}}canTunnel(b){return!!m(b)}createWithProvider(b,p,y,d,h,a,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${y} on local port ${d}.`);const o=y;this._factoryInProgress.add(o);const n={elevationRequired:h?w(d===void 0?y:d):!1},s={remoteAddress:{host:p,port:y},localAddressPort:d,privacy:a,public:a?a!==S.Private:void 0,protocol:i},c=b.forwardPort(s,n);return c?(this.addTunnelToMap(p,y,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),c}};f=ve([X(0,R.ILogService)],f),e.AbstractTunnelService=f}),define(J[233],Z([0,1,75,90,219,8,2,19,6,20,218,111,84]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(y,d,h,a,i){let o;for(let r=3;r&&(o?.dispose(),o=await new f(y,d,h,a,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));r--);return o}class f extends M.Disposable{constructor(d,h,a,i,o){super(),this.defaultTunnelHost=h,this.suggestedLocalPort=o,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let d=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(d){d.pause();const h=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,E.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),i=a.getSocket().socket,o=a.readEntireBuffer();a.dispose(),o.byteLength>0&&d.write(o.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),i.end()}),d.on("close",()=>i.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),i.destroy()}),i.on("end",()=>d.end()),i.on("close",()=>d.end()),i.on("error",()=>{d.destroy()}),d.pipe(i),i.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),i.end()})}}let C=class extends I.AbstractTunnelService{constructor(d,h,a,i,o){super(h),this.socketFactory=d,this.signService=a,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,h,a,i,o,r,n){const s=this.getTunnelFromMap(h,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,a,i,o,r,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${a} on local port ${i}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},u=g(c,this.defaultTunnelHost,h,a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,a,u),u}}};C=ve([X(1,l.ILogService),X(2,w.ISignService),X(3,m.IProductService),X(4,S.IConfigurationService)],C),e.BaseTunnelService=C;let b=class extends C{constructor(d,h,a,i){super(k.nodeSocketFactory,d,h,a,i)}};b=ve([X(0,l.ILogService),X(1,w.ISignService),X(2,m.IProductService),X(3,S.IConfigurationService)],b),e.TunnelService=b;let p=class extends M.Disposable{constructor(d,h,a,i){super(),this.logService=d,this.productService=h,this.signService=a,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(d,h,a,i,o,r,n,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${o}.`),!this._tunnelServices.has(d)){const c=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(d,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(h,a,i,o,r,n,s)}};p=ve([X(0,l.ILogService),X(1,m.IProductService),X(2,w.ISignService),X(3,S.IConfigurationService)],p),e.SharedTunnelsService=p}),define(J[45],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(J[234],Z([0,1,5,170,61,44]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[235],Z([0,1,3,45]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(S){this.service=S}listen(S,l){switch(l){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${l}`)}call(S,l,m){switch(l){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${l}`)}}e.UpdateChannel=k;class R{constructor(S){this.channel=S,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(l=>this.state=l),this.channel.call("_getInitialState").then(l=>this.state=l)}get state(){return this._state}set state(S){this._state=S,this._onStateChange.fire(S)}checkForUpdates(S){return this.channel.call("checkForUpdates",S)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(S){return this.channel.call("_applySpecificUpdate",S)}}e.UpdateChannelClient=R}),define(J[86],Z([0,1,8,22,3,19,26,21,6,20,54,45]),function(q,e,v,t,k,R,M,S,l,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function w(f,C,b){return`${b.updateUrl}/api/update/${f}/${C}/${b.commit}`}e.createUpdateURL=w;let g=class{constructor(C,b,p,y,d,h){this.lifecycleMainService=C,this.configurationService=b,this.environmentMainService=p,this.requestService=y,this.logService=d,this.productService=h,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(C){this.logService.info("update#setState",C.type),this._state=C,this._onStateChange.fire(C)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const C=this.getUpdateMode(),b=this.getProductQuality(C);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),C==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}C==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(C){return C==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(C=60*60*1e3){return(0,v.timeout)(C).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(C){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(C)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(C){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(C=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${C}`),!C&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(C){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ve([X(0,S.ILifecycleMainService),X(1,R.IConfigurationService),X(2,M.IEnvironmentMainService),X(3,E.IRequestService),X(4,l.ILogService),X(5,m.IProductService)],g),e.AbstractUpdateService=g}),define(J[236],Z([0,1,15,52,3,2,19,26,21,6,20,54,38,45,86]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let C=class extends f.AbstractUpdateService{constructor(p,y,d,h,a,i,o){super(p,y,h,a,i,o),this.telemetryService=d,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(p,y)=>y)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(p,y,d)=>({url:y,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(p,y,d,h)=>({releaseNotes:y,version:d,productVersion:d,date:h}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(g.State.Idle(1,d))}buildUpdateFeedUrl(p){let y;this.productService.darwinUniversalAssetId?y=this.productService.darwinUniversalAssetId:y=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,f.createUpdateURL)(y,p,this.productService);try{v.autoUpdater.setFeedURL({url:d})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return d}doCheckForUpdates(p){this.setState(g.State.CheckingForUpdates(p)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(g.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],C.prototype,"onRawError",null),ve([t.memoize],C.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],C.prototype,"onRawUpdateAvailable",null),ve([t.memoize],C.prototype,"onRawUpdateDownloaded",null),C=ve([X(0,l.ILifecycleMainService),X(1,M.IConfigurationService),X(2,w.ITelemetryService),X(3,S.IEnvironmentMainService),X(4,I.IRequestService),X(5,m.ILogService),X(6,E.IProductService)],C),e.DarwinUpdateService=C}),define(J[237],Z([0,1,50,29,8,3,9,26,21,6,38,45]),function(q,e,v,t,k,R,M,S,l,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let w=class{constructor(C,b,p){if(this.lifecycleMainService=C,this.logService=p,this._state=I.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}get state(){return this._state}setState(C){this.logService.info("update#setState",C.type),this._state=C,this._onStateChange.fire(C)}scheduleCheckForUpdates(C=60*60*1e3){return(0,k.timeout)(C).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(C){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(C)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(C){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(C=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${C}`),!C&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(C){}};w=ve([X(0,l.ILifecycleMainService),X(1,S.IEnvironmentMainService),X(2,m.ILogService)],w);let g=class extends w{constructor(C,b,p,y,d,h){super(p,y,d),this.snap=C,this.snapRevision=b,this.telemetryService=h;const a=(0,t.watch)(M.dirname(this.snap)),i=R.Event.fromNodeEventEmitter(a,"change",(s,c)=>c),o=R.Event.filter(i,s=>s==="current"),n=R.Event.debounce(o,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{n.dispose(),a.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(C=>{C?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,C.message||C))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const C=await new Promise((p,y)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(d,h)=>d?y(d):p(h))),b=M.basename(C);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,C=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([X(2,l.ILifecycleMainService),X(3,S.IEnvironmentMainService),X(4,m.ILogService),X(5,E.ITelemetryService)],g),e.SnapUpdateService=g}),define(J[55],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(J[238],Z([0,1,55,190,14,16,126,3,2]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(w){this.uri=w,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let E=class{constructor(w){this._fileService=w,this._dispooables=new l.DisposableStore,this._limit=2**16;const g=new Map,f=C=>{let b=g.get(C.scheme);return b===void 0&&(b=w.hasProvider(C)&&!this._fileService.hasCapability(C,1024),g.set(C.scheme,b)),b};this._dispooables.add(S.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(C=>{g.delete(C.scheme)})),this.extUri=new R.ExtUri(f),this._canonicalUris=new M.SkipList((C,b)=>this.extUri.compare(C,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,R.normalizePath)(w));const g=this._canonicalUris.get(w);return g?g.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new m(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((f,C)=>f[1].touch<C[1].touch?1:f[1].touch>C[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let f=0;f<g;f++)this._canonicalUris.set(w[f][0],w[f][1].touch())}};E=ve([X(0,k.IFileService)],E),e.UriIdentityService=E,(0,t.registerSingleton)(v.IUriIdentityService,E,!0)}),define(J[112],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(J[239],Z([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(S){this.handler=S}listen(S,l){throw new Error(`Event not found: ${l}`)}call(S,l,m){switch(l){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${l}`)}}e.URLHandlerChannel=t;class k{constructor(S){this.channel=S}handleURL(S,l){return this.channel.call("handleURL",[S.toJSON(),l])}}e.URLHandlerChannelClient=k;class R{constructor(S){this.next=S}async routeCall(S,l,m,E){if(l!=="handleURL")throw new Error(`Call not found: ${l}`);if(m){const I=v.URI.revive(m);if(I&&I.query){const w=/\bwindowId=(\d+)/.exec(I.query);if(w){const g=w[1],f=new RegExp(`window:${g}`),C=S.connections.find(b=>f.test(b.ctx));if(C)return C}}}return this.next.routeCall(S,l,m,E)}routeEvent(S,l){throw new Error(`Event not found: ${l}`)}}e.URLHandlerRouter=R}),define(J[240],Z([0,1,8,2,7,20]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,E){const I=[...this.handlers.values()];return(0,v.first)(I.map(w=>()=>w.handleURL(m,E)),void 0,!1).then(w=>w||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=M;let S=class extends M{constructor(m){super(),this.productService=m}create(m){let{authority:E,path:I,query:w,fragment:g}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&I&&I.indexOf("/")!==0&&(I=`/${I}`),k.URI.from({scheme:this.productService.urlProtocol,authority:E,path:I,query:w,fragment:g})}};S=ve([X(0,R.IProductService)],S),e.NativeURLService=S}),define(J[241],Z([0,1,15,8,3,2,5,7]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function l(E){try{return S.URI.parse(E)}catch{return null}}class m{constructor(I,w,g,f,C){if(this.urlService=w,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=I,M.isWindows){const y=f.isBuilt?[]:[`"${f.appRoot}"`];y.push("--open-url","--"),v.app.setAsDefaultProtocolClient(C.urlProtocol,process.execPath,y)}const b=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(y,d)=>({event:y,url:d})),({event:y,url:d})=>(y.preventDefault(),d));this.disposables.add(b(y=>{const d=l(y);!d||this.urlService.open(d,{originalUrl:y})})),g.getWindows().filter(y=>y.isReady).length>0?this.flush():k.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const w of this.uris)await this.urlService.open(w.uri,{originalUrl:w.url})||I.push(w);I.length!==0&&(this.uris=I,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[242],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(J[243],Z([0,1,15,2,13,7]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const l=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,l)}handleWebviewRequest(l,m){try{const E=R.URI.parse(l.url),I=M.validWebviewFilePaths.get(E.path);if(typeof I=="string"){const w=`vs/workbench/contrib/webview/browser/pre/${I}`,g=k.FileAccess.asFileUri(w,q);return m(decodeURIComponent(g.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(J[72],Z([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(E){return!!E.workspaceUri}e.isWorkspaceToOpen=t;function k(E){return!!E.folderUri}e.isFolderToOpen=k;function R(E){return!!E.fileUri}e.isFileToOpen=R;function M(E){const I=S(E),w=E.getValue("window.menuBarVisibility");return w==="default"||I==="native"&&w==="compact"||v.isMacintosh&&v.isNative?"classic":w}e.getMenuBarVisibility=M;function S(E){if(v.isWeb)return"custom";const I=E.getValue("window");if(I){if(v.isMacintosh&&I.nativeTabs===!0||v.isMacintosh&&I.nativeFullScreen===!1)return"native";const f=I.titleBarStyle;if(f==="native"||f==="custom")return f}return v.isLinux?"native":"custom"}e.getTitleBarStyle=S;function l(E,I){if(!v.isWindows||v.isWeb||!I.isBuilt||S(E)==="native")return!1;const w=E.getValue("window.experimental.windowControlsOverlay.enabled");return typeof w=="boolean"?w:!0}e.useWindowControlsOverlay=l;function m(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=m}),define(J[113],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=k;var R;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(J[33],Z([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(J[244],Z([0,1,15,22,3,66,2,28,69,101,6,20,33]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(C){C[C.Initial=1]="Initial",C[C.StoredCredentialsUsed=2]="StoredCredentialsUsed",C[C.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let f=class extends M.Disposable{constructor(b,p,y,d,h){super(),this.logService=b,this.windowsMainService=p,this.credentialsService=y,this.encryptionMainService=d,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(v.app,"login",(p,y,d,h,a)=>({event:p,webContents:y,req:d,authInfo:h,callback:a}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:y,callback:d}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&y.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(h?.username,h?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let y,d;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(o){const r=JSON.parse(await this.encryptionMainService.decrypt(o));y=r.username,d=r.password}}catch(o){this.logService.error(o)}if(this.state!==g.StoredCredentialsUsed&&typeof y=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:y,password:d};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const a={authInfo:b,username:this.sessionCredentials?.username??y,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,S.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,a),this.state=g.LoginDialogShown;const i=await new Promise(o=>{const r=async(n,s,c)=>{if(s===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",r),c){const u={username:c.username,password:c.password};try{if(c.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(P){this.logService.error(P)}o({username:u.username,password:u.password})}else o(void 0)};h.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};f=ve([X(0,E.ILogService),X(1,w.IWindowsMainService),X(2,l.ICredentialsMainService),X(3,m.IEncryptionMainService),X(4,I.IProductService)],f),e.ProxyAuthHandler=f}),define(J[245],Z([0,1,69,6,36,20,33,202]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let l=class extends S.BaseCredentialsMainService{constructor(E,I,w,g){super(E),this.environmentMainService=I,this.productService=w,this.windowsMainService=g,this.surfaceKeytarLoadError=f=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",f.message??f)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const E=await new Promise((I,w)=>{q(["keytar"],I,w)});return await E.findCredentials("test-keytar-loads"),this._keytarCache=E,this._keytarCache}};l=ve([X(0,t.ILogService),X(1,k.INativeEnvironmentService),X(2,R.IProductService),X(3,M.IWindowsMainService)],l),e.CredentialsNativeMainService=l}),define(J[246],Z([0,1,18,2,3,6,21,77,50,275,8,13,49,5,34,15,33]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=C.UtilityProcess,y=typeof p<"u";let d=class Ot{constructor(o,r,n){this._logService=o,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,r.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const r=this._extHosts.get(o);if(!r)throw new Error("Unknown extension host!");return r}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return y}async createExtensionHost(o){if(this._shutdown)throw(0,v.canceled)();const r=String(++Ot._lastId);let n;if(o){if(!y)throw new Error("Cannot use UtilityProcess!");n=new a(r,this._logService,this._windowsMainService)}else n=new h(r,this._logService);return this._extHosts.set(r,n),n.onExit(({pid:s,code:c,signal:u})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${u}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(r)})}),{id:r}}async start(o,r){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(o).start(r)}async enableInspectPort(o){if(this._shutdown)throw(0,v.canceled)();const r=this._extHosts.get(o);return r?r.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,v.canceled)();const r=this._extHosts.get(o);!r||r.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const r=[];for(const[,n]of this._extHosts)r.push(n.waitForExit(o));return E.Promises.settled(r).then(()=>{})}};d._lastId=0,d=ve([X(0,R.ILogService),X(1,M.ILifecycleMainService),X(2,b.IWindowsMainService)],d),e.ExtensionHostStarter=d;let h=class extends t.Disposable{constructor(o,r){super(),this.id=o,this._logService=r,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){g.isCI&&this._logService.info("Calling fork to start extension host...");const r=S.StopWatch.create(!1);this._process=(0,l.fork)(I.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,w.mixin)({cwd:(0,f.cwd)()},o));const n=r.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${n} ms).`);const c=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const D=typeof P=="string"?P:c.write(P);this._onStdout.fire(D)});const u=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const D=typeof P=="string"?P:u.write(P);this._onStderr.fire(D)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,D)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:P,signal:D})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const r=this._process.pid;this._logService.info(`Waiting for extension host with pid ${r} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,E.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${r} did not exit within ${o}ms.`),this._process.kill())}};h=ve([X(1,R.ILogService)],h);let a=class extends t.Disposable{constructor(o,r,n){super(),this.id=o,this._logService=r,this._windowsMainService=n,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const r=this._windowsMainService.getWindowById(o.responseWindowId);if(!r){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=r.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=I.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,u=["--type=extensionHost","--skipWorkspaceStorageLock"],P=o.execArgv||[],D={...o.env};for(const re of Object.keys(D))D[re]=String(D[re]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(c,u,{serviceName:s,env:D,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(re,le)=>le);this._register(T(re=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re,signal:""})}));const _=(re,le)=>{le.type==="Utility"&&le.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${le.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:le.exitCode,signal:""}))};C.app.on("child-process-gone",_),this._register((0,t.toDisposable)(()=>{C.app.off("child-process-gone",_)}));const{port1:U,port2:Q}=new C.MessageChannelMain;this._process.postMessage("port",null,[Q]),n.webContents.postMessage(o.responseChannel,o.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const r=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${r} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,E.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${r} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};a=ve([X(1,R.ILogService),X(2,b.IWindowsMainService)],a)}),define(J[247],Z([0,1,15,3,2,243,33]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,E){let I;if(typeof m.windowId=="number"){const{windowId:w}=m,g=this.windowsMainService.getWindowById(w);if(!g?.win)throw new Error(`Invalid windowId: ${w}`);I=g.win.webContents}else{const{webContentsId:w}=m;if(I=v.webContents.fromId(w),!I)throw new Error(`Invalid webContentsId: ${w}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(E)}async findInFrame(m,E,I,w){const f=this.getFrameByName(m,E);if(typeof f.findInFrame=="function"){f.findInFrame(I,{findNext:w.findNext,forward:w.forward});const C=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),f.removeListener("found-in-frame",C))};f.on("found-in-frame",C)}}async stopFindInFrame(m,E,I){const g=this.getFrameByName(m,E);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,E){const I=this.windowsMainService.getWindowById(m.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${m}`);const w=I.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===E);if(!w)throw new Error(`Unknown frame: ${E}`);return w}};S=ve([X(0,M.IWindowsMainService)],S),e.WebviewMainService=S}),define(J[248],Z([0,1,8,3,2]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:S,onDidFocusWindow:l,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(S,l))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(S){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=S}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(J[27],Z([0,1,174,9,32,16,7,4,13]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function m(r){const n=r;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m;function E(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=E;function I(r){const n=r;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=I;function w(r){const n=r;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:M.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=w;var g;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function C(r){const n=r;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=C;class b{constructor(n,s,c,u,P){this._id=n,this._transient=c,this._configuration=u,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class p{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function y(r){return new p({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(r,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function a(r){let n;return M.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===l.Schemas.tmp}e.isTemporaryWorkspace=a;function i(r,n){return!h(r,n)&&!a(r)}e.isSavedWorkspace=i;function o(r){return(typeof r=="string"?(0,t.extname)(r):(0,R.extname)(r))===d}e.hasWorkspaceFileExtension=o}),define(J[249],Z([0,1,74,29,31,13,9,5,16,7,25,178,19,26,14,6,177,27]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(h,a,i){this.configurationService=a,this.logService=i,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=l.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,r)=>(0,k.isEqual)(o,r,!S.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let a=[];try{Array.isArray(h.rootURIWorkspaces)&&(a=h.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:m.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(a);let i=[];try{Array.isArray(h.folderWorkspaceInfos)?i=h.folderWorkspaceInfos.map(o=>({folderUri:m.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(h.folderURIWorkspaces)&&(i=h.folderURIWorkspaces.map(o=>({folderUri:m.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(i),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==f.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,a){this.workspaces.some(o=>h.workspace.id===o.workspace.id)||(this.workspaces.push(h),this.saveSync());const i=this.getBackupPath(h.workspace.id);return a&&this.moveBackupFolderSync(i,a),i}moveBackupFolderSync(h,a){if(t.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),t.existsSync(a))try{t.renameSync(a,h)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}unregisterWorkspaceBackupSync(h){const a=h.id,i=this.workspaces.findIndex(o=>o.workspace.id===a);i!==-1&&(this.workspaces.splice(i,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(a=>this.backupUriComparer.isEqual(h.folderUri,a.folderUri))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const a=this.folders.findIndex(i=>this.backupUriComparer.isEqual(h,i.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(h,a){const i=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,i))||(this.emptyWindows.push({backupFolder:i,remoteAuthority:a}),this.saveSync()),this.getBackupPath(i)}unregisterEmptyWindowBackupSync(h){const a=this.emptyWindows.findIndex(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,h));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(h){return(0,M.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const a=new Set,i=[];for(const o of h){const r=o.workspace;if(!(0,p.isWorkspaceIdentifier)(r))return[];if(!a.has(r.id)){a.add(r.id);const n=this.getBackupPath(r.id);await this.doHasBackups(n)?r.configPath.scheme!==R.Schemas.file||await E.Promises.exists(r.configPath.fsPath)?i.push(o):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return i}async validateFolders(h){if(!Array.isArray(h))return[];const a=[],i=new Set;for(const o of h){const r=o.folderUri,n=this.backupUriComparer.getComparisonKey(r);if(!i.has(n)){i.add(n);const s=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(s)?r.scheme!==R.Schemas.file||await E.Promises.exists(r.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const a=[],i=new Set;for(const o of h){const r=o.backupFolder;if(typeof r!="string")return[];if(!i.has(r)){i.add(r);const n=this.getBackupPath(r);await this.doHasBackups(n)?a.push(o):await this.deleteStaleBackup(n)}}return a}async deleteStaleBackup(h){try{await E.Promises.exists(h)&&await E.Promises.rm(h,E.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const i=this.getBackupPath(a);try{await E.Promises.rename(h,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const i=this.getBackupPath(a);try{t.renameSync(h,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const h=[];for(const a of this.workspaces)await this.hasBackups(a)&&h.push(a);for(const a of this.folders)await this.hasBackups(a)&&h.push(a);return h}hasBackups(h){let a;return(0,I.isEmptyWindowBackupInfo)(h)?a=h.backupFolder:(0,b.isFolderBackupInfo)(h)?a=this.getBackupPath(this.getFolderHash(h)):a=this.getBackupPath(h.workspace.id),this.doHasBackups(a)}async doHasBackups(h){try{const a=await E.Promises.readdir(h);for(const i of a)try{if((await E.Promises.readdir((0,M.join)(h,i))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderWorkspaceInfos:this.folders.map(h=>({folderUri:h.folderUri.toString(),remoteAuthority:h.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){const a=h.folderUri;let i;return a.scheme===R.Schemas.file?i=S.isLinux?a.fsPath:a.fsPath.toLowerCase():i=a.toString().toLowerCase(),(0,v.createHash)("md5").update(i).digest("hex")}};y=ve([X(0,g.IEnvironmentMainService),X(1,w.IConfigurationService),X(2,C.ILogService)],y),e.BackupMainService=y}),define(J[56],Z([0,1,15,8,66,35,2,78,5,12,25,151,4,6,27]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let C=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,y){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},y)}pickFolder(p,y){return this.doPick({...p,pickFolders:!0,title:(0,I.localize)(1,null)},y)}pickFile(p,y){return this.doPick({...p,pickFiles:!0,title:(0,I.localize)(2,null)},y)}pickWorkspace(p,y){const d=(0,I.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,I.localize)(4,null)),a=f.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:d,filters:a,buttonLabel:h},y)}async doPick(p,y){const d={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(d.properties=void 0,p.pickFiles&&p.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),l.isMacintosh&&d.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(d,(0,m.withNullAsUndefined)(y||v.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(p){if(p){let y=this.windowDialogQueues.get(p.id);return y||(y=new t.Queue,this.windowDialogQueues.set(p.id,y)),y}else return this.noWindowDialogueQueue}showMessageBox(p,y){return this.getWindowDialogQueue(y).queue(async()=>y?v.dialog.showMessageBox(y,p):v.dialog.showMessageBox(p))}async showSaveDialog(p,y){const d=this.acquireFileDialogLock(p,y);if(!d)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(y).queue(async()=>{let h;return y?h=await v.dialog.showSaveDialog(y,p):h=await v.dialog.showSaveDialog(p),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,M.dispose)(d)}}normalizePath(p){return p&&l.isMacintosh&&(p=(0,S.normalizeNFC)(p)),p}normalizePaths(p){return p.map(y=>this.normalizePath(y))}async showOpenDialog(p,y){p.defaultPath&&(await E.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const d=this.acquireFileDialogLock(p,y);if(!d)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(y).queue(async()=>{let h;return y?h=await v.dialog.showOpenDialog(y,p):h=await v.dialog.showOpenDialog(p),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,M.dispose)(d)}}acquireFileDialogLock(p,y){if(!y)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let d=this.windowFileDialogLocks.get(y.id);d||(d=new Set,this.windowFileDialogLocks.set(y.id,d));const h=(0,k.hash)(p);if(!d.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),d.add(h),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),d?.delete(h),d?.size===0&&this.windowFileDialogLocks.delete(y.id)})}};C=ve([X(0,g.ILogService)],C),e.DialogMainService=C}),define(J[250],Z([0,1,3,2,67,27]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(l,m){super(),this.logService=l,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(l,m){this._register(v.Event.debounce(l.onDidChangeStorage,(E,I)=>(E?E.push(I):E=[I],E),M.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&m.fire(this.serializeStorageChangeEvents(E,l))}))}serializeStorageChangeEvents(l,m){const E=new Map,I=new Set;return l.forEach(w=>{const g=m.get(w.key);typeof g=="string"?E.set(w.key,g):I.add(w.key)}),{changed:Array.from(E.entries()),deleted:Array.from(I.values())}}listen(l,m,E){switch(m){case"onDidChangeStorage":{const I=E.profile?(0,k.revive)(E.profile):void 0;if(!I)return this.onDidChangeApplicationStorageEmitter.event;let w=this.mapProfileToOnDidChangeProfileStorageEmitter.get(I.id);return w||(w=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(I),w),this.mapProfileToOnDidChangeProfileStorageEmitter.set(I.id,w)),w.event}}throw new Error(`Event not found: ${m}`)}async call(l,m,E){const I=E.profile?(0,k.revive)(E.profile):void 0,w=(0,R.reviveIdentifier)(E.workspace),g=await this.withStorageInitialized(I,w);switch(m){case"getItems":return Array.from(g.items.entries());case"updateItems":{const f=E;if(f.insert)for(const[C,b]of f.insert)g.set(C,b);f.delete?.forEach(C=>g.delete(C));break}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(l,m){let E;m?E=this.storageMainService.workspaceStorage(m):l?E=this.storageMainService.profileStorage(l):E=this.storageMainService.applicationStorage;try{await E.init()}catch(I){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":l?"profile":"application"} storage due to ${I}`)}return E}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[39],Z([0,1,66,3,2,16,12,7,171,36,14,4,6,27,32,55,8,28,24]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function d(o){const r=o;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&S.URI.isUri(r.location)&&S.URI.isUri(r.globalStorageHome)&&S.URI.isUri(r.settingsResource)&&S.URI.isUri(r.keybindingsResource)&&S.URI.isUri(r.tasksResource)&&S.URI.isUri(r.snippetsHome)&&((0,M.isUndefined)(r.extensionsResource)||S.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=d,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function h(o,r){return{id:o.id,isDefault:o.isDefault,name:o.name,location:S.URI.revive(o.location).with({scheme:r}),globalStorageHome:S.URI.revive(o.globalStorageHome).with({scheme:r}),settingsResource:S.URI.revive(o.settingsResource).with({scheme:r}),keybindingsResource:S.URI.revive(o.keybindingsResource).with({scheme:r}),tasksResource:S.URI.revive(o.tasksResource).with({scheme:r}),snippetsHome:S.URI.revive(o.snippetsHome).with({scheme:r}),extensionsResource:S.URI.revive(o.extensionsResource)?.with({scheme:r}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=h,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function a(o,r,n,s){return{id:(0,v.hash)(r.path).toString(16),name:o,location:r,isDefault:!1,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:n,isTransient:s}}e.toUserDataProfile=a;let i=class extends k.Disposable{constructor(r,n,s,c){super(),this.environmentService=r,this.fileService=n,this.uriIdentityService=s,this.logService=c,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(u=>a(u.name,u.location,u.useDefaultFlags)):[];let n;const s=new f.ResourceMap,c=a((0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...c,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?c.extensionsResource:void 0}),r.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[P,D]of Object.entries(u.workspaces)){const T=S.URI.parse(P),_=S.URI.parse(D),U=r.find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,_));U&&s.set(T,U)}if(u.emptyWindow){const P=S.URI.parse(u.emptyWindow);n=r.find(D=>this.uriIdentityService.extUri.isEqual(D.location,P))}}this._profilesObject={profiles:r,workspaces:s,emptyWindow:n}}return this._profilesObject}async createTransientProfile(r){const n="Temp",s=new RegExp(`${(0,y.escapeRegExpCharacters)(n)}\\s(\\d+)`);let c=0;for(const P of this.profiles){const D=s.exec(P.name),T=D?parseInt(D[1]):0;c=T>c?T:c}const u=`${n} ${c+1}`;return this.createProfile(u,void 0,r,!0)}async createProfile(r,n,s,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.doCreateProfile(r,n,c);return s&&await this.setProfileForWorkspace(s,u),u}async doCreateProfile(r,n,s){let c=this.profileCreationPromises.get(r);return c||(c=(async()=>{try{const u=this.profiles.find(T=>T.name===r);if(u)return u;const P=a(r,(0,R.joinPath)(this.profilesHome,(0,v.hash)((0,p.generateUuid)()).toString(16)),n,s);await this.fileService.createFolder(P.location);const D=[];return this._onWillCreateProfile.fire({profile:P,join(T){D.push(T)}}),await b.Promises.settled(D),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,c)),c}async updateProfile(r,n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(u=>u.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=a(n,c.location,s),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(c=>c.id===r.id);if(!n)throw new Error(`Profile '${r.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:n,join(c){s.push(c)}}),await b.Promises.settled(s),n.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])n.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[n],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(n.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(r,n=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(r);return s||(s=n,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,s)),s}async setProfileForWorkspace(r,n){this.setProfileForWorkspaceSync(r,n)}setProfileForWorkspaceSync(r,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(c=>c.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(r,s)}unsetWorkspace(r,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,n)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(n=>n.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,n.resource))).map(n=>this.fileService.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(n=>!this.isProfileAssociatedToWorkspace(n));await Promise.allSettled(r.map(n=>this.removeProfile(n)))}getProfileForWorkspace(r){const n=this.getWorkspace(r);return S.URI.isUri(n)?this.transientProfilesObject.workspaces.get(n)??this.profilesObject.workspaces.get(n):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,g.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,g.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,r.location)))}updateProfiles(r,n,s){const c=[...this.profiles,...r],u=[];this.transientProfilesObject.profiles=[];for(let P of c)P.isDefault||n.some(D=>P.id===D.id)||(P=s.find(D=>P.id===D.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):u.push({location:P.location,name:P.name,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(r,n,s)}triggerProfilesChanges(r,n,s){this._onDidChangeProfiles.fire({added:r,removed:n,updated:s,all:this.profiles})}updateWorkspaceAssociation(r,n,s){s=n?.isTransient?!0:s,s||this.updateWorkspaceAssociation(r,void 0,!0);const c=this.getWorkspace(r),u=s?this.transientProfilesObject:this.profilesObject;S.URI.isUri(c)?(u.workspaces.delete(c),n&&u.workspaces.set(c,n)):u.emptyWindow=n,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[s,c]of this.profilesObject.workspaces.entries())r[s.toString()]=c.location.toString();const n=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:n}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=ve([X(0,m.IEnvironmentService),X(1,E.IFileService),X(2,C.IUriIdentityService),X(3,w.ILogService)],i),e.UserDataProfilesService=i}),define(J[87],Z([0,1,23,8,49,17,18,48,136,2,13,9,5,16,188,92,12,7,156,36,108,107,187,14,4,6,20,3,67,71,39,55,186]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r,n,s,c,u,P,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(K){function $(F,A){if(F===A)return!0;const W=Object.keys(F),z=new Set;for(const ee of Object.keys(A))z.add(ee);if(W.length!==z.size)return!1;for(const ee of W){if(F[ee]!==A[ee])return!1;z.delete(ee)}return z.size===0}K.equals=$})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let Q=class extends m.Disposable{constructor($,F,A,W,z,ee,B,H,L,O,N){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=z,this.extensionsProfileScannerService=ee,this.fileService=B,this.logService=H,this.environmentService=L,this.productService=O,this.instantiationService=N,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,a.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,a.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(le,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,F,A){const[W,z]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(F)]),ee=A?await this.scanExtensionsUnderDevelopment($,[...W,...z]):[];return this.dedupExtensions(W,z,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const F=[];F.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),F.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let W=await($.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,$,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment($,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===E.Schemas.file).map(async W=>{const z=await this.createExtensionScannerInput(W,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=F.find(H=>(0,h.areSameExtensions)(H.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",$,!0)}return[]}async scanExistingExtension($,F,A){const W=await this.createExtensionScannerInput($,!1,F,!0,A.language),z=await this.extensionsScanner.scanExtension(W);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions($,F,A){const W=await this.createExtensionScannerInput($,!1,F,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(z,F,A,!0)}async scanMetadata($){const F=(0,g.joinPath)($,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata($,F){const A=(0,g.joinPath)($,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,z.__metadata={...z.__metadata,...F},await this.fileService.writeFile((0,g.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions($,F,A,W){return A.includeAllVersions||($=this.dedupExtensions(F===0?$:void 0,F===1?$:void 0,F==="development"?$:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||($=$.filter(z=>z.isValid)),$.sort((z,ee)=>{const B=I.basename(z.location.fsPath),H=I.basename(ee.location.fsPath);return B<H?-1:B>H?1:0})}dedupExtensions($,F,A,W,z){const ee=(H,L,O)=>{if(H.isValid&&!L.isValid)return!1;if(H.isValid===L.isValid){if(z&&f.gt(H.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(f.eq(H.manifest.version,L.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${H.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${L.location.path}.`),!0},B=new Map;return $?.forEach(H=>{const L=a.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||ee(O,H,!1))&&B.set(L,H)}),F?.forEach(H=>{const L=a.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);if(!O&&$&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!O||ee(O,H,!1))&&B.set(L,H)}),A?.forEach(H=>{const L=a.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||ee(O,H,!0))&&B.set(L,H),B.set(L,H)}),[...B.values()]}async scanDefaultSystemExtensions($,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),z=await($&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions($,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},z=[],ee=p.URI.file(I.normalize(I.join(E.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const H of A){const L=W[H.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,g.joinPath)(ee,H.name));break;default:z.push(p.URI.file(L));break}}const B=await Promise.all(z.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,v.coalesce)(B)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,F,A,W,z,ee=!0){const B=await this.getTranslations(z??w.language),H=await this.getMtime($),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new re($,H,L,O,F,A,W,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime($){try{const F=await this.fileService.stat($);if(typeof F.mtime=="number")return F.mtime}catch{}}};Q=ve([X(4,D.IUserDataProfilesService),X(5,P.IExtensionsProfileScannerService),X(6,o.IFileService),X(7,n.ILogService),X(8,d.IEnvironmentService),X(9,s.IProductService),X(10,r.IInstantiationService)],Q),e.AbstractExtensionsScannerService=Q;class re{constructor($,F,A,W,z,ee,B,H,L,O,N,V,x,ne){this.location=$,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=z,this.type=ee,this.excludeObsolete=B,this.validate=H,this.productVersion=L,this.productDate=O,this.productCommit=N,this.devMode=V,this.language=x,this.translations=ne}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,F){return(0,g.isEqual)($.location,F.location)&&$.mtime===F.mtime&&(0,g.isEqual)($.applicationExtensionslocation,F.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&$.profile===F.profile&&$.type===F.type&&$.excludeObsolete===F.excludeObsolete&&$.validate===F.validate&&$.productVersion===F.productVersion&&$.productDate===F.productDate&&$.productCommit===F.productCommit&&$.devMode===F.devMode&&$.language===F.language&&U.equals($.translations,F.translations)}}let le=class extends m.Disposable{constructor($,F,A,W,z){super(),this.obsoleteFile=$,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=z}async scanExtensions($){const F=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let A={};if($.excludeObsolete&&$.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,b.isEmptyObject)(A)?F:F.filter(W=>!A[h.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation($){const F=await this.fileService.resolve($.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||$.type===1&&(0,g.basename)(W.resource).indexOf(".")===0)return null;const z=new re(W.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(z)}));return(0,v.coalesce)(A).sort((W,z)=>W.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile($){let F=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,$);F.push(...A)}return F}async scanExtensionsFromProfileResource($,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!W.length)return[];const z=await Promise.all(W.map(async ee=>{if(F(ee)){const B=new re(ee.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,ee.metadata)}return null}));return(0,v.coalesce)(z)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,g.joinPath)($.location,"package.json"))){const F=await this.scanExtension($);return F?[F]:[]}else return await this.scanExtensions($)}catch(F){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,M.getErrorMessage)(F)),[]}}async scanExtension($,F){try{let A=await this.scanExtensionManifest($.location);if(A){A.publisher||(A.publisher=a.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,h.getGalleryExtensionId)(A.publisher,A.name),z=F?.id?{id:W,uuid:F.id}:{id:W},ee=F?.isSystem?0:$.type,B=ee===0||!!F?.isBuiltin;A=await this.translateManifest($.location,A,re.createNlsConfiguration($));const H={type:ee,identifier:z,manifest:A,location:$.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return $.validate?this.validate(H,$):H}}catch(A){$.type!==0&&this.logService.error(A)}return null}validate($,F){let A=!0;const W=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,$.manifest,$.isBuiltin);for(const[z,ee]of W)z===C.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,ee)));return $.isValid=A,$.validations=W,$}async scanExtensionManifest($){const F=(0,g.joinPath)($,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage($,(0,y.localize)(0,null,F.path,z.message))),null}let W;try{W=JSON.parse(A)}catch{const ee=[];(0,S.parse)(A,ee);for(const B of ee)this.logService.error(this.formatMessage($,(0,y.localize)(1,null,F.path,B.offset,B.length,(0,l.getParseErrorMessage)(B.error))));return null}return(0,S.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage($,(0,y.localize)(2,null,F.path))),null):W}async translateManifest($,F,A){const W=await this.getLocalizedMessages($,F,A);if(W)try{const z=[],ee=await this.resolveOriginalMessageBundle(W.default,z);if(z.length>0)return z.forEach(H=>{this.logService.error(this.formatMessage($,(0,y.localize)(3,null,W.default?.path,(0,l.getParseErrorMessage)(H.error))))}),F;if((0,S.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage($,(0,y.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,_.localizeManifest)(F,B,ee)}catch{}return F}async getLocalizedMessages($,F,A){const W=(0,g.joinPath)($,"package.nls.json"),z=(L,O)=>{O.forEach(N=>{this.logService.error(this.formatMessage($,(0,y.localize)(5,null,L?.path,(0,l.getParseErrorMessage)(N.error))))})},ee=L=>{this.logService.error(this.formatMessage($,(0,y.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,H=A.translations[B];if(H)try{const L=p.URI.file(H),O=(await this.fileService.readFile(L)).value.toString(),N=[],V=(0,S.parse)(O,N);return N.length>0?(z(L,N),{values:void 0,default:W}):(0,S.getNodeType)(V)!=="object"?(ee(L),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles($,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const N=(await this.fileService.readFile(O.localized)).value.toString(),V=[],x=(0,S.parse)(N,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,S.getNodeType)(x)!=="object"?(ee(O.localized),{values:void 0,default:O.original}):{values:x,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle($,F){if($)try{const A=(await this.fileService.readFile($)).value.toString();return(0,S.parse)(A,F)}catch{}}findMessageBundles($,F){return new Promise((A,W)=>{const z=ee=>{const B=(0,g.joinPath)($,`package.nls.${ee}.json`);this.fileService.exists(B).then(H=>{H&&A({localized:B,original:(0,g.joinPath)($,"package.nls.json")});const L=ee.lastIndexOf("-");L===-1?A({localized:(0,g.joinPath)($,"package.nls.json"),original:null}):(ee=ee.substring(0,L),z(ee))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,g.joinPath)($,"package.nls.json"),original:null});z(F.language)})}formatMessage($,F){return`[${$.path}]: ${F}`}};le=ve([X(1,P.IExtensionsProfileScannerService),X(2,T.IUriIdentityService),X(3,o.IFileService),X(4,n.ILogService)],le);let ue=class extends le{constructor($,F,A,W,z,ee){super(F,A,W,z,ee),this.cacheFile=$,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const F=await this.readExtensionCache();if(this.input=$,F&&F.input&&re.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=p.URI.revive(W.location),W));const A=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:A}),A}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),F=JSON.parse($.value.toString());return{result:F.result,input:(0,u.revive)(F.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify($)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const F=$.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ue=ve([X(2,P.IExtensionsProfileScannerService),X(3,T.IUriIdentityService),X(4,o.IFileService),X(5,n.ILogService)],ue);function se(K,$){const F=(0,h.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:F,identifier:new a.ExtensionIdentifier(F),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:$,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=se;class fe extends Q{constructor($,F,A,W,z,ee,B,H,L,O,N){super($,F,(0,g.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(W,a.MANIFEST_CACHE_FOLDER),z,ee,B,H,L,O,N),this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const V=await this.fileService.readFile(p.URI.file(w.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=fe}),define(J[251],Z([0,1,7,36,71,87,14,4,6,20,39]),function(q,e,v,t,k,R,M,S,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends R.NativeExtensionsScannerService{constructor(g,f,C,b,p,y,d){super(v.URI.file(p.builtinExtensionsPath),v.URI.file(p.extensionsPath),p.userHome,v.URI.file(p.userDataPath),g,f,C,b,p,y,d)}};I=ve([X(0,E.IUserDataProfilesService),X(1,k.IExtensionsProfileScannerService),X(2,M.IFileService),X(3,l.ILogService),X(4,t.INativeEnvironmentService),X(5,m.IProductService),X(6,S.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(J[252],Z([0,1,15,40,2,32,13,9,5,7,28,36,6,39]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let f=class extends k.Disposable{constructor(b,p,y){super(),this.logService=y,this.validRoots=R.TernarySearchTree.forPaths(!l.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=v.session;b.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(p,y)=>this.handleResourceRequest(p,y)),b.protocol.interceptFileProtocol(M.Schemas.file,(p,y)=>this.handleFileRequest(p,y)),this._register((0,k.toDisposable)(()=>{b.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(b){const p=(0,S.normalize)(b);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(b,p){const y=m.URI.parse(b.url);return this.logService.error(`Refused to load resource ${y.fsPath} from ${M.Schemas.file}: protocol (original URL: ${b.url})`),p({error:-3})}handleResourceRequest(b,p){const y=this.requestToNormalizedFilePath(b);return this.validRoots.findSubstr(y)?p({path:y}):this.validExtensions.has((0,S.extname)(y).toLowerCase())?p({path:y}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${y} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),p({error:-3}))}requestToNormalizedFilePath(b){const p=m.URI.parse(b.url),y=M.FileAccess.asFileUri(p);return(0,S.normalize)(y.fsPath)}createIPCObjectUrl(){let b;const p=m.URI.from({scheme:"vscode",path:(0,E.generateUuid)()}),y=p.toString(),d=async()=>b;return t.validatedIpcMain.handle(y,d),this.logService.trace(`IPC Object URL: Registered new channel ${y}.`),{resource:p,update:h=>b=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${y}.`),t.validatedIpcMain.removeHandler(y)}}}};f=ve([X(0,I.INativeEnvironmentService),X(1,g.IUserDataProfilesService),X(2,w.ILogService)],f),e.ProtocolMainService=f}),define(J[253],Z([0,1,15,40,8,3,2,13,12,97,26,21,6,53,60,63,43,39,37]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends M.Disposable{constructor(a,i,o,r,n,s,c,u,P){super(),this.machineId=a,this.userEnv=i,this.environmentMainService=o,this.userDataProfilesService=r,this.lifecycleMainService=n,this.logService=s,this.policyService=c,this.themeMainService=u,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(a,i)=>this.onWindowConnection(a,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(a,i)=>this.onWorkerConnection(a,i)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(a,i){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(a.sender.isDestroyed())return o.close();a.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[o])}onWorkerConnection(a,i){this.logService.trace("SharedProcess: onWorkerConnection",i);const o=new M.DisposableStore,r=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",i))},n=v.BrowserWindow.fromId(i.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!i.reply.channel){r("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===n)(()=>r("load"))),o.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>r("closed"))),n.webContents.postMessage(i.reply.channel,i.reply.nonce,a.ports)}onWillShutdown(){const a=this.window;!a||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(a.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{a.close()}catch{}this.window=void 0},0))}send(a,...i){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${a}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(a,...i)}catch(o){this.logService.warn(`Error sending IPC message to channel '${a}' of shared process: ${(0,b.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),a()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),a()}))})()),this._whenIpcReady}createWindow(){const a=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),a.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=a=>{this.logService.trace("SharedProcess#close prevented"),a.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(a,i)=>this._onDidError.fire({type:2,details:i})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(a,i,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:i}})))}async connect(){await this.whenIpcReady;const a=(0,l.assertIsDefined)(this.window);return(0,m.connect)(a)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const a=this.window;return a?!a.isDestroyed()&&!a.webContents.isDestroyed():!1}};d=ve([X(2,E.IEnvironmentMainService),X(3,p.IUserDataProfilesService),X(4,I.ILifecycleMainService),X(5,w.ILogService),X(6,y.IPolicyService),X(7,C.IThemeMainService),X(8,f.IProtocolMainService)],d),e.SharedProcess=d}),define(J[114],Z([0,1,8,3,2,82,12,98,4,39]),function(q,e,v,t,k,R,M,S,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,l.createDecorator)("storageService");var I;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var g;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class f extends k.Disposable{constructor(d={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=d,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,h){if(h===E){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:h,target:this.getKeyTargets(d)[h]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,h,a){return this.getStorage(h)?.get(d,a)}getBoolean(d,h,a){return this.getStorage(h)?.getBoolean(d,a)}getNumber(d,h,a){return this.getStorage(h)?.getNumber(d,a)}store(d,h,a,i){if((0,M.isUndefinedOrNull)(h)){this.remove(d,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,a,i),this.getStorage(a)?.set(d,h)})}remove(d,h){this.withPausedEmitters(()=>{this.updateKeyTarget(d,h,void 0),this.getStorage(h)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,h){const a=[],i=this.getKeyTargets(d);for(const o of Object.keys(i))i[o]===h&&a.push(o);return a}updateKeyTarget(d,h,a){const i=this.getKeyTargets(h);typeof a=="number"?i[d]!==a&&(i[d]=a,this.getStorage(h)?.set(E,JSON.stringify(i))):typeof i[d]=="number"&&(delete i[d],this.getStorage(h)?.set(E,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const h=this.get(E,d);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=I.NONE){this._onWillSaveState.fire({reason:d});const h=this.getStorage(-1),a=this.getStorage(0),i=this.getStorage(1);switch(d){case I.NONE:await v.Promises.settled([h?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([h?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return p(d,h,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(d,h){return this.emitWillSaveState(I.NONE),(0,m.isUserDataProfile)(d)?this.switchToProfile(d,h):this.switchToWorkspace(d,h)}canSwitchProfile(d,h){return!(d.id===h.id||C(h)&&C(d))}switchData(d,h,a,i){this.withPausedEmitters(()=>{if(i)for(const[o,r]of d)h.set(o,r);else{const o=new Set;for(const[r,n]of d)o.add(r),h.get(r)!==n&&this.emitDidChangeValue(a,r);for(const[r]of h.items)o.has(r)||this.emitDidChangeValue(a,r)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function C(y){return y.isDefault||!!y.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=C;class b extends f{constructor(){super(),this.applicationStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.profileStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=b;async function p(y,d,h,a,i,o){const r=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,s=new Map;y.forEach((U,Q)=>{n.set(Q,U),s.set(Q,r(U))});const c=new Map,u=new Map;d.forEach((U,Q)=>{c.set(Q,U),u.set(Q,r(U))});const P=new Map,D=new Map;h.forEach((U,Q)=>{P.set(Q,U),D.set(Q,r(U))}),console.group(a!==i?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const T=[];if(n.forEach((U,Q)=>{T.push({key:Q,value:U})}),console.table(T),console.groupEnd(),console.log(s),a!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];c.forEach((Q,re)=>{U.push({key:re,value:Q})}),console.table(U),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const _=[];P.forEach((U,Q)=>{_.push({key:Q,value:U})}),console.table(_),console.groupEnd(),console.log(D)}e.logStorage=p}),define(J[254],Z([0,1,23,8,3,2,9,77,7,25,98,148,6,114,38,27]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{constructor(o,r){super(),this.logService=o,this.fileService=r,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=E.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===E.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(o);const r=o.getBoolean(g.IS_NEW_KEY);r===void 0?o.set(g.IS_NEW_KEY,!0):r&&o.set(g.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=E.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,r){return this._storage.get(o,r)}set(o,r){return this._storage.set(o,r)}delete(o){return this._storage.delete(o)}async close(){const o=new S.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const r=(0,v.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),n=(await this.fileService.stat(l.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${r}`)}catch(r){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=E.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends b{constructor(o,r,n,s){super(n,s),this.profile=o,this.options=r}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}async doCreate(){return new E.Storage(new I.SQLiteStorageDatabase(this.path??I.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class y extends p{constructor(o,r,n,s){super(o,r,n,s)}}e.ProfileStorageMain=y;class d extends p{constructor(o,r,n,s){super(r.defaultProfile,o,n,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(f.firstSessionDateStorageKey,void 0)===void 0&&o.set(f.firstSessionDateStorageKey,new Date().toUTCString());const n=o.get(f.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(f.lastSessionDateStorageKey,typeof n>"u"?null:n),o.set(f.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=d;class h extends b{constructor(o,r,n,s,c){super(n,c),this.workspace=o,this.options=r,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:o,wasCreated:r}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new I.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:r?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),r=(0,M.join)(o,h.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:r,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:r,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let r;if((0,C.isSingleFolderWorkspaceIdentifier)(this.workspace)?r={folder:this.workspace.uri.toString()}:(0,C.isWorkspaceIdentifier)(this.workspace)&&(r={workspace:this.workspace.configPath.toString()}),r)try{const n=(0,M.join)(o,h.WORKSPACE_META_NAME);await m.Promises.exists(n)||await m.Promises.writeFile(n,JSON.stringify(r,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class a extends b{get path(){}async doCreate(){return new E.Storage(new E.InMemoryStorageDatabase)}}e.InMemoryStorageMain=a}),define(J[255],Z([0,1,67,36,14,6,225,55,39]),function(q,e,v,t,k,R,M,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class Mt extends l.UserDataProfilesService{constructor(I,w,g,f,C){super(g,f,w,C),this.stateService=I}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(Mt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(Mt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([X(0,M.IStateService),X(1,S.IUriIdentityService),X(2,t.IEnvironmentService),X(3,k.IFileService),X(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(J[42],Z([0,1,7,36,14,4,6,41,55,39,255]),function(q,e,v,t,k,R,M,S,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let I=class ct extends E.UserDataProfilesService{constructor(g,f,C,b,p){super(g,f,C,b,p),this.stateMainService=g}setEnablement(g){super.setEnablement(g),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(g){if(!!this.isEnabled()&&!(!g._.length&&!g["folder-uri"]&&!g["file-uri"])){if(g.profile)return this.profiles.some(f=>f.name===g.profile)?void 0:this.createProfile(g.profile).then(()=>g);if(g["profile-temp"])return this.createTransientProfile().then(f=>(g.profile=f.name,g))}}saveStoredProfiles(g){g.length?this.stateMainService.setItem(ct.PROFILES_KEY,g):this.stateMainService.removeItem(ct.PROFILES_KEY)}saveStoredProfileAssociations(g){g.emptyWindow||g.workspaces?this.stateMainService.setItem(ct.PROFILE_ASSOCIATIONS_KEY,g):this.stateMainService.removeItem(ct.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",f=this.stateMainService.getItem(g,void 0);if(f){this.stateMainService.removeItem(g);const C=f.reduce((b,{workspace:p,profile:y})=>(b[v.URI.revive(p).toString()]=v.URI.revive(y).toString(),b),{});this.stateMainService.setItem(ct.PROFILE_ASSOCIATIONS_KEY,{workspaces:C})}return super.getStoredProfileAssociations()}};I=ve([X(0,S.IStateMainService),X(1,l.IUriIdentityService),X(2,t.IEnvironmentService),X(3,k.IFileService),X(4,M.ILogService)],I),e.UserDataProfilesMainService=I}),define(J[256],Z([0,1,2,16,71,87,14,6,39,42]),function(q,e,v,t,k,R,M,S,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let E=class extends v.Disposable{constructor(w,g,f,C,b){super(),this.userDataProfilesService=w,this.fileService=g,this.extensionsScannerService=f,this.extensionsProfileScannerService=C,w.isEnabled()?(this._register(w.onWillCreateProfile(p=>{w.profiles.length===1&&p.join(this.initialize())})),this._register(w.onDidChangeProfiles(p=>{w.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>b.error(p))}async initialize(){const w=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(w)}catch{}const g=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(g.map(f=>[f,f.metadata]),w)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,l.EXTENSIONS_RESOURCE_NAME)}};E=ve([X(0,m.IUserDataProfilesMainService),X(1,M.IFileService),X(2,R.IExtensionsScannerService),X(3,k.IExtensionsProfileScannerService),X(4,S.ILogService)],E),e.DefaultExtensionsProfileInitHandler=E}),define(J[88],Z([0,1,47,2,36,14,4,21,6,114,254,39,42]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(b,p,y,d,h){super(),this.logService=b,this.environmentService=p,this.userDataProfilesService=y,this.lifecycleMainService=d,this.fileService=h,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join(this.applicationStorage.close());for(const[,p]of this.mapProfileToStorage)b.join(p.close());for(const[,p]of this.mapWorkspaceToStorage)b.join(p.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const p=this.mapProfileToStorage.get(b.profile.id);p&&b.join(p.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new E.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,v.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,m.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let p=this.mapProfileToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),p=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,p),(0,v.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id)})),p}createProfileStorage(b){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let p=this.mapWorkspaceToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),p=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,p),(0,v.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),p}createWorkspaceStorage(b){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=ve([X(0,l.ILogService),X(1,k.IEnvironmentService),X(2,w.IUserDataProfilesMainService),X(3,S.ILifecycleMainService),X(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,M.createDecorator)("applicationStorageMainService");let f=class extends m.AbstractStorageService{constructor(b,p){super(),this.userDataProfilesService=b,this.storageMainService=p,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};f=ve([X(0,I.IUserDataProfilesService),X(1,e.IStorageMainService)],f),e.ApplicationStorageMainService=f}),define(J[257],Z([0,1,2,21,42]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends v.Disposable{constructor(S,l){super(),this.userDataProfilesService=l,this._register(S.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.previousWorkspace??"empty-window")})),this._register(S.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(S){this.userDataProfilesService.getOrSetProfileForWorkspace(S).isTransient&&(this.userDataProfilesService.unsetWorkspace(S,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([X(0,t.ILifecycleMainService),X(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(J[115],Z([0,1,16,7,27]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(l,m,E){for(const w of l){const g=w.openedWorkspace;if((0,k.isWorkspaceIdentifier)(g)){const f=E(g);if(f){if(f.folders.some(C=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,C.uri)))return w}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.configPath))return w}}const I=l.filter(w=>(0,k.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,w.openedWorkspace.uri));if(I.length)return I.sort((w,g)=>-(w.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(l,m){for(const E of l)if((0,k.isWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,m))return E}e.findWindowOnWorkspaceOrFolder=M;function S(l,m){const E=I=>m.some(w=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(w),t.URI.file(I)));for(const I of l)if(I.config?.extensionDevelopmentPath?.some(w=>E(w)))return I}e.findWindowOnExtensionDevelopmentPath=S}),define(J[258],Z([0,1,15,2,5,16,7,19,21,6,41,33,113,27]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let f=class Dt extends t.Disposable{constructor(h,a,i,o,r){super(),this.windowsMainService=h,this.stateMainService=a,this.lifecycleMainService=i,this.logService=o,this.configurationService=r,this._state=C(this.stateMainService.getItem(Dt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!a.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),r&&(a.lastActiveWindow=this.toWindowState(r),a.lastActiveWindow.uiState.mode===3&&h.add(a.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);i&&(a.lastPluginDevelopmentHostWindow=this.toWindowState(i),a.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(a.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(a.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const n=this.toWindowState(r);return n.uiState.mode===3&&(h.has(n.uiState.display)?k.isMacintosh&&n.windowId!==a.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const o=p(a);this.stateMainService.setItem(Dt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(i=>{const o=(0,g.isWorkspaceIdentifier)(h.openedWorkspace)&&i.workspace?.id===h.openedWorkspace.id,r=(0,g.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,h.openedWorkspace.uri);(o||r)&&(i.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(h){return{windowId:h.id,workspace:(0,g.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const a=this.doGetNewWindowState(h),i=this.configurationService.getValue("window");if(a.mode===3){let o;a.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),o||(a.mode=1)}return a}doGetNewWindowState(h){const a=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=h.workspace;if((0,g.isWorkspaceIdentifier)(c)){const P=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(P.length)return P[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(c)){const P=this.state.openedWindows.filter(D=>D.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(P.length)return P[0]}else if(h.backupPath){const P=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(P.length)return P[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!a&&u)return u.uiState}let i;const o=v.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(k.isMacintosh){const c=v.screen.getCursorScreenPoint();i=v.screen.getDisplayNearestPoint(c)}!i&&a&&(i=v.screen.getDisplayMatching(a.getBounds())),i||(i=v.screen.getPrimaryDisplay()||o[0])}let r=(0,w.defaultWindowState)();r.x=Math.round(i.bounds.x+i.bounds.width/2-r.width/2),r.y=Math.round(i.bounds.y+i.bounds.height/2-r.height/2);const n=this.configurationService.getValue("window");let s=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")r.mode=0,s=!1;else if(n.newWindowDimensions==="fullscreen")r.mode=3,s=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&a){const c=a.serializeWindowState();c.mode===3?r.mode=3:r=c,s=r.mode!==3&&n.newWindowDimensions==="offset"}}return s&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const a=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;a.some(i=>i.x===h.x||i.y===h.y);)h.x+=30,h.y+=30;return h}};f.windowsStateStorageKey="windowsState",f=ve([X(0,I.IWindowsMainService),X(1,E.IStateMainService),X(2,l.ILifecycleMainService),X(3,m.ILogService),X(4,S.IConfigurationService)],f),e.WindowsStateHandler=f;function C(d){const h={openedWindows:[]},a=d||{openedWindows:[]};return a.lastActiveWindow&&(h.lastActiveWindow=b(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=b(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(h.openedWindows=a.openedWindows.map(i=>b(i))),h}e.restoreWindowsState=C;function b(d){const h={uiState:d.uiState};return d.backupPath&&(h.backupPath=d.backupPath),d.remoteAuthority&&(h.remoteAuthority=d.remoteAuthority),d.folder&&(h.folderUri=M.URI.parse(d.folder)),d.workspaceIdentifier&&(h.workspace={id:d.workspaceIdentifier.id,configPath:M.URI.parse(d.workspaceIdentifier.configURIPath)}),h}function p(d){return{lastActiveWindow:d.lastActiveWindow&&y(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&y(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(h=>y(h))}}e.getWindowsStateStoreData=p;function y(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(J[89],Z([0,1,31,48,123,35,13,9,5,16,7,4,62,27]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function C(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=C;function b(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=b;function p(D){return y(D)||d(D)}e.isStoredWorkspaceFolder=p;function y(D){const T=D;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function d(D){const T=D;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function h(D,T,_,U,Q){if(D.scheme!==U.scheme)return{name:_,uri:D.toString(!0)};let re=T?void 0:Q.relativePath(U,D);if(re!==void 0)re.length===0?re=".":l.isWindows&&(re=a(re));else if(D.scheme===M.Schemas.file)re=D.fsPath,l.isWindows&&(re=a(re));else if(Q.isEqualAuthority(D.authority,U.authority))re=D.path;else return{name:_,uri:D.toString(!0)};return{name:_,path:re}}e.getStoredWorkspaceFolder=h;function a(D){return D=(0,R.normalizeDriveLetter)(D),(0,v.isUNC)(D)||(D=(0,v.toSlashes)(D)),D}function i(D,T,_){const U=[],Q=new Set,re=_.dirname(T);for(const le of D){let ue;if(y(le))le.path&&(ue=_.resolvePath(re,le.path));else if(d(le))try{ue=E.URI.parse(le.uri),ue.path[0]!==S.posix.sep&&(ue=ue.with({path:S.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=_.getComparisonKey(ue);if(!Q.has(se)){Q.add(se);const fe=le.name||_.basenameOrAuthority(ue);U.push(new g.WorkspaceFolder({uri:ue,name:fe,index:U.length},le))}}}return U}e.toWorkspaceFolders=i;function o(D,T,_,U,Q){const re=r(T,D),le=Q.dirname(T),ue=Q.dirname(U),se=[];for(const F of re.folders){const A=y(F)?Q.resolvePath(le,F.path):E.URI.parse(F.uri);let W;_?W=!1:W=!y(F)||(0,S.isAbsolute)(F.path),se.push(h(A,W,F.name,ue,Q))}const fe={insertSpaces:!1,tabSize:4,eol:l.isLinux||l.isMacintosh?`
`:`\r
`},K=k.setProperty(D,["folders"],se,fe);let $=k.applyEdits(D,K);return(0,m.isEqualAuthority)(re.remoteAuthority,(0,w.getRemoteAuthority)(U))&&($=k.applyEdits($,k.removeProperty($,["remoteAuthority"],fe))),$}e.rewriteWorkspaceFileForNewLocation=o;function r(D,T){const _=t.parse(T);if(_&&Array.isArray(_.folders))_.folders=_.folders.filter(U=>p(U));else throw new Error(`${D} looks like an invalid workspace file.`);return _}function n(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function u(D,T){const _={workspaces:[],files:[]};if(D){const U=function(re,le){for(let ue=0;ue<re.length;ue++)try{le(re[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(re[ue])}: ${se.toString()}. Skip entry.`)}},Q=D;Array.isArray(Q.entries)&&U(Q.entries,re=>{const le=re.label,ue=re.remoteAuthority;n(re)?_.workspaces.push({label:le,remoteAuthority:ue,workspace:{id:re.workspace.id,configPath:E.URI.parse(re.workspace.configPath)}}):s(re)?_.workspaces.push({label:le,remoteAuthority:ue,folderUri:E.URI.parse(re.folderUri)}):c(re)&&_.files.push({label:le,remoteAuthority:ue,fileUri:E.URI.parse(re.fileUri)})})}return _}e.restoreRecentlyOpened=u;function P(D){const T={entries:[]};for(const _ of D.workspaces)C(_)?T.entries.push({folderUri:_.folderUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority}):T.entries.push({workspace:{id:_.workspace.id,configPath:_.workspace.configPath.toString()},label:_.label,remoteAuthority:_.remoteAuthority});for(const _ of D.files)T.entries.push({fileUri:_.fileUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority});return T}e.toStoreData=P}),define(J[116],Z([0,1,74,29,13,5,16]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function S(m){function E(){let I=m.scheme===k.Schemas.file?(0,M.originalFSPath)(m):m.toString();return R.isLinux||(I=I.toLowerCase()),(0,v.createHash)("md5").update(I).digest("hex")}return{id:E(),configPath:m}}e.getWorkspaceIdentifier=S;function l(m,E){function I(){if(m.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(m.toString()).digest("hex");if(!E)try{E=(0,t.statSync)(m.fsPath)}catch{return}let g;return R.isLinux?g=E.ino:R.isMacintosh?g=E.birthtime.getTime():R.isWindows&&(typeof E.birthtimeMs=="number"?g=Math.floor(E.birthtimeMs):g=E.birthtime.getTime()),(0,v.createHash)("md5").update(m.fsPath).update(g?String(g):"").digest("hex")}const w=I();if(typeof w=="string")return{id:w,uri:m}}e.getSingleFolderWorkspaceIdentifier=l}),define(J[46],Z([0,1,15,29,3,48,35,2,13,9,16,12,25,176,59,56,26,4,6,20,42,115,27,89,116]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let n=class extends S.Disposable{constructor(c,u,P,D,T,_){super(),this.environmentMainService=c,this.logService=u,this.userDataProfilesMainService=P,this.backupMainService=D,this.dialogMainService=T,this.productService=_,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,u=>(0,t.readFileSync)(u,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,u=>w.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(c,u){if(!!this.isWorkspacePath(c)&&c.scheme===l.Schemas.file)try{const P=u(c.fsPath);return P instanceof Promise?P.then(D=>this.doResolveWorkspace(c,D),D=>{}):this.doResolveWorkspace(c,P)}catch{return}}isWorkspacePath(c){return(0,i.isUntitledWorkspace)(c,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,u){try{const P=this.doParseStoredWorkspace(c,u),D=(0,r.getWorkspaceIdentifier)(c);return{id:D.id,configPath:D.configPath,folders:(0,o.toWorkspaceFolders)(P.folders,D.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(c,u){const P=(0,R.parse)(u);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(D=>(0,o.isStoredWorkspaceFolder)(D));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(c,u){const{workspace:P,storedWorkspace:D}=this.newUntitledWorkspace(c,u),T=P.configPath.fsPath;return await w.Promises.mkdir((0,m.dirname)(T),{recursive:!0}),await w.Promises.writeFile(T,JSON.stringify(D,null,"	")),P}createUntitledWorkspaceSync(c,u){const{workspace:P,storedWorkspace:D}=this.newUntitledWorkspace(c,u),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,m.dirname)(T),{recursive:!0}),(0,w.writeFileSync)(T,JSON.stringify(D,null,"	")),P}newUntitledWorkspace(c=[],u){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,E.joinPath)(this.untitledWorkspacesHome,P),T=(0,E.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),_=[];for(const U of c)_.push((0,o.getStoredWorkspaceFolder)(U.uri,!0,U.name,D,E.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(T),storedWorkspace:{folders:_,remoteAuthority:u}}}async getWorkspaceIdentifier(c){return(0,r.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,i.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const u=(0,E.originalFSPath)(c.configPath);try{(0,w.rimrafSync)((0,m.dirname)(u));const P=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,t.existsSync)(P)&&(0,w.writeFileSync)((0,m.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${u} (${P}).`)}}getUntitledWorkspacesSync(){const c=[];try{const u=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,E.joinPath)(this.untitledWorkspacesHome,P,i.UNTITLED_WORKSPACE_NAME));for(const P of u){const D=(0,r.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?c.push({workspace:D,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return c}async enterWorkspace(c,u,P){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,u,P))return;const T=this.doEnterWorkspace(c,(0,r.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:c,workspace:T.workspace}),T}async isValidTargetWorkspacePath(c,u,P){if(!P)return!0;if((0,i.isWorkspaceIdentifier)(c.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,P))return!1;if((0,a.findWindowOnWorkspaceOrFolder)(u,P)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,E.basename)(P)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,I.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,u){if(!c.config)return;c.focus();let P;return c.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:u,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,i.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=u,c.config.backupPath=P,{workspace:u,backupPath:P}}};n=ve([X(0,b.IEnvironmentMainService),X(1,y.ILogService),X(2,h.IUserDataProfilesMainService),X(3,f.IBackupMainService),X(4,C.IDialogMainService),X(5,d.IProductService)],n),e.WorkspacesManagementMainService=n}),define(J[117],Z([0,1,40,22,4,33,27,46]),function(q,e,v,t,k,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let l=class{constructor(E,I){this.windowsMainService=E,this.workspacesManagementMainService=I}async getRemoteDiagnostics(E){const I=this.windowsMainService.getWindows();return(await Promise.all(I.map(g=>new Promise(f=>{const C=g.remoteAuthority;if(C){const b=`vscode:getDiagnosticInfoResponse${g.id}`,p={includeProcesses:E.includeProcesses,folders:E.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:b,args:p}),v.validatedIpcMain.once(b,(y,d)=>{d||f({hostName:C,errorMessage:`Unable to resolve connection to '${C}'.`}),f(d)}),setTimeout(()=>{f({hostName:C,errorMessage:`Connection to '${C}' could not be established`})},5e3)}else f(void 0)})))).filter(g=>!!g)}getFolderURIs(E){const I=[],w=E.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(w))I.push(w.uri);else if((0,M.isWorkspaceIdentifier)(w)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(w.configPath);g&&g.folders.forEach(C=>{I.push(C.uri)})}return I}};l=ve([X(0,R.IWindowsMainService),X(1,S.IWorkspacesManagementMainService)],l),e.DiagnosticsMainService=l}),define(J[118],Z([0,1,15,23,5,12,7,25,19,58,4,6,112,33,27,46,42]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let p=class{constructor(d,h,a,i,o,r){this.logService=d,this.windowsMainService=h,this.urlService=a,this.workspacesManagementMainService=i,this.configurationService=o,this.userDataProfilesMainService=r}async start(d,h){this.logService.trace("Received data from other instance: ",d,h),k.isMacintosh&&v.app.focus({steal:!0});const a=this.parseOpenUrl(d);if(a.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:o,url:r}of a)this.urlService.open(o,{originalUrl:r})})}else return this.startOpenWindow(d,h)}parseOpenUrl(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,t.coalesce)(d._urls.map(h=>{try{return{uri:M.URI.parse(h),url:h}}catch{return null}})):[]}async startOpenWindow(d,h){const a=(0,m.isLaunchedFromCli)(h)?0:4;let i=[];const o=d.wait&&d.waitMarkerFilePath?M.URI.file(d.waitMarkerFilePath):void 0,r=d.remote||void 0,n=this.userDataProfilesMainService.checkAndCreateProfileFromCli(d);n&&await n;const s={context:a,cli:d,userEnv:h,waitMarkerFileURI:o,remoteAuthority:r};if(d.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,s);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let c=!1;if(d["new-window"]||d["unity-launch"])c=!0;else if(d["reuse-window"])c=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":c=!0;break;case"off":c=!1;break;default:c=!k.isMacintosh}if(c)i=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const u=this.windowsMainService.getLastActiveWindow();u?(this.windowsMainService.openExistingWindow(u,s),i=[u]):i=this.windowsMainService.open({...s,forceEmpty:!0})}}else i=this.windowsMainService.open({...s,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(o&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,S.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const d=[];return v.BrowserWindow.getAllWindows().forEach(h=>{const a=this.windowsMainService.getWindowById(h.id);a?d.push(this.codeWindowToInfo(a)):d.push(this.browserWindowToInfo(h))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}getFolderURIs(d){const h=[],a=d.openedWorkspace;if((0,f.isSingleFolderWorkspaceIdentifier)(a))h.push(a.uri);else if((0,f.isWorkspaceIdentifier)(a)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(a.configPath);i&&i.folders.forEach(r=>{h.push(r.uri)})}return h}codeWindowToInfo(d){const h=this.getFolderURIs(d),a=(0,R.assertIsDefined)(d.win);return this.browserWindowToInfo(a,h,d.remoteAuthority)}browserWindowToInfo(d,h=[],a){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:h,remoteAuthority:a}}};p=ve([X(0,I.ILogService),X(1,g.IWindowsMainService),X(2,w.IURLService),X(3,C.IWorkspacesManagementMainService),X(4,l.IConfigurationService),X(5,b.IUserDataProfilesMainService)],p),e.LaunchMainService=p}),define(J[64],Z([0,1,50,15,30,141,52,3,35,2,13,9,5,7,95,94,25,90,166,56,26,4,21,6,20,63,33,27,46,17]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r,n,s,c,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let D=class extends m.Disposable{constructor(_,U,Q,re,le,ue,se,fe,K){super(),this.sharedProcess=_,this.windowsMainService=U,this.dialogMainService=Q,this.lifecycleMainService=re,this.environmentMainService=le,this.logService=ue,this.productService=se,this.themeMainService=fe,this.workspacesManagementMainService=K,this.onDidOpenWindow=S.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:$,x:F,y:A})=>({windowId:$.id,x:F,y:A})),({windowId:$})=>!!this.windowsMainService.getWindowById($)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",($,F)=>F.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",($,F)=>F.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-blur",($,F)=>F.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-focus",($,F)=>F.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new S.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",($,F,A)=>A),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),S.Event.fromNodeEventEmitter(t.screen,"display-added"),S.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(_){return this.windowsMainService.getWindowCount()}async getActiveWindowId(_){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(_,U,Q){return Array.isArray(U)?this.doOpenWindow(_,U,Q):this.doOpenEmptyWindow(_,U)}async doOpenWindow(_,U,Q=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:_,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:Q.forceNewWindow,forceReuseWindow:Q.forceReuseWindow,preferNewWindow:Q.preferNewWindow,diffMode:Q.diffMode,mergeMode:Q.mergeMode,addMode:Q.addMode,gotoLineMode:Q.gotoLineMode,noRecentEntry:Q.noRecentEntry,waitMarkerFileURI:Q.waitMarkerFileURI,remoteAuthority:Q.remoteAuthority||void 0})}async doOpenEmptyWindow(_,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:_},U)}async toggleFullScreen(_){this.windowById(_)?.toggleFullScreen()}async handleTitleDoubleClick(_){this.windowById(_)?.handleTitleDoubleClick()}async isMaximized(_){const U=this.windowById(_);return U?.win?U.win.isMaximized():!1}async maximizeWindow(_){const U=this.windowById(_);U?.win&&U.win.maximize()}async unmaximizeWindow(_){const U=this.windowById(_);U?.win&&U.win.unmaximize()}async minimizeWindow(_){const U=this.windowById(_);U?.win&&U.win.minimize()}async updateWindowControls(_,U){const Q=this.windowById(_);Q&&Q.updateWindowControls(U)}async focusWindow(_,U){U&&typeof U.windowId=="number"&&(_=U.windowId),this.windowById(_)?.focus({force:U?.force??!1})}async setMinimumSize(_,U,Q){const re=this.windowById(_);if(re?.win){const[le,ue]=re.win.getSize(),[se,fe]=re.win.getMinimumSize(),[K,$]=[U??se,Q??fe],[F,A]=[Math.max(le,K),Math.max(ue,$)];(se!==K||fe!==$)&&re.win.setMinimumSize(K,$),(le!==F||ue!==A)&&re.win.setSize(F,A)}}async saveWindowSplash(_,U){this.themeMainService.saveWindowSplash(_,U)}async installShellCommand(_){const{source:U,target:Q}=await this.getShellCommandLink();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(U);if(re&&!re.dangling){const le=await(0,f.realpath)(U);if(Q===le)return}await b.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(Q,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:le}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,l.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(le===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Q}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(ue)}catch{throw new Error((0,y.localize)(3,null,U))}}}async uninstallShellCommand(_){const{source:U}=await this.getShellCommandLink();try{await b.Promises.unlink(U)}catch(Q){switch(Q.code){case"EACCES":{const{response:re}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,l.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(le)}catch{throw new Error((0,y.localize)(7,null,U))}break}case"ENOENT":break;default:throw Q}}}async getShellCommandLink(){const _=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(_))throw new Error((0,y.localize)(8,null,_));return{source:U,target:_}}async showMessageBox(_,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(_))}async showSaveDialog(_,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(_))}async showOpenDialog(_,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(_))}toBrowserWindow(_){const U=this.windowById(_);if(U?.win)return U.win}async pickFileFolderAndOpen(_,U){const Q=await this.dialogMainService.pickFileFolder(U);Q&&this.doOpenPicked(await Promise.all(Q.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),U,_)}async pickFolderAndOpen(_,U){const Q=await this.dialogMainService.pickFolder(U);Q&&this.doOpenPicked(Q.map(re=>({folderUri:g.URI.file(re)})),U,_)}async pickFileAndOpen(_,U){const Q=await this.dialogMainService.pickFile(U);Q&&this.doOpenPicked(Q.map(re=>({fileUri:g.URI.file(re)})),U,_)}async pickWorkspaceAndOpen(_,U){const Q=await this.dialogMainService.pickWorkspace(U);Q&&this.doOpenPicked(Q.map(re=>({workspaceUri:g.URI.file(re)})),U,_)}doOpenPicked(_,U,Q){this.windowsMainService.open({context:3,contextWindowId:Q,cli:this.environmentMainService.args,urisToOpen:_,forceNewWindow:U.forceNewWindow})}async showItemInFolder(_,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(_,U){this.windowById(_)?.setRepresentedFilename(U)}async setDocumentEdited(_,U){this.windowById(_)?.setDocumentEdited(U)}async openExternal(_,U){return w.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(_){const U=process.env.GDK_PIXBUF_MODULE_FILE,Q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(_),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=Q}moveItemToTrash(_,U){return t.shell.trashItem(U)}async isAdmin(){let _;return w.isWindows?_=(await new Promise((U,Q)=>{q(["native-is-elevated"],U,Q)}))():_=process.getuid()===0,_}async writeElevated(_,U,Q,re){const le=await new Promise((ue,se)=>{q(["@vscode/sudo-prompt"],ue,se)});return new Promise((ue,se)=>{const fe=[`"${this.cliPath}"`];re?.unlock&&fe.push("--file-chmod"),fe.push("--file-write",`"${U.fsPath}"`,`"${Q.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:w.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(fe.join(" "),K,($,F,A)=>{F&&this.logService.trace(`[sudo-prompt] received stdout: ${F}`),A&&this.logService.trace(`[sudo-prompt] received stderr: ${A}`),$?se($):ue(void 0)})})}get cliPath(){return w.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):w.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return C.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(_,U,Q){process.kill(U,Q)}async readClipboardText(_,U){return t.clipboard.readText(U)}async writeClipboardText(_,U,Q){return t.clipboard.writeText(U,Q)}async readClipboardFindText(_){return t.clipboard.readFindText()}async writeClipboardFindText(_,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(_,U,Q,re){return t.clipboard.writeBuffer(U,Buffer.from(Q.buffer),re)}async readClipboardBuffer(_,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(_,U,Q){return t.clipboard.has(U,Q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(_,U){this.windowById(_)?.updateTouchBar(U)}async notifyReady(_){this.windowById(_)?.setReady()}async relaunch(_,U){return this.lifecycleMainService.relaunch(U)}async reload(_,U){const Q=this.windowById(_);if(Q){if((0,c.isWorkspaceIdentifier)(Q.openedWorkspace)){const re=Q.openedWorkspace.configPath;if(re.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(Q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(_){this.closeWindowById(_,_)}async closeWindowById(_,U){const Q=this.windowById(U);if(Q?.win)return Q.win.close()}async quit(_){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(_,U){await this.lifecycleMainService.kill(U)}async resolveProxy(_,U){const re=this.windowById(_)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(_,U,Q,re,le=1){return(0,p.findFreePort)(U,Q,re,le)}async openDevTools(_,U){const Q=this.windowById(_);Q?.win&&Q.win.webContents.openDevTools(U)}async toggleDevTools(_){const U=this.windowById(_);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(_,U){const Q=this.windowById(_);Q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&Q.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(_,U,Q,re){if(!w.isWindows)return;const le=await new Promise((ue,se)=>{q(["@vscode/windows-registry"],ue,se)});try{return le.GetStringRegKey(U,Q,re)}catch{return}}windowById(_){if(typeof _=="number")return this.windowsMainService.getWindowById(_)}};ve([M.memoize],D.prototype,"cliPath",null),D=ve([X(1,s.IWindowsMainService),X(2,d.IDialogMainService),X(3,i.ILifecycleMainService),X(4,h.IEnvironmentMainService),X(5,o.ILogService),X(6,r.IProductService),X(7,n.IThemeMainService),X(8,u.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(J[259],Z([0,1,15,40,30,35,2,13,5,143,164,100,117,56,26,4,118,6,64,53,20,60,72]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,C.createDecorator)("issueMainService");let o=class Wt{constructor(n,s,c,u,P,D,T,_,U,Q){this.userEnv=n,this.environmentMainService=s,this.launchMainService=c,this.logService=u,this.diagnosticsService=P,this.diagnosticsMainService=D,this.dialogMainService=T,this.nativeHostMainService=_,this.protocolMainService=U,this.productService=Q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[s,c]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),u=await this.diagnosticsService.getSystemInfo(s,c);this.safeSend(n,"vscode:issueSystemInfoResponse",u)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const s=[];try{const c=await this.launchMainService.getMainProcessId();s.push({name:(0,E.localize)(0,null),rootProcess:await(0,m.listProcesses)(c)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,I.isRemoteDiagnosticError)(P)?s.push({name:P.hostName,rootProcess:P}):P.processes&&s.push({name:P.hostName,rootProcess:P.processes})})}catch(c){this.logService.error(`Listing processes failed: ${c}`)}this.safeSend(n,"vscode:listProcessesResponse",s)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const s={title:this.productService.nameLong,message:(0,E.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const c=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",c.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const s=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",s)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,E.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,s)=>{const{id:c,from:u,args:P}=s;let D;switch(u){case"issueReporter":D=this.issueReporterParentWindow;break;case"processExplorer":D=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${u}`)}D?.webContents.send("vscode:runAction",{id:c,from:u,args:P})}),t.validatedIpcMain.on("vscode:openExternal",(n,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",s.windows)})}safeSend(n,s,...c){n.sender.isDestroyed()||n.sender.send(s,...c)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,c=s.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,c,{backgroundColor:n.styles.backgroundColor,title:(0,E.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:d.default}),this.issueReporterWindow.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,c=s.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,c,{backgroundColor:n.styles.backgroundColor,title:(0,E.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),c.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:d.default}),this.processExplorerWindow.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,s,c,u){const P=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:c.title,backgroundColor:c.backgroundColor||Wt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,`--vscode-window-kind=${u}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.zoomLevelToZoomFactor)(c.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}async getSystemStatus(){const[n,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,s)}getWindowPosition(n,s,c){let u;const P=v.screen.getAllDisplays();if(P.length===1)u=P[0];else{if(l.isMacintosh){const _=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(_)}!u&&n&&(u=v.screen.getDisplayMatching(n.getBounds())),u||(u=v.screen.getPrimaryDisplay()||P[0])}const D={width:s,height:c},T=u.bounds;return D.x=T.x+T.width/2-D.width/2,D.y=T.y+T.height/2-D.height/2,T.width>0&&T.height>0&&(D.x<T.x&&(D.x=T.x),D.y<T.y&&(D.y=T.y),D.x>T.x+T.width&&(D.x=T.x),D.y>T.y+T.height&&(D.y=T.y),D.width>T.width&&(D.width=T.width),D.height>T.height&&(D.height=T.height)),D}async getPerformanceInfo(){try{const[n,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,s)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=ve([X(1,f.IEnvironmentMainService),X(2,b.ILaunchMainService),X(3,p.ILogService),X(4,I.IDiagnosticsService),X(5,w.IDiagnosticsMainService),X(6,g.IDialogMainService),X(7,y.INativeHostMainService),X(8,a.IProtocolMainService),X(9,h.IProductService)],o),e.IssueMainService=o}),define(J[260],Z([0,1,22,19,26,21,6,64,20,54,38,45,86]),function(q,e,v,t,k,R,M,S,l,m,E,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends w.AbstractUpdateService{constructor(C,b,p,y,d,h,a,i){super(C,b,y,d,h,i),this.telemetryService=p,this.nativeHostMainService=a}buildUpdateFeedUrl(C){return(0,w.createUpdateURL)(`linux-${process.arch}`,C,this.productService)}doCheckForUpdates(C){!this.url||(this.setState(I.State.CheckingForUpdates(C)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!C}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!C});const p=C?b.message||b:void 0;this.setState(I.State.Idle(1,p))}))}async doDownloadUpdate(C){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):C.update.url&&this.nativeHostMainService.openExternal(void 0,C.update.url),this.setState(I.State.Idle(1))}};g=ve([X(0,R.ILifecycleMainService),X(1,t.IConfigurationService),X(2,E.ITelemetryService),X(3,k.IEnvironmentMainService),X(4,m.IRequestService),X(5,M.ILogService),X(6,S.INativeHostMainService),X(7,l.IProductService)],g),e.LinuxUpdateService=g}),define(J[261],Z([0,1,50,29,30,8,22,52,9,7,127,25,19,26,14,21,6,64,20,54,38,45,86]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(c,u=1e3){for(;!c();)await(0,R.timeout)(u)}let r;function n(){return typeof r>"u"&&(r=t.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends i.AbstractUpdateService{constructor(u,P,D,T,_,U,Q,re,le){super(u,P,T,_,U,le),this.telemetryService=D,this.fileService=Q,this.nativeHostMainService=re}get cachePath(){const u=l.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(u,{recursive:!0}).then(()=>u)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(u){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,i.createUpdateURL)(P,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(a.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},M.CancellationToken.None).then(d.asJson).then(P=>{const D=n();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(a.State.Idle(D)),Promise.resolve(null)):D===1?(this.setState(a.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(a.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>I.Promises.exists(T).then(_=>{if(_)return Promise.resolve(T);const U=P.url,Q=P.hash,re=`${T}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(le=>this.fileService.writeFile(m.URI.file(re),le.stream)).then(Q?()=>(0,E.checksum)(re,P.hash):()=>{}).then(()=>I.Promises.rename(re,T)).then(()=>T)})).then(T=>{const _=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},_&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(P)):this.setState(a.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const D=u?P.message||P:void 0;this.setState(a.State.Idle(n(),D))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(a.State.Idle(n()))}async getUpdatePackagePath(u){const P=await this.cachePath;return l.join(P,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const P=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,D=await this.cachePath,_=(await I.Promises.readdir(D)).filter(P).map(async U=>{try{await I.Promises.unlink(l.join(D,U))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(a.State.Updating(u));const P=await this.cachePath;this.availableUpdate.updateFilePath=l.join(P,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(a.State.Idle(n()))});const T=`${this.productService.win32MutexName}-ready`,_=await new Promise((U,Q)=>{q(["windows-mutex"],U,Q)});o(()=>_.isActive(T)).then(()=>this.setState(a.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(u){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(a.State.Downloading(D)),this.availableUpdate={packagePath:u},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(D)):this.setState(a.State.Ready(D))}};ve([S.memoize],s.prototype,"cachePath",null),s=ve([X(0,C.ILifecycleMainService),X(1,w.IConfigurationService),X(2,h.ITelemetryService),X(3,g.IEnvironmentMainService),X(4,d.IRequestService),X(5,b.ILogService),X(6,f.IFileService),X(7,p.INativeHostMainService),X(8,y.IProductService)],s),e.Win32UpdateService=s}),define(J[262],Z([0,1,15,8,22,43,3,35,2,13,9,82,5,7,172,59,19,56,26,58,14,21,6,20,60,229,88,38,232,63,72,33,27,46,113,121,37,41,53,42]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r,n,s,c,u,P,D,T,_,U,Q,re,le,ue,se,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(K||(K={}));let $=class Rt extends l.Disposable{constructor(A,W,z,ee,B,H,L,O,N,V,x,ne,j,te,ie,ae,de,ge,we){super(),this.logService=W,this.environmentMainService=z,this.policyService=ee,this.userDataProfilesService=B,this.fileService=H,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=N,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=ne,this.telemetryService=j,this.dialogMainService=te,this.lifecycleMainService=ie,this.productService=ae,this.protocolMainService=de,this.windowsMainService=ge,this.stateMainService=we,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Se,Ee]=this.restoreWindowState(A.state);this.windowState=Se,this.logService.trace("window#ctor: using window state",Se);const We=this.windowState.mode===0||this.windowState.mode===3,Re=this.configurationService.getValue("window");let Ie=!1;typeof Re?.experimental?.useSandbox=="boolean"?Ie=Re.experimental.useSandbox:Ie=typeof se.default.quality=="string"&&se.default.quality!=="stable";const De={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!We,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(Re?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...Ie?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};w.isLinux?De.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):w.isWindows&&!this.environmentMainService.isBuilt&&(De.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),w.isMacintosh&&!this.useNativeFullScreen()&&(De.fullscreenable=!1),w.isMacintosh&&(De.acceptFirstMouse=!0,Re?.clickThroughInactive===!1&&(De.acceptFirstMouse=!1));const Y=w.isMacintosh&&Re?.nativeTabs===!0;Y&&(De.tabbingIdentifier=this.productService.nameShort);const ce=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ce&&(De.titleBarStyle="hidden",w.isMacintosh||(De.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Pe=re.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";De.titleBarOverlay={height:29,color:he,symbolColor:Pe},this.hasWindowControlOverlay=!0}if((0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(De),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,w.isMacintosh&&ce&&this._win.setSheetOffset(22),ce&&(w.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||w.isMacintosh)){const he=this.stateMainService.getItem(Rt.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}w.isWindows&&ce&&this._win.hookWindowMessage(278,()=>{const[Pe,ke]=this._win.getPosition(),Ne=v.screen.getCursorScreenPoint(),Ue=Ne.x-Pe,xe=Ne.y-ke;return(()=>!(Ue>30&&xe>=0&&xe<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Ue,y:xe})),0}),(w.isMacintosh||w.isWindows)&&Ee&&(!Y||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),We&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get previousWorkspace(){return this._previousWorkspace}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){w.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return w.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){w.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return w.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){w.isMacintosh&&A?.force&&v.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){z.dispose(),ee.dispose(),A()}const z=this.onDidClose(()=>W()),ee=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(W,z,ee)=>this.onWindowError(3,{reason:ee,exitCode:z})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,z)=>{const ee=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,ee)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,f.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,f.localize)(1,null)),(0,S.mnemonicButtonLabel)((0,f.localize)(2,null))],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,f.localize)(5,null):void 0},this._win);if(z.response!==1){const ee=z.response===0;this.destroyWindow(ee,z.checkboxChecked)}}else if(A===2){let z;W?z=(0,f.localize)(7,null,W.reason,W.exitCode??"<unknown>"):z=(0,f.localize)(6,null);const ee=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,f.localize)(8,null)),(0,S.mnemonicButtonLabel)((0,f.localize)(9,null))],message:z,detail:(0,f.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,f.localize)(11,null):void 0},this._win),B=ee.response===0;this.destroyWindow(B,ee.checkboxChecked)}break}}async destroyWindow(A,W){const z=this._config?.workspace;if(W&&z)try{const ee=this.storageMainService.workspaceStorage(z);await ee.init(),ee.delete("memento/workbench.parts.editor"),await ee.close()}catch(ee){this.logService.error(ee)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let ee,B;(0,_.isSingleFolderWorkspaceIdentifier)(z)?ee={folderUri:z.uri}:(0,_.isWorkspaceIdentifier)(z)?ee={workspaceUri:z.configPath}:B=!0;const[H]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ee?[ee]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const ee=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||ee!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=ee;const B=z||"",H=ee?`${ee},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(A){w.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this._previousWorkspace=this.openedWorkspace,this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:z?2:1})}updateConfiguration(A,W){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const ee=(0,d.isLaunchedFromCli)(z)&&!(0,d.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(ee||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),A.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,_.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}else if((0,_.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,Q.defaultWindowState)();if(this.isFullScreen){let z;try{z=v.screen.getDisplayMatching(this.getBounds())}catch{}const ee=(0,Q.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||ee.width,height:this.windowState.height||ee.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!w.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let z;W===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Rt.windowControlHeightStateStorageKey,A.height),w.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):w.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,I.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const z=v.screen.getAllDisplays();W=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[A||(0,Q.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let H=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),H(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),H()}return A}if(A.display&&A.mode===3){const B=W.find(H=>H.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,Q.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let z,ee;try{z=v.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),ee=this.getWorkingArea(z)}catch{}if(z&&ee&&A.x+A.width>ee.x&&A.y+A.height>ee.y&&A.x<ee.x+ee.width&&A.y<ee.y+ee.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ee),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[z,ee]=this._win.getSize();return{x:A,y:W,width:z,height:ee}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return w.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){w.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){w.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,f.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...z)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!w.isMacintosh||this.touchBarGroups.forEach((W,z)=>{const ee=A[z];W.segments=this.createTouchBarGroupSegments(ee)})}createTouchBar(){if(!!w.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),z=new v.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:ee=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[ee].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let ee;z.icon&&!u.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===m.Schemas.file&&(ee=v.nativeImage.createFromPath(g.URI.revive(z.icon.dark).fsPath),ee.isEmpty()&&(ee=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:ee?void 0:B,icon:ee}})}dispose(){super.dispose(),this._win=null}};$.windowControlHeightStateStorageKey="windowControlHeight",$=ve([X(1,i.ILogService),X(2,y.IEnvironmentMainService),X(3,le.IPolicyService),X(4,fe.IUserDataProfilesMainService),X(5,h.IFileService),X(6,s.IApplicationStorageMainService),X(7,s.IStorageMainService),X(8,b.IConfigurationService),X(9,P.IThemeMainService),X(10,U.IWorkspacesManagementMainService),X(11,C.IBackupMainService),X(12,c.ITelemetryService),X(13,p.IDialogMainService),X(14,a.ILifecycleMainService),X(15,o.IProductService),X(16,r.IProtocolMainService),X(17,T.IWindowsMainService),X(18,ue.IStateMainService)],$),e.CodeWindow=$}),define(J[73],Z([0,1,15,23,8,3,35,2,13,5,16,7,25,175,4,21,6,88,89,27,46]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,f.createDecorator)("workspacesHistoryMainService");let a=class nt extends S.Disposable{constructor(o,r,n,s){super(),this.logService=o,this.workspacesManagementMainService=r,this.lifecycleMainService=n,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){const r=[],n=[];for(const s of o)if((0,y.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(r,s.workspace)===-1&&r.push(s);else if((0,y.isRecentFolder)(s))this.indexOfFolder(r,s.folderUri)===-1&&r.push(s);else{const c=this.indexOfFile(n,s.fileUri)>=0,u=s.fileUri.scheme===l.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,E.basename)(s.fileUri))>=0;!c&&!u&&(n.push(s),m.isWindows&&s.fileUri.scheme===l.Schemas.file&&v.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(r,n),r.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=nt.MAX_TOTAL_RECENT_ENTRIES),n.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:r,files:n}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const r=u=>{const P=this.location(u);for(const D of o)if(E.extUriBiasedIgnorePathCase.isEqual(D,P))return!1;return!0},n=await this.getRecentlyOpened(),s=n.workspaces.filter(r),c=n.files.filter(r);(s.length!==n.workspaces.length||c.length!==n.files.length)&&(await this.saveRecentlyOpened({files:c,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const o=[],r=[];return await this.addEntriesFromStorage(o,r),{workspaces:o,files:r}}async addEntriesFromStorage(o,r){const n=await this.getRecentlyOpenedFromStorage();for(const s of n.workspaces){const c=(0,y.isRecentFolder)(s)?this.indexOfFolder(o,s.folderUri):this.indexOfWorkspace(o,s.workspace);c>=0?o[c].label=o[c].label||s.label:o.push(s)}for(const s of n.files){const c=this.indexOfFile(r,s.fileUri);c>=0?r[c].label=r[c].label||s.label:r.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const r=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof r=="string")try{o=JSON.parse(r)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,y.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,y.toStoreData)(o)),-1,1)}location(o){return(0,y.isRecentFolder)(o)?o.folderUri:(0,y.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,r){return o.findIndex(n=>(0,y.isRecentWorkspace)(n)&&n.workspace.id===r.id)}indexOfFolder(o,r){return o.findIndex(n=>(0,y.isRecentFolder)(n)&&E.extUriBiasedIgnorePathCase.isEqual(n.folderUri,r))}indexOfFile(o,r){return o.findIndex(n=>E.extUriBiasedIgnorePathCase.isEqual(n.fileUri,r))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const c of v.app.getJumpListSettings().removedItems){const u=c.args;if(u){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);P&&r.push(I.URI.parse(P[2]))}}await this.removeRecentlyOpened(r);let n=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(c=>{const u=(0,y.isRecentWorkspace)(c)?c.workspace:c.folderUri,{title:P,description:D}=this.getWindowsJumpListLabel(u,c.label);let T;return I.URI.isUri(u)?T=`--folder-uri "${u.toString()}"`:(n=!0,T=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:D.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&o.push({type:"custom",name:n?(0,g.localize)(2,null):(0,g.localize)(3,null),items:s})}o.push({type:"recent"});try{const r=v.app.setJumpList(o);r&&r!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.logService.warn("updateWindowsJumpList#setJumpList",r)}}getWindowsJumpListLabel(o,r){if(r)return{title:(0,M.splitName)(r).name,description:r};if(I.URI.isUri(o))return{title:(0,E.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,g.localize)(4,null),description:""};let n=(0,E.basename)(o.configPath);return n.endsWith(d.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,n),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,M.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),r=[];let n=0;for(let c=0;c<o.workspaces.length&&n<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;c++){const u=this.location(o.workspaces[c]);if(u.scheme===l.Schemas.file){const P=(0,E.originalFSPath)(u);await w.Promises.exists(P)&&(r.push(P),n++)}}const s=[];for(let c=0;c<o.files.length&&n<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;c++){const u=this.location(o.files[c]);if(u.scheme===l.Schemas.file){const P=(0,E.originalFSPath)(u);if(nt.COMMON_FILES_FILTER.includes((0,E.basename)(u))||r.includes(P))continue;await w.Promises.exists(P)&&(s.push(P),n++)}}s.reverse().forEach(c=>v.app.addRecentDocument(c)),r.reverse().forEach(c=>v.app.addRecentDocument(c))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ve([X(0,b.ILogService),X(1,h.IWorkspacesManagementMainService),X(2,C.ILifecycleMainService),X(3,p.IApplicationStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(J[263],Z([0,1,15,8,22,35,5,7,165,19,26,21,6,210,64,20,41,38,45,72,33,73]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let o=class Lt{constructor(s,c,u,P,D,T,_,U,Q,re,le){this.updateService=s,this.configurationService=c,this.windowsMainService=u,this.environmentMainService=P,this.telemetryService=D,this.workspacesHistoryMainService=T,this.stateMainService=_,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=re,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Lt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,_,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,_,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,_,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,_,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,_,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Lt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=v.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(M.isMacintosh?new v.Menu:null);return}const c=new v.Menu;let u;if(M.isMacintosh){const D=new v.Menu;u=new v.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),c.append(u)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new v.Menu;D.append(new v.MenuItem({label:this.mnemonicLabel(l.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(1,null)),submenu:D});this.setMenuById(D,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(4,null)),submenu:D});this.setMenuById(D,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),c.append(T)}let P;if(this.shouldDrawMenu("Window")){const D=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(l.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(P&&c.append(P),this.shouldDrawMenu("Help")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),c.append(T)}c.items&&c.items.length>0?v.Menu.setApplicationMenu(c):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(l.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ue=new v.Menu;this.setMenuById(ue,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(l.localize(11,null)),submenu:ue})}const D=new v.Menu,T=new v.MenuItem({label:l.localize(12,null),role:"services",submenu:D}),_=new v.MenuItem({label:l.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new v.MenuItem({label:l.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new v.MenuItem({label:l.localize(15,null),role:"unhide"}),re=new v.MenuItem(this.likeAction("workbench.action.quit",{label:l.localize(16,null,this.productService.nameLong),click:async(ue,se,fe)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(fe)&&this.nativeHostMainService.quit(void 0)}})),le=[c];le.push(...u),P&&le.push(r(),P),le.push(r(),T,r(),_,U,Q,r(),re),le.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const u={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(l.localize(17,null)),(0,R.mnemonicButtonLabel)(l.localize(18,null))],message:l.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,u);return P===0}return!0}shouldDrawMenu(s){if(!M.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(u=>{if((0,g.isMenubarMenuItemSeparator)(u))s.append(r());else if((0,g.isMenubarMenuItemSubmenu)(u)){const P=new v.Menu,D=new v.MenuItem({label:this.mnemonicLabel(u.label),submenu:P});this.setMenu(P,u.submenu.items),s.append(D)}else(0,g.isMenubarMenuItemRecentAction)(u)?s.append(this.createOpenRecentMenuItem(u)):(0,g.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?s.append(new v.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):s.append(this.createMenuItem(u.label,u.id,!1,u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(u=>s.append(u)),s.append(r()))}createOpenRecentMenuItem(s){const c=S.URI.revive(s.uri),u=s.id,P=u==="openRecentFile"?{fileUri:c}:u==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new v.MenuItem(this.likeAction(u,{label:s.label,click:(D,T,_)=>{const U=this.isOptionClick(_);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,u){const P={label:this.mnemonicLabel(s),role:u,enabled:!0};return new v.MenuItem(this.withKeybinding(c,P))}setMacWindowMenu(s){const c=new v.MenuItem({label:l.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new v.MenuItem({label:l.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:l.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(l.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(r()),T.push(this.createMenuItem(l.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(l.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(l.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(l.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(l.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,u,r(),D,...T,r(),P].forEach(_=>s.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:l.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:l.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:l.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,u,P){const D=this.mnemonicLabel(s),T=typeof c=="function"?c:(le,ue,se)=>{const fe=le?le.userSettingsLabel:null;let K=c;Array.isArray(c)&&(K=this.isOptionClick(se)?c[1]:c[0]),fe&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:fe}):this.runActionInRenderer({type:"commandId",commandId:K})},_=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,Q={label:D,click:T,enabled:_};U&&(Q.type="checkbox",Q.checked=U);let re;return typeof c=="string"?re=c:Array.isArray(c)&&(re=c[0]),M.isMacintosh&&(re==="editor.action.clipboardCutAction"?Q.role="cut":re==="editor.action.clipboardCopyAction"?Q.role="copy":re==="editor.action.clipboardPasteAction"&&(Q.role="paste"),re==="undo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(re,Q))}makeContextAwareClickHandler(s,c){return(u,P,D)=>{const T=v.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(u,P||T,D)}}runActionInRenderer(s){let c=v.BrowserWindow.getFocusedWindow();if(!c){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(c=P.win)}const u=c?this.windowsMainService.getWindowById(c.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const P={id:s.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:s.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const u=typeof s=="string"?this.keybindings[s]:void 0;if(u?.label){if(u.isNative!==!1)c.accelerator=u.label,c.userSettingsLabel=u.userSettingsLabel;else if(typeof c.label=="string"){const P=c.label.indexOf("[");P>=0?c.label=`${c.label.substr(0,P)} [${u.label}]`:c.label=`${c.label} [${u.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,u=!c.accelerator){u&&(c=this.withKeybinding(s,c));const P=c.click;return c.click=(D,T,_)=>{this.reportMenuActionTelemetry(s),P?.(D,T,_)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:i})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([X(0,y.IUpdateService),X(1,m.IConfigurationService),X(2,h.IWindowsMainService),X(3,E.IEnvironmentMainService),X(4,p.ITelemetryService),X(5,a.IWorkspacesHistoryMainService),X(6,b.IStateMainService),X(7,I.ILifecycleMainService),X(8,w.ILogService),X(9,f.INativeHostMainService),X(10,C.IProductService)],o),e.Menubar=o;function r(){return new v.MenuItem({type:"separator"})}}),define(J[264],Z([0,1,4,21,6,263]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let M=class{constructor(l,m,E){this.instantiationService=l,this.lifecycleMainService=m,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(l,m){this.logService.trace("menubarService#updateMenubar",l),(await this.menubar).updateMenu(m,l)}};M=ve([X(0,v.IInstantiationService),X(1,t.ILifecycleMainService),X(2,k.ILogService)],M),e.MenubarMainService=M}),define(J[265],Z([0,1,15,29,30,23,22,3,31,47,35,2,13,9,82,5,34,16,12,7,173,59,19,56,26,14,4,21,6,53,20,60,62,41,72,262,115,258,27,116,73,46,63,37,42]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r,n,s,c,u,P,D,T,_,U,Q,re,le,ue,se,fe,K,$,F,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(H){return(0,se.isWorkspaceIdentifier)(H?.workspace)}function ee(H){return(0,se.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class lt extends I.Disposable{constructor(L,O,N,V,x,ne,j,te,ie,ae,de,ge,we,Se,Ee,We,Re,Ie){super(),this.machineId=L,this.initialUserEnv=O,this.logService=N,this.stateMainService=V,this.policyService=x,this.environmentMainService=ne,this.userDataProfilesMainService=j,this.lifecycleMainService=te,this.backupMainService=ie,this.configurationService=ae,this.workspacesHistoryMainService=de,this.workspacesManagementMainService=ge,this.instantiationService=we,this.dialogMainService=Se,this.fileService=Ee,this.productService=We,this.protocolMainService=Re,this.themeMainService=Ie,this._onDidOpenWindow=this._register(new S.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new S.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new S.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new S.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new S.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new I.DisposableStore;if(O.add(S.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const N of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const N=this.environmentMainService.args,V=O?.remoteAuthority||void 0,x=!0,ne=O?.forceReuseWindow,j=!ne;return this.open({...L,cli:N,forceEmpty:x,forceNewWindow:j,forceReuseWindow:ne,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],N=[],V=[],x=[],ne=[];let j,te=0;const ie=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const Se of ie)ee(Se)?L.addMode?O.push(Se):N.push(Se):z(Se)?V.push(Se):Se.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),j.filesToOpenOrCreate.push(Se)):Se.backupPath?ne.push({backupFolder:(0,g.basename)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):te++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...x),ne.push(...this.backupMainService.getEmptyWindowBackupPaths())):ne.length=0;const{windows:ae,filesOpenedInWindow:de}=this.doOpen(L,V,N,ne,te,j,O);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${N.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${te})`),ae.length>1)if(de)de.focus();else{const Se=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ee=!0,We=!0;if(Se){const Re=ae.filter(Ie=>this.windowsStateHandler.state.lastActiveWindow&&Ie.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Re.length&&(Re[0].focus(),Ee=!1,We=!1)}if(Ee)for(let Re=ae.length-1;Re>=0;Re--){const Ie=ae[Re];if(!(Ie.openedWorkspace&&x.some(De=>Ie.openedWorkspace&&De.workspace.id===Ie.openedWorkspace.id)||Ie.backupPath&&ne.some(De=>Ie.backupPath&&De.backupFolder===(0,g.basename)(Ie.backupPath)))){Ie.focus(),We=!1;break}}We&&ae[ae.length-1].focus()}const ge=j&&j.filesToDiff.length>0,we=j&&j.filesToMerge.length>0;if(!ae.some(Se=>Se.isExtensionDevelopmentHost)&&!ge&&!we&&!L.noRecentEntry){const Se=[];for(const Ee of ie)z(Ee)&&!Ee.transient?Se.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):ee(Ee)?Se.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&Se.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Se)}return this.handleWaitMarkerFile(L,ae),ae}handleWaitMarkerFile(L,O){const N=L.waitMarkerFileURI;L.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(L,O,N,V,x,ne,j){const te=[];let ie;function ae(Re,Ie){te.push(Re),Ie&&(ie=Re,ne=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:ge}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const Re=j[0].remoteAuthority,Ie=this.getLastActiveWindowForAuthority(Re);Ie&&ae(this.doAddFoldersToExistingWindow(Ie,j.map(De=>De.workspace.uri)))}const we=N.length+O.length+V.length;if(ne&&we===0){const Re=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],Ie=this.getWindows().filter(Y=>ne&&(0,p.isEqualAuthority)(Y.remoteAuthority,ne.remoteAuthority));let De;Re?.fileUri&&!ge&&((L.context===4||L.context===0||L.context===1)&&(De=(0,le.findWindowOnFile)(Ie,Re.fileUri,Y=>Y.configPath.scheme===w.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Y.configPath):void 0)),De||(De=this.doGetLastActiveWindow(Ie))),De?(0,se.isWorkspaceIdentifier)(De.openedWorkspace)?O.push({workspace:De.openedWorkspace,remoteAuthority:De.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(De.openedWorkspace)?N.push({workspace:De.openedWorkspace,remoteAuthority:De.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(L,De,ne),!0):ae(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Se=(0,R.distinct)(O,Re=>Re.workspace.id);if(Se.length>0){const Re=(0,R.coalesce)(Se.map(Ie=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ie.workspace.configPath)));if(Re.length>0){const Ie=Re[0],De=(0,p.isEqualAuthority)(ne?.remoteAuthority,Ie.remoteAuthority)?ne:void 0;ae(this.doOpenFilesInExistingWindow(L,Ie,De),!!De),de=!0}Se.forEach(Ie=>{if(Re.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===Ie.workspace.id))return;const De=Ie.remoteAuthority,Y=(0,p.isEqualAuthority)(ne?.remoteAuthority,De)?ne:void 0;ae(this.doOpenFolderOrWorkspace(L,Ie,de,Y),!!Y),de=!0})}const Ee=(0,R.distinct)(N,Re=>p.extUriBiasedIgnorePathCase.getComparisonKey(Re.workspace.uri));if(Ee.length>0){const Re=(0,R.coalesce)(Ee.map(Ie=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ie.workspace.uri)));if(Re.length>0){const Ie=Re[0],De=(0,p.isEqualAuthority)(ne?.remoteAuthority,Ie.remoteAuthority)?ne:void 0;ae(this.doOpenFilesInExistingWindow(L,Ie,De),!!De),de=!0}Ee.forEach(Ie=>{if(Re.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,Ie.workspace.uri)))return;const De=Ie.remoteAuthority,Y=(0,p.isEqualAuthority)(ne?.remoteAuthority,De)?ne:void 0;ae(this.doOpenFolderOrWorkspace(L,Ie,de,Y),!!Y),de=!0})}const We=(0,R.distinct)(V,Re=>Re.backupFolder);if(We.length>0&&We.forEach(Re=>{const Ie=Re.remoteAuthority,De=(0,p.isEqualAuthority)(ne?.remoteAuthority,Ie)?ne:void 0;ae(this.doOpenEmpty(L,!0,Ie,De,Re),!!De),de=!0}),te.length===0||ne){ne&&!x&&x++;const Re=ne?ne.remoteAuthority:L.remoteAuthority;for(let Ie=0;Ie<x;Ie++)ae(this.doOpenEmpty(L,de,Re,ne),!!ne),de=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(L,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const V={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",M.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const N={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",M.CancellationToken.None,N),L}doOpenEmpty(L,O,N,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:N,filesToOpen:V,forceNewWindow:O});let ne;return!O&&typeof L.contextWindowId=="number"&&(ne=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ne,emptyWindowBackupInfo:x})}doOpenFolderOrWorkspace(L,O,N,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!N&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x,userDataProfileInfo:O.userDataProfileInfo})}getPathsToOpen(L){let O,N=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),N=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&N){const x=O.filter(ne=>ee(ne));if(x.length>1){const ne=x[0].remoteAuthority;if(x.every(j=>(0,p.isEqualAuthority)(j.remoteAuthority,ne))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(x.map(te=>({uri:te.workspace.uri})));O.push({workspace:j,remoteAuthority:ne}),O=O.filter(te=>!ee(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(x=>z(x)||ee(x)||x.backupPath)),O}doExtractPathsFromAPI(L){const O=[],N={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const x=this.resolveOpenable(V,N);if(x)x.label=V.label,O.push(x);else{const ne=this.resourceFromOpenable(V),j={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:ne.scheme===w.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:ne.scheme===w.Schemas.file?(0,h.localize)(3,null,(0,E.getPathLabel)(ne,{os:C.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,ne.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const j of V){const te=this.cliArgToUri(j);if(te){const ie=this.resolveOpenable({folderUri:te},N);ie&&O.push(ie)}}const x=L["file-uri"];if(x)for(const j of x){const te=this.cliArgToUri(j);if(te){const ie=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(j)?{workspaceUri:te}:{fileUri:te},N);ie&&O.push(ie)}}const ne=L._;for(const j of ne){const te=N.remoteAuthority?this.doResolvePathRemote(j,N):this.doResolveFilePath(j,N);te&&O.push(te)}if(L.profile)for(const j of O)j.userDataProfileInfo={name:L.profile};return O}cliArgToUri(L){try{const O=d.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const V of O)if(V.workspace){const x=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});z(x)&&N.push(x)}else if(V.folderUri){const x=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});ee(x)&&N.push(x)}else L!=="folders"&&V.backupPath&&N.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return N}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const N=this.resourceFromOpenable(L);return N.scheme===w.Schemas.file?((0,Q.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let N=this.resourceFromOpenable(L);const V=(0,_.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(N)),(0,Q.isFileToOpen)(L)){if(O.gotoLineMode){const{path:x,line:ne,column:j}=(0,l.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:x}),options:{selection:ne?{startLineNumber:ne,startColumn:j||1}:void 0},remoteAuthority:V}}return{fileUri:N,remoteAuthority:V}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,fe.getWorkspaceIdentifier)(N),remoteAuthority:V};return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:V}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let N,V;O.gotoLineMode&&({path:L,line:N,column:V}=(0,l.parseLineAndColumnAware)(L)),L=(0,l.sanitizeFilePath)((0,g.normalize)(L),(0,b.cwd)());try{const x=(0,t.statSync)(L);if(x.isFile()){if(!O.forceOpenWorkspaceAsFile){const ne=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(L));if(ne)return ne.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:d.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(d.URI.file(L),x),type:n.FileType.Directory,exists:!0};if(!C.isWindows&&L==="/dev/null")return{fileUri:d.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const ne=d.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ne]),O.ignoreFileNotFound)return{fileUri:ne,type:n.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const N=L.charCodeAt(0),V=O.remoteAuthority;let x,ne;O.gotoLineMode&&({path:L,line:x,column:ne}=(0,l.parseLineAndColumnAware)(L)),N!==47&&((0,l.isWindowsDriveLetter)(N)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.toSlashes)(L)),L=`/${L}`);const j=d.URI.from({scheme:w.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:x?{startLineNumber:x,startColumn:ne||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,fe.getWorkspaceIdentifier)(j),remoteAuthority:V};if(O.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:x?{startLineNumber:x,startColumn:ne||1}:void 0},remoteAuthority:V}}return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(N==="on"||N==="off")&&(x=N==="on");let ne=!1;return L.forceNewWindow||L.forceReuseWindow?ne=!!L.forceNewWindow&&!L.forceReuseWindow:(C.isMacintosh?L.context===1&&(ne=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ne=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:ne}}openExtensionDevelopmentHostWindow(L,O){const N=(0,le.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let V=O.cli["folder-uri"]||[],x=O.cli["file-uri"]||[],ne=O.cli._;if(!ne.length&&!V.length&&!x.length&&!O.cli.extensionTestsPath){const ae=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,de=ae&&(ae.workspace||ae.folderUri);de&&(d.URI.isUri(de)?de.scheme===w.Schemas.file?ne=[de.fsPath]:V=[de.toString()]:de.configPath.scheme===w.Schemas.file?ne=[(0,p.originalFSPath)(de.configPath)]:x=[de.configPath.toString()])}let j=O.remoteAuthority;for(const ae of L)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const de=d.URI.parse(ae),ge=(0,_.getRemoteAuthority)(de);ge&&(j?(0,p.isEqualAuthority)(ge,j)||this.logService.error("more than one extension development path authority"):j=ge)}ne=ne.filter(ae=>{const de=d.URI.file(ae);return(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(de),j)}),V=V.filter(ae=>{const de=this.cliArgToUri(ae);return de&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:de?(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(de),j):!1}),x=x.filter(ae=>{const de=this.cliArgToUri(ae);return de&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:de?(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(de),j):!1}),O.cli._=ne,O.cli["folder-uri"]=V,O.cli["file-uri"]=x;const te=!ne.length&&!V.length&&!x.length,ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!N.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(N.extensionDevelopmentPath=x.extensionDevelopmentPath,N.extensionDevelopmentKind=x.extensionDevelopmentKind,N["enable-proposed-api"]=x["enable-proposed-api"],N.verbose=x.verbose,N["inspect-extensions"]=x["inspect-extensions"],N["inspect-brk-extensions"]=x["inspect-brk-extensions"],N.debugId=x.debugId,N.extensionEnvironment=x.extensionEnvironment,N["extensions-dir"]=x["extensions-dir"],N["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(N);(0,f.mark)("code/willCreateCodeWindow");const ne=V=this.instantiationService.createInstance(re.CodeWindow,{state:x,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),lt.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,m.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,m.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne)),ne.onDidTriggerSystemContextMenu(({x:te,y:ie})=>this._onDidTriggerSystemContextMenu.fire({window:ne,x:te,y:ie}));const j=(0,y.assertIsDefined)(ne.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return N.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,N,L)}):this.doOpenInBrowserWindow(V,N,L),V}resolveProfileForBrowserWindow(L){let O;return L.userDataProfileInfo&&(O=this.userDataProfilesMainService.profiles.find(N=>N.name===L.userDataProfileInfo.name),O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O)),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}doOpenInBrowserWindow(L,O,N){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,O.remoteAuthority)}L.load(O)}onWindowClosed(L){const O=lt.WINDOWS.indexOf(L);lt.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=v.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(N=>N.lastFocusTime));return L.find(N=>N.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,M.CancellationToken.None,...O)}sendToAll(L,O,N){for(const V of this.getWindows())N&&N.indexOf(V.id)>=0||V.sendWhenReady(L,M.CancellationToken.None,O)}getWindows(){return lt.WINDOWS}getWindowCount(){return lt.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(N=>N.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=v.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([X(2,u.ILogService),X(3,U.IStateMainService),X(4,A.IPolicyService),X(5,r.IEnvironmentMainService),X(6,W.IUserDataProfilesMainService),X(7,c.ILifecycleMainService),X(8,a.IBackupMainService),X(9,i.IConfigurationService),X(10,K.IWorkspacesHistoryMainService),X(11,$.IWorkspacesManagementMainService),X(12,s.IInstantiationService),X(13,o.IDialogMainService),X(14,n.IFileService),X(15,D.IProductService),X(16,T.IProtocolMainService),X(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(J[266],Z([0,1,59,33,73,46]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(l,m,E,I){this.workspacesManagementMainService=l,this.windowsMainService=m,this.workspacesHistoryMainService=E,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(l,m){const E=this.windowsMainService.getWindowById(l);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(l,m,E){return this.workspacesManagementMainService.createUntitledWorkspace(m,E)}deleteUntitledWorkspace(l,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(l,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(l){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(l,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(l,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(l){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ve([X(0,R.IWorkspacesManagementMainService),X(1,t.IWindowsMainService),X(2,k.IWorkspacesHistoryMainService),X(3,v.IBackupMainService)],M),e.WorkspacesMainService=M}),define(J[267],Z([0,1,15,40,29,30,17,43,18,31,47,48,35,2,13,9,5,12,7,28,94,131,51,146,97,244,149,59,249,19,69,182,100,117,56,101,180,26,58,109,193,213,194,246,102,195,196,14,206,83,68,4,81,259,224,118,21,6,208,264,64,20,62,253,84,41,250,88,110,38,228,230,85,45,235,236,260,237,261,112,239,240,241,242,247,33,265,248,27,89,73,266,46,245,37,212,42,256,220,54,71,87,251,257,8]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r,n,s,c,u,P,D,T,_,U,Q,re,le,ue,se,fe,K,$,F,A,W,z,ee,B,H,L,O,N,V,x,ne,j,te,ie,ae,de,ge,we,Se,Ee,We,Re,Ie,De,Y,ce,he,Pe,ke,Ne,Ue,xe,Ve,Ye,Qe,$e,G,oe,pe,me,ye,Le,Te,Ke,tt,He,Je,it,ot,ut,Ft,_t,Et,Ut,Nt,Bt,At,zt,$t,qt,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends g.Disposable{constructor(be,Me,Ae,Ce,Oe,je,Be,ze,Fe,qe){super(),this.userEnv=be,this.mainInstantiationService=Me,this.logService=Ae,this.environmentMainService=Ce,this.lifecycleMainService=Oe,this.configurationService=je,this.stateMainService=Be,this.fileService=ze,this.productService=Fe,this.userDataProfilesMainService=qe,this.configureSession(),this.registerListeners()}configureSession(){const be=Fe=>Fe?.startsWith(`${f.Schemas.vscodeWebview}://`),Me=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((Fe,qe,_e,Xe)=>be(Xe.requestingUrl)?_e(Me.has(qe)):_e(!1)),v.session.defaultSession.setPermissionCheckHandler((Fe,qe,_e,Xe)=>be(Xe.requestingUrl)?Me.has(qe):!1);const Ae=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Ce=Fe=>{for(let qe=Fe;qe;qe=qe.parent)if(qe.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Oe=Fe=>Fe.resourceType==="xhr"||Ce(Fe.frame),je=Fe=>{const qe=Fe.frame;if(!qe||!this.windowsMainService)return!1;const _e=v.BrowserWindow.getAllWindows();for(const Xe of _e)if(qe.processId===Xe.webContents.mainFrame.processId)return!0;return!1},Be=(Fe,qe)=>{if(Fe.path!=="/index.html")return!0;const _e=qe.frame;if(!_e||!this.windowsMainService)return!1;for(const Xe of this.windowsMainService.getWindows())if(Xe.win&&_e.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((Fe,qe)=>{const _e=y.URI.parse(Fe.url);return _e.scheme===f.Schemas.vscodeWebview&&!Be(_e,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),qe({cancel:!0})):_e.scheme===f.Schemas.vscodeFileResource&&!je(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),qe({cancel:!0})):_e.path.endsWith(".svg")&&!Ae.has(_e.scheme)?qe({cancel:!Oe(Fe)}):qe({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((Fe,qe)=>{const _e=Fe.responseHeaders,Xe=_e["content-type"]||_e["Content-Type"];if(Xe&&Array.isArray(Xe)){const rt=y.URI.parse(Fe.url);if(rt.path.endsWith(".svg")&&Ae.has(rt.scheme))return _e["Content-Type"]=["image/svg+xml"],qe({cancel:!1,responseHeaders:_e});if(!rt.path.endsWith(f.Schemas.vscodeRemoteResource)&&Xe.some(ht=>ht.toLowerCase().includes("image/svg")))return qe({cancel:!Oe(Fe)})}return qe({cancel:!1})});const ze=v.session.defaultSession;typeof ze.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&ze.setCodeCachePath((0,C.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,l.setUnexpectedErrorHandler)(Ae=>this.onUnexpectedError(Ae)),process.on("uncaughtException",Ae=>(0,l.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,l.onUnexpectedError)(Ae)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,a.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Ae,Ce)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ce)}),v.app.on("activate",(Ae,Ce)=>{this.logService.trace("app#activate"),Ce||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Ae,Ce)=>{Ce.on("will-navigate",Oe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Oe.preventDefault()}),Ce.setWindowOpenHandler(({url:Oe})=>(this.nativeHostMainService?.openExternal(void 0,Oe),{action:"deny"}))});let be=[],Me;v.app.on("open-file",(Ae,Ce)=>{this.logService.trace("app#open-file: ",Ce),Ae.preventDefault(),be.push(this.getWindowOpenableFromPathSync(Ce)),Me!==void 0&&(clearTimeout(Me),Me=void 0),Me=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Me=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const Ce=this.windowsMainService?.getWindowByWebContents(Ae.sender);let Oe,je;return Ce?.config?(Oe=Ce.config,je={...process.env,...Ce.config.userEnv}):(Oe=this.environmentMainService.args,je=process.env),this.resolveShellEnvironment(Oe,je,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,Ce,Oe)=>{const je=this.validateNlsPath([Ce]);if(!je||typeof Oe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(je,M.VSBuffer.fromString(Oe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...Ce)=>{const Oe=this.validateNlsPath(Ce);if(!Oe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Oe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}validateNlsPath(be){let Me;for(const Ae of be)typeof Ae=="string"&&(typeof Me!="string"?Me=Ae:Me=(0,C.join)(Me,Ae));if(!(typeof Me!="string"||!(0,C.isAbsolute)(Me)||!(0,m.isEqualOrParent)(Me,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return y.URI.file(Me)}onUnexpectedError(be){if(be){const Me={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;b.isWindows&&be&&v.app.setAppUserModelId(be);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Me=new o.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Me.dispose()}),this.logService.trace("Resolving machine identifier...");const Ae=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:Ce,sharedProcessReady:Oe,sharedProcessClient:je}=this.setupSharedProcess(Ae),Be=await this.initServices(Ae,Ce,Oe);this.setUpHandlers(Be);const ze=this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);ze&&await ze,Be.invokeFunction(_e=>this.initChannels(_e,Me,je));const Fe=Be.invokeFunction(_e=>this.openFirstWindow(_e,Me));Be.invokeFunction(_e=>this.afterWindowOpen(_e,Ce)),this.environmentMainService.args.trace&&Be.invokeFunction(_e=>this.stopTracingEventually(_e,Fe)),this._register(new Tt.RunOnceScheduler(()=>{this._register((0,Tt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(Ut.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(qt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(ce.machineIdKey);return(!be||b.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,h.getMachineId)(),this.stateMainService.setItem(ce.machineIdKey,be)),be}setupSharedProcess(be){const Me=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,be,this.userEnv)),Ae=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Oe=await Me.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(Oe,"main")})(),Ce=(async()=>(await Me.whenReady(),Ae))();return{sharedProcess:Me,sharedProcessReady:Ce,sharedProcessClient:Ae}}async initServices(be,Me,Ae){const Ce=new V.ServiceCollection;switch(process.platform){case"win32":Ce.set(Ne.IUpdateService,new O.SyncDescriptor(Qe.Win32UpdateService));break;case"linux":b.isLinuxSnap?Ce.set(Ne.IUpdateService,new O.SyncDescriptor(Ye.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ce.set(Ne.IUpdateService,new O.SyncDescriptor(Ve.LinuxUpdateService));break;case"darwin":Ce.set(Ne.IUpdateService,new O.SyncDescriptor(xe.DarwinUpdateService));break}Ce.set(Le.IWindowsMainService,new O.SyncDescriptor(Te.WindowsMainService,[be,this.userEnv])),Ce.set(Q.IDialogMainService,new O.SyncDescriptor(Q.DialogMainService)),Ce.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService)),Ce.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService)),Ce.set(_.IDiagnosticsService,i.ProxyChannel.toService((0,i.getDelayedChannel)(Ae.then(je=>je.getChannel("diagnostics"))))),Ce.set(x.IIssueMainService,new O.SyncDescriptor(x.IssueMainService,[this.userEnv])),Ce.set(re.IEncryptionMainService,new O.SyncDescriptor(le.EncryptionMainService,[be])),Ce.set(ne.IKeyboardLayoutMainService,new O.SyncDescriptor(ne.KeyboardLayoutMainService)),Ce.set(ge.INativeHostMainService,new O.SyncDescriptor(ge.NativeHostMainService,[Me])),Ce.set(D.ICredentialsMainService,new O.SyncDescriptor(ut.CredentialsNativeMainService)),Ce.set(me.IWebviewManagerService,new O.SyncDescriptor(ye.WebviewMainService)),Ce.set(He.IWorkspacesService,new O.SyncDescriptor(it.WorkspacesMainService)),Ce.set(ot.IWorkspacesManagementMainService,new O.SyncDescriptor(ot.WorkspacesManagementMainService)),Ce.set(Je.IWorkspacesHistoryMainService,new O.SyncDescriptor(Je.WorkspacesHistoryMainService)),Ce.set(de.IMenubarMainService,new O.SyncDescriptor(de.MenubarMainService)),Ce.set(K.IExtensionUrlTrustService,new O.SyncDescriptor($.ExtensionUrlTrustService)),Ce.set(F.IExtensionHostStarter,new O.SyncDescriptor(A.ExtensionHostStarter)),Ce.set(De.IStorageMainService,new O.SyncDescriptor(De.StorageMainService)),Ce.set(De.IApplicationStorageMainService,new O.SyncDescriptor(De.ApplicationStorageMainService)),b.isWindows?Ce.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.WindowsExternalTerminalService)):b.isMacintosh?Ce.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.MacExternalTerminalService)):b.isLinux&&Ce.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.LinuxExternalTerminalService));const Oe=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Ce.set(c.IBackupMainService,Oe),Ce.set($e.IURLService,new O.SyncDescriptor(oe.NativeURLService)),(0,ke.supportsTelemetry)(this.productService,this.environmentMainService)){const je=(0,ke.isInternalTelemetry)(this.productService,this.configurationService),Be=(0,i.getDelayedChannel)(Ae.then(Xe=>Xe.getChannel("telemetryAppender"))),ze=new he.TelemetryAppenderClient(Be),Fe=(0,Y.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,be,je,this.environmentMainService.installSourcePath),qe=(0,ke.getPiiPathsFromEnvironment)(this.environmentMainService),_e={appenders:[ze],commonProperties:Fe,piiPaths:qe,sendErrorTelemetry:!0};Ce.set(ce.ITelemetryService,new O.SyncDescriptor(Pe.TelemetryService,[_e]))}else Ce.set(ce.ITelemetryService,ke.NullTelemetryService);return Ce.set(At.IExtensionsProfileScannerService,new O.SyncDescriptor(At.ExtensionsProfileScannerService)),Ce.set(zt.IExtensionsScannerService,new O.SyncDescriptor($t.ExtensionsScannerService)),await Oe.initialize(),this.mainInstantiationService.createChild(Ce)}initChannels(be,Me,Ae){const Ce=new _t.PolicyChannel(be.get(Ft.IPolicyService));Me.registerChannel("policy",Ce),Ae.then(et=>et.registerChannel("policy",Ce));const Oe=this.fileService.getProvider(f.Schemas.file);(0,p.assertType)(Oe instanceof L.DiskFileSystemProvider);const je=new H.DiskFileSystemProviderChannel(Oe,this.logService,this.environmentMainService);Me.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,je),Ae.then(et=>et.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,je));const Be=i.ProxyChannel.fromService(be.get(Et.IUserDataProfilesMainService));Me.registerChannel("userDataProfiles",Be),Ae.then(et=>et.registerChannel("userDataProfiles",Be));const ze=new Nt.RequestChannel(be.get(Bt.IRequestService));Ae.then(et=>et.registerChannel("request",ze));const Fe=new Ue.UpdateChannel(be.get(Ne.IUpdateService));Me.registerChannel("update",Fe);const qe=i.ProxyChannel.fromService(be.get(x.IIssueMainService));Me.registerChannel("issue",qe);const _e=i.ProxyChannel.fromService(be.get(re.IEncryptionMainService));Me.registerChannel("encryption",_e);const Xe=i.ProxyChannel.fromService(be.get(D.ICredentialsMainService));Me.registerChannel("credentials",Xe);const rt=i.ProxyChannel.fromService(be.get(We.ISignService));Me.registerChannel("sign",rt);const ht=i.ProxyChannel.fromService(be.get(ne.IKeyboardLayoutMainService));Me.registerChannel("keyboardLayout",ht),this.nativeHostMainService=be.get(ge.INativeHostMainService);const wt=i.ProxyChannel.fromService(this.nativeHostMainService);Me.registerChannel("nativeHost",wt),Ae.then(et=>et.registerChannel("nativeHost",wt));const Ze=i.ProxyChannel.fromService(be.get(He.IWorkspacesService));Me.registerChannel("workspaces",Ze);const vt=i.ProxyChannel.fromService(be.get(de.IMenubarMainService));Me.registerChannel("menubar",vt);const dt=i.ProxyChannel.fromService(be.get($e.IURLService));Me.registerChannel("url",dt);const ft=i.ProxyChannel.fromService(be.get(K.IExtensionUrlTrustService));Me.registerChannel("extensionUrlTrust",ft);const St=i.ProxyChannel.fromService(be.get(me.IWebviewManagerService));Me.registerChannel("webview",St);const gt=this._register(new Ie.StorageDatabaseChannel(this.logService,be.get(De.IStorageMainService)));Me.registerChannel("storage",gt),Ae.then(et=>et.registerChannel("storage",gt));const mt=i.ProxyChannel.fromService(be.get(W.IExternalTerminalMainService));Me.registerChannel("externalTerminal",mt);const at=new ae.LogLevelChannel(be.get(ie.ILogService));Me.registerChannel("logLevel",at),Ae.then(et=>et.registerChannel("logLevel",at));const pt=new ae.LoggerChannel(be.get(ie.ILoggerService));Me.registerChannel("logger",pt),Ae.then(et=>et.registerChannel("logger",pt));const Ge=new T.ElectronExtensionHostDebugBroadcastChannel(be.get(Le.IWindowsMainService),be.get(Et.IUserDataProfilesMainService));Me.registerChannel("extensionhostdebugservice",Ge);const st=i.ProxyChannel.fromService(be.get(F.IExtensionHostStarter));Me.registerChannel(F.ipcExtensionHostStarterChannelName,st)}openFirstWindow(be,Me){const Ae=this.windowsMainService=be.get(Le.IWindowsMainService),Ce=be.get($e.IURLService),Oe=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const je=[],Be=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ge=>{try{return{uri:y.URI.parse(Ge),url:Ge}}catch{return}}).filter(Ge=>{if(!Ge||this.shouldBlockURI(Ge.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(Ge.uri);return st?(je.push(st),!1):!0}),ze=this,Fe=this.environmentMainService,qe=this.productService,_e=this.logService;Ce.registerHandler({async handleURL(Ge,st){if(_e.trace("app#handleURL: ",Ge.toString(!0),st),Ge.scheme===qe.urlProtocol&&Ge.path==="workspace"&&(Ge=Ge.with({authority:"file",path:y.URI.parse(Ge.query).path,query:""})),ze.shouldBlockURI(Ge))return!0;let et=!1;const It=new URLSearchParams(Ge.query);It.get("windowId")==="_blank"&&(It.delete("windowId"),Ge=Ge.with({query:It.toString()}),et=!0),et||=b.isMacintosh&&Ae.getWindowCount()===0;const Pt=ze.getWindowOpenableFromProtocolLink(Ge);if(_e.trace("app#handleURL: windowOpenableFromProtocolLink = ",Pt),Pt){const[kt]=Ae.open({context:5,cli:{...Fe.args},urisToOpen:[Pt],forceNewWindow:et,gotoLineMode:!0});return kt.focus(),!0}if(et){const[kt]=Ae.open({context:5,cli:{...Fe.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Se.getRemoteAuthority)(Ge)});return await kt.ready(),Ce.open(Ge,st)}return!1}});const Xe=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:Oe.onDidOpenWindow,onDidFocusWindow:Oe.onDidFocusWindow,getActiveWindowId:()=>Oe.getActiveWindowId(-1)})),rt=new i.StaticRouter(Ge=>Xe.getActiveClientId().then(st=>Ge===st)),ht=new G.URLHandlerRouter(rt),wt=Me.getChannel("urlHandler",ht);Ce.registerHandler(new G.URLHandlerChannelClient(wt)),this._register(new pe.ElectronURLListener(Be,Ce,Ae,this.environmentMainService,this.productService));const Ze=this.environmentMainService.args,vt=global.macOpenFiles,dt=(0,se.isLaunchedFromCli)(process.env)?0:4,ft=Ze._.length,St=!!Ze["folder-uri"],gt=!!Ze["file-uri"],mt=Ze["skip-add-to-recently-opened"]===!0,at=Ze.wait&&Ze.waitMarkerFilePath?y.URI.file(Ze.waitMarkerFilePath):void 0,pt=Ze.remote||void 0;return je.length>0?Ae.open({context:dt,cli:Ze,urisToOpen:je,gotoLineMode:!0,initialStartup:!0}):Ze["new-window"]&&!ft&&!St&&!gt?Ae.open({context:dt,cli:Ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:at,initialStartup:!0,remoteAuthority:pt}):vt.length&&!ft&&!St&&!gt?Ae.open({context:1,cli:Ze,urisToOpen:vt.map(Ge=>this.getWindowOpenableFromPathSync(Ge)),noRecentEntry:mt,waitMarkerFileURI:at,initialStartup:!0}):Ae.open({context:dt,cli:Ze,forceNewWindow:Ze["new-window"]||!ft&&Ze["unity-launch"],diffMode:Ze.diff,mergeMode:Ze.merge,noRecentEntry:mt,waitMarkerFileURI:at,gotoLineMode:Ze.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(be){return!!(be.authority===f.Schemas.file&&b.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,w.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,w.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,w.getPathLabel)(be,{os:b.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===f.Schemas.file){const Me=y.URI.file(be.fsPath);return(0,tt.hasWorkspaceFileExtension)(Me)?{workspaceUri:Me}:{fileUri:Me}}else if(be.authority===f.Schemas.vscodeRemote){const Me=be.path.indexOf(C.posix.sep,1);if(Me!==-1){const Ae=be.path.substring(1,Me),Ce=be.path.substring(Me),Oe=y.URI.from({scheme:f.Schemas.vscodeRemote,authority:Ae,path:Ce,query:be.query,fragment:be.fragment});return(0,tt.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Oe}:/:[\d]+$/.test(Ce)?{fileUri:Oe}:{folderUri:Oe}}}}}getWindowOpenableFromPathSync(be){try{if((0,k.statSync)(be).isDirectory())return{folderUri:y.URI.file(be)};if((0,tt.hasWorkspaceFileExtension)(be))return{workspaceUri:y.URI.file(be)}}catch{}return{fileUri:y.URI.file(be)}}async afterWindowOpen(be,Me){this.lifecycleMainService.phase=3;let Ae=!1;(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae=!0);const Ce=be.get(ce.ITelemetryService);this._register(Me.onDidError(({type:Be,details:ze})=>{let Fe;switch(Be){case 1:Fe="SharedProcess: detected unresponsive window";break;case 2:Fe=`SharedProcess: crashed (detail: ${ze?.reason??"<unknown>"}, code: ${ze?.exitCode??"<unknown>"})`;break;case 3:Fe=`SharedProcess: failed to load (detail: ${ze?.reason??"<unknown>"}, code: ${ze?.exitCode??"<unknown>"})`;break}(0,l.onUnexpectedError)(new Error(Fe)),Ce.publicLog2("sharedprocesserror",{type:Be,reason:ze?.reason,code:ze?.exitCode,visible:Me.isVisible(),shuttingdown:Ae})}));const Oe=this.productService.win32MutexName;if(b.isWindows&&Oe)try{const Be=q.__$__nodeRequire("windows-mutex").Mutex,ze=new Be(Oe);(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>ze.release())}catch(Be){this.logService.error(Be)}v.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Be,ze)=>{ze({url:Be.url.replace(/^vscode-remote-resource:/,"http:"),method:Be.method})});const je=be.get(Ne.IUpdateService);(je instanceof Qe.Win32UpdateService||je instanceof Ve.LinuxUpdateService||je instanceof xe.DarwinUpdateService)&&await je.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const ze=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Fe=JSON.parse((0,I.stripComments)(ze)),_e=(0,ke.getTelemetryLevel)(this.configurationService)>=1;if(Fe["enable-crash-reporter"]===void 0){const Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],rt=ze.substring(0,ze.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(rt))}else{const Xe=ze.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${_e},`);await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Xe))}}catch(Be){this.logService.error(Be)}}async resolveShellEnvironment(be,Me,Ae){try{return await(0,fe.getResolvedShellEnv)(this.logService,be,Me)}catch(Ce){const Oe=(0,S.toErrorMessage)(Ce);Ae?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Oe):this.logService.error(Oe)}return{}}stopTracingEventually(be,Me){this.logService.info("Tracing: waiting for windows to get ready...");const Ae=be.get(Q.IDialogMainService);let Ce=!1;const Oe=async Be=>{if(Ce)return;Ce=!0;const ze=await v.contentTracing.stopRecording(`${(0,m.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Be?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${ze}`):Ae.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,ze),buttons:[(0,w.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},je=setTimeout(()=>Oe(!0),3e4);Promise.all(Me.map(Be=>Be.ready())).then(()=>{clearTimeout(je),Oe(!1)})}};Ct=ve([X(1,N.IInstantiationService),X(2,ie.ILogService),X(3,ue.IEnvironmentMainService),X(4,te.ILifecycleMainService),X(5,P.IConfigurationService),X(6,Re.IStateMainService),X(7,B.IFileService),X(8,we.IProductService),X(9,Et.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(J[268],Z([0,1,37,8,276,2]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends v.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((m,E)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,I=>{for(const w in I){const g=I[w];g===void 0?this.policies.delete(w):this.policies.set(w,g)}this._onDidChange.fire(Object.keys(I)),m()})}catch(I){E(I)}}))}}e.NativePolicyService=M}),define(J[269],Z([0,1,222,8,17,18,2,12,19,36,109,6,221,277]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends M.Disposable{constructor(b,p,y){super(),this.environmentService=p,this.logService=y,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:y,strictSSL:d}=this;let h;try{h=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const a={...process.env,...h},i=b.agent?b.agent:await(0,w.getProxyAgent)(b.url||"",a,{proxyUrl:y,strictSSL:d});b.agent=i,b.strictSSL=d,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(b,p);return this.logService.trace("RequestService#request (node) - success",b.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",b.url,o),o}}async getNodeRequest(b){return((0,v.parse)(b.url).protocol==="https:"?await new Promise((d,h)=>{q(["https"],d,h)}):await new Promise((d,h)=>{q(["http"],d,h)})).request}_request(b,p){return t.Promises.withAsyncBody(async(y,d)=>{const h=(0,v.parse)(b.url),a=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),i={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,S.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const o=a(i,r=>{const n=(0,S.isNumber)(b.followRedirects)?b.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&n>0&&r.headers.location)this._request({...b,url:r.headers.location,followRedirects:n-1},p).then(y,d);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,g.createGunzip)())),y({res:r,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",d),b.timeout&&o.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),p.onCancellationRequested(()=>{o.abort(),d(new R.CancellationError)})})}async resolveProxy(b){}};f=ve([X(0,l.IConfigurationService),X(1,m.INativeEnvironmentService),X(2,I.ILogService)],f),e.RequestService=f}),define(J[270],Z([0,1,15,269]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(M){return v.net.request}class R extends t.RequestService{request(S,l){return super.request({...S||{},getRawRequest:k},l)}}e.RequestMainService=R}),define(J[278],Z([0,1,15,7,23,8,43,18,31,47,35,13,9,5,34,24,25,80,267,10,19,216,26,58,185,14,204,83,68,201,81,21,104,6,209,105,53,20,60,252,111,233,54,270,84,223,41,227,63,42,37,268,211,2,55,238,39,234]),function(q,e,v,t,k,R,M,S,l,m,E,I,w,g,f,C,b,p,y,d,h,a,i,o,r,n,s,c,u,P,D,T,_,U,Q,re,le,ue,se,fe,K,$,F,A,W,z,ee,B,H,L,O,N,V,x,ne,j,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ge){console.error(ge.message),v.app.exit(1)}}async startup(){(0,S.setUnexpectedErrorHandler)(Y=>console.error(Y));const[ge,we,Se,Ee,We,Re,Ie,De]=this.createServices();try{try{await this.initServices(Se,De,Ee,We,Ie)}catch(Y){throw this.handleStartupDataDirError(Se,Ie.nameLong,Y),Y}await ge.invokeFunction(async Y=>{const ce=Y.get(U.ILogService),he=Y.get(T.ILifecycleMainService),Pe=Y.get(n.IFileService);return b.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(ke=>{ce.warn(`Error writing main lockfile: ${ke.stack}`)}),Re.logger=new re.SpdLogLogger("main",(0,w.join)(Se.logsPath,"main.log"),!0,!1,Re.getLevel()),(0,m.once)(he.onWillShutdown)(ke=>{Pe.dispose(),Ee.dispose(),ke.join(b.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),ge.createInstance(y.CodeApplication,we).startup()})}catch(Y){ge.invokeFunction(this.quit,Y)}}createServices(){const ge=new D.ServiceCollection,we=new x.DisposableStore;process.once("exit",()=>we.dispose());const Se={_serviceBrand:void 0,...le.default};ge.set(ue.IProductService,Se);const Ee=new i.EnvironmentMainService(this.resolveArgs(),Se),We=this.patchEnvironment(Ee);ge.set(i.IEnvironmentMainService,Ee);const Re=new _.BufferLogService,Ie=we.add(new U.MultiplexLogService([new U.ConsoleMainLogger((0,U.getLogLevel)(Ee)),Re]));ge.set(U.ILogService,Ie);const De=new s.FileService(Ie);ge.set(n.IFileService,De);const Y=new c.DiskFileSystemProvider(Ie);De.registerProvider(I.Schemas.file,Y);const ce=new j.UriIdentityService(De);ge.set(ne.IUriIdentityService,ce),ge.set(U.ILoggerService,new Q.LoggerService(Ie,De));const he=new B.StateMainService(Ee,Ie,De);ge.set(ee.IStateMainService,he);const Pe=new L.UserDataProfilesMainService(he,ce,Ee,De,Ie);ge.set(L.IUserDataProfilesMainService,Pe);const ke=g.isWindows&&Se.win32RegValueName?we.add(new N.NativePolicyService(Se.win32RegValueName)):Ee.policyFile?we.add(new V.FilePolicyService(Ee.policyFile,De,Ie)):new O.NullPolicyService;ge.set(O.IPolicyService,ke);const Ne=new a.ConfigurationService(Pe.defaultProfile.settingsResource,De,ke,Ie);return ge.set(h.IConfigurationService,Ne),ge.set(T.ILifecycleMainService,new u.SyncDescriptor(T.LifecycleMainService)),ge.set(F.IRequestService,new u.SyncDescriptor(A.RequestMainService)),ge.set(H.IThemeMainService,new u.SyncDescriptor(H.ThemeMainService)),ge.set(W.ISignService,new u.SyncDescriptor(z.SignService)),ge.set(K.ITunnelService,new u.SyncDescriptor($.TunnelService)),ge.set(se.IProtocolMainService,new u.SyncDescriptor(fe.ProtocolMainService)),[new P.InstantiationService(ge,!0),We,Ee,Ne,he,Re,Se,Pe]}patchEnvironment(ge){const we={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const Ee=process.env[Se];typeof Ee=="string"&&(we[Se]=Ee)}),Object.assign(process.env,we),we}async initServices(ge,we,Se,Ee,We){await R.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsPath,we.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(Re=>Re?b.Promises.mkdir(Re,{recursive:!0}):void 0)),Ee.init(),Se.initialize()]),we.setEnablement(We.quality!=="stable"||Se.getValue(te.PROFILES_ENABLEMENT_CONFIG))}handleStartupDataDirError(ge,we,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const Ee=(0,k.coalesce)([ge.userDataPath,ge.extensionsPath,p.XDG_RUNTIME_DIR]).map(We=>(0,E.getPathLabel)(t.URI.file(We),{os:g.OS,tildify:ge}));this.showStartupWarningDialog((0,d.localize)(0,null),(0,d.localize)(1,null,(0,M.toErrorMessage)(Se),Ee.join(`
`)),we)}}showStartupWarningDialog(ge,we,Se){v.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(2,null))],message:ge,detail:we,defaultId:0,noLink:!0})}quit(ge,we){const Se=ge.get(U.ILogService),Ee=ge.get(T.ILifecycleMainService);let We=0;we&&(we.isExpected?we.message&&Se.trace(we.message):(We=1,we.stack?Se.error(we.stack):Se.error(`Startup error: ${we.toString()}`))),Ee.kill(We)}resolveArgs(){const ge=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const we=(0,r.createWaitMarkerFile)(ge.verbose);we&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",we),ge.waitMarkerFilePath=we)}return ge}validatePaths(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const we=this.doValidatePaths(ge._,ge.goto);ge._=we}return ge}doValidatePaths(ge,we){const Se=(0,f.cwd)(),Ee=ge.map(Ie=>{let De=String(Ie),Y;we&&(Y=(0,l.parseLineAndColumnAware)(De),De=Y.path),De&&(De=this.preparePath(Se,De));const ce=(0,l.sanitizeFilePath)(De,Se),he=(0,w.basename)(ce);return he&&!(0,l.isValidBasename)(he)?null:we&&Y?(Y.path=ce,this.toPath(Y)):ce}),We=g.isWindows||g.isMacintosh,Re=(0,k.distinct)(Ee,Ie=>Ie&&We?Ie.toLowerCase():Ie||"");return(0,k.coalesce)(Re)}preparePath(ge,we){return g.isWindows&&(we=(0,C.rtrim)(we,'"')),we=(0,C.trim)((0,C.trim)(we," "),"	"),g.isWindows&&(we=(0,w.resolve)(ge,we),we=(0,C.rtrim)(we,".")),we}toPath(ge){const we=[ge.path];return typeof ge.line=="number"&&we.push(String(ge.line)),typeof ge.column=="number"&&we.push(String(ge.column)),we.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e97a738a8376160783f53d587c2cf420815b1eb1/core/vs/code/electron-main/main.js.map
