/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/errors","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/assert","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(Z){for(var t=[],y=0,i=Z.length;y<i;y++)t[y]=me[Z[y]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Vt(Z){if(Array.isArray(Z)){for(var t=0,y=Array(Z.length);t<Z.length;t++)y[t]=Z[t];return y}else return Array.from(Z)}var $t=Object.hasOwnProperty,Lt=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,xt=Object.getOwnPropertyDescriptor,tt=Object.freeze,ot=Object.seal,jt=Object.create,Nt=typeof Reflect<"u"&&Reflect,wt=Nt.apply,Et=Nt.construct;wt||(wt=function(t,y,i){return t.apply(y,i)}),tt||(tt=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,y){return new(Function.prototype.bind.apply(t,[null].concat(Vt(y))))});var Gt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Rt=nt(String.prototype.match),lt=nt(String.prototype.replace),Yt=nt(String.prototype.indexOf),Xt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Pt=Zt(TypeError);function nt(Z){return function(t){for(var y=arguments.length,i=Array(y>1?y-1:0),H=1;H<y;H++)i[H-1]=arguments[H];return wt(Z,t,i)}}function Zt(Z){return function(){for(var t=arguments.length,y=Array(t),i=0;i<t;i++)y[i]=arguments[i];return Et(Z,y)}}function Be(Z,t){Lt&&Lt(Z,null);for(var y=t.length;y--;){var i=t[y];if(typeof i=="string"){var H=ut(i);H!==i&&(Kt(t)||(t[y]=H),i=H)}Z[i]=!0}return Z}function ct(Z){var t=jt(null),y=void 0;for(y in Z)wt($t,Z,[y])&&(t[y]=Z[y]);return t}function vt(Z,t){for(;Z!==null;){var y=xt(Z,t);if(y){if(y.get)return nt(y.get);if(typeof y.value=="function")return nt(y.value)}Z=qt(Z)}function i(H){return console.warn("fallback value for",H),null}return i}var Mt=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),_t=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Qt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Jt=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=tt(["#text"]),Bt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Z){return typeof Z}:function(Z){return Z&&typeof Symbol=="function"&&Z.constructor===Symbol&&Z!==Symbol.prototype?"symbol":typeof Z};function rt(Z){if(Array.isArray(Z)){for(var t=0,y=Array(Z.length);t<Z.length;t++)y[t]=Z[t];return y}else return Array.from(Z)}var ai=function(){return typeof window>"u"?null:window},li=function(t,y){if((typeof t>"u"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,H="data-tt-policy-suffix";y.currentScript&&y.currentScript.hasAttribute(H)&&(i=y.currentScript.getAttribute(H));var O="dompurify"+(i?"#"+i:"");try{return t.createPolicy(O,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+O+" could not be created."),null}};function Wt(){var Z=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(ue){return Wt(ue)};if(t.version="2.3.1",t.removed=[],!Z||!Z.document||Z.document.nodeType!==9)return t.isSupported=!1,t;var y=Z.document,i=Z.document,H=Z.DocumentFragment,O=Z.HTMLTemplateElement,C=Z.Node,w=Z.Element,g=Z.NodeFilter,d=Z.NamedNodeMap,f=d===void 0?Z.NamedNodeMap||Z.MozNamedAttrMap:d,N=Z.Text,o=Z.Comment,s=Z.DOMParser,e=Z.trustedTypes,b=w.prototype,D=vt(b,"cloneNode"),v=vt(b,"nextSibling"),E=vt(b,"childNodes"),a=vt(b,"parentNode");if(typeof O=="function"){var l=i.createElement("template");l.content&&l.content.ownerDocument&&(i=l.content.ownerDocument)}var p=li(e,y),S=p&&X?p.createHTML(""):"",T=i,_=T.implementation,r=T.createNodeIterator,n=T.createDocumentFragment,u=T.getElementsByTagName,h=y.importNode,m={};try{m=ct(i).documentMode?i.documentMode:{}}catch{}var z={};t.isSupported=typeof a=="function"&&_&&typeof _.createHTMLDocument<"u"&&m!==9;var $=ei,J=ti,Q=ii,ge=ni,oe=ri,we=oi,he=si,se=null,_e=Be({},[].concat(rt(Mt),rt(Ct),rt(_t),rt(St),rt(Ot))),te=null,De=Be({},[].concat(rt(Bt),rt(At),rt(Ht),rt(Dt))),re=null,ie=null,ce=!0,ne=!0,F=!1,V=!1,j=!1,k=!1,c=!1,I=!1,U=!1,K=!0,X=!1,L=!0,R=!0,W=!1,A={},P=null,M=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),B=null,q=Be({},["audio","video","img","source","image","track"]),ee=null,le=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",ye="http://www.w3.org/2000/svg",Ee="http://www.w3.org/1999/xhtml",Re=Ee,Le=!1,ve=null,Pe=i.createElement("form"),ke=function(ue){ve&&ve===ue||((!ue||(typeof ue>"u"?"undefined":pt(ue))!=="object")&&(ue={}),ue=ct(ue),se="ALLOWED_TAGS"in ue?Be({},ue.ALLOWED_TAGS):_e,te="ALLOWED_ATTR"in ue?Be({},ue.ALLOWED_ATTR):De,ee="ADD_URI_SAFE_ATTR"in ue?Be(ct(le),ue.ADD_URI_SAFE_ATTR):le,B="ADD_DATA_URI_TAGS"in ue?Be(ct(q),ue.ADD_DATA_URI_TAGS):q,P="FORBID_CONTENTS"in ue?Be({},ue.FORBID_CONTENTS):M,re="FORBID_TAGS"in ue?Be({},ue.FORBID_TAGS):{},ie="FORBID_ATTR"in ue?Be({},ue.FORBID_ATTR):{},A="USE_PROFILES"in ue?ue.USE_PROFILES:!1,ce=ue.ALLOW_ARIA_ATTR!==!1,ne=ue.ALLOW_DATA_ATTR!==!1,F=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,V=ue.SAFE_FOR_TEMPLATES||!1,j=ue.WHOLE_DOCUMENT||!1,I=ue.RETURN_DOM||!1,U=ue.RETURN_DOM_FRAGMENT||!1,K=ue.RETURN_DOM_IMPORT!==!1,X=ue.RETURN_TRUSTED_TYPE||!1,c=ue.FORCE_BODY||!1,L=ue.SANITIZE_DOM!==!1,R=ue.KEEP_CONTENT!==!1,W=ue.IN_PLACE||!1,he=ue.ALLOWED_URI_REGEXP||he,Re=ue.NAMESPACE||Ee,V&&(ne=!1),U&&(I=!0),A&&(se=Be({},[].concat(rt(Ot))),te=[],A.html===!0&&(Be(se,Mt),Be(te,Bt)),A.svg===!0&&(Be(se,Ct),Be(te,At),Be(te,Dt)),A.svgFilters===!0&&(Be(se,_t),Be(te,At),Be(te,Dt)),A.mathMl===!0&&(Be(se,St),Be(te,Ht),Be(te,Dt))),ue.ADD_TAGS&&(se===_e&&(se=ct(se)),Be(se,ue.ADD_TAGS)),ue.ADD_ATTR&&(te===De&&(te=ct(te)),Be(te,ue.ADD_ATTR)),ue.ADD_URI_SAFE_ATTR&&Be(ee,ue.ADD_URI_SAFE_ATTR),ue.FORBID_CONTENTS&&(P===M&&(P=ct(P)),Be(P,ue.FORBID_CONTENTS)),R&&(se["#text"]=!0),j&&Be(se,["html","head","body"]),se.table&&(Be(se,["tbody"]),delete re.tbody),tt&&tt(ue),ve=ue)},qe=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},Ct);Be(Ue,_t),Be(Ue,Qt);var Ye=Be({},St);Be(Ye,Jt);var it=function(ue){var Se=a(ue);(!Se||!Se.tagName)&&(Se={namespaceURI:Ee,tagName:"template"});var Ne=ut(ue.tagName),We=ut(Se.tagName);if(ue.namespaceURI===ye)return Se.namespaceURI===Ee?Ne==="svg":Se.namespaceURI===de?Ne==="svg"&&(We==="annotation-xml"||qe[We]):Boolean(Ue[Ne]);if(ue.namespaceURI===de)return Se.namespaceURI===Ee?Ne==="math":Se.namespaceURI===ye?Ne==="math"&&He[We]:Boolean(Ye[Ne]);if(ue.namespaceURI===Ee){if(Se.namespaceURI===ye&&!He[We]||Se.namespaceURI===de&&!qe[We])return!1;var Xe=Be({},["title","style","font","a","script"]);return!Ye[Ne]&&(Xe[Ne]||!Ue[Ne])}return!1},Oe=function(ue){mt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{try{ue.outerHTML=S}catch{ue.remove()}}},xe=function(ue,Se){try{mt(t.removed,{attribute:Se.getAttributeNode(ue),from:Se})}catch{mt(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(ue),ue==="is"&&!te[ue])if(I||U)try{Oe(Se)}catch{}else try{Se.setAttribute(ue,"")}catch{}},x=function(ue){var Se=void 0,Ne=void 0;if(c)ue="<remove></remove>"+ue;else{var We=Rt(ue,/^[\r\n\t ]+/);Ne=We&&We[0]}var Xe=p?p.createHTML(ue):ue;if(Re===Ee)try{Se=new s().parseFromString(Xe,"text/html")}catch{}if(!Se||!Se.documentElement){Se=_.createDocument(Re,"template",null);try{Se.documentElement.innerHTML=Le?"":Xe}catch{}}var Ze=Se.body||Se.documentElement;return ue&&Ne&&Ze.insertBefore(i.createTextNode(Ne),Ze.childNodes[0]||null),Re===Ee?u.call(Se,j?"html":"body")[0]:j?Se.documentElement:Ze},ae=function(ue){return r.call(ue.ownerDocument||ue,ue,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},be=function(ue){return ue instanceof N||ue instanceof o?!1:typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof f)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"},Ce=function(ue){return(typeof C>"u"?"undefined":pt(C))==="object"?ue instanceof C:ue&&(typeof ue>"u"?"undefined":pt(ue))==="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},Ae=function(ue,Se,Ne){!z[ue]||Gt(z[ue],function(We){We.call(t,Se,Ne,ve)})},Me=function(ue){var Se=void 0;if(Ae("beforeSanitizeElements",ue,null),be(ue)||Rt(ue.nodeName,/[\u0080-\uFFFF]/))return Oe(ue),!0;var Ne=ut(ue.nodeName);if(Ae("uponSanitizeElement",ue,{tagName:Ne,allowedTags:se}),!Ce(ue.firstElementChild)&&(!Ce(ue.content)||!Ce(ue.content.firstElementChild))&&at(/<[/\w]/g,ue.innerHTML)&&at(/<[/\w]/g,ue.textContent)||Ne==="select"&&at(/<template/i,ue.innerHTML))return Oe(ue),!0;if(!se[Ne]||re[Ne]){if(R&&!P[Ne]){var We=a(ue)||ue.parentNode,Xe=E(ue)||ue.childNodes;if(Xe&&We)for(var Ze=Xe.length,Qe=Ze-1;Qe>=0;--Qe)We.insertBefore(D(Xe[Qe],!0),v(ue))}return Oe(ue),!0}return ue instanceof w&&!it(ue)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,ue.innerHTML)?(Oe(ue),!0):(V&&ue.nodeType===3&&(Se=ue.textContent,Se=lt(Se,$," "),Se=lt(Se,J," "),ue.textContent!==Se&&(mt(t.removed,{element:ue.cloneNode()}),ue.textContent=Se)),Ae("afterSanitizeElements",ue,null),!1)},$e=function(ue,Se,Ne){if(L&&(Se==="id"||Se==="name")&&(Ne in i||Ne in Pe))return!1;if(!(ne&&!ie[Se]&&at(Q,Se))){if(!(ce&&at(ge,Se))){if(!te[Se]||ie[Se])return!1;if(!ee[Se]){if(!at(he,lt(Ne,we,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&ue!=="script"&&Yt(Ne,"data:")===0&&B[ue])){if(!(F&&!at(oe,lt(Ne,we,"")))){if(Ne)return!1}}}}}}return!0},Ge=function(ue){var Se=void 0,Ne=void 0,We=void 0,Xe=void 0;Ae("beforeSanitizeAttributes",ue,null);var Ze=ue.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:te};for(Xe=Ze.length;Xe--;){Se=Ze[Xe];var st=Se,ht=st.name,yt=st.namespaceURI;if(Ne=Xt(Se.value),We=ut(ht),Qe.attrName=We,Qe.attrValue=Ne,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ae("uponSanitizeAttribute",ue,Qe),Ne=Qe.attrValue,!Qe.forceKeepAttr&&(xe(ht,ue),!!Qe.keepAttr)){if(at(/\/>/i,Ne)){xe(ht,ue);continue}V&&(Ne=lt(Ne,$," "),Ne=lt(Ne,J," "));var Ft=ue.nodeName.toLowerCase();if(!!$e(Ft,We,Ne))try{yt?ue.setAttributeNS(yt,ht,Ne):ue.setAttribute(ht,Ne),kt(t.removed)}catch{}}}Ae("afterSanitizeAttributes",ue,null)}},et=function Ie(ue){var Se=void 0,Ne=ae(ue);for(Ae("beforeSanitizeShadowDOM",ue,null);Se=Ne.nextNode();)Ae("uponSanitizeShadowNode",Se,null),!Me(Se)&&(Se.content instanceof H&&Ie(Se.content),Ge(Se));Ae("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Ie,ue){var Se=void 0,Ne=void 0,We=void 0,Xe=void 0,Ze=void 0;if(Le=!Ie,Le&&(Ie="<!-->"),typeof Ie!="string"&&!Ce(Ie)){if(typeof Ie.toString!="function")throw Pt("toString is not a function");if(Ie=Ie.toString(),typeof Ie!="string")throw Pt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(Z.toStaticHTML)==="object"||typeof Z.toStaticHTML=="function"){if(typeof Ie=="string")return Z.toStaticHTML(Ie);if(Ce(Ie))return Z.toStaticHTML(Ie.outerHTML)}return Ie}if(k||ke(ue),t.removed=[],typeof Ie=="string"&&(W=!1),!W)if(Ie instanceof C)Se=x("<!---->"),Ne=Se.ownerDocument.importNode(Ie,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Se=Ne:Se.appendChild(Ne);else{if(!I&&!V&&!j&&Ie.indexOf("<")===-1)return p&&X?p.createHTML(Ie):Ie;if(Se=x(Ie),!Se)return I?null:S}Se&&c&&Oe(Se.firstChild);for(var Qe=ae(W?Ie:Se);We=Qe.nextNode();)We.nodeType===3&&We===Xe||Me(We)||(We.content instanceof H&&et(We.content),Ge(We),Xe=We);if(Xe=null,W)return Ie;if(I){if(U)for(Ze=n.call(Se.ownerDocument);Se.firstChild;)Ze.appendChild(Se.firstChild);else Ze=Se;return K&&(Ze=h.call(y,Ze,!0)),Ze}var st=j?Se.outerHTML:Se.innerHTML;return V&&(st=lt(st,$," "),st=lt(st,J," ")),p&&X?p.createHTML(st):st},t.setConfig=function(Ie){ke(Ie),k=!0},t.clearConfig=function(){ve=null,k=!1},t.isValidAttribute=function(Ie,ue,Se){ve||ke({});var Ne=ut(Ie),We=ut(ue);return $e(Ne,We,Se)},t.addHook=function(Ie,ue){typeof ue=="function"&&(z[Ie]=z[Ie]||[],mt(z[Ie],ue))},t.removeHook=function(Ie){z[Ie]&&kt(z[Ie])},t.removeHooks=function(Ie){z[Ie]&&(z[Ie]=[])},t.removeAllHooks=function(){z={}},t}var ui=Wt();define("vs/base/browser/dompurify/dompurify",function(){return ui}),define(me[40],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class y{constructor(C){this.domNode=C,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(C){const w=i(C);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(C){const w=i(C);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(C){const w=i(C);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(C){const w=i(C);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(C){const w=i(C);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(C){const w=i(C);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(C){const w=i(C);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setFontFamily(C){this._fontFamily!==C&&(this._fontFamily=C,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(C){this._fontWeight!==C&&(this._fontWeight=C,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(C){const w=i(C);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(C){this._fontStyle!==C&&(this._fontStyle=C,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(C){this._fontFeatureSettings!==C&&(this._fontFeatureSettings=C,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(C){this._textDecoration!==C&&(this._textDecoration=C,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(C){const w=i(C);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(C){const w=i(C);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(C){this._className!==C&&(this._className=C,this.domNode.className=this._className)}toggleClassName(C,w){this.domNode.classList.toggle(C,w),this._className=this.domNode.className}setDisplay(C){this._display!==C&&(this._display=C,this.domNode.style.display=this._display)}setPosition(C){this._position!==C&&(this._position=C,this.domNode.style.position=this._position)}setVisibility(C){this._visibility!==C&&(this._visibility=C,this.domNode.style.visibility=this._visibility)}setColor(C){this._color!==C&&(this._color=C,this.domNode.style.color=this._color)}setBackgroundColor(C){this._backgroundColor!==C&&(this._backgroundColor=C,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(C){this._layerHint!==C&&(this._layerHint=C,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(C){this._boxShadow!==C&&(this._boxShadow=C,this.domNode.style.boxShadow=C)}setContain(C){this._contain!==C&&(this._contain=C,this.domNode.style.contain=this._contain)}setAttribute(C,w){this.domNode.setAttribute(C,w)}removeAttribute(C){this.domNode.removeAttribute(C)}appendChild(C){this.domNode.appendChild(C.domNode)}removeChild(C){this.domNode.removeChild(C.domNode)}}t.FastDomNode=y;function i(O){return typeof O=="number"?`${O}px`:O}function H(O){return new y(O)}t.createFastDomNode=H}),define(me[66],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let y=!1,i=null;function H(C){if(!C.parent||C.parent===C)return null;try{const w=C.location,g=C.parent.location;if(w.origin!=="null"&&g.origin!=="null"&&w.origin!==g.origin)return y=!0,null}catch{return y=!0,null}return C.parent}class O{static getSameOriginWindowChain(){if(!i){i=[];let w=window,g;do g=H(w),g?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=g;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(w,g){if(!g||w===g)return{top:0,left:0};let d=0,f=0;const N=this.getSameOriginWindowChain();for(const o of N){if(d+=o.window.scrollY,f+=o.window.scrollX,o.window===g||!o.iframeElement)break;const s=o.iframeElement.getBoundingClientRect();d+=s.top,f+=s.left}return{top:d,left:f}}}t.IframeUtils=O}),define(me[67],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var y;(function(O){O[O.Copy=0]="Copy",O[O.Move=1]="Move"})(y=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(C,w){super(`ListError [${C}] ${w}`)}}t.ListError=i;class H{constructor(){this.cache=new WeakMap}getHeight(C){return this.cache.get(C)??this.estimateHeight(C)}setDynamicHeight(C,w){w>0&&this.cache.set(C,w)}}t.CachedListVirtualDelegate=H}),define(me[68],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class y{constructor(H){this.spliceables=H}splice(H,O,C){this.spliceables.forEach(w=>w.splice(H,O,C))}}t.CombinedSpliceable=y}),define(me[41],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const y=20;class i{constructor(O,C,w,g,d,f){this._scrollbarSize=Math.round(C),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(O),this._visibleSize=g,this._scrollSize=d,this._scrollPosition=f,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(O){const C=Math.round(O);return this._visibleSize!==C?(this._visibleSize=C,this._refreshComputedValues(),!0):!1}setScrollSize(O){const C=Math.round(O);return this._scrollSize!==C?(this._scrollSize=C,this._refreshComputedValues(),!0):!1}setScrollPosition(O){const C=Math.round(O);return this._scrollPosition!==C?(this._scrollPosition=C,this._refreshComputedValues(),!0):!1}setScrollbarSize(O){this._scrollbarSize=Math.round(O)}setOppositeScrollbarSize(O){this._oppositeScrollbarSize=Math.round(O)}static _computeValues(O,C,w,g,d){const f=Math.max(0,w-O),N=Math.max(0,f-2*C),o=g>0&&g>w;if(!o)return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(N),computedSliderRatio:0,computedSliderPosition:0};const s=Math.round(Math.max(y,Math.floor(w*N/g))),e=(N-s)/(g-w),b=d*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(s),computedSliderRatio:e,computedSliderPosition:Math.round(b)}}_refreshComputedValues(){const O=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=O.computedAvailableSize,this._computedIsNeeded=O.computedIsNeeded,this._computedSliderSize=O.computedSliderSize,this._computedSliderRatio=O.computedSliderRatio,this._computedSliderPosition=O.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(O){if(!this._computedIsNeeded)return 0;const C=O-this._arrowSize-this._computedSliderSize/2;return Math.round(C/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(O){if(!this._computedIsNeeded)return 0;const C=O-this._arrowSize;let w=this._scrollPosition;return C<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(O){if(!this._computedIsNeeded)return 0;const C=this._computedSliderPosition+O;return Math.round(C/this._computedSliderRatio)}}t.ScrollbarState=i}),define(me[23],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var y;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(y=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var H;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(H=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class O extends Error{constructor(g,d){super(`TreeError [${g}] ${d}`)}}t.TreeError=O;class C{constructor(g){this.fn=g,this._map=new WeakMap}map(g){let d=this._map.get(g);return d||(d=this.fn(g),this._map.set(g,d)),d}}t.WeakMapper=C}),define(me[69],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.ok=void 0;function y(H,O){if(!H)throw new Error(O?`Assertion failed (${O})`:"Assertion Failed")}t.ok=y;function i(H,O="Unreachable"){throw new Error(O)}t.assertNever=i}),define(me[11],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function y(C){return C?C.replace(/\$\((.*?)\)/g,(w,g)=>` ${g} `).trim():""}t.getCodiconAriaLabel=y;class i{constructor(w,g,d){this.id=w,this.definition=g,this.description=d,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function H(C,w){const g=["codicon","codicon-"+C];return w&&g.push("codicon-modifier-"+w),g}t.getClassNamesArray=H;var O;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function g(N){if(N instanceof i)return["codicon","codicon-"+N.id];const o=w.exec(N.id);if(!o)return g(i.error);const[,s,e]=o,b=["codicon","codicon-"+s];return e&&b.push("codicon-modifier-"+e.substr(1)),b}C.asClassNameArray=g;function d(N){return g(N).join(" ")}C.asClassName=d;function f(N){return"."+g(N).join(".")}C.asCSSSelector=f})(O=t.CSSIcon||(t.CSSIcon={}))}),define(me[70],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function y(C,w){const g=Object.create(null);for(const d of C){const f=w(d);let N=g[f];N||(N=g[f]=[]),N.push(d)}return g}t.groupBy=y;function i(C,w){const g=[],d=[];for(const f of C)w.has(f)||g.push(f);for(const f of w)C.has(f)||d.push(f);return{removed:g,added:d}}t.diffSets=i;function H(C,w){const g=[],d=[];for(const[f,N]of C)w.has(f)||g.push(N);for(const[f,N]of w)C.has(f)||d.push(N);return{removed:g,added:d}}t.diffMaps=H;class O{constructor(){this.map=new Map}add(w,g){let d=this.map.get(w);d||(d=new Set,this.map.set(w,d)),d.add(g)}delete(w,g){const d=this.map.get(w);!d||(d.delete(g),d.size===0&&this.map.delete(w))}forEach(w,g){const d=this.map.get(w);!d||d.forEach(g)}}t.SetMap=O}),define(me[24],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function y(w,g){const d=Math.pow(10,g);return Math.round(w*d)/d}class i{constructor(g,d,f,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=y(Math.max(Math.min(1,N),0),3)}static equals(g,d){return g.r===d.r&&g.g===d.g&&g.b===d.b&&g.a===d.a}}t.RGBA=i;class H{constructor(g,d,f,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=y(Math.max(Math.min(1,d),0),3),this.l=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,N),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.l===d.l&&g.a===d.a}static fromRGBA(g){const d=g.r/255,f=g.g/255,N=g.b/255,o=g.a,s=Math.max(d,f,N),e=Math.min(d,f,N);let b=0,D=0;const v=(e+s)/2,E=s-e;if(E>0){switch(D=Math.min(v<=.5?E/(2*v):E/(2-2*v),1),s){case d:b=(f-N)/E+(f<N?6:0);break;case f:b=(N-d)/E+2;break;case N:b=(d-f)/E+4;break}b*=60,b=Math.round(b)}return new H(b,D,v,o)}static _hue2rgb(g,d,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?g+(d-g)*6*f:f<1/2?d:f<2/3?g+(d-g)*(2/3-f)*6:g}static toRGBA(g){const d=g.h/360,{s:f,l:N,a:o}=g;let s,e,b;if(f===0)s=e=b=N;else{const D=N<.5?N*(1+f):N+f-N*f,v=2*N-D;s=H._hue2rgb(v,D,d+1/3),e=H._hue2rgb(v,D,d),b=H._hue2rgb(v,D,d-1/3)}return new i(Math.round(s*255),Math.round(e*255),Math.round(b*255),o)}}t.HSLA=H;class O{constructor(g,d,f,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=y(Math.max(Math.min(1,d),0),3),this.v=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,N),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.v===d.v&&g.a===d.a}static fromRGBA(g){const d=g.r/255,f=g.g/255,N=g.b/255,o=Math.max(d,f,N),s=Math.min(d,f,N),e=o-s,b=o===0?0:e/o;let D;return e===0?D=0:o===d?D=((f-N)/e%6+6)%6:o===f?D=(N-d)/e+2:D=(d-f)/e+4,new O(Math.round(D*60),b,o,g.a)}static toRGBA(g){const{h:d,s:f,v:N,a:o}=g,s=N*f,e=s*(1-Math.abs(d/60%2-1)),b=N-s;let[D,v,E]=[0,0,0];return d<60?(D=s,v=e):d<120?(D=e,v=s):d<180?(v=s,E=e):d<240?(v=e,E=s):d<300?(D=e,E=s):d<=360&&(D=s,E=e),D=Math.round((D+b)*255),v=Math.round((v+b)*255),E=Math.round((E+b)*255),new i(D,v,E,o)}}t.HSVA=O;class C{constructor(g){if(g)if(g instanceof i)this.rgba=g;else if(g instanceof H)this._hsla=g,this.rgba=H.toRGBA(g);else if(g instanceof O)this._hsva=g,this.rgba=O.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(g){return C.Format.CSS.parseHex(g)||C.red}get hsla(){return this._hsla?this._hsla:H.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}equals(g){return!!g&&i.equals(this.rgba,g.rgba)&&H.equals(this.hsla,g.hsla)&&O.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=C._relativeLuminanceForComponent(this.rgba.r),d=C._relativeLuminanceForComponent(this.rgba.g),f=C._relativeLuminanceForComponent(this.rgba.b),N=.2126*g+.7152*d+.0722*f;return y(N,4)}static _relativeLuminanceForComponent(g){const d=g/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(g){const d=this.getRelativeLuminance(),f=g.getRelativeLuminance();return d>f?(d+.05)/(f+.05):(f+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const d=this.getRelativeLuminance(),f=g.getRelativeLuminance();return d>f}isDarkerThan(g){const d=this.getRelativeLuminance(),f=g.getRelativeLuminance();return d<f}lighten(g){return new C(new H(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new C(new H(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:d,g:f,b:N,a:o}=this.rgba;return new C(new i(d,f,N,o*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const d=g.rgba,f=this.rgba.a,N=d.a,o=f+N*(1-f);if(o<1e-6)return C.transparent;const s=this.rgba.r*f/o+d.r*N*(1-f)/o,e=this.rgba.g*f/o+d.g*N*(1-f)/o,b=this.rgba.b*f/o+d.b*N*(1-f)/o;return new C(new i(s,e,b,o))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:d,g:f,b:N,a:o}=this.rgba;return new C(new i(g.rgba.r-o*(g.rgba.r-d),g.rgba.g-o*(g.rgba.g-f),g.rgba.b-o*(g.rgba.b-N),1))}flatten(...g){const d=g.reduceRight((f,N)=>C._flatten(N,f));return C._flatten(this,d)}static _flatten(g,d){const f=1-g.rgba.a;return new C(new i(f*d.rgba.r+g.rgba.a*g.rgba.r,f*d.rgba.g+g.rgba.a*g.rgba.g,f*d.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this._toString||(this._toString=C.Format.CSS.format(this)),this._toString}static getLighterColor(g,d,f){if(g.isLighterThan(d))return g;f=f||.5;const N=g.getRelativeLuminance(),o=d.getRelativeLuminance();return f=f*(o-N)/o,g.lighten(f)}static getDarkerColor(g,d,f){if(g.isDarkerThan(d))return g;f=f||.5;const N=g.getRelativeLuminance(),o=d.getRelativeLuminance();return f=f*(N-o)/N,g.darken(f)}}t.Color=C,C.white=new C(new i(255,255,255,1)),C.black=new C(new i(0,0,0,1)),C.red=new C(new i(255,0,0,1)),C.blue=new C(new i(0,0,255,1)),C.green=new C(new i(0,255,0,1)),C.cyan=new C(new i(0,255,255,1)),C.lightgrey=new C(new i(211,211,211,1)),C.transparent=new C(new i(0,0,0,0)),function(w){let g;(function(d){let f;(function(N){function o(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:w.Format.CSS.formatRGBA(S)}N.formatRGB=o;function s(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}N.formatRGBA=s;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(S)}N.formatHSL=e;function b(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}N.formatHSLA=b;function D(S){const T=S.toString(16);return T.length!==2?"0"+T:T}function v(S){return`#${D(S.rgba.r)}${D(S.rgba.g)}${D(S.rgba.b)}`}N.formatHex=v;function E(S,T=!1){return T&&S.rgba.a===1?w.Format.CSS.formatHex(S):`#${D(S.rgba.r)}${D(S.rgba.g)}${D(S.rgba.b)}${D(Math.round(S.rgba.a*255))}`}N.formatHexA=E;function a(S){return S.isOpaque()?w.Format.CSS.formatHex(S):w.Format.CSS.formatRGBA(S)}N.format=a;function l(S){const T=S.length;if(T===0||S.charCodeAt(0)!==35)return null;if(T===7){const _=16*p(S.charCodeAt(1))+p(S.charCodeAt(2)),r=16*p(S.charCodeAt(3))+p(S.charCodeAt(4)),n=16*p(S.charCodeAt(5))+p(S.charCodeAt(6));return new w(new i(_,r,n,1))}if(T===9){const _=16*p(S.charCodeAt(1))+p(S.charCodeAt(2)),r=16*p(S.charCodeAt(3))+p(S.charCodeAt(4)),n=16*p(S.charCodeAt(5))+p(S.charCodeAt(6)),u=16*p(S.charCodeAt(7))+p(S.charCodeAt(8));return new w(new i(_,r,n,u/255))}if(T===4){const _=p(S.charCodeAt(1)),r=p(S.charCodeAt(2)),n=p(S.charCodeAt(3));return new w(new i(16*_+_,16*r+r,16*n+n))}if(T===5){const _=p(S.charCodeAt(1)),r=p(S.charCodeAt(2)),n=p(S.charCodeAt(3)),u=p(S.charCodeAt(4));return new w(new i(16*_+_,16*r+r,16*n+n,(16*u+u)/255))}return null}N.parseHex=l;function p(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=d.CSS||(d.CSS={}))})(g=w.Format||(w.Format={}))}(C=t.Color||(t.Color={}))}),define(me[25],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function y(C){return(w,g,d)=>{let f=null,N=null;if(typeof d.value=="function"?(f="value",N=d.value):typeof d.get=="function"&&(f="get",N=d.get),!N)throw new Error("not supported");d[f]=C(N,g)}}t.createDecorator=y;function i(C,w,g){let d=null,f=null;if(typeof g.value=="function"?(d="value",f=g.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(d="get",f=g.get),!f)throw new Error("not supported");const N=`$memoize$${w}`;g[d]=function(...o){return this.hasOwnProperty(N)||Object.defineProperty(this,N,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,o)}),this[N]}}t.memoize=i;function H(C,w,g){return y((d,f)=>{const N=`$debounce$${f}`,o=`$debounce$result$${f}`;return function(...s){this[o]||(this[o]=g?g():void 0),clearTimeout(this[N]),w&&(this[o]=w(this[o],...s),s=[this[o]]),this[N]=setTimeout(()=>{d.apply(this,s),this[o]=g?g():void 0},C)}})}t.debounce=H;function O(C,w,g){return y((d,f)=>{const N=`$throttle$timer$${f}`,o=`$throttle$result$${f}`,s=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...b){if(this[o]||(this[o]=g?g():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),w&&(this[o]=w(this[o],...b)),this[e])return;const D=this[s]+C;D<=Date.now()?(this[s]=Date.now(),d.apply(this,[this[o]]),this[o]=g?g():void 0):(this[e]=!0,this[N]=setTimeout(()=>{this[e]=!1,this[s]=Date.now(),d.apply(this,[this[o]]),this[o]=g?g():void 0},D-Date.now()))}})}t.throttle=O}),define(me[71],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class y{constructor(H,O,C,w){this.originalStart=H,this.originalLength=O,this.modifiedStart=C,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=y}),define(me[13],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(S){setTimeout(()=>{throw S.stack?a.isErrorNoTelemetry(S)?new a(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.listeners.push(S),()=>{this._removeListener(S)}}emit(S){this.listeners.forEach(T=>{T(S)})}_removeListener(S){this.listeners.splice(this.listeners.indexOf(S),1)}setUnexpectedErrorHandler(S){this.unexpectedErrorHandler=S}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(S){this.unexpectedErrorHandler(S),this.emit(S)}onUnexpectedExternalError(S){this.unexpectedErrorHandler(S)}}t.ErrorHandler=y,t.errorHandler=new y;function i(p){t.errorHandler.setUnexpectedErrorHandler(p)}t.setUnexpectedErrorHandler=i;function H(p){g(p)||t.errorHandler.onUnexpectedError(p)}t.onUnexpectedError=H;function O(p){g(p)||t.errorHandler.onUnexpectedExternalError(p)}t.onUnexpectedExternalError=O;function C(p){if(p instanceof Error){const{name:S,message:T}=p,_=p.stacktrace||p.stack;return{$isError:!0,name:S,message:T,stack:_,noTelemetry:a.isErrorNoTelemetry(p)}}return p}t.transformErrorForSerialization=C;const w="Canceled";function g(p){return p instanceof d?!0:p instanceof Error&&p.name===w&&p.message===w}t.isCancellationError=g;class d extends Error{constructor(){super(w),this.name=this.message}}t.CancellationError=d;function f(){const p=new Error(w);return p.name=p.message,p}t.canceled=f;function N(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}t.illegalArgument=N;function o(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}t.illegalState=o;function s(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=s;function e(p){const S=new Error(`${p} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function b(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}t.getErrorMessage=b;class D extends Error{constructor(S){super("NotImplemented"),S&&(this.message=S)}}t.NotImplementedError=D;class v extends Error{constructor(S){super("NotSupported"),S&&(this.message=S)}}t.NotSupportedError=v;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=E;class a extends Error{constructor(S){super(S),this.name="CodeExpectedError"}static fromError(S){if(S instanceof a)return S;const T=new a;return T.message=S.message,T.stack=S.stack,T}static isErrorNoTelemetry(S){return S.name==="CodeExpectedError"}}t.ErrorNoTelemetry=a;class l extends Error{constructor(S){super(S||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}t.BugIndicatingError=l}),define(me[14],pe([1,0,13]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(L,R=0){return L[L.length-(1+R)]}t.tail=i;function H(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}t.tail2=H;function O(L,R,W=(A,P)=>A===P){if(L===R)return!0;if(!L||!R||L.length!==R.length)return!1;for(let A=0,P=L.length;A<P;A++)if(!W(L[A],R[A]))return!1;return!0}t.equals=O;function C(L,R){const W=L.length-1;R<W&&(L[R]=L[W]),L.pop()}t.removeFastWithoutKeepingOrder=C;function w(L,R,W){return g(L.length,A=>W(L[A],R))}t.binarySearch=w;function g(L,R){let W=0,A=L-1;for(;W<=A;){const P=(W+A)/2|0,M=R(P);if(M<0)W=P+1;else if(M>0)A=P-1;else return P}return-(W+1)}t.binarySearch2=g;function d(L,R){let W=0,A=L.length;if(A===0)return 0;for(;W<A;){const P=Math.floor((W+A)/2);R(L[P])?A=P:W=P+1}return W}t.findFirstInSorted=d;function f(L,R,W){if(L=L|0,L>=R.length)throw new TypeError("invalid index");const A=R[Math.floor(R.length*Math.random())],P=[],M=[],B=[];for(const q of R){const ee=W(q,A);ee<0?P.push(q):ee>0?M.push(q):B.push(q)}return L<P.length?f(L,P,W):L<P.length+B.length?B[0]:f(L-(P.length+B.length),M,W)}t.quickSelect=f;function N(L,R){const W=[];let A;for(const P of L.slice(0).sort(R))!A||R(A[0],P)!==0?(A=[P],W.push(A)):A.push(P);return W}t.groupBy=N;function o(L,R,W){const A=[];function P(q,ee,le){if(ee===0&&le.length===0)return;const de=A[A.length-1];de&&de.start+de.deleteCount===q?(de.deleteCount+=ee,de.toInsert.push(...le)):A.push({start:q,deleteCount:ee,toInsert:le})}let M=0,B=0;for(;;){if(M===L.length){P(M,0,R.slice(B));break}if(B===R.length){P(M,L.length-M,[]);break}const q=L[M],ee=R[B],le=W(q,ee);le===0?(M+=1,B+=1):le<0?(P(M,1,[]),M+=1):le>0&&(P(M,0,[ee]),B+=1)}return A}t.sortedDiff=o;function s(L,R,W){const A=o(L,R,W),P=[],M=[];for(const B of A)P.push(...L.slice(B.start,B.start+B.deleteCount)),M.push(...B.toInsert);return{removed:P,added:M}}t.delta=s;function e(L,R,W){if(W===0)return[];const A=L.slice(0,W).sort(R);return D(L,R,A,W,L.length),A}t.top=e;function b(L,R,W,A,P){return W===0?Promise.resolve([]):new Promise((M,B)=>{(async()=>{const q=L.length,ee=L.slice(0,W).sort(R);for(let le=W,de=Math.min(W+A,q);le<q;le=de,de=Math.min(de+A,q)){if(le>W&&await new Promise(ye=>setTimeout(ye)),P&&P.isCancellationRequested)throw new y.CancellationError;D(L,R,ee,le,de)}return ee})().then(M,B)})}t.topAsync=b;function D(L,R,W,A,P){for(const M=W.length;A<P;A++){const B=L[A];if(R(B,W[M-1])<0){W.pop();const q=d(W,ee=>R(B,ee)<0);W.splice(q,0,B)}}}function v(L){return L.filter(R=>!!R)}t.coalesce=v;function E(L){let R=0;for(let W=0;W<L.length;W++)L[W]&&(L[R]=L[W],R+=1);L.length=R}t.coalesceInPlace=E;function a(L,R,W){L.splice(W,0,L.splice(R,1)[0])}t.move=a;function l(L){return!Array.isArray(L)||L.length===0}t.isFalsyOrEmpty=l;function p(L){return Array.isArray(L)&&L.length>0}t.isNonEmptyArray=p;function S(L,R=W=>W){const W=new Set;return L.filter(A=>{const P=R(A);return W.has(P)?!1:(W.add(P),!0)})}t.distinct=S;function T(L){const R=new Set;return W=>{const A=L(W);return R.has(A)?!1:(R.add(A),!0)}}t.uniqueFilter=T;function _(L,R){const W=r(L,R);if(W!==-1)return L[W]}t.findLast=_;function r(L,R){for(let W=L.length-1;W>=0;W--){const A=L[W];if(R(A))return W}return-1}t.lastIndex=r;function n(L,R){return L.length>0?L[0]:R}t.firstOrDefault=n;function u(L,R){return L.length>0?L[L.length-1]:R}t.lastOrDefault=u;function h(L,R,W=(A,P)=>A===P){let A=0;for(let P=0,M=Math.min(L.length,R.length);P<M&&W(L[P],R[P]);P++)A++;return A}t.commonPrefixLength=h;function m(L){return[].concat(...L)}t.flatten=m;function z(L,R){let W=typeof R=="number"?L:0;typeof R=="number"?W=L:(W=0,R=L);const A=[];if(W<=R)for(let P=W;P<R;P++)A.push(P);else for(let P=W;P>R;P--)A.push(P);return A}t.range=z;function $(L,R,W){return L.reduce((A,P)=>(A[R(P)]=W?W(P):P,A),Object.create(null))}t.index=$;function J(L,R){return L.push(R),()=>Q(L,R)}t.insert=J;function Q(L,R){const W=L.indexOf(R);if(W>-1)return L.splice(W,1),R}t.remove=Q;function ge(L,R,W){const A=L.slice(0,R),P=L.slice(R);return A.concat(W,P)}t.arrayInsert=ge;function oe(L,R){let W;if(typeof R=="number"){let A=R;W=()=>{const P=Math.sin(A++)*179426549;return P-Math.floor(P)}}else W=Math.random;for(let A=L.length-1;A>0;A-=1){const P=Math.floor(W()*(A+1)),M=L[A];L[A]=L[P],L[P]=M}}t.shuffle=oe;function we(L,R){const W=L.indexOf(R);W>-1&&(L.splice(W,1),L.unshift(R))}t.pushToStart=we;function he(L,R){const W=L.indexOf(R);W>-1&&(L.splice(W,1),L.push(R))}t.pushToEnd=he;function se(L,R){for(const W of R)L.push(W)}t.pushMany=se;function _e(L,R){return Array.isArray(L)?L.map(R):R(L)}t.mapArrayOrNot=_e;function te(L){return Array.isArray(L)?L:[L]}t.asArray=te;function De(L){return L[Math.floor(Math.random()*L.length)]}t.getRandomElement=De;function re(L,R){for(const W of L){const A=R(W);if(A!==void 0)return A}}t.mapFind=re;function ie(L,R,W){const A=ne(L,R),P=L.length,M=W.length;L.length=P+M;for(let B=P-1;B>=A;B--)L[B+M]=L[B];for(let B=0;B<M;B++)L[B+A]=W[B]}t.insertInto=ie;function ce(L,R,W,A){const P=ne(L,R),M=L.splice(P,W);return ie(L,P,A),M}t.splice=ce;function ne(L,R){return R<0?Math.max(R+L.length,0):Math.min(R,L.length)}var F;(function(L){function R(P){return P<0}L.isLessThan=R;function W(P){return P>0}L.isGreaterThan=W;function A(P){return P===0}L.isNeitherLessOrGreaterThan=A,L.greaterThan=1,L.lessThan=-1,L.neitherLessOrGreaterThan=0})(F=t.CompareResult||(t.CompareResult={}));function V(L,R){return(W,A)=>R(L(W),L(A))}t.compareBy=V;function j(...L){return(R,W)=>{for(const A of L){const P=A(R,W);if(!F.isNeitherLessOrGreaterThan(P))return P}return F.neitherLessOrGreaterThan}}t.tieBreakComparators=j;const k=(L,R)=>L-R;t.numberComparator=k;function c(L,R){if(L.length===0)return;let W=L[0];for(let A=1;A<L.length;A++){const P=L[A];R(P,W)>0&&(W=P)}return W}t.findMaxBy=c;function I(L,R){if(L.length===0)return;let W=L[0];for(let A=1;A<L.length;A++){const P=L[A];R(P,W)>=0&&(W=P)}return W}t.findLastMaxBy=I;function U(L,R){return c(L,(W,A)=>-R(W,A))}t.findMinBy=U;class K{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let W=this.firstIdx;for(;W<this.items.length&&R(this.items[W]);)W++;const A=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,A}takeFromEndWhile(R){let W=this.lastIdx;for(;W>=0&&R(this.items[W]);)W--;const A=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,A}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}removeLast(){const R=this.items[this.lastIdx];return this.lastIdx--,R}takeCount(R){const W=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,W}}t.ArrayQueue=K;class X{constructor(R){this.iterate=R}forEach(R){this.iterate(W=>(R(W),!0))}toArray(){const R=[];return this.iterate(W=>(R.push(W),!0)),R}filter(R){return new X(W=>this.iterate(A=>R(A)?W(A):!0))}map(R){return new X(W=>this.iterate(A=>W(R(A))))}some(R){let W=!1;return this.iterate(A=>(W=R(A),!W)),W}findFirst(R){let W;return this.iterate(A=>R(A)?(W=A,!1):!0),W}findLast(R){let W;return this.iterate(A=>(R(A)&&(W=A),!0)),W}findLastMaxBy(R){let W,A=!0;return this.iterate(P=>((A||F.isGreaterThan(R(P,W)))&&(A=!1,W=P),!0)),W}}t.CallbackIterable=X,X.empty=new X(L=>{})}),define(me[42],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function y(i){const H=this;let O=!1,C;return function(){return O||(O=!0,C=i.apply(H,arguments)),C}}t.once=y}),define(me[72],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class y{constructor(H){this._prefix=H,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=y,t.defaultGenerator=new y("id#")}),define(me[26],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(i){function H(T){return T&&typeof T=="object"&&typeof T[Symbol.iterator]=="function"}i.is=H;const O=Object.freeze([]);function C(){return O}i.empty=C;function*w(T){yield T}i.single=w;function g(T){return T||O}i.from=g;function d(T){return!T||T[Symbol.iterator]().next().done===!0}i.isEmpty=d;function f(T){return T[Symbol.iterator]().next().value}i.first=f;function N(T,_){for(const r of T)if(_(r))return!0;return!1}i.some=N;function o(T,_){for(const r of T)if(_(r))return r}i.find=o;function*s(T,_){for(const r of T)_(r)&&(yield r)}i.filter=s;function*e(T,_){let r=0;for(const n of T)yield _(n,r++)}i.map=e;function*b(...T){for(const _ of T)for(const r of _)yield r}i.concat=b;function*D(T){for(const _ of T)for(const r of _)yield r}i.concatNested=D;function v(T,_,r){let n=r;for(const u of T)n=_(n,u);return n}i.reduce=v;function E(T,_){let r=0;for(const n of T)_(n,r++)}i.forEach=E;function*a(T,_,r=T.length){for(_<0&&(_+=T.length),r<0?r+=T.length:r>T.length&&(r=T.length);_<r;_++)yield T[_]}i.slice=a;function l(T,_=Number.POSITIVE_INFINITY){const r=[];if(_===0)return[r,T];const n=T[Symbol.iterator]();for(let u=0;u<_;u++){const h=n.next();if(h.done)return[r,i.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return n}}]}i.consume=l;function p(T){return l(T)[0]}i.collect=p;function S(T,_,r=(n,u)=>n===u){const n=T[Symbol.iterator](),u=_[Symbol.iterator]();for(;;){const h=n.next(),m=u.next();if(h.done!==m.done)return!1;if(h.done)return!0;if(!r(h.value,m.value))return!1}}i.equals=S})(y=t.Iterable||(t.Iterable={}))}),define(me[43],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(y=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class H{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,D){this._keyCodeToStr[b]=D,this._strToKeyCode[D.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||0}}const O=new H,C=new H,w=new H;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],d=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>d[e]||0,toString:e=>g[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",b=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],v=[];for(const E of b){const[a,l,p,S,T,_,r,n,u,h]=E;if(v[p]||(v[p]=!0,g[p]=S,d[S]=p,f[S.toLowerCase()]=p,l&&(t.IMMUTABLE_CODE_TO_KEY_CODE[p]=T,T!==0&&T!==3&&T!==5&&T!==4&&T!==6&&T!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[T]=p))),!D[T]){if(D[T]=!0,!_)throw new Error(`String representation missing for key code ${T} around scan code ${S}`);O.define(T,_),C.define(T,u||_),w.define(T,h||u||_)}r&&(t.EVENT_KEY_CODE_MAP[r]=T),n&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[n]=T)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function b(p){return O.keyCodeToStr(p)}e.toString=b;function D(p){return O.strToKeyCode(p)}e.fromString=D;function v(p){return C.keyCodeToStr(p)}e.toUserSettingsUS=v;function E(p){return w.keyCodeToStr(p)}e.toUserSettingsGeneral=E;function a(p){return C.strToKeyCode(p)||w.strToKeyCode(p)}e.fromUserSettings=a;function l(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return O.keyCodeToStr(p)}e.toElectronAccelerator=l})(N=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function s(e,b){const D=(b&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=s}),define(me[73],pe([1,0,13]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(N){N[N.CtrlCmd=2048]="CtrlCmd",N[N.Shift=1024]="Shift",N[N.Alt=512]="Alt",N[N.WinCtrl=256]="WinCtrl",N[N.KeyCode=255]="KeyCode"})(i||(i={}));function H(N,o){if(N===0)return null;const s=(N&65535)>>>0,e=(N&4294901760)>>>16;return e!==0?new w([O(s,o),O(e,o)]):new w([O(s,o)])}t.createKeybinding=H;function O(N,o){const s=!!(N&2048),e=!!(N&256),b=o===2?e:s,D=!!(N&1024),v=!!(N&512),E=o===2?s:e,a=N&255;return new C(b,D,v,E,a)}t.createSimpleKeybinding=O;class C{constructor(o,s,e,b,D){this.ctrlKey=o,this.shiftKey=s,this.altKey=e,this.metaKey=b,this.keyCode=D}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",e=this.altKey?"1":"0",b=this.metaKey?"1":"0";return`${o}${s}${e}${b}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=C;class w{constructor(o){if(o.length===0)throw(0,y.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let s=0,e=this.parts.length;s<e;s++)s!==0&&(o+=";"),o+=this.parts[s].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let s=0;s<this.parts.length;s++)if(!this.parts[s].equals(o.parts[s]))return!1;return!0}}t.ChordKeybinding=w;class g{constructor(o,s,e,b,D){this.ctrlKey=o,this.shiftKey=s,this.altKey=e,this.metaKey=b,this.scanCode=D}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=g;class d{constructor(o,s,e,b,D,v){this.ctrlKey=o,this.shiftKey=s,this.altKey=e,this.metaKey=b,this.keyLabel=D,this.keyAriaLabel=v}}t.ResolvedKeybindingPart=d;class f{}t.ResolvedKeybinding=f}),define(me[44],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class y{constructor(H){this.executor=H,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(H){this._error=H}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(H){return new y(()=>H(this.getValue()))}}t.Lazy=y}),define(me[2],pe([1,0,42,26]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const H=!1;let O=null;function C(n){O=n}if(t.setDisposableTracker=C,H){const n="__is_disposable_tracked__";C(new class{trackDisposable(u){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[n]||console.log(h)},3e3)}setParent(u,h){if(u&&u!==E.None)try{u[n]=!0}catch{}}markAsDisposed(u){if(u&&u!==E.None)try{u[n]=!0}catch{}}markAsSingleton(u){}})}function w(n){return O?.trackDisposable(n),n}function g(n){O?.markAsDisposed(n)}function d(n,u){O?.setParent(n,u)}function f(n,u){if(!!O)for(const h of n)O.setParent(h,u)}function N(n){return O?.markAsSingleton(n),n}t.markAsSingleton=N;function o(n){return typeof n.dispose=="function"&&n.dispose.length===0}t.isDisposable=o;function s(n){if(i.Iterable.is(n)){const u=[];for(const h of n)if(h)try{h.dispose()}catch(m){u.push(m)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}t.dispose=s;function e(n){for(const u of n)o(u)&&u.dispose();return[]}t.disposeIfDisposable=e;function b(...n){const u=D(()=>s(n));return f(n,u),u}t.combinedDisposable=b;function D(n){const u=w({dispose:(0,y.once)(()=>{g(u),n()})});return u}t.toDisposable=D;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{s(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return d(u,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}t.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new v,w(this),d(this._store,this)}dispose(){g(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}t.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&d(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&d(u,null),u}}t.MutableDisposable=a;class l{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=l;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(u){let h=u;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,g(this))},this}}t.SafeDisposable=p;class S{constructor(){this.references=new Map}acquire(u,...h){let m=this.references.get(u);m||(m={counter:0,object:this.createReferencedObject(u,...h)},this.references.set(u,m));const{object:z}=m,$=(0,y.once)(()=>{--m.counter===0&&(this.destroyReferencedObject(u,m.object),this.references.delete(u))});return m.counter++,{object:z,dispose:$}}}t.ReferenceCollection=S;class T{constructor(u){this.referenceCollection=u}async acquire(u,...h){const m=this.referenceCollection.acquire(u,...h);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(z){throw m.dispose(),z}}}t.AsyncReferenceCollection=T;class _{constructor(u){this.object=u}dispose(){}}t.ImmortalReference=_;function r(n){const u=new v;try{n(u)}finally{u.dispose()}}t.disposeOnReturn=r}),define(me[74],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class y{constructor(O){this.element=O,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class i{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let O=this._first;for(;O!==y.Undefined;){const C=O.next;O.prev=y.Undefined,O.next=y.Undefined,O=C}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,C){const w=new y(O);if(this._first===y.Undefined)this._first=w,this._last=w;else if(C){const d=this._last;this._last=w,w.prev=d,d.next=w}else{const d=this._first;this._first=w,w.next=d,d.prev=w}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(w))}}shift(){if(this._first!==y.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==y.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==y.Undefined&&O.next!==y.Undefined){const C=O.prev;C.next=O.next,O.next.prev=C}else O.prev===y.Undefined&&O.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):O.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):O.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==y.Undefined;)yield O.element,O=O.next}}t.LinkedList=i}),function(Z,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(me[75],pe([0]),t):(Z=typeof globalThis<"u"?globalThis:Z||self,t(Z.marked={}))}(this,function(Z){"use strict";function t(L,R){for(var W=0;W<R.length;W++){var A=R[W];A.enumerable=A.enumerable||!1,A.configurable=!0,"value"in A&&(A.writable=!0),Object.defineProperty(L,A.key,A)}}function y(L,R,W){return R&&t(L.prototype,R),W&&t(L,W),Object.defineProperty(L,"prototype",{writable:!1}),L}function i(L,R){if(!!L){if(typeof L=="string")return H(L,R);var W=Object.prototype.toString.call(L).slice(8,-1);if(W==="Object"&&L.constructor&&(W=L.constructor.name),W==="Map"||W==="Set")return Array.from(L);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return H(L,R)}}function H(L,R){(R==null||R>L.length)&&(R=L.length);for(var W=0,A=new Array(R);W<R;W++)A[W]=L[W];return A}function O(L,R){var W=typeof Symbol<"u"&&L[Symbol.iterator]||L["@@iterator"];if(W)return(W=W.call(L)).next.bind(W);if(Array.isArray(L)||(W=i(L))||R&&L&&typeof L.length=="number"){W&&(L=W);var A=0;return function(){return A>=L.length?{done:!0}:{done:!1,value:L[A++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=C();function w(L){Z.defaults=L}var g=/[&<>"']/,d=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,N=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},s=function(R){return o[R]};function e(L,R){if(R){if(g.test(L))return L.replace(d,s)}else if(f.test(L))return L.replace(N,s);return L}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(L){return L.replace(b,function(R,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var v=/(^|[^\[])\^/g;function E(L,R){L=typeof L=="string"?L:L.source,R=R||"";var W={replace:function(P,M){return M=M.source||M,M=M.replace(v,"$1"),L=L.replace(P,M),W},getRegex:function(){return new RegExp(L,R)}};return W}var a=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(L,R,W){if(L){var A;try{A=decodeURIComponent(D(W)).replace(a,"").toLowerCase()}catch{return null}if(A.indexOf("javascript:")===0||A.indexOf("vbscript:")===0||A.indexOf("data:")===0)return null}R&&!l.test(W)&&(W=n(R,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var S={},T=/^[^:]+:\/*[^/]*$/,_=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(L,R){S[" "+L]||(T.test(L)?S[" "+L]=L+"/":S[" "+L]=z(L,"/",!0)),L=S[" "+L];var W=L.indexOf(":")===-1;return R.substring(0,2)==="//"?W?R:L.replace(_,"$1")+R:R.charAt(0)==="/"?W?R:L.replace(r,"$1")+R:L+R}var u={exec:function(){}};function h(L){for(var R=1,W,A;R<arguments.length;R++){W=arguments[R];for(A in W)Object.prototype.hasOwnProperty.call(W,A)&&(L[A]=W[A])}return L}function m(L,R){var W=L.replace(/\|/g,function(M,B,q){for(var ee=!1,le=B;--le>=0&&q[le]==="\\";)ee=!ee;return ee?"|":" |"}),A=W.split(/ \|/),P=0;if(A[0].trim()||A.shift(),A.length>0&&!A[A.length-1].trim()&&A.pop(),A.length>R)A.splice(R);else for(;A.length<R;)A.push("");for(;P<A.length;P++)A[P]=A[P].trim().replace(/\\\|/g,"|");return A}function z(L,R,W){var A=L.length;if(A===0)return"";for(var P=0;P<A;){var M=L.charAt(A-P-1);if(M===R&&!W)P++;else if(M!==R&&W)P++;else break}return L.slice(0,A-P)}function $(L,R){if(L.indexOf(R[1])===-1)return-1;for(var W=L.length,A=0,P=0;P<W;P++)if(L[P]==="\\")P++;else if(L[P]===R[0])A++;else if(L[P]===R[1]&&(A--,A<0))return P;return-1}function J(L){L&&L.sanitize&&!L.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Q(L,R){if(R<1)return"";for(var W="";R>1;)R&1&&(W+=L),R>>=1,L+=L;return W+L}function ge(L,R,W,A){var P=R.href,M=R.title?e(R.title):null,B=L[1].replace(/\\([\[\]])/g,"$1");if(L[0].charAt(0)!=="!"){A.state.inLink=!0;var q={type:"link",raw:W,href:P,title:M,text:B,tokens:A.inlineTokens(B)};return A.state.inLink=!1,q}return{type:"image",raw:W,href:P,title:M,text:e(B)}}function oe(L,R){var W=L.match(/^(\s+)(?:```)/);if(W===null)return R;var A=W[1];return R.split(`
`).map(function(P){var M=P.match(/^\s+/);if(M===null)return P;var B=M[0];return B.length>=A.length?P.slice(A.length):P}).join(`
`)}var we=function(){function L(W){this.options=W||Z.defaults}var R=L.prototype;return R.space=function(A){var P=this.rules.block.newline.exec(A);if(P&&P[0].length>0)return{type:"space",raw:P[0]}},R.code=function(A){var P=this.rules.block.code.exec(A);if(P){var M=P[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:P[0],codeBlockStyle:"indented",text:this.options.pedantic?M:z(M,`
`)}}},R.fences=function(A){var P=this.rules.block.fences.exec(A);if(P){var M=P[0],B=oe(M,P[3]||"");return{type:"code",raw:M,lang:P[2]?P[2].trim():P[2],text:B}}},R.heading=function(A){var P=this.rules.block.heading.exec(A);if(P){var M=P[2].trim();if(/#$/.test(M)){var B=z(M,"#");(this.options.pedantic||!B||/ $/.test(B))&&(M=B.trim())}return{type:"heading",raw:P[0],depth:P[1].length,text:M,tokens:this.lexer.inline(M)}}},R.hr=function(A){var P=this.rules.block.hr.exec(A);if(P)return{type:"hr",raw:P[0]}},R.blockquote=function(A){var P=this.rules.block.blockquote.exec(A);if(P){var M=P[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:P[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},R.list=function(A){var P=this.rules.block.list.exec(A);if(P){var M,B,q,ee,le,de,ye,Ee,Re,Le,ve,Pe,ke=P[1].trim(),qe=ke.length>1,He={type:"list",raw:"",ordered:qe,start:qe?+ke.slice(0,-1):"",loose:!1,items:[]};ke=qe?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=qe?ke:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");A&&(Pe=!1,!(!(P=Ue.exec(A))||this.rules.block.hr.test(A)));){if(M=P[0],A=A.substring(M.length),Ee=P[2].split(`
`,1)[0],Re=A.split(`
`,1)[0],this.options.pedantic?(ee=2,ve=Ee.trimLeft()):(ee=P[2].search(/[^ ]/),ee=ee>4?1:ee,ve=Ee.slice(ee),ee+=P[1].length),de=!1,!Ee&&/^ *$/.test(Re)&&(M+=Re+`
`,A=A.substring(Re.length+1),Pe=!0),!Pe)for(var Ye=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:```|~~~)"),xe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}#");A&&(Le=A.split(`
`,1)[0],Ee=Le,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(Ee)||xe.test(Ee)||Ye.test(Ee)||it.test(A)));){if(Ee.search(/[^ ]/)>=ee||!Ee.trim())ve+=`
`+Ee.slice(ee);else if(!de)ve+=`
`+Ee;else break;!de&&!Ee.trim()&&(de=!0),M+=Le+`
`,A=A.substring(Le.length+1)}He.loose||(ye?He.loose=!0:/\n *\n *$/.test(M)&&(ye=!0)),this.options.gfm&&(B=/^\[[ xX]\] /.exec(ve),B&&(q=B[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:M,task:!!B,checked:q,loose:!1,text:ve}),He.raw+=M}He.items[He.items.length-1].raw=M.trimRight(),He.items[He.items.length-1].text=ve.trimRight(),He.raw=He.raw.trimRight();var x=He.items.length;for(le=0;le<x;le++){this.lexer.state.top=!1,He.items[le].tokens=this.lexer.blockTokens(He.items[le].text,[]);var ae=He.items[le].tokens.filter(function(Ce){return Ce.type==="space"}),be=ae.every(function(Ce){for(var Ae=Ce.raw.split(""),Me=0,$e=O(Ae),Ge;!(Ge=$e()).done;){var et=Ge.value;if(et===`
`&&(Me+=1),Me>1)return!0}return!1});!He.loose&&ae.length&&be&&(He.loose=!0,He.items[le].loose=!0)}return He}},R.html=function(A){var P=this.rules.block.html.exec(A);if(P){var M={type:"html",raw:P[0],pre:!this.options.sanitizer&&(P[1]==="pre"||P[1]==="script"||P[1]==="style"),text:P[0]};if(this.options.sanitize){var B=this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]);M.type="paragraph",M.text=B,M.tokens=this.lexer.inline(B)}return M}},R.def=function(A){var P=this.rules.block.def.exec(A);if(P){P[3]&&(P[3]=P[3].substring(1,P[3].length-1));var M=P[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:P[0],href:P[2],title:P[3]}}},R.table=function(A){var P=this.rules.block.table.exec(A);if(P){var M={type:"table",header:m(P[1]).map(function(ye){return{text:ye}}),align:P[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:P[3]&&P[3].trim()?P[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=P[0];var B=M.align.length,q,ee,le,de;for(q=0;q<B;q++)/^ *-+: *$/.test(M.align[q])?M.align[q]="right":/^ *:-+: *$/.test(M.align[q])?M.align[q]="center":/^ *:-+ *$/.test(M.align[q])?M.align[q]="left":M.align[q]=null;for(B=M.rows.length,q=0;q<B;q++)M.rows[q]=m(M.rows[q],M.header.length).map(function(ye){return{text:ye}});for(B=M.header.length,ee=0;ee<B;ee++)M.header[ee].tokens=this.lexer.inline(M.header[ee].text);for(B=M.rows.length,ee=0;ee<B;ee++)for(de=M.rows[ee],le=0;le<de.length;le++)de[le].tokens=this.lexer.inline(de[le].text);return M}}},R.lheading=function(A){var P=this.rules.block.lheading.exec(A);if(P)return{type:"heading",raw:P[0],depth:P[2].charAt(0)==="="?1:2,text:P[1],tokens:this.lexer.inline(P[1])}},R.paragraph=function(A){var P=this.rules.block.paragraph.exec(A);if(P){var M=P[1].charAt(P[1].length-1)===`
`?P[1].slice(0,-1):P[1];return{type:"paragraph",raw:P[0],text:M,tokens:this.lexer.inline(M)}}},R.text=function(A){var P=this.rules.block.text.exec(A);if(P)return{type:"text",raw:P[0],text:P[0],tokens:this.lexer.inline(P[0])}},R.escape=function(A){var P=this.rules.inline.escape.exec(A);if(P)return{type:"escape",raw:P[0],text:e(P[1])}},R.tag=function(A){var P=this.rules.inline.tag.exec(A);if(P)return!this.lexer.state.inLink&&/^<a /i.test(P[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(P[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(P[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(P[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:P[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]}},R.link=function(A){var P=this.rules.inline.link.exec(A);if(P){var M=P[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var B=z(M.slice(0,-1),"\\");if((M.length-B.length)%2===0)return}else{var q=$(P[2],"()");if(q>-1){var ee=P[0].indexOf("!")===0?5:4,le=ee+P[1].length+q;P[2]=P[2].substring(0,q),P[0]=P[0].substring(0,le).trim(),P[3]=""}}var de=P[2],ye="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Ee&&(de=Ee[1],ye=Ee[3])}else ye=P[3]?P[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(M)?de=de.slice(1):de=de.slice(1,-1)),ge(P,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:ye&&ye.replace(this.rules.inline._escapes,"$1")},P[0],this.lexer)}},R.reflink=function(A,P){var M;if((M=this.rules.inline.reflink.exec(A))||(M=this.rules.inline.nolink.exec(A))){var B=(M[2]||M[1]).replace(/\s+/g," ");if(B=P[B.toLowerCase()],!B||!B.href){var q=M[0].charAt(0);return{type:"text",raw:q,text:q}}return ge(M,B,M[0],this.lexer)}},R.emStrong=function(A,P,M){M===void 0&&(M="");var B=this.rules.inline.emStrong.lDelim.exec(A);if(!!B&&!(B[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=B[1]||B[2]||"";if(!q||q&&(M===""||this.rules.inline.punctuation.exec(M))){var ee=B[0].length-1,le,de,ye=ee,Ee=0,Re=B[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Re.lastIndex=0,P=P.slice(-1*A.length+ee);(B=Re.exec(P))!=null;)if(le=B[1]||B[2]||B[3]||B[4]||B[5]||B[6],!!le){if(de=le.length,B[3]||B[4]){ye+=de;continue}else if((B[5]||B[6])&&ee%3&&!((ee+de)%3)){Ee+=de;continue}if(ye-=de,!(ye>0)){if(de=Math.min(de,de+ye+Ee),Math.min(ee,de)%2){var Le=A.slice(1,ee+B.index+de);return{type:"em",raw:A.slice(0,ee+B.index+de+1),text:Le,tokens:this.lexer.inlineTokens(Le)}}var ve=A.slice(2,ee+B.index+de-1);return{type:"strong",raw:A.slice(0,ee+B.index+de+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},R.codespan=function(A){var P=this.rules.inline.code.exec(A);if(P){var M=P[2].replace(/\n/g," "),B=/[^ ]/.test(M),q=/^ /.test(M)&&/ $/.test(M);return B&&q&&(M=M.substring(1,M.length-1)),M=e(M,!0),{type:"codespan",raw:P[0],text:M}}},R.br=function(A){var P=this.rules.inline.br.exec(A);if(P)return{type:"br",raw:P[0]}},R.del=function(A){var P=this.rules.inline.del.exec(A);if(P)return{type:"del",raw:P[0],text:P[2],tokens:this.lexer.inlineTokens(P[2])}},R.autolink=function(A,P){var M=this.rules.inline.autolink.exec(A);if(M){var B,q;return M[2]==="@"?(B=e(this.options.mangle?P(M[1]):M[1]),q="mailto:"+B):(B=e(M[1]),q=B),{type:"link",raw:M[0],text:B,href:q,tokens:[{type:"text",raw:B,text:B}]}}},R.url=function(A,P){var M;if(M=this.rules.inline.url.exec(A)){var B,q;if(M[2]==="@")B=e(this.options.mangle?P(M[0]):M[0]),q="mailto:"+B;else{var ee;do ee=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(ee!==M[0]);B=e(M[0]),M[1]==="www."?q="http://"+B:q=B}return{type:"link",raw:M[0],text:B,href:q,tokens:[{type:"text",raw:B,text:B}]}}},R.inlineText=function(A,P){var M=this.rules.inline.text.exec(A);if(M){var B;return this.lexer.state.inRawBlock?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]:B=e(this.options.smartypants?P(M[0]):M[0]),{type:"text",raw:M[0],text:B}}},L}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=E(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=E(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=E(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=E(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=E(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=E(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=h({},he),he.gfm=h({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=E(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=E(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=h({},he.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:E(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=E(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=E(he._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=E(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=E(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=E(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=E(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=E(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=E(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=E(se.reflink).replace("label",se._label).replace("ref",he._label).getRegex(),se.nolink=E(se.nolink).replace("ref",he._label).getRegex(),se.reflinkSearch=E(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=h({},se),se.pedantic=h({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=h({},se.normal,{escape:E(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=E(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=h({},se.gfm,{br:E(se.br).replace("{2,}","*").getRegex(),text:E(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _e(L){return L.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(L){var R="",W,A,P=L.length;for(W=0;W<P;W++)A=L.charCodeAt(W),Math.random()>.5&&(A="x"+A.toString(16)),R+="&#"+A+";";return R}var De=function(){function L(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||Z.defaults,this.options.tokenizer=this.options.tokenizer||new we,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var A={block:he.normal,inline:se.normal};this.options.pedantic?(A.block=he.pedantic,A.inline=se.pedantic):this.options.gfm&&(A.block=he.gfm,this.options.breaks?A.inline=se.breaks:A.inline=se.gfm),this.tokenizer.rules=A}L.lex=function(A,P){var M=new L(P);return M.lex(A)},L.lexInline=function(A,P){var M=new L(P);return M.inlineTokens(A)};var R=L.prototype;return R.lex=function(A){A=A.replace(/\r\n|\r/g,`
`),this.blockTokens(A,this.tokens);for(var P;P=this.inlineQueue.shift();)this.inlineTokens(P.src,P.tokens);return this.tokens},R.blockTokens=function(A,P){var M=this;P===void 0&&(P=[]),this.options.pedantic?A=A.replace(/\t/g,"    ").replace(/^ +$/gm,""):A=A.replace(/^( *)(\t+)/gm,function(ye,Ee,Re){return Ee+"    ".repeat(Re.length)});for(var B,q,ee,le;A;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ye){return(B=ye.call({lexer:M},A,P))?(A=A.substring(B.raw.length),P.push(B),!0):!1}))){if(B=this.tokenizer.space(A)){A=A.substring(B.raw.length),B.raw.length===1&&P.length>0?P[P.length-1].raw+=`
`:P.push(B);continue}if(B=this.tokenizer.code(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+B.raw,q.text+=`
`+B.text,this.inlineQueue[this.inlineQueue.length-1].src=q.text):P.push(B);continue}if(B=this.tokenizer.fences(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.heading(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.hr(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.blockquote(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.list(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.html(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.def(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+B.raw,q.text+=`
`+B.raw,this.inlineQueue[this.inlineQueue.length-1].src=q.text):this.tokens.links[B.tag]||(this.tokens.links[B.tag]={href:B.href,title:B.title});continue}if(B=this.tokenizer.table(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.lheading(A)){A=A.substring(B.raw.length),P.push(B);continue}if(ee=A,this.options.extensions&&this.options.extensions.startBlock&&function(){var ye=1/0,Ee=A.slice(1),Re=void 0;M.options.extensions.startBlock.forEach(function(Le){Re=Le.call({lexer:this},Ee),typeof Re=="number"&&Re>=0&&(ye=Math.min(ye,Re))}),ye<1/0&&ye>=0&&(ee=A.substring(0,ye+1))}(),this.state.top&&(B=this.tokenizer.paragraph(ee))){q=P[P.length-1],le&&q.type==="paragraph"?(q.raw+=`
`+B.raw,q.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):P.push(B),le=ee.length!==A.length,A=A.substring(B.raw.length);continue}if(B=this.tokenizer.text(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&q.type==="text"?(q.raw+=`
`+B.raw,q.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):P.push(B);continue}if(A){var de="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,P},R.inline=function(A,P){return P===void 0&&(P=[]),this.inlineQueue.push({src:A,tokens:P}),P},R.inlineTokens=function(A,P){var M=this;P===void 0&&(P=[]);var B,q,ee,le=A,de,ye,Ee;if(this.tokens.links){var Re=Object.keys(this.tokens.links);if(Re.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(le))!=null;)Re.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(le=le.slice(0,de.index)+"["+Q("a",de[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(le))!=null;)le=le.slice(0,de.index)+"["+Q("a",de[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(le))!=null;)le=le.slice(0,de.index)+"++"+le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;A;)if(ye||(Ee=""),ye=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(B=ve.call({lexer:M},A,P))?(A=A.substring(B.raw.length),P.push(B),!0):!1}))){if(B=this.tokenizer.escape(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.tag(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&B.type==="text"&&q.type==="text"?(q.raw+=B.raw,q.text+=B.text):P.push(B);continue}if(B=this.tokenizer.link(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.reflink(A,this.tokens.links)){A=A.substring(B.raw.length),q=P[P.length-1],q&&B.type==="text"&&q.type==="text"?(q.raw+=B.raw,q.text+=B.text):P.push(B);continue}if(B=this.tokenizer.emStrong(A,le,Ee)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.codespan(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.br(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.del(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.autolink(A,te)){A=A.substring(B.raw.length),P.push(B);continue}if(!this.state.inLink&&(B=this.tokenizer.url(A,te))){A=A.substring(B.raw.length),P.push(B);continue}if(ee=A,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=A.slice(1),ke=void 0;M.options.extensions.startInline.forEach(function(qe){ke=qe.call({lexer:this},Pe),typeof ke=="number"&&ke>=0&&(ve=Math.min(ve,ke))}),ve<1/0&&ve>=0&&(ee=A.substring(0,ve+1))}(),B=this.tokenizer.inlineText(ee,_e)){A=A.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(Ee=B.raw.slice(-1)),ye=!0,q=P[P.length-1],q&&q.type==="text"?(q.raw+=B.raw,q.text+=B.text):P.push(B);continue}if(A){var Le="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return P},y(L,null,[{key:"rules",get:function(){return{block:he,inline:se}}}]),L}(),re=function(){function L(W){this.options=W||Z.defaults}var R=L.prototype;return R.code=function(A,P,M){var B=(P||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(A,B);q!=null&&q!==A&&(M=!0,A=q)}return A=A.replace(/\n$/,"")+`
`,B?'<pre><code class="'+this.options.langPrefix+e(B,!0)+'">'+(M?A:e(A,!0))+`</code></pre>
`:"<pre><code>"+(M?A:e(A,!0))+`</code></pre>
`},R.blockquote=function(A){return`<blockquote>
`+A+`</blockquote>
`},R.html=function(A){return A},R.heading=function(A,P,M,B){if(this.options.headerIds){var q=this.options.headerPrefix+B.slug(M);return"<h"+P+' id="'+q+'">'+A+"</h"+P+`>
`}return"<h"+P+">"+A+"</h"+P+`>
`},R.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},R.list=function(A,P,M){var B=P?"ol":"ul",q=P&&M!==1?' start="'+M+'"':"";return"<"+B+q+`>
`+A+"</"+B+`>
`},R.listitem=function(A){return"<li>"+A+`</li>
`},R.checkbox=function(A){return"<input "+(A?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},R.paragraph=function(A){return"<p>"+A+`</p>
`},R.table=function(A,P){return P&&(P="<tbody>"+P+"</tbody>"),`<table>
<thead>
`+A+`</thead>
`+P+`</table>
`},R.tablerow=function(A){return`<tr>
`+A+`</tr>
`},R.tablecell=function(A,P){var M=P.header?"th":"td",B=P.align?"<"+M+' align="'+P.align+'">':"<"+M+">";return B+A+("</"+M+`>
`)},R.strong=function(A){return"<strong>"+A+"</strong>"},R.em=function(A){return"<em>"+A+"</em>"},R.codespan=function(A){return"<code>"+A+"</code>"},R.br=function(){return this.options.xhtml?"<br/>":"<br>"},R.del=function(A){return"<del>"+A+"</del>"},R.link=function(A,P,M){if(A=p(this.options.sanitize,this.options.baseUrl,A),A===null)return M;var B='<a href="'+e(A)+'"';return P&&(B+=' title="'+P+'"'),B+=">"+M+"</a>",B},R.image=function(A,P,M){if(A=p(this.options.sanitize,this.options.baseUrl,A),A===null)return M;var B='<img src="'+A+'" alt="'+M+'"';return P&&(B+=' title="'+P+'"'),B+=this.options.xhtml?"/>":">",B},R.text=function(A){return A},L}(),ie=function(){function L(){}var R=L.prototype;return R.strong=function(A){return A},R.em=function(A){return A},R.codespan=function(A){return A},R.del=function(A){return A},R.html=function(A){return A},R.text=function(A){return A},R.link=function(A,P,M){return""+M},R.image=function(A,P,M){return""+M},R.br=function(){return""},L}(),ce=function(){function L(){this.seen={}}var R=L.prototype;return R.serialize=function(A){return A.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},R.getNextSafeSlug=function(A,P){var M=A,B=0;if(this.seen.hasOwnProperty(M)){B=this.seen[A];do B++,M=A+"-"+B;while(this.seen.hasOwnProperty(M))}return P||(this.seen[A]=B,this.seen[M]=0),M},R.slug=function(A,P){P===void 0&&(P={});var M=this.serialize(A);return this.getNextSafeSlug(M,P.dryrun)},L}(),ne=function(){function L(W){this.options=W||Z.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ce}L.parse=function(A,P){var M=new L(P);return M.parse(A)},L.parseInline=function(A,P){var M=new L(P);return M.parseInline(A)};var R=L.prototype;return R.parse=function(A,P){P===void 0&&(P=!0);var M="",B,q,ee,le,de,ye,Ee,Re,Le,ve,Pe,ke,qe,He,Ue,Ye,it,Oe,xe,x=A.length;for(B=0;B<x;B++){if(ve=A[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(xe=this.options.extensions.renderers[ve.type].call({parser:this},ve),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){M+=xe||"";continue}switch(ve.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,D(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Re="",Ee="",le=ve.header.length,q=0;q<le;q++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[q].tokens),{header:!0,align:ve.align[q]});for(Re+=this.renderer.tablerow(Ee),Le="",le=ve.rows.length,q=0;q<le;q++){for(ye=ve.rows[q],Ee="",de=ye.length,ee=0;ee<de;ee++)Ee+=this.renderer.tablecell(this.parseInline(ye[ee].tokens),{header:!1,align:ve.align[ee]});Le+=this.renderer.tablerow(Ee)}M+=this.renderer.table(Re,Le);continue}case"blockquote":{Le=this.parse(ve.tokens),M+=this.renderer.blockquote(Le);continue}case"list":{for(Pe=ve.ordered,ke=ve.start,qe=ve.loose,le=ve.items.length,Le="",q=0;q<le;q++)Ue=ve.items[q],Ye=Ue.checked,it=Ue.task,He="",Ue.task&&(Oe=this.renderer.checkbox(Ye),qe?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Oe+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Oe+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(Ue.tokens,qe),Le+=this.renderer.listitem(He,it,Ye);M+=this.renderer.list(Le,Pe,ke);continue}case"html":{M+=this.renderer.html(ve.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Le=ve.tokens?this.parseInline(ve.tokens):ve.text;B+1<x&&A[B+1].type==="text";)ve=A[++B],Le+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);M+=P?this.renderer.paragraph(Le):Le;continue}default:{var ae='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}}return M},R.parseInline=function(A,P){P=P||this.renderer;var M="",B,q,ee,le=A.length;for(B=0;B<le;B++){if(q=A[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(ee=this.options.extensions.renderers[q.type].call({parser:this},q),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(q.type))){M+=ee||"";continue}switch(q.type){case"escape":{M+=P.text(q.text);break}case"html":{M+=P.html(q.text);break}case"link":{M+=P.link(q.href,q.title,this.parseInline(q.tokens,P));break}case"image":{M+=P.image(q.href,q.title,q.text);break}case"strong":{M+=P.strong(this.parseInline(q.tokens,P));break}case"em":{M+=P.em(this.parseInline(q.tokens,P));break}case"codespan":{M+=P.codespan(q.text);break}case"br":{M+=P.br();break}case"del":{M+=P.del(this.parseInline(q.tokens,P));break}case"text":{M+=P.text(q.text);break}default:{var de='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return M},L}();function F(L,R,W){if(typeof L>"u"||L===null)throw new Error("marked(): input parameter is undefined or null");if(typeof L!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(L)+", string expected");if(typeof R=="function"&&(W=R,R=null),R=h({},F.defaults,R||{}),J(R),W){var A=R.highlight,P;try{P=De.lex(L,R)}catch(le){return W(le)}var M=function(de){var ye;if(!de)try{R.walkTokens&&F.walkTokens(P,R.walkTokens),ye=ne.parse(P,R)}catch(Ee){de=Ee}return R.highlight=A,de?W(de):W(null,ye)};if(!A||A.length<3||(delete R.highlight,!P.length))return M();var B=0;F.walkTokens(P,function(le){le.type==="code"&&(B++,setTimeout(function(){A(le.text,le.lang,function(de,ye){if(de)return M(de);ye!=null&&ye!==le.text&&(le.text=ye,le.escaped=!0),B--,B===0&&M()})},0))}),B===0&&M();return}function q(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(le.message+"",!0)+"</pre>";throw le}try{var ee=De.lex(L,R);if(R.walkTokens){if(R.async)return Promise.all(F.walkTokens(ee,R.walkTokens)).then(function(){return ne.parse(ee,R)}).catch(q);F.walkTokens(ee,R.walkTokens)}return ne.parse(ee,R)}catch(le){q(le)}}F.options=F.setOptions=function(L){return h(F.defaults,L),w(F.defaults),F},F.getDefaults=C,F.defaults=Z.defaults,F.use=function(){for(var L=arguments.length,R=new Array(L),W=0;W<L;W++)R[W]=arguments[W];var A=h.apply(void 0,[{}].concat(R)),P=F.defaults.extensions||{renderers:{},childTokens:{}},M;R.forEach(function(B){if(B.extensions&&(M=!0,B.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var le=P.renderers?P.renderers[ee.name]:null;le?P.renderers[ee.name]=function(){for(var de=arguments.length,ye=new Array(de),Ee=0;Ee<de;Ee++)ye[Ee]=arguments[Ee];var Re=ee.renderer.apply(this,ye);return Re===!1&&(Re=le.apply(this,ye)),Re}:P.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");P[ee.level]?P[ee.level].unshift(ee.tokenizer):P[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?P.startBlock?P.startBlock.push(ee.start):P.startBlock=[ee.start]:ee.level==="inline"&&(P.startInline?P.startInline.push(ee.start):P.startInline=[ee.start]))}ee.childTokens&&(P.childTokens[ee.name]=ee.childTokens)})),B.renderer&&function(){var ee=F.defaults.renderer||new re,le=function(Ee){var Re=ee[Ee];ee[Ee]=function(){for(var Le=arguments.length,ve=new Array(Le),Pe=0;Pe<Le;Pe++)ve[Pe]=arguments[Pe];var ke=B.renderer[Ee].apply(ee,ve);return ke===!1&&(ke=Re.apply(ee,ve)),ke}};for(var de in B.renderer)le(de);A.renderer=ee}(),B.tokenizer&&function(){var ee=F.defaults.tokenizer||new we,le=function(Ee){var Re=ee[Ee];ee[Ee]=function(){for(var Le=arguments.length,ve=new Array(Le),Pe=0;Pe<Le;Pe++)ve[Pe]=arguments[Pe];var ke=B.tokenizer[Ee].apply(ee,ve);return ke===!1&&(ke=Re.apply(ee,ve)),ke}};for(var de in B.tokenizer)le(de);A.tokenizer=ee}(),B.walkTokens){var q=F.defaults.walkTokens;A.walkTokens=function(ee){var le=[];return le.push(B.walkTokens.call(this,ee)),q&&(le=le.concat(q.call(this,ee))),le}}M&&(A.extensions=P),F.setOptions(A)})},F.walkTokens=function(L,R){for(var W=[],A=function(){var q=M.value;switch(W=W.concat(R.call(F,q)),q.type){case"table":{for(var ee=O(q.header),le;!(le=ee()).done;){var de=le.value;W=W.concat(F.walkTokens(de.tokens,R))}for(var ye=O(q.rows),Ee;!(Ee=ye()).done;)for(var Re=Ee.value,Le=O(Re),ve;!(ve=Le()).done;){var Pe=ve.value;W=W.concat(F.walkTokens(Pe.tokens,R))}break}case"list":{W=W.concat(F.walkTokens(q.items,R));break}default:F.defaults.extensions&&F.defaults.extensions.childTokens&&F.defaults.extensions.childTokens[q.type]?F.defaults.extensions.childTokens[q.type].forEach(function(ke){W=W.concat(F.walkTokens(q[ke],R))}):q.tokens&&(W=W.concat(F.walkTokens(q.tokens,R)))}},P=O(L),M;!(M=P()).done;)A();return W},F.parseInline=function(L,R){if(typeof L>"u"||L===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof L!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(L)+", string expected");R=h({},F.defaults,R||{}),J(R);try{var W=De.lexInline(L,R);return R.walkTokens&&F.walkTokens(W,R.walkTokens),ne.parseInline(W,R)}catch(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(A.message+"",!0)+"</pre>";throw A}},F.Parser=ne,F.parser=ne.parse,F.Renderer=re,F.TextRenderer=ie,F.Lexer=De,F.lexer=De.lex,F.Tokenizer=we,F.Slugger=ce,F.parse=F;var V=F.options,j=F.setOptions,k=F.use,c=F.walkTokens,I=F.parseInline,U=F,K=ne.parse,X=De.lex;Z.Lexer=De,Z.Parser=ne,Z.Renderer=re,Z.Slugger=ce,Z.TextRenderer=ie,Z.Tokenizer=we,Z.getDefaults=C,Z.lexer=X,Z.marked=F,Z.options=V,Z.parse=U,Z.parseInline=I,Z.parser=K,Z.setOptions=j,Z.use=k,Z.walkTokens=c,Object.defineProperty(Z,"__esModule",{value:!0})}),define(me[76],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class y{constructor(H,O=0,C=H.length,w=O-1){this.items=H,this.start=O,this.end=C,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=y}),define(me[77],pe([1,0,76]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(C=[],w=10){this._initialize(C),this._limit=w,this._onChange()}getHistory(){return this._elements}add(C){this._history.delete(C),this._history.add(C),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(C){return this._history.has(C)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const C=this._elements;this._navigator=new y.ArrayNavigator(C,0,C.length,C.length)}_reduceToLimit(){const C=this._elements;C.length>this._limit&&this._initialize(C.slice(C.length-this._limit))}_currentPosition(){const C=this._navigator.current();return C?this._elements.indexOf(C):-1}_initialize(C){this._history=new Set;for(const w of C)this._history.add(w)}get _elements(){const C=[];return this._history.forEach(w=>C.push(w)),C}}t.HistoryNavigator=i;class H{constructor(C,w=10){if(this.capacity=w,C.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:C[0],previous:void 0,next:void 0};for(let g=1;g<C.length;g++)this.add(C[g])}add(C){const w={value:C,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(C){const w=this.tail.value;return this.tail.value=C,w}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(C){let w=this.head;for(;w;){if(w.value===C)return!0;w=w.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let C=this.head;for(;C;)yield C.value,C=C.next}}t.HistoryNavigator2=H}),define(me[45],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function y(w,g,d){return Math.min(Math.max(w,g),d)}t.clamp=y;function i(w,g){return(g+w%g)%g}t.rot=i;class H{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=H;class O{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=O;class C{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const d=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=d,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=C}),define(me[46],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(i){function H(g,d){if(g.start>=d.end||d.start>=g.end)return{start:0,end:0};const f=Math.max(g.start,d.start),N=Math.min(g.end,d.end);return N-f<=0?{start:0,end:0}:{start:f,end:N}}i.intersect=H;function O(g){return g.end-g.start<=0}i.isEmpty=O;function C(g,d){return!O(H(g,d))}i.intersects=C;function w(g,d){const f=[],N={start:g.start,end:Math.min(d.start,g.end)},o={start:Math.max(d.end,g.start),end:g.end};return O(N)||f.push(N),O(o)||f.push(o),f}i.relativeComplement=w})(y=t.Range||(t.Range={}))}),define(me[78],pe([1,0,46]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(g,d){const f=[];for(const N of d){if(g.start>=N.range.end)continue;if(g.end<N.range.start)break;const o=y.Range.intersect(g,N.range);y.Range.isEmpty(o)||f.push({range:o,size:N.size})}return f}t.groupIntersect=i;function H({start:g,end:d},f){return{start:g+f,end:d+f}}t.shift=H;function O(g){const d=[];let f=null;for(const N of g){const o=N.range.start,s=N.range.end,e=N.size;if(f&&e===f.size){f.range.end=s;continue}f={range:{start:o,end:s},size:e},d.push(f)}return d}t.consolidate=O;function C(...g){return O(g.reduce((d,f)=>d.concat(f),[]))}class w{constructor(){this.groups=[],this._size=0}splice(d,f,N=[]){const o=N.length-f,s=i({start:0,end:d},this.groups),e=i({start:d+f,end:Number.POSITIVE_INFINITY},this.groups).map(D=>({range:H(D.range,o),size:D.size})),b=N.map((D,v)=>({range:{start:d+v,end:d+v+1},size:D.size}));this.groups=C(s,b,e),this._size=this.groups.reduce((D,v)=>D+v.size*(v.range.end-v.range.start),0)}get count(){const d=this.groups.length;return d?this.groups[d-1].range.end:0}get size(){return this._size}indexAt(d){if(d<0)return-1;let f=0,N=0;for(const o of this.groups){const s=o.range.end-o.range.start,e=N+s*o.size;if(d<e)return f+Math.floor((d-N)/o.size);f+=s,N=e}return f}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let f=0,N=0;for(const o of this.groups){const s=o.range.end-o.range.start,e=N+s;if(d<e)return f+(d-N)*o.size;f+=s*o.size,N=e}return-1}}t.RangeMap=w}),define(me[79],pe([1,0,13,2]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function H(l){const p=l;return p?typeof p.read=="function":!1}t.isReadable=H;function O(l){const p=l;return p?[p.on,p.pause,p.resume,p.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=O;function C(l){const p=l;return p?O(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}t.isReadableBufferedStream=C;function w(l,p){return new g(l,p)}t.newWriteableStream=w;class g{constructor(p,S){this.reducer=p,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(S=>S(p))}emitError(p){this.listeners.error.length===0?(0,y.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(S=>S(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,S){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(p,S){if(this.state.destroyed)return;let T;switch(p){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const _=T.indexOf(S);_>=0&&T.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(l,p){const S=[];let T;for(;(T=l.read())!==null;)S.push(T);return p(S)}t.consumeReadable=d;function f(l,p,S){const T=[];let _;for(;(_=l.read())!==null&&T.length<S;)T.push(_);return _===null&&T.length>0?p(T):{read:()=>{if(T.length>0)return T.shift();if(typeof _<"u"){const r=_;return _=void 0,r}return l.read()}}}t.peekReadable=f;function N(l,p){return new Promise((S,T)=>{const _=[];o(l,{onData:r=>{p&&_.push(r)},onError:r=>{p?T(r):S(void 0)},onEnd:()=>{S(p?p(_):void 0)}})})}t.consumeStream=N;function o(l,p){let S=!1;return l.on("error",T=>{S||p.onError(T)}),l.on("end",()=>{S||p.onEnd()}),l.on("data",T=>{S||p.onData(T)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=o;function s(l,p){return new Promise((S,T)=>{const _=new i.DisposableStore,r=[],n=m=>{if(r.push(m),r.length>p)return _.dispose(),l.pause(),S({stream:l,buffer:r,ended:!1})},u=m=>T(m),h=()=>S({stream:l,buffer:r,ended:!0});_.add((0,i.toDisposable)(()=>l.removeListener("error",u))),l.on("error",u),_.add((0,i.toDisposable)(()=>l.removeListener("end",h))),l.on("end",h),_.add((0,i.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}t.peekStream=s;function e(l,p){const S=w(p);return S.end(l),S}t.toStream=e;function b(){const l=w(()=>{throw new Error("not supported")});return l.end(),l}t.emptyStream=b;function D(l){let p=!1;return{read:()=>p?null:(p=!0,l)}}t.toReadable=D;function v(l,p,S){const T=w(S);return o(l,{onData:_=>T.write(p.data(_)),onError:_=>T.error(p.error?p.error(_):_),onEnd:()=>T.end()}),T}t.transform=v;function E(l,p,S){let T=!1;return{read:()=>{const _=p.read();return T?_:(T=!0,_!==null?S([l,_]):l)}}}t.prefixedReadable=E;function a(l,p,S){let T=!1;const _=w(S);return o(p,{onData:r=>T?_.write(r):(T=!0,_.write(S([l,r]))),onError:r=>_.error(r),onEnd:()=>{T||(T=!0,_.write(l)),_.end()}}),_}t.prefixedStream=a}),define(me[31],pe([1,0,79]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let H,O;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return i?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return i&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,z){return!(z?.dontUseNodeBuffer||!1)&&i?new C(Buffer.from(m)):(H||(H=new TextEncoder),new C(H.encode(m)))}static fromByteArray(m){const z=C.alloc(m.length);for(let $=0,J=m.length;$<J;$++)z.buffer[$]=m[$];return z}static concat(m,z){if(typeof z>"u"){z=0;for(let Q=0,ge=m.length;Q<ge;Q++)z+=m[Q].byteLength}const $=C.alloc(z);let J=0;for(let Q=0,ge=m.length;Q<ge;Q++){const oe=m[Q];$.set(oe,J),J+=oe.byteLength}return $}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return i?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(m,z){return new C(this.buffer.subarray(m,z))}set(m,z){if(m instanceof C)this.buffer.set(m.buffer,z);else if(m instanceof Uint8Array)this.buffer.set(m,z);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),z);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,z){f(this.buffer,m,z)}readUInt32LE(m){return N(this.buffer,m)}writeUInt32LE(m,z){o(this.buffer,m,z)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,z){e(this.buffer,m,z)}}t.VSBuffer=C;function w(h,m){return h[m+0]<<0>>>0|h[m+1]<<8>>>0}t.readUInt16LE=w;function g(h,m,z){h[z+0]=m&255,m=m>>>8,h[z+1]=m&255}t.writeUInt16LE=g;function d(h,m){return h[m]*2**24+h[m+1]*2**16+h[m+2]*2**8+h[m+3]}t.readUInt32BE=d;function f(h,m,z){h[z+3]=m,m=m>>>8,h[z+2]=m,m=m>>>8,h[z+1]=m,m=m>>>8,h[z]=m}t.writeUInt32BE=f;function N(h,m){return h[m+0]<<0>>>0|h[m+1]<<8>>>0|h[m+2]<<16>>>0|h[m+3]<<24>>>0}t.readUInt32LE=N;function o(h,m,z){h[z+0]=m&255,m=m>>>8,h[z+1]=m&255,m=m>>>8,h[z+2]=m&255,m=m>>>8,h[z+3]=m&255}t.writeUInt32LE=o;function s(h,m){return h[m]}t.readUInt8=s;function e(h,m,z){h[z]=m}t.writeUInt8=e;function b(h){return y.consumeReadable(h,m=>C.concat(m))}t.readableToBuffer=b;function D(h){return y.toReadable(h)}t.bufferToReadable=D;function v(h){return y.consumeStream(h,m=>C.concat(m))}t.streamToBuffer=v;async function E(h){return h.ended?C.concat(h.buffer):C.concat([...h.buffer,await v(h.stream)])}t.bufferedStreamToBuffer=E;function a(h){return y.toStream(h,m=>C.concat(m))}t.bufferToStream=a;function l(h){return y.transform(h,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}t.streamToBufferReadableStream=l;function p(h){return y.newWriteableStream(m=>C.concat(m),h)}t.newWriteableBufferStream=p;function S(h,m){return y.prefixedReadable(h,m,z=>C.concat(z))}t.prefixedBufferReadable=S;function T(h,m){return y.prefixedStream(h,m,z=>C.concat(z))}t.prefixedBufferStream=T;function _(h){let m=0,z=0,$=0;const J=new Uint8Array(Math.floor(h.length/4*3)),Q=oe=>{switch(z){case 3:J[$++]=m|oe,z=0;break;case 2:J[$++]=m|oe>>>2,m=oe<<6,z=3;break;case 1:J[$++]=m|oe>>>4,m=oe<<4,z=2;break;default:m=oe<<2,z=1}};for(let oe=0;oe<h.length;oe++){const we=h.charCodeAt(oe);if(we>=65&&we<=90)Q(we-65);else if(we>=97&&we<=122)Q(we-97+26);else if(we>=48&&we<=57)Q(we-48+52);else if(we===43||we===45)Q(62);else if(we===47||we===95)Q(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${h[oe]}`)}}const ge=$;for(;z>0;)Q(0);return C.wrap(J).slice(0,ge)}t.decodeBase64=_;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:h},m=!0,z=!1){const $=z?n:r;let J="";const Q=h.byteLength%3;let ge=0;for(;ge<h.byteLength-Q;ge+=3){const oe=h[ge+0],we=h[ge+1],he=h[ge+2];J+=$[oe>>>2],J+=$[(oe<<4|we>>>4)&63],J+=$[(we<<2|he>>>6)&63],J+=$[he&63]}if(Q===1){const oe=h[ge+0];J+=$[oe>>>2],J+=$[oe<<4&63],m&&(J+="==")}else if(Q===2){const oe=h[ge+0],we=h[ge+1];J+=$[oe>>>2],J+=$[(oe<<4|we>>>4)&63],J+=$[we<<2&63],m&&(J+="=")}return J}t.encodeBase64=u}),define(me[6],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function y(T){return typeof T=="string"}t.isString=y;function i(T){return Array.isArray(T)&&T.every(_=>y(_))}t.isStringArray=i;function H(T){return typeof T=="object"&&T!==null&&!Array.isArray(T)&&!(T instanceof RegExp)&&!(T instanceof Date)}t.isObject=H;function O(T){const _=Object.getPrototypeOf(Uint8Array);return typeof T=="object"&&T instanceof _}t.isTypedArray=O;function C(T){return typeof T=="number"&&!isNaN(T)}t.isNumber=C;function w(T){return!!T&&typeof T[Symbol.iterator]=="function"}t.isIterable=w;function g(T){return T===!0||T===!1}t.isBoolean=g;function d(T){return typeof T>"u"}t.isUndefined=d;function f(T){return!N(T)}t.isDefined=f;function N(T){return d(T)||T===null}t.isUndefinedOrNull=N;function o(T,_){if(!T)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}t.assertType=o;function s(T){if(N(T))throw new Error("Assertion Failed: argument is undefined or null");return T}t.assertIsDefined=s;function e(...T){const _=[];for(let r=0;r<T.length;r++){const n=T[r];if(N(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);_.push(n)}return _}t.assertAllDefined=e;const b=Object.prototype.hasOwnProperty;function D(T){if(!H(T))return!1;for(const _ in T)if(b.call(T,_))return!1;return!0}t.isEmptyObject=D;function v(T){return typeof T=="function"}t.isFunction=v;function E(...T){return T.length>0&&T.every(v)}t.areFunctions=E;function a(T,_){const r=Math.min(T.length,_.length);for(let n=0;n<r;n++)l(T[n],_[n])}t.validateConstraints=a;function l(T,_){if(y(_)){if(typeof T!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(v(_)){try{if(T instanceof _)return}catch{}if(!N(T)&&T.constructor===_||_.length===1&&_.call(void 0,T)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=l;function p(T){return T===null?void 0:T}t.withNullAsUndefined=p;function S(T){return typeof T>"u"?null:T}t.withUndefinedAsNull=S}),define(me[27],pe([1,0,6]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const E=Array.isArray(v)?[]:{};return Object.keys(v).forEach(a=>{v[a]&&typeof v[a]=="object"?E[a]=i(v[a]):E[a]=v[a]}),E}t.deepClone=i;function H(v){if(!v||typeof v!="object")return v;const E=[v];for(;E.length>0;){const a=E.shift();Object.freeze(a);for(const l in a)if(O.call(a,l)){const p=a[l];typeof p=="object"&&!Object.isFrozen(p)&&!(0,y.isTypedArray)(p)&&E.push(p)}}return v}t.deepFreeze=H;const O=Object.prototype.hasOwnProperty;function C(v,E){return w(v,E,new Set)}t.cloneAndChange=C;function w(v,E,a){if((0,y.isUndefinedOrNull)(v))return v;const l=E(v);if(typeof l<"u")return l;if(Array.isArray(v)){const p=[];for(const S of v)p.push(w(S,E,a));return p}if((0,y.isObject)(v)){if(a.has(v))throw new Error("Cannot clone recursive data-structure");a.add(v);const p={};for(const S in v)O.call(v,S)&&(p[S]=w(v[S],E,a));return a.delete(v),p}return v}function g(v,E,a=!0){return(0,y.isObject)(v)?((0,y.isObject)(E)&&Object.keys(E).forEach(l=>{l in v?a&&((0,y.isObject)(v[l])&&(0,y.isObject)(E[l])?g(v[l],E[l],a):v[l]=E[l]):v[l]=E[l]}),v):E}t.mixin=g;function d(v,E){if(v===E)return!0;if(v==null||E===null||E===void 0||typeof v!=typeof E||typeof v!="object"||Array.isArray(v)!==Array.isArray(E))return!1;let a,l;if(Array.isArray(v)){if(v.length!==E.length)return!1;for(a=0;a<v.length;a++)if(!d(v[a],E[a]))return!1}else{const p=[];for(l in v)p.push(l);p.sort();const S=[];for(l in E)S.push(l);if(S.sort(),!d(p,S))return!1;for(a=0;a<p.length;a++)if(!d(v[p[a]],E[p[a]]))return!1}return!0}t.equals=d;function f(v){const E=new Set;return JSON.stringify(v,(a,l)=>{if((0,y.isObject)(l)||Array.isArray(l)){if(E.has(l))return"[Circular]";E.add(l)}return l})}t.safeStringify=f;function N(v,E){const a=Object.create(null);return!v||!E||Object.keys(E).forEach(p=>{const S=v[p],T=E[p];d(S,T)||(a[p]=T)}),a}t.distinct=N;function o(v,E){const a=E.toLowerCase(),l=Object.keys(v).find(p=>p.toLowerCase()===a);return l?v[l]:v[E]}t.getCaseInsensitive=o;function s(v,E){const a=Object.create(null);for(const[l,p]of Object.entries(v))E(l,p)&&(a[l]=p);return a}t.filter=s;function e(v){let E=[],a=Object.getPrototypeOf(v);for(;Object.prototype!==a;)E=E.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return E}t.getAllPropertyNames=e;function b(v){const E=[];for(const a of e(v))typeof v[a]=="function"&&E.push(a);return E}t.getAllMethodNames=b;function D(v,E){const a=p=>function(){const S=Array.prototype.slice.call(arguments,0);return E(p,S)},l={};for(const p of v)l[p]=a(p);return l}t.createProxyObject=D}),define(me[80],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[81],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class y{constructor(H,O){this.sender=H,this.onMessage=O}send(H){try{this.sender.send("vscode:message",H.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=y}),define(me[47],pe([7]),{}),define(me[82],pe([7]),{}),define(me[83],pe([7]),{}),define(me[84],pe([7]),{}),define(me[85],pe([1,0,11,83,84]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(H){let O=H.definition;for(;O instanceof y.Codicon;)O=O.definition;return`.codicon-${H.id}:before { content: '${O.fontCharacter}'; }`}t.formatRule=i}),define(me[86],pe([7]),{}),define(me[87],pe([7]),{}),define(me[88],pe([7]),{}),define(me[89],pe([7]),{}),define(me[90],pe([7]),{}),define(me[91],pe([7]),{}),define(me[92],pe([7]),{}),define(me[93],pe([7]),{}),define(me[94],pe([7]),{}),define(me[95],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[96],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[97],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[98],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[99],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[100],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[101],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[102],pe([12,9]),function(Z,t){return Z.create("vs/base/common/actions",t)}),define(me[103],pe([12,9]),function(Z,t){return Z.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,103]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let H=!1,O=!1,C=!1,w=!1,g=!1,d=!1,f=!1,N=!1,o=!1,s,e=i,b,D;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?v=t.globals.vscode.process:typeof process<"u"&&(v=process);const E=typeof v?.versions?.electron=="string",a=E&&v?.type==="renderer";if(typeof navigator=="object"&&!a)D=navigator.userAgent,H=D.indexOf("Windows")>=0,O=D.indexOf("Macintosh")>=0,N=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=D.indexOf("Linux")>=0,d=!0,s=y.getConfiguredDefaultLocale(y.localize(0,null))||i,e=s;else if(typeof v=="object"){H=v.platform==="win32",O=v.platform==="darwin",C=v.platform==="linux",w=C&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,f=E,o=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=i,e=i;const h=v.env.VSCODE_NLS_CONFIG;if(h)try{const m=JSON.parse(h),z=m.availableLanguages["*"];s=m.locale,e=z||i,b=m._translationsConfigFile}catch{}g=!0}else console.error("Unable to resolve platform.");var l;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(l=t.Platform||(t.Platform={}));function p(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=p;let S=0;O?S=1:H?S=3:C&&(S=2),t.isWindows=H,t.isMacintosh=O,t.isLinux=C,t.isLinuxSnap=w,t.isNative=g,t.isElectron=f,t.isWeb=d,t.isWebWorker=d&&typeof t.globals.importScripts=="function",t.isIOS=N,t.isCI=o,t.platform=S,t.userAgent=D,t.language=e;var T;(function(h){function m(){return t.language}h.value=m;function z(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}h.isDefaultVariant=z;function $(){return t.language==="en"}h.isDefault=$})(T=t.Language||(t.Language={})),t.locale=s,t.translationsConfigFile=b,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const h=[];t.globals.addEventListener("message",z=>{if(z.data&&z.data.vscodeScheduleAsyncWork)for(let $=0,J=h.length;$<J;$++){const Q=h[$];if(Q.id===z.data.vscodeScheduleAsyncWork){h.splice($,1),Q.callback();return}}});let m=0;return z=>{const $=++m;h.push({id:$,callback:z}),t.globals.postMessage({vscodeScheduleAsyncWork:$},"*")}}return h=>setTimeout(h)})();var _;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(_=t.OperatingSystem||(t.OperatingSystem={})),t.OS=O||N?2:H?1:3;let r=!0,n=!1;function u(){if(!n){n=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,r=new Uint16Array(h.buffer)[0]===(2<<8)+1}return r}t.isLittleEndian=u,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[104],pe([1,0,5]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const H=y.globals.vscode.process;i={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],pe([1,0,104]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,H=97,O=90,C=122,w=46,g=47,d=92,f=58,N=63;class o extends Error{constructor(l,p,S){let T;typeof p=="string"&&p.indexOf("not ")===0?(T="must not be",p=p.replace(/^not /,"")):T="must be";const _=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${_} ${T} of type ${p}`;r+=`. Received type ${typeof S}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function s(a,l){if(typeof a!="string")throw new o(l,"string",a)}function e(a){return a===g||a===d}function b(a){return a===g}function D(a){return a>=i&&a<=O||a>=H&&a<=C}function v(a,l,p,S){let T="",_=0,r=-1,n=0,u=0;for(let h=0;h<=a.length;++h){if(h<a.length)u=a.charCodeAt(h);else{if(S(u))break;u=g}if(S(u)){if(!(r===h-1||n===1))if(n===2){if(T.length<2||_!==2||T.charCodeAt(T.length-1)!==w||T.charCodeAt(T.length-2)!==w){if(T.length>2){const m=T.lastIndexOf(p);m===-1?(T="",_=0):(T=T.slice(0,m),_=T.length-1-T.lastIndexOf(p)),r=h,n=0;continue}else if(T.length!==0){T="",_=0,r=h,n=0;continue}}l&&(T+=T.length>0?`${p}..`:"..",_=2)}else T.length>0?T+=`${p}${a.slice(r+1,h)}`:T=a.slice(r+1,h),_=h-r-1;r=h,n=0}else u===w&&n!==-1?++n:n=-1}return T}function E(a,l){if(l===null||typeof l!="object")throw new o("pathObject","Object",l);const p=l.dir||l.root,S=l.base||`${l.name||""}${l.ext||""}`;return p?p===l.root?`${p}${S}`:`${p}${a}${S}`:S}t.win32={resolve(...a){let l="",p="",S=!1;for(let T=a.length-1;T>=-1;T--){let _;if(T>=0){if(_=a[T],s(_,"path"),_.length===0)continue}else l.length===0?_=y.cwd():(_=y.env[`=${l}`]||y.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==l.toLowerCase()&&_.charCodeAt(2)===d)&&(_=`${l}\\`));const r=_.length;let n=0,u="",h=!1;const m=_.charCodeAt(0);if(r===1)e(m)&&(n=1,h=!0);else if(e(m))if(h=!0,e(_.charCodeAt(1))){let z=2,$=z;for(;z<r&&!e(_.charCodeAt(z));)z++;if(z<r&&z!==$){const J=_.slice($,z);for($=z;z<r&&e(_.charCodeAt(z));)z++;if(z<r&&z!==$){for($=z;z<r&&!e(_.charCodeAt(z));)z++;(z===r||z!==$)&&(u=`\\\\${J}\\${_.slice($,z)}`,n=z)}}}else n=1;else D(m)&&_.charCodeAt(1)===f&&(u=_.slice(0,2),n=2,r>2&&e(_.charCodeAt(2))&&(h=!0,n=3));if(u.length>0)if(l.length>0){if(u.toLowerCase()!==l.toLowerCase())continue}else l=u;if(S){if(l.length>0)break}else if(p=`${_.slice(n)}\\${p}`,S=h,h&&l.length>0)break}return p=v(p,!S,"\\",e),S?`${l}\\${p}`:`${l}${p}`||"."},normalize(a){s(a,"path");const l=a.length;if(l===0)return".";let p=0,S,T=!1;const _=a.charCodeAt(0);if(l===1)return b(_)?"\\":a;if(e(_))if(T=!0,e(a.charCodeAt(1))){let n=2,u=n;for(;n<l&&!e(a.charCodeAt(n));)n++;if(n<l&&n!==u){const h=a.slice(u,n);for(u=n;n<l&&e(a.charCodeAt(n));)n++;if(n<l&&n!==u){for(u=n;n<l&&!e(a.charCodeAt(n));)n++;if(n===l)return`\\\\${h}\\${a.slice(u)}\\`;n!==u&&(S=`\\\\${h}\\${a.slice(u,n)}`,p=n)}}}else p=1;else D(_)&&a.charCodeAt(1)===f&&(S=a.slice(0,2),p=2,l>2&&e(a.charCodeAt(2))&&(T=!0,p=3));let r=p<l?v(a.slice(p),!T,"\\",e):"";return r.length===0&&!T&&(r="."),r.length>0&&e(a.charCodeAt(l-1))&&(r+="\\"),S===void 0?T?`\\${r}`:r:T?`${S}\\${r}`:`${S}${r}`},isAbsolute(a){s(a,"path");const l=a.length;if(l===0)return!1;const p=a.charCodeAt(0);return e(p)||l>2&&D(p)&&a.charCodeAt(1)===f&&e(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let l,p;for(let _=0;_<a.length;++_){const r=a[_];s(r,"path"),r.length>0&&(l===void 0?l=p=r:l+=`\\${r}`)}if(l===void 0)return".";let S=!0,T=0;if(typeof p=="string"&&e(p.charCodeAt(0))){++T;const _=p.length;_>1&&e(p.charCodeAt(1))&&(++T,_>2&&(e(p.charCodeAt(2))?++T:S=!1))}if(S){for(;T<l.length&&e(l.charCodeAt(T));)T++;T>=2&&(l=`\\${l.slice(T)}`)}return t.win32.normalize(l)},relative(a,l){if(s(a,"from"),s(l,"to"),a===l)return"";const p=t.win32.resolve(a),S=t.win32.resolve(l);if(p===S||(a=p.toLowerCase(),l=S.toLowerCase(),a===l))return"";let T=0;for(;T<a.length&&a.charCodeAt(T)===d;)T++;let _=a.length;for(;_-1>T&&a.charCodeAt(_-1)===d;)_--;const r=_-T;let n=0;for(;n<l.length&&l.charCodeAt(n)===d;)n++;let u=l.length;for(;u-1>n&&l.charCodeAt(u-1)===d;)u--;const h=u-n,m=r<h?r:h;let z=-1,$=0;for(;$<m;$++){const Q=a.charCodeAt(T+$);if(Q!==l.charCodeAt(n+$))break;Q===d&&(z=$)}if($!==m){if(z===-1)return S}else{if(h>m){if(l.charCodeAt(n+$)===d)return S.slice(n+$+1);if($===2)return S.slice(n+$)}r>m&&(a.charCodeAt(T+$)===d?z=$:$===2&&(z=3)),z===-1&&(z=0)}let J="";for($=T+z+1;$<=_;++$)($===_||a.charCodeAt($)===d)&&(J+=J.length===0?"..":"\\..");return n+=z,J.length>0?`${J}${S.slice(n,u)}`:(S.charCodeAt(n)===d&&++n,S.slice(n,u))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const l=t.win32.resolve(a);if(l.length<=2)return a;if(l.charCodeAt(0)===d){if(l.charCodeAt(1)===d){const p=l.charCodeAt(2);if(p!==N&&p!==w)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(D(l.charCodeAt(0))&&l.charCodeAt(1)===f&&l.charCodeAt(2)===d)return`\\\\?\\${l}`;return a},dirname(a){s(a,"path");const l=a.length;if(l===0)return".";let p=-1,S=0;const T=a.charCodeAt(0);if(l===1)return e(T)?a:".";if(e(T)){if(p=S=1,e(a.charCodeAt(1))){let n=2,u=n;for(;n<l&&!e(a.charCodeAt(n));)n++;if(n<l&&n!==u){for(u=n;n<l&&e(a.charCodeAt(n));)n++;if(n<l&&n!==u){for(u=n;n<l&&!e(a.charCodeAt(n));)n++;if(n===l)return a;n!==u&&(p=S=n+1)}}}}else D(T)&&a.charCodeAt(1)===f&&(p=l>2&&e(a.charCodeAt(2))?3:2,S=p);let _=-1,r=!0;for(let n=l-1;n>=S;--n)if(e(a.charCodeAt(n))){if(!r){_=n;break}}else r=!1;if(_===-1){if(p===-1)return".";_=p}return a.slice(0,_)},basename(a,l){l!==void 0&&s(l,"ext"),s(a,"path");let p=0,S=-1,T=!0,_;if(a.length>=2&&D(a.charCodeAt(0))&&a.charCodeAt(1)===f&&(p=2),l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let r=l.length-1,n=-1;for(_=a.length-1;_>=p;--_){const u=a.charCodeAt(_);if(e(u)){if(!T){p=_+1;break}}else n===-1&&(T=!1,n=_+1),r>=0&&(u===l.charCodeAt(r)?--r===-1&&(S=_):(r=-1,S=n))}return p===S?S=n:S===-1&&(S=a.length),a.slice(p,S)}for(_=a.length-1;_>=p;--_)if(e(a.charCodeAt(_))){if(!T){p=_+1;break}}else S===-1&&(T=!1,S=_+1);return S===-1?"":a.slice(p,S)},extname(a){s(a,"path");let l=0,p=-1,S=0,T=-1,_=!0,r=0;a.length>=2&&a.charCodeAt(1)===f&&D(a.charCodeAt(0))&&(l=S=2);for(let n=a.length-1;n>=l;--n){const u=a.charCodeAt(n);if(e(u)){if(!_){S=n+1;break}continue}T===-1&&(_=!1,T=n+1),u===w?p===-1?p=n:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||T===-1||r===0||r===1&&p===T-1&&p===S+1?"":a.slice(p,T)},format:E.bind(null,"\\"),parse(a){s(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const p=a.length;let S=0,T=a.charCodeAt(0);if(p===1)return e(T)?(l.root=l.dir=a,l):(l.base=l.name=a,l);if(e(T)){if(S=1,e(a.charCodeAt(1))){let z=2,$=z;for(;z<p&&!e(a.charCodeAt(z));)z++;if(z<p&&z!==$){for($=z;z<p&&e(a.charCodeAt(z));)z++;if(z<p&&z!==$){for($=z;z<p&&!e(a.charCodeAt(z));)z++;z===p?S=z:z!==$&&(S=z+1)}}}}else if(D(T)&&a.charCodeAt(1)===f){if(p<=2)return l.root=l.dir=a,l;if(S=2,e(a.charCodeAt(2))){if(p===3)return l.root=l.dir=a,l;S=3}}S>0&&(l.root=a.slice(0,S));let _=-1,r=S,n=-1,u=!0,h=a.length-1,m=0;for(;h>=S;--h){if(T=a.charCodeAt(h),e(T)){if(!u){r=h+1;break}continue}n===-1&&(u=!1,n=h+1),T===w?_===-1?_=h:m!==1&&(m=1):_!==-1&&(m=-1)}return n!==-1&&(_===-1||m===0||m===1&&_===n-1&&_===r+1?l.base=l.name=a.slice(r,n):(l.name=a.slice(r,_),l.base=a.slice(r,n),l.ext=a.slice(_,n))),r>0&&r!==S?l.dir=a.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...a){let l="",p=!1;for(let S=a.length-1;S>=-1&&!p;S--){const T=S>=0?a[S]:y.cwd();s(T,"path"),T.length!==0&&(l=`${T}/${l}`,p=T.charCodeAt(0)===g)}return l=v(l,!p,"/",b),p?`/${l}`:l.length>0?l:"."},normalize(a){if(s(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===g,p=a.charCodeAt(a.length-1)===g;return a=v(a,!l,"/",b),a.length===0?l?"/":p?"./":".":(p&&(a+="/"),l?`/${a}`:a)},isAbsolute(a){return s(a,"path"),a.length>0&&a.charCodeAt(0)===g},join(...a){if(a.length===0)return".";let l;for(let p=0;p<a.length;++p){const S=a[p];s(S,"path"),S.length>0&&(l===void 0?l=S:l+=`/${S}`)}return l===void 0?".":t.posix.normalize(l)},relative(a,l){if(s(a,"from"),s(l,"to"),a===l||(a=t.posix.resolve(a),l=t.posix.resolve(l),a===l))return"";const p=1,S=a.length,T=S-p,_=1,r=l.length-_,n=T<r?T:r;let u=-1,h=0;for(;h<n;h++){const z=a.charCodeAt(p+h);if(z!==l.charCodeAt(_+h))break;z===g&&(u=h)}if(h===n)if(r>n){if(l.charCodeAt(_+h)===g)return l.slice(_+h+1);if(h===0)return l.slice(_+h)}else T>n&&(a.charCodeAt(p+h)===g?u=h:h===0&&(u=0));let m="";for(h=p+u+1;h<=S;++h)(h===S||a.charCodeAt(h)===g)&&(m+=m.length===0?"..":"/..");return`${m}${l.slice(_+u)}`},toNamespacedPath(a){return a},dirname(a){if(s(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===g;let p=-1,S=!0;for(let T=a.length-1;T>=1;--T)if(a.charCodeAt(T)===g){if(!S){p=T;break}}else S=!1;return p===-1?l?"/":".":l&&p===1?"//":a.slice(0,p)},basename(a,l){l!==void 0&&s(l,"ext"),s(a,"path");let p=0,S=-1,T=!0,_;if(l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let r=l.length-1,n=-1;for(_=a.length-1;_>=0;--_){const u=a.charCodeAt(_);if(u===g){if(!T){p=_+1;break}}else n===-1&&(T=!1,n=_+1),r>=0&&(u===l.charCodeAt(r)?--r===-1&&(S=_):(r=-1,S=n))}return p===S?S=n:S===-1&&(S=a.length),a.slice(p,S)}for(_=a.length-1;_>=0;--_)if(a.charCodeAt(_)===g){if(!T){p=_+1;break}}else S===-1&&(T=!1,S=_+1);return S===-1?"":a.slice(p,S)},extname(a){s(a,"path");let l=-1,p=0,S=-1,T=!0,_=0;for(let r=a.length-1;r>=0;--r){const n=a.charCodeAt(r);if(n===g){if(!T){p=r+1;break}continue}S===-1&&(T=!1,S=r+1),n===w?l===-1?l=r:_!==1&&(_=1):l!==-1&&(_=-1)}return l===-1||S===-1||_===0||_===1&&l===S-1&&l===p+1?"":a.slice(l,S)},format:E.bind(null,"/"),parse(a){s(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const p=a.charCodeAt(0)===g;let S;p?(l.root="/",S=1):S=0;let T=-1,_=0,r=-1,n=!0,u=a.length-1,h=0;for(;u>=S;--u){const m=a.charCodeAt(u);if(m===g){if(!n){_=u+1;break}continue}r===-1&&(n=!1,r=u+1),m===w?T===-1?T=u:h!==1&&(h=1):T!==-1&&(h=-1)}if(r!==-1){const m=_===0&&p?1:_;T===-1||h===0||h===1&&T===r-1&&T===_+1?l.base=l.name=a.slice(m,r):(l.name=a.slice(m,T),l.base=a.slice(m,r),l.ext=a.slice(T,r))}return _>0?l.dir=a.slice(0,_-1):p&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=y.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=y.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=y.platform==="win32"?t.win32.join:t.posix.join,t.resolve=y.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=y.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=y.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=y.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=y.platform==="win32"?t.win32.extname:t.posix.extname,t.format=y.platform==="win32"?t.win32.format:t.posix.format,t.parse=y.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=y.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=y.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=y.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[105],pe([1,0,21]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},H={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(f){const N=(0,y.extname)(f),o=i[N.toLowerCase()];return o!==void 0?o:C(f)}t.getMediaOrTextMime=O;function C(f){const N=(0,y.extname)(f);return H[N.toLowerCase()]}t.getMediaMime=C;function w(f){for(const N in H)if(H[N]===f)return N}t.getExtensionForMimeType=w;const g=/^(.+)\/(.+?)(;.+)?$/;function d(f,N){const o=g.exec(f);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:N?void 0:f}t.normalizeMimeType=d}),define(me[106],pe([1,0,5]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=y.globals.performance&&typeof y.globals.performance.now=="function";class H{constructor(C){this._highResolution=i&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new H(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}t.StopWatch=H}),define(me[3],pe([1,0,13,42,2,74,106]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;const w=!1,g=!1;var d;(function(u){u.None=()=>H.Disposable.None;function h(c){if(g){const{onListenerDidAdd:I}=c,U=e.create();let K=0;c.onListenerDidAdd=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),I?.()}}}function m(c){return(I,U=null,K)=>{let X=!1,L;return L=c(R=>{if(!X)return L?L.dispose():X=!0,I.call(U,R)},null,K),X&&L.dispose(),L}}u.once=m;function z(c,I,U){return we((K,X=null,L)=>c(R=>K.call(X,I(R)),null,L),U)}u.map=z;function $(c,I,U){return we((K,X=null,L)=>c(R=>{I(R),K.call(X,R)},null,L),U)}u.forEach=$;function J(c,I,U){return we((K,X=null,L)=>c(R=>I(R)&&K.call(X,R),null,L),U)}u.filter=J;function Q(c){return c}u.signal=Q;function ge(...c){return(I,U=null,K)=>(0,H.combinedDisposable)(...c.map(X=>X(L=>I.call(U,L),null,K)))}u.any=ge;function oe(c,I,U,K){let X=U;return z(c,L=>(X=I(X,L),X),K)}u.reduce=oe;function we(c,I){let U;const K={onFirstListenerAdd(){U=c(X.fire,X)},onLastListenerRemove(){U?.dispose()}};I||h(K);const X=new D(K);return I?.add(X),X.event}function he(c,I,U=100,K=!1,X,L){let R,W,A,P=0;const M={leakWarningThreshold:X,onFirstListenerAdd(){R=c(q=>{P++,W=I(W,q),K&&!A&&(B.fire(W),W=void 0),clearTimeout(A),A=setTimeout(()=>{const ee=W;W=void 0,A=void 0,(!K||P>1)&&B.fire(ee),P=0},U)})},onLastListenerRemove(){R.dispose()}};L||h(M);const B=new D(M);return L?.add(B),B.event}u.debounce=he;function se(c,I=(K,X)=>K===X,U){let K=!0,X;return J(c,L=>{const R=K||!I(L,X);return K=!1,X=L,R},U)}u.latch=se;function _e(c,I,U){return[u.filter(c,I,U),u.filter(c,K=>!I(K),U)]}u.split=_e;function te(c,I=!1,U=[]){let K=U.slice(),X=c(W=>{K?K.push(W):R.fire(W)});const L=()=>{K?.forEach(W=>R.fire(W)),K=null},R=new D({onFirstListenerAdd(){X||(X=c(W=>R.fire(W)))},onFirstListenerDidAdd(){K&&(I?setTimeout(L):L())},onLastListenerRemove(){X&&X.dispose(),X=null}});return R.event}u.buffer=te;class De{constructor(I){this.event=I,this.disposables=new H.DisposableStore}map(I){return new De(z(this.event,I,this.disposables))}forEach(I){return new De($(this.event,I,this.disposables))}filter(I){return new De(J(this.event,I,this.disposables))}reduce(I,U){return new De(oe(this.event,I,U,this.disposables))}latch(){return new De(se(this.event,void 0,this.disposables))}debounce(I,U=100,K=!1,X){return new De(he(this.event,I,U,K,X,this.disposables))}on(I,U,K){return this.event(I,U,K)}once(I,U,K){return m(this.event)(I,U,K)}dispose(){this.disposables.dispose()}}function re(c){return new De(c)}u.chain=re;function ie(c,I,U=K=>K){const K=(...W)=>R.fire(U(...W)),X=()=>c.on(I,K),L=()=>c.removeListener(I,K),R=new D({onFirstListenerAdd:X,onLastListenerRemove:L});return R.event}u.fromNodeEventEmitter=ie;function ce(c,I,U=K=>K){const K=(...W)=>R.fire(U(...W)),X=()=>c.addEventListener(I,K),L=()=>c.removeEventListener(I,K),R=new D({onFirstListenerAdd:X,onLastListenerRemove:L});return R.event}u.fromDOMEventEmitter=ce;function ne(c){return new Promise(I=>m(c)(I))}u.toPromise=ne;function F(c,I){return I(void 0),c(U=>I(U))}u.runAndSubscribe=F;function V(c,I){let U=null;function K(L){U?.dispose(),U=new H.DisposableStore,I(L,U)}K(void 0);const X=c(L=>K(L));return(0,H.toDisposable)(()=>{X.dispose(),U?.dispose()})}u.runAndSubscribeWithStore=V;class j{constructor(I,U){this.obs=I,this._counter=0,this._hasChanged=!1;const K={onFirstListenerAdd:()=>{I.addObserver(this)},onLastListenerRemove:()=>{I.removeObserver(this)}};U||h(K),this.emitter=new D(K),U&&U.add(this.emitter)}beginUpdate(I){this._counter++}handleChange(I,U){this._hasChanged=!0}endUpdate(I){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function k(c,I){return new j(c,I).emitter.event}u.fromObservable=k})(d=t.Event||(t.Event={}));class f{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${f._idPool++}`}start(h){this._stopWatch=new C.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let N=-1;function o(u){const h=N;return N=u,{dispose(){N=h}}}t.setGlobalLeakWarningThreshold=o;class s{constructor(h,m=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h,m){let z=N;if(typeof this.customThreshold=="number"&&(z=this.customThreshold),z<=0||m<z)return;this._stacks||(this._stacks=new Map);const $=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,$+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;let J,Q=0;for(const[ge,oe]of this._stacks)(!J||Q<oe)&&(J=ge,Q=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${Q}):`),console.warn(J)}return()=>{const J=this._stacks.get(h.value)||0;this._stacks.set(h.value,J-1)}}}class e{constructor(h){this.value=h}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(h,m,z){this.callback=h,this.callbackThis=m,this.stack=z,this.subscription=new H.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class D{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=N>0?new s(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const h=Array.from(this._listeners);queueMicrotask(()=>{for(const m of h)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(h,m,z)=>{this._listeners||(this._listeners=new O.LinkedList);const $=this._listeners.isEmpty();$&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let J,Q;this._leakageMon&&this._listeners.size>=30&&(Q=e.create(),J=this._leakageMon.check(Q,this._listeners.size+1)),w&&(Q=Q??e.create());const ge=new b(h,m,Q),oe=this._listeners.push(ge);$&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,m);const we=ge.subscription.set(()=>{J?.(),this._disposed||(oe(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return z instanceof H.DisposableStore?z.add(we):Array.isArray(z)&&z.push(we),we}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E);for(const m of this._listeners)this._deliveryQueue.push(this,m,h);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=D;class v{constructor(){this._queue=new O.LinkedList}get size(){return this._queue.size}push(h,m,z){this._queue.push(new a(h,m,z))}clear(h){const m=new O.LinkedList;for(const z of this._queue)z.emitter!==h&&m.push(z);this._queue=m}deliver(){for(;this._queue.size>0;){const h=this._queue.shift();try{h.listener.invoke(h.event)}catch(m){(0,y.onUnexpectedError)(m)}}}}t.EventDeliveryQueue=v;class E extends v{clear(h){this._queue.clear()}}class a{constructor(h,m,z){this.emitter=h,this.listener=m,this.event=z}}class l extends D{async fireAsync(h,m,z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList);for(const $ of this._listeners)this._asyncDeliveryQueue.push([$,h]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[$,J]=this._asyncDeliveryQueue.shift(),Q=[],ge={...J,token:m,waitUntil:oe=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");z&&(oe=z(oe,$.callback)),Q.push(oe)}};try{$.invoke(ge)}catch(oe){(0,y.onUnexpectedError)(oe);continue}Object.freeze(Q),await Promise.allSettled(Q).then(oe=>{for(const we of oe)we.status==="rejected"&&(0,y.onUnexpectedError)(we.reason)})}}}}t.AsyncEmitter=l;class p extends D{constructor(h){super(h),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}t.PauseableEmitter=p;class S extends p{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}t.DebounceEmitter=S;class T extends D{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){!this.hasListeners()||(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=T;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new D({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const m={event:h,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const z=()=>{this.hasListeners&&this.unhook(m);const $=this.events.indexOf(m);this.events.splice($,1)};return(0,H.toDisposable)((0,i.once)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(m=>this.emitter.fire(m))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=_;class r{constructor(){this.buffers=[]}wrapEvent(h){return(m,z,$)=>h(J=>{const Q=this.buffers[this.buffers.length-1];Q?Q.push(()=>m.call(z,J)):m.call(z,J)},void 0,$)}bufferEvents(h){const m=[];this.buffers.push(m);const z=h();return this.buffers.pop(),m.forEach($=>$()),z}}t.EventBufferer=r;class n{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=H.Disposable.None,this.emitter=new D({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),define(me[15],pe([1,0,3,2]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class H{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new y.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(a,l){this._zoomLevel!==a&&(this._zoomLevel=a)}getZoomFactor(){return this._zoomFactor}setZoomFactor(a){this._zoomFactor=a}setFullscreen(a){this._fullscreen!==a&&(this._fullscreen=a,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}H.INSTANCE=new H;class O extends i.Disposable{constructor(){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(a){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),a&&this._onDidChange.fire()}}class C extends i.Disposable{constructor(){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const a=this._register(new O);this._register(a.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}get value(){return this._value}_getPixelRatio(){const a=document.createElement("canvas").getContext("2d"),l=window.devicePixelRatio||1,p=a.webkitBackingStorePixelRatio||a.mozBackingStorePixelRatio||a.msBackingStorePixelRatio||a.oBackingStorePixelRatio||a.backingStorePixelRatio||1;return l/p}}class w{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new C)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function g(E,a){typeof E=="string"&&(E=window.matchMedia(E)),E.addEventListener("change",a)}t.addMatchMediaChangeListener=g,t.PixelRatio=new w;function d(E,a){H.INSTANCE.setZoomLevel(E,a)}t.setZoomLevel=d;function f(){return H.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function N(){return H.INSTANCE.getZoomFactor()}t.getZoomFactor=N;function o(E){H.INSTANCE.setZoomFactor(E)}t.setZoomFactor=o;function s(E){H.INSTANCE.setFullscreen(E)}t.setFullscreen=s;function e(){return H.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=H.INSTANCE.onDidChangeFullscreen;const b=navigator.userAgent;t.isFirefox=b.indexOf("Firefox")>=0,t.isWebKit=b.indexOf("AppleWebKit")>=0,t.isChrome=b.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&b.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=b.indexOf("Electron/")>=0,t.isAndroid=b.indexOf("Android")>=0;let D=!1;if(window.matchMedia){const E=window.matchMedia("(display-mode: standalone)"),a=window.matchMedia("(display-mode: fullscreen)");D=E.matches,g(E,({matches:l})=>{D&&a.matches||(D=l)})}function v(){return D}t.isStandalone=v}),define(me[107],pe([1,0,15,5]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var H;(function(O){O[O.Always=0]="Always",O[O.FullScreen=1]="FullScreen",O[O.None=2]="None"})(H=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||y.isStandalone()?0:navigator.keyboard||y.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[18],pe([1,0,3]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{constructor(O,C,w){const g=d=>this.emitter.fire(d);this.emitter=new y.Emitter({onFirstListenerAdd:()=>O.addEventListener(C,g,w),onLastListenerRemove:()=>O.removeEventListener(C,g,w)})}get event(){return this.emitter.event}dispose(){this.emitter.dispose()}}t.DomEmitter=i}),define(me[19],pe([1,0,15,43,73,5]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function C(e){if(e.charCode){const D=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(D)}const b=e.keyCode;if(b===3)return 7;if(y.isFirefox){if(b===59)return 80;if(b===107)return 81;if(b===109)return 83;if(O.isMacintosh&&b===224)return 57}else if(y.isWebKit){if(b===91)return 57;if(O.isMacintosh&&b===93)return 57;if(!O.isMacintosh&&b===92)return 57}return i.EVENT_KEY_CODE_MAP[b]||0}const w=O.isMacintosh?256:2048,g=512,d=1024,f=O.isMacintosh?2048:256;function N(e){const b=[];return e.ctrlKey&&b.push("ctrl"),e.shiftKey&&b.push("shift"),e.altKey&&b.push("alt"),e.metaKey&&b.push("meta"),`modifiers: [${b.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=N;function o(e){const b=[];return e.ctrlKey&&b.push("ctrl"),e.shiftKey&&b.push("shift"),e.altKey&&b.push("alt"),e.metaKey&&b.push("meta"),`modifiers: [${b.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class s{constructor(b){this._standardKeyboardEventBrand=!0;const D=b;this.browserEvent=D,this.target=D.target,this.ctrlKey=D.ctrlKey,this.shiftKey=D.shiftKey,this.altKey=D.altKey,this.metaKey=D.metaKey,this.keyCode=C(D),this.code=D.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(b){return this._asKeybinding===b}_computeKeybinding(){let b=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(b=this.keyCode);let D=0;return this.ctrlKey&&(D|=w),this.altKey&&(D|=g),this.shiftKey&&(D|=d),this.metaKey&&(D|=f),D|=b,D}_computeRuntimeKeybinding(){let b=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(b=this.keyCode),new H.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,b)}}t.StandardKeyboardEvent=s}),define(me[20],pe([1,0,15,66,5]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class O{constructor(d){this.timestamp=Date.now(),this.browserEvent=d,this.leftButton=d.button===0,this.middleButton=d.button===1,this.rightButton=d.button===2,this.buttons=d.buttons,this.target=d.target,this.detail=d.detail||1,d.type==="dblclick"&&(this.detail=2),this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,typeof d.pageX=="number"?(this.posx=d.pageX,this.posy=d.pageY):(this.posx=d.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=d.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,d.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=O;class C extends O{constructor(d){super(d),this.dataTransfer=d.dataTransfer}}t.DragMouseEvent=C;class w{constructor(d,f=0,N=0){if(this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=N,this.deltaX=f,d){const o=d,s=d;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof s.VERTICAL_AXIS<"u"&&s.axis===s.VERTICAL_AXIS)this.deltaY=-s.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!H.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof o.wheelDeltaX<"u")y.isSafari&&H.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof s.HORIZONTAL_AXIS<"u"&&s.axis===s.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!H.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(me[32],pe([1,0,3,2,102]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class O extends i.Disposable{constructor(o,s="",e="",b=!0,D){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=o,this._label=s,this._cssClass=e,this._enabled=b,this._actionCallback=D}get id(){return this._id}get label(){return this._label}set label(o){this._setLabel(o)}_setLabel(o){this._label!==o&&(this._label=o,this._onDidChange.fire({label:o}))}get tooltip(){return this._tooltip||""}set tooltip(o){this._setTooltip(o)}_setTooltip(o){this._tooltip!==o&&(this._tooltip=o,this._onDidChange.fire({tooltip:o}))}get class(){return this._cssClass}set class(o){this._setClass(o)}_setClass(o){this._cssClass!==o&&(this._cssClass=o,this._onDidChange.fire({class:o}))}get enabled(){return this._enabled}set enabled(o){this._setEnabled(o)}_setEnabled(o){this._enabled!==o&&(this._enabled=o,this._onDidChange.fire({enabled:o}))}get checked(){return this._checked}set checked(o){this._setChecked(o)}_setChecked(o){this._checked!==o&&(this._checked=o,this._onDidChange.fire({checked:o}))}async run(o,s){this._actionCallback&&await this._actionCallback(o)}}t.Action=O;class C extends i.Disposable{constructor(){super(...arguments),this._onBeforeRun=this._register(new y.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event}async run(o,s){if(!o.enabled)return;this._onBeforeRun.fire({action:o});let e;try{await this.runAction(o,s)}catch(b){e=b}this._onDidRun.fire({action:o,error:e})}async runAction(o,s){await o.run(s)}}t.ActionRunner=C;class w extends O{constructor(o){super(w.ID,o,o?"separator text":"separator"),this.checked=!1,this.enabled=!1}static join(...o){let s=[];for(const e of o)e.length&&(s.length?s=[...s,new w,...e]:s=e);return s}}t.Separator=w,w.ID="vs.actions.separator";class g{constructor(o,s,e,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=s,this.class=b,this._actions=e}get actions(){return this._actions}async run(){}}t.SubmenuAction=g;class d extends O{constructor(){super(d.ID,H.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=d,d.ID="vs.actions.empty";function f(N){return{id:N.id,label:N.label,class:void 0,enabled:N.enabled??!0,checked:N.checked??!1,run:async()=>N.run(),tooltip:N.label}}t.toAction=f}),define(me[28],pe([1,0,3]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,g){const d=setTimeout(w.bind(g),0);return{dispose(){clearTimeout(d)}}});var H;(function(w){function g(d){return d===w.None||d===w.Cancelled||d instanceof O?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}w.isCancellationToken=g,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(H=t.CancellationToken||(t.CancellationToken={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=H.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=H.None}}t.CancellationTokenSource=C}),define(me[108],pe([1,0,28]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new y.CancellationTokenSource,g=this.task(w.token);return this.result={promise:g,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=i;class H{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const g=JSON.stringify(w);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(w)),this.lastCache}}t.LRUCachedFunction=H;class O{constructor(w){this.fn=w,this._map=new Map}get cachedValues(){return this._map}get(w){if(this._map.has(w))return this._map.get(w);const g=this.fn(w);return this._map.set(w,g),g}}t.CachedFunction=O}),define(me[48],pe([1,0,3,2]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var H;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(H=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class O{constructor(e,b,D,v,E,a,l){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(b=b|0,D=D|0,v=v|0,E=E|0,a=a|0,l=l|0),this.rawScrollLeft=v,this.rawScrollTop=l,b<0&&(b=0),v+b>D&&(v=D-b),v<0&&(v=0),E<0&&(E=0),l+E>a&&(l=a-E),l<0&&(l=0),this.width=b,this.scrollWidth=D,this.scrollLeft=v,this.height=E,this.scrollHeight=a,this.scrollTop=l}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,b){return new O(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,b?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,b?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,b){const D=this.width!==e.width,v=this.scrollWidth!==e.scrollWidth,E=this.scrollLeft!==e.scrollLeft,a=this.height!==e.height,l=this.scrollHeight!==e.scrollHeight,p=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:b,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:D,scrollWidthChanged:v,scrollLeftChanged:E,heightChanged:a,scrollHeightChanged:l,scrollTopChanged:p}}}t.ScrollState=O;class C extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new y.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new O(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,b){const D=this._state.withScrollDimensions(e,b);this._setState(D,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const b=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(b,!1)}setScrollPositionSmooth(e,b){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const D=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===D.scrollLeft&&this._smoothScrolling.to.scrollTop===D.scrollTop)return;let v;b?v=new f(this._smoothScrolling.from,D,this._smoothScrolling.startTime,this._smoothScrolling.duration):v=this._smoothScrolling.combine(this._state,D,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=v}else{const D=this._state.withScrollPosition(e);this._smoothScrolling=f.start(this._state,D,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),b=this._state.withScrollPosition(e);if(this._setState(b,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,b){const D=this._state;D.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(D,b)))}}t.Scrollable=C;class w{constructor(e,b,D){this.scrollLeft=e,this.scrollTop=b,this.isDone=D}}t.SmoothScrollingUpdate=w;function g(s,e){const b=e-s;return function(D){return s+b*o(D)}}function d(s,e,b){return function(D){return D<b?s(D/b):e((D-b)/(1-b))}}class f{constructor(e,b,D,v){this.from=e,this.to=b,this.duration=v,this.startTime=D,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,b,D){if(Math.abs(e-b)>2.5*D){let E,a;return e<b?(E=e+.75*D,a=b-.75*D):(E=e-.75*D,a=b+.75*D),d(g(e,E),g(a,b),.33)}return g(e,b)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const b=(e-this.startTime)/this.duration;if(b<1){const D=this.scrollLeft(b),v=this.scrollTop(b);return new w(D,v,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,b,D){return f.start(e,b,D)}static start(e,b,D){D=D+10;const v=Date.now()-10;return new f(e,b,v,D)}}t.SmoothScrollingOperation=f;function N(s){return Math.pow(s,3)}function o(s){return 1-N(1-s)}}),define(me[10],pe([1,0,108,44]),function(Z,t,y,i){"use strict";var H;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function O(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.isFalsyOrWhitespace=O;const C=/{(\d+)}/g;function w(x,...ae){return ae.length===0?x:x.replace(C,function(be,Ce){const Ae=parseInt(Ce,10);return isNaN(Ae)||Ae<0||Ae>=ae.length?be:ae[Ae]})}t.format=w;const g=/{([^}]+)}/g;function d(x,ae){return x.replace(g,(be,Ce)=>ae[Ce]??be)}t.format2=d;function f(x){return x.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.escape=f;function N(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=N;function o(x,ae){let be=0;const Ce=ae.charCodeAt(0);for(let Ae=x.length-1;Ae>=0;Ae--)x.charCodeAt(Ae)===Ce&&be++;return be}t.count=o;function s(x,ae,be="\u2026"){return x.length<=ae?x:`${x.substr(0,ae)}${be}`}t.truncate=s;function e(x,ae=" "){const be=b(x,ae);return D(be,ae)}t.trim=e;function b(x,ae){if(!x||!ae)return x;const be=ae.length;if(be===0||x.length===0)return x;let Ce=0;for(;x.indexOf(ae,Ce)===Ce;)Ce=Ce+be;return x.substring(Ce)}t.ltrim=b;function D(x,ae){if(!x||!ae)return x;const be=ae.length,Ce=x.length;if(be===0||Ce===0)return x;let Ae=Ce,Me=-1;for(;Me=x.lastIndexOf(ae,Ae-1),!(Me===-1||Me+be!==Ae);){if(Me===0)return"";Ae=Me}return x.substring(0,Ae)}t.rtrim=D;function v(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=v;function E(x){return x.replace(/\*/g,"")}t.stripWildcards=E;function a(x,ae,be={}){if(!x)throw new Error("Cannot create regex from empty string");ae||(x=N(x)),be.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ce="";return be.global&&(Ce+="g"),be.matchCase||(Ce+="i"),be.multiline&&(Ce+="m"),be.unicode&&(Ce+="u"),new RegExp(x,Ce)}t.createRegExp=a;function l(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.regExpLeadsToEndlessLoop=l;function p(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=p;function S(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}t.regExpFlags=S;function T(x){return x.split(/\r\n|\r|\n/)}t.splitLines=T;function _(x){for(let ae=0,be=x.length;ae<be;ae++){const Ce=x.charCodeAt(ae);if(Ce!==32&&Ce!==9)return ae}return-1}t.firstNonWhitespaceIndex=_;function r(x,ae=0,be=x.length){for(let Ce=ae;Ce<be;Ce++){const Ae=x.charCodeAt(Ce);if(Ae!==32&&Ae!==9)return x.substring(ae,Ce)}return x.substring(ae,be)}t.getLeadingWhitespace=r;function n(x,ae=x.length-1){for(let be=ae;be>=0;be--){const Ce=x.charCodeAt(be);if(Ce!==32&&Ce!==9)return be}return-1}t.lastNonWhitespaceIndex=n;function u(x,ae,be){const Ce=[];let Ae=0;for(const Me of x.matchAll(ae)){if(Ce.push(x.slice(Ae,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Ae=Me.index+Me[0].length,Ce.push(be(Me[0],...Me.slice(1),Me.index,x,Me.groups))}return Ce.push(x.slice(Ae)),Promise.all(Ce).then(Me=>Me.join(""))}t.replaceAsync=u;function h(x,ae){return x<ae?-1:x>ae?1:0}t.compare=h;function m(x,ae,be=0,Ce=x.length,Ae=0,Me=ae.length){for(;be<Ce&&Ae<Me;be++,Ae++){const et=x.charCodeAt(be),Ie=ae.charCodeAt(Ae);if(et<Ie)return-1;if(et>Ie)return 1}const $e=Ce-be,Ge=Me-Ae;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstring=m;function z(x,ae){return $(x,ae,0,x.length,0,ae.length)}t.compareIgnoreCase=z;function $(x,ae,be=0,Ce=x.length,Ae=0,Me=ae.length){for(;be<Ce&&Ae<Me;be++,Ae++){let et=x.charCodeAt(be),Ie=ae.charCodeAt(Ae);if(et===Ie)continue;if(et>=128||Ie>=128)return m(x.toLowerCase(),ae.toLowerCase(),be,Ce,Ae,Me);Q(et)&&(et-=32),Q(Ie)&&(Ie-=32);const ue=et-Ie;if(ue!==0)return ue}const $e=Ce-be,Ge=Me-Ae;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstringIgnoreCase=$;function J(x){return x>=48&&x<=57}t.isAsciiDigit=J;function Q(x){return x>=97&&x<=122}t.isLowerAsciiLetter=Q;function ge(x){return x>=65&&x<=90}t.isUpperAsciiLetter=ge;function oe(x,ae){return x.length===ae.length&&$(x,ae)===0}t.equalsIgnoreCase=oe;function we(x,ae){const be=ae.length;return ae.length>x.length?!1:$(x,ae,0,be)===0}t.startsWithIgnoreCase=we;function he(x,ae){const be=Math.min(x.length,ae.length);let Ce;for(Ce=0;Ce<be;Ce++)if(x.charCodeAt(Ce)!==ae.charCodeAt(Ce))return Ce;return be}t.commonPrefixLength=he;function se(x,ae){const be=Math.min(x.length,ae.length);let Ce;const Ae=x.length-1,Me=ae.length-1;for(Ce=0;Ce<be;Ce++)if(x.charCodeAt(Ae-Ce)!==ae.charCodeAt(Me-Ce))return Ce;return be}t.commonSuffixLength=se;function _e(x){return 55296<=x&&x<=56319}t.isHighSurrogate=_e;function te(x){return 56320<=x&&x<=57343}t.isLowSurrogate=te;function De(x,ae){return(x-55296<<10)+(ae-56320)+65536}t.computeCodePoint=De;function re(x,ae,be){const Ce=x.charCodeAt(be);if(_e(Ce)&&be+1<ae){const Ae=x.charCodeAt(be+1);if(te(Ae))return De(Ce,Ae)}return Ce}t.getNextCodePoint=re;function ie(x,ae){const be=x.charCodeAt(ae-1);if(te(be)&&ae>1){const Ce=x.charCodeAt(ae-2);if(_e(Ce))return De(Ce,be)}return be}class ce{constructor(ae,be=0){this._str=ae,this._len=ae.length,this._offset=be}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=ie(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=re(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}t.CodePointIterator=ce;class ne{constructor(ae,be=0){this._iterator=new ce(ae,be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=ke.getInstance(),be=this._iterator,Ce=be.offset;let Ae=ae.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Me=be.offset,$e=ae.getGraphemeBreakType(be.nextCodePoint());if(ve(Ae,$e)){be.setOffset(Me);break}Ae=$e}return be.offset-Ce}prevGraphemeLength(){const ae=ke.getInstance(),be=this._iterator,Ce=be.offset;let Ae=ae.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Me=be.offset,$e=ae.getGraphemeBreakType(be.prevCodePoint());if(ve($e,Ae)){be.setOffset(Me);break}Ae=$e}return Ce-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ne;function F(x,ae){return new ne(x,ae).nextGraphemeLength()}t.nextCharLength=F;function V(x,ae){return new ne(x,ae).prevGraphemeLength()}t.prevCharLength=V;function j(x,ae){ae>0&&te(x.charCodeAt(ae))&&ae--;const be=ae+F(x,ae);return[be-V(x,be),be]}t.getCharContainingOffset=j;let k;function c(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function I(x){return k||(k=c()),k.test(x)}t.containsRTL=I;const U=/^[\t\n\r\x20-\x7E]*$/;function K(x){return U.test(x)}t.isBasicASCII=K,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(x){return t.UNUSUAL_LINE_TERMINATORS.test(x)}t.containsUnusualLineTerminators=X;function L(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.isFullWidthCharacter=L;function R(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.isEmojiImprecise=R;function W(x,ae){if(x.length<ae)return x;const be=/\b/g;let Ce=0;for(;be.test(x)&&!(x.length-be.lastIndex<ae);)Ce=be.lastIndex,be.lastIndex+=1;return x.substring(Ce).replace(/^\s/,"")}t.lcut=W;const A=/\x1B\x5B[12]?K/g,P=/\x1b\[\d+m/g,M=/\x1b\[0?m/g;function B(x){return x&&(x=x.replace(A,""),x=x.replace(P,""),x=x.replace(M,"")),x}t.removeAnsiEscapeCodes=B,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function q(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.startsWithUTF8BOM=q;function ee(x){return q(x)?x.substr(1):x}t.stripUTF8BOM=ee;function le(x,ae){if(!x||!ae||x.length<ae.length)return!1;const be=ae.length,Ce=x.toLowerCase();let Ae=0,Me=-1;for(;Ae<be;){const $e=Ce.indexOf(ae[Ae],Me+1);if($e<0)return!1;Me=$e,Ae++}return!0}t.fuzzyContains=le;function de(x,ae=!1){return x?(ae&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.containsUppercaseCharacter=de;function ye(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.uppercaseFirstLetter=ye;function Ee(x,ae=1){if(ae===0)return"";let be=-1;do be=x.indexOf(`
`,be+1),ae--;while(ae>0&&be>=0);return be===-1?x:(x[be-1]==="\r"&&be--,x.substr(0,be))}t.getNLines=Ee;function Re(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.singleLetterHash=Re;function Le(x){return ke.getInstance().getGraphemeBreakType(x)}t.getGraphemeBreakType=Le;function ve(x,ae){return x===0?ae!==5&&ae!==7:x===2&&ae===3?!1:x===4||x===2||x===3||ae===4||ae===2||ae===3?!0:!(x===8&&(ae===8||ae===9||ae===11||ae===12)||(x===11||x===9)&&(ae===9||ae===10)||(x===12||x===10)&&ae===10||ae===5||ae===13||ae===7||x===1||x===13&&ae===14||x===6&&ae===6)}var Pe;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class ke{constructor(){this._data=qe()}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const be=this._data,Ce=be.length/3;let Ae=1;for(;Ae<=Ce;)if(ae<be[3*Ae])Ae=2*Ae;else if(ae>be[3*Ae+1])Ae=2*Ae+1;else return be[3*Ae+2];return 0}}ke._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(x,ae){if(x===0)return 0;const be=Ue(x,ae);if(be!==void 0)return be;const Ce=new ce(ae,x);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=He;function Ue(x,ae){const be=new ce(ae,x);let Ce=be.prevCodePoint();for(;Ye(Ce)||Ce===65039||Ce===8419;){if(be.offset===0)return;Ce=be.prevCodePoint()}if(!R(Ce))return;let Ae=be.offset;return Ae>0&&be.prevCodePoint()===8205&&(Ae=be.offset),Ae}function Ye(x){return 127995<=x&&x<=127999}var it;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Oe{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return Oe.cache.get(Array.from(ae))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Oe,H=Oe,Oe.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new y.LRUCachedFunction(x=>{function ae(Ie){const ue=new Map;for(let Se=0;Se<Ie.length;Se+=2)ue.set(Ie[Se],Ie[Se+1]);return ue}function be(Ie,ue){const Se=new Map(Ie);for(const[Ne,We]of ue)Se.set(Ne,We);return Se}function Ce(Ie,ue){if(!Ie)return ue;const Se=new Map;for(const[Ne,We]of Ie)ue.has(Ne)&&Se.set(Ne,We);return Se}const Ae=H.ambiguousCharacterData.getValue();let Me=x.filter(Ie=>!Ie.startsWith("_")&&Ie in Ae);Me.length===0&&(Me=["_default"]);let $e;for(const Ie of Me){const ue=ae(Ae[Ie]);$e=Ce($e,ue)}const Ge=ae(Ae._common),et=be(Ge,$e);return new Oe(et)}),Oe._locales=new i.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(x=>!x.startsWith("_")));class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(ae){return xe.getData().has(ae)}static get codePoints(){return xe.getData()}}t.InvisibleCharacters=xe,xe._data=void 0}),define(me[109],pe([1,0,21,5,10,6]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function C(n){return n===47||n===92}t.isPathSeparator=C;function w(n){return n.replace(/[\\/]/g,y.posix.sep)}t.toSlashes=w;function g(n){return n.indexOf("/")===-1&&(n=w(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}t.toPosixPath=g;function d(n,u=y.posix.sep){if(!n)return"";const h=n.length,m=n.charCodeAt(0);if(C(m)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let $=3;const J=$;for(;$<h&&!C(n.charCodeAt($));$++);if(J!==$&&!C(n.charCodeAt($+1))){for($+=1;$<h;$++)if(C(n.charCodeAt($)))return n.slice(0,$+1).replace(/[\\/]/g,u)}}return u}else if(v(m)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+u:n.slice(0,2);let z=n.indexOf("://");if(z!==-1){for(z+=3;z<h;z++)if(C(n.charCodeAt(z)))return n.slice(0,z+1)}return""}t.getRoot=d;function f(n){if(!i.isWindows||!n||n.length<5)return!1;let u=n.charCodeAt(0);if(u!==92||(u=n.charCodeAt(1),u!==92))return!1;let h=2;const m=h;for(;h<n.length&&(u=n.charCodeAt(h),u!==92);h++);return!(m===h||(u=n.charCodeAt(h+1),isNaN(u)||u===92))}t.isUNC=f;const N=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(n,u=i.isWindows){const h=u?N:o;return!(!n||n.length===0||/^\s+$/.test(n)||(h.lastIndex=0,h.test(n))||u&&s.test(n)||n==="."||n===".."||u&&n[n.length-1]==="."||u&&n.length!==n.trim().length||n.length>255)}t.isValidBasename=e;function b(n,u,h){const m=n===u;return!h||m?m:!n||!u?!1:(0,H.equalsIgnoreCase)(n,u)}t.isEqual=b;function D(n,u,h,m=y.sep){if(n===u)return!0;if(!n||!u||u.length>n.length)return!1;if(h){if(!(0,H.startsWithIgnoreCase)(n,u))return!1;if(u.length===n.length)return!0;let $=u.length;return u.charAt(u.length-1)===m&&$--,n.charAt($)===m}return u.charAt(u.length-1)!==m&&(u+=m),n.indexOf(u)===0}t.isEqualOrParent=D;function v(n){return n>=65&&n<=90||n>=97&&n<=122}t.isWindowsDriveLetter=v;function E(n,u){return i.isWindows&&n.endsWith(":")&&(n+=y.sep),(0,y.isAbsolute)(n)||(n=(0,y.join)(u,n)),n=(0,y.normalize)(n),i.isWindows?(n=(0,H.rtrim)(n,y.sep),n.endsWith(":")&&(n+=y.sep)):(n=(0,H.rtrim)(n,y.sep),n||(n=y.sep)),n}t.sanitizeFilePath=E;function a(n){const u=(0,y.normalize)(n);return i.isWindows?n.length>3?!1:l(u)&&(n.length===2||u.charCodeAt(2)===92):u===y.posix.sep}t.isRootOrDriveLetter=a;function l(n,u=i.isWindows){return u?v(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}t.hasDriveLetter=l;function p(n){return l(n)?n[0]:void 0}t.getDriveLetter=p;function S(n,u,h){return u.length>n.length?-1:n===u?0:(h&&(n=n.toLowerCase(),u=u.toLowerCase()),n.indexOf(u))}t.indexOfPath=S;function T(n){const u=n.split(":");let h,m,z;for(const $ of u){const J=Number($);(0,O.isNumber)(J)?m===void 0?m=J:z===void 0&&(z=J):h=h?[h,$].join(":"):$}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:m!==void 0?m:void 0,column:z!==void 0?z:m!==void 0?1:void 0}}t.parseLineAndColumnAware=T;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(n,u,h=8){let m="";for(let $=0;$<h;$++)m+=_.charAt(Math.floor(Math.random()*_.length));let z;return u?z=`${u}-${m}`:z=m,n?(0,y.join)(n,z):z}t.randomPath=r}),define(me[110],pe([1,0,10]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(v){return H(v,0)}t.hash=i;function H(v,E){switch(typeof v){case"object":return v===null?O(349,E):Array.isArray(v)?g(v,E):d(v,E);case"string":return w(v,E);case"boolean":return C(v,E);case"number":return O(v,E);case"undefined":return O(937,E);default:return O(617,E)}}t.doHash=H;function O(v,E){return(E<<5)-E+v|0}t.numberHash=O;function C(v,E){return O(v?433:863,E)}function w(v,E){E=O(149417,E);for(let a=0,l=v.length;a<l;a++)E=O(v.charCodeAt(a),E);return E}t.stringHash=w;function g(v,E){return E=O(104579,E),v.reduce((a,l)=>H(l,a),E)}function d(v,E){return E=O(181387,E),Object.keys(v).sort().reduce((a,l)=>(a=w(l,a),H(v[l],a)),E)}class f{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=H(E,this._value),this._value}}t.Hasher=f;var N;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function o(v,E,a=32){const l=a-E,p=~((1<<l)-1);return(v<<E|(p&v)>>>l)>>>0}function s(v,E=0,a=v.byteLength,l=0){for(let p=0;p<a;p++)v[E+p]=l}function e(v,E,a="0"){for(;v.length<E;)v=a+v;return v}function b(v,E=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(a=>a.toString(16).padStart(2,"0")).join(""):e((v>>>0).toString(16),E/4)}t.toHexString=b;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const l=this._buff;let p=this._buffLen,S=this._leftoverHighSurrogate,T,_;for(S!==0?(T=S,_=-1,S=0):(T=E.charCodeAt(0),_=0);;){let r=T;if(y.isHighSurrogate(T))if(_+1<a){const n=E.charCodeAt(_+1);y.isLowSurrogate(n)?(_++,r=y.computeCodePoint(T,n)):r=65533}else{S=T;break}else y.isLowSurrogate(T)&&(r=65533);if(p=this._push(l,p,r),_++,_<a)T=E.charCodeAt(_);else break}this._buffLen=p,this._leftoverHighSurrogate=S}_push(E,a,l){return l<128?E[a++]=l:l<2048?(E[a++]=192|(l&1984)>>>6,E[a++]=128|(l&63)>>>0):l<65536?(E[a++]=224|(l&61440)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0):(E[a++]=240|(l&1835008)>>>18,E[a++]=128|(l&258048)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,s(this._buff,this._buffLen),this._buffLen>56&&(this._step(),s(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=D._bigBlock32,a=this._buffDV;for(let h=0;h<64;h+=4)E.setUint32(h,a.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)E.setUint32(h,o(E.getUint32(h-12,!1)^E.getUint32(h-32,!1)^E.getUint32(h-56,!1)^E.getUint32(h-64,!1),1),!1);let l=this._h0,p=this._h1,S=this._h2,T=this._h3,_=this._h4,r,n,u;for(let h=0;h<80;h++)h<20?(r=p&S|~p&T,n=1518500249):h<40?(r=p^S^T,n=1859775393):h<60?(r=p&S|p&T|S&T,n=2400959708):(r=p^S^T,n=3395469782),u=o(l,5)+r+_+n+E.getUint32(h*4,!1)&4294967295,_=T,T=S,S=o(p,30),p=l,l=u;this._h0=this._h0+l&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+T&4294967295,this._h4=this._h4+_&4294967295}}t.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[111],pe([1,0,71,110]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class H{constructor(o){this.source=o}getElements(){const o=this.source,s=new Int32Array(o.length);for(let e=0,b=o.length;e<b;e++)s[e]=o.charCodeAt(e);return s}}t.StringDiffSequence=H;function O(N,o,s){return new f(new H(N),new H(o)).ComputeDiff(s).changes}t.stringDiff=O;class C{static Assert(o,s){if(!o)throw new Error(s)}}t.Debug=C;class w{static Copy(o,s,e,b,D){for(let v=0;v<D;v++)e[b+v]=o[s+v]}static Copy2(o,s,e,b,D){for(let v=0;v<D;v++)e[b+v]=o[s+v]}}t.MyArray=w;var g;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(g||(g={}));class d{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new y.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(o,s){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(o,s){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(o,s,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=o,this._modifiedSequence=s;const[b,D,v]=f._getElements(o),[E,a,l]=f._getElements(s);this._hasStrings=v&&l,this._originalStringElements=b,this._originalElementsOrHash=D,this._modifiedStringElements=E,this._modifiedElementsOrHash=a,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(o){return o.length>0&&typeof o[0]=="string"}static _getElements(o){const s=o.getElements();if(f._isStringArray(s)){const e=new Int32Array(s.length);for(let b=0,D=s.length;b<D;b++)e[b]=(0,i.stringHash)(s[b],0);return[s,e,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(o,s){return this._originalElementsOrHash[o]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[o]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(o,s){if(!this.ElementsAreEqual(o,s))return!1;const e=f._getStrictElement(this._originalSequence,o),b=f._getStrictElement(this._modifiedSequence,s);return e===b}static _getStrictElement(o,s){return typeof o.getStrictElement=="function"?o.getStrictElement(s):null}OriginalElementsAreEqual(o,s){return this._originalElementsOrHash[o]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[o]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(o,s){return this._modifiedElementsOrHash[o]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[o]===this._modifiedStringElements[s]:!0}ComputeDiff(o){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,o)}_ComputeDiff(o,s,e,b,D){const v=[!1];let E=this.ComputeDiffRecursive(o,s,e,b,v);return D&&(E=this.PrettifyChanges(E)),{quitEarly:v[0],changes:E}}ComputeDiffRecursive(o,s,e,b,D){for(D[0]=!1;o<=s&&e<=b&&this.ElementsAreEqual(o,e);)o++,e++;for(;s>=o&&b>=e&&this.ElementsAreEqual(s,b);)s--,b--;if(o>s||e>b){let S;return e<=b?(C.Assert(o===s+1,"originalStart should only be one more than originalEnd"),S=[new y.DiffChange(o,0,e,b-e+1)]):o<=s?(C.Assert(e===b+1,"modifiedStart should only be one more than modifiedEnd"),S=[new y.DiffChange(o,s-o+1,e,0)]):(C.Assert(o===s+1,"originalStart should only be one more than originalEnd"),C.Assert(e===b+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const v=[0],E=[0],a=this.ComputeRecursionPoint(o,s,e,b,v,E,D),l=v[0],p=E[0];if(a!==null)return a;if(!D[0]){const S=this.ComputeDiffRecursive(o,l,e,p,D);let T=[];return D[0]?T=[new y.DiffChange(l+1,s-(l+1)+1,p+1,b-(p+1)+1)]:T=this.ComputeDiffRecursive(l+1,s,p+1,b,D),this.ConcatenateChanges(S,T)}return[new y.DiffChange(o,s-o+1,e,b-e+1)]}WALKTRACE(o,s,e,b,D,v,E,a,l,p,S,T,_,r,n,u,h,m){let z=null,$=null,J=new d,Q=s,ge=e,oe=_[0]-u[0]-b,we=-1073741824,he=this.m_forwardHistory.length-1;do{const se=oe+o;se===Q||se<ge&&l[se-1]<l[se+1]?(S=l[se+1],r=S-oe-b,S<we&&J.MarkNextChange(),we=S,J.AddModifiedElement(S+1,r),oe=se+1-o):(S=l[se-1]+1,r=S-oe-b,S<we&&J.MarkNextChange(),we=S-1,J.AddOriginalElement(S,r+1),oe=se-1-o),he>=0&&(l=this.m_forwardHistory[he],o=l[0],Q=1,ge=l.length-1)}while(--he>=-1);if(z=J.getReverseChanges(),m[0]){let se=_[0]+1,_e=u[0]+1;if(z!==null&&z.length>0){const te=z[z.length-1];se=Math.max(se,te.getOriginalEnd()),_e=Math.max(_e,te.getModifiedEnd())}$=[new y.DiffChange(se,T-se+1,_e,n-_e+1)]}else{J=new d,Q=v,ge=E,oe=_[0]-u[0]-a,we=1073741824,he=h?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const se=oe+D;se===Q||se<ge&&p[se-1]>=p[se+1]?(S=p[se+1]-1,r=S-oe-a,S>we&&J.MarkNextChange(),we=S+1,J.AddOriginalElement(S+1,r+1),oe=se+1-D):(S=p[se-1],r=S-oe-a,S>we&&J.MarkNextChange(),we=S,J.AddModifiedElement(S+1,r+1),oe=se-1-D),he>=0&&(p=this.m_reverseHistory[he],D=p[0],Q=1,ge=p.length-1)}while(--he>=-1);$=J.getChanges()}return this.ConcatenateChanges(z,$)}ComputeRecursionPoint(o,s,e,b,D,v,E){let a=0,l=0,p=0,S=0,T=0,_=0;o--,e--,D[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const r=s-o+(b-e),n=r+1,u=new Int32Array(n),h=new Int32Array(n),m=b-e,z=s-o,$=o-e,J=s-b,ge=(z-m)%2===0;u[m]=o,h[z]=s,E[0]=!1;for(let oe=1;oe<=r/2+1;oe++){let we=0,he=0;p=this.ClipDiagonalBound(m-oe,oe,m,n),S=this.ClipDiagonalBound(m+oe,oe,m,n);for(let _e=p;_e<=S;_e+=2){_e===p||_e<S&&u[_e-1]<u[_e+1]?a=u[_e+1]:a=u[_e-1]+1,l=a-(_e-m)-$;const te=a;for(;a<s&&l<b&&this.ElementsAreEqual(a+1,l+1);)a++,l++;if(u[_e]=a,a+l>we+he&&(we=a,he=l),!ge&&Math.abs(_e-z)<=oe-1&&a>=h[_e])return D[0]=a,v[0]=l,te<=h[_e]&&1447>0&&oe<=1447+1?this.WALKTRACE(m,p,S,$,z,T,_,J,u,h,a,s,D,l,b,v,ge,E):null}const se=(we-o+(he-e)-oe)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(we,se))return E[0]=!0,D[0]=we,v[0]=he,se>0&&1447>0&&oe<=1447+1?this.WALKTRACE(m,p,S,$,z,T,_,J,u,h,a,s,D,l,b,v,ge,E):(o++,e++,[new y.DiffChange(o,s-o+1,e,b-e+1)]);T=this.ClipDiagonalBound(z-oe,oe,z,n),_=this.ClipDiagonalBound(z+oe,oe,z,n);for(let _e=T;_e<=_;_e+=2){_e===T||_e<_&&h[_e-1]>=h[_e+1]?a=h[_e+1]-1:a=h[_e-1],l=a-(_e-z)-J;const te=a;for(;a>o&&l>e&&this.ElementsAreEqual(a,l);)a--,l--;if(h[_e]=a,ge&&Math.abs(_e-m)<=oe&&a<=u[_e])return D[0]=a,v[0]=l,te>=u[_e]&&1447>0&&oe<=1447+1?this.WALKTRACE(m,p,S,$,z,T,_,J,u,h,a,s,D,l,b,v,ge,E):null}if(oe<=1447){let _e=new Int32Array(S-p+2);_e[0]=m-p+1,w.Copy2(u,p,_e,1,S-p+1),this.m_forwardHistory.push(_e),_e=new Int32Array(_-T+2),_e[0]=z-T+1,w.Copy2(h,T,_e,1,_-T+1),this.m_reverseHistory.push(_e)}}return this.WALKTRACE(m,p,S,$,z,T,_,J,u,h,a,s,D,l,b,v,ge,E)}PrettifyChanges(o){for(let s=0;s<o.length;s++){const e=o[s],b=s<o.length-1?o[s+1].originalStart:this._originalElementsOrHash.length,D=s<o.length-1?o[s+1].modifiedStart:this._modifiedElementsOrHash.length,v=e.originalLength>0,E=e.modifiedLength>0;for(;e.originalStart+e.originalLength<b&&e.modifiedStart+e.modifiedLength<D&&(!v||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!E||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const l=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!l)break;e.originalStart++,e.modifiedStart++}const a=[null];if(s<o.length-1&&this.ChangesOverlap(o[s],o[s+1],a)){o[s]=a[0],o.splice(s+1,1),s--;continue}}for(let s=o.length-1;s>=0;s--){const e=o[s];let b=0,D=0;if(s>0){const S=o[s-1];b=S.originalStart+S.originalLength,D=S.modifiedStart+S.modifiedLength}const v=e.originalLength>0,E=e.modifiedLength>0;let a=0,l=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const T=e.originalStart-S,_=e.modifiedStart-S;if(T<b||_<D||v&&!this.OriginalElementsAreEqual(T,T+e.originalLength)||E&&!this.ModifiedElementsAreEqual(_,_+e.modifiedLength))break;const n=(T===b&&_===D?5:0)+this._boundaryScore(T,e.originalLength,_,e.modifiedLength);n>l&&(l=n,a=S)}e.originalStart-=a,e.modifiedStart-=a;const p=[null];if(s>0&&this.ChangesOverlap(o[s-1],o[s],p)){o[s-1]=p[0],o.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,e=o.length;s<e;s++){const b=o[s-1],D=o[s],v=D.originalStart-b.originalStart-b.originalLength,E=b.originalStart,a=D.originalStart+D.originalLength,l=a-E,p=b.modifiedStart,S=D.modifiedStart+D.modifiedLength,T=S-p;if(v<5&&l<20&&T<20){const _=this._findBetterContiguousSequence(E,l,p,T,v);if(_){const[r,n]=_;(r!==b.originalStart+b.originalLength||n!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=r-b.originalStart,b.modifiedLength=n-b.modifiedStart,D.originalStart=r+v,D.modifiedStart=n+v,D.originalLength=a-D.originalStart,D.modifiedLength=S-D.modifiedStart)}}}return o}_findBetterContiguousSequence(o,s,e,b,D){if(s<D||b<D)return null;const v=o+s-D+1,E=e+b-D+1;let a=0,l=0,p=0;for(let S=o;S<v;S++)for(let T=e;T<E;T++){const _=this._contiguousSequenceScore(S,T,D);_>0&&_>a&&(a=_,l=S,p=T)}return a>0?[l,p]:null}_contiguousSequenceScore(o,s,e){let b=0;for(let D=0;D<e;D++){if(!this.ElementsAreEqual(o+D,s+D))return 0;b+=this._originalStringElements[o+D].length}return b}_OriginalIsBoundary(o){return o<=0||o>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[o])}_OriginalRegionIsBoundary(o,s){if(this._OriginalIsBoundary(o)||this._OriginalIsBoundary(o-1))return!0;if(s>0){const e=o+s;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(o){return o<=0||o>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[o])}_ModifiedRegionIsBoundary(o,s){if(this._ModifiedIsBoundary(o)||this._ModifiedIsBoundary(o-1))return!0;if(s>0){const e=o+s;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(o,s,e,b){const D=this._OriginalRegionIsBoundary(o,s)?1:0,v=this._ModifiedRegionIsBoundary(e,b)?1:0;return D+v}ConcatenateChanges(o,s){const e=[];if(o.length===0||s.length===0)return s.length>0?s:o;if(this.ChangesOverlap(o[o.length-1],s[0],e)){const b=new Array(o.length+s.length-1);return w.Copy(o,0,b,0,o.length-1),b[o.length-1]=e[0],w.Copy(s,1,b,o.length,s.length-1),b}else{const b=new Array(o.length+s.length);return w.Copy(o,0,b,0,o.length),w.Copy(s,0,b,o.length,s.length),b}}ChangesOverlap(o,s,e){if(C.Assert(o.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),C.Assert(o.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=s.originalStart||o.modifiedStart+o.modifiedLength>=s.modifiedStart){const b=o.originalStart;let D=o.originalLength;const v=o.modifiedStart;let E=o.modifiedLength;return o.originalStart+o.originalLength>=s.originalStart&&(D=s.originalStart+s.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=s.modifiedStart&&(E=s.modifiedStart+s.modifiedLength-o.modifiedStart),e[0]=new y.DiffChange(b,D,v,E),!0}else return e[0]=null,!1}ClipDiagonalBound(o,s,e,b){if(o>=0&&o<b)return o;const D=e,v=b-e-1,E=s%2===0;if(o<0){const a=D%2===0;return E===a?0:1}else{const a=v%2===0;return E===a?b-1:b-2}}}t.LcsDiff=f}),define(me[49],pe([1,0,14,10]),function(Z,t,y,i){"use strict";var H,O,C;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function w(_,r,n){let u=_.get(r);return u===void 0&&(u=n,_.set(r,u)),u}t.getOrSet=w;function g(_){const r=[];return _.forEach((n,u)=>{r.push(`${u} => ${n}`)}),`Map(${_.size}) {${r.join(", ")}}`}t.mapToString=g;function d(_){const r=[];return _.forEach(n=>{r.push(n)}),`Set(${_.size}) {${r.join(", ")}}`}t.setToString=d;class f{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return n-u}value(){return this._value[this._pos]}}t.StringIterator=f;class N{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=N;class o{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let n=r.length-1;n>=0;n--,this._valueLen--){const u=this._value.charCodeAt(n);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=o;var s;(function(_){_[_.Scheme=1]="Scheme",_[_.Authority=2]="Authority",_[_.Path=3]="Path",_[_.Query=4]="Query",_[_.Fragment=5]="Fragment"})(s||(s={}));class e{constructor(r,n){this._ignorePathCasing=r,this._ignoreQueryAndFragment=n,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,i.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(_){_[_.Left=-1]="Left",_[_.Mid=0]="Mid",_[_.Right=1]="Right"})(D||(D={}));class v{constructor(r){this._iter=r}static forUris(r=()=>!1,n=()=>!1){return new v(new e(r,n))}static forPaths(r=!1){return new v(new o(void 0,!r))}static forStrings(){return new v(new f)}static forConfigKeys(){return new v(new N)}clear(){this._root=void 0}fill(r,n){if(n){const u=n.slice(0);(0,y.shuffle)(u);for(const h of u)this.set(h,r)}else{const u=r.slice(0);(0,y.shuffle)(u);for(const h of u)this.set(h[0],h[1])}}set(r,n){const u=this._iter.reset(r);let h;this._root||(this._root=new b,this._root.segment=u.value());const m=[];for(h=this._root;;){const $=u.cmp(h.segment);if($>0)h.left||(h.left=new b,h.left.segment=u.value()),m.push([-1,h]),h=h.left;else if($<0)h.right||(h.right=new b,h.right.segment=u.value()),m.push([1,h]),h=h.right;else if(u.hasNext())u.next(),h.mid||(h.mid=new b,h.mid.segment=u.value()),m.push([0,h]),h=h.mid;else break}const z=h.value;h.value=n,h.key=r;for(let $=m.length-1;$>=0;$--){const J=m[$][1];J.updateHeight();const Q=J.balanceFactor();if(Q<-1||Q>1){const ge=m[$][0],oe=m[$+1][0];if(ge===1&&oe===1)m[$][1]=J.rotateLeft();else if(ge===-1&&oe===-1)m[$][1]=J.rotateRight();else if(ge===1&&oe===-1)J.right=m[$+1][1]=m[$+1][1].rotateRight(),m[$][1]=J.rotateLeft();else if(ge===-1&&oe===1)J.left=m[$+1][1]=m[$+1][1].rotateLeft(),m[$][1]=J.rotateRight();else throw new Error;if($>0)switch(m[$-1][0]){case-1:m[$-1][1].left=m[$][1];break;case 1:m[$-1][1].right=m[$][1];break;case 0:m[$-1][1].mid=m[$][1];break}else this._root=m[0][1]}}return z}get(r){return this._getNode(r)?.value}_getNode(r){const n=this._iter.reset(r);let u=this._root;for(;u;){const h=n.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else break}return u}has(r){const n=this._getNode(r);return!(n?.value===void 0&&n?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const u=this._iter.reset(r),h=[];let m=this._root;for(;m;){const z=u.cmp(m.segment);if(z>0)h.push([-1,m]),m=m.left;else if(z<0)h.push([1,m]),m=m.right;else if(u.hasNext())u.next(),h.push([0,m]),m=m.mid;else break}if(!!m){if(n?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const z=this._min(m.right),{key:$,value:J,segment:Q}=z;this._delete(z.key,!1),m.key=$,m.value=J,m.segment=Q}else{const z=m.left??m.right;if(h.length>0){const[$,J]=h[h.length-1];switch($){case-1:J.left=z;break;case 0:J.mid=z;break;case 1:J.right=z;break}}else this._root=z}for(let z=h.length-1;z>=0;z--){const $=h[z][1];$.updateHeight();const J=$.balanceFactor();if(J>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),h[z][1]=$.rotateLeft()):J<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),h[z][1]=$.rotateRight()),z>0)switch(h[z-1][0]){case-1:h[z-1][1].left=h[z][1];break;case 1:h[z-1][1].right=h[z][1];break;case 0:h[z-1][1].mid=h[z][1];break}else this._root=h[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const n=this._iter.reset(r);let u=this._root,h;for(;u;){const m=n.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(n.hasNext())n.next(),h=u.value||h,u=u.mid;else break}return u&&u.value||h}findSuperstr(r){const n=this._iter.reset(r);let u=this._root;for(;u;){const h=n.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[n,u]of this)r(u,n)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const n=[];return this._dfsEntries(r,n),n[Symbol.iterator]()}_dfsEntries(r,n){!r||(r.left&&this._dfsEntries(r.left,n),r.value&&n.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,n),r.right&&this._dfsEntries(r.right,n))}_isBalanced(){const r=n=>{if(!n)return!0;const u=n.balanceFactor();return u<-1||u>1?!1:r(n.left)&&r(n.right)};return r(this._root)}}t.TernarySearchTree=v;class E{constructor(r,n){this.uri=r,this.value=n}}class a{constructor(r,n){this[H]="ResourceMap",r instanceof a?(this.map=new Map(r.map),this.toKey=n??a.defaultToKey):(this.map=new Map,this.toKey=r??a.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),new E(r,n)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n<"u"&&(r=r.bind(n));for(const[u,h]of this.map)r(h.value,h.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(H=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=a,a.defaultToKey=_=>_.toString();class l{constructor(r,n){this[O]="ResourceSet",!r||typeof r=="function"?this._map=new a(r):(this._map=new a(n),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,n){this._map.forEach((u,h)=>r.call(n,h,h,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=l;var p;(function(_){_[_.None=0]="None",_[_.AsOld=1]="AsOld",_[_.AsNew=2]="AsNew"})(p=t.Touch||(t.Touch={}));class S{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,n=0){const u=this._map.get(r);if(!!u)return n!==0&&this.touch(u,n),u.value}set(r,n,u=0){let h=this._map.get(r);if(h)h.value=n,u!==0&&this.touch(h,u);else{switch(h={key:r,value:n,next:void 0,previous:void 0},u){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const u=this._state;let h=this._head;for(;h;){if(n?r.bind(n)(h.value,h.key,this):r(h.value,h.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,n=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.key,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return h}values(){const r=this,n=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.value,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return h}entries(){const r=this,n=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:[u.key,u.value],done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,u=this.size;for(;n&&u>r;)this._map.delete(n.key),n=n.next,u--;this._head=n,this._size=u,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,u=r.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const u=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(u.previous=h,h.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const u=r.next,h=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=h,h.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,u)=>{r.push([u,n])}),r}fromJSON(r){this.clear();for(const[n,u]of r)this.set(n,u)}}t.LinkedMap=S;class T extends S{constructor(r,n=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=T}),define(me[33],pe([1,0,49,10]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function H(...M){return function(B,q){for(let ee=0,le=M.length;ee<le;ee++){const de=M[ee](B,q);if(de)return de}return null}}t.or=H,t.matchesStrictPrefix=O.bind(void 0,!1),t.matchesPrefix=O.bind(void 0,!0);function O(M,B,q){if(!q||q.length<B.length)return null;let ee;return M?ee=i.startsWithIgnoreCase(q,B):ee=q.indexOf(B)===0,ee?B.length>0?[{start:0,end:B.length}]:[]:null}function C(M,B){const q=B.toLowerCase().indexOf(M.toLowerCase());return q===-1?null:[{start:q,end:q+M.length}]}t.matchesContiguousSubString=C;function w(M,B){return g(M.toLowerCase(),B.toLowerCase(),0,0)}t.matchesSubString=w;function g(M,B,q,ee){if(q===M.length)return[];if(ee===B.length)return null;if(M[q]===B[ee]){let le=null;return(le=g(M,B,q+1,ee+1))?v({start:ee,end:ee+1},le):null}return g(M,B,q,ee+1)}function d(M){return 97<=M&&M<=122}function f(M){return 65<=M&&M<=90}t.isUpper=f;function N(M){return 48<=M&&M<=57}function o(M){return M===32||M===9||M===10||M===13}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(M=>s.add(M.charCodeAt(0)));function e(M){return o(M)||s.has(M)}function b(M,B){return M===B||e(M)&&e(B)}function D(M){return d(M)||f(M)||N(M)}function v(M,B){return B.length===0?B=[M]:M.end===B[0].start?B[0].start=M.start:B.unshift(M),B}function E(M,B){for(let q=B;q<M.length;q++){const ee=M.charCodeAt(q);if(f(ee)||N(ee)||q>0&&!D(M.charCodeAt(q-1)))return q}return M.length}function a(M,B,q,ee){if(q===M.length)return[];if(ee===B.length)return null;if(M[q]!==B[ee].toLowerCase())return null;{let le=null,de=ee+1;for(le=a(M,B,q+1,ee+1);!le&&(de=E(B,de))<B.length;)le=a(M,B,q+1,de),de++;return le===null?null:v({start:ee,end:ee+1},le)}}function l(M){let B=0,q=0,ee=0,le=0,de=0;for(let ve=0;ve<M.length;ve++)de=M.charCodeAt(ve),f(de)&&B++,d(de)&&q++,D(de)&&ee++,N(de)&&le++;const ye=B/M.length,Ee=q/M.length,Re=ee/M.length,Le=le/M.length;return{upperPercent:ye,lowerPercent:Ee,alphaPercent:Re,numericPercent:Le}}function p(M){const{upperPercent:B,lowerPercent:q}=M;return q===0&&B>.6}function S(M){const{upperPercent:B,lowerPercent:q,alphaPercent:ee,numericPercent:le}=M;return q>.2&&B<.8&&ee>.6&&le<.2}function T(M){let B=0,q=0,ee=0,le=0;for(let de=0;de<M.length;de++)ee=M.charCodeAt(de),f(ee)&&B++,d(ee)&&q++,o(ee)&&le++;return(B===0||q===0)&&le===0?M.length<=30:B<=5}function _(M,B){if(!B||(B=B.trim(),B.length===0)||!T(M)||B.length>60)return null;const q=l(B);if(!S(q)){if(!p(q))return null;B=B.toLowerCase()}let ee=null,le=0;for(M=M.toLowerCase();le<B.length&&(ee=a(M,B,0,le))===null;)le=E(B,le+1);return ee}t.matchesCamelCase=_;function r(M,B,q=!1){if(!B||B.length===0)return null;let ee=null,le=0;for(M=M.toLowerCase(),B=B.toLowerCase();le<B.length&&(ee=n(M,B,0,le,q))===null;)le=u(B,le+1);return ee}t.matchesWords=r;function n(M,B,q,ee,le){if(q===M.length)return[];if(ee===B.length)return null;if(b(M.charCodeAt(q),B.charCodeAt(ee))){let de=null,ye=ee+1;if(de=n(M,B,q+1,ee+1,le),!le)for(;!de&&(ye=u(B,ye))<B.length;)de=n(M,B,q+1,ye,le),ye++;return de?M.charCodeAt(q)!==B.charCodeAt(ee)?de:v({start:ee,end:ee+1},de):null}else return null}function u(M,B){for(let q=B;q<M.length;q++)if(e(M.charCodeAt(q))||q>0&&e(M.charCodeAt(q-1)))return q;return M.length}const h=H(t.matchesPrefix,_,C),m=H(t.matchesPrefix,_,w),z=new y.LRUCache(1e4);function $(M,B,q=!1){if(typeof M!="string"||typeof B!="string")return null;let ee=z.get(M);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(M),"i"),z.set(M,ee));const le=ee.exec(B);return le?[{start:le.index,end:le.index+le[0].length}]:q?m(M,B):h(M,B)}t.matchesFuzzy=$;function J(M,B){const q=K(M,M.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?ge(q):null}t.matchesFuzzy2=J;function Q(M,B,q,ee,le,de){const ye=Math.min(13,M.length);for(;q<ye;q++){const Ee=K(M,B,q,ee,le,de,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,de]}t.anyScore=Q;function ge(M){if(typeof M>"u")return[];const B=[],q=M[1];for(let ee=M.length-1;ee>1;ee--){const le=M[ee]+q,de=B[B.length-1];de&&de.end===le?de.end=le+1:B.push({start:le,end:le+1})}return B}t.createMatches=ge;const oe=128;function we(){const M=[],B=[];for(let q=0;q<=oe;q++)B[q]=0;for(let q=0;q<=oe;q++)M.push(B.slice(0));return M}function he(M){const B=[];for(let q=0;q<=M;q++)B[q]=0;return B}const se=he(2*oe),_e=he(2*oe),te=we(),De=we(),re=we(),ie=!1;function ce(M,B,q,ee,le){function de(Ee,Re,Le=" "){for(;Ee.length<Re;)Ee=Le+Ee;return Ee}let ye=` |   |${ee.split("").map(Ee=>de(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=q;Ee++)Ee===0?ye+=" |":ye+=`${B[Ee-1]}|`,ye+=M[Ee].slice(0,le+1).map(Re=>de(Re.toString(),3)).join("|")+`
`;return ye}function ne(M,B,q,ee){M=M.substr(B),q=q.substr(ee),console.log(ce(De,M,M.length,q,q.length)),console.log(ce(re,M,M.length,q,q.length)),console.log(ce(te,M,M.length,q,q.length))}function F(M,B){if(B<0||B>=M.length)return!1;const q=M.codePointAt(B);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(q)}}function V(M,B){if(B<0||B>=M.length)return!1;switch(M.charCodeAt(B)){case 32:case 9:return!0;default:return!1}}function j(M,B,q){return B[M]!==q[M]}function k(M,B,q,ee,le,de,ye=!1){for(;B<q&&le<de;)M[B]===ee[le]&&(ye&&(se[B]=le),B+=1),le+=1;return B===q}t.isPatternInWord=k;var c;(function(M){M[M.Diag=1]="Diag",M[M.Left=2]="Left",M[M.LeftLeft=3]="LeftLeft"})(c||(c={}));var I;(function(M){M.Default=[-100,0];function B(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}M.isDefault=B})(I=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(B,q){this.firstMatchCanBeWeak=B,this.boostFullMatch=q}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(M,B,q,ee,le,de,ye=U.default){const Ee=M.length>oe?oe:M.length,Re=ee.length>oe?oe:ee.length;if(q>=Ee||de>=Re||Ee-q>Re-de||!k(B,q,Ee,le,de,Re,!0))return;X(Ee,Re,q,de,B,le);let Le=1,ve=1,Pe=q,ke=de;const qe=[!1];for(Le=1,Pe=q;Pe<Ee;Le++,Pe++){const Oe=se[Pe],xe=_e[Pe],x=Pe+1<Ee?_e[Pe+1]:Re;for(ve=Oe-de+1,ke=Oe;ke<x;ve++,ke++){let ae=Number.MIN_SAFE_INTEGER,be=!1;ke<=xe&&(ae=L(M,B,Pe,q,ee,le,ke,Re,de,te[Le-1][ve-1]===0,qe));let Ce=0;ae!==Number.MAX_SAFE_INTEGER&&(be=!0,Ce=ae+De[Le-1][ve-1]);const Ae=ke>Oe,Me=Ae?De[Le][ve-1]+(te[Le][ve-1]>0?-5:0):0,$e=ke>Oe+1&&te[Le][ve-1]>0,Ge=$e?De[Le][ve-2]+(te[Le][ve-2]>0?-5:0):0;if($e&&(!Ae||Ge>=Me)&&(!be||Ge>=Ce))De[Le][ve]=Ge,re[Le][ve]=3,te[Le][ve]=0;else if(Ae&&(!be||Me>=Ce))De[Le][ve]=Me,re[Le][ve]=2,te[Le][ve]=0;else if(be)De[Le][ve]=Ce,re[Le][ve]=1,te[Le][ve]=te[Le-1][ve-1]+1;else throw new Error("not possible")}}if(ie&&ne(M,q,ee,de),!qe[0]&&!ye.firstMatchCanBeWeak)return;Le--,ve--;const He=[De[Le][ve],de];let Ue=0,Ye=0;for(;Le>=1;){let Oe=ve;do{const xe=re[Le][Oe];if(xe===3)Oe=Oe-2;else if(xe===2)Oe=Oe-1;else break}while(Oe>=1);Ue>1&&B[q+Le-1]===le[de+ve-1]&&!j(Oe+de-1,ee,le)&&Ue+1>te[Le][Oe]&&(Oe=ve),Oe===ve?Ue++:Ue=1,Ye||(Ye=Oe),Le--,ve=Oe-1,He.push(ve)}Re===Ee&&ye.boostFullMatch&&(He[0]+=2);const it=Ye-Ee;return He[0]-=it,He}t.fuzzyScore=K;function X(M,B,q,ee,le,de){let ye=M-1,Ee=B-1;for(;ye>=q&&Ee>=ee;)le[ye]===de[Ee]&&(_e[ye]=Ee,ye--),Ee--}function L(M,B,q,ee,le,de,ye,Ee,Re,Le,ve){if(B[q]!==de[ye])return Number.MIN_SAFE_INTEGER;let Pe=1,ke=!1;return ye===q-ee?Pe=M[q]===le[ye]?7:5:j(ye,le,de)&&(ye===0||!j(ye-1,le,de))?(Pe=M[q]===le[ye]?7:5,ke=!0):F(de,ye)&&(ye===0||!F(de,ye-1))?Pe=5:(F(de,ye-1)||V(de,ye-1))&&(Pe=5,ke=!0),Pe>1&&q===ee&&(ve[0]=!0),ke||(ke=j(ye,le,de)||F(de,ye-1)||V(de,ye-1)),q===ee?ye>Re&&(Pe-=ke?3:5):Le?Pe+=ke?2:0:Pe+=ke?0:1,ye+1===Ee&&(Pe-=ke?3:5),Pe}function R(M,B,q,ee,le,de,ye){return A(M,B,q,ee,le,de,!0,ye)}t.fuzzyScoreGracefulAggressive=R;function W(M,B,q,ee,le,de,ye){return A(M,B,q,ee,le,de,!1,ye)}t.fuzzyScoreGraceful=W;function A(M,B,q,ee,le,de,ye,Ee){let Re=K(M,B,q,ee,le,de,Ee);if(Re&&!ye)return Re;if(M.length>=3){const Le=Math.min(7,M.length-1);for(let ve=q+1;ve<Le;ve++){const Pe=P(M,ve);if(Pe){const ke=K(Pe,Pe.toLowerCase(),q,ee,le,de,Ee);ke&&(ke[0]-=3,(!Re||ke[0]>Re[0])&&(Re=ke))}}}return Re}function P(M,B){if(B+1>=M.length)return;const q=M[B],ee=M[B+1];if(q!==ee)return M.slice(0,B)+ee+q+M.slice(B+2)}}),define(me[34],pe([1,0,11,33,10]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const O=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(y.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${O.source}`,"g");function g(D){return D.replace(w,(v,E)=>E?v:`\\${v}`)}t.escapeIcons=g;const d=new RegExp(`\\\\${O.source}`,"g");function f(D){return D.replace(d,v=>`\\${v}`)}t.markdownEscapeEscapedIcons=f;const N=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function o(D){return D.indexOf(t.iconStartMarker)===-1?D:D.replace(N,(v,E,a,l)=>a?v:E||l||"")}t.stripIcons=o;function s(D){const v=D.indexOf(t.iconStartMarker);return v===-1?{text:D}:e(D,v)}t.parseLabelWithIcons=s;function e(D,v){const E=[];let a="";function l(h){if(h){a+=h;for(const m of h)E.push(T)}}let p=-1,S="",T=0,_,r,n=v;const u=D.length;for(l(D.substr(0,v));n<u;)_=D[n],r=D[n+1],_===t.iconStartMarker[0]&&r===t.iconStartMarker[1]?(p=n,l(S),S=t.iconStartMarker,n++):_===")"&&p!==-1?(T+=n-p+1,p=-1,S=""):p!==-1?C.test(_)?S+=_:(l(S),p=-1,S=""):l(_),n++;return l(S),{text:a,iconOffsets:E}}function b(D,v,E=!1){const{text:a,iconOffsets:l}=v;if(!l||l.length===0)return(0,i.matchesFuzzy)(D,a,E);const p=(0,H.ltrim)(a," "),S=a.length-p.length,T=(0,i.matchesFuzzy)(D,p,E);if(T)for(const _ of T){const r=l[_.start+S]+S;_.start+=r,_.end+=r}return T}t.matchesFuzzyIconAware=b}),define(me[16],pe([1,0,21,5]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const H=/^\w[\w\d+.-]*$/,O=/^\//,C=/^\/\//;function w(_,r){if(!_.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!H.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!O.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(_,r){return!_&&!r?"file":_}function d(_,r){switch(_){case"https":case"http":case"file":r?r[0]!==N&&(r=N+r):r=N;break}return r}const f="",N="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{constructor(r,n,u,h,m,z=!1){typeof r=="object"?(this.scheme=r.scheme||f,this.authority=r.authority||f,this.path=r.path||f,this.query=r.query||f,this.fragment=r.fragment||f):(this.scheme=g(r,z),this.authority=n||f,this.path=d(this.scheme,u||f),this.query=h||f,this.fragment=m||f,w(this,z))}static isUri(r){return r instanceof s?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return a(this,!1)}with(r){if(!r)return this;let{scheme:n,authority:u,path:h,query:m,fragment:z}=r;return n===void 0?n=this.scheme:n===null&&(n=f),u===void 0?u=this.authority:u===null&&(u=f),h===void 0?h=this.path:h===null&&(h=f),m===void 0?m=this.query:m===null&&(m=f),z===void 0?z=this.fragment:z===null&&(z=f),n===this.scheme&&u===this.authority&&h===this.path&&m===this.query&&z===this.fragment?this:new b(n,u,h,m,z)}static parse(r,n=!1){const u=o.exec(r);return u?new b(u[2]||f,T(u[4]||f),T(u[5]||f),T(u[7]||f),T(u[9]||f),n):new b(f,f,f,f,f)}static file(r){let n=f;if(i.isWindows&&(r=r.replace(/\\/g,N)),r[0]===N&&r[1]===N){const u=r.indexOf(N,2);u===-1?(n=r.substring(2),r=N):(n=r.substring(2,u),r=r.substring(u)||N)}return new b("file",n,r,f,f)}static from(r){const n=new b(r.scheme,r.authority,r.path,r.query,r.fragment);return w(n,!0),n}static joinPath(r,...n){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return i.isWindows&&r.scheme==="file"?u=s.file(y.win32.join(a(r,!0),...n)).path:u=y.posix.join(r.path,...n),r.with({path:u})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof s)return r;{const n=new b(r);return n._formatted=r.external,n._fsPath=r._sep===e?r.fsPath:null,n}}else return r}}t.URI=s;const e=i.isWindows?1:void 0;class b extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=e),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(_,r){let n,u=-1;for(let h=0;h<_.length;h++){const m=_.charCodeAt(h);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||r&&m===47)u!==-1&&(n+=encodeURIComponent(_.substring(u,h)),u=-1),n!==void 0&&(n+=_.charAt(h));else{n===void 0&&(n=_.substr(0,h));const z=D[m];z!==void 0?(u!==-1&&(n+=encodeURIComponent(_.substring(u,h)),u=-1),n+=z):u===-1&&(u=h)}}return u!==-1&&(n+=encodeURIComponent(_.substring(u))),n!==void 0?n:_}function E(_){let r;for(let n=0;n<_.length;n++){const u=_.charCodeAt(n);u===35||u===63?(r===void 0&&(r=_.substr(0,n)),r+=D[u]):r!==void 0&&(r+=_[n])}return r!==void 0?r:_}function a(_,r){let n;return _.authority&&_.path.length>1&&_.scheme==="file"?n=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===47&&(_.path.charCodeAt(1)>=65&&_.path.charCodeAt(1)<=90||_.path.charCodeAt(1)>=97&&_.path.charCodeAt(1)<=122)&&_.path.charCodeAt(2)===58?r?n=_.path.substr(1):n=_.path[1].toLowerCase()+_.path.substr(2):n=_.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}t.uriToFsPath=a;function l(_,r){const n=r?E:v;let u="",{scheme:h,authority:m,path:z,query:$,fragment:J}=_;if(h&&(u+=h,u+=":"),(m||h==="file")&&(u+=N,u+=N),m){let Q=m.indexOf("@");if(Q!==-1){const ge=m.substr(0,Q);m=m.substr(Q+1),Q=ge.indexOf(":"),Q===-1?u+=n(ge,!1):(u+=n(ge.substr(0,Q),!1),u+=":",u+=n(ge.substr(Q+1),!1)),u+="@"}m=m.toLowerCase(),Q=m.indexOf(":"),Q===-1?u+=n(m,!1):(u+=n(m.substr(0,Q),!1),u+=m.substr(Q))}if(z){if(z.length>=3&&z.charCodeAt(0)===47&&z.charCodeAt(2)===58){const Q=z.charCodeAt(1);Q>=65&&Q<=90&&(z=`/${String.fromCharCode(Q+32)}:${z.substr(3)}`)}else if(z.length>=2&&z.charCodeAt(1)===58){const Q=z.charCodeAt(0);Q>=65&&Q<=90&&(z=`${String.fromCharCode(Q+32)}:${z.substr(2)}`)}u+=n(z,!0)}return $&&(u+="?",u+=n($,!1)),J&&(u+="#",u+=r?J:v(J,!1)),u}function p(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+p(_.substr(3)):_}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(_){return _.match(S)?_.replace(S,r=>p(r)):_}}),define(me[50],pe([1,0,31,10,16]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function O(d){return JSON.stringify(d,w)}t.stringify=O;function C(d){let f=JSON.parse(d);return f=g(f),f}t.parse=C;function w(d,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function g(d,f=0){if(!d||f>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return H.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof y.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let N=0;N<d.length;++N)d[N]=g(d[N],f+1);else for(const N in d)Object.hasOwnProperty.call(d,N)&&(d[N]=g(d[N],f+1))}return d}t.revive=g}),define(me[35],pe([1,0,5,16]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var H;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(H=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class O{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${H.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${H.vscodeRemoteResource}`}set(g,d,f){this._hosts[g]=d,this._ports[g]=f}setConnectionToken(g,d){this._connectionTokens[g]=d}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const d=g.authority;let f=this._hosts[d];f&&f.indexOf(":")!==-1&&(f=`[${f}]`);const N=this._ports[d],o=this._connectionTokens[d];let s=`path=${encodeURIComponent(g.path)}`;return typeof o=="string"&&(s+=`&${t.connectionTokenQueryName}=${encodeURIComponent(o)}`),i.URI.from({scheme:y.isWeb?this._preferredWebSchema:H.vscodeRemoteResource,authority:`${f}:${N}`,path:this._remoteResourcesPath,query:s})}}t.RemoteAuthorities=new O;class C{asBrowserUri(g,d){const f=this.toUri(g,d);return f.scheme===H.vscodeRemote?t.RemoteAuthorities.rewrite(f):f.scheme===H.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${H.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?f.with({scheme:H.vscodeFileResource,authority:f.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(g,d){const f=this.toUri(g,d);return f.scheme===H.vscodeFileResource?f.with({scheme:H.file,authority:f.authority!==C.FALLBACK_AUTHORITY?f.authority:null,query:null,fragment:null}):f}toUri(g,d){return i.URI.isUri(g)?g:i.URI.parse(d.toUrl(g))}}C.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new C}),define(me[36],pe([1,0,109,35,21,5,10,16]),function(Z,t,y,i,H,O,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function g(s){return(0,w.uriToFsPath)(s,!0)}t.originalFSPath=g;class d{constructor(e){this._ignorePathCasing=e}compare(e,b,D=!1){return e===b?0:(0,C.compare)(this.getComparisonKey(e,D),this.getComparisonKey(b,D))}isEqual(e,b,D=!1){return e===b?!0:!e||!b?!1:this.getComparisonKey(e,D)===this.getComparisonKey(b,D)}getComparisonKey(e,b=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,b,D=!1){if(e.scheme===b.scheme){if(e.scheme===i.Schemas.file)return y.isEqualOrParent(g(e),g(b),this._ignorePathCasing(e))&&e.query===b.query&&(D||e.fragment===b.fragment);if((0,t.isEqualAuthority)(e.authority,b.authority))return y.isEqualOrParent(e.path,b.path,this._ignorePathCasing(e),"/")&&e.query===b.query&&(D||e.fragment===b.fragment)}return!1}joinPath(e,...b){return w.URI.joinPath(e,...b)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return H.posix.basename(e.path)}extname(e){return H.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let b;return e.scheme===i.Schemas.file?b=w.URI.file(H.dirname(g(e))).path:(b=H.posix.dirname(e.path),e.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),b="/")),e.with({path:b})}normalizePath(e){if(!e.path.length)return e;let b;return e.scheme===i.Schemas.file?b=w.URI.file(H.normalize(g(e))).path:b=H.posix.normalize(e.path),e.with({path:b})}relativePath(e,b){if(e.scheme!==b.scheme||!(0,t.isEqualAuthority)(e.authority,b.authority))return;if(e.scheme===i.Schemas.file){const E=H.relative(g(e),g(b));return O.isWindows?y.toSlashes(E):E}let D=e.path||"/";const v=b.path||"/";if(this._ignorePathCasing(e)){let E=0;for(const a=Math.min(D.length,v.length);E<a&&!(D.charCodeAt(E)!==v.charCodeAt(E)&&D.charAt(E).toLowerCase()!==v.charAt(E).toLowerCase());E++);D=v.substr(0,E)+D.substr(E)}return H.posix.relative(D,v)}resolvePath(e,b){if(e.scheme===i.Schemas.file){const D=w.URI.file(H.resolve(g(e),b));return e.with({authority:D.authority,path:D.path})}return b=y.toPosixPath(b),e.with({path:H.posix.resolve(e.path,b)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,b){return e===b||e!==void 0&&b!==void 0&&(0,C.equalsIgnoreCase)(e,b)}hasTrailingPathSeparator(e,b=H.sep){if(e.scheme===i.Schemas.file){const D=g(e);return D.length>y.getRoot(D).length&&D[D.length-1]===b}else{const D=e.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,b=H.sep){return(0,t.hasTrailingPathSeparator)(e,b)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,b=H.sep){let D=!1;if(e.scheme===i.Schemas.file){const v=g(e);D=v!==void 0&&v.length===y.getRoot(v).length&&v[v.length-1]===b}else{b="/";const v=e.path;D=v.length===1&&v.charCodeAt(v.length-1)===47}return!D&&!(0,t.hasTrailingPathSeparator)(e,b)?e.with({path:e.path+"/"}):e}}t.ExtUri=d,t.extUri=new d(()=>!1),t.extUriBiasedIgnorePathCase=new d(s=>s.scheme===i.Schemas.file?!O.isLinux:!0),t.extUriIgnorePathCase=new d(s=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(s,e){const b=[];for(let D=0;D<s.length;D++){const v=e(s[D]);s.some((E,a)=>a===D?!1:(0,t.isEqualOrParent)(v,e(E)))||b.push(s[D])}return b}t.distinctParents=f;var N;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function e(b){const D=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(a=>{const[l,p]=a.split(":");l&&p&&D.set(l,p)});const E=b.path.substring(0,b.path.indexOf(";"));return E&&D.set(s.META_DATA_MIME,E),D}s.parseMetaData=e})(N=t.DataUri||(t.DataUri={}));function o(s,e,b){if(e){let D=s.path;return D&&D[0]!==H.posix.sep&&(D=H.posix.sep+D),s.with({scheme:b,authority:e,path:D})}return s.with({scheme:b})}t.toLocalResource=o}),define(me[8],pe([1,0,28,13,3,2,36,5]),function(Z,t,y,i,H,O,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function g(j){return!!j&&typeof j.then=="function"}t.isThenable=g;function d(j){const k=new y.CancellationTokenSource,c=j(k.token),I=new Promise((U,K)=>{const X=k.token.onCancellationRequested(()=>{X.dispose(),k.dispose(),K(new i.CancellationError)});Promise.resolve(c).then(L=>{X.dispose(),k.dispose(),U(L)},L=>{X.dispose(),k.dispose(),K(L)})});return new class{cancel(){k.cancel()}then(U,K){return I.then(U,K)}catch(U){return this.then(void 0,U)}finally(U){return I.finally(U)}}}t.createCancelablePromise=d;function f(j,k,c){return new Promise((I,U)=>{const K=k.onCancellationRequested(()=>{K.dispose(),I(c)});j.then(I,U).finally(()=>K.dispose())})}t.raceCancellation=f;function N(j,k){return new Promise((c,I)=>{const U=k.onCancellationRequested(()=>{U.dispose(),I(new i.CancellationError)});j.then(c,I).finally(()=>U.dispose())})}t.raceCancellationError=N;async function o(j){let k=-1;const c=j.map((U,K)=>U.then(X=>(k=K,X))),I=await Promise.race(c);return j.forEach((U,K)=>{K!==k&&U.cancel()}),I}t.raceCancellablePromises=o;function s(j,k,c){let I;const U=setTimeout(()=>{I?.(void 0),c?.()},k);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(K=>I=K)])}t.raceTimeout=s;function e(j){return new Promise((k,c)=>{const I=j();g(I)?I.then(k,c):k(I)})}t.asPromise=e;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const c=()=>{this.queuedPromise=null;const I=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,I};this.queuedPromise=new Promise(I=>{this.activePromise.then(c,c).then(I)})}return new Promise((c,I)=>{this.queuedPromise.then(c,I)})}return this.activePromise=k(),new Promise((c,I)=>{this.activePromise.then(U=>{this.activePromise=null,c(U)},U=>{this.activePromise=null,I(U)})})}}t.Throttler=b;class D{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}t.Sequencer=D;class v{constructor(){this.promiseMap=new Map}queue(k,c){const U=(this.promiseMap.get(k)??Promise.resolve()).catch(()=>{}).then(c).finally(()=>{this.promiseMap.get(k)===U&&this.promiseMap.delete(k)});return this.promiseMap.set(k,U),U}}t.SequencerByKey=v;const E=(j,k)=>{let c=!0;const I=setTimeout(()=>{c=!1,k()},j);return{isTriggered:()=>c,dispose:()=>{clearTimeout(I),c=!1}}},a=j=>{let k=!0;return queueMicrotask(()=>{k&&(k=!1,j())}),{isTriggered:()=>k,dispose:()=>{k=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(k){this.defaultDelay=k,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,c=this.defaultDelay){this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,K)=>{this.doResolve=U,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const I=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=c===t.MicrotaskDelay?a(I):E(c,I),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=l;class p{constructor(k){this.delayer=new l(k),this.throttler=new b}trigger(k,c){return this.delayer.trigger(()=>this.throttler.queue(k),c)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=p;class S{constructor(){this._isOpen=!1,this._promise=new Promise((k,c)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class T extends S{constructor(k){super(),this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=T;function _(j,k){return k?new Promise((c,I)=>{const U=setTimeout(()=>{K.dispose(),c()},j),K=k.onCancellationRequested(()=>{clearTimeout(U),K.dispose(),I(new i.CancellationError)})}):d(c=>_(j,c))}t.timeout=_;function r(j,k=0){const c=setTimeout(j,k);return(0,O.toDisposable)(()=>clearTimeout(c))}t.disposableTimeout=r;function n(j){const k=[];let c=0;const I=j.length;function U(){return c<I?j[c++]():null}function K(X){X!=null&&k.push(X);const L=U();return L?L.then(K):Promise.resolve(k)}return Promise.resolve(null).then(K)}t.sequence=n;function u(j,k=I=>!!I,c=null){let I=0;const U=j.length,K=()=>{if(I>=U)return Promise.resolve(c);const X=j[I++];return Promise.resolve(X()).then(R=>k(R)?Promise.resolve(R):K())};return K()}t.first=u;function h(j,k=I=>!!I,c=null){if(j.length===0)return Promise.resolve(c);let I=j.length;const U=()=>{I=-1;for(const K of j)K.cancel?.()};return new Promise((K,X)=>{for(const L of j)L.then(R=>{--I>=0&&k(R)?(U(),K(R)):I===0&&K(c)}).catch(R=>{--I>=0&&(U(),X(R))})})}t.firstParallel=h;class m{constructor(k){this._size=0,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new H.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(k){return this._size++,new Promise((c,I)=>{this.outstandingPromises.push({factory:k,c,e:I}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const c=k.factory();c.then(k.c,k.e),c.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=m;class z extends m{constructor(){super(1)}}t.Queue=z;class ${constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const k=new re;return this.drainers.add(k),k.p}isDrained(){for(const[,k]of this.queues)if(k.size>0)return!1;return!0}queueFor(k,c=C.extUri){const I=c.getComparisonKey(k);let U=this.queues.get(I);return U||(U=new z,H.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(I),this.onDidQueueDrain()}),this.queues.set(I,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const k of this.drainers)k.complete();this.drainers.clear()}dispose(){for(const[,k]of this.queues)k.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=$;class J{constructor(k,c){this._token=-1,typeof k=="function"&&typeof c=="number"&&this.setIfNotSet(k,c)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,c){this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},c)}setIfNotSet(k,c){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},c))}}t.TimeoutTimer=J;class Q{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(k,c){this.cancel(),this._token=setInterval(()=>{k()},c)}}t.IntervalTimer=Q;class ge{constructor(k,c){this.timeoutToken=-1,this.runner=k,this.timeout=c,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ge;class oe{constructor(k,c){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.runner=k,this.timeout=c,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(k=this.timeout){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(k/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=oe;class we extends ge{constructor(k,c){super(k,c),this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner?.(k)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=we;class he extends O.Disposable{constructor(k,c){super(),this.options=k,this.handler=c,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(k){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+k.length>this.options.maxBufferedWork)return!1}else if(this.pending+k.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...k),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ge(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=he,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=j=>{(0,w.setTimeout0)(()=>{if(k)return;const c=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,c-Date.now())}}))});let k=!1;return{dispose(){k||(k=!0)}}}:t.runWhenIdle=(j,k)=>{const c=requestIdleCallback(j,typeof k=="number"?{timeout:k}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(c))}}}}();class se{constructor(k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(c){this._error=c}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=se;async function _e(j,k,c){let I;for(let U=0;U<c;U++)try{return await j()}catch(K){I=K,await _(k)}throw I}t.retry=_e;class te{hasPending(k){return this._pending?typeof k=="number"?this._pending.taskId===k:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(k,c,I){return this._pending={taskId:k,cancel:()=>I?.(),promise:c},c.then(()=>this.donePending(k),()=>this.donePending(k)),c}donePending(k){this._pending&&k===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const k=this._next;this._next=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}setNext(k){if(this._next)this._next.run=k;else{let c,I;const U=new Promise((K,X)=>{c=K,I=X});this._next={run:k,promise:U,promiseResolve:c,promiseReject:I}}return this._next.promise}}t.TaskSequentializer=te;class De{constructor(k,c=()=>Date.now()){this.interval=k,this.nowFn=c,this.lastIncrementTime=0,this.value=0}increment(){const k=this.nowFn();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}t.IntervalCounter=De;class re{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((k,c)=>{this.completeCallback=k,this.errorCallback=c})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(k){return new Promise(c=>{this.completeCallback(k),this.resolved=!0,c()})}error(k){return new Promise(c=>{this.errorCallback(k),this.rejected=!0,c()})}cancel(){new Promise(k=>{this.errorCallback(new i.CancellationError),this.rejected=!0,k()})}}t.DeferredPromise=re;var ie;(function(j){async function k(I){let U;const K=await Promise.all(I.map(X=>X.then(L=>L,L=>{U||(U=L)})));if(typeof U<"u")throw U;return K}j.settled=k;function c(I){return new Promise(async(U,K)=>{try{await I(U,K)}catch(X){K(X)}})}j.withAsyncBody=c})(ie=t.Promises||(t.Promises={}));var ce;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ce||(ce={}));class ne{constructor(k){this._state=0,this._results=[],this._error=null,this._onStateChanged=new H.Emitter,queueMicrotask(async()=>{const c={emitOne:I=>this.emitOne(I),emitMany:I=>this.emitMany(I),reject:I=>this.reject(I)};try{await Promise.resolve(k(c)),this.resolve()}catch(I){this.reject(I)}finally{c.emitOne=void 0,c.emitMany=void 0,c.reject=void 0}})}static fromArray(k){return new ne(c=>{c.emitMany(k)})}static fromPromise(k){return new ne(async c=>{c.emitMany(await k)})}static fromPromises(k){return new ne(async c=>{await Promise.all(k.map(async I=>c.emitOne(await I)))})}static merge(k){return new ne(async c=>{await Promise.all(k.map(async I=>{for await(const U of I)c.emitOne(U)}))})}[Symbol.asyncIterator](){let k=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(k<this._results.length)return{done:!1,value:this._results[k++]};if(this._state===1)return{done:!0,value:void 0};await H.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(k,c){return new ne(async I=>{for await(const U of k)I.emitOne(c(U))})}map(k){return ne.map(this,k)}static filter(k,c){return new ne(async I=>{for await(const U of k)c(U)&&I.emitOne(U)})}filter(k){return ne.filter(this,k)}static coalesce(k){return ne.filter(k,c=>!!c)}coalesce(){return ne.coalesce(this)}static async toPromise(k){const c=[];for await(const I of k)c.push(I);return c}toPromise(){return ne.toPromise(this)}emitOne(k){this._state===0&&(this._results.push(k),this._onStateChanged.fire())}emitMany(k){this._state===0&&(this._results=this._results.concat(k),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(k){this._state===0&&(this._state=2,this._error=k,this._onStateChanged.fire())}}t.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class F extends ne{constructor(k,c){super(c),this._source=k}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=F;function V(j){const k=new y.CancellationTokenSource,c=j(k.token);return new F(k,async I=>{const U=k.token.onCancellationRequested(()=>{U.dispose(),k.dispose(),I.reject(new i.CancellationError)});try{for await(const K of c){if(k.token.isCancellationRequested)return;I.emitOne(K)}U.dispose(),k.dispose()}catch(K){U.dispose(),k.dispose(),I.reject(K)}})}t.createCancelableAsyncIterable=V}),define(me[4],pe([1,0,15,107,19,20,8,13,3,112,2,35,5,6,16]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function b(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=b;function D(Y){return Y?.isConnected??!1}t.isInDOM=D;class v{constructor(G,fe,Te,Fe){this._node=G,this._type=fe,this._handler=Te,this._options=Fe||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function E(Y,G,fe,Te){return new v(Y,G,fe,Te)}t.addDisposableListener=E;function a(Y){return function(G){return Y(new O.StandardMouseEvent(G))}}function l(Y){return function(G){return Y(new H.StandardKeyboardEvent(G))}}const p=function(G,fe,Te,Fe){let Ve=Te;return fe==="click"||fe==="mousedown"?Ve=a(Te):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(Ve=l(Te)),E(G,fe,Ve,Fe)};t.addStandardDisposableListener=p;const S=function(G,fe,Te){const Fe=a(fe);return _(G,Fe,Te)};t.addStandardDisposableGenericMouseDownListener=S;const T=function(G,fe,Te){const Fe=a(fe);return n(G,Fe,Te)};t.addStandardDisposableGenericMouseUpListener=T;function _(Y,G,fe){return E(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,fe)}t.addDisposableGenericMouseDownListener=_;function r(Y,G,fe){return E(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,fe)}t.addDisposableGenericMouseMoveListener=r;function n(Y,G,fe){return E(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,fe)}t.addDisposableGenericMouseUpListener=n;let u=null;function h(Y){if(!u){const G=fe=>setTimeout(()=>fe(new Date().getTime()),0);u=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||G}return u.call(self,Y)}class m{constructor(G,fe=0){this._runner=G,this.priority=fe,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,w.onUnexpectedError)(G)}}static sort(G,fe){return fe.priority-G.priority}}(function(){let Y=[],G=null,fe=!1,Te=!1;const Fe=()=>{for(fe=!1,G=Y,Y=[],Te=!0;G.length>0;)G.sort(m.sort),G.shift().execute();Te=!1};t.scheduleAtNextAnimationFrame=(Ve,ze=0)=>{const je=new m(Ve,ze);return Y.push(je),fe||(fe=!0,h(Fe)),je},t.runAtThisOrScheduleAtNextAnimationFrame=(Ve,ze)=>{if(Te){const je=new m(Ve,ze);return G.push(je),je}else return(0,t.scheduleAtNextAnimationFrame)(Ve,ze)}})();function z(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=z;function $(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=$;const J=8,Q=function(Y,G){return G};class ge extends f.Disposable{constructor(G,fe,Te,Fe=Q,Ve=J){super();let ze=null,je=0;const Je=this._register(new C.TimeoutTimer),ft=()=>{je=new Date().getTime(),Te(ze),ze=null};this._register(E(G,fe,It=>{ze=Fe(ze,It);const gt=new Date().getTime()-je;gt>=Ve?(Je.cancel(),ft()):Je.setIfNotSet(ft,Ve-gt)}))}}function oe(Y,G,fe,Te,Fe){return new ge(Y,G,fe,Te,Fe)}t.addDisposableThrottledListener=oe;function we(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=we;function he(Y){if(Y!==document.body)return new _e(Y.clientWidth,Y.clientHeight);if(o.isIOS&&window.visualViewport)return new _e(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new _e(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new _e(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new _e(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=he;class se{static convertToPixels(G,fe){return parseFloat(fe)||0}static getDimension(G,fe,Te){const Fe=we(G),Ve=Fe?Fe.getPropertyValue(fe):"0";return se.convertToPixels(G,Ve)}static getBorderLeftWidth(G){return se.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return se.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return se.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return se.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return se.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return se.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return se.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return se.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return se.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return se.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return se.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return se.getDimension(G,"margin-bottom","marginBottom")}}class _e{constructor(G,fe){this.width=G,this.height=fe}with(G=this.width,fe=this.height){return G!==this.width||fe!==this.height?new _e(G,fe):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof _e?G:new _e(G.width,G.height)}static equals(G,fe){return G===fe?!0:!G||!fe?!1:G.width===fe.width&&G.height===fe.height}}t.Dimension=_e,_e.None=new _e(0,0);function te(Y){let G=Y.offsetParent,fe=Y.offsetTop,Te=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){fe-=Y.scrollTop;const Fe=P(Y)?null:we(Y);Fe&&(Te-=Fe.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Te+=se.getBorderLeftWidth(Y),fe+=se.getBorderTopWidth(Y),fe+=Y.offsetTop,Te+=Y.offsetLeft,G=Y.offsetParent)}return{left:Te,top:fe}}t.getTopLeftOffset=te;function De(Y,G,fe){typeof G=="number"&&(Y.style.width=`${G}px`),typeof fe=="number"&&(Y.style.height=`${fe}px`)}t.size=De;function re(Y,G,fe,Te,Fe,Ve="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof fe=="number"&&(Y.style.right=`${fe}px`),typeof Te=="number"&&(Y.style.bottom=`${Te}px`),typeof Fe=="number"&&(Y.style.left=`${Fe}px`),Y.style.position=Ve}t.position=re;function ie(Y){const G=Y.getBoundingClientRect();return{left:G.left+window.scrollX,top:G.top+window.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=ie;function ce(Y){let G=Y,fe=1;do{const Te=we(G).zoom;Te!=null&&Te!=="1"&&(fe*=Te),G=G.parentElement}while(G!==null&&G!==document.documentElement);return fe}t.getDomNodeZoomLevel=ce;function ne(Y){const G=se.getMarginLeft(Y)+se.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=ne;function F(Y){const G=se.getBorderLeftWidth(Y)+se.getBorderRightWidth(Y),fe=se.getPaddingLeft(Y)+se.getPaddingRight(Y);return Y.offsetWidth-G-fe}t.getContentWidth=F;function V(Y){const G=se.getMarginLeft(Y)+se.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=V;function j(Y){const G=se.getBorderTopWidth(Y)+se.getBorderBottomWidth(Y),fe=se.getPaddingTop(Y)+se.getPaddingBottom(Y);return Y.offsetHeight-G-fe}t.getContentHeight=j;function k(Y){const G=se.getMarginTop(Y)+se.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=k;function c(Y,G){if(Y===null)return 0;const fe=te(Y),Te=te(G);return fe.left-Te.left}function I(Y,G){const fe=G.map(Fe=>Math.max(V(Fe),ne(Fe))+c(Fe,Y)||0);return Math.max(...fe)}t.getLargestChildWidth=I;function U(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=U;const K="parentFlowToElementId";function X(Y,G){Y.dataset[K]=G.id}t.setParentFlowTo=X;function L(Y){const G=Y.dataset[K];return typeof G=="string"?document.getElementById(G):null}function R(Y,G){let fe=Y;for(;fe;){if(fe===G)return!0;if(fe instanceof HTMLElement){const Te=L(fe);if(Te){fe=Te;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=R;function W(Y,G,fe){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(fe){if(typeof fe=="string"){if(Y.classList.contains(fe))return null}else if(Y===fe)return null}Y=Y.parentNode}return null}t.findParentWithClass=W;function A(Y,G,fe){return!!W(Y,G,fe)}t.hasParentWithClass=A;function P(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=P;function M(Y){return!!B(Y)}t.isInShadowDOM=M;function B(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return P(Y)?Y:null}t.getShadowRoot=B;function q(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=q;function ee(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=ee;function le(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=le;let de=null;function ye(){return de||(de=ee()),de}function Ee(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function Re(Y,G,fe=ye()){!fe||!G||fe.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=Re;function Le(Y,G=ye()){if(!G)return;const fe=Ee(G),Te=[];for(let Fe=0;Fe<fe.length;Fe++)fe[Fe].selectorText.indexOf(Y)!==-1&&Te.push(Fe);for(let Fe=Te.length-1;Fe>=0;Fe--)G.sheet.deleteRule(Te[Fe])}t.removeCSSRulesContainingSelector=Le;function ve(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=ve,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:y.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function Pe(Y){const G=[];for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)G[fe]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=Pe;function ke(Y,G){for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)Y.scrollTop!==G[fe]&&(Y.scrollTop=G[fe]),Y=Y.parentNode}t.restoreParentsScrollTop=ke;class qe extends f.Disposable{constructor(G){super(),this._onDidFocus=this._register(new g.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new g.Emitter),this.onDidBlur=this._onDidBlur.event;let fe=qe.hasFocusWithin(G),Te=!1;const Fe=()=>{Te=!1,fe||(fe=!0,this._onDidFocus.fire())},Ve=()=>{fe&&(Te=!0,window.setTimeout(()=>{Te&&(Te=!1,fe=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{qe.hasFocusWithin(G)!==fe&&(fe?Ve():Fe())},this._register(E(G,t.EventType.FOCUS,Fe,!0)),this._register(E(G,t.EventType.BLUR,Ve,!0)),this._register(E(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(E(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}static hasFocusWithin(G){const fe=B(G),Te=fe?fe.activeElement:document.activeElement;return U(Te,G)}refreshState(){this._refreshStateHandler()}}function He(Y){return new qe(Y)}t.trackFocus=He;function Ue(Y,G){return Y.after(G),G}t.after=Ue;function Ye(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=Ye;function it(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=it;function Oe(Y,...G){Y.innerText="",Ye(Y,...G)}t.reset=Oe;const xe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var x;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(x=t.Namespace||(t.Namespace={}));function ae(Y,G,fe,...Te){const Fe=xe.exec(G);if(!Fe)throw new Error("Bad use of emmet");fe={...fe||{}};const Ve=Fe[1]||"div";let ze;return Y!==x.HTML?ze=document.createElementNS(Y,Ve):ze=document.createElement(Ve),Fe[3]&&(ze.id=Fe[3]),Fe[4]&&(ze.className=Fe[4].replace(/\./g," ").trim()),Object.keys(fe).forEach(je=>{const Je=fe[je];typeof Je>"u"||(/^on\w+$/.test(je)?ze[je]=Je:je==="selected"?Je&&ze.setAttribute(je,"true"):ze.setAttribute(je,Je))}),ze.append(...Te),ze}function be(Y,G,...fe){return ae(x.HTML,Y,G,...fe)}t.$=be,be.SVG=function(Y,G,...fe){return ae(x.SVG,Y,G,...fe)};function Ce(Y,G){const fe=[];return Y.forEach((Te,Fe)=>{Fe>0&&(G instanceof Node?fe.push(G.cloneNode()):fe.push(document.createTextNode(G))),fe.push(Te)}),fe}t.join=Ce;function Ae(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=Ae;function Me(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=Me;function $e(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function Ge(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&$e(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ge;function et(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=et;function Ie(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=Ie;function ue(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=ue;function Se(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=Se;const Ne=780,We=640;function Xe(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-Ne/2),fe=Math.floor(window.screenTop+window.innerHeight/2-We/2);window.open(Y,"_blank",`width=${Ne},height=${We},top=${fe},left=${G}`)}t.windowOpenPopup=Xe;function Ze(Y,G=!0){const fe=window.open();return fe?(G&&(fe.opener=null),fe.location.href=Y,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(Y){const G=()=>{Y(),fe=(0,t.scheduleAtNextAnimationFrame)(G)};let fe=(0,t.scheduleAtNextAnimationFrame)(G);return(0,f.toDisposable)(()=>fe.dispose())}t.animate=Qe,N.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function st(Y){return Y?`url('${N.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=st;function ht(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=ht;function yt(Y,G){let fe;if(e.URI.isUri(Y))fe=Y.toString(!0);else{const Fe=new Blob([Y]);fe=URL.createObjectURL(Fe),setTimeout(()=>URL.revokeObjectURL(fe))}const Te=document.createElement("a");document.body.appendChild(Te),Te.download=G,Te.href=fe,Te.click(),setTimeout(()=>document.body.removeChild(Te))}t.triggerDownload=yt;function Ft(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,g.Event.once(g.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,s.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=Ft;var bt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(bt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function ci(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:bt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:bt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:bt.BROWSER,guess:!0}:null}t.detectFullscreen=ci;function zt(Y,G=!1){const fe=document.createElement("a");return d.addHook("afterSanitizeAttributes",Te=>{for(const Fe of["href","src"])if(Te.hasAttribute(Fe)){const Ve=Te.getAttribute(Fe);if(Fe==="href"&&Ve.startsWith("#"))continue;if(fe.href=Ve,!Y.includes(fe.protocol.replace(/:$/,""))){if(G&&Fe==="src"&&fe.href.startsWith("data:"))continue;Te.removeAttribute(Fe)}}}),(0,f.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=zt;const hi=[N.Schemas.http,N.Schemas.https,N.Schemas.command];function di(Y,G){const fe={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Te=zt(hi);try{const Fe=d.sanitize(G,{...fe,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Fe}finally{Te.dispose()}}t.safeInnerHtml=di;function fi(Y){const G=new Uint16Array(Y.length);for(let Fe=0;Fe<G.length;Fe++)G[Fe]=Y.charCodeAt(Fe);let fe="";const Te=new Uint8Array(G.buffer);for(let Fe=0;Fe<Te.length;Fe++)fe+=String.fromCharCode(Te[Fe]);return fe}function gi(Y){return btoa(fi(Y))}t.multibyteAwareBtoa=gi;class dt extends g.Emitter{constructor(){super(),this._subscriptions=new f.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(E(window,"keydown",G=>{if(G.defaultPrevented)return;const fe=new H.StandardKeyboardEvent(G);if(!(fe.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(fe.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(E(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(E(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(E(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.instance||(dt.instance=new dt),dt.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=dt;function mi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=mi;class pi extends f.Disposable{constructor(G,fe){super(),this.element=G,this.callbacks=fe,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(E(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(E(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(E(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(E(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(E(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=pi;function bi(Y,G){const fe=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Te=G.getBoundingClientRect(),Fe=Math.max(Te.top-fe.top,0),Ve=Math.max(fe.width-(fe.right-Te.right),0),ze=Math.max(fe.height-(fe.bottom-Te.bottom),0),je=Math.max(Te.left-fe.left,0);return{top:Fe,right:Ve,bottom:ze,left:je}}t.computeClippingRect=bi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(Y,...G){let fe,Te;Array.isArray(G[0])?(fe={},Te=G[0]):(fe=G[0]||{},Te=G[1]);const Fe=wi.exec(Y);if(!Fe||!Fe.groups)throw new Error("Bad use of h");const Ve=Fe.groups.tag||"div",ze=document.createElement(Ve);Fe.groups.id&&(ze.id=Fe.groups.id),Fe.groups.class&&(ze.className=Fe.groups.class.replace(/\./g," ").trim());const je={};if(Fe.groups.name&&(je[Fe.groups.name]=ze),Te)for(const Je of Te)Je instanceof HTMLElement?ze.appendChild(Je):typeof Je=="string"?ze.append(Je):(Object.assign(je,Je),ze.appendChild(Je.root));for(const[Je,ft]of Object.entries(fe))if(Je==="style")for(const[It,gt]of Object.entries(ft))ze.style.setProperty(Ut(It),typeof gt=="number"?gt+"px":""+gt);else Je==="tabIndex"?ze.tabIndex=ft:ze.setAttribute(Ut(Je),ft.toString());return je.root=ze,je}t.h=vi;function Ut(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],pe([1,0,4,2,105]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class O extends i.Disposable{constructor(g,d){super(),this._register((0,y.addDisposableListener)(g,"dragover",f=>{f.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{d(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this._register((0,y.addDisposableListener)(g,f,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=O,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:H.Mimes.text};function C(w,g,d){const f=document.createElement("div");f.className=d,f.textContent=g,w.dataTransfer&&(document.body.appendChild(f),w.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>document.body.removeChild(f),0))}t.applyDragImage=C}),define(me[52],pe([1,0,4]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,s={}){const e=O(s);return e.textContent=o,e}t.renderText=i;function H(o,s={}){const e=O(s);return g(e,d(o,!!s.renderCodeSegments),s.actionHandler,s.renderCodeSegments),e}t.renderFormattedText=H;function O(o){const s=o.inline?"span":"div",e=document.createElement(s);return o.className&&(e.className=o.className),e}t.createElement=O;class C{constructor(s){this.source=s,this.index=0}eos(){return this.index>=this.source.length}next(){const s=this.peek();return this.advance(),s}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(w||(w={}));function g(o,s,e,b){let D;if(s.type===2)D=document.createTextNode(s.content||"");else if(s.type===3)D=document.createElement("b");else if(s.type===4)D=document.createElement("i");else if(s.type===7&&b)D=document.createElement("code");else if(s.type===5&&e){const v=document.createElement("a");e.disposables.add(y.addStandardDisposableListener(v,"click",E=>{e.callback(String(s.index),E)})),D=v}else s.type===8?D=document.createElement("br"):s.type===1&&(D=o);D&&o!==D&&o.appendChild(D),D&&Array.isArray(s.children)&&s.children.forEach(v=>{g(D,v,e,b)})}function d(o,s){const e={type:1,children:[]};let b=0,D=e;const v=[],E=new C(o);for(;!E.eos();){let a=E.next();const l=a==="\\"&&N(E.peek(),s)!==0;if(l&&(a=E.next()),!l&&f(a,s)&&a===E.peek()){E.advance(),D.type===2&&(D=v.pop());const p=N(a,s);if(D.type===p||D.type===5&&p===6)D=v.pop();else{const S={type:p,children:[]};p===5&&(S.index=b,b++),D.children.push(S),v.push(D),D=S}}else if(a===`
`)D.type===2&&(D=v.pop()),D.children.push({type:8});else if(D.type!==2){const p={type:2,content:a};D.children.push(p),v.push(D),D=p}else D.content+=a}return D.type===2&&(D=v.pop()),v.length,e}function f(o,s){return N(o,s)!==0}function N(o,s){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return s?7:0;default:return 0}}}),define(me[53],pe([1,0,4,2]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class H{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(C,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const g=this._onStopCallback;this._onStopCallback=null,C&&g&&g(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(C,w,g,d,f){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=d,this._onStopCallback=f;let N=C;try{C.setPointerCapture(w),this._hooks.add((0,i.toDisposable)(()=>{C.releasePointerCapture(w)}))}catch{N=window}this._hooks.add(y.addDisposableListener(N,y.EventType.POINTER_MOVE,o=>{if(o.buttons!==g){this.stopMonitoring(!0);return}o.preventDefault(),this._pointerMoveCallback(o)})),this._hooks.add(y.addDisposableListener(N,y.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=H});var Ke=this&&this.__decorate||function(Z,t,y,i){var H=arguments.length,O=H<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,y):i,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Z,t,y,i);else for(var w=Z.length-1;w>=0;w--)(C=Z[w])&&(O=(H<3?C(O):H>3?C(t,y,O):C(t,y))||O);return H>3&&O&&Object.defineProperty(t,y,O),O};define(me[22],pe([1,0,4,14,25,2]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var C;(function(g){g.Tap="-monaco-gesturetap",g.Change="-monaco-gesturechange",g.Start="-monaco-gesturestart",g.End="-monaco-gesturesend",g.Contextmenu="-monaco-gesturecontextmenu"})(C=t.EventType||(t.EventType={}));class w extends O.Disposable{constructor(){super(),this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(y.addDisposableListener(document,"touchstart",d=>this.onTouchStart(d),{passive:!1})),this._register(y.addDisposableListener(document,"touchend",d=>this.onTouchEnd(d))),this._register(y.addDisposableListener(document,"touchmove",d=>this.onTouchMove(d),{passive:!1}))}static addTarget(d){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.targets.push(d),{dispose:()=>{w.INSTANCE.targets=w.INSTANCE.targets.filter(f=>f!==d)}}):O.Disposable.None}static ignoreTarget(d){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.ignoreTargets.push(d),{dispose:()=>{w.INSTANCE.ignoreTargets=w.INSTANCE.ignoreTargets.filter(f=>f!==d)}}):O.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(d){const f=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let N=0,o=d.targetTouches.length;N<o;N++){const s=d.targetTouches.item(N);this.activeTouches[s.identifier]={id:s.identifier,initialTarget:s.target,initialTimeStamp:f,initialPageX:s.pageX,initialPageY:s.pageY,rollingTimestamps:[f],rollingPageX:[s.pageX],rollingPageY:[s.pageY]};const e=this.newGestureEvent(C.Start,s.target);e.pageX=s.pageX,e.pageY=s.pageY,this.dispatchEvent(e)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}onTouchEnd(d){const f=Date.now(),N=Object.keys(this.activeTouches).length;for(let o=0,s=d.changedTouches.length;o<s;o++){const e=d.changedTouches.item(o);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const b=this.activeTouches[e.identifier],D=Date.now()-b.initialTimeStamp;if(D<w.HOLD_DELAY&&Math.abs(b.initialPageX-i.tail(b.rollingPageX))<30&&Math.abs(b.initialPageY-i.tail(b.rollingPageY))<30){const v=this.newGestureEvent(C.Tap,b.initialTarget);v.pageX=i.tail(b.rollingPageX),v.pageY=i.tail(b.rollingPageY),this.dispatchEvent(v)}else if(D>=w.HOLD_DELAY&&Math.abs(b.initialPageX-i.tail(b.rollingPageX))<30&&Math.abs(b.initialPageY-i.tail(b.rollingPageY))<30){const v=this.newGestureEvent(C.Contextmenu,b.initialTarget);v.pageX=i.tail(b.rollingPageX),v.pageY=i.tail(b.rollingPageY),this.dispatchEvent(v)}else if(N===1){const v=i.tail(b.rollingPageX),E=i.tail(b.rollingPageY),a=i.tail(b.rollingTimestamps)-b.rollingTimestamps[0],l=v-b.rollingPageX[0],p=E-b.rollingPageY[0],S=this.targets.filter(T=>b.initialTarget instanceof Node&&T.contains(b.initialTarget));this.inertia(S,f,Math.abs(l)/a,l>0?1:-1,v,Math.abs(p)/a,p>0?1:-1,E)}this.dispatchEvent(this.newGestureEvent(C.End,b.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(d,f){const N=document.createEvent("CustomEvent");return N.initEvent(d,!1,!0),N.initialTarget=f,N.tapCount=0,N}dispatchEvent(d){if(d.type===C.Tap){const f=new Date().getTime();let N=0;f-this._lastSetTapCountTime>w.CLEAR_TAP_COUNT_TIME?N=1:N=2,this._lastSetTapCountTime=f,d.tapCount=N}else(d.type===C.Change||d.type===C.Contextmenu)&&(this._lastSetTapCountTime=0);for(let f=0;f<this.ignoreTargets.length;f++)if(d.initialTarget instanceof Node&&this.ignoreTargets[f].contains(d.initialTarget))return;this.targets.forEach(f=>{d.initialTarget instanceof Node&&f.contains(d.initialTarget)&&(f.dispatchEvent(d),this.dispatched=!0)})}inertia(d,f,N,o,s,e,b,D){this.handle=y.scheduleAtNextAnimationFrame(()=>{const v=Date.now(),E=v-f;let a=0,l=0,p=!0;N+=w.SCROLL_FRICTION*E,e+=w.SCROLL_FRICTION*E,N>0&&(p=!1,a=o*N*E),e>0&&(p=!1,l=b*e*E);const S=this.newGestureEvent(C.Change);S.translationX=a,S.translationY=l,d.forEach(T=>T.dispatchEvent(S)),p||this.inertia(d,v,N,o,s+a,e,b,D+l)})}onTouchMove(d){const f=Date.now();for(let N=0,o=d.changedTouches.length;N<o;N++){const s=d.changedTouches.item(N);if(!this.activeTouches.hasOwnProperty(String(s.identifier))){console.warn("end of an UNKNOWN touch",s);continue}const e=this.activeTouches[s.identifier],b=this.newGestureEvent(C.Change,e.initialTarget);b.translationX=s.pageX-i.tail(e.rollingPageX),b.translationY=s.pageY-i.tail(e.rollingPageY),b.pageX=s.pageX,b.pageY=s.pageY,this.dispatchEvent(b),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(s.pageX),e.rollingPageY.push(s.pageY),e.rollingTimestamps.push(f)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}}w.SCROLL_FRICTION=-.005,w.HOLD_DELAY=700,w.CLEAR_TAP_COUNT_TIME=400,Ke([H.memoize],w,"isTouchDevice",null),t.Gesture=w}),define(me[54],pe([1,0,4,5,82]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const H=2e4;let O,C,w,g,d;function f(e){O=document.createElement("div"),O.className="monaco-aria-container";const b=()=>{const v=document.createElement("div");return v.className="monaco-alert",v.setAttribute("role","alert"),v.setAttribute("aria-atomic","true"),O.appendChild(v),v};C=b(),w=b();const D=()=>{const v=document.createElement("div");return v.className="monaco-status",v.setAttribute("role","complementary"),v.setAttribute("aria-live","polite"),v.setAttribute("aria-atomic","true"),O.appendChild(v),v};g=D(),d=D(),e.appendChild(O)}t.setARIAContainer=f;function N(e){!O||(C.textContent!==e?(y.clearNode(w),s(C,e)):(y.clearNode(C),s(w,e)))}t.alert=N;function o(e){!O||(i.isMacintosh?N(e):g.textContent!==e?(y.clearNode(d),s(g,e)):(y.clearNode(g),s(d,e)))}t.status=o;function s(e,b){y.clearNode(e),b.length>H&&(b=b.substr(0,H)),e.textContent=b,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[113],pe([1,0,4,11]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const H=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function O(w){const g=new Array;let d,f=0,N=0;for(;(d=H.exec(w))!==null;){N=d.index||0,g.push(w.substring(f,N)),f=(d.index||0)+d[0].length;const[,o,s]=d;g.push(o?`$(${s})`:C({id:s}))}return f<w.length&&g.push(w.substring(f)),g}t.renderLabelWithIcons=O;function C(w){const g=y.$("span");return g.classList.add(...i.CSSIcon.asClassNameArray(w)),g}t.renderIcon=C}),define(me[114],pe([1,0,4]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(O){try{O.parentElement?.removeChild(O)}catch{}}class H{constructor(C){this.renderers=C,this.cache=new Map}alloc(C){let w=this.getTemplateCache(C).pop();if(!w){const g=(0,y.$)(".monaco-list-row"),f=this.getRenderer(C).renderTemplate(g);w={domNode:g,templateId:C,templateData:f}}return w}release(C){!C||this.releaseRow(C)}releaseRow(C){const{domNode:w,templateId:g}=C;w&&(w.classList.remove("scrolling"),i(w)),this.getTemplateCache(g).push(C)}getTemplateCache(C){let w=this.cache.get(C);return w||(w=[],this.cache.set(C,w)),w}dispose(){this.cache.forEach((C,w)=>{for(const g of C)this.getRenderer(w).disposeTemplate(g.templateData),g.templateData=null}),this.cache.clear()}getRenderer(C){const w=this.renderers.get(C);if(!w)throw new Error(`No renderer found for ${C}`);return w}}t.RowCache=H}),define(me[115],pe([1,0,8,2]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class H extends i.Disposable{constructor(C,w,g){super(),this._visibility=C,this._visibleClassName=w,this._invisibleClassName=g,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new y.TimeoutTimer)}setVisibility(C){this._visibility!==C&&(this._visibility=C,this._updateShouldBeVisible())}setShouldBeVisible(C){this._rawShouldBeVisible=C,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const C=this._applyVisibilitySetting();this._shouldBeVisible!==C&&(this._shouldBeVisible=C,this.ensureVisibility())}setIsNeeded(C){this._isNeeded!==C&&(this._isNeeded=C,this.ensureVisibility())}setDomNode(C){this._domNode=C,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(C){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(C?" fade":"")))}}t.ScrollbarVisibilityController=H}),define(me[116],pe([1,0,4,22,14,3,2,5]),function(Z,t,y,i,H,O,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class g extends C.Disposable{constructor(f,N,o,s){super(),this.selected=0,this.selectBoxOptions=s||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new O.Emitter),this.styles=o,this.registerListeners(),this.setOptions(f,N)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(f=>{this._register(y.addDisposableListener(this.selectElement,f,N=>{this.selectElement.focus()}))}),this._register(y.addStandardDisposableListener(this.selectElement,"click",f=>{y.EventHelper.stop(f,!0)})),this._register(y.addStandardDisposableListener(this.selectElement,"change",f=>{this.selectElement.title=f.target.value,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value})})),this._register(y.addStandardDisposableListener(this.selectElement,"keydown",f=>{let N=!1;w.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(N=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(N=!0),N&&f.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(f,N){(!this.options||!H.equals(this.options,f))&&(this.options=f,this.selectElement.options.length=0,this.options.forEach((o,s)=>{this.selectElement.add(this.createOption(o.text,s,o.isDisabled))})),N!==void 0&&this.select(N)}select(f){this.options.length===0?this.selected=0:f>=0&&f<this.options.length?this.selected=f:f>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(f){this.selectBoxOptions.ariaLabel=f,this.selectElement.setAttribute("aria-label",f)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(f){this.selectElement.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(f){this.styles=f,this.applyStyles()}applyStyles(){if(this.selectElement){const f=this.styles.selectBackground?this.styles.selectBackground.toString():"",N=this.styles.selectForeground?this.styles.selectForeground.toString():"",o=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=f,this.selectElement.style.color=N,this.selectElement.style.borderColor=o}}createOption(f,N,o){const s=document.createElement("option");return s.value=f,s.text=f,s.disabled=!!o,s}}t.SelectBoxNative=g}),define(me[55],pe([1,0,23,14,8,111,3,26]),function(Z,t,y,i,H,O,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function g(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=g;function d(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=d;function f(o){return typeof o.collapsible=="boolean"}class N{constructor(s,e,b,D={}){this.user=s,this.list=e,this.rootRef=[],this.eventBufferer=new C.EventBufferer,this._onDidChangeCollapseState=new C.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new C.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new C.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new H.Delayer(H.MicrotaskDelay),this.collapseByDefault=typeof D.collapseByDefault>"u"?!1:D.collapseByDefault,this.filter=D.filter,this.autoExpandSingleChildren=typeof D.autoExpandSingleChildren>"u"?!1:D.autoExpandSingleChildren,this.root={parent:void 0,element:b,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(s,e,b=w.Iterable.empty(),D={}){if(s.length===0)throw new y.TreeError(this.user,"Invalid tree location");D.diffIdentityProvider?this.spliceSmart(D.diffIdentityProvider,s,e,b,D):this.spliceSimple(s,e,b,D)}spliceSmart(s,e,b,D=w.Iterable.empty(),v,E=v.diffDepth??0){const{parentNode:a}=this.getParentNodeWithListIndex(e);if(!a.lastDiffIds)return this.spliceSimple(e,b,D,v);const l=[...D],p=e[e.length-1],S=new O.LcsDiff({getElements:()=>a.lastDiffIds},{getElements:()=>[...a.children.slice(0,p),...l,...a.children.slice(p+b)].map(u=>s.getId(u.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return a.lastDiffIds=void 0,this.spliceSimple(e,b,l,v);const T=e.slice(0,-1),_=(u,h,m)=>{if(E>0)for(let z=0;z<m;z++)u--,h--,this.spliceSmart(s,[...T,u,0],Number.MAX_SAFE_INTEGER,l[h].children,v,E-1)};let r=Math.min(a.children.length,p+b),n=l.length;for(const u of S.changes.sort((h,m)=>m.originalStart-h.originalStart))_(r,n,r-(u.originalStart+u.originalLength)),r=u.originalStart,n=u.modifiedStart-p,this.spliceSimple([...T,r],u.originalLength,w.Iterable.slice(l,n,n+u.modifiedLength),v);_(r,n,r)}spliceSimple(s,e,b=w.Iterable.empty(),{onDidCreateNode:D,onDidDeleteNode:v,diffIdentityProvider:E}){const{parentNode:a,listIndex:l,revealed:p,visible:S}=this.getParentNodeWithListIndex(s),T=[],_=w.Iterable.map(b,oe=>this.createTreeNode(oe,a,a.visible?1:0,p,T,D)),r=s[s.length-1],n=a.children.length>0;let u=0;for(let oe=r;oe>=0&&oe<a.children.length;oe--){const we=a.children[oe];if(we.visible){u=we.visibleChildIndex;break}}const h=[];let m=0,z=0;for(const oe of _)h.push(oe),z+=oe.renderNodeCount,oe.visible&&(oe.visibleChildIndex=u+m++);const $=(0,i.splice)(a.children,r,e,h);E?a.lastDiffIds?(0,i.splice)(a.lastDiffIds,r,e,h.map(oe=>E.getId(oe.element).toString())):a.lastDiffIds=a.children.map(oe=>E.getId(oe.element).toString()):a.lastDiffIds=void 0;let J=0;for(const oe of $)oe.visible&&J++;if(J!==0)for(let oe=r+h.length;oe<a.children.length;oe++){const we=a.children[oe];we.visible&&(we.visibleChildIndex-=J)}if(a.visibleChildrenCount+=m-J,p&&S){const oe=$.reduce((we,he)=>we+(he.visible?he.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(a,z-oe),this.list.splice(l,oe,T)}if($.length>0&&v){const oe=we=>{v(we),we.children.forEach(oe)};$.forEach(oe)}this._onDidSplice.fire({insertedNodes:h,deletedNodes:$});const Q=a.children.length>0;n!==Q&&this.setCollapsible(s.slice(0,-1),Q);let ge=a;for(;ge;){if(ge.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(s){if(s.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:b,revealed:D}=this.getTreeNodeWithListIndex(s);e.visible&&D&&this.list.splice(b,1,[e])}updateElementHeight(s,e){if(s.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{listIndex:b}=this.getTreeNodeWithListIndex(s);this.list.updateElementHeight(b,e)}has(s){return this.hasTreeNode(s)}getListIndex(s){const{listIndex:e,visible:b,revealed:D}=this.getTreeNodeWithListIndex(s);return b&&D?e:-1}getListRenderCount(s){return this.getTreeNode(s).renderNodeCount}isCollapsible(s){return this.getTreeNode(s).collapsible}setCollapsible(s,e){const b=this.getTreeNode(s);typeof e>"u"&&(e=!b.collapsible);const D={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,D))}isCollapsed(s){return this.getTreeNode(s).collapsed}setCollapsed(s,e,b){const D=this.getTreeNode(s);typeof e>"u"&&(e=!D.collapsed);const v={collapsed:e,recursive:b||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,v))}_setCollapseState(s,e){const{node:b,listIndex:D,revealed:v}=this.getTreeNodeWithListIndex(s),E=this._setListNodeCollapseState(b,D,v,e);if(b!==this.root&&this.autoExpandSingleChildren&&E&&!f(e)&&b.collapsible&&!b.collapsed&&!e.recursive){let a=-1;for(let l=0;l<b.children.length;l++)if(b.children[l].visible)if(a>-1){a=-1;break}else a=l;a>-1&&this._setCollapseState([...s,a],e)}return E}_setListNodeCollapseState(s,e,b,D){const v=this._setNodeCollapseState(s,D,!1);if(!b||!s.visible||!v)return v;const E=s.renderNodeCount,a=this.updateNodeAfterCollapseChange(s),l=E-(e===-1?0:1);return this.list.splice(e+1,l,a.slice(1)),v}_setNodeCollapseState(s,e,b){let D;if(s===this.root?D=!1:(f(e)?(D=s.collapsible!==e.collapsible,s.collapsible=e.collapsible):s.collapsible?(D=s.collapsed!==e.collapsed,s.collapsed=e.collapsed):D=!1,D&&this._onDidChangeCollapseState.fire({node:s,deep:b})),!f(e)&&e.recursive)for(const v of s.children)D=this._setNodeCollapseState(v,e,!0)||D;return D}expandTo(s){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(s);for(;e.parent;)e=e.parent,s=s.slice(0,s.length-1),e.collapsed&&this._setCollapseState(s,{collapsed:!1,recursive:!1})})}refilter(){const s=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,s,e),this.refilterDelayer.cancel()}createTreeNode(s,e,b,D,v,E){const a={parent:e,element:s.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof s.collapsible=="boolean"?s.collapsible:typeof s.collapsed<"u",collapsed:typeof s.collapsed>"u"?this.collapseByDefault:s.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},l=this._filterNode(a,b);a.visibility=l,D&&v.push(a);const p=s.children||w.Iterable.empty(),S=D&&l!==0&&!a.collapsed,T=w.Iterable.map(p,n=>this.createTreeNode(n,a,l,S,v,E));let _=0,r=1;for(const n of T)a.children.push(n),r+=n.renderNodeCount,n.visible&&(n.visibleChildIndex=_++);return a.collapsible=a.collapsible||a.children.length>0,a.visibleChildrenCount=_,a.visible=l===2?_>0:l===1,a.visible?a.collapsed||(a.renderNodeCount=r):(a.renderNodeCount=0,D&&v.pop()),E?.(a),a}updateNodeAfterCollapseChange(s){const e=s.renderNodeCount,b=[];return this._updateNodeAfterCollapseChange(s,b),this._updateAncestorsRenderNodeCount(s.parent,b.length-e),b}_updateNodeAfterCollapseChange(s,e){if(s.visible===!1)return 0;if(e.push(s),s.renderNodeCount=1,!s.collapsed)for(const b of s.children)s.renderNodeCount+=this._updateNodeAfterCollapseChange(b,e);return this._onDidChangeRenderNodeCount.fire(s),s.renderNodeCount}updateNodeAfterFilterChange(s){const e=s.renderNodeCount,b=[];return this._updateNodeAfterFilterChange(s,s.visible?1:0,b),this._updateAncestorsRenderNodeCount(s.parent,b.length-e),b}_updateNodeAfterFilterChange(s,e,b,D=!0){let v;if(s!==this.root){if(v=this._filterNode(s,e),v===0)return s.visible=!1,s.renderNodeCount=0,!1;D&&b.push(s)}const E=b.length;s.renderNodeCount=s===this.root?0:1;let a=!1;if(!s.collapsed||v!==0){let l=0;for(const p of s.children)a=this._updateNodeAfterFilterChange(p,v,b,D&&!s.collapsed)||a,p.visible&&(p.visibleChildIndex=l++);s.visibleChildrenCount=l}else s.visibleChildrenCount=0;return s!==this.root&&(s.visible=v===2?a:v===1,s.visibility=v),s.visible?s.collapsed||(s.renderNodeCount+=b.length-E):(s.renderNodeCount=0,D&&b.pop()),this._onDidChangeRenderNodeCount.fire(s),s.visible}_updateAncestorsRenderNodeCount(s,e){if(e!==0)for(;s;)s.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(s),s=s.parent}_filterNode(s,e){const b=this.filter?this.filter.filter(s.element,e):1;return typeof b=="boolean"?(s.filterData=void 0,b?1:0):g(b)?(s.filterData=b.data,d(b.visibility)):(s.filterData=void 0,d(b))}hasTreeNode(s,e=this.root){if(!s||s.length===0)return!0;const[b,...D]=s;return b<0||b>e.children.length?!1:this.hasTreeNode(D,e.children[b])}getTreeNode(s,e=this.root){if(!s||s.length===0)return e;const[b,...D]=s;if(b<0||b>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");return this.getTreeNode(D,e.children[b])}getTreeNodeWithListIndex(s){if(s.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:b,revealed:D,visible:v}=this.getParentNodeWithListIndex(s),E=s[s.length-1];if(E<0||E>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");const a=e.children[E];return{node:a,listIndex:b,revealed:D,visible:v&&a.visible}}getParentNodeWithListIndex(s,e=this.root,b=0,D=!0,v=!0){const[E,...a]=s;if(E<0||E>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");for(let l=0;l<E;l++)b+=e.children[l].renderNodeCount;return D=D&&!e.collapsed,v=v&&e.visible,a.length===0?{parentNode:e,listIndex:b,revealed:D,visible:v}:this.getParentNodeWithListIndex(a,e.children[E],b+1,D,v)}getNode(s=[]){return this.getTreeNode(s)}getNodeLocation(s){const e=[];let b=s;for(;b.parent;)e.push(b.parent.children.indexOf(b)),b=b.parent;return e.reverse()}getParentNodeLocation(s){if(s.length!==0)return s.length===1?[]:(0,i.tail2)(s)[0]}getFirstElementChild(s){const e=this.getTreeNode(s);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(s=[]){const e=this.getTreeNode(s);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(s){return s.children.length===0?s.element:this._getLastElementAncestor(s.children[s.children.length-1])}}t.IndexTreeModel=N}),define(me[117],pe([1,0,55,23,26]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class O{constructor(w,g,d={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new y.IndexTreeModel(w,g,null,d),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,d.sorter&&(this.sorter={compare(f,N){return d.sorter.compare(f.element,N.element)}}),this.identityProvider=d.identityProvider}get size(){return this.nodes.size}setChildren(w,g=H.Iterable.empty(),d={}){const f=this.getElementLocation(w);this._setChildren(f,this.preserveCollapseState(g),d)}_setChildren(w,g=H.Iterable.empty(),d){const f=new Set,N=new Set,o=e=>{if(e.element===null)return;const b=e;if(f.add(b.element),this.nodes.set(b.element,b),this.identityProvider){const D=this.identityProvider.getId(b.element).toString();N.add(D),this.nodesByIdentity.set(D,b)}d.onDidCreateNode?.(b)},s=e=>{if(e.element===null)return;const b=e;if(f.has(b.element)||this.nodes.delete(b.element),this.identityProvider){const D=this.identityProvider.getId(b.element).toString();N.has(D)||this.nodesByIdentity.delete(D)}d.onDidDeleteNode?.(b)};this.model.splice([...w,0],Number.MAX_VALUE,g,{...d,onDidCreateNode:o,onDidDeleteNode:s})}preserveCollapseState(w=H.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),H.Iterable.map(w,g=>{let d=this.nodes.get(g.element);if(!d&&this.identityProvider){const o=this.identityProvider.getId(g.element).toString();d=this.nodesByIdentity.get(o)}if(!d)return{...g,children:this.preserveCollapseState(g.children)};const f=typeof g.collapsible=="boolean"?g.collapsible:d.collapsible,N=typeof g.collapsed<"u"?g.collapsed:d.collapsed;return{...g,collapsible:f,collapsed:N,children:this.preserveCollapseState(g.children)}})}rerender(w){const g=this.getElementLocation(w);this.model.rerender(g)}updateElementHeight(w,g){const d=this.getElementLocation(w);this.model.updateElementHeight(d,g)}resort(w=null,g=!0){if(!this.sorter)return;const d=this.getElementLocation(w),f=this.model.getNode(d);this._setChildren(d,this.resortChildren(f,g),{})}resortChildren(w,g,d=!0){let f=[...w.children];return(g||d)&&(f=f.sort(this.sorter.compare.bind(this.sorter))),H.Iterable.map(f,N=>({element:N.element,collapsible:N.collapsible,collapsed:N.collapsed,children:this.resortChildren(N,g,!1)}))}getFirstElementChild(w=null){const g=this.getElementLocation(w);return this.model.getFirstElementChild(g)}getLastElementAncestor(w=null){const g=this.getElementLocation(w);return this.model.getLastElementAncestor(g)}has(w){return this.nodes.has(w)}getListIndex(w){const g=this.getElementLocation(w);return this.model.getListIndex(g)}getListRenderCount(w){const g=this.getElementLocation(w);return this.model.getListRenderCount(g)}isCollapsible(w){const g=this.getElementLocation(w);return this.model.isCollapsible(g)}setCollapsible(w,g){const d=this.getElementLocation(w);return this.model.setCollapsible(d,g)}isCollapsed(w){const g=this.getElementLocation(w);return this.model.isCollapsed(g)}setCollapsed(w,g,d){const f=this.getElementLocation(w);return this.model.setCollapsed(f,g,d)}expandTo(w){const g=this.getElementLocation(w);this.model.expandTo(g)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const g=this.nodes.get(w);if(!g)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return g}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const g=this.nodes.get(w);if(!g)throw new i.TreeError(this.user,`Tree element not found: ${w}`);const d=this.model.getNodeLocation(g),f=this.model.getParentNodeLocation(d);return this.model.getNode(f).element}getElementLocation(w){if(w===null)return[];const g=this.nodes.get(w);if(!g)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(g)}}t.ObjectTreeModel=O}),define(me[17],pe([1,0,4,19,20,22,2]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends C.Disposable{onclick(d,f){this._register(y.addDisposableListener(d,y.EventType.CLICK,N=>f(new H.StandardMouseEvent(N))))}onmousedown(d,f){this._register(y.addDisposableListener(d,y.EventType.MOUSE_DOWN,N=>f(new H.StandardMouseEvent(N))))}onmouseover(d,f){this._register(y.addDisposableListener(d,y.EventType.MOUSE_OVER,N=>f(new H.StandardMouseEvent(N))))}onmouseleave(d,f){this._register(y.addDisposableListener(d,y.EventType.MOUSE_LEAVE,N=>f(new H.StandardMouseEvent(N))))}onkeydown(d,f){this._register(y.addDisposableListener(d,y.EventType.KEY_DOWN,N=>f(new i.StandardKeyboardEvent(N))))}onkeyup(d,f){this._register(y.addDisposableListener(d,y.EventType.KEY_UP,N=>f(new i.StandardKeyboardEvent(N))))}oninput(d,f){this._register(y.addDisposableListener(d,y.EventType.INPUT,f))}onblur(d,f){this._register(y.addDisposableListener(d,y.EventType.BLUR,f))}onfocus(d,f){this._register(y.addDisposableListener(d,y.EventType.FOCUS,f))}onchange(d,f){this._register(y.addDisposableListener(d,y.EventType.CHANGE,f))}ignoreGesture(d){O.Gesture.ignoreTarget(d)}}t.Widget=w}),define(me[37],pe([1,0,53,17,8,4]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class C extends i.Widget{constructor(g){super(),this._onActivate=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...g.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this._pointerMoveMonitor=this._register(new y.GlobalPointerMoveMonitor),this._register(O.addStandardDisposableListener(this.bgDomNode,O.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._register(O.addStandardDisposableListener(this.domNode,O.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._pointerdownRepeatTimer=this._register(new H.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new H.TimeoutTimer)}_arrowPointerDown(g){if(!g.target||!(g.target instanceof Element))return;const d=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(d,200),this._pointerMoveMonitor.startMonitoring(g.target,g.pointerId,g.buttons,f=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),g.preventDefault()}}t.ScrollbarArrow=C}),define(me[56],pe([1,0,4,40,53,37,115,17,5]),function(Z,t,y,i,H,O,C,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const d=140;class f extends w.Widget{constructor(o){super(),this._lazyRender=o.lazyRender,this._host=o.host,this._scrollable=o.scrollable,this._scrollByPage=o.scrollByPage,this._scrollbarState=o.scrollbarState,this._visibilityController=this._register(new C.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new H.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(y.addDisposableListener(this.domNode.domNode,y.EventType.POINTER_DOWN,s=>this._domNodePointerDown(s)))}_createArrow(o){const s=this._register(new O.ScrollbarArrow(o));this.domNode.domNode.appendChild(s.bgDomNode),this.domNode.domNode.appendChild(s.domNode)}_createSlider(o,s,e,b){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(s),typeof e=="number"&&this.slider.setWidth(e),typeof b=="number"&&this.slider.setHeight(b),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(y.addDisposableListener(this.slider.domNode,y.EventType.POINTER_DOWN,D=>{D.button===0&&(D.preventDefault(),this._sliderPointerDown(D))})),this.onclick(this.slider.domNode,D=>{D.leftButton&&D.stopPropagation()})}_onElementSize(o){return this._scrollbarState.setVisibleSize(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(o){return this._scrollbarState.setScrollSize(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(o){return this._scrollbarState.setScrollPosition(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(o){o.target===this.domNode.domNode&&this._onPointerDown(o)}delegatePointerDown(o){const s=this.domNode.domNode.getClientRects()[0].top,e=s+this._scrollbarState.getSliderPosition(),b=s+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),D=this._sliderPointerPosition(o);e<=D&&D<=b?o.button===0&&(o.preventDefault(),this._sliderPointerDown(o)):this._onPointerDown(o)}_onPointerDown(o){let s,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")s=o.offsetX,e=o.offsetY;else{const D=y.getDomNodePagePosition(this.domNode.domNode);s=o.pageX-D.left,e=o.pageY-D.top}const b=this._pointerDownRelativePosition(s,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(b):this._scrollbarState.getDesiredScrollPositionFromOffset(b)),o.button===0&&(o.preventDefault(),this._sliderPointerDown(o))}_sliderPointerDown(o){if(!o.target||!(o.target instanceof Element))return;const s=this._sliderPointerPosition(o),e=this._sliderOrthogonalPointerPosition(o),b=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(o.target,o.pointerId,o.buttons,D=>{const v=this._sliderOrthogonalPointerPosition(D),E=Math.abs(v-e);if(g.isWindows&&E>d){this._setDesiredScrollPositionNow(b.getScrollPosition());return}const l=this._sliderPointerPosition(D)-s;this._setDesiredScrollPositionNow(b.getDesiredScrollPositionFromDelta(l))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(o){const s={};this.writeScrollPosition(s,o),this._scrollable.setScrollPositionNow(s)}updateScrollbarSize(o){this._updateScrollbarSize(o),this._scrollbarState.setScrollbarSize(o),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=f}),define(me[118],pe([1,0,20,56,37,41,11]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(d,f,N){const o=d.getScrollDimensions(),s=d.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:N,scrollbarState:new O.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,o.width,o.scrollWidth,s.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:d,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-H.ARROW_IMG_SIZE)/2,b=(f.horizontalScrollbarSize-H.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonLeft,top:b,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonRight,top:b,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}_updateSlider(d,f){this.slider.setWidth(d),this.slider.setLeft(f)}_renderDomNode(d,f){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(d){return this._shouldRender=this._onElementScrollSize(d.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(d.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(d.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(d,f){return d}_sliderPointerPosition(d){return d.pageX}_sliderOrthogonalPointerPosition(d){return d.pageY}_updateScrollbarSize(d){this.slider.setHeight(d)}writeScrollPosition(d,f){d.scrollLeft=f}updateOptions(d){this.updateScrollbarSize(d.horizontal===2?0:d.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this._visibilityController.setVisibility(d.horizontal),this._scrollByPage=d.scrollByPage}}t.HorizontalScrollbar=w}),define(me[119],pe([1,0,20,56,37,41,11]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(d,f,N){const o=d.getScrollDimensions(),s=d.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:N,scrollbarState:new O.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,o.height,o.scrollHeight,s.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:d,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-H.ARROW_IMG_SIZE)/2,b=(f.verticalScrollbarSize-H.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonUp,top:e,left:b,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonDown,top:void 0,left:b,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}_updateSlider(d,f){this.slider.setHeight(d),this.slider.setTop(f)}_renderDomNode(d,f){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(d){return this._shouldRender=this._onElementScrollSize(d.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(d.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(d.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(d,f){return f}_sliderPointerPosition(d){return d.pageY}_sliderOrthogonalPointerPosition(d){return d.pageX}_updateScrollbarSize(d){this.slider.setWidth(d)}writeScrollPosition(d,f){d.scrollTop=f}updateOptions(d){this.updateScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(d.vertical),this._scrollByPage=d.scrollByPage}}t.VerticalScrollbar=w}),define(me[57],pe([1,0,15,4,40,20,118,119,17,8,3,2,5,48,89]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,b=50,D=!0;class v{constructor(r,n,u){this.timestamp=r,this.deltaX=n,this.deltaY=u,this.score=0}}class E{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let r=1,n=0,u=1,h=this._rear;do{const m=h===this._front?r:Math.pow(2,-u);if(r-=m,n+=this._memory[h].score*m,h===this._front)break;h=(this._capacity+h-1)%this._capacity,u++}while(!0);return n<=.5}accept(r,n,u){const h=new v(r,n,u);h.score=this._computeScore(h),this._front===-1&&this._rear===-1?(this._memory[0]=h,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=h)}_computeScore(r){if(Math.abs(r.deltaX)>0&&Math.abs(r.deltaY)>0)return 1;let n=.5;const u=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(r.deltaX)||!this._isAlmostInt(r.deltaY))&&(n+=.25),Math.min(Math.max(n,0),1)}_isAlmostInt(r){return Math.abs(Math.round(r)-r)<.01}}t.MouseWheelClassifier=E,E.INSTANCE=new E;class a extends g.Widget{constructor(r,n,u){super(),this._onScroll=this._register(new f.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new f.Emitter),this.onWillScroll=this._onWillScroll.event,r.style.overflow="hidden",this._options=T(n),this._scrollable=u,this._register(this._scrollable.onScroll(m=>{this._onWillScroll.fire(m),this._onDidScroll(m),this._onScroll.fire(m)}));const h={onMouseWheel:m=>this._onMouseWheel(m),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,h)),this._horizontalScrollbar=this._register(new C.HorizontalScrollbar(this._scrollable,this._options,h)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(r),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,H.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,H.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,H.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,m=>this._onMouseOver(m)),this.onmouseleave(this._listenOnDomNode,m=>this._onMouseLeave(m)),this._hideTimeout=this._register(new d.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}get options(){return this._options}dispose(){this._mouseWheelToDispose=(0,N.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(r){this._verticalScrollbar.delegatePointerDown(r)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(r){this._scrollable.setScrollDimensions(r,!1)}updateClassName(r){this._options.className=r,o.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(r){typeof r.handleMouseWheel<"u"&&(this._options.handleMouseWheel=r.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof r.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=r.mouseWheelScrollSensitivity),typeof r.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=r.fastScrollSensitivity),typeof r.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=r.scrollPredominantAxis),typeof r.horizontal<"u"&&(this._options.horizontal=r.horizontal),typeof r.vertical<"u"&&(this._options.vertical=r.vertical),typeof r.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=r.horizontalScrollbarSize),typeof r.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=r.verticalScrollbarSize),typeof r.scrollByPage<"u"&&(this._options.scrollByPage=r.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(r){this._revealOnScroll=r}triggerScrollFromMouseWheelEvent(r){this._onMouseWheel(new O.StandardWheelEvent(r))}_setListeningToMouseWheel(r){if(this._mouseWheelToDispose.length>0!==r&&(this._mouseWheelToDispose=(0,N.dispose)(this._mouseWheelToDispose),r)){const u=h=>{this._onMouseWheel(new O.StandardWheelEvent(h))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,u,{passive:!1}))}}_onMouseWheel(r){const n=E.INSTANCE;if(D){const m=window.devicePixelRatio/(0,y.getZoomFactor)();o.isWindows||o.isLinux?n.accept(Date.now(),r.deltaX/m,r.deltaY/m):n.accept(Date.now(),r.deltaX,r.deltaY)}let u=!1;if(r.deltaY||r.deltaX){let m=r.deltaY*this._options.mouseWheelScrollSensitivity,z=r.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(m)>=Math.abs(z)?z=0:m=0),this._options.flipAxes&&([m,z]=[z,m]);const $=!o.isMacintosh&&r.browserEvent&&r.browserEvent.shiftKey;(this._options.scrollYToX||$)&&!z&&(z=m,m=0),r.browserEvent&&r.browserEvent.altKey&&(z=z*this._options.fastScrollSensitivity,m=m*this._options.fastScrollSensitivity);const J=this._scrollable.getFutureScrollPosition();let Q={};if(m){const ge=b*m,oe=J.scrollTop-(ge<0?Math.floor(ge):Math.ceil(ge));this._verticalScrollbar.writeScrollPosition(Q,oe)}if(z){const ge=b*z,oe=J.scrollLeft-(ge<0?Math.floor(ge):Math.ceil(ge));this._horizontalScrollbar.writeScrollPosition(Q,oe)}Q=this._scrollable.validateScrollPosition(Q),(J.scrollLeft!==Q.scrollLeft||J.scrollTop!==Q.scrollTop)&&(D&&this._options.mouseWheelSmoothScroll&&n.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(Q):this._scrollable.setScrollPositionNow(Q),u=!0)}let h=u;!h&&this._options.alwaysConsumeMouseWheel&&(h=!0),!h&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(h=!0),h&&(r.preventDefault(),r.stopPropagation())}_onDidScroll(r){this._shouldRender=this._horizontalScrollbar.onDidScroll(r)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(r)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const r=this._scrollable.getCurrentScrollPosition(),n=r.scrollTop>0,u=r.scrollLeft>0,h=u?" left":"",m=n?" top":"",z=u||n?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${h}`),this._topShadowDomNode.setClassName(`shadow${m}`),this._topLeftShadowDomNode.setClassName(`shadow${z}${m}${h}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(r){this._mouseIsOver=!1,this._hide()}_onMouseOver(r){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=a;class l extends a{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const u=new s.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:h=>i.scheduleAtNextAnimationFrame(h)});super(r,n,u),this._register(u)}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=l;class p extends a{constructor(r,n,u){super(r,n,u)}setScrollPosition(r){r.reuseAnimation?this._scrollable.setScrollPositionSmooth(r,r.reuseAnimation):this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=p;class S extends a{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const u=new s.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:h=>i.scheduleAtNextAnimationFrame(h)});super(r,n,u),this._register(u),this._element=r,this.onScroll(h=>{h.scrollTopChanged&&(this._element.scrollTop=h.scrollTop),h.scrollLeftChanged&&(this._element.scrollLeft=h.scrollLeft)}),this.scanDomNode()}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=S;function T(_){const r={lazyRender:typeof _.lazyRender<"u"?_.lazyRender:!1,className:typeof _.className<"u"?_.className:"",useShadows:typeof _.useShadows<"u"?_.useShadows:!0,handleMouseWheel:typeof _.handleMouseWheel<"u"?_.handleMouseWheel:!0,flipAxes:typeof _.flipAxes<"u"?_.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof _.consumeMouseWheelIfScrollbarIsNeeded<"u"?_.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof _.alwaysConsumeMouseWheel<"u"?_.alwaysConsumeMouseWheel:!1,scrollYToX:typeof _.scrollYToX<"u"?_.scrollYToX:!1,mouseWheelScrollSensitivity:typeof _.mouseWheelScrollSensitivity<"u"?_.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof _.fastScrollSensitivity<"u"?_.fastScrollSensitivity:5,scrollPredominantAxis:typeof _.scrollPredominantAxis<"u"?_.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof _.mouseWheelSmoothScroll<"u"?_.mouseWheelSmoothScroll:!0,arrowSize:typeof _.arrowSize<"u"?_.arrowSize:11,listenOnDomNode:typeof _.listenOnDomNode<"u"?_.listenOnDomNode:null,horizontal:typeof _.horizontal<"u"?_.horizontal:1,horizontalScrollbarSize:typeof _.horizontalScrollbarSize<"u"?_.horizontalScrollbarSize:10,horizontalSliderSize:typeof _.horizontalSliderSize<"u"?_.horizontalSliderSize:0,horizontalHasArrows:typeof _.horizontalHasArrows<"u"?_.horizontalHasArrows:!1,vertical:typeof _.vertical<"u"?_.vertical:1,verticalScrollbarSize:typeof _.verticalScrollbarSize<"u"?_.verticalScrollbarSize:10,verticalHasArrows:typeof _.verticalHasArrows<"u"?_.verticalHasArrows:!1,verticalSliderSize:typeof _.verticalSliderSize<"u"?_.verticalSliderSize:0,scrollByPage:typeof _.scrollByPage<"u"?_.scrollByPage:!1};return r.horizontalSliderSize=typeof _.horizontalSliderSize<"u"?_.horizontalSliderSize:r.horizontalScrollbarSize,r.verticalSliderSize=typeof _.verticalSliderSize<"u"?_.verticalSliderSize:r.verticalScrollbarSize,o.isMacintosh&&(r.className+=" mac"),r}}),define(me[58],pe([1,0,15,51,4,18,22,57,14,8,25,3,2,46,48,78,114]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s,e,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const v={CurrentDragAndDropData:void 0},E={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(r){return[r]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class a{constructor(n){this.elements=n}get context(){return this._context}set context(n){this._context=n}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=a;class l{constructor(n){this.elements=n}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=l;class p{constructor(){this.types=[],this.files=[]}update(n){if(n.types&&this.types.splice(0,this.types.length,...n.types),n.files){this.files.splice(0,this.files.length);for(let u=0;u<n.files.length;u++){const h=n.files.item(u);h&&(h.size||h.type)&&this.files.push(h)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=p;function S(r,n){return Array.isArray(r)&&Array.isArray(n)?(0,g.equals)(r,n):r===n}class T{constructor(n){n?.getSetSize?this.getSetSize=n.getSetSize.bind(n):this.getSetSize=(u,h,m)=>m,n?.getPosInSet?this.getPosInSet=n.getPosInSet.bind(n):this.getPosInSet=(u,h)=>h+1,n?.getRole?this.getRole=n.getRole.bind(n):this.getRole=u=>"listitem",n?.isChecked?this.isChecked=n.isChecked.bind(n):this.isChecked=u=>{}}}class _{constructor(n,u,h,m=E){if(this.virtualDelegate=u,this.domId=`list_id_${++_.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new d.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=o.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=o.Disposable.None,this.onDragLeaveTimeout=o.Disposable.None,this.disposables=new o.DisposableStore,this._onDidChangeContentHeight=new N.Emitter,this.onDidChangeContentHeight=N.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,m.horizontalScrolling&&m.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new b.RangeMap;for(const $ of h)this.renderers.set($.templateId,$);this.cache=this.disposables.add(new D.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof m.mouseSupport=="boolean"?m.mouseSupport:!0),this._horizontalScrolling=m.horizontalScrolling??E.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof m.additionalScrollHeight>"u"?0:m.additionalScrollHeight,this.accessibilityProvider=new T(m.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(m.transformOptimization??E.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(C.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:m.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:$=>(0,H.scheduleAtNextAnimationFrame)($)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:m.alwaysConsumeMouseWheel??E.alwaysConsumeMouseWheel,horizontal:1,vertical:m.verticalScrollMode??E.verticalScrollMode,useShadows:m.useShadows??E.useShadows,mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity,fastScrollSensitivity:m.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),n.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,H.addDisposableListener)(this.rowsContainer,C.EventType.Change,$=>this.onTouchChange($))),this.disposables.add((0,H.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",$=>$.target.scrollTop=0)),this.disposables.add((0,H.addDisposableListener)(this.domNode,"dragover",$=>this.onDragOver(this.toDragEvent($)))),this.disposables.add((0,H.addDisposableListener)(this.domNode,"drop",$=>this.onDrop(this.toDragEvent($)))),this.disposables.add((0,H.addDisposableListener)(this.domNode,"dragleave",$=>this.onDragLeave(this.toDragEvent($)))),this.disposables.add((0,H.addDisposableListener)(this.domNode,"dragend",$=>this.onDragEnd($))),this.setRowLineHeight=m.setRowLineHeight??E.setRowLineHeight,this.setRowHeight=m.setRowHeight??E.setRowHeight,this.supportDynamicHeights=m.supportDynamicHeights??E.supportDynamicHeights,this.dnd=m.dnd??E.dnd,this.layout()}get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(n){if(n!==this._horizontalScrolling){if(n&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=n,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const u of this.items)this.measureItemWidth(u);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,H.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}updateOptions(n){n.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=n.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),n.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(n.smoothScrolling?125:0),n.horizontalScrolling!==void 0&&(this.horizontalScrolling=n.horizontalScrolling),n.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:n.mouseWheelScrollSensitivity}),n.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:n.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(n){this.scrollableElement.triggerScrollFromMouseWheelEvent(n)}updateElementHeight(n,u,h){if(n<0||n>=this.items.length)return;const m=this.items[n].size;if(typeof u>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[n].lastDynamicHeightWidth=void 0,u=m+this.probeDynamicHeight(n)}if(m===u)return;const z=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let $=0;n<z.start||h!==null&&h>n&&h<=z.end?$=u-m:$=0,this.rangeMap.splice(n,1,[{size:u}]),this.items[n].size=u,this.render(z,Math.max(0,this.lastRenderTop+$),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(n,u,h=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(n,u,h)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(n,u,h=[]){const m=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),z={start:n,end:n+u},$=s.Range.intersect(m,z),J=new Map;for(let V=$.end-1;V>=$.start;V--){const j=this.items[V];if(j.dragStartDisposable.dispose(),j.checkedDisposable.dispose(),j.row){let k=J.get(j.templateId);k||(k=[],J.set(j.templateId,k));const c=this.renderers.get(j.templateId);c&&c.disposeElement&&c.disposeElement(j.element,V,j.row.templateData,j.size),k.push(j.row)}j.row=null}const Q={start:n+u,end:this.items.length},ge=s.Range.intersect(Q,m),oe=s.Range.relativeComplement(Q,m),we=h.map(V=>({id:String(this.itemId++),element:V,templateId:this.virtualDelegate.getTemplateId(V),size:this.virtualDelegate.getHeight(V),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:o.Disposable.None,checkedDisposable:o.Disposable.None}));let he;n===0&&u>=this.items.length?(this.rangeMap=new b.RangeMap,this.rangeMap.splice(0,0,we),he=this.items,this.items=we):(this.rangeMap.splice(n,u,we),he=this.items.splice(n,u,...we));const se=h.length-u,_e=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),te=(0,b.shift)(ge,se),De=s.Range.intersect(_e,te);for(let V=De.start;V<De.end;V++)this.updateItemInDOM(this.items[V],V);const re=s.Range.relativeComplement(te,_e);for(const V of re)for(let j=V.start;j<V.end;j++)this.removeItemFromDOM(j);const ie=oe.map(V=>(0,b.shift)(V,se)),ne=[{start:n,end:n+h.length},...ie].map(V=>s.Range.intersect(_e,V)),F=this.getNextToLastElement(ne);for(const V of ne)for(let j=V.start;j<V.end;j++){const k=this.items[j],I=J.get(k.templateId)?.pop();this.insertItemInDOM(j,F,I)}for(const V of J.values())for(const j of V)this.cache.release(j);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),he.map(V=>V.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,H.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let n=0;for(const u of this.items)typeof u.width<"u"&&(n=Math.max(n,u.width));this.scrollWidth=n,this.scrollableElement.setScrollDimensions({scrollWidth:n===0?0:n+10})}updateWidth(n){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const u=this.items[n];this.measureItemWidth(u),typeof u.width<"u"&&u.width>this.scrollWidth&&(this.scrollWidth=u.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const n of this.items)n.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const n=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),u=this.rangeMap.positionAt(n.start),h=this.rangeMap.positionAt(n.start+1);return h!==-1&&(h-u)/2+u<this.scrollTop?n.start+1:n.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(n){return this.items[n].element}indexOf(n){return this.items.findIndex(u=>u.element===n)}domElement(n){const u=this.items[n].row;return u&&u.domNode}elementHeight(n){return this.items[n].size}elementTop(n){return this.rangeMap.positionAt(n)}indexAt(n){return this.rangeMap.indexAt(n)}indexAfter(n){return this.rangeMap.indexAfter(n)}layout(n,u){const h={height:typeof n=="number"?n:(0,H.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,h.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(h),typeof u<"u"&&(this.renderWidth=u,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof u=="number"?u:(0,H.getContentWidth)(this.domNode)})}render(n,u,h,m,z,$=!1){const J=this.getRenderRange(u,h),Q=s.Range.relativeComplement(J,n),ge=s.Range.relativeComplement(n,J),oe=this.getNextToLastElement(Q);if($){const we=s.Range.intersect(n,J);for(let he=we.start;he<we.end;he++)this.updateItemInDOM(this.items[he],he)}for(const we of Q)for(let he=we.start;he<we.end;he++)this.insertItemInDOM(he,oe);for(const we of ge)for(let he=we.start;he<we.end;he++)this.removeItemFromDOM(he);m!==void 0&&(this.rowsContainer.style.left=`-${m}px`),this.rowsContainer.style.top=`-${u}px`,this.horizontalScrolling&&z!==void 0&&(this.rowsContainer.style.width=`${Math.max(z,this.renderWidth)}px`),this.lastRenderTop=u,this.lastRenderHeight=h}insertItemInDOM(n,u,h){const m=this.items[n];m.row||(m.row=h??this.cache.alloc(m.templateId));const z=this.accessibilityProvider.getRole(m.element)||"listitem";m.row.domNode.setAttribute("role",z);const $=this.accessibilityProvider.isChecked(m.element);if(typeof $=="boolean")m.row.domNode.setAttribute("aria-checked",String(!!$));else if($){const ge=oe=>m.row.domNode.setAttribute("aria-checked",String(!!oe));ge($.value),m.checkedDisposable=$.onDidChange(ge)}m.row.domNode.parentElement||(u?this.rowsContainer.insertBefore(m.row.domNode,u):this.rowsContainer.appendChild(m.row.domNode)),this.updateItemInDOM(m,n);const J=this.renderers.get(m.templateId);if(!J)throw new Error(`No renderer found for template id ${m.templateId}`);J?.renderElement(m.element,n,m.row.templateData,m.size);const Q=this.dnd.getDragURI(m.element);m.dragStartDisposable.dispose(),m.row.domNode.draggable=!!Q,Q&&(m.dragStartDisposable=(0,H.addDisposableListener)(m.row.domNode,"dragstart",ge=>this.onDragStart(m.element,Q,ge))),this.horizontalScrolling&&(this.measureItemWidth(m),this.eventuallyUpdateScrollWidth())}measureItemWidth(n){if(!n.row||!n.row.domNode)return;n.row.domNode.style.width=y.isFirefox?"-moz-fit-content":"fit-content",n.width=(0,H.getContentWidth)(n.row.domNode);const u=window.getComputedStyle(n.row.domNode);u.paddingLeft&&(n.width+=parseFloat(u.paddingLeft)),u.paddingRight&&(n.width+=parseFloat(u.paddingRight)),n.row.domNode.style.width=""}updateItemInDOM(n,u){n.row.domNode.style.top=`${this.elementTop(u)}px`,this.setRowHeight&&(n.row.domNode.style.height=`${n.size}px`),this.setRowLineHeight&&(n.row.domNode.style.lineHeight=`${n.size}px`),n.row.domNode.setAttribute("data-index",`${u}`),n.row.domNode.setAttribute("data-last-element",u===this.length-1?"true":"false"),n.row.domNode.setAttribute("data-parity",u%2===0?"even":"odd"),n.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(n.element,u,this.length))),n.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(n.element,u))),n.row.domNode.setAttribute("id",this.getElementDomId(u)),n.row.domNode.classList.toggle("drop-target",n.dropTarget)}removeItemFromDOM(n){const u=this.items[n];if(u.dragStartDisposable.dispose(),u.checkedDisposable.dispose(),u.row){const h=this.renderers.get(u.templateId);h&&h.disposeElement&&h.disposeElement(u.element,n,u.row.templateData,u.size),this.cache.release(u.row),u.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(n,u){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:n,reuseAnimation:u})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(n){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:n})}get scrollTop(){return this.getScrollTop()}set scrollTop(n){this.setScrollTop(n)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"click")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDblClick(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"dblclick")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMiddleClick(){return N.Event.filter(N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"auxclick")).event,n=>this.toMouseEvent(n),this.disposables),n=>n.browserEvent.button===1,this.disposables)}get onMouseUp(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseup")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDown(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousedown")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOver(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseover")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMove(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousemove")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOut(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseout")).event,n=>this.toMouseEvent(n),this.disposables)}get onContextMenu(){return N.Event.any(N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"contextmenu")).event,n=>this.toMouseEvent(n),this.disposables),N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,C.EventType.Contextmenu)).event,n=>this.toGestureEvent(n),this.disposables))}get onTouchStart(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"touchstart")).event,n=>this.toTouchEvent(n),this.disposables)}get onTap(){return N.Event.map(this.disposables.add(new O.DomEmitter(this.rowsContainer,C.EventType.Tap)).event,n=>this.toGestureEvent(n),this.disposables)}toMouseEvent(n){const u=this.getItemIndexFromEventTarget(n.target||null),h=typeof u>"u"?void 0:this.items[u],m=h&&h.element;return{browserEvent:n,index:u,element:m}}toTouchEvent(n){const u=this.getItemIndexFromEventTarget(n.target||null),h=typeof u>"u"?void 0:this.items[u],m=h&&h.element;return{browserEvent:n,index:u,element:m}}toGestureEvent(n){const u=this.getItemIndexFromEventTarget(n.initialTarget||null),h=typeof u>"u"?void 0:this.items[u],m=h&&h.element;return{browserEvent:n,index:u,element:m}}toDragEvent(n){const u=this.getItemIndexFromEventTarget(n.target||null),h=typeof u>"u"?void 0:this.items[u],m=h&&h.element;return{browserEvent:n,index:u,element:m}}onScroll(n){try{const u=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(u,n.scrollTop,n.height,n.scrollLeft,n.scrollWidth),this.supportDynamicHeights&&this._rerender(n.scrollTop,n.height,n.inSmoothScrolling)}catch(u){throw console.error("Got bad scroll event:",n),u}}onTouchChange(n){n.preventDefault(),n.stopPropagation(),this.scrollTop-=n.translationY}onDragStart(n,u,h){if(!h.dataTransfer)return;const m=this.dnd.getDragElements(n);if(h.dataTransfer.effectAllowed="copyMove",h.dataTransfer.setData(i.DataTransfers.TEXT,u),h.dataTransfer.setDragImage){let z;this.dnd.getDragLabel&&(z=this.dnd.getDragLabel(m,h)),typeof z>"u"&&(z=String(m.length));const $=(0,H.$)(".monaco-drag-image");$.textContent=z,document.body.appendChild($),h.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>document.body.removeChild($),0)}this.currentDragData=new a(m),v.CurrentDragAndDropData=new l(m),this.dnd.onDragStart?.(this.currentDragData,h)}onDragOver(n){if(n.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),v.CurrentDragAndDropData&&v.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(n.browserEvent),!n.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(v.CurrentDragAndDropData)this.currentDragData=v.CurrentDragAndDropData;else{if(!n.browserEvent.dataTransfer.types)return!1;this.currentDragData=new p}const u=this.dnd.onDragOver(this.currentDragData,n.element,n.index,n.browserEvent);if(this.canDrop=typeof u=="boolean"?u:u.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;n.browserEvent.dataTransfer.dropEffect=typeof u!="boolean"&&u.effect===0?"copy":"move";let h;if(typeof u!="boolean"&&u.feedback?h=u.feedback:typeof n.index>"u"?h=[-1]:h=[n.index],h=(0,g.distinct)(h).filter(m=>m>=-1&&m<this.length).sort((m,z)=>m-z),h=h[0]===-1?[-1]:h,S(this.currentDragFeedback,h))return!0;if(this.currentDragFeedback=h,this.currentDragFeedbackDisposable.dispose(),h[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,o.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const m of h){const z=this.items[m];z.dropTarget=!0,z.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,o.toDisposable)(()=>{for(const m of h){const z=this.items[m];z.dropTarget=!1,z.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(n){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,d.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,n.element,n.index,n.browserEvent)}onDrop(n){if(!this.canDrop)return;const u=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,v.CurrentDragAndDropData=void 0,!(!u||!n.browserEvent.dataTransfer)&&(n.browserEvent.preventDefault(),u.update(n.browserEvent.dataTransfer),this.dnd.drop(u,n.element,n.index,n.browserEvent))}onDragEnd(n){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,v.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(n)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=o.Disposable.None}setupDragAndDropScrollTopAnimation(n){if(!this.dragOverAnimationDisposable){const u=(0,H.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,H.animate)(this.animateDragAndDropScrollTop.bind(this,u))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,d.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=n.pageY}animateDragAndDropScrollTop(n){if(this.dragOverMouseY===void 0)return;const u=this.dragOverMouseY-n,h=this.renderHeight-35;u<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(u-35))):u>h&&(this.scrollTop+=Math.min(14,Math.floor(.3*(u-h))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(n){const u=this.scrollableElement.getDomNode();let h=n;for(;h instanceof HTMLElement&&h!==this.rowsContainer&&u.contains(h);){const m=h.getAttribute("data-index");if(m){const z=Number(m);if(!isNaN(z))return z}h=h.parentElement}}getRenderRange(n,u){return{start:this.rangeMap.indexAt(n),end:this.rangeMap.indexAfter(n+u-1)}}_rerender(n,u,h){const m=this.getRenderRange(n,u);let z,$;n===this.elementTop(m.start)?(z=m.start,$=0):m.end-m.start>1&&(z=m.start+1,$=this.elementTop(z)-n);let J=0;for(;;){const Q=this.getRenderRange(n,u);let ge=!1;for(let oe=Q.start;oe<Q.end;oe++){const we=this.probeDynamicHeight(oe);we!==0&&this.rangeMap.splice(oe,1,[this.items[oe]]),J+=we,ge=ge||we!==0}if(!ge){J!==0&&this.eventuallyUpdateScrollDimensions();const oe=s.Range.relativeComplement(m,Q);for(const he of oe)for(let se=he.start;se<he.end;se++)this.items[se].row&&this.removeItemFromDOM(se);const we=s.Range.relativeComplement(Q,m);for(const he of we)for(let se=he.start;se<he.end;se++){const _e=se+1,te=_e<this.items.length?this.items[_e].row:null,De=te?te.domNode:null;this.insertItemInDOM(se,De)}for(let he=Q.start;he<Q.end;he++)this.items[he].row&&this.updateItemInDOM(this.items[he],he);if(typeof z=="number"){const he=this.scrollable.getFutureScrollPosition().scrollTop-n,se=this.elementTop(z)-$+he;this.setScrollTop(se,h)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(n){const u=this.items[n];if(this.virtualDelegate.getDynamicHeight){const $=this.virtualDelegate.getDynamicHeight(u.element);if($!==null){const J=u.size;return u.size=$,u.lastDynamicHeightWidth=this.renderWidth,$-J}}if(!u.hasDynamicHeight||u.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(u.element))return 0;const h=u.size;if(!this.setRowHeight&&u.row){const $=u.row.domNode.offsetHeight;return u.size=$,u.lastDynamicHeightWidth=this.renderWidth,$-h}const m=this.cache.alloc(u.templateId);m.domNode.style.height="",this.rowsContainer.appendChild(m.domNode);const z=this.renderers.get(u.templateId);return z&&(z.renderElement(u.element,n,m.templateData,void 0),z.disposeElement?.(u.element,n,m.templateData,void 0)),u.size=m.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(u.element,u.size),u.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(m.domNode),this.cache.release(m),u.size-h}getNextToLastElement(n){const u=n[n.length-1];if(!u)return null;const h=this.items[u.end];return!h||!h.row?null:h.row.domNode}getElementDomId(n){return`${this.domId}_${n}`}dispose(){if(this.items){for(const n of this.items)if(n.row){const u=this.renderers.get(n.row.templateId);u&&(u.disposeElement?.(n.element,-1,n.row.templateData,void 0),u.disposeTemplate(n.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,o.dispose)(this.disposables)}}_.InstanceCount=0,Ke([f.memoize],_.prototype,"onMouseClick",null),Ke([f.memoize],_.prototype,"onMouseDblClick",null),Ke([f.memoize],_.prototype,"onMouseMiddleClick",null),Ke([f.memoize],_.prototype,"onMouseUp",null),Ke([f.memoize],_.prototype,"onMouseDown",null),Ke([f.memoize],_.prototype,"onMouseOver",null),Ke([f.memoize],_.prototype,"onMouseMove",null),Ke([f.memoize],_.prototype,"onMouseOut",null),Ke([f.memoize],_.prototype,"onContextMenu",null),Ke([f.memoize],_.prototype,"onTouchStart",null),Ke([f.memoize],_.prototype,"onTap",null),t.ListView=_}),define(me[59],pe([1,0,4,18,19,22,54,68,14,8,24,25,3,33,2,45,27,5,6,67,58,88]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s,e,b,D,v,E,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class p{constructor(c){this.trait=c,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(c){return c}renderElement(c,I,U){const K=this.renderedElements.findIndex(X=>X.templateData===U);if(K>=0){const X=this.renderedElements[K];this.trait.unrender(U),X.index=I}else{const X={index:I,templateData:U};this.renderedElements.push(X)}this.trait.renderIndex(I,U)}splice(c,I,U){const K=[];for(const X of this.renderedElements)X.index<c?K.push(X):X.index>=c+I&&K.push({index:X.index+U-I,templateData:X.templateData});this.renderedElements=K}renderIndexes(c){for(const{index:I,templateData:U}of this.renderedElements)c.indexOf(I)>-1&&this.trait.renderIndex(I,U)}disposeTemplate(c){const I=this.renderedElements.findIndex(U=>U.templateData===c);I<0||this.renderedElements.splice(I,1)}}class S{constructor(c){this._trait=c,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new o.Emitter,this.onChange=this._onChange.event}get name(){return this._trait}get renderer(){return new p(this)}splice(c,I,U){I=Math.max(0,Math.min(I,this.length-c));const K=U.length-I,X=c+I,L=[...this.sortedIndexes.filter(W=>W<c),...U.map((W,A)=>W?A+c:-1).filter(W=>W!==-1),...this.sortedIndexes.filter(W=>W>=X).map(W=>W+K)],R=this.length+K;if(this.sortedIndexes.length>0&&L.length===0&&R>0){const W=this.sortedIndexes.find(A=>A>=c)??R-1;L.push(Math.min(W,R-1))}this.renderer.splice(c,I,U.length),this._set(L,L),this.length=R}renderIndex(c,I){I.classList.toggle(this._trait,this.contains(c))}unrender(c){c.classList.remove(this._trait)}set(c,I){return this._set(c,[...c].sort(ce),I)}_set(c,I,U){const K=this.indexes,X=this.sortedIndexes;this.indexes=c,this.sortedIndexes=I;const L=re(X,c);return this.renderer.renderIndexes(L),this._onChange.fire({indexes:c,browserEvent:U}),K}get(){return this.indexes}contains(c){return(0,g.binarySearch)(this.sortedIndexes,c,ce)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([N.memoize],S.prototype,"renderer",null);class T extends S{constructor(c){super("selected"),this.setAriaSelected=c}renderIndex(c,I){super.renderIndex(c,I),this.setAriaSelected&&(this.contains(c)?I.setAttribute("aria-selected","true"):I.setAttribute("aria-selected","false"))}}class _{constructor(c,I,U){this.trait=c,this.view=I,this.identityProvider=U}splice(c,I,U){if(!this.identityProvider)return this.trait.splice(c,I,U.map(()=>!1));const K=this.trait.get().map(L=>this.identityProvider.getId(this.view.element(L)).toString()),X=U.map(L=>K.indexOf(this.identityProvider.getId(L).toString())>-1);this.trait.splice(c,I,X)}}function r(k){return k.tagName==="INPUT"||k.tagName==="TEXTAREA"}t.isInputElement=r;function n(k){return k.classList.contains("monaco-editor")?!0:k.classList.contains("monaco-list")||!k.parentElement?!1:n(k.parentElement)}t.isMonacoEditor=n;function u(k){return k.tagName==="A"&&k.classList.contains("monaco-button")||k.tagName==="DIV"&&k.classList.contains("monaco-button-dropdown")?!0:k.classList.contains("monaco-list")||!k.parentElement?!1:u(k.parentElement)}t.isButton=u;class h{constructor(c,I,U){this.list=c,this.view=I,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(K=>K.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(K=>(v.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}get onKeyDown(){return this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(c=>!r(c.target)).map(c=>new H.StandardKeyboardEvent(c)))}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),c.multipleSelectionSupport&&this.onKeyDown.filter(I=>(v.isMacintosh?I.metaKey:I.ctrlKey)&&I.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(c){c.preventDefault(),c.stopPropagation(),this.list.setSelection(this.list.getFocus(),c.browserEvent)}onUpArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusPrevious(1,!1,c.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onDownArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusNext(1,!1,c.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageUpArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusPreviousPage(c.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageDownArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusNextPage(c.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onCtrlA(c){c.preventDefault(),c.stopPropagation(),this.list.setSelection((0,g.range)(this.list.length),c.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(c){this.list.getSelection().length&&(c.preventDefault(),c.stopPropagation(),this.list.setSelection([],c.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([N.memoize],h.prototype,"onKeyDown",null);var m;(function(k){k[k.Automatic=0]="Automatic",k[k.Trigger=1]="Trigger"})(m=t.TypeNavigationMode||(t.TypeNavigationMode={}));var z;(function(k){k[k.Idle=0]="Idle",k[k.Typing=1]="Typing"})(z||(z={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(k){return k.ctrlKey||k.metaKey||k.altKey?!1:k.keyCode>=31&&k.keyCode<=56||k.keyCode>=21&&k.keyCode<=30||k.keyCode>=93&&k.keyCode<=102||k.keyCode>=80&&k.keyCode<=90}};class ${constructor(c,I,U,K,X){this.list=c,this.view=I,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=K,this.delegate=X,this.enabled=!1,this.state=z.Idle,this.mode=m.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(c.options)}updateOptions(c){c.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=c.typeNavigationMode??m.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let c=!1;const I=this.enabledDisposables.add(o.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(X=>!r(X.target)).filter(()=>this.mode===m.Automatic||this.triggered).map(X=>new H.StandardKeyboardEvent(X)).filter(X=>c||this.keyboardNavigationEventFilter(X)).filter(X=>this.delegate.mightProducePrintableCharacter(X)).forEach(X=>y.EventHelper.stop(X,!0)).map(X=>X.browserEvent.key).event,U=o.Event.debounce(I,()=>null,800,void 0,void 0,this.enabledDisposables);o.Event.reduce(o.Event.any(I,U),(X,L)=>L===null?null:(X||"")+L,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),I(()=>c=!0,void 0,this.enabledDisposables),U(()=>c=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const c=this.list.getFocus();if(c.length>0&&c[0]===this.previouslyFocused){const I=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(c[0]));I&&(0,C.alert)(I)}this.previouslyFocused=-1}onInput(c){if(!c){this.state=z.Idle,this.triggered=!1;return}const I=this.list.getFocus(),U=I.length>0?I[0]:0,K=this.state===z.Idle?1:0;this.state=z.Typing;for(let X=0;X<this.list.length;X++){const L=(U+X+K)%this.list.length,R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(L)),W=R&&R.toString();if(typeof W>"u"||(0,s.matchesPrefix)(c,W)){this.previouslyFocused=U,this.list.setFocus([L]),this.list.reveal(L);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class J{constructor(c,I){this.list=c,this.view=I,this.disposables=new e.DisposableStore,this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(I.domNode,"keydown")).event)).filter(K=>!r(K.target)).map(K=>new H.StandardKeyboardEvent(K)).filter(K=>K.keyCode===2&&!K.ctrlKey&&!K.metaKey&&!K.shiftKey&&!K.altKey).on(this.onTab,this,this.disposables)}onTab(c){if(c.target!==this.view.domNode)return;const I=this.list.getFocus();if(I.length===0)return;const U=this.view.domElement(I[0]);if(!U)return;const K=U.querySelector("[tabIndex]");if(!K||!(K instanceof HTMLElement)||K.tabIndex===-1)return;const X=window.getComputedStyle(K);X.visibility==="hidden"||X.display==="none"||(c.preventDefault(),c.stopPropagation(),K.focus())}dispose(){this.disposables.dispose()}}function Q(k){return v.isMacintosh?k.browserEvent.metaKey:k.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Q;function ge(k){return k.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ge;function oe(k){return k instanceof MouseEvent&&k.button===2}const we={isSelectionSingleChangeEvent:Q,isSelectionRangeChangeEvent:ge};class he{constructor(c){this.list=c,this.disposables=new e.DisposableStore,this._onPointer=new o.Emitter,this.onPointer=this._onPointer.event,c.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||we),this.mouseSupport=typeof c.options.mouseSupport>"u"||!!c.options.mouseSupport,this.mouseSupport&&(c.onMouseDown(this.onMouseDown,this,this.disposables),c.onContextMenu(this.onContextMenu,this,this.disposables),c.onMouseDblClick(this.onDoubleClick,this,this.disposables),c.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(O.Gesture.addTarget(c.getHTMLElement()))),o.Event.any(c.onMouseClick,c.onMouseMiddleClick,c.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,c.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||we))}isSelectionSingleChangeEvent(c){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(c):!1}isSelectionRangeChangeEvent(c){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(c):!1}isSelectionChangeEvent(c){return this.isSelectionSingleChangeEvent(c)||this.isSelectionRangeChangeEvent(c)}onMouseDown(c){n(c.browserEvent.target)||document.activeElement!==c.browserEvent.target&&this.list.domFocus()}onContextMenu(c){if(n(c.browserEvent.target))return;const I=typeof c.index>"u"?[]:[c.index];this.list.setFocus(I,c.browserEvent)}onViewPointer(c){if(!this.mouseSupport||r(c.browserEvent.target)||n(c.browserEvent.target))return;const I=c.index;if(typeof I>"u"){this.list.setFocus([],c.browserEvent),this.list.setSelection([],c.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(c))return this.changeSelection(c);if(this.isSelectionChangeEvent(c))return this.changeSelection(c);this.list.setFocus([I],c.browserEvent),this.list.setAnchor(I),oe(c.browserEvent)||this.list.setSelection([I],c.browserEvent),this._onPointer.fire(c)}onDoubleClick(c){if(r(c.browserEvent.target)||n(c.browserEvent.target)||this.isSelectionChangeEvent(c))return;const I=this.list.getFocus();this.list.setSelection(I,c.browserEvent)}changeSelection(c){const I=c.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(c)){typeof U>"u"&&(U=this.list.getFocus()[0]??I,this.list.setAnchor(U));const K=Math.min(U,I),X=Math.max(U,I),L=(0,g.range)(K,X+1),R=this.list.getSelection(),W=De(re(R,[U]),U);if(W.length===0)return;const A=re(L,ie(R,W));this.list.setSelection(A,c.browserEvent),this.list.setFocus([I],c.browserEvent)}else if(this.isSelectionSingleChangeEvent(c)){const K=this.list.getSelection(),X=K.filter(L=>L!==I);this.list.setFocus([I]),this.list.setAnchor(I),K.length===X.length?this.list.setSelection([...X,I],c.browserEvent):this.list.setSelection(X,c.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=he;class se{constructor(c,I){this.styleElement=c,this.selectorSuffix=I}style(c){const I=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];c.listBackground&&(c.listBackground.isOpaque()?U.push(`.monaco-list${I} .monaco-list-rows { background: ${c.listBackground}; }`):v.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),c.listFocusBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.focused { background-color: ${c.listFocusBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.focused:hover { background-color: ${c.listFocusBackground}; }`)),c.listFocusForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.focused { color: ${c.listFocusForeground}; }`),c.listActiveSelectionBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.selected { background-color: ${c.listActiveSelectionBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.selected:hover { background-color: ${c.listActiveSelectionBackground}; }`)),c.listActiveSelectionForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { color: ${c.listActiveSelectionForeground}; }`),c.listActiveSelectionIconForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected .codicon { color: ${c.listActiveSelectionIconForeground}; }`),c.listFocusAndSelectionOutline&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { outline-color: ${c.listFocusAndSelectionOutline} !important; }`),c.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { background-color: ${c.listFocusAndSelectionBackground}; }
			`),c.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { color: ${c.listFocusAndSelectionForeground}; }
			`),c.listInactiveFocusForeground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { color:  ${c.listInactiveFocusForeground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { color:  ${c.listInactiveFocusForeground}; }`)),c.listInactiveSelectionIconForeground&&U.push(`.monaco-list${I} .monaco-list-row.focused .codicon { color:  ${c.listInactiveSelectionIconForeground}; }`),c.listInactiveFocusBackground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { background-color:  ${c.listInactiveFocusBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { background-color:  ${c.listInactiveFocusBackground}; }`)),c.listInactiveSelectionBackground&&(U.push(`.monaco-list${I} .monaco-list-row.selected { background-color:  ${c.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.selected:hover { background-color:  ${c.listInactiveSelectionBackground}; }`)),c.listInactiveSelectionForeground&&U.push(`.monaco-list${I} .monaco-list-row.selected { color: ${c.listInactiveSelectionForeground}; }`),c.listHoverBackground&&U.push(`.monaco-list${I}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${c.listHoverBackground}; }`),c.listHoverForeground&&U.push(`.monaco-list${I} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${c.listHoverForeground}; }`),c.listSelectionOutline&&U.push(`.monaco-list${I} .monaco-list-row.selected { outline: 1px dotted ${c.listSelectionOutline}; outline-offset: -1px; }`),c.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
			`),c.listInactiveFocusOutline&&U.push(`.monaco-list${I} .monaco-list-row.focused { outline: 1px dotted ${c.listInactiveFocusOutline}; outline-offset: -1px; }`),c.listHoverOutline&&U.push(`.monaco-list${I} .monaco-list-row:hover { outline: 1px dashed ${c.listHoverOutline}; outline-offset: -1px; }`),c.listDropBackground&&U.push(`
				.monaco-list${I}.drop-target,
				.monaco-list${I} .monaco-list-rows.drop-target,
				.monaco-list${I} .monaco-list-row.drop-target { background-color: ${c.listDropBackground} !important; color: inherit !important; }
			`),c.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${c.tableColumnsBorder};
			}`),c.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${c.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=se;const _e={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function De(k,c){const I=k.indexOf(c);if(I===-1)return[];const U=[];let K=I-1;for(;K>=0&&k[K]===c-(I-K);)U.push(k[K--]);for(U.reverse(),K=I;K<k.length&&k[K]===c+(K-I);)U.push(k[K++]);return U}function re(k,c){const I=[];let U=0,K=0;for(;U<k.length||K<c.length;)if(U>=k.length)I.push(c[K++]);else if(K>=c.length)I.push(k[U++]);else if(k[U]===c[K]){I.push(k[U]),U++,K++;continue}else k[U]<c[K]?I.push(k[U++]):I.push(c[K++]);return I}function ie(k,c){const I=[];let U=0,K=0;for(;U<k.length||K<c.length;)if(U>=k.length)I.push(c[K++]);else if(K>=c.length)I.push(k[U++]);else if(k[U]===c[K]){U++,K++;continue}else k[U]<c[K]?I.push(k[U++]):K++;return I}const ce=(k,c)=>k-c;class ne{constructor(c,I){this._templateId=c,this.renderers=I}get templateId(){return this._templateId}renderTemplate(c){return this.renderers.map(I=>I.renderTemplate(c))}renderElement(c,I,U,K){let X=0;for(const L of this.renderers)L.renderElement(c,I,U[X++],K)}disposeElement(c,I,U,K){let X=0;for(const L of this.renderers)L.disposeElement?.(c,I,U[X],K),X+=1}disposeTemplate(c){let I=0;for(const U of this.renderers)U.disposeTemplate(c[I++])}}class F{constructor(c){this.accessibilityProvider=c,this.templateId="a18n"}renderTemplate(c){return c}renderElement(c,I,U){const K=this.accessibilityProvider.getAriaLabel(c);K?U.setAttribute("aria-label",K):U.removeAttribute("aria-label");const X=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(c);typeof X=="number"?U.setAttribute("aria-level",`${X}`):U.removeAttribute("aria-level")}disposeTemplate(c){}}class V{constructor(c,I){this.list=c,this.dnd=I}getDragElements(c){const I=this.list.getSelectedElements();return I.indexOf(c)>-1?I:[c]}getDragURI(c){return this.dnd.getDragURI(c)}getDragLabel(c,I){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(c,I)}onDragStart(c,I){this.dnd.onDragStart?.(c,I)}onDragOver(c,I,U,K){return this.dnd.onDragOver(c,I,U,K)}onDragLeave(c,I,U,K){this.dnd.onDragLeave?.(c,I,U,K)}onDragEnd(c){this.dnd.onDragEnd?.(c)}drop(c,I,U,K){this.dnd.drop(c,I,U,K)}}class j{constructor(c,I,U,K,X=te){this.user=c,this._options=X,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new o.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new o.Emitter,this.onDidDispose=this._onDidDispose.event;const L=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new T(L!=="listbox"),(0,D.mixin)(X,_e,!1);const R=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=X.accessibilityProvider,this.accessibilityProvider&&(R.push(new F(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),K=K.map(A=>new ne(A.templateId,[...R,A]));const W={...X,dnd:X.dnd&&new V(this,X.dnd)};if(this.view=new l.ListView(I,U,K,W),this.view.domNode.setAttribute("role",L),X.styleController)this.styleController=X.styleController(this.view.domId);else{const A=(0,y.createStyleSheet)(this.view.domNode);this.styleController=new se(A,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new _(this.focus,this.view,X.identityProvider),new _(this.selection,this.view,X.identityProvider),new _(this.anchor,this.view,X.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new J(this,this.view)),(typeof X.keyboardSupport!="boolean"||X.keyboardSupport)&&(this.keyboardController=new h(this,this.view,X),this.disposables.add(this.keyboardController)),X.keyboardNavigationLabelProvider){const A=X.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new $(this,this.view,X.keyboardNavigationLabelProvider,X.keyboardNavigationEventFilter??(()=>!0),A),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(X),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}get onDidChangeFocus(){return o.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),c=>this.toListEvent(c),this.disposables)}get onDidChangeSelection(){return o.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),c=>this.toListEvent(c),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let c=!1;const I=this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(X=>new H.StandardKeyboardEvent(X)).filter(X=>c=X.keyCode===58||X.shiftKey&&X.keyCode===68).map(X=>y.EventHelper.stop(X,!0)).filter(()=>!1).event,U=this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>c=!1).map(X=>new H.StandardKeyboardEvent(X)).filter(X=>X.keyCode===58||X.shiftKey&&X.keyCode===68).map(X=>y.EventHelper.stop(X,!0)).map(({browserEvent:X})=>{const L=this.getFocus(),R=L.length?L[0]:void 0,W=typeof R<"u"?this.view.element(R):void 0,A=typeof R<"u"?this.view.domElement(R):this.view.domNode;return{index:R,element:W,anchor:A,browserEvent:X}}).event,K=this.disposables.add(o.Event.chain(this.view.onContextMenu)).filter(X=>!c).map(({element:X,index:L,browserEvent:R})=>({element:X,index:L,anchor:{x:R.pageX+1,y:R.pageY},browserEvent:R})).event;return o.Event.any(I,U,K)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}createMouseController(c){return new he(this)}updateOptions(c={}){this._options={...this._options,...c},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(c),this.keyboardController?.updateOptions(c),this.view.updateOptions(c)}get options(){return this._options}splice(c,I,U=[]){if(c<0||c>this.view.length)throw new a.ListError(this.user,`Invalid start index: ${c}`);if(I<0)throw new a.ListError(this.user,`Invalid delete count: ${I}`);I===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(c,I,U))}updateWidth(c){this.view.updateWidth(c)}updateElementHeight(c,I){this.view.updateElementHeight(c,I,null)}rerender(){this.view.rerender()}element(c){return this.view.element(c)}indexOf(c){return this.view.indexOf(c)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(c){this.view.setScrollTop(c)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(c){this.view.setScrollLeft(c)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(c){this._ariaLabel=c,this.view.domNode.setAttribute("aria-label",c)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(c,I){this.view.layout(c,I)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(c,I){for(const U of c)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.selection.set(c,I)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(c=>this.view.element(c))}setAnchor(c){if(typeof c>"u"){this.anchor.set([]);return}if(c<0||c>=this.length)throw new a.ListError(this.user,`Invalid index ${c}`);this.anchor.set([c])}getAnchor(){return(0,g.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const c=this.getAnchor();return typeof c>"u"?void 0:this.element(c)}setFocus(c,I){for(const U of c)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.focus.set(c,I)}focusNext(c=1,I=!1,U,K){if(this.length===0)return;const X=this.focus.get(),L=this.findNextIndex(X.length>0?X[0]+c:0,I,K);L>-1&&this.setFocus([L],U)}focusPrevious(c=1,I=!1,U,K){if(this.length===0)return;const X=this.focus.get(),L=this.findPreviousIndex(X.length>0?X[0]-c:0,I,K);L>-1&&this.setFocus([L],U)}async focusNextPage(c,I){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const K=this.getFocus()[0];if(K!==U&&(K===void 0||U>K)){const X=this.findPreviousIndex(U,!1,I);X>-1&&K!==X?this.setFocus([X],c):this.setFocus([U],c)}else{const X=this.view.getScrollTop();let L=X+this.view.renderHeight;U>K&&(L-=this.view.elementHeight(U)),this.view.setScrollTop(L),this.view.getScrollTop()!==X&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(c,I))}}async focusPreviousPage(c,I){let U;const K=this.view.getScrollTop();K===0?U=this.view.indexAt(K):U=this.view.indexAfter(K-1);const X=this.getFocus()[0];if(X!==U&&(X===void 0||X>=U)){const L=this.findNextIndex(U,!1,I);L>-1&&X!==L?this.setFocus([L],c):this.setFocus([U],c)}else{const L=K;this.view.setScrollTop(K-this.view.renderHeight),this.view.getScrollTop()!==L&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(c,I))}}focusLast(c,I){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,I);U>-1&&this.setFocus([U],c)}focusFirst(c,I){this.focusNth(0,c,I)}focusNth(c,I,U){if(this.length===0)return;const K=this.findNextIndex(c,!1,U);K>-1&&this.setFocus([K],I)}findNextIndex(c,I=!1,U){for(let K=0;K<this.length;K++){if(c>=this.length&&!I)return-1;if(c=c%this.length,!U||U(this.element(c)))return c;c++}return-1}findPreviousIndex(c,I=!1,U){for(let K=0;K<this.length;K++){if(c<0&&!I)return-1;if(c=(this.length+c%this.length)%this.length,!U||U(this.element(c)))return c;c--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(c=>this.view.element(c))}reveal(c,I){if(c<0||c>=this.length)throw new a.ListError(this.user,`Invalid index ${c}`);const U=this.view.getScrollTop(),K=this.view.elementTop(c),X=this.view.elementHeight(c);if((0,E.isNumber)(I)){const L=X-this.view.renderHeight;this.view.setScrollTop(L*(0,b.clamp)(I,0,1)+K)}else{const L=K+X,R=U+this.view.renderHeight;K<U&&L>=R||(K<U||L>=R&&X>=this.view.renderHeight?this.view.setScrollTop(K):L>=R&&this.view.setScrollTop(L-this.view.renderHeight))}}getRelativeTop(c){if(c<0||c>=this.length)throw new a.ListError(this.user,`Invalid index ${c}`);const I=this.view.getScrollTop(),U=this.view.elementTop(c),K=this.view.elementHeight(c);if(U<I||U+K>I+this.view.renderHeight)return null;const X=K-this.view.renderHeight;return Math.abs((I-U)/X)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(c){return this.view.getElementDomId(c)}style(c){this.styleController.style(c)}toListEvent({indexes:c,browserEvent:I}){return{indexes:c,elements:c.map(U=>this.view.element(U)),browserEvent:I}}_onFocusChange(){const c=this.focus.get();this.view.domNode.classList.toggle("element-focused",c.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const c=this.focus.get();if(c.length>0){let I;this.accessibilityProvider?.getActiveDescendantId&&(I=this.accessibilityProvider.getActiveDescendantId(this.view.element(c[0]))),this.view.domNode.setAttribute("aria-activedescendant",I||this.view.getElementDomId(c[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const c=this.selection.get();this.view.domNode.classList.toggle("selection-none",c.length===0),this.view.domNode.classList.toggle("selection-single",c.length===1),this.view.domNode.classList.toggle("selection-multiple",c.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([N.memoize],j.prototype,"onDidChangeFocus",null),Ke([N.memoize],j.prototype,"onDidChangeSelection",null),Ke([N.memoize],j.prototype,"onContextMenu",null),Ke([N.memoize],j.prototype,"onKeyDown",null),Ke([N.memoize],j.prototype,"onKeyUp",null),Ke([N.memoize],j.prototype,"onKeyPress",null),Ke([N.memoize],j.prototype,"onDidFocus",null),Ke([N.memoize],j.prototype,"onDidBlur",null),t.List=j}),define(me[60],pe([1,0,13,34,36,10,16]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(D){D[D.Paragraph=0]="Paragraph",D[D.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class g{constructor(v="",E=!1){if(this.value=v,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(v,E=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(v):v).replace(/([ \t]+)/g,(a,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,E){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(v,E,a){return this.value+="[",this.value+=this._escape(E,"]"),this.value+="](",this.value+=this._escape(String(v),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(v,E){const a=new RegExp((0,O.escapeRegExpCharacters)(E),"g");return v.replace(a,(l,p)=>v.charAt(p-1)!=="\\"?`\\${l}`:l)}}t.MarkdownString=g;function d(D){return f(D)?!D.value:Array.isArray(D)?D.every(d):!0}t.isEmptyMarkdownString=d;function f(D){return D instanceof g?!0:D&&typeof D=="object"?typeof D.value=="string"&&(typeof D.isTrusted=="boolean"||D.isTrusted===void 0)&&(typeof D.supportThemeIcons=="boolean"||D.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function N(D,v){return D===v?!0:!D||!v?!1:D.value===v.value&&D.isTrusted===v.isTrusted&&D.supportThemeIcons===v.supportThemeIcons&&D.supportHtml===v.supportHtml&&(D.baseUri===v.baseUri||!!D.baseUri&&!!v.baseUri&&(0,H.isEqual)(C.URI.from(D.baseUri),C.URI.from(v.baseUri)))}t.markdownStringEqual=N;function o(D){return D.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function s(D){return D.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=s;function e(D){return D&&D.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function b(D){const v=[],E=D.split("|").map(l=>l.trim());D=E[0];const a=E[1];if(a){const l=/height=(\d+)/.exec(a),p=/width=(\d+)/.exec(a),S=l?l[1]:"",T=p?p[1]:"",_=isFinite(parseInt(T)),r=isFinite(parseInt(S));_&&v.push(`width="${T}"`),r&&v.push(`height="${S}"`)}return{href:D,dimensions:v}}t.parseHrefAndDimensions=b}),define(me[120],pe([1,0,4,112,18,52,20,113,13,3,60,34,72,44,2,75,50,35,27,36,10,16]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s,e,b,D,v,E,a,l,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;const S=Object.freeze({image:(J,Q,ge)=>{let oe=[],we=[];return J&&({href:J,dimensions:oe}=(0,f.parseHrefAndDimensions)(J),we.push(`src="${(0,f.escapeDoubleQuotes)(J)}"`)),ge&&we.push(`alt="${(0,f.escapeDoubleQuotes)(ge)}"`),Q&&we.push(`title="${(0,f.escapeDoubleQuotes)(Q)}"`),oe.length&&(we=we.concat(oe)),"<img "+we.join(" ")+">"},paragraph:J=>`<p>${J}</p>`,link:(J,Q,ge)=>typeof J!="string"?"":(J===ge&&(ge=(0,f.removeMarkdownEscapes)(ge)),Q=typeof Q=="string"?(0,f.escapeDoubleQuotes)((0,f.removeMarkdownEscapes)(Q)):"",J=(0,f.removeMarkdownEscapes)(J),J=J.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${J}" title="${Q||J}">${ge}</a>`)});function T(J,Q={},ge={}){const oe=new e.DisposableStore;let we=!1;const he=(0,O.createElement)(Q),se=function(F){let V;try{V=(0,D.parse)(decodeURIComponent(F))}catch{}return V?(V=(0,E.cloneAndChange)(V,j=>{if(J.uris&&J.uris[j])return p.URI.revive(J.uris[j])}),encodeURIComponent(JSON.stringify(V))):F},_e=function(F,V){const j=J.uris&&J.uris[F];let k=p.URI.revive(j);return V?F.startsWith(v.Schemas.data+":")?F:(k||(k=p.URI.parse(F)),v.FileAccess.asBrowserUri(k).toString(!0)):!k||p.URI.parse(F).toString()===k.toString()?F:(k.query&&(k=k.with({query:se(k.query)})),k.toString())},te=new b.marked.Renderer;te.image=S.image,te.link=S.link,te.paragraph=S.paragraph;const De=[];if(Q.codeBlockRenderer&&(te.code=(F,V)=>{const j=o.defaultGenerator.nextId(),k=Q.codeBlockRenderer(_(V),F);return De.push(k.then(c=>[j,c])),`<div class="code" data-code="${j}">${(0,l.escape)(F)}</div>`}),Q.actionHandler){const F=Q.actionHandler.disposables.add(new H.DomEmitter(he,"click")),V=Q.actionHandler.disposables.add(new H.DomEmitter(he,"auxclick"));Q.actionHandler.disposables.add(d.Event.any(F.event,V.event)(j=>{const k=new C.StandardMouseEvent(j);if(!k.leftButton&&!k.middleButton)return;let c=k.target;if(!(c.tagName!=="A"&&(c=c.parentElement,!c||c.tagName!=="A")))try{let I=c.dataset.href;I&&(J.baseUri&&(I=r(p.URI.from(J.baseUri),I)),Q.actionHandler.callback(I,k))}catch(I){(0,g.onUnexpectedError)(I)}finally{k.preventDefault()}}))}J.supportHtml||(ge.sanitizer=F=>(J.isTrusted?F.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?F:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=te;let re=J.value??"";re.length>1e5&&(re=`${re.substr(0,1e5)}\u2026`),J.supportThemeIcons&&(re=(0,N.markdownEscapeEscapedIcons)(re));let ie=b.marked.parse(re,ge);J.supportThemeIcons&&(ie=(0,w.renderLabelWithIcons)(ie).map(V=>typeof V=="string"?V:V.outerHTML).join(""));const ne=new DOMParser().parseFromString(n(J,ie),"text/html");if(ne.body.querySelectorAll("img").forEach(F=>{const V=F.getAttribute("src");if(V){let j=V;try{J.baseUri&&(j=r(p.URI.from(J.baseUri),j))}catch{}F.src=_e(j,!0)}}),ne.body.querySelectorAll("a").forEach(F=>{const V=F.getAttribute("href");if(F.setAttribute("href",""),!V||/^data:|javascript:/i.test(V)||/^command:/i.test(V)&&!J.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(V))F.replaceWith(...F.childNodes);else{let j=_e(V,!1);J.baseUri&&(j=r(p.URI.from(J.baseUri),V)),F.dataset.href=j}}),he.innerHTML=n(J,ne.body.innerHTML),De.length>0&&Promise.all(De).then(F=>{if(we)return;const V=new Map(F),j=he.querySelectorAll("div[data-code]");for(const k of j){const c=V.get(k.dataset.code??"");c&&y.reset(k,c)}Q.asyncRenderCallback?.()}),Q.asyncRenderCallback)for(const F of he.getElementsByTagName("img")){const V=oe.add(y.addDisposableListener(F,"load",()=>{V.dispose(),Q.asyncRenderCallback()}))}return{element:he,dispose:()=>{we=!0,oe.dispose()}}}t.renderMarkdown=T;function _(J){if(!J)return"";const Q=J.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:J}function r(J,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:J.path.endsWith("/")?(0,a.resolvePath)(J,Q).toString():(0,a.resolvePath)((0,a.dirname)(J),Q).toString()}function n(J,Q){const{config:ge,allowedSchemes:oe}=u(J);i.addHook("uponSanitizeAttribute",(he,se)=>{if(se.attrName==="style"||se.attrName==="class"){if(he.tagName==="SPAN"){if(se.attrName==="style"){se.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(se.attrValue);return}else if(se.attrName==="class"){se.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(se.attrValue);return}}se.keepAttr=!1;return}});const we=y.hookDomPurifyHrefAndSrcSanitizer(oe);try{return i.sanitize(Q,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),we.dispose()}}function u(J){const Q=[v.Schemas.http,v.Schemas.https,v.Schemas.mailto,v.Schemas.data,v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemote,v.Schemas.vscodeRemoteResource];return J.isTrusted&&Q.push(v.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function h(J){return typeof J=="string"?J:m(J)}t.renderStringAsPlaintext=h;function m(J){let Q=J.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const ge=b.marked.parse(Q,{renderer:$.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,oe=>z.get(oe)??oe);return n({isTrusted:!1},ge).toString()}t.renderMarkdownAsPlaintext=m;const z=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),$=new s.Lazy(()=>{const J=new b.marked.Renderer;return J.code=Q=>Q,J.blockquote=Q=>Q,J.html=Q=>"",J.heading=(Q,ge,oe)=>Q+`
`,J.hr=()=>"",J.list=(Q,ge)=>Q,J.listitem=Q=>Q+`
`,J.paragraph=Q=>Q+`
`,J.table=(Q,ge)=>Q+ge+`
`,J.tablerow=Q=>Q,J.tablecell=(Q,ge)=>Q+" ",J.strong=Q=>Q,J.em=Q=>Q,J.codespan=Q=>Q,J.br=()=>`
`,J.del=Q=>Q,J.image=(Q,ge,oe)=>"",J.text=Q=>Q,J.link=(Q,ge,oe)=>oe,J})}),define(me[121],pe([1,0,4,8,28,60,34,2,6,98]),function(Z,t,y,i,H,O,C,w,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(s,e){(0,g.isString)(e)?s.title=(0,C.stripIcons)(e):e?.markdownNotSupportedFallback?s.title=e.markdownNotSupportedFallback:s.removeAttribute("title")}t.setupNativeHover=f;class N{constructor(e,b,D){this.hoverDelegate=e,this.target=b,this.fadeInAnimation=D}async update(e,b,D){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let v;if(e===void 0||(0,g.isString)(e)||e instanceof HTMLElement)v=e;else if(!(0,g.isFunction)(e.markdown))v=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,d.localize)(0,null),b),this._cancellationTokenSource=new H.CancellationTokenSource;const E=this._cancellationTokenSource.token;if(v=await e.markdown(E),v===void 0&&(v=e.markdownNotSupportedFallback),this.isDisposed||E.isCancellationRequested)return}this.show(v,b,D)}show(e,b,D){const v=this._hoverWidget;if(this.hasContent(e)){const E={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!v,...D};this._hoverWidget=this.hoverDelegate.showHover(E,b)}v?.dispose()}hasContent(e){return e?(0,O.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function o(s,e,b,D){let v,E;const a=(_,r)=>{_&&(E?.dispose(),E=void 0),r&&(v?.dispose(),v=void 0),s.onDidHideHover?.()},l=(_,r,n)=>new i.TimeoutTimer(async()=>{(!E||E.isDisposed)&&(E=new N(s,n||e,_>0),await E.update(b,r,D))},_),p=()=>{if(v)return;const _=new w.DisposableStore,r=h=>a(!1,h.fromElement===e);_.add(y.addDisposableListener(e,y.EventType.MOUSE_LEAVE,r,!0));const n=()=>a(!0,!0);_.add(y.addDisposableListener(e,y.EventType.MOUSE_DOWN,n,!0));const u={targetElements:[e],dispose:()=>{}};if(s.placement===void 0||s.placement==="mouse"){const h=m=>{u.x=m.x+10,m.target instanceof HTMLElement&&m.target.classList.contains("action-label")&&a(!0,!0)};_.add(y.addDisposableListener(e,y.EventType.MOUSE_MOVE,h,!0))}_.add(l(s.delay,!1,u)),v=_},S=y.addDisposableListener(e,y.EventType.MOUSE_OVER,p,!0);return{show:_=>{a(!1,!0),l(0,_)},hide:()=>{a(!0,!0)},update:async(_,r)=>{b=_,await E?.update(b,void 0,r)},dispose:()=>{S.dispose(),a(!0,!0)}}}t.setupCustomHover=o}),define(me[122],pe([1,0,4,18,19,120,59,14,3,43,2,5,100,91]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const s=y.$,e="selectOption.entry.template";class b{get templateId(){return e}renderTemplate(E){const a=Object.create(null);return a.disposables=[],a.root=E,a.text=y.append(E,s(".option-text")),a.detail=y.append(E,s(".option-detail")),a.decoratorRight=y.append(E,s(".option-decorator-right")),a}renderElement(E,a,l){const p=l,S=E.text,T=E.detail,_=E.decoratorRight,r=E.isDisabled;p.text.textContent=S,p.detail.textContent=T||"",p.decoratorRight.innerText=_||"",r?p.root.classList.add("option-disabled"):p.root.classList.remove("option-disabled")}disposeTemplate(E){E.disposables=(0,f.dispose)(E.disposables)}}class D extends f.Disposable{constructor(E,a,l,p,S){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=S||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=D.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new g.Emitter,this._register(this._onDidSelect),this.styles=p,this.registerListeners(),this.constructSelectDropDown(l),this.selected=a||0,E&&this.setOptions(E,a)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(E){this.contextViewProvider=E,this.selectDropDownContainer=y.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=y.append(this.selectDropDownContainer,s(".select-box-details-pane"));const a=y.append(this.selectDropDownContainer,s(".select-box-dropdown-container-width-control")),l=y.append(a,s(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",y.append(l,this.widthControlElement),this._dropDownPosition=0,this.styleElement=y.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.DRAG_START,p=>{y.EventHelper.stop(p,!0)}))}registerListeners(){this._register(y.addStandardDisposableListener(this.selectElement,"change",a=>{this.selected=a.target.selectedIndex,this._onDidSelect.fire({index:a.target.selectedIndex,selected:a.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(y.addDisposableListener(this.selectElement,y.EventType.CLICK,a=>{y.EventHelper.stop(a),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.MOUSE_DOWN,a=>{y.EventHelper.stop(a)}));let E;this._register(y.addDisposableListener(this.selectElement,"touchstart",a=>{E=this._isVisible})),this._register(y.addDisposableListener(this.selectElement,"touchend",a=>{y.EventHelper.stop(a),E?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.KEY_DOWN,a=>{const l=new H.StandardKeyboardEvent(a);let p=!1;N.isMacintosh?(l.keyCode===18||l.keyCode===16||l.keyCode===10||l.keyCode===3)&&(p=!0):(l.keyCode===18&&l.altKey||l.keyCode===16&&l.altKey||l.keyCode===10||l.keyCode===3)&&(p=!0),p&&(this.showSelectDropDown(),y.EventHelper.stop(a,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(E,a){w.equals(this.options,E)||(this.options=E,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((l,p)=>{this.selectElement.add(this.createOption(l.text,p,l.isDisabled)),typeof l.description=="string"&&(this._hasDetails=!0)})),a!==void 0&&(this.select(a),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(E){E>=0&&E<this.options.length?this.selected=E:E>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(E){this.selectBoxOptions.ariaLabel=E,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(E){this.selectElement.tabIndex=E?0:-1}render(E){this.container=E,E.classList.add("select-container"),E.appendChild(this.selectElement),this.applyStyles()}style(E){const a=[];this.styles=E,this.styles.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=a.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"",a=this.styles.selectForeground?this.styles.selectForeground.toString():"",l=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=E,this.selectElement.style.color=a,this.selectElement.style.borderColor=l}this.selectList&&this.styleList()}styleList(){if(this.selectList){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const a=this.styles.selectListBackground?this.styles.selectListBackground.toString():E;this.selectDropDownListContainer.style.backgroundColor=a,this.selectionDetailsPane.style.backgroundColor=a;const l=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=l,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(E,a,l){const p=document.createElement("option");return p.value=E,p.text=E,p.disabled=!!l,p}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(E){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),E&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(E,a){return E.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(a),{dispose:()=>{try{E.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let E=0;return this.options.forEach((a,l)=>{this.updateDetail(l),this.selectionDetailsPane.offsetHeight>E&&(E=this.selectionDetailsPane.offsetHeight)}),E}layoutSelectDropDown(E){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const a=y.getDomNodePagePosition(this.selectElement),l=getComputedStyle(this.selectElement),p=parseFloat(l.getPropertyValue("--dropdown-padding-top"))+parseFloat(l.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-a.top-a.height-(this.selectBoxOptions.minBottomMargin||0),T=a.top-D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,_=this.selectElement.offsetWidth,r=this.setWidthControlElement(this.widthControlElement),n=Math.max(r,Math.round(_)).toString()+"px";this.selectDropDownContainer.style.width=n,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let u=this.selectList.contentHeight;const h=this._hasDetails?this.measureMaxDetailsHeight():0,m=u+p+h,z=Math.floor((S-p-h)/this.getHeight()),$=Math.floor((T-p-h)/this.getHeight());if(E)return a.top+a.height>window.innerHeight-22||a.top<D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||z<1&&$<1?!1:(z<D.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&$>z&&this.options.length>z?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(a.top+a.height>window.innerHeight-22||a.top<D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&z<1||this._dropDownPosition===1&&$<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&z+$<1)return this.hideSelectDropDown(!0),!1;m>S&&(u=z*this.getHeight())}else m>T&&(u=$*this.getHeight());return this.selectList.layout(u),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=u+p+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=u+p+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=n,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(E){let a=0;if(E){let l=0,p=0;this.options.forEach((S,T)=>{const _=S.detail?S.detail.length:0,r=S.decoratorRight?S.decoratorRight.length:0,n=S.text.length+_+r;n>p&&(l=T,p=n)}),E.textContent=this.options[l].text+(this.options[l].decoratorRight?this.options[l].decoratorRight+" ":""),a=y.getTotalWidth(E)}return a}createSelectList(E){if(this.selectList)return;this.selectDropDownListContainer=y.append(E,s(".select-box-dropdown-list-container")),this.listRenderer=new b,this.selectList=new C.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:p=>{let S=p.text;return p.detail&&(S+=`. ${p.detail}`),p.decoratorRight&&(S+=`. ${p.decoratorRight}`),p.description&&(S+=`. ${p.description}`),S},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const a=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),l=g.Event.chain(a.event).filter(()=>this.selectList.length>0).map(p=>new H.StandardKeyboardEvent(p));this._register(l.filter(p=>p.keyCode===3).on(p=>this.onEnter(p),this)),this._register(l.filter(p=>p.keyCode===2).on(p=>this.onEnter(p),this)),this._register(l.filter(p=>p.keyCode===9).on(p=>this.onEscape(p),this)),this._register(l.filter(p=>p.keyCode===16).on(p=>this.onUpArrow(p),this)),this._register(l.filter(p=>p.keyCode===18).on(p=>this.onDownArrow(p),this)),this._register(l.filter(p=>p.keyCode===12).on(this.onPageDown,this)),this._register(l.filter(p=>p.keyCode===11).on(this.onPageUp,this)),this._register(l.filter(p=>p.keyCode===14).on(this.onHome,this)),this._register(l.filter(p=>p.keyCode===13).on(this.onEnd,this)),this._register(l.filter(p=>p.keyCode>=21&&p.keyCode<=56||p.keyCode>=80&&p.keyCode<=108).on(this.onCharacter,this)),this._register(y.addDisposableListener(this.selectList.getHTMLElement(),y.EventType.POINTER_UP,p=>this.onPointerUp(p))),this._register(this.selectList.onMouseOver(p=>typeof p.index<"u"&&this.selectList.setFocus([p.index]))),this._register(this.selectList.onDidChangeFocus(p=>this.onListFocus(p))),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.FOCUS_OUT,p=>{!this._isVisible||y.isAncestor(p.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(E){if(!this.selectList.length)return;y.EventHelper.stop(E);const a=E.target;if(!a||a.classList.contains("slider"))return;const l=a.closest(".monaco-list-row");if(!l)return;const p=Number(l.getAttribute("data-index")),S=l.classList.contains("option-disabled");p>=0&&p<this.options.length&&!S&&(this.selected=p,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(E,a){const l=S=>{for(let T=0;T<S.childNodes.length;T++){const _=S.childNodes.item(T);(_.tagName&&_.tagName.toLowerCase())==="img"?S.removeChild(_):l(_)}},p=(0,O.renderMarkdown)({value:E},{actionHandler:a});return p.element.classList.add("select-box-description-markdown"),l(p.element),p.element}onListFocus(E){!this._isVisible||!this._hasDetails||this.updateDetail(E.indexes[0])}updateDetail(E){this.selectionDetailsPane.innerText="";const a=this.options[E],l=a?.description??"",p=a?.descriptionIsMarkdown??!1;if(l){if(p){const S=a.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(l,S))}else this.selectionDetailsPane.innerText=l;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(E){y.EventHelper.stop(E),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(E){y.EventHelper.stop(E),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(E){if(this.selected<this.options.length-1){y.EventHelper.stop(E,!0);const a=this.options[this.selected+1].isDisabled;if(a&&this.options.length>this.selected+2)this.selected+=2;else{if(a)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(E){this.selected>0&&(y.EventHelper.stop(E,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(E){y.EventHelper.stop(E),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(E){y.EventHelper.stop(E),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(E){y.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(E){y.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(E){const a=d.KeyCodeUtils.toString(E.keyCode);let l=-1;for(let p=0;p<this.options.length-1;p++)if(l=(p+this.selected+1)%this.options.length,this.options[l].text.charAt(0).toUpperCase()===a&&!this.options[l].isDisabled){this.select(l),this.selectList.setFocus([l]),this.selectList.reveal(this.selectList.getFocus()[0]),y.EventHelper.stop(E);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=D,D.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,D.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(me[123],pe([1,0,122,116,17,24,27,5,90]),function(Z,t,y,i,H,O,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:O.Color.fromHex("#3C3C3C"),selectForeground:O.Color.fromHex("#F0F0F0"),selectBorder:O.Color.fromHex("#3C3C3C")};class g extends H.Widget{constructor(f,N,o,s=(0,C.deepClone)(t.defaultStyles),e){super(),w.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(f,N,s,e):this.selectBoxDelegate=new y.SelectBoxList(f,N,o,s,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(f,N){this.selectBoxDelegate.setOptions(f,N)}select(f){this.selectBoxDelegate.select(f)}setAriaLabel(f){this.selectBoxDelegate.setAriaLabel(f)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(f){this.selectBoxDelegate.setFocusable(f)}render(f){this.selectBoxDelegate.render(f)}style(f){this.selectBoxDelegate.style(f)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=g}),define(me[61],pe([1,0,15,51,4,22,121,123,32,2,5,6,95,47]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class s extends d.Disposable{constructor(v,E,a={}){super(),this.options=a,this._context=v||this,this._action=E,E instanceof g.Action&&this._register(E.onDidChange(l=>{!this.element||this.handleActionChangeEvent(l)}))}get action(){return this._action}handleActionChangeEvent(v){v.enabled!==void 0&&this.updateEnabled(),v.checked!==void 0&&this.updateChecked(),v.class!==void 0&&this.updateClass(),v.label!==void 0&&(this.updateLabel(),this.updateTooltip()),v.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new g.ActionRunner)),this._actionRunner}set actionRunner(v){this._actionRunner=v}isEnabled(){return this._action.enabled}setActionContext(v){this._context=v}render(v){const E=this.element=v;this._register(O.Gesture.addTarget(v));const a=this.options&&this.options.draggable;a&&(v.draggable=!0,y.isFirefox&&this._register((0,H.addDisposableListener)(v,H.EventType.DRAG_START,l=>l.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,H.addDisposableListener)(E,O.EventType.Tap,l=>this.onClick(l,!0))),this._register((0,H.addDisposableListener)(E,H.EventType.MOUSE_DOWN,l=>{a||H.EventHelper.stop(l,!0),this._action.enabled&&l.button===0&&E.classList.add("active")})),f.isMacintosh&&this._register((0,H.addDisposableListener)(E,H.EventType.CONTEXT_MENU,l=>{l.button===0&&l.ctrlKey===!0&&this.onClick(l)})),this._register((0,H.addDisposableListener)(E,H.EventType.CLICK,l=>{H.EventHelper.stop(l,!0),this.options&&this.options.isMenu||this.onClick(l)})),this._register((0,H.addDisposableListener)(E,H.EventType.DBLCLICK,l=>{H.EventHelper.stop(l,!0)})),[H.EventType.MOUSE_UP,H.EventType.MOUSE_OUT].forEach(l=>{this._register((0,H.addDisposableListener)(E,l,p=>{H.EventHelper.stop(p),E.classList.remove("active")}))})}onClick(v,E=!1){H.EventHelper.stop(v,!0);const a=N.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?v:{preserveFocus:E}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(v){this.element&&(this.element.tabIndex=v?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const v=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(v):(this.customHover=(0,C.setupCustomHover)(this.options.hoverDelegate,this.element,v),this._store.add(this.customHover))):this.element.title=v}updateAriaLabel(){if(this.element){const v=this.getTooltip()??"";this.element.setAttribute("aria-label",v)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=s;class e extends s{constructor(v,E,a={}){super(v,E,a),this.options=a,this.options.icon=a.icon!==void 0?a.icon:!1,this.options.label=a.label!==void 0?a.label:!0,this.cssClass=""}render(v){super.render(v),this.element&&(this.label=(0,H.append)(this.element,(0,H.$)("a.action-label"))),this.label&&(this._action.id===g.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,H.append)(this.element,(0,H.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(v){this.label&&(this.label.tabIndex=v?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let v=null;return this.action.tooltip?v=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(v=this.action.label,this.options.keybinding&&(v=o.localize(0,null,v,this.options.keybinding))),v??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const v=this.getTooltip()??"";this.label.setAttribute("aria-label",v)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class b extends s{constructor(v,E,a,l,p,S){super(v,E),this.selectBox=new w.SelectBox(a,l,p,void 0,S),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(v,E){this.selectBox.setOptions(v,E)}select(v){this.selectBox.select(v)}registerListeners(){this._register(this.selectBox.onDidSelect(v=>{this.actionRunner.run(this._action,this.getActionContext(v.selected,v.index))}))}getActionContext(v,E){return v}setFocusable(v){this.selectBox.setFocusable(v)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(v){this.selectBox.render(v)}}t.SelectActionViewItem=b}),define(me[62],pe([1,0,4,19,61,32,3,2,6,47]),function(Z,t,y,i,H,O,C,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var d;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(d=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends w.Disposable{constructor(s,e={}){super(),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new C.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new C.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new C.Emitter),this.onDidRun=this._onDidRun.event,this._onBeforeRun=this._register(new C.Emitter),this.onBeforeRun=this._onBeforeRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new O.ActionRunner,this._register(this._actionRunner)),this._register(this._actionRunner.onDidRun(v=>this._onDidRun.fire(v))),this._register(this._actionRunner.onBeforeRun(v=>this._onBeforeRun.fire(v))),this._actionIds=[],this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let b,D;switch(this._orientation){case 0:b=[15],D=[17];break;case 1:b=[16],D=[18],this.domNode.className+=" vertical";break}this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_DOWN,v=>{const E=new i.StandardKeyboardEvent(v);let a=!0;const l=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;b&&(E.equals(b[0])||E.equals(b[1]))?a=this.focusPrevious():D&&(E.equals(D[0])||E.equals(D[1]))?a=this.focusNext():E.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():E.equals(14)?a=this.focusFirst():E.equals(13)?a=this.focusLast():E.equals(2)&&l instanceof H.BaseActionViewItem&&l.trapsArrowNavigation?a=this.focusNext():this.isTriggerKeyEvent(E)?this._triggerKeys.keyDown?this.doTrigger(E):this.triggerKeyDown=!0:a=!1,a&&(E.preventDefault(),E.stopPropagation())})),this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_UP,v=>{const E=new i.StandardKeyboardEvent(v);this.isTriggerKeyEvent(E)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(E)),E.preventDefault(),E.stopPropagation()):(E.equals(2)||E.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(y.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(y.getActiveElement()===this.domNode||!y.isAncestor(y.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const e=this.viewItems.find(b=>b instanceof H.BaseActionViewItem&&b.isEnabled());e instanceof H.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof H.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(s){let e=!1;return this._triggerKeys.keys.forEach(b=>{e=e||s.equals(b)}),e}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const e=this.actionsList.children[s];if(y.isAncestor(y.getActiveElement(),e)){this.focusedItem=s;break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(e=>e.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){s&&(this._actionRunner=s,this.viewItems.forEach(e=>e.actionRunner=s))}getContainer(){return this.domNode}hasAction(s){return this._actionIds.includes(s.id)}getAction(s){return this.viewItems[s].action}push(s,e={}){const b=Array.isArray(s)?s:[s];let D=g.isNumber(e.index)?e.index:null;b.forEach(v=>{const E=document.createElement("li");E.className="action-item",E.setAttribute("role","presentation");let a;this.options.actionViewItemProvider&&(a=this.options.actionViewItemProvider(v)),a||(a=new H.ActionViewItem(this.context,v,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(a,y.addDisposableListener(E,y.EventType.CONTEXT_MENU,l=>{y.EventHelper.stop(l,!0)})),a.actionRunner=this._actionRunner,a.setActionContext(this.context),a.render(E),this.focusable&&a instanceof H.BaseActionViewItem&&this.viewItems.length===0&&a.setFocusable(!0),D===null||D<0||D>=this.actionsList.children.length?(this.actionsList.appendChild(E),this.viewItems.push(a),this._actionIds.push(v.id)):(this.actionsList.insertBefore(E,this.actionsList.children[D]),this.viewItems.splice(D,0,a),this._actionIds.splice(D,0,v.id),D++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[s]),this.viewItemDisposables.get(this.viewItems[s])?.dispose(),this.viewItemDisposables.delete(this.viewItems[s]),(0,w.dispose)(this.viewItems.splice(s,1)),this._actionIds.splice(s,1),this.refreshRole())}clear(){(0,w.dispose)(this.viewItems),this.viewItemDisposables.forEach(s=>s.dispose()),this.viewItemDisposables.clear(),this.viewItems=[],this._actionIds=[],y.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let e=!1,b;if(s===void 0?e=!0:typeof s=="number"?b=s:typeof s=="boolean"&&(e=s),e&&typeof this.focusedItem>"u"){const D=this.viewItems.findIndex(v=>v.isEnabled());this.focusedItem=D===-1?void 0:D,this.updateFocus(void 0,void 0,!0)}else b!==void 0&&(this.focusedItem=b),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let b;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,b=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!b.isEnabled()||b.action.id===O.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let b;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}b=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!b.isEnabled()||b.action.id===O.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,e,b=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const D=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(D){let v=!0;g.isFunction(D.focus)||(v=!1),this.options.focusOnlyEnabledItems&&g.isFunction(D.isEnabled)&&!D.isEnabled()&&(v=!1),D.action.id===O.Separator.ID&&(v=!1),v?(b||this.previouslyFocusedItem!==this.focusedItem)&&(D.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(s){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof H.BaseActionViewItem){const b=e._context===null||e._context===void 0?s:e._context;this.run(e._action,b)}}async run(s,e){await this._actionRunner.run(s,e)}dispose(){(0,w.dispose)(this.viewItems),this.viewItems=[],this._actionIds=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function N(o){if(!o.length)return o;let s=-1;for(let b=0;b<o.length;b++)if(o[b].id!==O.Separator.ID){s=b;break}if(s===-1)return[];o=o.slice(s);for(let b=o.length-1;b>=0&&o[b].id===O.Separator.ID;b--)o.splice(b,1);let e=!1;for(let b=o.length-1;b>=0;b--){const D=o[b].id===O.Separator.ID;D&&!e?o.splice(b,1):D?D&&(e=!1):e=!0}return o}t.prepareActions=N}),define(me[124],pe([1,0,4,18,52,62,54,57,17,24,3,77,27,99,87]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=y.$;var b;(function(a){a[a.INFO=1]="INFO",a[a.WARNING=2]="WARNING",a[a.ERROR=3]="ERROR"})(b=t.MessageType||(t.MessageType={}));const D={inputBackground:d.Color.fromHex("#3C3C3C"),inputForeground:d.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:d.Color.fromHex("#55AAFF"),inputValidationInfoBackground:d.Color.fromHex("#063B49"),inputValidationWarningBorder:d.Color.fromHex("#B89500"),inputValidationWarningBackground:d.Color.fromHex("#352A05"),inputValidationErrorBorder:d.Color.fromHex("#BE1100"),inputValidationErrorBackground:d.Color.fromHex("#5A1D1D")};class v extends g.Widget{constructor(l,p,S){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new f.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=p,this.options=S||Object.create(null),(0,o.mixin)(this.options,D,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=y.append(l,e(".monaco-inputbox.idle"));const T=this.options.flexibleHeight?"textarea":"input",_=y.append(this.element,e(".ibwrapper"));if(this.input=y.append(_,e(T+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=y.append(_,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new w.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),y.append(l,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(u=>this.input.scrollTop=u.scrollTop));const r=this._register(new i.DomEmitter(document,"selectionchange")),n=f.Event.filter(r.event,()=>document.getSelection()?.anchorNode===_);this._register(n(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new O.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(l){this.placeholder=l,this.input.setAttribute("placeholder",l)}setTooltip(l){this.tooltip=l,this.input.title=l}setAriaLabel(l){this.ariaLabel=l,l?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(l){this.input.value!==l&&(this.input.value=l,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:y.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(l=null){this.input.select(),l&&(this.input.setSelectionRange(l.start,l.end),l.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(l){l?this.enable():this.disable()}get width(){return y.getTotalWidth(this.input)}set width(l){if(this.options.flexibleHeight&&this.options.flexibleWidth){let p=0;if(this.mirror){const S=parseFloat(this.mirror.style.paddingLeft||"")||0,T=parseFloat(this.mirror.style.paddingRight||"")||0;p=S+T}this.input.style.width=l-p+"px"}else this.input.style.width=l+"px";this.mirror&&(this.mirror.style.width=l+"px")}set paddingRight(l){this.input.style.width=`calc(100% - ${l}px)`,this.mirror&&(this.mirror.style.paddingRight=l+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const l=this.cachedContentHeight,p=this.cachedHeight,S=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:l,height:p}),this.scrollableElement.setScrollPosition({scrollTop:S})}showMessage(l,p){this.message=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(l.type));const S=this.stylesForType(this.message.type);this.element.style.border=S.border?`1px solid ${S.border}`:"",(this.hasFocus()||p)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let l=null;return this.validation&&(l=this.validation(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){switch(l){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let l;const p=()=>l.style.width=y.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:T=>{if(!this.message)return null;l=y.append(T,e(".monaco-inputbox-container")),p();const _={inline:!0,className:"monaco-inputbox-message"},r=this.message.formatContent?(0,H.renderFormattedText)(this.message.content,_):(0,H.renderText)(this.message.content,_);r.classList.add(this.classForType(this.message.type));const n=this.stylesForType(this.message.type);return r.style.backgroundColor=n.background?n.background.toString():"",r.style.color=n.foreground?n.foreground.toString():"",r.style.border=n.border?`1px solid ${n.border}`:"",y.append(l,r),null},onHide:()=>{this.state="closed"},layout:p});let S;this.message.type===3?S=s.localize(0,null,this.message.content):this.message.type===2?S=s.localize(1,null,this.message.content):S=s.localize(2,null,this.message.content),C.alert(S),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const l=this.value,S=l.charCodeAt(l.length-1)===10?" ":"";(l+S).replace(/\u000c/g,"")?this.mirror.textContent=l+S:this.mirror.innerText="\xA0",this.layout()}style(l){this.inputBackground=l.inputBackground,this.inputForeground=l.inputForeground,this.inputBorder=l.inputBorder,this.inputValidationInfoBackground=l.inputValidationInfoBackground,this.inputValidationInfoForeground=l.inputValidationInfoForeground,this.inputValidationInfoBorder=l.inputValidationInfoBorder,this.inputValidationWarningBackground=l.inputValidationWarningBackground,this.inputValidationWarningForeground=l.inputValidationWarningForeground,this.inputValidationWarningBorder=l.inputValidationWarningBorder,this.inputValidationErrorBackground=l.inputValidationErrorBackground,this.inputValidationErrorForeground=l.inputValidationErrorForeground,this.inputValidationErrorBorder=l.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const l=this.inputBackground?this.inputBackground.toString():"",p=this.inputForeground?this.inputForeground.toString():"",S=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=l,this.element.style.color=p,this.input.style.backgroundColor="inherit",this.input.style.color=p,this.element.style.borderWidth=S?"1px":"",this.element.style.borderStyle=S?"solid":"",this.element.style.borderColor=S}layout(){if(!this.mirror)return;const l=this.cachedContentHeight;this.cachedContentHeight=y.getTotalHeight(this.mirror),l!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(l){const p=this.inputElement,S=p.selectionStart,T=p.selectionEnd,_=p.value;S!==null&&T!==null&&(this.value=_.substr(0,S)+l+_.substr(T),p.setSelectionRange(S+1,S+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=v;class E extends v{constructor(l,p,S){const T=s.localize(3,null),_=` or \u21C5 ${T}`,r=` (\u21C5 ${T})`;super(l,p,S),this._onDidFocus=this._register(new f.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new f.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new N.HistoryNavigator(S.history,100);const n=()=>{if(S.showHistoryHint&&S.showHistoryHint()&&!this.placeholder.endsWith(_)&&!this.placeholder.endsWith(r)&&this.history.getHistory().length){const u=this.placeholder.endsWith(")")?_:r,h=this.placeholder+u;S.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=h:this.setPlaceHolder(h)}};this.observer=new MutationObserver((u,h)=>{u.forEach(m=>{m.target.textContent||n()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>n()),this.onblur(this.input,()=>{const u=h=>{if(this.placeholder.endsWith(h)){const m=this.placeholder.slice(0,this.placeholder.length-h.length);return S.showPlaceholderOnFocus?this.placeholder=m:this.setPlaceHolder(m),!0}else return!1};u(r)||u(_)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let l=this.getNextValue();l&&(l=l===this.value?this.getNextValue():l),l&&(this.value=l,C.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let l=this.getPreviousValue();l&&(l=l===this.value?this.getPreviousValue():l),l&&(this.value=l,C.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let l=this.history.current();return l||(l=this.history.last(),this.history.next()),l}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=E}),define(me[63],pe([1,0,61,17,11,24,3,92]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const w={inputActiveOptionBorder:O.Color.fromHex("#007ACC00"),inputActiveOptionForeground:O.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:O.Color.fromHex("#0E639C50")};class g extends y.BaseActionViewItem{constructor(o,s,e){super(o,s,e),this.toggle=this._register(new d({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(o){this.element=o,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.ToggleActionViewItem=g;class d extends i.Widget{constructor(o){super(),this._onChange=this._register(new C.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new C.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...w,...o},this._checked=this._opts.isChecked;const s=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,s.push(...H.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&s.push(...this._opts.actionClassName.split(" ")),this._checked&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...s),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(o){this._checked=o,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(o){this._icon&&this.domNode.classList.remove(...H.CSSIcon.asClassNameArray(this._icon)),this._icon=o,this._icon&&this.domNode.classList.add(...H.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(o){o.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=o.inputActiveOptionBorder),o.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=o.inputActiveOptionForeground),o.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=o.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this.domNode.title=o,this.domNode.setAttribute("aria-label",o)}}t.Toggle=d;class f extends i.Widget{constructor(o,s){super(),this.title=o,this.isChecked=s,this.checkbox=new d({title:this.title,isChecked:this.isChecked,icon:H.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(o){this.checkbox.checked=o,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(o){this.styles=o,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=f}),define(me[125],pe([1,0,63,11,97]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const O=H.localize(0,null),C=H.localize(1,null),w=H.localize(2,null);class g extends y.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:O+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=g;class d extends y.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:C+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=d;class f extends y.Toggle{constructor(o){super({icon:i.Codicon.regex,title:w+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=f}),define(me[126],pe([1,0,4,125,124,17,3,96,2,86]),function(Z,t,y,i,H,O,C,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const d=w.localize(0,null);class f extends O.Widget{constructor(o,s,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new g.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new C.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new C.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new C.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new C.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new C.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new C.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new C.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||d,this.showCommonFindToggles=!!e.showCommonFindToggles,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const b=e.appendCaseSensitiveLabel||"",D=e.appendWholeWordsLabel||"",v=e.appendRegexLabel||"",E=e.history||[],a=!!e.flexibleHeight,l=!!e.flexibleWidth,p=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new H.HistoryInputBox(this.domNode,s,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:E,showHistoryHint:e.showHistoryHint,flexibleHeight:a,flexibleWidth:l,flexibleMaxHeight:p})),this.regex=this._register(new i.RegexToggle({appendTitle:v,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(T=>{this._onRegexKeyDown.fire(T)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:D,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:b,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(T=>{this._onCaseSensitiveKeyDown.fire(T)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,T=>{if(T.equals(15)||T.equals(17)||T.equals(9)){const _=S.indexOf(document.activeElement);if(_>=0){let r=-1;T.equals(17)?r=(_+1)%S.length:T.equals(15)&&(_===0?r=S.length-1:r=_-1),T.equals(9)?(S[_].blur(),this.inputBox.focus()):r>=0&&S[r].focus(),y.EventHelper.stop(T,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this.showCommonFindToggles||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none"),this.setAdditionalToggles(e?.additionalToggles),this.domNode.appendChild(this.controls),o?.appendChild(this.domNode),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionstart",T=>{this.imeSessionInProgress=!0})),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionend",T=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,T=>this._onKeyDown.fire(T)),this.onkeyup(this.inputBox.inputElement,T=>this._onKeyUp.fire(T)),this.oninput(this.inputBox.inputElement,T=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,T=>this._onMouseDown.fire(T))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const o of this.additionalToggles)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const o of this.additionalToggles)o.disable()}setFocusInputOnOptionClick(o){this.fixFocusOnOptionClickEnabled=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const s of this.additionalToggles)s.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new g.DisposableStore;for(const s of o??[])this.additionalTogglesDisposables.add(s),this.controls.appendChild(s.domNode),this.additionalTogglesDisposables.add(s.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(s);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this.showCommonFindToggles?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((s,e)=>s+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}style(o){this.inputActiveOptionBorder=o.inputActiveOptionBorder,this.inputActiveOptionForeground=o.inputActiveOptionForeground,this.inputActiveOptionBackground=o.inputActiveOptionBackground,this.inputBackground=o.inputBackground,this.inputForeground=o.inputForeground,this.inputBorder=o.inputBorder,this.inputValidationInfoBackground=o.inputValidationInfoBackground,this.inputValidationInfoForeground=o.inputValidationInfoForeground,this.inputValidationInfoBorder=o.inputValidationInfoBorder,this.inputValidationWarningBackground=o.inputValidationWarningBackground,this.inputValidationWarningForeground=o.inputValidationWarningForeground,this.inputValidationWarningBorder=o.inputValidationWarningBorder,this.inputValidationErrorBackground=o.inputValidationErrorBackground,this.inputValidationErrorForeground=o.inputValidationErrorForeground,this.inputValidationErrorBorder=o.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const o={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(o),this.wholeWords.style(o),this.caseSensitive.style(o);for(const e of this.additionalToggles)e.style(o);const s={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(s)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(o){this.caseSensitive.checked=o}getWholeWords(){return this.wholeWords.checked}setWholeWords(o){this.wholeWords.checked=o}getRegex(){return this.regex.checked}setRegex(o){this.regex.checked=o,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(me[127],pe([1,0,4,18,19,62,126,58,59,63,55,23,32,14,8,11,70,3,33,2,45,6,101,93]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s,e,b,D,v,E,a,l,p,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class T extends w.ElementsDragAndDropData{constructor(F){super(F.elements.map(V=>V.element)),this.data=F}set context(F){this.data.context=F}get context(){return this.data.context}}function _(ne){return ne instanceof w.ElementsDragAndDropData?new T(ne):ne}class r{constructor(F,V){this.modelProvider=F,this.dnd=V,this.autoExpandDisposable=a.Disposable.None}getDragURI(F){return this.dnd.getDragURI(F.element)}getDragLabel(F,V){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(F.map(j=>j.element),V)}onDragStart(F,V){this.dnd.onDragStart?.(_(F),V)}onDragOver(F,V,j,k,c=!0){const I=this.dnd.onDragOver(_(F),V&&V.element,j,k),U=this.autoExpandNode!==V;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=V),typeof V>"u")return I;if(U&&typeof I!="boolean"&&I.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const W=this.modelProvider(),A=W.getNodeLocation(V);W.isCollapsed(A)&&W.setCollapsed(A,!1),this.autoExpandNode=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble>"u"||I.feedback){if(!c){const W=typeof I=="boolean"?I:I.accept,A=typeof I=="boolean"?void 0:I.effect;return{accept:W,effect:A,feedback:[j]}}return I}if(I.bubble===1){const W=this.modelProvider(),A=W.getNodeLocation(V),P=W.getParentNodeLocation(A),M=W.getNode(P),B=P&&W.getListIndex(P);return this.onDragOver(F,M,B,k,!1)}const K=this.modelProvider(),X=K.getNodeLocation(V),L=K.getListIndex(X),R=K.getListRenderCount(X);return{...I,feedback:(0,s.range)(L,L+R)}}drop(F,V,j,k){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(_(F),V&&V.element,j,k)}onDragEnd(F){this.dnd.onDragEnd?.(F)}}function n(ne,F){return F&&{...F,identityProvider:F.identityProvider&&{getId(V){return F.identityProvider.getId(V.element)}},dnd:F.dnd&&new r(ne,F.dnd),multipleSelectionController:F.multipleSelectionController&&{isSelectionSingleChangeEvent(V){return F.multipleSelectionController.isSelectionSingleChangeEvent({...V,element:V.element})},isSelectionRangeChangeEvent(V){return F.multipleSelectionController.isSelectionRangeChangeEvent({...V,element:V.element})}},accessibilityProvider:F.accessibilityProvider&&{...F.accessibilityProvider,getSetSize(V){const j=ne(),k=j.getNodeLocation(V),c=j.getParentNodeLocation(k);return j.getNode(c).visibleChildrenCount},getPosInSet(V){return V.visibleChildIndex+1},isChecked:F.accessibilityProvider&&F.accessibilityProvider.isChecked?V=>F.accessibilityProvider.isChecked(V.element):void 0,getRole:F.accessibilityProvider&&F.accessibilityProvider.getRole?V=>F.accessibilityProvider.getRole(V.element):()=>"treeitem",getAriaLabel(V){return F.accessibilityProvider.getAriaLabel(V.element)},getWidgetAriaLabel(){return F.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:F.accessibilityProvider&&F.accessibilityProvider.getWidgetRole?()=>F.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:F.accessibilityProvider&&F.accessibilityProvider.getAriaLevel?V=>F.accessibilityProvider.getAriaLevel(V.element):V=>V.depth,getActiveDescendantId:F.accessibilityProvider.getActiveDescendantId&&(V=>F.accessibilityProvider.getActiveDescendantId(V.element))},keyboardNavigationLabelProvider:F.keyboardNavigationLabelProvider&&{...F.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(V){return F.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(V.element)}}}}class u{constructor(F){this.delegate=F}getHeight(F){return this.delegate.getHeight(F.element)}getTemplateId(F){return this.delegate.getTemplateId(F.element)}hasDynamicHeight(F){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(F.element)}setDynamicHeight(F,V){this.delegate.setDynamicHeight?.(F.element,V)}}t.ComposedTreeDelegate=u;class h{constructor(F){if(this.focus=new Set(F.focus),this.selection=new Set(F.selection),F.expanded instanceof Array){this.expanded=Object.create(null);for(const V of F.expanded)this.expanded[V]=1}else this.expanded=F.expanded;this.expanded=F.expanded,this.scrollTop=F.scrollTop}static lift(F){return F instanceof h?F:new h(F)}static empty(F=0){return new h({focus:[],selection:[],expanded:Object.create(null),scrollTop:F})}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=h;var m;(function(ne){ne.None="none",ne.OnHover="onHover",ne.Always="always"})(m=t.RenderIndentGuides||(t.RenderIndentGuides={}));class z{constructor(F,V=[]){this._elements=V,this.disposables=new a.DisposableStore,this.onDidChange=v.Event.forEach(F,j=>this._elements=j,this.disposables)}get elements(){return this._elements}dispose(){this.disposables.dispose()}}class ${constructor(F,V,j,k,c={}){this.renderer=F,this.modelProvider=V,this.activeNodes=k,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=$.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new D.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=a.Disposable.None,this.disposables=new a.DisposableStore,this.templateId=F.templateId,this.updateOptions(c),v.Event.map(j,I=>I.node)(this.onDidChangeNodeTwistieState,this,this.disposables),F.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(F={}){if(typeof F.indent<"u"&&(this.indent=(0,l.clamp)(F.indent,0,40)),typeof F.renderIndentGuides<"u"){const V=F.renderIndentGuides!==m.None;if(V!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=V,this.indentGuidesDisposable.dispose(),V)){const j=new a.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,j),this.indentGuidesDisposable=j,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof F.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=F.hideTwistiesOfChildlessElements)}renderTemplate(F){const V=(0,y.append)(F,(0,y.$)(".monaco-tl-row")),j=(0,y.append)(V,(0,y.$)(".monaco-tl-indent")),k=(0,y.append)(V,(0,y.$)(".monaco-tl-twistie")),c=(0,y.append)(V,(0,y.$)(".monaco-tl-contents")),I=this.renderer.renderTemplate(c);return{container:F,indent:j,twistie:k,indentGuidesDisposable:a.Disposable.None,templateData:I}}renderElement(F,V,j,k){typeof k=="number"&&(this.renderedNodes.set(F,{templateData:j,height:k}),this.renderedElements.set(F.element,F));const c=$.DefaultIndent+(F.depth-1)*this.indent;j.twistie.style.paddingLeft=`${c}px`,j.indent.style.width=`${c+this.indent-16}px`,this.renderTwistie(F,j),typeof k=="number"&&this.renderIndentGuides(F,j),this.renderer.renderElement(F,V,j.templateData,k)}disposeElement(F,V,j,k){j.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(F,V,j.templateData,k),typeof k=="number"&&(this.renderedNodes.delete(F),this.renderedElements.delete(F.element))}disposeTemplate(F){this.renderer.disposeTemplate(F.templateData)}onDidChangeTwistieState(F){const V=this.renderedElements.get(F);!V||this.onDidChangeNodeTwistieState(V)}onDidChangeNodeTwistieState(F){const V=this.renderedNodes.get(F);!V||(this.renderTwistie(F,V.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(F,V.templateData))}renderTwistie(F,V){V.twistie.classList.remove(...b.Codicon.treeItemExpanded.classNamesArray);let j=!1;this.renderer.renderTwistie&&(j=this.renderer.renderTwistie(F.element,V.twistie)),F.collapsible&&(!this.hideTwistiesOfChildlessElements||F.visibleChildrenCount>0)?(j||V.twistie.classList.add(...b.Codicon.treeItemExpanded.classNamesArray),V.twistie.classList.add("collapsible"),V.twistie.classList.toggle("collapsed",F.collapsed)):V.twistie.classList.remove("collapsible","collapsed"),F.collapsible?V.container.setAttribute("aria-expanded",String(!F.collapsed)):V.container.removeAttribute("aria-expanded")}renderIndentGuides(F,V){if((0,y.clearNode)(V.indent),V.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const j=new a.DisposableStore,k=this.modelProvider();let c=F;for(;;){const I=k.getNodeLocation(c),U=k.getParentNodeLocation(I);if(!U)break;const K=k.getNode(U),X=(0,y.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(K)&&X.classList.add("active"),V.indent.childElementCount===0?V.indent.appendChild(X):V.indent.insertBefore(X,V.indent.firstElementChild),this.renderedIndentGuides.add(K,X),j.add((0,a.toDisposable)(()=>this.renderedIndentGuides.delete(K,X))),c=K}V.indentGuidesDisposable=j}_onDidChangeActiveNodes(F){if(!this.shouldRenderIndentGuides)return;const V=new Set,j=this.modelProvider();F.forEach(k=>{const c=j.getNodeLocation(k);try{const I=j.getParentNodeLocation(c);k.collapsible&&k.children.length>0&&!k.collapsed?V.add(k):I&&V.add(j.getNode(I))}catch{}}),this.activeIndentNodes.forEach(k=>{V.has(k)||this.renderedIndentGuides.forEach(k,c=>c.classList.remove("active"))}),V.forEach(k=>{this.activeIndentNodes.has(k)||this.renderedIndentGuides.forEach(k,c=>c.classList.add("active"))}),this.activeIndentNodes=V}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,a.dispose)(this.disposables)}}$.DefaultIndent=8;class J{constructor(F,V,j){this.tree=F,this.keyboardNavigationLabelProvider=V,this._filter=j,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new a.DisposableStore,F.onWillRefilter(this.reset,this,this.disposables)}get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(F){this._pattern=F,this._lowercasePattern=F.toLowerCase()}filter(F,V){let j=1;if(this._filter){const I=this._filter.filter(F,V);if(typeof I=="boolean"?j=I?1:0:(0,f.isFilterResult)(I)?j=(0,f.getVisibleState)(I.visibility):j=I,j===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:E.FuzzyScore.Default,visibility:j};const k=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(F),c=Array.isArray(k)?k:[k];for(const I of c){const U=I&&I.toString();if(typeof U>"u")return{data:E.FuzzyScore.Default,visibility:j};const K=(0,E.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return this._matchCount++,c.length===1?{data:K,visibility:j}:{data:{label:U,score:K},visibility:j}}return this.tree.findMode===ge.Filter?2:{data:E.FuzzyScore.Default,visibility:j}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,a.dispose)(this.disposables)}}class Q extends d.Toggle{constructor(F){super({icon:b.Codicon.listFilter,title:(0,S.localize)(0,null),isChecked:F?.isChecked??!1,inputActiveOptionBorder:F?.inputActiveOptionBorder,inputActiveOptionForeground:F?.inputActiveOptionForeground,inputActiveOptionBackground:F?.inputActiveOptionBackground})}}t.ModeToggle=Q;var ge;(function(ne){ne[ne.Highlight=0]="Highlight",ne[ne.Filter=1]="Filter"})(ge=t.TreeFindMode||(t.TreeFindMode={}));class oe extends a.Disposable{constructor(F,V,j,k,c){super(),this.tree=V,this.elements=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this._onDidDisable=new v.Emitter,this.onDidDisable=this._onDidDisable.event,F.appendChild(this.elements.root),this._register((0,a.toDisposable)(()=>F.removeChild(this.elements.root))),this.modeToggle=this._register(new Q({...c,isChecked:k===ge.Filter})),this.onDidChangeMode=v.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?ge.Filter:ge.Highlight,this._store),this.findInput=this._register(new C.FindInput(this.elements.findInput,j,{label:(0,S.localize)(3,null),additionalToggles:[this.modeToggle],showCommonFindToggles:!1})),this.actionbar=this._register(new O.ActionBar(this.elements.actionbar)),this.mode=k;const I=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(v.Event.chain(I.event)).map(R=>new H.StandardKeyboardEvent(R)).event;this._register(U(R=>{switch(R.keyCode){case 18:R.preventDefault(),R.stopPropagation(),this.tree.domFocus();return}}));const K=this._register(new o.Action("close",(0,S.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(K,{icon:!0,label:!1});const X=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(X.event(R=>{const W=new a.DisposableStore,A=W.add(new i.DomEmitter(window,"mousemove")),P=W.add(new i.DomEmitter(window,"mouseup")),M=this.right,B=R.pageX;this.elements.grab.classList.add("grabbing");const q=ee=>{const le=ee.pageX-B;this.right=M-le,this.layout()};W.add(A.event(q)),W.add(P.event(ee=>{q(ee),this.elements.grab.classList.remove("grabbing"),W.dispose()}))}));const L=this._register(v.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(R=>new H.StandardKeyboardEvent(R)).event;this._register(L(R=>{let W;R.keyCode===15?W=Number.POSITIVE_INFINITY:R.keyCode===17?W=0:R.keyCode===10&&(W=this.right===0?Number.POSITIVE_INFINITY:0),W!==void 0&&(R.preventDefault(),R.stopPropagation(),this.right=W,this.layout())})),this.onDidChangeValue=this.findInput.onDidChange,this.style(c??{})}set mode(F){this.modeToggle.checked=F===ge.Filter,this.findInput.inputBox.setPlaceHolder(F===ge.Filter?(0,S.localize)(1,null):(0,S.localize)(2,null))}style(F){this.findInput.style(F),F.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=F.listFilterWidgetBackground.toString()),F.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${F.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(F=this.width){this.width=F,this.right=(0,l.clamp)(this.right,0,Math.max(0,F-212)),this.elements.root.style.right=`${this.right}px`}showMessage(F){this.findInput.showMessage(F)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class we{constructor(F,V,j,k,c){this.tree=F,this.view=j,this.filter=k,this.contextViewProvider=c,this._pattern="",this.width=0,this._onDidChangeMode=new v.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new v.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new v.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new a.DisposableStore,this.disposables=new a.DisposableStore,this._mode=F.options.defaultFindMode??ge.Highlight,V.onDidSplice(this.onDidSpliceModel,this,this.disposables)}get pattern(){return this._pattern}get mode(){return this._mode}set mode(F){F!==this._mode&&(this._mode=F,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(F))}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??ge.Highlight,this.widget=new oe(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(F=>this.mode=F,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new a.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(F){this._pattern=F,this._onDidChangePattern.fire(F),this.filter.pattern=F,this.tree.refilter(),F&&this.tree.focusNext(0,!0,void 0,j=>!E.FuzzyScore.isDefault(j.filterData));const V=this.tree.getFocus();if(V.length>0){const j=V[0];this.tree.getRelativeTop(j)===null&&this.tree.reveal(j,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const F=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&F?this.widget?.showMessage({type:2,content:(0,S.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(F){return!this.widget||!this.pattern||this._mode===ge.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!E.FuzzyScore.isDefault(F.filterData)}style(F){this.styles=F,this.widget?.style(F)}layout(F){this.width=F,this.widget?.layout(F)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function he(ne){let F=N.TreeMouseEventTarget.Unknown;return(0,y.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?F=N.TreeMouseEventTarget.Twistie:(0,y.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?F=N.TreeMouseEventTarget.Element:(0,y.hasParentWithClass)(ne.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(F=N.TreeMouseEventTarget.Filter),{browserEvent:ne.browserEvent,element:ne.element?ne.element.element:null,target:F}}function se(ne){return{element:ne.element?ne.element.element:null,browserEvent:ne.browserEvent,anchor:ne.anchor}}function _e(ne,F){F(ne),ne.children.forEach(V=>_e(V,F))}class te{constructor(F,V){this.getFirstViewElementWithTrait=F,this.identityProvider=V,this.nodes=[],this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event}get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}set(F,V){!V?.__forceEvent&&(0,s.equals)(this.nodes,F)||this._set(F,!1,V)}_set(F,V,j){if(this.nodes=[...F],this.elements=void 0,this._nodeSet=void 0,!V){const k=this;this._onDidChange.fire({get elements(){return k.get()},browserEvent:j})}}get(){return this.elements||(this.elements=this.nodes.map(F=>F.element)),[...this.elements]}getNodes(){return this.nodes}has(F){return this.nodeSet.has(F)}onDidModelSplice({insertedNodes:F,deletedNodes:V}){if(!this.identityProvider){const K=this.createNodeSet(),X=L=>K.delete(L);V.forEach(L=>_e(L,X)),this.set([...K.values()]);return}const j=new Set,k=K=>j.add(this.identityProvider.getId(K.element).toString());V.forEach(K=>_e(K,k));const c=new Map,I=K=>c.set(this.identityProvider.getId(K.element).toString(),K);F.forEach(K=>_e(K,I));const U=[];for(const K of this.nodes){const X=this.identityProvider.getId(K.element).toString();if(!j.has(X))U.push(K);else{const R=c.get(X);R&&U.push(R)}}if(this.nodes.length>0&&U.length===0){const K=this.getFirstViewElementWithTrait();K&&U.push(K)}this._set(U,!0)}createNodeSet(){const F=new Set;for(const V of this.nodes)F.add(V);return F}}class De extends g.MouseController{constructor(F,V){super(F),this.tree=V}onViewPointer(F){if((0,g.isButton)(F.browserEvent.target)||(0,g.isInputElement)(F.browserEvent.target)||(0,g.isMonacoEditor)(F.browserEvent.target))return;const V=F.element;if(!V)return super.onViewPointer(F);if(this.isSelectionRangeChangeEvent(F)||this.isSelectionSingleChangeEvent(F))return super.onViewPointer(F);const j=F.browserEvent.target,k=j.classList.contains("monaco-tl-twistie")||j.classList.contains("monaco-icon-label")&&j.classList.contains("folder-icon")&&F.browserEvent.offsetX<16;let c=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?c=this.tree.expandOnlyOnTwistieClick(V.element):c=!!this.tree.expandOnlyOnTwistieClick,c&&!k&&F.browserEvent.detail!==2)return super.onViewPointer(F);if(!this.tree.expandOnDoubleClick&&F.browserEvent.detail===2)return super.onViewPointer(F);if(V.collapsible){const I=this.tree.model,U=I.getNodeLocation(V),K=F.browserEvent.altKey;if(this.tree.setFocus([U]),I.setCollapsed(U,void 0,K),c&&k)return}super.onViewPointer(F)}onDoubleClick(F){F.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(F)}}class re extends g.List{constructor(F,V,j,k,c,I,U,K){super(F,V,j,k,K),this.focusTrait=c,this.selectionTrait=I,this.anchorTrait=U}createMouseController(F){return new De(this,F.tree)}splice(F,V,j=[]){if(super.splice(F,V,j),j.length===0)return;const k=[],c=[];let I;j.forEach((U,K)=>{this.focusTrait.has(U)&&k.push(F+K),this.selectionTrait.has(U)&&c.push(F+K),this.anchorTrait.has(U)&&(I=F+K)}),k.length>0&&super.setFocus((0,s.distinct)([...super.getFocus(),...k])),c.length>0&&super.setSelection((0,s.distinct)([...super.getSelection(),...c])),typeof I=="number"&&super.setAnchor(I)}setFocus(F,V,j=!1){super.setFocus(F,V),j||this.focusTrait.set(F.map(k=>this.element(k)),V)}setSelection(F,V,j=!1){super.setSelection(F,V),j||this.selectionTrait.set(F.map(k=>this.element(k)),V)}setAnchor(F,V=!1){super.setAnchor(F),V||(typeof F>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(F)]))}}class ie{constructor(F,V,j,k,c={}){this._user=F,this._options=c,this.eventBufferer=new v.EventBufferer,this.onDidChangeFindOpenState=v.Event.None,this.disposables=new a.DisposableStore,this._onWillRefilter=new v.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new v.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const I=new u(j),U=new v.Relay,K=new v.Relay,X=this.disposables.add(new z(K.event));this.renderers=k.map(W=>new $(W,()=>this.model,U.event,X,c));for(const W of this.renderers)this.disposables.add(W);let L;c.keyboardNavigationLabelProvider&&(L=new J(this,c.keyboardNavigationLabelProvider,c.filter),c={...c,filter:L},this.disposables.add(L)),this.focus=new te(()=>this.view.getFocusedElements()[0],c.identityProvider),this.selection=new te(()=>this.view.getSelectedElements()[0],c.identityProvider),this.anchor=new te(()=>this.view.getAnchorElement(),c.identityProvider),this.view=new re(F,V,I,this.renderers,this.focus,this.selection,this.anchor,{...n(()=>this.model,c),tree:this}),this.model=this.createModel(F,this.view,c),U.input=this.model.onDidChangeCollapseState;const R=v.Event.forEach(this.model.onDidSplice,W=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(W),this.selection.onDidModelSplice(W)})},this.disposables);if(R(()=>null,null,this.disposables),K.input=v.Event.chain(v.Event.any(R,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const W=new Set;for(const A of this.focus.getNodes())W.add(A);for(const A of this.selection.getNodes())W.add(A);return[...W.values()]}).event,c.keyboardSupport!==!1){const W=v.Event.chain(this.view.onKeyDown).filter(A=>!(0,g.isInputElement)(A.target)).map(A=>new H.StandardKeyboardEvent(A));W.filter(A=>A.keyCode===15).on(this.onLeftArrow,this,this.disposables),W.filter(A=>A.keyCode===17).on(this.onRightArrow,this,this.disposables),W.filter(A=>A.keyCode===10).on(this.onSpace,this,this.disposables)}(c.findWidgetEnabled??!0)&&c.keyboardNavigationLabelProvider&&c.contextViewProvider?(this.findController=new we(this,this.model,this.view,L,c.contextViewProvider),this.focusNavigationFilter=W=>this.findController.shouldAllowFocus(W),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=v.Event.None,this.styleElement=(0,y.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===m.Always)}get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return v.Event.map(this.view.onMouseClick,he)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.view.onMouseDblClick,he),F=>F.target!==N.TreeMouseEventTarget.Filter)}get onContextMenu(){return v.Event.map(this.view.onContextMenu,se)}get onTap(){return v.Event.map(this.view.onTap,he)}get onPointer(){return v.Event.map(this.view.onPointer,he)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??ge.Highlight}set findMode(F){this.findController&&(this.findController.mode=F)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}updateOptions(F={}){this._options={...this._options,...F};for(const V of this.renderers)V.updateOptions(F);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===m.Always)}get options(){return this._options}updateWidth(F){const V=this.model.getListIndex(F);V!==-1&&this.view.updateWidth(V)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(F){this.view.scrollTop=F}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(F){this.view.scrollLeft=F}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const F=this.view.firstVisibleIndex;return F<0||F>=this.view.length?void 0:this.view.element(F).element}get lastVisibleElement(){const F=this.view.lastVisibleIndex;return this.view.element(F).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(F){this.view.ariaLabel=F}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(F,V){this.view.layout(F,V),(0,p.isNumber)(V)&&this.findController?.layout(V)}style(F){const V=`.${this.view.domId}`,j=[];F.treeIndentGuidesStroke&&(j.push(`.monaco-list${V}:hover .monaco-tl-indent > .indent-guide, .monaco-list${V}.always .monaco-tl-indent > .indent-guide  { border-color: ${F.treeIndentGuidesStroke.transparent(.4)}; }`),j.push(`.monaco-list${V} .monaco-tl-indent > .indent-guide.active { border-color: ${F.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=j.join(`
`),this.findController?.style(F),this.view.style(F)}getParentElement(F){const V=this.model.getParentNodeLocation(F);return this.model.getNode(V).element}getFirstElementChild(F){return this.model.getFirstElementChild(F)}getNode(F){return this.model.getNode(F)}collapse(F,V=!1){return this.model.setCollapsed(F,!0,V)}expand(F,V=!1){return this.model.setCollapsed(F,!1,V)}toggleCollapsed(F,V=!1){return this.model.setCollapsed(F,void 0,V)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(F){return this.model.isCollapsible(F)}setCollapsible(F,V){return this.model.setCollapsible(F,V)}isCollapsed(F){return this.model.isCollapsed(F)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(F){if(typeof F>"u")return this.view.setAnchor(void 0);const V=this.model.getNode(F);this.anchor.set([V]);const j=this.model.getListIndex(F);j>-1&&this.view.setAnchor(j,!0)}getAnchor(){return(0,s.firstOrDefault)(this.anchor.get(),void 0)}setSelection(F,V){const j=F.map(c=>this.model.getNode(c));this.selection.set(j,V);const k=F.map(c=>this.model.getListIndex(c)).filter(c=>c>-1);this.view.setSelection(k,V,!0)}getSelection(){return this.selection.get()}setFocus(F,V){const j=F.map(c=>this.model.getNode(c));this.focus.set(j,V);const k=F.map(c=>this.model.getListIndex(c)).filter(c=>c>-1);this.view.setFocus(k,V,!0)}focusNext(F=1,V=!1,j,k=this.focusNavigationFilter){this.view.focusNext(F,V,j,k)}focusPrevious(F=1,V=!1,j,k=this.focusNavigationFilter){this.view.focusPrevious(F,V,j,k)}focusNextPage(F,V=this.focusNavigationFilter){return this.view.focusNextPage(F,V)}focusPreviousPage(F,V=this.focusNavigationFilter){return this.view.focusPreviousPage(F,V)}focusLast(F,V=this.focusNavigationFilter){this.view.focusLast(F,V)}focusFirst(F,V=this.focusNavigationFilter){this.view.focusFirst(F,V)}getFocus(){return this.focus.get()}reveal(F,V){this.model.expandTo(F);const j=this.model.getListIndex(F);j!==-1&&this.view.reveal(j,V)}getRelativeTop(F){const V=this.model.getListIndex(F);return V===-1?null:this.view.getRelativeTop(V)}getViewState(F=this.options.identityProvider){if(!F)throw new N.TreeError(this._user,"Can't get tree view state without an identity provider");const V=I=>F.getId(I).toString(),j=h.empty(this.scrollTop);for(const I of this.getFocus())j.focus.add(V(I));for(const I of this.getSelection())j.selection.add(V(I));const k=this.model.getNode(),c=[k];for(;c.length>0;){const I=c.shift();I!==k&&I.collapsible&&(j.expanded[V(I.element)]=I.collapsed?0:1),c.push(...I.children)}return j}onLeftArrow(F){F.preventDefault(),F.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],k=this.model.getNodeLocation(j);if(!this.model.setCollapsed(k,!0)){const I=this.model.getParentNodeLocation(k);if(!I)return;const U=this.model.getListIndex(I);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(F){F.preventDefault(),F.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],k=this.model.getNodeLocation(j);if(!this.model.setCollapsed(k,!1)){if(!j.children.some(K=>K.visible))return;const[I]=this.view.getFocus(),U=I+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(F){F.preventDefault(),F.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],k=this.model.getNodeLocation(j),c=F.browserEvent.altKey;this.model.setCollapsed(k,void 0,c)}navigate(F){return new ce(this.view,this.model,F)}dispose(){(0,a.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=ie;class ce{constructor(F,V,j){this.view=F,this.model=V,j?this.index=this.model.getListIndex(j):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[128],pe([1,0,127,117,23,26]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class C extends y.AbstractTree{constructor(g,d,f,N,o,s={}){super(g,d,f,N,s),this.user=g,this.dataSource=o,this.nodesByIdentity=new Map,this.identityProvider=s.identityProvider}getInput(){return this.input}setInput(g,d){if(d&&!this.identityProvider)throw new H.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=g,!g){this.nodesByIdentity.clear(),this.model.setChildren(null,O.Iterable.empty());return}if(!d){this._refresh(g);return}const f=[],N=[],o=e=>{const b=this.identityProvider.getId(e).toString();return!d.expanded[b]},s=e=>{const b=this.identityProvider.getId(e.element).toString();d.focus.has(b)&&f.push(e.element),d.selection.has(b)&&N.push(e.element)};this._refresh(g,o,s),this.setFocus(f),this.setSelection(N),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(g=this.input){if(typeof this.input>"u")throw new H.TreeError(this.user,"Tree input not set");let d;this.identityProvider&&(d=f=>{const N=this.identityProvider.getId(f).toString(),o=this.nodesByIdentity.get(N);if(!!o)return o.collapsed}),this._refresh(g,d)}resort(g=this.input,d=!0){this.model.resort(g===this.input?null:g,d)}refresh(g){if(g===void 0){this.view.rerender();return}this.model.rerender(g)}_refresh(g,d,f){let N;if(this.identityProvider){const o=new Set,s=f;f=e=>{const b=this.identityProvider.getId(e.element).toString();o.add(b),this.nodesByIdentity.set(b,e),s?.(e)},N=e=>{const b=this.identityProvider.getId(e.element).toString();o.has(b)||this.nodesByIdentity.delete(b)}}this.model.setChildren(g===this.input?null:g,this.iterate(g,d).elements,{onDidCreateNode:f,onDidDeleteNode:N})}iterate(g,d){const f=[...this.dataSource.getChildren(g)];return{elements:O.Iterable.map(f,o=>{const{elements:s,size:e}=this.iterate(o,d),b=this.dataSource.hasChildren?this.dataSource.hasChildren(o):void 0,D=e===0?void 0:d&&d(o);return{element:o,children:s,collapsible:b,collapsed:D}}),size:f.length}}createModel(g,d,f){return new i.ObjectTreeModel(g,d,f)}}t.DataTree=C}),define(me[38],pe([1,0,14,8,31,28,25,13,3,2,50,10,6]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var s;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(s=t.RequestType||(t.RequestType={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(b=t.ResponseType||(t.ResponseType={}));function D(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(v||(v={}));class E{constructor(ie){this.buffer=ie,this.pos=0}read(ie){const ce=this.buffer.slice(this.pos,this.pos+ie);return this.pos+=ce.byteLength,ce}}class a{constructor(){this.buffers=[]}get buffer(){return H.VSBuffer.concat(this.buffers)}write(ie){this.buffers.push(ie)}}var l;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object"})(l||(l={}));function p(re){const ie=H.VSBuffer.alloc(4);return ie.writeUInt32BE(re,0),ie}function S(re){return re.read(4).readUInt32BE(0)}function T(re){const ie=H.VSBuffer.alloc(1);return ie.writeUInt8(re,0),ie}const _={Undefined:T(l.Undefined),String:T(l.String),Buffer:T(l.Buffer),VSBuffer:T(l.VSBuffer),Array:T(l.Array),Object:T(l.Object)},r=typeof Buffer<"u";function n(re,ie){if(typeof ie>"u")re.write(_.Undefined);else if(typeof ie=="string"){const ce=H.VSBuffer.fromString(ie);re.write(_.String),re.write(p(ce.byteLength)),re.write(ce)}else if(r&&Buffer.isBuffer(ie)){const ce=H.VSBuffer.wrap(ie);re.write(_.Buffer),re.write(p(ce.byteLength)),re.write(ce)}else if(ie instanceof H.VSBuffer)re.write(_.VSBuffer),re.write(p(ie.byteLength)),re.write(ie);else if(Array.isArray(ie)){re.write(_.Array),re.write(p(ie.length));for(const ce of ie)n(re,ce)}else{const ce=H.VSBuffer.fromString(JSON.stringify(ie));re.write(_.Object),re.write(p(ce.byteLength)),re.write(ce)}}function u(re){switch(re.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return re.read(S(re)).toString();case l.Buffer:return re.read(S(re)).buffer;case l.VSBuffer:return re.read(S(re));case l.Array:{const ce=S(re),ne=[];for(let F=0;F<ce;F++)ne.push(u(re));return ne}case l.Object:return JSON.parse(re.read(S(re)).toString())}}class h{constructor(ie,ce,ne=null,F=1e3){this.protocol=ie,this.ctx=ce,this.logger=ne,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(ie,ce){this.channels.set(ie,ce),setTimeout(()=>this.flushPendingRequests(ie),0)}sendResponse(ie){switch(ie.type){case 200:{const ce=this.send([ie.type]);this.logger?.logOutgoing(ce,0,1,D(ie.type));return}case 201:case 202:case 204:case 203:{const ce=this.send([ie.type,ie.id],ie.data);this.logger?.logOutgoing(ce,ie.id,1,D(ie.type),ie.data);return}}}send(ie,ce=void 0){const ne=new a;return n(ne,ie),n(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onRawMessage(ie){const ce=new E(ie),ne=u(ce),F=u(ce),V=ne[0];switch(V){case 100:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}: ${ne[2]}.${ne[3]}`,F),this.onPromise({type:V,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 102:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}: ${ne[2]}.${ne[3]}`,F),this.onEventListen({type:V,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 101:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:ne[1]});case 103:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:ne[1]})}}onPromise(ie){const ce=this.channels.get(ie.channelName);if(!ce){this.collectPendingRequest(ie);return}const ne=new O.CancellationTokenSource;let F;try{F=ce.call(this.ctx,ie.name,ie.arg,ne.token)}catch(k){F=Promise.reject(k)}const V=ie.id;F.then(k=>{this.sendResponse({id:V,data:k,type:201}),this.activeRequests.delete(ie.id)},k=>{k instanceof Error?this.sendResponse({id:V,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:V,data:k,type:203}),this.activeRequests.delete(ie.id)});const j=(0,d.toDisposable)(()=>ne.cancel());this.activeRequests.set(ie.id,j)}onEventListen(ie){const ce=this.channels.get(ie.channelName);if(!ce){this.collectPendingRequest(ie);return}const ne=ie.id,V=ce.listen(this.ctx,ie.name,ie.arg)(j=>this.sendResponse({id:ne,data:j,type:204}));this.activeRequests.set(ie.id,V)}disposeActiveRequest(ie){const ce=this.activeRequests.get(ie.id);ce&&(ce.dispose(),this.activeRequests.delete(ie.id))}collectPendingRequest(ie){let ce=this.pendingRequests.get(ie.channelName);ce||(ce=[],this.pendingRequests.set(ie.channelName,ce));const ne=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.sendResponse({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ce.push({request:ie,timeoutTimer:ne})}flushPendingRequests(ie){const ce=this.pendingRequests.get(ie);if(ce){for(const ne of ce)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(ie)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=h;var m;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(m=t.RequestInitiator||(t.RequestInitiator={}));class z{constructor(ie,ce=null){this.protocol=ie,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=ce}getChannel(ie){const ce=this;return{call(ne,F,V){return ce.isDisposed?Promise.reject(new w.CancellationError):ce.requestPromise(ie,ne,F,V)},listen(ne,F){return ce.isDisposed?g.Event.None:ce.requestEvent(ie,ne,F)}}}requestPromise(ie,ce,ne,F=O.CancellationToken.None){const V=this.lastRequestId++,k={id:V,type:100,channelName:ie,name:ce,arg:ne};if(F.isCancellationRequested)return Promise.reject(new w.CancellationError);let c;return new Promise((U,K)=>{if(F.isCancellationRequested)return K(new w.CancellationError);const X=()=>{const A=P=>{switch(P.type){case 201:this.handlers.delete(V),U(P.data);break;case 202:{this.handlers.delete(V);const M=new Error(P.data.message);M.stack=P.data.stack,M.name=P.data.name,K(M);break}case 203:this.handlers.delete(V),K(P.data);break}};this.handlers.set(V,A),this.sendRequest(k)};let L=null;this.state===v.Idle?X():(L=(0,i.createCancelablePromise)(A=>this.whenInitialized()),L.then(()=>{L=null,X()}));const R=()=>{L?(L.cancel(),L=null):this.sendRequest({id:V,type:101}),K(new w.CancellationError)},W=F.onCancellationRequested(R);c=(0,d.combinedDisposable)((0,d.toDisposable)(R),W),this.activeRequests.add(c)}).finally(()=>{this.activeRequests.delete(c)})}requestEvent(ie,ce,ne){const F=this.lastRequestId++,j={id:F,type:102,channelName:ie,name:ce,arg:ne};let k=null;const c=new g.Emitter({onFirstListenerAdd:()=>{k=(0,i.createCancelablePromise)(U=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(c),this.sendRequest(j)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(c),this.sendRequest({id:F,type:103}))}}),I=U=>c.fire(U.data);return this.handlers.set(F,I),c.event}sendRequest(ie){switch(ie.type){case 100:case 102:{const ce=this.send([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.logger?.logOutgoing(ce,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const ce=this.send([ie.type,ie.id]);this.logger?.logOutgoing(ce,ie.id,0,e(ie.type));return}}}send(ie,ce=void 0){const ne=new a;return n(ne,ie),n(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onBuffer(ie){const ce=new E(ie),ne=u(ce),F=u(ce),V=ne[0];switch(V){case 200:return this.logger?.logIncoming(ie.byteLength,0,0,D(V)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(ie.byteLength,ne[1],0,D(V),F),this.onResponse({type:ne[0],id:ne[1],data:F})}}onResponse(ie){if(ie.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}this.handlers.get(ie.id)?.(ie)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([C.memoize],z.prototype,"onDidInitializePromise",null),t.ChannelClient=z;class ${constructor(ie){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,ie(({protocol:ce,onDidClientDisconnect:ne})=>{g.Event.once(ce.onMessage)(V=>{const j=new E(V),k=u(j),c=new h(ce,k),I=new z(ce);this.channels.forEach((K,X)=>c.registerChannel(X,K));const U={channelServer:c,channelClient:I,ctx:k};this._connections.add(U),this._onDidAddConnection.fire(U),ne(()=>{c.dispose(),I.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const ie=[];return this._connections.forEach(ce=>ie.push(ce)),ie}getChannel(ie,ce){const ne=this;return{call(F,V,j){let k;if((0,o.isFunction)(ce)){const I=(0,y.getRandomElement)(ne.connections.filter(ce));k=I?Promise.resolve(I):g.Event.toPromise(g.Event.filter(ne.onDidAddConnection,ce))}else k=ce.routeCall(ne,F,V);const c=k.then(I=>I.channelClient.getChannel(ie));return Q(c).call(F,V,j)},listen(F,V){if((0,o.isFunction)(ce))return ne.getMulticastEvent(ie,ce,F,V);const j=ce.routeEvent(ne,F,V).then(k=>k.channelClient.getChannel(ie));return Q(j).listen(F,V)}}}getMulticastEvent(ie,ce,ne,F){const V=this;let j=new d.DisposableStore;const k=new g.Emitter({onFirstListenerAdd:()=>{j=new d.DisposableStore;const c=new g.EventMultiplexer,I=new Map,U=X=>{const R=X.channelClient.getChannel(ie).listen(ne,F),W=c.add(R);I.set(X,W)},K=X=>{const L=I.get(X);!L||(L.dispose(),I.delete(X))};V.connections.filter(ce).forEach(U),g.Event.filter(V.onDidAddConnection,ce)(U,void 0,j),V.onDidRemoveConnection(K,void 0,j),c.event(k.fire,k,j),j.add(c)},onLastListenerRemove:()=>{j.dispose()}});return k.event}registerChannel(ie,ce){this.channels.set(ie,ce),this._connections.forEach(ne=>{ne.channelServer.registerChannel(ie,ce)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=$;class J{constructor(ie,ce,ne=null){const F=new a;n(F,ce),ie.send(F.buffer),this.channelClient=new z(ie,ne),this.channelServer=new h(ie,ce,ne)}getChannel(ie){return this.channelClient.getChannel(ie)}registerChannel(ie,ce){this.channelServer.registerChannel(ie,ce)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=J;function Q(re){return{call(ie,ce,ne){return re.then(F=>F.call(ie,ce,ne))},listen(ie,ce){const ne=new g.Relay;return re.then(F=>ne.input=F.listen(ie,ce)),ne.event}}}t.getDelayedChannel=Q;function ge(re){let ie=!1;return{call(ce,ne,F){return ie?re.call(ce,ne,F):(0,i.timeout)(0).then(()=>ie=!0).then(()=>re.call(ce,ne,F))},listen(ce,ne){if(ie)return re.listen(ce,ne);const F=new g.Relay;return(0,i.timeout)(0).then(()=>ie=!0).then(()=>F.input=re.listen(ce,ne)),F.event}}}t.getNextTickChannel=ge;class oe{constructor(ie){this.fn=ie}routeCall(ie){return this.route(ie)}routeEvent(ie){return this.route(ie)}async route(ie){for(const ce of ie.connections)if(await Promise.resolve(this.fn(ce.ctx)))return Promise.resolve(ce);return await g.Event.toPromise(ie.onDidAddConnection),await this.route(ie)}}t.StaticRouter=oe;var we;(function(re){function ie(V,j){const k=V,c=j&&j.disableMarshalling,I=new Map;for(const U in k)ne(U)&&I.set(U,g.Event.buffer(k[U],!0));return new class{listen(U,K,X){const L=I.get(K);if(L)return L;if(F(K)){const R=k[K];if(typeof R=="function")return R.call(k,X)}throw new Error(`Event not found: ${K}`)}call(U,K,X){const L=k[K];if(typeof L=="function"){if(!c&&Array.isArray(X))for(let R=0;R<X.length;R++)X[R]=(0,f.revive)(X[R]);return L.apply(k,X)}throw new Error(`Method not found: ${K}`)}}}re.fromService=ie;function ce(V,j){const k=j&&j.disableMarshalling;return new Proxy({},{get(c,I){if(typeof I=="string")return j?.properties?.has(I)?j.properties.get(I):F(I)?function(U){return V.listen(I,U)}:ne(I)?V.listen(I):async function(...U){let K;j&&!(0,o.isUndefinedOrNull)(j.context)?K=[j.context,...U]:K=U;const X=await V.call(I,K);return k?X:(0,f.revive)(X)};throw new Error(`Property not found: ${String(I)}`)}})}re.toService=ce;function ne(V){return V[0]==="o"&&V[1]==="n"&&N.isUpperAsciiLetter(V.charCodeAt(2))}function F(V){return/^onDynamic/.test(V)&&N.isUpperAsciiLetter(V.charCodeAt(9))}})(we=t.ProxyChannel||(t.ProxyChannel={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const ie=re.toString();if(ie!=="[object Object]")return ie}return re}function _e(re){return Array.isArray(re)?re.map(se):se(re)}function te(re,ie,ce,ne,F,V,j){j=_e(j);const k=he[F],c=k[ne%k.length];let I=[`%c[${re}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${c}`];/\($/.test(V)?(I=I.concat(j),I.push(")")):I.push(j),console.log.apply(console,I)}t.logWithColors=te;class De{constructor(ie,ce){this._outgoingPrefix=ie,this._incomingPrefix=ce,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ie,ce,ne,F,V){this._totalOutgoing+=ie,te(this._outgoingPrefix,this._totalOutgoing,ie,ce,ne,F,V)}logIncoming(ie,ce,ne,F,V){this._totalIncoming+=ie,te(this._incomingPrefix,this._totalIncoming,ie,ce,ne,F,V)}}t.IPCLogger=De}),define(me[29],pe([1,0,5]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=y.globals.vscode.ipcRenderer,t.ipcMessagePort=y.globals.vscode.ipcMessagePort,t.webFrame=y.globals.vscode.webFrame,t.process=y.globals.vscode.process,t.context=y.globals.vscode.context}),define(me[129],pe([1,0,80,29]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let H=0;function O(w,g,d){const f=[],N=H++,o=`vscode:onContextMenu${N}`,s=(e,b,D)=>{f[b].click?.(D)};i.ipcRenderer.once(o,s),i.ipcRenderer.once(y.CONTEXT_MENU_CLOSE_CHANNEL,(e,b)=>{b===N&&(i.ipcRenderer.removeListener(o,s),d?.())}),i.ipcRenderer.send(y.CONTEXT_MENU_CHANNEL,N,w.map(e=>C(e,f)),o,g)}t.popup=O;function C(w,g){const d={id:g.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return g.push(w),Array.isArray(w.submenu)&&(d.submenu=w.submenu.map(f=>C(f,g))),d}}),define(me[130],pe([1,0,31,3,38,81,29]),function(Z,t,y,i,H,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends H.IPCClient{constructor(d){const f=w.createProtocol();super(f,d),this.protocol=f}static createProtocol(){const d=i.Event.fromNodeEventEmitter(C.ipcRenderer,"vscode:message",(f,N)=>y.VSBuffer.wrap(N));return C.ipcRenderer.send("vscode:hello"),new O.Protocol(C.ipcRenderer,d)}dispose(){this.protocol.disconnect()}}t.Client=w}),define(me[131],pe([12,9]),function(Z,t){return Z.create("vs/platform/files/common/files",t)}),define(me[132],pe([12,9]),function(Z,t){return Z.create("vs/platform/theme/common/iconRegistry",t)}),define(me[64],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class y{constructor(H,O=[],C=!1){this.ctor=H,this.staticArguments=O,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=y}),define(me[133],pe([1,0,64]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const i=[];function H(C,w,g){w instanceof y.SyncDescriptor||(w=new y.SyncDescriptor(w,[],g)),i.push([C,w])}t.registerSingleton=H;function O(){return i}t.getSingletonServiceDescriptors=O}),define(me[30],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var y;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function w(g){return g[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=w})(y=t._util||(t._util={})),t.IInstantiationService=H("instantiationService");function i(C,w,g){w[y.DI_TARGET]===w?w[y.DI_DEPENDENCIES].push({id:C,index:g}):(w[y.DI_DEPENDENCIES]=[{id:C,index:g}],w[y.DI_TARGET]=w)}function H(C){if(y.serviceIds.has(C))return y.serviceIds.get(C);const w=function(g,d,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,g,f)};return w.toString=()=>C,y.serviceIds.set(C,w),w}t.createDecorator=H;function O(C){return C}t.refineServiceDecorator=O}),define(me[134],pe([1,0,30]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,y.createDecorator)(t.ID);function i(O){return!!O.hostName&&!!O.errorMessage}t.isRemoteDiagnosticError=i;class H{async getPerformanceInfo(C,w){return{}}async getSystemInfo(C,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,w){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}t.NullDiagnosticsService=H}),define(me[135],pe([1,0,49,21,10,6,16,131,30]),function(Z,t,y,i,H,O,C,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,g.createDecorator)("fileService");function d(te){return te.create===!0}t.isFileOpenForWriteOptions=d;var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var N;(function(te){te[te.Readonly=1]="Readonly"})(N=t.FilePermission||(t.FilePermission={}));var o;(function(te){te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function s(te){return!!(te.capabilities&2)}t.hasReadWriteCapability=s;function e(te){return!!(te.capabilities&8)}t.hasFileFolderCopyCapability=e;function b(te){return!!(te.capabilities&32768)}t.hasFileCloneCapability=b;function D(te){return!!(te.capabilities&4)}t.hasOpenReadWriteCloseCapability=D;function v(te){return!!(te.capabilities&16)}t.hasFileReadStreamCapability=v;function E(te){return s(te)?!!(te.capabilities&16384):!1}t.hasFileAtomicReadCapability=E;var a;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(a=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class l extends Error{constructor(De,re){super(De),this.code=re}}t.FileSystemProviderError=l;function p(te,De){const re=new l(te.toString(),De);return T(re,De),re}t.createFileSystemProviderError=p;function S(te){return te||p((0,w.localize)(0,null),a.Unknown)}t.ensureFileSystemProviderError=S;function T(te,De){return te.name=De?`${De} (FileSystemError)`:"FileSystemError",te}t.markAsFileSystemProviderError=T;function _(te){if(!te)return a.Unknown;if(te instanceof l)return te.code;const De=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!De)return a.Unknown;switch(De[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}t.toFileSystemProviderErrorCode=_;function r(te){if(te instanceof $)return te.fileOperationResult;switch(_(te)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=r;var n;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(n=t.FileOperation||(t.FileOperation={}));class u{constructor(De,re,ie){this.resource=De,this.operation=re,this.target=ie}isOperation(De){return this.operation===De}}t.FileOperationEvent=u;var h;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(h=t.FileChangeType||(t.FileChangeType={}));class m{constructor(De,re){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=De;const ie=new Map;for(const ce of De){const ne=ie.get(ce.type);switch(ne?ne.push([ce.resource,ce]):ie.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,ne]of ie)switch(ce){case 1:this.added=y.TernarySearchTree.forUris(()=>re),this.added.fill(ne);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>re),this.updated.fill(ne);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>re),this.deleted.fill(ne);break}}contains(De,...re){return this.doContains(De,{includeChildren:!1},...re)}affects(De,...re){return this.doContains(De,{includeChildren:!0},...re)}doContains(De,re,...ie){if(!De)return!1;const ce=ie.length>0;return!!((!ce||ie.includes(1))&&(this.added?.get(De)||re.includeChildren&&this.added?.findSuperstr(De))||(!ce||ie.includes(0))&&(this.updated?.get(De)||re.includeChildren&&this.updated?.findSuperstr(De))||(!ce||ie.includes(2))&&(this.deleted?.findSubstr(De)||re.includeChildren&&this.deleted?.findSuperstr(De)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=m;function z(te,De,re){return!te||!De||te===De||De.length>te.length?!1:(De.charAt(De.length-1)!==i.sep&&(De+=i.sep),re?(0,H.startsWithIgnoreCase)(te,De):te.indexOf(De)===0)}t.isParent=z;class $ extends Error{constructor(De,re,ie){super(De),this.fileOperationResult=re,this.options=ie}}t.FileOperationError=$;class J extends ${constructor(De,re,ie){super(De,2,ie),this.stat=re}}t.NotModifiedSinceFileOperationError=J;var Q;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ge;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function oe(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}t.etag=oe;async function we(te,De){if(!De.hasProvider(C.URI.from({scheme:te.scheme})))return new Promise(re=>{const ie=De.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===te.scheme&&ce.added&&(ie.dispose(),re())})})}t.whenProviderRegistered=we,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class he{static formatSize(De){return(0,O.isNumber)(De)||(De=0),De<he.KB?(0,w.localize)(1,null,De.toFixed(0)):De<he.MB?(0,w.localize)(2,null,(De/he.KB).toFixed(2)):De<he.GB?(0,w.localize)(3,null,(De/he.MB).toFixed(2)):De<he.TB?(0,w.localize)(4,null,(De/he.GB).toFixed(2)):(0,w.localize)(5,null,(De/he.TB).toFixed(2))}}t.ByteSize=he,he.KB=1024,he.MB=he.KB*he.KB,he.GB=he.MB*he.KB,he.TB=he.GB*he.KB;var se;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(se=t.Arch||(t.Arch={}));function _e(te){return{maxFileSize:te===0?300*he.MB:16*he.GB,maxHeapSize:te===0?700*he.MB:2*700*he.MB}}t.getPlatformLimits=_e}),define(me[136],pe([1,0,2,130]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class H extends y.Disposable{constructor(C){super(),this.mainProcessConnection=this._register(new i.Client(`window:${C}`))}getChannel(C){return this.mainProcessConnection.getChannel(C)}registerChannel(C,w){this.mainProcessConnection.registerChannel(C,w)}}t.ElectronIPCMainProcessService=H});var Tt=this&&this.__param||function(Z,t){return function(y,i){t(y,i,Z)}};define(me[137],pe([1,0,38,64,133,30]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class C{constructor(s,e,b){const D=b.getChannel(s);return w(e)?new e.channelClientCtor(D):y.ProxyChannel.toService(D,e?.proxyOptions)}}function w(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,O.createDecorator)("mainProcessService");let g=class extends C{constructor(s,e,b){super(s,e,b)}};g=Ke([Tt(2,t.IMainProcessService)],g);function d(o,s,e){(0,H.registerSingleton)(o,new i.SyncDescriptor(g,[s,e],e?.supportsDelayedInstantiation))}t.registerMainProcessRemoteService=d,t.ISharedProcessService=(0,O.createDecorator)("sharedProcessService");let f=class extends C{constructor(s,e,b){super(s,e,b)}};f=Ke([Tt(2,t.ISharedProcessService)],f);function N(o,s,e){(0,H.registerSingleton)(o,new i.SyncDescriptor(f,[s,e],e?.supportsDelayedInstantiation))}t.registerSharedProcessRemoteService=N}),define(me[138],pe([1,0,38,137]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let H=class{constructor(C,w){return this.windowId=C,y.ProxyChannel.toService(w.getChannel("nativeHost"),{context:C,properties:(()=>{const g=new Map;return g.set("windowId",C),g})()})}};H=Ke([Tt(1,i.IMainProcessService)],H),t.NativeHostService=H}),define(me[39],pe([1,0,69,6]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class H{constructor(){this.data=new Map}add(C,w){y.ok(i.isString(C)),y.ok(i.isObject(w)),y.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,w)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new H}),define(me[139],pe([1,0,3,39]),function(Z,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function H(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class O{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,d){this.schemasById[H(g)]=d,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new O;i.Registry.add(t.Extensions.JSONContribution,C)}),define(me[140],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var y;(function(O){O.DARK="dark",O.LIGHT="light",O.HIGH_CONTRAST_DARK="hcDark",O.HIGH_CONTRAST_LIGHT="hcLight"})(y=t.ColorScheme||(t.ColorScheme={}));function i(O){return O===y.HIGH_CONTRAST_DARK||O===y.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function H(O){return O===y.DARK||O===y.HIGH_CONTRAST_DARK}t.isDark=H}),define(me[65],pe([1,0,11,3,2,30,39,140]),function(Z,t,y,i,H,O,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,O.createDecorator)("themeService");var g;(function(D){function v(E){return E&&typeof E=="object"&&typeof E.id=="string"}D.isThemeColor=v})(g=t.ThemeColor||(t.ThemeColor={}));function d(D){return{id:D}}t.themeColorFromId=d;var f;(function(D){function v(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||g.isThemeColor(r.color))}D.isThemeIcon=v;const E=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const n=E.exec(r);if(!n)return;const[,u]=n;return{id:u}}D.fromString=a;function l(r){return{id:r}}D.fromId=l;function p(r,n){let u=r.id;const h=u.lastIndexOf("~");return h!==-1&&(u=u.substring(0,h)),n&&(u=`${u}~${n}`),{id:u}}D.modify=p;function S(r){const n=r.id.lastIndexOf("~");if(n!==-1)return r.id.substring(n+1)}D.getModifier=S;function T(r,n){return r.id===n.id&&r.color?.id===n.color?.id}D.isEqual=T;function _(r,n){return{id:r.id,color:n?d(n):void 0}}D.asThemeIcon=_,D.asClassNameArray=y.CSSIcon.asClassNameArray,D.asClassName=y.CSSIcon.asClassName,D.asCSSSelector=y.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=y.Codicon.file,t.FolderThemeIcon=y.Codicon.folder;function N(D){switch(D){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=N,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,H.toDisposable)(()=>{const E=this.themingParticipants.indexOf(v);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const s=new o;C.Registry.add(t.Extensions.ThemingContribution,s);function e(D){return s.onColorThemeChange(D)}t.registerThemingParticipant=e;class b extends H.Disposable{constructor(v){super(),this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,E){let a=this.theme.getColor(v);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}t.Themable=b}),define(me[141],pe([1,0,8,11,3,6,16,132,139,39,65]),function(Z,t,y,i,H,O,C,w,g,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var N;(function(l){function p(S,T){let _=S.defaults;for(;f.ThemeIcon.isThemeIcon(_);){const r=e.getIcon(_.id);if(!r)return;_=r.defaults}return _}l.getDefinition=p})(N=t.IconContribution||(t.IconContribution={}));var o;(function(l){function p(T){return{weight:T.weight,style:T.style,src:T.src.map(_=>({format:_.format,location:_.location.toString()}))}}l.toJSONObject=p;function S(T){const _=r=>(0,O.isString)(r)?r:void 0;if(T&&Array.isArray(T.src)&&T.src.every(r=>(0,O.isString)(r.format)&&(0,O.isString)(r.location)))return{weight:_(T.weight),style:_(T.style),src:T.src.map(r=>({format:r.format,location:C.URI.parse(r.location)}))}}l.fromJSONObject=S})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class s{constructor(){this._onDidChange=new H.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,S,T,_){const r=this.iconsById[p];if(r){if(T&&!r.description){r.description=T,this.iconSchema.properties[p].markdownDescription=`${T} $(${p})`;const h=this.iconReferenceSchema.enum.indexOf(p);h!==-1&&(this.iconReferenceSchema.enumDescriptions[h]=T),this._onDidChange.fire()}return r}const n={id:p,description:T,defaults:S,deprecationMessage:_};this.iconsById[p]=n;const u={$ref:"#/definitions/icons"};return _&&(u.deprecationMessage=_),T&&(u.markdownDescription=`${T}: $(${p})`),this.iconSchema.properties[p]=u,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(T||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const S=this.iconReferenceSchema.enum.indexOf(p);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,S){const T=this.iconFontsById[p];return T||(this.iconFontsById[p]=S,this._onDidChange.fire(),S)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(r,n)=>r.id.localeCompare(n.id),S=r=>{for(;f.ThemeIcon.isThemeIcon(r.defaults);)r=this.iconsById[r.defaults.id];return`codicon codicon-${r?r.id:""}`},T=[];T.push("| preview     | identifier                        | default codicon ID                | description"),T.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const _=Object.keys(this.iconsById).map(r=>this.iconsById[r]);for(const r of _.filter(n=>!!n.description).sort(p))T.push(`|<i class="${S(r)}"></i>|${r.id}|${f.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);T.push("| preview     | identifier                        "),T.push("| ----------- | --------------------------------- |");for(const r of _.filter(n=>!f.ThemeIcon.isThemeIcon(n.defaults)).sort(p))T.push(`|<i class="${S(r)}"></i>|${r.id}|`);return T.join(`
`)}}const e=new s;d.Registry.add(t.Extensions.IconContribution,e);function b(l,p,S,T){return e.registerIcon(l,p,S,T)}t.registerIcon=b;function D(){return e}t.getIconRegistry=D;function v(){for(const l of i.Codicon.getAll())e.registerIcon(l.id,l.definition,l.description)}v(),t.iconsSchemaId="vscode://schemas/icons";const E=d.Registry.as(g.Extensions.JSONContribution);E.registerSchema(t.iconsSchemaId,e.getIconSchema());const a=new y.RunOnceScheduler(()=>E.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.widgetClose=b("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=b("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=b("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[142],pe([1,0,4,3,141,65]),function(Z,t,y,i,H,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function C(g){const d=new i.Emitter,f=(0,H.getIconRegistry)();return f.onDidChange(()=>d.fire()),g?.onDidProductIconThemeChange(()=>d.fire()),{onDidChange:d.event,getCSS(){const N=g?g.getProductIconTheme():new w,o={},s=b=>{const D=N.getIcon(b);if(!D)return;const v=D.font;return v?(o[v.id]=v.definition,`.codicon-${b.id}:before { content: '${D.fontCharacter}'; font-family: ${(0,y.asCSSPropertyValue)(v.id)}; }`):`.codicon-${b.id}:before { content: '${D.fontCharacter}'; }`},e=[];for(const b of f.getIcons()){const D=s(b);D&&e.push(D)}for(const b in o){const D=o[b],v=D.weight?`font-weight: ${D.weight};`:"",E=D.style?`font-style: ${D.style};`:"",a=D.src.map(l=>`${(0,y.asCSSUrl)(l.location)} format('${l.format}')`).join(", ");e.push(`@font-face { src: ${a}; font-family: ${(0,y.asCSSPropertyValue)(b)};${v}${E} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=C;class w{getIcon(d){const f=(0,H.getIconRegistry)();let N=d.defaults;for(;O.ThemeIcon.isThemeIcon(N);){const o=f.getIcon(N.id);if(!o)return;N=o.defaults}return N}}t.UnthemedProductIconTheme=w}),define(me[143],pe([1,0,5]),function(Z,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function H(f){return!!f.folderUri}t.isFolderToOpen=H;function O(f){return!!f.fileUri}t.isFileToOpen=O;function C(f){const N=w(f),o=f.getValue("window.menuBarVisibility");return o==="default"||N==="native"&&o==="compact"||y.isMacintosh&&y.isNative?"classic":o}t.getMenuBarVisibility=C;function w(f){if(y.isWeb)return"custom";const N=f.getValue("window");if(N){if(y.isMacintosh&&N.nativeTabs===!0||y.isMacintosh&&N.nativeFullScreen===!1)return"native";const e=N.titleBarStyle;if(e==="native"||e==="custom")return e}return y.isLinux?"native":"custom"}t.getTitleBarStyle=w;function g(f,N){if(!y.isWindows||y.isWeb||!N.isBuilt||w(f)==="native")return!1;const o=f.getValue("window.experimental.windowControlsOverlay.enabled");return typeof o=="boolean"?o:!0}t.useWindowControlsOverlay=g;function d(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=d}),define(me[144],pe([1,0,15,29,143]),function(Z,t,y,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function O(g){i.webFrame.setZoomLevel(g),(0,y.setZoomFactor)((0,H.zoomLevelToZoomFactor)(g)),(0,y.setZoomLevel)(g,!1)}t.applyZoom=O;function C(){O((0,y.getZoomLevel)()+1)}t.zoomIn=C;function w(){O((0,y.getZoomLevel)()-1)}t.zoomOut=w}),define(me[145],pe([1,0,9,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(Z,t,y,i,H,O,C,w,g,d,f,N,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,b=/\s--(inspect|debug)-port=(\d+)/;class D{getHeight(m){return 22}getTemplateId(m){return _(m)?"process":S(m)?"machine":(0,g.isRemoteDiagnosticError)(m)?"error":T(m)?"header":""}}class v{hasChildren(m){return(0,g.isRemoteDiagnosticError)(m)?!1:_(m)?!!m.children?.length:!0}getChildren(m){return _(m)?m.children?m.children:[]:(0,g.isRemoteDiagnosticError)(m)?[]:T(m)?m.processRoots.length>1?m.processRoots:[m.processRoots[0].rootProcess]:S(m)?[m.rootProcess]:[m.processes]}}class E{constructor(){this.templateId="header"}renderTemplate(m){const z=Object.create(null),$=(0,i.append)(m,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)($,(0,i.$)(".cpu")),z.memory=(0,i.append)($,(0,i.$)(".memory")),z.PID=(0,i.append)($,(0,i.$)(".pid")),z}renderElement(m,z,$,J){$.name.textContent=(0,y.localize)(0,null),$.CPU.textContent=(0,y.localize)(1,null),$.PID.textContent=(0,y.localize)(2,null),$.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(m){}}class a{constructor(){this.templateId="machine"}renderTemplate(m){const z=Object.create(null),$=(0,i.append)(m,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z}renderElement(m,z,$,J){$.name.textContent=m.element.name}disposeTemplate(m){}}class l{constructor(){this.templateId="error"}renderTemplate(m){const z=Object.create(null),$=(0,i.append)(m,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z}renderElement(m,z,$,J){$.name.textContent=m.element.errorMessage}disposeTemplate(m){}}class p{constructor(m,z,$){this.platform=m,this.totalMem=z,this.mapPidToWindowTitle=$,this.templateId="process"}renderTemplate(m){const z=Object.create(null),$=(0,i.append)(m,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)($,(0,i.$)(".cpu")),z.memory=(0,i.append)($,(0,i.$)(".memory")),z.PID=(0,i.append)($,(0,i.$)(".pid")),z}renderElement(m,z,$,J){const{element:Q}=m;let ge=Q.name;ge==="window"&&(ge=this.mapPidToWindowTitle.get(Q.pid)!==void 0?`${ge} (${this.mapPidToWindowTitle.get(Q.pid)})`:ge);const oe=Q.pid.toFixed(0);$.name.textContent=ge,$.name.title=Q.cmd,$.CPU.textContent=Q.load.toFixed(0),$.PID.textContent=oe,$.PID.parentElement.id=`pid-${oe}`;const we=this.platform==="win32"?Q.mem:this.totalMem*(Q.mem/100);$.memory.textContent=(we/d.ByteSize.MB).toFixed(0)}disposeTemplate(m){}}function S(h){return!!h.name&&!!h.rootProcess}function T(h){return!!h.processRoots}function _(h){return!!h.pid}class r{constructor(m,z){this.data=z,this.mapPidToWindowTitle=new Map;const $=new f.ElectronIPCMainProcessService(m);this.nativeHostService=new N.NativeHostService(m,$),this.applyStyles(z.styles),this.setEventHandlers(z),w.ipcRenderer.on("vscode:windowsInfoResponse",(J,Q)=>{this.mapPidToWindowTitle=new Map,Q.forEach(ge=>this.mapPidToWindowTitle.set(ge.pid,ge.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(J,Q)=>{Q.forEach((ge,oe)=>{_(ge.rootProcess)&&(ge.rootProcess.name=oe===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:Q}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(Q),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(m){document.onkeydown=z=>{const $=m.platform==="darwin"?z.metaKey:z.ctrlKey;$&&z.keyCode===87&&(z.stopPropagation(),z.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),$&&z.keyCode===187&&(0,s.zoomIn)(),$&&z.keyCode===189&&(0,s.zoomOut)()}}async createProcessTree(m){const z=document.getElementById("process-list");if(!z)return;const{totalmem:$}=await this.nativeHostService.getOSStatistics(),J=[new p(this.data.platform,$,this.mapPidToWindowTitle),new E,new a,new l];this.tree=new H.DataTree("processExplorer",z,new D,J,new v,{identityProvider:{getId:Q=>_(Q)?Q.pid.toString():(0,g.isRemoteDiagnosticError)(Q)?Q.hostName:T(Q)?"processes":S(Q)?Q.name:"header"}}),this.tree.setInput({processes:{processRoots:m}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(Q=>{_(Q.element)&&this.showContextMenu(Q.element,!0)}),z.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{z.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(m){const z=e.exec(m);return z&&z.length>=2||m.indexOf("node ")>=0||m.indexOf("node.exe")>=0}attachTo(m){const z={type:"node",request:"attach",name:`process ${m.pid}`};let $=e.exec(m.cmd);$&&$.length>=2?($.length===4&&$[3]&&(z.port=parseInt($[3])),z.protocol=$[1]==="debug"?"legacy":"inspector"):z.processId=String(m.pid),$=b.exec(m.cmd),$&&$.length===3&&(z.port=parseInt($[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[z]})}applyStyles(m){const z=(0,i.createStyleSheet)(),$=[];m.listFocusBackground&&($.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${m.listFocusBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${m.listFocusBackground}; }`)),m.listFocusForeground&&$.push(`.monaco-list:focus .monaco-list-row.focused { color: ${m.listFocusForeground}; }`),m.listActiveSelectionBackground&&($.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${m.listActiveSelectionBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${m.listActiveSelectionBackground}; }`)),m.listActiveSelectionForeground&&$.push(`.monaco-list:focus .monaco-list-row.selected { color: ${m.listActiveSelectionForeground}; }`),m.listHoverBackground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${m.listHoverBackground}; }`),m.listHoverForeground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${m.listHoverForeground}; }`),m.listFocusOutline&&$.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${m.listFocusOutline}; outline-offset: -1px; }`),m.listHoverOutline&&$.push(`.monaco-list-row:hover { outline: 1px dashed ${m.listHoverOutline}; outline-offset: -1px; }`),m.scrollbarShadowColor&&$.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${m.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${m.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${m.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),m.scrollbarSliderBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${m.scrollbarSliderBackgroundColor};
				}
			`),m.scrollbarSliderHoverBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${m.scrollbarSliderHoverBackgroundColor};
				}
			`),m.scrollbarSliderActiveBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${m.scrollbarSliderActiveBackgroundColor};
				}
			`),z.textContent=$.join(`
`),m.color&&(document.body.style.color=m.color)}showContextMenu(m,z){const $=[],J=Number(m.pid);z&&($.push({label:(0,y.localize)(4,null),click:()=>{this.nativeHostService.killProcess(J,"SIGTERM")}}),$.push({label:(0,y.localize)(5,null),click:()=>{this.nativeHostService.killProcess(J,"SIGKILL")}}),$.push({type:"separator"})),$.push({label:(0,y.localize)(6,null),click:()=>{const Q=this.tree?.getSelection()?.map(oe=>{if(!(!oe||!("pid"in oe)))return oe.pid}).filter(oe=>!!oe);Q?.includes(J)||(Q.length=0,Q.push(J));const ge=Q?.map(oe=>document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(ge){const oe=ge.map(we=>we.innerText).filter(we=>!!we);this.nativeHostService.writeClipboardText(oe.join(`
`))}}}),$.push({label:(0,y.localize)(7,null),click:()=>{const Q=document.getElementById("process-list");Q&&this.nativeHostService.writeClipboardText(Q.innerText)}}),m&&z&&this.isDebuggable(m.cmd)&&($.push({type:"separator"}),$.push({label:(0,y.localize)(8,null),click:()=>{this.attachTo(m)}})),(0,C.popup)($)}requestProcessList(m){setTimeout(()=>{const z=Date.now(),$=m+z-this.lastRequestTime;this.lastRequestTime=z,$>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList($)},200)}}function n(){const h=(0,i.createStyleSheet)();h.id="codiconStyles";const m=(0,o.getIconsStyleSheet)(void 0);function z(){h.textContent=m.getCSS()}const $=new O.RunOnceScheduler(z,0);m.onDidChange(()=>$.schedule()),$.schedule()}function u(h){const m=h.data.platform==="win32"?"windows":h.data.platform==="linux"?"linux":"mac";document.body.classList.add(m),n(),(0,s.applyZoom)(h.data.zoomLevel),new r(h.windowId,h.data)}t.startup=u})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e97a738a8376160783f53d587c2cf420815b1eb1/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
