/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","vs/platform/files/common/files","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=De[J[l]];return e};define(De[48],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function l(D,P){if(!D)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=l;function t(D,P="Unreachable"){throw new Error(P)}e.assertNever=t}),define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(_){return _?_.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(y,E,I){this.id=y,this.definition=E,this.description=I,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(_,y){const E=["codicon","codicon-"+_];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=D;var P;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function E(k){if(k instanceof t)return["codicon","codicon-"+k.id];const S=y.exec(k.id);if(!S)return E(t.error);const[,T,w]=S,b=["codicon","codicon-"+T];return w&&b.push("codicon-modifier-"+w.substr(1)),b}_.asClassNameArray=E;function I(k){return E(k).join(" ")}_.asClassName=I;function R(k){return"."+E(k).join(".")}_.asCSSSelector=R})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(_,y){const E=Object.create(null);for(const I of _){const R=y(I);let k=E[R];k||(k=E[R]=[]),k.push(I)}return E}e.groupBy=l;function t(_,y){const E=[],I=[];for(const R of _)y.has(R)||E.push(R);for(const R of y)_.has(R)||I.push(R);return{removed:E,added:I}}e.diffSets=t;function D(_,y){const E=[],I=[];for(const[R,k]of _)y.has(R)||E.push(k);for(const[R,k]of y)_.has(R)||I.push(k);return{removed:E,added:I}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(y,E){let I=this.map.get(y);I||(I=new Set,this.map.set(y,I)),I.add(E)}delete(y,E){const I=this.map.get(y);!I||(I.delete(E),I.size===0&&this.map.delete(y))}forEach(y,E){const I=this.map.get(y);!I||I.forEach(E)}}e.SetMap=P}),define(De[58],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(_){return(y,E,I)=>{let R=null,k=null;if(typeof I.value=="function"?(R="value",k=I.value):typeof I.get=="function"&&(R="get",k=I.get),!k)throw new Error("not supported");I[R]=_(k,E)}}e.createDecorator=l;function t(_,y,E){let I=null,R=null;if(typeof E.value=="function"?(I="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(I="get",R=E.get),!R)throw new Error("not supported");const k=`$memoize$${y}`;E[I]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,S)}),this[k]}}e.memoize=t;function D(_,y,E){return l((I,R)=>{const k=`$debounce$${R}`,S=`$debounce$result$${R}`;return function(...T){this[S]||(this[S]=E?E():void 0),clearTimeout(this[k]),y&&(this[S]=y(this[S],...T),T=[this[S]]),this[k]=setTimeout(()=>{I.apply(this,T),this[S]=E?E():void 0},_)}})}e.debounce=D;function P(_,y,E){return l((I,R)=>{const k=`$throttle$timer$${R}`,S=`$throttle$result$${R}`,T=`$throttle$lastRun$${R}`,w=`$throttle$pending$${R}`;return function(...b){if(this[S]||(this[S]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),y&&(this[S]=y(this[S],...b)),this[w])return;const v=this[T]+_;v<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[S]]),this[S]=E?E():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[T]=Date.now(),I.apply(this,[this[S]]),this[S]=E?E():void 0},v-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?f.isErrorNoTelemetry(s)?new f(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(u=>{u(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=l,e.errorHandler=new l;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function D(g){E(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=D;function P(g){E(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=P;function _(g){if(g instanceof Error){const{name:s,message:u}=g,o=g.stacktrace||g.stack;return{$isError:!0,name:s,message:u,stack:o,noTelemetry:f.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=_;const y="Canceled";function E(g){return g instanceof I?!0:g instanceof Error&&g.name===y&&g.message===y}e.isCancellationError=E;class I extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=I;function R(){const g=new Error(y);return g.name=g.message,g}e.canceled=R;function k(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=k;function S(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=S;function T(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function w(g){const s=new Error(`${g} has been disposed`);return s.name="DISPOSED",s}e.disposed=w;function b(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=b;class v extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=v;class d extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=d;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class f extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof f)return s;const u=new f;return u.message=s.message,u.stack=s.stack,u}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class a extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(De[17],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,ue=0){return oe[oe.length-(1+ue)]}e.tail=t;function D(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=D;function P(oe,ue,fe=(Z,ae)=>Z===ae){if(oe===ue)return!0;if(!oe||!ue||oe.length!==ue.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!fe(oe[Z],ue[Z]))return!1;return!0}e.equals=P;function _(oe,ue){const fe=oe.length-1;ue<fe&&(oe[ue]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=_;function y(oe,ue,fe){return E(oe.length,Z=>fe(oe[Z],ue))}e.binarySearch=y;function E(oe,ue){let fe=0,Z=oe-1;for(;fe<=Z;){const ae=(fe+Z)/2|0,ee=ue(ae);if(ee<0)fe=ae+1;else if(ee>0)Z=ae-1;else return ae}return-(fe+1)}e.binarySearch2=E;function I(oe,ue){let fe=0,Z=oe.length;if(Z===0)return 0;for(;fe<Z;){const ae=Math.floor((fe+Z)/2);ue(oe[ae])?Z=ae:fe=ae+1}return fe}e.findFirstInSorted=I;function R(oe,ue,fe){if(oe=oe|0,oe>=ue.length)throw new TypeError("invalid index");const Z=ue[Math.floor(ue.length*Math.random())],ae=[],ee=[],ie=[];for(const F of ue){const H=fe(F,Z);H<0?ae.push(F):H>0?ee.push(F):ie.push(F)}return oe<ae.length?R(oe,ae,fe):oe<ae.length+ie.length?ie[0]:R(oe-(ae.length+ie.length),ee,fe)}e.quickSelect=R;function k(oe,ue){const fe=[];let Z;for(const ae of oe.slice(0).sort(ue))!Z||ue(Z[0],ae)!==0?(Z=[ae],fe.push(Z)):Z.push(ae);return fe}e.groupBy=k;function S(oe,ue,fe){const Z=[];function ae(F,H,G){if(H===0&&G.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===F?(X.deleteCount+=H,X.toInsert.push(...G)):Z.push({start:F,deleteCount:H,toInsert:G})}let ee=0,ie=0;for(;;){if(ee===oe.length){ae(ee,0,ue.slice(ie));break}if(ie===ue.length){ae(ee,oe.length-ee,[]);break}const F=oe[ee],H=ue[ie],G=fe(F,H);G===0?(ee+=1,ie+=1):G<0?(ae(ee,1,[]),ee+=1):G>0&&(ae(ee,0,[H]),ie+=1)}return Z}e.sortedDiff=S;function T(oe,ue,fe){const Z=S(oe,ue,fe),ae=[],ee=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:ae,added:ee}}e.delta=T;function w(oe,ue,fe){if(fe===0)return[];const Z=oe.slice(0,fe).sort(ue);return v(oe,ue,Z,fe,oe.length),Z}e.top=w;function b(oe,ue,fe,Z,ae){return fe===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const F=oe.length,H=oe.slice(0,fe).sort(ue);for(let G=fe,X=Math.min(fe+Z,F);G<F;G=X,X=Math.min(X+Z,F)){if(G>fe&&await new Promise(me=>setTimeout(me)),ae&&ae.isCancellationRequested)throw new l.CancellationError;v(oe,ue,H,G,X)}return H})().then(ee,ie)})}e.topAsync=b;function v(oe,ue,fe,Z,ae){for(const ee=fe.length;Z<ae;Z++){const ie=oe[Z];if(ue(ie,fe[ee-1])<0){fe.pop();const F=I(fe,H=>ue(ie,H)<0);fe.splice(F,0,ie)}}}function d(oe){return oe.filter(ue=>!!ue)}e.coalesce=d;function p(oe){let ue=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[ue]=oe[fe],ue+=1);oe.length=ue}e.coalesceInPlace=p;function f(oe,ue,fe){oe.splice(fe,0,oe.splice(ue,1)[0])}e.move=f;function a(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=a;function g(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=g;function s(oe,ue=fe=>fe){const fe=new Set;return oe.filter(Z=>{const ae=ue(Z);return fe.has(ae)?!1:(fe.add(ae),!0)})}e.distinct=s;function u(oe){const ue=new Set;return fe=>{const Z=oe(fe);return ue.has(Z)?!1:(ue.add(Z),!0)}}e.uniqueFilter=u;function o(oe,ue){const fe=i(oe,ue);if(fe!==-1)return oe[fe]}e.findLast=o;function i(oe,ue){for(let fe=oe.length-1;fe>=0;fe--){const Z=oe[fe];if(ue(Z))return fe}return-1}e.lastIndex=i;function r(oe,ue){return oe.length>0?oe[0]:ue}e.firstOrDefault=r;function n(oe,ue){return oe.length>0?oe[oe.length-1]:ue}e.lastOrDefault=n;function c(oe,ue,fe=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ee=Math.min(oe.length,ue.length);ae<ee&&fe(oe[ae],ue[ae]);ae++)Z++;return Z}e.commonPrefixLength=c;function h(oe){return[].concat(...oe)}e.flatten=h;function m(oe,ue){let fe=typeof ue=="number"?oe:0;typeof ue=="number"?fe=oe:(fe=0,ue=oe);const Z=[];if(fe<=ue)for(let ae=fe;ae<ue;ae++)Z.push(ae);else for(let ae=fe;ae>ue;ae--)Z.push(ae);return Z}e.range=m;function C(oe,ue,fe){return oe.reduce((Z,ae)=>(Z[ue(ae)]=fe?fe(ae):ae,Z),Object.create(null))}e.index=C;function L(oe,ue){return oe.push(ue),()=>U(oe,ue)}e.insert=L;function U(oe,ue){const fe=oe.indexOf(ue);if(fe>-1)return oe.splice(fe,1),ue}e.remove=U;function B(oe,ue,fe){const Z=oe.slice(0,ue),ae=oe.slice(ue);return Z.concat(fe,ae)}e.arrayInsert=B;function A(oe,ue){let fe;if(typeof ue=="number"){let Z=ue;fe=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else fe=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(fe()*(Z+1)),ee=oe[Z];oe[Z]=oe[ae],oe[ae]=ee}}e.shuffle=A;function M(oe,ue){const fe=oe.indexOf(ue);fe>-1&&(oe.splice(fe,1),oe.unshift(ue))}e.pushToStart=M;function $(oe,ue){const fe=oe.indexOf(ue);fe>-1&&(oe.splice(fe,1),oe.push(ue))}e.pushToEnd=$;function N(oe,ue){for(const fe of ue)oe.push(fe)}e.pushMany=N;function K(oe,ue){return Array.isArray(oe)?oe.map(ue):ue(oe)}e.mapArrayOrNot=K;function z(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=z;function O(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=O;function x(oe,ue){for(const fe of oe){const Z=ue(fe);if(Z!==void 0)return Z}}e.mapFind=x;function V(oe,ue,fe){const Z=Y(oe,ue),ae=oe.length,ee=fe.length;oe.length=ae+ee;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ee]=oe[ie];for(let ie=0;ie<ee;ie++)oe[ie+Z]=fe[ie]}e.insertInto=V;function q(oe,ue,fe,Z){const ae=Y(oe,ue),ee=oe.splice(ae,fe);return V(oe,ae,Z),ee}e.splice=q;function Y(oe,ue){return ue<0?Math.max(ue+oe.length,0):Math.min(ue,oe.length)}var Q;(function(oe){function ue(ae){return ae<0}oe.isLessThan=ue;function fe(ae){return ae>0}oe.isGreaterThan=fe;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function he(oe,ue){return(fe,Z)=>ue(oe(fe),oe(Z))}e.compareBy=he;function ve(...oe){return(ue,fe)=>{for(const Z of oe){const ae=Z(ue,fe);if(!Q.isNeitherLessOrGreaterThan(ae))return ae}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ve;const ne=(oe,ue)=>oe-ue;e.numberComparator=ne;function pe(oe,ue){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];ue(ae,fe)>0&&(fe=ae)}return fe}e.findMaxBy=pe;function be(oe,ue){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];ue(ae,fe)>=0&&(fe=ae)}return fe}e.findLastMaxBy=be;function ke(oe,ue){return pe(oe,(fe,Z)=>-ue(fe,Z))}e.findMinBy=ke;class Le{constructor(ue){this.items=ue,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ue){let fe=this.firstIdx;for(;fe<this.items.length&&ue(this.items[fe]);)fe++;const Z=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,Z}takeFromEndWhile(ue){let fe=this.lastIdx;for(;fe>=0&&ue(this.items[fe]);)fe--;const Z=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ue=this.items[this.firstIdx];return this.firstIdx++,ue}removeLast(){const ue=this.items[this.lastIdx];return this.lastIdx--,ue}takeCount(ue){const fe=this.items.slice(this.firstIdx,this.firstIdx+ue);return this.firstIdx+=ue,fe}}e.ArrayQueue=Le;class We{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(fe=>(ue(fe),!0))}toArray(){const ue=[];return this.iterate(fe=>(ue.push(fe),!0)),ue}filter(ue){return new We(fe=>this.iterate(Z=>ue(Z)?fe(Z):!0))}map(ue){return new We(fe=>this.iterate(Z=>fe(ue(Z))))}some(ue){let fe=!1;return this.iterate(Z=>(fe=ue(Z),!fe)),fe}findFirst(ue){let fe;return this.iterate(Z=>ue(Z)?(fe=Z,!1):!0),fe}findLast(ue){let fe;return this.iterate(Z=>(ue(Z)&&(fe=Z),!0)),fe}findLastMaxBy(ue){let fe,Z=!0;return this.iterate(ae=>((Z||Q.isGreaterThan(ue(ae,fe)))&&(Z=!1,fe=ae),!0)),fe}}e.CallbackIterable=We,We.empty=new We(oe=>{})}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const D=this;let P=!1,_;return function(){return P||(P=!0,_=t.apply(D,arguments)),_}}e.once=l}),define(De[93],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=D;const P=Object.freeze([]);function _(){return P}t.empty=_;function*y(u){yield u}t.single=y;function E(u){return u||P}t.from=E;function I(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=I;function R(u){return u[Symbol.iterator]().next().value}t.first=R;function k(u,o){for(const i of u)if(o(i))return!0;return!1}t.some=k;function S(u,o){for(const i of u)if(o(i))return i}t.find=S;function*T(u,o){for(const i of u)o(i)&&(yield i)}t.filter=T;function*w(u,o){let i=0;for(const r of u)yield o(r,i++)}t.map=w;function*b(...u){for(const o of u)for(const i of o)yield i}t.concat=b;function*v(u){for(const o of u)for(const i of o)yield i}t.concatNested=v;function d(u,o,i){let r=i;for(const n of u)r=o(r,n);return r}t.reduce=d;function p(u,o){let i=0;for(const r of u)o(r,i++)}t.forEach=p;function*f(u,o,i=u.length){for(o<0&&(o+=u.length),i<0?i+=u.length:i>u.length&&(i=u.length);o<i;o++)yield u[o]}t.slice=f;function a(u,o=Number.POSITIVE_INFINITY){const i=[];if(o===0)return[i,u];const r=u[Symbol.iterator]();for(let n=0;n<o;n++){const c=r.next();if(c.done)return[i,t.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=a;function g(u){return a(u)[0]}t.collect=g;function s(u,o,i=(r,n)=>r===n){const r=u[Symbol.iterator](),n=o[Symbol.iterator]();for(;;){const c=r.next(),h=n.next();if(c.done!==h.done)return!1;if(c.done)return!0;if(!i(c.value,h.value))return!1}}t.equals=s})(l=e.Iterable||(e.Iterable={}))}),define(De[143],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(s){s.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function _(s,u=!1){let o=0;const i=s.length;let r="",n=0,c=16,h=0;function m($){let N=0,K=0;for(;N<$;){const z=s.charCodeAt(o);if(z>=48&&z<=57)K=K*16+z-48;else if(z>=65&&z<=70)K=K*16+z-65+10;else if(z>=97&&z<=102)K=K*16+z-97+10;else break;o++,N++}return N<$&&(K=-1),K}function C($){o=$,r="",n=0,c=16,h=0}function L(){const $=o;if(s.charCodeAt(o)===48)o++;else for(o++;o<s.length&&I(s.charCodeAt(o));)o++;if(o<s.length&&s.charCodeAt(o)===46)if(o++,o<s.length&&I(s.charCodeAt(o)))for(o++;o<s.length&&I(s.charCodeAt(o));)o++;else return h=3,s.substring($,o);let N=o;if(o<s.length&&(s.charCodeAt(o)===69||s.charCodeAt(o)===101))if(o++,(o<s.length&&s.charCodeAt(o)===43||s.charCodeAt(o)===45)&&o++,o<s.length&&I(s.charCodeAt(o))){for(o++;o<s.length&&I(s.charCodeAt(o));)o++;N=o}else h=3;return s.substring($,N)}function U(){let $="",N=o;for(;;){if(o>=i){$+=s.substring(N,o),h=2;break}const K=s.charCodeAt(o);if(K===34){$+=s.substring(N,o),o++;break}if(K===92){if($+=s.substring(N,o),o++,o>=i){h=2;break}switch(s.charCodeAt(o++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const O=m(4);O>=0?$+=String.fromCharCode(O):h=4;break}default:h=5}N=o;continue}if(K>=0&&K<=31)if(E(K)){$+=s.substring(N,o),h=2;break}else h=6;o++}return $}function B(){if(r="",h=0,n=o,o>=i)return n=i,c=17;let $=s.charCodeAt(o);if(y($)){do o++,r+=String.fromCharCode($),$=s.charCodeAt(o);while(y($));return c=15}if(E($))return o++,r+=String.fromCharCode($),$===13&&s.charCodeAt(o)===10&&(o++,r+=`
`),c=14;switch($){case 123:return o++,c=1;case 125:return o++,c=2;case 91:return o++,c=3;case 93:return o++,c=4;case 58:return o++,c=6;case 44:return o++,c=5;case 34:return o++,r=U(),c=10;case 47:{const N=o-1;if(s.charCodeAt(o+1)===47){for(o+=2;o<i&&!E(s.charCodeAt(o));)o++;return r=s.substring(N,o),c=12}if(s.charCodeAt(o+1)===42){o+=2;const K=i-1;let z=!1;for(;o<K;){if(s.charCodeAt(o)===42&&s.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,h=1),r=s.substring(N,o),c=13}return r+=String.fromCharCode($),o++,c=16}case 45:if(r+=String.fromCharCode($),o++,o===i||!I(s.charCodeAt(o)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),c=11;default:for(;o<i&&A($);)o++,$=s.charCodeAt(o);if(n!==o){switch(r=s.substring(n,o),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode($),o++,c=16}}function A($){if(y($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>o,scan:u?M:B,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>n,getTokenLength:()=>o-n,getTokenError:()=>h}}e.createScanner=_;function y(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function E(s){return s===10||s===13||s===8232||s===8233}function I(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function k(s,u){const o=[],i=new Object;let r;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(m,C,L,U){n.value=m,n.offset=C,n.length=L,n.type=U,n.colonOffset=void 0,r=n}try{f(s,{onObjectBegin:(m,C)=>{if(u<=m)throw i;r=void 0,c=u>m,o.push("")},onObjectProperty:(m,C,L)=>{if(u<C||(h(m,C,L,"property"),o[o.length-1]=m,u<=C+L))throw i},onObjectEnd:(m,C)=>{if(u<=m)throw i;r=void 0,o.pop()},onArrayBegin:(m,C)=>{if(u<=m)throw i;r=void 0,o.push(0)},onArrayEnd:(m,C)=>{if(u<=m)throw i;r=void 0,o.pop()},onLiteralValue:(m,C,L)=>{if(u<C||(h(m,C,L,g(m)),u<=C+L))throw i},onSeparator:(m,C,L)=>{if(u<=C)throw i;if(m===":"&&r&&r.type==="property")r.colonOffset=C,c=!1,r=void 0;else if(m===","){const U=o[o.length-1];typeof U=="number"?o[o.length-1]=U+1:(c=!0,o[o.length-1]=""),r=void 0}}})}catch(m){if(m!==i)throw m}return{path:o,previousNode:r,isAtPropertyKey:c,matches:m=>{let C=0;for(let L=0;C<m.length&&L<o.length;L++)if(m[C]===o[L]||m[C]==="*")C++;else if(m[C]!=="**")return!1;return C===m.length}}}e.getLocation=k;function S(s,u=[],o=P.DEFAULT){let i=null,r=[];const n=[];function c(m){Array.isArray(r)?r.push(m):i!==null&&(r[i]=m)}return f(s,{onObjectBegin:()=>{const m={};c(m),n.push(r),r=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{r=n.pop()},onArrayBegin:()=>{const m=[];c(m),n.push(r),r=m,i=null},onArrayEnd:()=>{r=n.pop()},onLiteralValue:c,onError:(m,C,L)=>{u.push({error:m,offset:C,length:L})}},o),r[0]}e.parse=S;function T(s,u=[],o=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function n(m){return i.children.push(m),m}f(s,{onObjectBegin:m=>{i=n({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,C,L)=>{i=n({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:C,length:L,parent:i})},onObjectEnd:(m,C)=>{i.length=m+C-i.offset,i=i.parent,r(m+C)},onArrayBegin:(m,C)=>{i=n({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,C)=>{i.length=m+C-i.offset,i=i.parent,r(m+C)},onLiteralValue:(m,C,L)=>{n({type:g(m),offset:C,length:L,parent:i,value:m}),r(C+L)},onSeparator:(m,C,L)=>{i.type==="property"&&(m===":"?i.colonOffset=C:m===","&&r(C))},onError:(m,C,L)=>{u.push({error:m,offset:C,length:L})}},o);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=T;function w(s,u){if(!s)return;let o=s;for(const i of u)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let r=!1;for(const n of o.children)if(Array.isArray(n.children)&&n.children[0].value===i){o=n.children[1],r=!0;break}if(!r)return}else{const r=i;if(o.type!=="array"||r<0||!Array.isArray(o.children)||r>=o.children.length)return;o=o.children[r]}return o}e.findNodeAtLocation=w;function b(s){if(!s.parent||!s.parent.children)return[];const u=b(s.parent);if(s.parent.type==="property"){const o=s.parent.children[0].value;u.push(o)}else if(s.parent.type==="array"){const o=s.parent.children.indexOf(s);o!==-1&&u.push(o)}return u}e.getNodePath=b;function v(s){switch(s.type){case"array":return s.children.map(v);case"object":{const u=Object.create(null);for(const o of s.children){const i=o.children[1];i&&(u[o.children[0].value]=v(i))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=v;function d(s,u,o=!1){return u>=s.offset&&u<s.offset+s.length||o&&u===s.offset+s.length}e.contains=d;function p(s,u,o=!1){if(d(s,u,o)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=u;r++){const n=p(i[r],u,o);if(n)return n}return s}}e.findNodeAtOffset=p;function f(s,u,o=P.DEFAULT){const i=_(s,!1);function r(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function n(he){return he?ve=>he(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=r(u.onObjectBegin),h=n(u.onObjectProperty),m=r(u.onObjectEnd),C=r(u.onArrayBegin),L=r(u.onArrayEnd),U=n(u.onLiteralValue),B=n(u.onSeparator),A=r(u.onComment),M=n(u.onError),$=o&&o.disallowComments,N=o&&o.allowTrailingComma;function K(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:$||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(he){case 12:case 13:$?z(10):A();break;case 16:z(1);break;case 15:case 14:break;default:return he}}}function z(he,ve=[],ne=[]){if(M(he),ve.length+ne.length>0){let pe=i.getToken();for(;pe!==17;){if(ve.indexOf(pe)!==-1){K();break}else if(ne.indexOf(pe)!==-1)break;pe=K()}}}function O(he){const ve=i.getTokenValue();return he?U(ve):h(ve),K(),!0}function x(){switch(i.getToken()){case 11:{let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(z(2),he=0)}catch{z(2)}U(he);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return K(),!0}function V(){return i.getToken()!==10?(z(3,[],[2,5]),!1):(O(!1),i.getToken()===6?(B(":"),K(),Q()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function q(){c(),K();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||z(4,[],[]),B(","),K(),i.getToken()===2&&N)break}else he&&z(6,[],[]);V()||z(4,[],[2,5]),he=!0}return m(),i.getToken()!==2?z(7,[2],[]):K(),!0}function Y(){C(),K();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||z(4,[],[]),B(","),K(),i.getToken()===4&&N)break}else he&&z(6,[],[]);Q()||z(4,[],[4,5]),he=!0}return L(),i.getToken()!==4?z(8,[4],[]):K(),!0}function Q(){switch(i.getToken()){case 3:return Y();case 1:return q();case 10:return O(!0);default:return x()}}return K(),i.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):Q()?(i.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=f;function a(s,u){const o=_(s),i=[];let r,n=0,c;do switch(c=o.getPosition(),r=o.scan(),r){case 12:case 13:case 17:n!==c&&i.push(s.substring(n,c)),u!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,u)),n=o.getPosition();break}while(r!==17);return i.join("")}e.stripComments=a;function g(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(De[78],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new l(()=>D(this.getValue()))}}e.Lazy=l}),define(De[6],Ie([1,0,59,60]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let P=null;function _(r){P=r}if(e.setDisposableTracker=_,D){const r="__is_disposable_tracked__";_(new class{trackDisposable(n){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[r]||console.log(c)},3e3)}setParent(n,c){if(n&&n!==p.None)try{n[r]=!0}catch{}}markAsDisposed(n){if(n&&n!==p.None)try{n[r]=!0}catch{}}markAsSingleton(n){}})}function y(r){return P?.trackDisposable(r),r}function E(r){P?.markAsDisposed(r)}function I(r,n){P?.setParent(r,n)}function R(r,n){if(!!P)for(const c of r)P.setParent(c,n)}function k(r){return P?.markAsSingleton(r),r}e.markAsSingleton=k;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function T(r){if(t.Iterable.is(r)){const n=[];for(const c of r)if(c)try{c.dispose()}catch(h){n.push(h)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=T;function w(r){for(const n of r)S(n)&&n.dispose();return[]}e.disposeIfDisposable=w;function b(...r){const n=v(()=>T(r));return R(r,n),n}e.combinedDisposable=b;function v(r){const n=y({dispose:(0,l.once)(()=>{E(n),r()})});return n}e.toDisposable=v;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{T(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new d,y(this),I(this._store,this)}dispose(){E(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&I(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&I(n,null),n}}e.MutableDisposable=f;class a{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(n){let c=n;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,E(this))},this}}e.SafeDisposable=g;class s{constructor(){this.references=new Map}acquire(n,...c){let h=this.references.get(n);h||(h={counter:0,object:this.createReferencedObject(n,...c)},this.references.set(n,h));const{object:m}=h,C=(0,l.once)(()=>{--h.counter===0&&(this.destroyReferencedObject(n,h.object),this.references.delete(n))});return h.counter++,{object:m,dispose:C}}}e.ReferenceCollection=s;class u{constructor(n){this.referenceCollection=n}async acquire(n,...c){const h=this.referenceCollection.acquire(n,...c);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(m){throw h.dispose(),m}}}e.AsyncReferenceCollection=u;class o{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=o;function i(r){const n=new d;try{r(n)}finally{n.dispose()}}e.disposeOnReturn=i}),define(De[79],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const _=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=_}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,_){const y=new l(P);if(this._first===l.Undefined)this._first=y,this._last=y;else if(_){const I=this._last;this._last=y,y.prev=I,I.next=y}else{const I=this._first;this._first=y,y.next=I,I.prev=y}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(y))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const _=P.prev;_.next=P.next,P.next.prev=_}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[144],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,ue){for(var fe=0;fe<ue.length;fe++){var Z=ue[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,ue,fe){return ue&&e(oe.prototype,ue),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,ue){if(!!oe){if(typeof oe=="string")return D(oe,ue);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return D(oe,ue)}}function D(oe,ue){(ue==null||ue>oe.length)&&(ue=oe.length);for(var fe=0,Z=new Array(ue);fe<ue;fe++)Z[fe]=oe[fe];return Z}function P(oe,ue){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=t(oe))||ue&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=_();function y(oe){J.defaults=oe}var E=/[&<>"']/,I=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ue){return S[ue]};function w(oe,ue){if(ue){if(E.test(oe))return oe.replace(I,T)}else if(R.test(oe))return oe.replace(k,T);return oe}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(oe){return oe.replace(b,function(ue,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var d=/(^|[^\[])\^/g;function p(oe,ue){oe=typeof oe=="string"?oe:oe.source,ue=ue||"";var fe={replace:function(ae,ee){return ee=ee.source||ee,ee=ee.replace(d,"$1"),oe=oe.replace(ae,ee),fe},getRegex:function(){return new RegExp(oe,ue)}};return fe}var f=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(oe,ue,fe){if(oe){var Z;try{Z=decodeURIComponent(v(fe)).replace(f,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ue&&!a.test(fe)&&(fe=r(ue,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var s={},u=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,ue){s[" "+oe]||(u.test(oe)?s[" "+oe]=oe+"/":s[" "+oe]=m(oe,"/",!0)),oe=s[" "+oe];var fe=oe.indexOf(":")===-1;return ue.substring(0,2)==="//"?fe?ue:oe.replace(o,"$1")+ue:ue.charAt(0)==="/"?fe?ue:oe.replace(i,"$1")+ue:oe+ue}var n={exec:function(){}};function c(oe){for(var ue=1,fe,Z;ue<arguments.length;ue++){fe=arguments[ue];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(oe[Z]=fe[Z])}return oe}function h(oe,ue){var fe=oe.replace(/\|/g,function(ee,ie,F){for(var H=!1,G=ie;--G>=0&&F[G]==="\\";)H=!H;return H?"|":" |"}),Z=fe.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ue)Z.splice(ue);else for(;Z.length<ue;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function m(oe,ue,fe){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ee=oe.charAt(Z-ae-1);if(ee===ue&&!fe)ae++;else if(ee!==ue&&fe)ae++;else break}return oe.slice(0,Z-ae)}function C(oe,ue){if(oe.indexOf(ue[1])===-1)return-1;for(var fe=oe.length,Z=0,ae=0;ae<fe;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===ue[0])Z++;else if(oe[ae]===ue[1]&&(Z--,Z<0))return ae;return-1}function L(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(oe,ue){if(ue<1)return"";for(var fe="";ue>1;)ue&1&&(fe+=oe),ue>>=1,oe+=oe;return fe+oe}function B(oe,ue,fe,Z){var ae=ue.href,ee=ue.title?w(ue.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var F={type:"link",raw:fe,href:ae,title:ee,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,F}return{type:"image",raw:fe,href:ae,title:ee,text:w(ie)}}function A(oe,ue){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return ue;var Z=fe[1];return ue.split(`
`).map(function(ae){var ee=ae.match(/^\s+/);if(ee===null)return ae;var ie=ee[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var M=function(){function oe(fe){this.options=fe||J.defaults}var ue=oe.prototype;return ue.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ue.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ee=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:m(ee,`
`)}}},ue.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ee=ae[0],ie=A(ee,ae[3]||"");return{type:"code",raw:ee,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},ue.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ee=ae[2].trim();if(/#$/.test(ee)){var ie=m(ee,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ee=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ue.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},ue.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ee=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ue.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ee,ie,F,H,G,X,me,we,le,Ce,ye,$e,je=ae[1].trim(),Ze=je.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+je.slice(0,-1):"",loose:!1,items:[]};je=Ze?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ze?je:"[*+-]");for(var Oe=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&($e=!1,!(!(ae=Oe.exec(Z))||this.rules.block.hr.test(Z)));){if(ee=ae[0],Z=Z.substring(ee.length),we=ae[2].split(`
`,1)[0],le=Z.split(`
`,1)[0],this.options.pedantic?(H=2,ye=we.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,ye=we.slice(H),H+=ae[1].length),X=!1,!we&&/^ *$/.test(le)&&(ee+=le+`
`,Z=Z.substring(le.length+1),$e=!0),!$e)for(var ot=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||ot.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=H||!we.trim())ye+=`
`+we.slice(H);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ee+=Ce+`
`,Z=Z.substring(Ce.length+1)}Ye.loose||(me?Ye.loose=!0:/\n *\n *$/.test(ee)&&(me=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(F=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!ie,checked:F,loose:!1,text:ye}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var de=Ye.items.length;for(G=0;G<de;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var Te=Ye.items[G].tokens.filter(function(Be){return Be.type==="space"}),Ne=Te.every(function(Be){for(var ze=Be.raw.split(""),Xe=0,nt=P(ze),ct;!(ct=nt()).done;){var st=ct.value;if(st===`
`&&(Xe+=1),Xe>1)return!0}return!1});!Ye.loose&&Te.length&&Ne&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},ue.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ee={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]);ee.type="paragraph",ee.text=ie,ee.tokens=this.lexer.inline(ie)}return ee}},ue.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ee=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ae[0],href:ae[2],title:ae[3]}}},ue.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ee={type:"table",header:h(ae[1]).map(function(me){return{text:me}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ae[0];var ie=ee.align.length,F,H,G,X;for(F=0;F<ie;F++)/^ *-+: *$/.test(ee.align[F])?ee.align[F]="right":/^ *:-+: *$/.test(ee.align[F])?ee.align[F]="center":/^ *:-+ *$/.test(ee.align[F])?ee.align[F]="left":ee.align[F]=null;for(ie=ee.rows.length,F=0;F<ie;F++)ee.rows[F]=h(ee.rows[F],ee.header.length).map(function(me){return{text:me}});for(ie=ee.header.length,H=0;H<ie;H++)ee.header[H].tokens=this.lexer.inline(ee.header[H].text);for(ie=ee.rows.length,H=0;H<ie;H++)for(X=ee.rows[H],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ee}}},ue.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ue.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ee=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ee,tokens:this.lexer.inline(ee)}}},ue.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ue.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:w(ae[1])}},ue.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]):ae[0]}},ue.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ee=ae[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ie=m(ee.slice(0,-1),"\\");if((ee.length-ie.length)%2===0)return}else{var F=C(ae[2],"()");if(F>-1){var H=ae[0].indexOf("!")===0?5:4,G=H+ae[1].length+F;ae[2]=ae[2].substring(0,F),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],me="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],me=we[3])}else me=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ee)?X=X.slice(1):X=X.slice(1,-1)),B(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ue.reflink=function(Z,ae){var ee;if((ee=this.rules.inline.reflink.exec(Z))||(ee=this.rules.inline.nolink.exec(Z))){var ie=(ee[2]||ee[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var F=ee[0].charAt(0);return{type:"text",raw:F,text:F}}return B(ee,ie,ee[0],this.lexer)}},ue.emStrong=function(Z,ae,ee){ee===void 0&&(ee="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=ie[1]||ie[2]||"";if(!F||F&&(ee===""||this.rules.inline.punctuation.exec(ee))){var H=ie[0].length-1,G,X,me=H,we=0,le=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,ae=ae.slice(-1*Z.length+H);(ie=le.exec(ae))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){me+=X;continue}else if((ie[5]||ie[6])&&H%3&&!((H+X)%3)){we+=X;continue}if(me-=X,!(me>0)){if(X=Math.min(X,X+me+we),Math.min(H,X)%2){var Ce=Z.slice(1,H+ie.index+X);return{type:"em",raw:Z.slice(0,H+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,H+ie.index+X-1);return{type:"strong",raw:Z.slice(0,H+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},ue.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ee=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ee),F=/^ /.test(ee)&&/ $/.test(ee);return ie&&F&&(ee=ee.substring(1,ee.length-1)),ee=w(ee,!0),{type:"codespan",raw:ae[0],text:ee}}},ue.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},ue.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ue.autolink=function(Z,ae){var ee=this.rules.inline.autolink.exec(Z);if(ee){var ie,F;return ee[2]==="@"?(ie=w(this.options.mangle?ae(ee[1]):ee[1]),F="mailto:"+ie):(ie=w(ee[1]),F=ie),{type:"link",raw:ee[0],text:ie,href:F,tokens:[{type:"text",raw:ie,text:ie}]}}},ue.url=function(Z,ae){var ee;if(ee=this.rules.inline.url.exec(Z)){var ie,F;if(ee[2]==="@")ie=w(this.options.mangle?ae(ee[0]):ee[0]),F="mailto:"+ie;else{var H;do H=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(H!==ee[0]);ie=w(ee[0]),ee[1]==="www."?F="http://"+ie:F=ie}return{type:"link",raw:ee[0],text:ie,href:F,tokens:[{type:"text",raw:ie,text:ie}]}}},ue.inlineText=function(Z,ae){var ee=this.rules.inline.text.exec(Z);if(ee){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]):ee[0]:ie=w(this.options.smartypants?ae(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ie}}},oe}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=p($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=p(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=p($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=p($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=p($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=p($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=c({},$),$.gfm=c({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=p($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=p($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=c({},$.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:p($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=p(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=p($._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=p(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=p(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=p(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=p(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=p(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=p(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=p(N.reflink).replace("label",N._label).replace("ref",$._label).getRegex(),N.nolink=p(N.nolink).replace("ref",$._label).getRegex(),N.reflinkSearch=p(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=c({},N),N.pedantic=c({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=c({},N.normal,{escape:p(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=p(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=c({},N.gfm,{br:p(N.br).replace("{2,}","*").getRegex(),text:p(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(oe){var ue="",fe,Z,ae=oe.length;for(fe=0;fe<ae;fe++)Z=oe.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),ue+="&#"+Z+";";return ue}var O=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||J.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:$.normal,inline:N.normal};this.options.pedantic?(Z.block=$.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=$.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ee=new oe(ae);return ee.lex(Z)},oe.lexInline=function(Z,ae){var ee=new oe(ae);return ee.inlineTokens(Z)};var ue=oe.prototype;return ue.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ue.blockTokens=function(Z,ae){var ee=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(me,we,le){return we+"    ".repeat(le.length)});for(var ie,F,H,G;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(ie=me.call({lexer:ee},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(H=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,we=Z.slice(1),le=void 0;ee.options.extensions.startBlock.forEach(function(Ce){le=Ce.call({lexer:this},we),typeof le=="number"&&le>=0&&(me=Math.min(me,le))}),me<1/0&&me>=0&&(H=Z.substring(0,me+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(H))){F=ae[ae.length-1],G&&F.type==="paragraph"?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie),G=H.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},ue.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},ue.inlineTokens=function(Z,ae){var ee=this;ae===void 0&&(ae=[]);var ie,F,H,G=Z,X,me,we;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)le.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+U("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+U("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(me||(we=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ee},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&ie.type==="text"&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&ie.type==="text"&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,G,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,z))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(H=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,$e=Z.slice(1),je=void 0;ee.options.extensions.startInline.forEach(function(Ze){je=Ze.call({lexer:this},$e),typeof je=="number"&&je>=0&&(ye=Math.min(ye,je))}),ye<1/0&&ye>=0&&(H=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(H,K)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),me=!0,F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:$,inline:N}}}]),oe}(),x=function(){function oe(fe){this.options=fe||J.defaults}var ue=oe.prototype;return ue.code=function(Z,ae,ee){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(Z,ie);F!=null&&F!==Z&&(ee=!0,Z=F)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+w(ie,!0)+'">'+(ee?Z:w(Z,!0))+`</code></pre>
`:"<pre><code>"+(ee?Z:w(Z,!0))+`</code></pre>
`},ue.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ue.html=function(Z){return Z},ue.heading=function(Z,ae,ee,ie){if(this.options.headerIds){var F=this.options.headerPrefix+ie.slug(ee);return"<h"+ae+' id="'+F+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(Z,ae,ee){var ie=ae?"ol":"ul",F=ae&&ee!==1?' start="'+ee+'"':"";return"<"+ie+F+`>
`+Z+"</"+ie+`>
`},ue.listitem=function(Z){return"<li>"+Z+`</li>
`},ue.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(Z){return"<p>"+Z+`</p>
`},ue.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},ue.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ue.tablecell=function(Z,ae){var ee=ae.header?"th":"td",ie=ae.align?"<"+ee+' align="'+ae.align+'">':"<"+ee+">";return ie+Z+("</"+ee+`>
`)},ue.strong=function(Z){return"<strong>"+Z+"</strong>"},ue.em=function(Z){return"<em>"+Z+"</em>"},ue.codespan=function(Z){return"<code>"+Z+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(Z){return"<del>"+Z+"</del>"},ue.link=function(Z,ae,ee){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ee;var ie='<a href="'+w(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ee+"</a>",ie},ue.image=function(Z,ae,ee){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ee;var ie='<img src="'+Z+'" alt="'+ee+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},ue.text=function(Z){return Z},oe}(),V=function(){function oe(){}var ue=oe.prototype;return ue.strong=function(Z){return Z},ue.em=function(Z){return Z},ue.codespan=function(Z){return Z},ue.del=function(Z){return Z},ue.html=function(Z){return Z},ue.text=function(Z){return Z},ue.link=function(Z,ae,ee){return""+ee},ue.image=function(Z,ae,ee){return""+ee},ue.br=function(){return""},oe}(),q=function(){function oe(){this.seen={}}var ue=oe.prototype;return ue.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(Z,ae){var ee=Z,ie=0;if(this.seen.hasOwnProperty(ee)){ie=this.seen[Z];do ie++,ee=Z+"-"+ie;while(this.seen.hasOwnProperty(ee))}return ae||(this.seen[Z]=ie,this.seen[ee]=0),ee},ue.slug=function(Z,ae){ae===void 0&&(ae={});var ee=this.serialize(Z);return this.getNextSafeSlug(ee,ae.dryrun)},oe}(),Y=function(){function oe(fe){this.options=fe||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new q}oe.parse=function(Z,ae){var ee=new oe(ae);return ee.parse(Z)},oe.parseInline=function(Z,ae){var ee=new oe(ae);return ee.parseInline(Z)};var ue=oe.prototype;return ue.parse=function(Z,ae){ae===void 0&&(ae=!0);var ee="",ie,F,H,G,X,me,we,le,Ce,ye,$e,je,Ze,Ye,Oe,ot,re,se,Ee,de=Z.length;for(ie=0;ie<de;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,v(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(le="",we="",G=ye.header.length,F=0;F<G;F++)we+=this.renderer.tablecell(this.parseInline(ye.header[F].tokens),{header:!0,align:ye.align[F]});for(le+=this.renderer.tablerow(we),Ce="",G=ye.rows.length,F=0;F<G;F++){for(me=ye.rows[F],we="",X=me.length,H=0;H<X;H++)we+=this.renderer.tablecell(this.parseInline(me[H].tokens),{header:!1,align:ye.align[H]});Ce+=this.renderer.tablerow(we)}ee+=this.renderer.table(le,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ee+=this.renderer.blockquote(Ce);continue}case"list":{for($e=ye.ordered,je=ye.start,Ze=ye.loose,G=ye.items.length,Ce="",F=0;F<G;F++)Oe=ye.items[F],ot=Oe.checked,re=Oe.task,Ye="",Oe.task&&(se=this.renderer.checkbox(ot),Ze?Oe.tokens.length>0&&Oe.tokens[0].type==="paragraph"?(Oe.tokens[0].text=se+" "+Oe.tokens[0].text,Oe.tokens[0].tokens&&Oe.tokens[0].tokens.length>0&&Oe.tokens[0].tokens[0].type==="text"&&(Oe.tokens[0].tokens[0].text=se+" "+Oe.tokens[0].tokens[0].text)):Oe.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Oe.tokens,Ze),Ce+=this.renderer.listitem(Ye,re,ot);ee+=this.renderer.list(Ce,$e,je);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<de&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var Te='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return ee},ue.parseInline=function(Z,ae){ae=ae||this.renderer;var ee="",ie,F,H,G=Z.length;for(ie=0;ie<G;ie++){if(F=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(H=this.options.extensions.renderers[F.type].call({parser:this},F),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){ee+=H||"";continue}switch(F.type){case"escape":{ee+=ae.text(F.text);break}case"html":{ee+=ae.html(F.text);break}case"link":{ee+=ae.link(F.href,F.title,this.parseInline(F.tokens,ae));break}case"image":{ee+=ae.image(F.href,F.title,F.text);break}case"strong":{ee+=ae.strong(this.parseInline(F.tokens,ae));break}case"em":{ee+=ae.em(this.parseInline(F.tokens,ae));break}case"codespan":{ee+=ae.codespan(F.text);break}case"br":{ee+=ae.br();break}case"del":{ee+=ae.del(this.parseInline(F.tokens,ae));break}case"text":{ee+=ae.text(F.text);break}default:{var X='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ee},oe}();function Q(oe,ue,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ue=="function"&&(fe=ue,ue=null),ue=c({},Q.defaults,ue||{}),L(ue),fe){var Z=ue.highlight,ae;try{ae=O.lex(oe,ue)}catch(G){return fe(G)}var ee=function(X){var me;if(!X)try{ue.walkTokens&&Q.walkTokens(ae,ue.walkTokens),me=Y.parse(ae,ue)}catch(we){X=we}return ue.highlight=Z,X?fe(X):fe(null,me)};if(!Z||Z.length<3||(delete ue.highlight,!ae.length))return ee();var ie=0;Q.walkTokens(ae,function(G){G.type==="code"&&(ie++,setTimeout(function(){Z(G.text,G.lang,function(X,me){if(X)return ee(X);me!=null&&me!==G.text&&(G.text=me,G.escaped=!0),ie--,ie===0&&ee()})},0))}),ie===0&&ee();return}function F(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+w(G.message+"",!0)+"</pre>";throw G}try{var H=O.lex(oe,ue);if(ue.walkTokens){if(ue.async)return Promise.all(Q.walkTokens(H,ue.walkTokens)).then(function(){return Y.parse(H,ue)}).catch(F);Q.walkTokens(H,ue.walkTokens)}return Y.parse(H,ue)}catch(G){F(G)}}Q.options=Q.setOptions=function(oe){return c(Q.defaults,oe),y(Q.defaults),Q},Q.getDefaults=_,Q.defaults=J.defaults,Q.use=function(){for(var oe=arguments.length,ue=new Array(oe),fe=0;fe<oe;fe++)ue[fe]=arguments[fe];var Z=c.apply(void 0,[{}].concat(ue)),ae=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;ue.forEach(function(ie){if(ie.extensions&&(ee=!0,ie.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=ae.renderers?ae.renderers[H.name]:null;G?ae.renderers[H.name]=function(){for(var X=arguments.length,me=new Array(X),we=0;we<X;we++)me[we]=arguments[we];var le=H.renderer.apply(this,me);return le===!1&&(le=G.apply(this,me)),le}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),ie.renderer&&function(){var H=Q.defaults.renderer||new x,G=function(we){var le=H[we];H[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),$e=0;$e<Ce;$e++)ye[$e]=arguments[$e];var je=ie.renderer[we].apply(H,ye);return je===!1&&(je=le.apply(H,ye)),je}};for(var X in ie.renderer)G(X);Z.renderer=H}(),ie.tokenizer&&function(){var H=Q.defaults.tokenizer||new M,G=function(we){var le=H[we];H[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),$e=0;$e<Ce;$e++)ye[$e]=arguments[$e];var je=ie.tokenizer[we].apply(H,ye);return je===!1&&(je=le.apply(H,ye)),je}};for(var X in ie.tokenizer)G(X);Z.tokenizer=H}(),ie.walkTokens){var F=Q.defaults.walkTokens;Z.walkTokens=function(H){var G=[];return G.push(ie.walkTokens.call(this,H)),F&&(G=G.concat(F.call(this,H))),G}}ee&&(Z.extensions=ae),Q.setOptions(Z)})},Q.walkTokens=function(oe,ue){for(var fe=[],Z=function(){var F=ee.value;switch(fe=fe.concat(ue.call(Q,F)),F.type){case"table":{for(var H=P(F.header),G;!(G=H()).done;){var X=G.value;fe=fe.concat(Q.walkTokens(X.tokens,ue))}for(var me=P(F.rows),we;!(we=me()).done;)for(var le=we.value,Ce=P(le),ye;!(ye=Ce()).done;){var $e=ye.value;fe=fe.concat(Q.walkTokens($e.tokens,ue))}break}case"list":{fe=fe.concat(Q.walkTokens(F.items,ue));break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[F.type]?Q.defaults.extensions.childTokens[F.type].forEach(function(je){fe=fe.concat(Q.walkTokens(F[je],ue))}):F.tokens&&(fe=fe.concat(Q.walkTokens(F.tokens,ue)))}},ae=P(oe),ee;!(ee=ae()).done;)Z();return fe},Q.parseInline=function(oe,ue){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ue=c({},Q.defaults,ue||{}),L(ue);try{var fe=O.lexInline(oe,ue);return ue.walkTokens&&Q.walkTokens(fe,ue.walkTokens),Y.parseInline(fe,ue)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+w(Z.message+"",!0)+"</pre>";throw Z}},Q.Parser=Y,Q.parser=Y.parse,Q.Renderer=x,Q.TextRenderer=V,Q.Lexer=O,Q.lexer=O.lex,Q.Tokenizer=M,Q.Slugger=q,Q.parse=Q;var he=Q.options,ve=Q.setOptions,ne=Q.use,pe=Q.walkTokens,be=Q.parseInline,ke=Q,Le=Y.parse,We=O.lex;J.Lexer=O,J.Parser=Y,J.Renderer=x,J.Slugger=q,J.TextRenderer=V,J.Tokenizer=M,J.getDefaults=_,J.lexer=We,J.marked=Q,J.options=he,J.parse=ke,J.parseInline=be,J.parser=Le,J.setOptions=ve,J.use=ne,J.walkTokens=pe,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[94],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(y,E,I){return Math.min(Math.max(y,E),I)}e.clamp=l;function t(y,E){return(E+y%E)%E}e.rot=t;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class P{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class _{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const I=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function J(D){const P=[];typeof D=="number"&&P.push("code/timeOrigin",D);function _(E){P.push(E,Date.now())}function y(){const E=[];for(let I=0;I<P.length;I+=2)E.push({name:P[I],startTime:P[I+1]});return E}return{mark:_,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const _ of performance.getEntriesByType("mark"))P.push({name:_.name,startTime:Math.round(D+_.startTime)});return P}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return J[t].call(D.exports,D,D.exports,l),D.l=!0,D.exports}return l.m=J,l.c=e,l.d=function(t,D,P){l.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,D){if(1&D&&(t=l(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var _ in t)l.d(P,_,function(y){return t[y]}.bind(null,_));return P},l.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(D,"a",D),D},l.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var D;e=J.exports=ne,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],E=e.src=[],I=0,R=I++;E[R]="0|[1-9]\\d*";var k=I++;E[k]="[0-9]+";var S=I++;E[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;E[T]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var w=I++;E[w]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var b=I++;E[b]="(?:"+E[R]+"|"+E[S]+")";var v=I++;E[v]="(?:"+E[k]+"|"+E[S]+")";var d=I++;E[d]="(?:-("+E[b]+"(?:\\."+E[b]+")*))";var p=I++;E[p]="(?:-?("+E[v]+"(?:\\."+E[v]+")*))";var f=I++;E[f]="[0-9A-Za-z-]+";var a=I++;E[a]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var g=I++,s="v?"+E[T]+E[d]+"?"+E[a]+"?";E[g]="^"+s+"$";var u="[v=\\s]*"+E[w]+E[p]+"?"+E[a]+"?",o=I++;E[o]="^"+u+"$";var i=I++;E[i]="((?:<|>)?=?)";var r=I++;E[r]=E[k]+"|x|X|\\*";var n=I++;E[n]=E[R]+"|x|X|\\*";var c=I++;E[c]="[v=\\s]*("+E[n]+")(?:\\.("+E[n]+")(?:\\.("+E[n]+")(?:"+E[d]+")?"+E[a]+"?)?)?";var h=I++;E[h]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[p]+")?"+E[a]+"?)?)?";var m=I++;E[m]="^"+E[i]+"\\s*"+E[c]+"$";var C=I++;E[C]="^"+E[i]+"\\s*"+E[h]+"$";var L=I++;E[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=I++;E[U]="(?:~>?)";var B=I++;E[B]="(\\s*)"+E[U]+"\\s+",y[B]=new RegExp(E[B],"g");var A=I++;E[A]="^"+E[U]+E[c]+"$";var M=I++;E[M]="^"+E[U]+E[h]+"$";var $=I++;E[$]="(?:\\^)";var N=I++;E[N]="(\\s*)"+E[$]+"\\s+",y[N]=new RegExp(E[N],"g");var K=I++;E[K]="^"+E[$]+E[c]+"$";var z=I++;E[z]="^"+E[$]+E[h]+"$";var O=I++;E[O]="^"+E[i]+"\\s*("+u+")$|^$";var x=I++;E[x]="^"+E[i]+"\\s*("+s+")$|^$";var V=I++;E[V]="(\\s*)"+E[i]+"\\s*("+u+"|"+E[c]+")",y[V]=new RegExp(E[V],"g");var q=I++;E[q]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var Y=I++;E[Y]="^\\s*("+E[h]+")\\s+-\\s+("+E[h]+")\\s*$";var Q=I++;E[Q]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)D(he,E[he]),y[he]||(y[he]=new RegExp(E[he]));function ve(le,Ce){if(le instanceof ne)return le;if(typeof le!="string"||le.length>P||!(Ce?y[o]:y[g]).test(le))return null;try{return new ne(le,Ce)}catch{return null}}function ne(le,Ce){if(le instanceof ne){if(le.loose===Ce)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(le,Ce);D("SemVer",le,Ce),this.loose=Ce;var ye=le.trim().match(Ce?y[o]:y[g]);if(!ye)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var je=+$e;if(je>=0&&je<_)return je}return $e}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ve,e.valid=function(le,Ce){var ye=ve(le,Ce);return ye?ye.version:null},e.clean=function(le,Ce){var ye=ve(le.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(le){return D("SemVer.compare",this.version,this.loose,le),le instanceof ne||(le=new ne(le,this.loose)),this.compareMain(le)||this.comparePre(le)},ne.prototype.compareMain=function(le){return le instanceof ne||(le=new ne(le,this.loose)),be(this.major,le.major)||be(this.minor,le.minor)||be(this.patch,le.patch)},ne.prototype.comparePre=function(le){if(le instanceof ne||(le=new ne(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],$e=le.prerelease[Ce];if(D("prerelease compare",Ce,ye,$e),ye===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ye===void 0)return-1;if(ye!==$e)return be(ye,$e)}while(++Ce)},ne.prototype.inc=function(le,Ce){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,Ce,ye,$e){typeof ye=="string"&&($e=ye,ye=void 0);try{return new ne(le,ye).inc(Ce,$e).version}catch{return null}},e.diff=function(le,Ce){if(oe(le,Ce))return null;var ye=ve(le),$e=ve(Ce);if(ye.prerelease.length||$e.prerelease.length){for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==$e[je])return"pre"+je;return"prerelease"}for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==$e[je])return je},e.compareIdentifiers=be;var pe=/^[0-9]+$/;function be(le,Ce){var ye=pe.test(le),$e=pe.test(Ce);return ye&&$e&&(le=+le,Ce=+Ce),ye&&!$e?-1:$e&&!ye?1:le<Ce?-1:le>Ce?1:0}function ke(le,Ce,ye){return new ne(le,ye).compare(new ne(Ce,ye))}function Le(le,Ce,ye){return ke(le,Ce,ye)>0}function We(le,Ce,ye){return ke(le,Ce,ye)<0}function oe(le,Ce,ye){return ke(le,Ce,ye)===0}function ue(le,Ce,ye){return ke(le,Ce,ye)!==0}function fe(le,Ce,ye){return ke(le,Ce,ye)>=0}function Z(le,Ce,ye){return ke(le,Ce,ye)<=0}function ae(le,Ce,ye,$e){var je;switch(Ce){case"===":typeof le=="object"&&(le=le.version),typeof ye=="object"&&(ye=ye.version),je=le===ye;break;case"!==":typeof le=="object"&&(le=le.version),typeof ye=="object"&&(ye=ye.version),je=le!==ye;break;case"":case"=":case"==":je=oe(le,ye,$e);break;case"!=":je=ue(le,ye,$e);break;case">":je=Le(le,ye,$e);break;case">=":je=fe(le,ye,$e);break;case"<":je=We(le,ye,$e);break;case"<=":je=Z(le,ye,$e);break;default:throw new TypeError("Invalid operator: "+Ce)}return je}function ee(le,Ce){if(le instanceof ee){if(le.loose===Ce)return le;le=le.value}if(!(this instanceof ee))return new ee(le,Ce);D("comparator",le,Ce),this.loose=Ce,this.parse(le),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(le,Ce){return be(Ce,le)},e.major=function(le,Ce){return new ne(le,Ce).major},e.minor=function(le,Ce){return new ne(le,Ce).minor},e.patch=function(le,Ce){return new ne(le,Ce).patch},e.compare=ke,e.compareLoose=function(le,Ce){return ke(le,Ce,!0)},e.rcompare=function(le,Ce,ye){return ke(Ce,le,ye)},e.sort=function(le,Ce){return le.sort(function(ye,$e){return e.compare(ye,$e,Ce)})},e.rsort=function(le,Ce){return le.sort(function(ye,$e){return e.rcompare(ye,$e,Ce)})},e.gt=Le,e.lt=We,e.eq=oe,e.neq=ue,e.gte=fe,e.lte=Z,e.cmp=ae,e.Comparator=ee;var ie={};function F(le,Ce){if(le instanceof F)return le.loose===Ce?le:new F(le.raw,Ce);if(le instanceof ee)return new F(le.value,Ce);if(!(this instanceof F))return new F(le,Ce);if(this.loose=Ce,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function H(le){return!le||le.toLowerCase()==="x"||le==="*"}function G(le,Ce,ye,$e,je,Ze,Ye,Oe,ot,re,se,Ee,de){return((Ce=H(ye)?"":H($e)?">="+ye+".0.0":H(je)?">="+ye+"."+$e+".0":">="+Ce)+" "+(Oe=H(ot)?"":H(re)?"<"+(+ot+1)+".0.0":H(se)?"<"+ot+"."+(+re+1)+".0":Ee?"<="+ot+"."+re+"."+se+"-"+Ee:"<="+Oe)).trim()}function X(le,Ce){for(var ye=0;ye<le.length;ye++)if(!le[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<le.length;ye++)if(D(le[ye].semver),le[ye].semver!==ie&&le[ye].semver.prerelease.length>0){var $e=le[ye].semver;if($e.major===Ce.major&&$e.minor===Ce.minor&&$e.patch===Ce.patch)return!0}return!1}return!0}function me(le,Ce,ye){try{Ce=new F(Ce,ye)}catch{return!1}return Ce.test(le)}function we(le,Ce,ye,$e){var je,Ze,Ye,Oe,ot;switch(le=new ne(le,$e),Ce=new F(Ce,$e),ye){case">":je=Le,Ze=Z,Ye=We,Oe=">",ot=">=";break;case"<":je=We,Ze=fe,Ye=Le,Oe="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(le,Ce,$e))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Ee=null,de=null;if(se.forEach(function(Te){Te.semver===ie&&(Te=new ee(">=0.0.0")),Ee=Ee||Te,de=de||Te,je(Te.semver,Ee.semver,$e)?Ee=Te:Ye(Te.semver,de.semver,$e)&&(de=Te)}),Ee.operator===Oe||Ee.operator===ot||(!de.operator||de.operator===Oe)&&Ze(le,de.semver)||de.operator===ot&&Ye(le,de.semver))return!1}return!0}ee.prototype.parse=function(le){var Ce=this.loose?y[O]:y[x],ye=le.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+le);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ne(ye[2],this.loose):this.semver=ie},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(le){return D("Comparator.test",le,this.loose),this.semver===ie||(typeof le=="string"&&(le=new ne(le,this.loose)),ae(le,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(le,Ce){if(!(le instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new F(le.value,Ce),me(this.value,ye,Ce);if(le.operator==="")return ye=new F(this.value,Ce),me(le.semver,ye,Ce);var $e=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ze=this.semver.version===le.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Oe=ae(this.semver,"<",le.semver,Ce)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),ot=ae(this.semver,">",le.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return $e||je||Ze&&Ye||Oe||ot},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(le){var Ce=this.loose;le=le.trim(),D("range",le,Ce);var ye=Ce?y[Y]:y[q];le=le.replace(ye,G),D("hyphen replace",le),le=le.replace(y[V],"$1$2$3"),D("comparator trim",le,y[V]),le=(le=(le=le.replace(y[B],"$1~")).replace(y[N],"$1^")).split(/\s+/).join(" ");var $e=Ce?y[O]:y[x],je=le.split(" ").map(function(Ze){return function(Ye,Oe){return D("comp",Ye),Ye=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,de){D("caret",Ee,de);var Te=de?y[z]:y[K];return Ee.replace(Te,function(Ne,Be,ze,Xe,nt){var ct;return D("caret",Ee,Ne,Be,ze,Xe,nt),H(Be)?ct="":H(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Xe)?ct=Be==="0"?">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+".0 <"+(+Be+1)+".0.0":nt?(D("replaceCaret pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Xe+nt+" <"+Be+"."+ze+"."+(+Xe+1):">="+Be+"."+ze+"."+Xe+nt+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Xe+nt+" <"+(+Be+1)+".0.0"):(D("no pr"),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Xe+" <"+Be+"."+ze+"."+(+Xe+1):">="+Be+"."+ze+"."+Xe+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Xe+" <"+(+Be+1)+".0.0"),D("caret return",ct),ct})}(se,re)}).join(" ")}(Ye,Oe),D("caret",Ye),Ye=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,de){var Te=de?y[M]:y[A];return Ee.replace(Te,function(Ne,Be,ze,Xe,nt){var ct;return D("tilde",Ee,Ne,Be,ze,Xe,nt),H(Be)?ct="":H(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Xe)?ct=">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":nt?(D("replaceTilde pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=">="+Be+"."+ze+"."+Xe+nt+" <"+Be+"."+(+ze+1)+".0"):ct=">="+Be+"."+ze+"."+Xe+" <"+Be+"."+(+ze+1)+".0",D("tilde return",ct),ct})}(se,re)}).join(" ")}(Ye,Oe),D("tildes",Ye),Ye=function(ot,re){return D("replaceXRanges",ot,re),ot.split(/\s+/).map(function(se){return function(Ee,de){Ee=Ee.trim();var Te=de?y[C]:y[m];return Ee.replace(Te,function(Ne,Be,ze,Xe,nt,ct){D("xRange",Ee,Ne,Be,ze,Xe,nt,ct);var st=H(ze),et=st||H(Xe),gt=et||H(nt);return Be==="="&&gt&&(Be=""),st?Ne=Be===">"||Be==="<"?"<0.0.0":"*":Be&&gt?(et&&(Xe=0),gt&&(nt=0),Be===">"?(Be=">=",et?(ze=+ze+1,Xe=0,nt=0):gt&&(Xe=+Xe+1,nt=0)):Be==="<="&&(Be="<",et?ze=+ze+1:Xe=+Xe+1),Ne=Be+ze+"."+Xe+"."+nt):et?Ne=">="+ze+".0.0 <"+(+ze+1)+".0.0":gt&&(Ne=">="+ze+"."+Xe+".0 <"+ze+"."+(+Xe+1)+".0"),D("xRange return",Ne),Ne})}(se,re)}).join(" ")}(Ye,Oe),D("xrange",Ye),Ye=function(ot,re){return D("replaceStars",ot,re),ot.trim().replace(y[Q],"")}(Ye,Oe),D("stars",Ye),Ye}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ze){return!!Ze.match($e)})),je=je.map(function(Ze){return new ee(Ze,Ce)})},F.prototype.intersects=function(le,Ce){if(!(le instanceof F))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function($e){return le.set.some(function(je){return je.every(function(Ze){return $e.intersects(Ze,Ce)})})})})},e.toComparators=function(le,Ce){return new F(le,Ce).set.map(function(ye){return ye.map(function($e){return $e.value}).join(" ").trim().split(" ")})},F.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new ne(le,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(X(this.set[Ce],le))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(le,Ce,ye){var $e=null,je=null;try{var Ze=new F(Ce,ye)}catch{return null}return le.forEach(function(Ye){Ze.test(Ye)&&($e&&je.compare(Ye)!==-1||(je=new ne($e=Ye,ye)))}),$e},e.minSatisfying=function(le,Ce,ye){var $e=null,je=null;try{var Ze=new F(Ce,ye)}catch{return null}return le.forEach(function(Ye){Ze.test(Ye)&&($e&&je.compare(Ye)!==1||(je=new ne($e=Ye,ye)))}),$e},e.validRange=function(le,Ce){try{return new F(le,Ce).range||"*"}catch{return null}},e.ltr=function(le,Ce,ye){return we(le,Ce,"<",ye)},e.gtr=function(le,Ce,ye){return we(le,Ce,">",ye)},e.outside=we,e.prerelease=function(le,Ce){var ye=ve(le,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(le,Ce,ye){return le=new F(le,ye),Ce=new F(Ce,ye),le.intersects(Ce)},e.coerce=function(le){if(le instanceof ne)return le;if(typeof le!="string")return null;var Ce=le.match(y[L]);return Ce==null?null:ve((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,D=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function y(v){if(l===setTimeout)return setTimeout(v,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(v,0);try{return l(v,0)}catch{try{return l.call(null,v,0)}catch{return l.call(this,v,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:_}catch{t=_}})();var E,I=[],R=!1,k=-1;function S(){R&&E&&(R=!1,E.length?I=E.concat(I):k=-1,I.length&&T())}function T(){if(!R){var v=y(S);R=!0;for(var d=I.length;d;){for(E=I,I=[];++k<d;)E&&E[k].run();k=-1,d=I.length}E=null,R=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===_||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(v)}}function w(v,d){this.fun=v,this.array=d}function b(){}D.nextTick=function(v){var d=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)d[p-1]=arguments[p];I.push(new w(v,d)),I.length!==1||R||y(T)},w.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=b,D.addListener=b,D.once=b,D.off=b,D.removeListener=b,D.removeAllListeners=b,D.emit=b,D.prependListener=b,D.prependOnceListener=b,D.listeners=function(v){return[]},D.binding=function(v){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(v){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(De[95],Ie([1,0,10,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(a){const g=a;return g?typeof g.read=="function":!1}e.isReadable=D;function P(a){const g=a;return g?[g.on,g.pause,g.resume,g.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=P;function _(a){const g=a;return g?P(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=_;function y(a,g){return new E(a,g)}e.newWriteableStream=y;class E{constructor(g,s){this.reducer=g,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(s=>s(g))}emitError(g){this.listeners.error.length===0?(0,l.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(s=>s(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,s){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(g,s){if(this.state.destroyed)return;let u;switch(g){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const o=u.indexOf(s);o>=0&&u.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(a,g){const s=[];let u;for(;(u=a.read())!==null;)s.push(u);return g(s)}e.consumeReadable=I;function R(a,g,s){const u=[];let o;for(;(o=a.read())!==null&&u.length<s;)u.push(o);return o===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return a.read()}}}e.peekReadable=R;function k(a,g){return new Promise((s,u)=>{const o=[];S(a,{onData:i=>{g&&o.push(i)},onError:i=>{g?u(i):s(void 0)},onEnd:()=>{s(g?g(o):void 0)}})})}e.consumeStream=k;function S(a,g){let s=!1;return a.on("error",u=>{s||g.onError(u)}),a.on("end",()=>{s||g.onEnd()}),a.on("data",u=>{s||g.onData(u)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=S;function T(a,g){return new Promise((s,u)=>{const o=new t.DisposableStore,i=[],r=h=>{if(i.push(h),i.length>g)return o.dispose(),a.pause(),s({stream:a,buffer:i,ended:!1})},n=h=>u(h),c=()=>s({stream:a,buffer:i,ended:!0});o.add((0,t.toDisposable)(()=>a.removeListener("error",n))),a.on("error",n),o.add((0,t.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),o.add((0,t.toDisposable)(()=>a.removeListener("data",r))),a.on("data",r)})}e.peekStream=T;function w(a,g){const s=y(g);return s.end(a),s}e.toStream=w;function b(){const a=y(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=b;function v(a){let g=!1;return{read:()=>g?null:(g=!0,a)}}e.toReadable=v;function d(a,g,s){const u=y(s);return S(a,{onData:o=>u.write(g.data(o)),onError:o=>u.error(g.error?g.error(o):o),onEnd:()=>u.end()}),u}e.transform=d;function p(a,g,s){let u=!1;return{read:()=>{const o=g.read();return u?o:(u=!0,o!==null?s([a,o]):a)}}}e.prefixedReadable=p;function f(a,g,s){let u=!1;const o=y(s);return S(g,{onData:i=>u?o.write(i):(u=!0,o.write(s([a,i]))),onError:i=>o.error(i),onEnd:()=>{u||(u=!0,o.write(a)),o.end()}}),o}e.prefixedStream=f}),define(De[23],Ie([1,0,95]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,P;class _{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new _(Buffer.allocUnsafe(h)):new _(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new _(h)}static fromString(h,m){return!(m?.dontUseNodeBuffer||!1)&&t?new _(Buffer.from(h)):(D||(D=new TextEncoder),new _(D.encode(h)))}static fromByteArray(h){const m=_.alloc(h.length);for(let C=0,L=h.length;C<L;C++)m.buffer[C]=h[C];return m}static concat(h,m){if(typeof m>"u"){m=0;for(let U=0,B=h.length;U<B;U++)m+=h[U].byteLength}const C=_.alloc(m);let L=0;for(let U=0,B=h.length;U<B;U++){const A=h[U];C.set(A,L),L+=A.byteLength}return C}clone(){const h=_.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(h,m){return new _(this.buffer.subarray(h,m))}set(h,m){if(h instanceof _)this.buffer.set(h.buffer,m);else if(h instanceof Uint8Array)this.buffer.set(h,m);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),m);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return I(this.buffer,h)}writeUInt32BE(h,m){R(this.buffer,h,m)}readUInt32LE(h){return k(this.buffer,h)}writeUInt32LE(h,m){S(this.buffer,h,m)}readUInt8(h){return T(this.buffer,h)}writeUInt8(h,m){w(this.buffer,h,m)}}e.VSBuffer=_;function y(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=y;function E(c,h,m){c[m+0]=h&255,h=h>>>8,c[m+1]=h&255}e.writeUInt16LE=E;function I(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=I;function R(c,h,m){c[m+3]=h,h=h>>>8,c[m+2]=h,h=h>>>8,c[m+1]=h,h=h>>>8,c[m]=h}e.writeUInt32BE=R;function k(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=k;function S(c,h,m){c[m+0]=h&255,h=h>>>8,c[m+1]=h&255,h=h>>>8,c[m+2]=h&255,h=h>>>8,c[m+3]=h&255}e.writeUInt32LE=S;function T(c,h){return c[h]}e.readUInt8=T;function w(c,h,m){c[m]=h}e.writeUInt8=w;function b(c){return l.consumeReadable(c,h=>_.concat(h))}e.readableToBuffer=b;function v(c){return l.toReadable(c)}e.bufferToReadable=v;function d(c){return l.consumeStream(c,h=>_.concat(h))}e.streamToBuffer=d;async function p(c){return c.ended?_.concat(c.buffer):_.concat([...c.buffer,await d(c.stream)])}e.bufferedStreamToBuffer=p;function f(c){return l.toStream(c,h=>_.concat(h))}e.bufferToStream=f;function a(c){return l.transform(c,{data:h=>typeof h=="string"?_.fromString(h):_.wrap(h)},h=>_.concat(h))}e.streamToBufferReadableStream=a;function g(c){return l.newWriteableStream(h=>_.concat(h),c)}e.newWriteableBufferStream=g;function s(c,h){return l.prefixedReadable(c,h,m=>_.concat(m))}e.prefixedBufferReadable=s;function u(c,h){return l.prefixedStream(c,h,m=>_.concat(m))}e.prefixedBufferStream=u;function o(c){let h=0,m=0,C=0;const L=new Uint8Array(Math.floor(c.length/4*3)),U=A=>{switch(m){case 3:L[C++]=h|A,m=0;break;case 2:L[C++]=h|A>>>2,h=A<<6,m=3;break;case 1:L[C++]=h|A>>>4,h=A<<4,m=2;break;default:h=A<<2,m=1}};for(let A=0;A<c.length;A++){const M=c.charCodeAt(A);if(M>=65&&M<=90)U(M-65);else if(M>=97&&M<=122)U(M-97+26);else if(M>=48&&M<=57)U(M-48+52);else if(M===43||M===45)U(62);else if(M===47||M===95)U(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${c[A]}`)}}const B=C;for(;m>0;)U(0);return _.wrap(L).slice(0,B)}e.decodeBase64=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:c},h=!0,m=!1){const C=m?r:i;let L="";const U=c.byteLength%3;let B=0;for(;B<c.byteLength-U;B+=3){const A=c[B+0],M=c[B+1],$=c[B+2];L+=C[A>>>2],L+=C[(A<<4|M>>>4)&63],L+=C[(M<<2|$>>>6)&63],L+=C[$&63]}if(U===1){const A=c[B+0];L+=C[A>>>2],L+=C[A<<4&63],h&&(L+="==")}else if(U===2){const A=c[B+0],M=c[B+1];L+=C[A>>>2],L+=C[(A<<4|M>>>4)&63],L+=C[M<<2&63],h&&(L+="=")}return L}e.encodeBase64=n}),define(De[13],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(u){return typeof u=="string"}e.isString=l;function t(u){return Array.isArray(u)&&u.every(o=>l(o))}e.isStringArray=t;function D(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=D;function P(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}e.isTypedArray=P;function _(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=_;function y(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=y;function E(u){return u===!0||u===!1}e.isBoolean=E;function I(u){return typeof u>"u"}e.isUndefined=I;function R(u){return!k(u)}e.isDefined=R;function k(u){return I(u)||u===null}e.isUndefinedOrNull=k;function S(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=S;function T(u){if(k(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=T;function w(...u){const o=[];for(let i=0;i<u.length;i++){const r=u[i];if(k(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);o.push(r)}return o}e.assertAllDefined=w;const b=Object.prototype.hasOwnProperty;function v(u){if(!D(u))return!1;for(const o in u)if(b.call(u,o))return!1;return!0}e.isEmptyObject=v;function d(u){return typeof u=="function"}e.isFunction=d;function p(...u){return u.length>0&&u.every(d)}e.areFunctions=p;function f(u,o){const i=Math.min(u.length,o.length);for(let r=0;r<i;r++)a(u[r],o[r])}e.validateConstraints=f;function a(u,o){if(l(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(d(o)){try{if(u instanceof o)return}catch{}if(!k(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function g(u){return u===null?void 0:u}e.withNullAsUndefined=g;function s(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=s}),define(De[24],Ie([1,0,13]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(f=>{d[f]&&typeof d[f]=="object"?p[f]=t(d[f]):p[f]=d[f]}),p}e.deepClone=t;function D(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const f=p.shift();Object.freeze(f);for(const a in f)if(P.call(f,a)){const g=f[a];typeof g=="object"&&!Object.isFrozen(g)&&!(0,l.isTypedArray)(g)&&p.push(g)}}return d}e.deepFreeze=D;const P=Object.prototype.hasOwnProperty;function _(d,p){return y(d,p,new Set)}e.cloneAndChange=_;function y(d,p,f){if((0,l.isUndefinedOrNull)(d))return d;const a=p(d);if(typeof a<"u")return a;if(Array.isArray(d)){const g=[];for(const s of d)g.push(y(s,p,f));return g}if((0,l.isObject)(d)){if(f.has(d))throw new Error("Cannot clone recursive data-structure");f.add(d);const g={};for(const s in d)P.call(d,s)&&(g[s]=y(d[s],p,f));return f.delete(d),g}return d}function E(d,p,f=!0){return(0,l.isObject)(d)?((0,l.isObject)(p)&&Object.keys(p).forEach(a=>{a in d?f&&((0,l.isObject)(d[a])&&(0,l.isObject)(p[a])?E(d[a],p[a],f):d[a]=p[a]):d[a]=p[a]}),d):p}e.mixin=E;function I(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let f,a;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(f=0;f<d.length;f++)if(!I(d[f],p[f]))return!1}else{const g=[];for(a in d)g.push(a);g.sort();const s=[];for(a in p)s.push(a);if(s.sort(),!I(g,s))return!1;for(f=0;f<g.length;f++)if(!I(d[g[f]],p[g[f]]))return!1}return!0}e.equals=I;function R(d){const p=new Set;return JSON.stringify(d,(f,a)=>{if((0,l.isObject)(a)||Array.isArray(a)){if(p.has(a))return"[Circular]";p.add(a)}return a})}e.safeStringify=R;function k(d,p){const f=Object.create(null);return!d||!p||Object.keys(p).forEach(g=>{const s=d[g],u=p[g];I(s,u)||(f[g]=u)}),f}e.distinct=k;function S(d,p){const f=p.toLowerCase(),a=Object.keys(d).find(g=>g.toLowerCase()===f);return a?d[a]:d[p]}e.getCaseInsensitive=S;function T(d,p){const f=Object.create(null);for(const[a,g]of Object.entries(d))p(a,g)&&(f[a]=g);return f}e.filter=T;function w(d){let p=[],f=Object.getPrototypeOf(d);for(;Object.prototype!==f;)p=p.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return p}e.getAllPropertyNames=w;function b(d){const p=[];for(const f of w(d))typeof d[f]=="function"&&p.push(f);return p}e.getAllMethodNames=b;function v(d,p){const f=g=>function(){const s=Array.prototype.slice.call(arguments,0);return p(g,s)},a={};for(const g of d)a[g]=f(g);return a}e.createProxyObject=v}),define(De[96],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function D(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=D}),define(De[34],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return l.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let E=0;E<y.length;E++)y[E]=Math.floor(Math.random()*256);return y};const P=new Uint8Array(16),_=[];for(let y=0;y<256;y++)_.push(y.toString(16).padStart(2,"0"));return function(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let E=0,I="";return I+=_[P[E++]],I+=_[P[E++]],I+=_[P[E++]],I+=_[P[E++]],I+="-",I+=_[P[E++]],I+=_[P[E++]],I+="-",I+=_[P[E++]],I+=_[P[E++]],I+="-",I+=_[P[E++]],I+=_[P[E++]],I+="-",I+=_[P[E++]],I+=_[P[E++]],I+=_[P[E++]],I+=_[P[E++]],I+=_[P[E++]],I+=_[P[E++]],I}}()}),define(De[97],Ie([1,0,96]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(y){const E=(0,l.toUint8)(y);this._defaultValue=E,this._asciiMap=t._createAsciiMap(E),this._map=new Map}static _createAsciiMap(y){const E=new Uint8Array(256);for(let I=0;I<256;I++)E[I]=y;return E}set(y,E){const I=(0,l.toUint8)(E);y>=0&&y<256?this._asciiMap[y]=I:this._map.set(y,I)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=t;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(D||(D={}));class P{constructor(){this._actual=new t(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(D,P){this.lineNumber=D,this.column=P}with(D=this.lineNumber,P=this.column){return D===this.lineNumber&&P===this.column?this:new l(D,P)}delta(D=0,P=0){return this.with(this.lineNumber+D,this.column+P)}equals(D){return l.equals(this,D)}static equals(D,P){return!D&&!P?!0:!!D&&!!P&&D.lineNumber===P.lineNumber&&D.column===P.column}isBefore(D){return l.isBefore(this,D)}static isBefore(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<P.column}isBeforeOrEqual(D){return l.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<=P.column}static compare(D,P){const _=D.lineNumber|0,y=P.lineNumber|0;if(_===y){const E=D.column|0,I=P.column|0;return E-I}return _-y}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new l(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=l}),define(De[35],Ie([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,_,y,E){P>y||P===y&&_>E?(this.startLineNumber=y,this.startColumn=E,this.endLineNumber=P,this.endColumn=_):(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=y,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<P.startColumn||_.lineNumber===P.endLineNumber&&_.column>P.endColumn)}static strictContainsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<=P.startColumn||_.lineNumber===P.endLineNumber&&_.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<=P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,_){let y,E,I,R;return _.startLineNumber<P.startLineNumber?(y=_.startLineNumber,E=_.startColumn):_.startLineNumber===P.startLineNumber?(y=_.startLineNumber,E=Math.min(_.startColumn,P.startColumn)):(y=P.startLineNumber,E=P.startColumn),_.endLineNumber>P.endLineNumber?(I=_.endLineNumber,R=_.endColumn):_.endLineNumber===P.endLineNumber?(I=_.endLineNumber,R=Math.max(_.endColumn,P.endColumn)):(I=P.endLineNumber,R=P.endColumn),new t(y,E,I,R)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,_){let y=P.startLineNumber,E=P.startColumn,I=P.endLineNumber,R=P.endColumn;const k=_.startLineNumber,S=_.startColumn,T=_.endLineNumber,w=_.endColumn;return y<k?(y=k,E=S):y===k&&(E=Math.max(E,S)),I>T?(I=T,R=w):I===T&&(R=Math.min(R,w)),y>I||y===I&&E>R?null:new t(y,E,I,R)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,_){return!!P&&!!_&&P.startLineNumber===_.startLineNumber&&P.startColumn===_.startColumn&&P.endLineNumber===_.endLineNumber&&P.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,_){return new t(this.startLineNumber,this.startColumn,P,_)}setStartPosition(P,_){return new t(P,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,_=P){return new t(P.lineNumber,P.column,_.lineNumber,_.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn)}static areIntersecting(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,_){if(P&&_){const I=P.startLineNumber|0,R=_.startLineNumber|0;if(I===R){const k=P.startColumn|0,S=_.startColumn|0;if(k===S){const T=P.endLineNumber|0,w=_.endLineNumber|0;if(T===w){const b=P.endColumn|0,v=_.endColumn|0;return b-v}return T-w}return k-S}return I-R}return(P?1:0)-(_?1:0)}static compareRangesUsingEnds(P,_){return P.endLineNumber===_.endLineNumber?P.endColumn===_.endColumn?P.startLineNumber===_.startLineNumber?P.startColumn-_.startColumn:P.startLineNumber-_.startLineNumber:P.endColumn-_.endColumn:P.endLineNumber-_.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[145],Ie([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(y,E,I,R){super(y,E,I,R),this.selectionStartLineNumber=y,this.selectionStartColumn=E,this.positionLineNumber=I,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return P.selectionsEqual(this,y)}static selectionsEqual(y,E){return y.selectionStartLineNumber===E.selectionStartLineNumber&&y.selectionStartColumn===E.selectionStartColumn&&y.positionLineNumber===E.positionLineNumber&&y.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,E){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,y,E):new P(y,E,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(y,E){return this.getDirection()===0?new P(y,E,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,y,E)}static fromPositions(y,E=y){return new P(y.lineNumber,y.column,E.lineNumber,E.column)}static fromRange(y,E){return E===0?new P(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):new P(y.endLineNumber,y.endColumn,y.startLineNumber,y.startColumn)}static liftSelection(y){return new P(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,E){if(y&&!E||!y&&E)return!1;if(!y&&!E)return!0;if(y.length!==E.length)return!1;for(let I=0,R=y.length;I<R;I++)if(!this.selectionsEqual(y[I],E[I]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,E,I,R,k){return k===0?new P(y,E,I,R):new P(I,R,y,E)}}e.Selection=P}),define(De[146],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[147],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends l.CharacterClassifier{constructor(y){super(0);for(let E=0,I=y.length;E<I;E++)this.set(y.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function P(_){const y={};return E=>(y.hasOwnProperty(E)||(y[E]=_(E)),y[E])}e.getMapForWordSeparators=P(_=>new D(_))}),define(De[98],Ie([1,0,60,6,79]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(S+="\\"+T);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=P();function _(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),S=new RegExp(k.source,T)}return S.lastIndex=0,S}e.ensureValidWordDefinition=_;const y=new D.LinkedList;y.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(k){const S=y.unshift(k);return(0,t.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=E;function I(k,S,T,w,b){if(b||(b=l.Iterable.first(y)),T.length>b.maxLen){let a=k-b.maxLen/2;return a<0?a=0:w+=a,T=T.substring(a,k+b.maxLen/2),I(k,S,T,w,b)}const v=Date.now(),d=k-1-w;let p=-1,f=null;for(let a=1;!(Date.now()-v>=b.timeBudget);a++){const g=d-b.windowSize*a;S.lastIndex=Math.max(0,g);const s=R(S,T,d,p);if(!s&&f||(f=s,g<=0))break;p=g}if(f){const a={word:f[0],startColumn:w+1+f.index,endColumn:w+1+f.index+f[0].length};return S.lastIndex=0,a}return null}e.getWordAtText=I;function R(k,S,T,w){let b;for(;b=k.exec(S);){const v=b.index||0;if(v<=T&&k.lastIndex>=T)return b;if(w>0&&v>w)return null}return null}}),define(De[148],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(y){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=y.open,this.close=y.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(y.notIn))for(let E=0,I=y.notIn.length;E<I;E++)switch(y.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(y){switch(y){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(y,E){if(y.getTokenCount()===0)return!0;const I=y.findTokenIndexAtOffset(E-2),R=y.getStandardTokenType(I);return this.isOK(R)}_findNeutralCharacterInRange(y,E){for(let I=y;I<=E;I++){const R=String.fromCharCode(I);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class D{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of y)P(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),P(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),P(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),P(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&P(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=D;function P(_,y,E){_.has(y)?_.get(y).push(E):_.set(y,[E])}}),define(De[149],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class D{constructor(w,b,v){const d=new Uint8Array(w*b);for(let p=0,f=w*b;p<f;p++)d[p]=v;this._data=d,this.rows=w,this.cols=b}get(w,b){return this._data[w*this.cols+b]}set(w,b,v){this._data[w*this.cols+b]=v}}e.Uint8Matrix=D;class P{constructor(w){let b=0,v=0;for(let p=0,f=w.length;p<f;p++){const[a,g,s]=w[p];g>b&&(b=g),a>v&&(v=a),s>v&&(v=s)}b++,v++;const d=new D(v,b,0);for(let p=0,f=w.length;p<f;p++){const[a,g,s]=w[p];d.set(a,g,s)}this._states=d,this._maxCharCode=b}nextState(w,b){return b<0||b>=this._maxCharCode?0:this._states.get(w,b)}}e.StateMachine=P;let _=null;function y(){return _===null&&(_=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var E;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let I=null;function R(){if(I===null){I=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<T.length;b++)I.set(T.charCodeAt(b),1);const w=".,;:";for(let b=0;b<w.length;b++)I.set(w.charCodeAt(b),2)}return I}class k{static _createLink(w,b,v,d,p){let f=p-1;do{const a=b.charCodeAt(f);if(w.get(a)!==2)break;f--}while(f>d);if(d>0){const a=b.charCodeAt(d-1),g=b.charCodeAt(f);(a===40&&g===41||a===91&&g===93||a===123&&g===125)&&f--}return{range:{startLineNumber:v,startColumn:d+1,endLineNumber:v,endColumn:f+2},url:b.substring(d,f+1)}}static computeLinks(w,b=y()){const v=R(),d=[];for(let p=1,f=w.getLineCount();p<=f;p++){const a=w.getLineContent(p),g=a.length;let s=0,u=0,o=0,i=1,r=!1,n=!1,c=!1,h=!1;for(;s<g;){let m=!1;const C=a.charCodeAt(s);if(i===13){let L;switch(C){case 40:r=!0,L=0;break;case 41:L=r?0:1;break;case 91:c=!0,n=!0,L=0;break;case 93:c=!1,L=n?0:1;break;case 123:h=!0,L=0;break;case 125:L=h?0:1;break;case 39:L=o===39?1:0;break;case 34:L=o===34?1:0;break;case 96:L=o===96?1:0;break;case 42:L=o===42?1:0;break;case 124:L=o===124?1:0;break;case 32:L=c?0:1;break;default:L=v.get(C)}L===1&&(d.push(k._createLink(v,a,p,u,s)),m=!0)}else if(i===12){let L;C===91?(n=!0,L=0):L=v.get(C),L===1?m=!0:i=13}else i=b.nextState(i,C),i===0&&(m=!0);m&&(i=1,r=!1,n=!1,h=!1,u=s+1,o=C),s++}i===13&&d.push(k._createLink(v,a,p,u,g))}return d}}e.LinkComputer=k;function S(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=S}),define(De[99],Ie([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var _;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class R{constructor(a,g){this._findMatchBrand=void 0,this.range=a,this.matches=g}}e.FindMatch=R;var k;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(f){return f&&typeof f.read=="function"}e.isITextSnapshot=S;var T;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class b{constructor(a,g,s,u,o,i){this.identifier=a,this.range=g,this.text=s,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=o,this._isTracked=i}}e.ValidAnnotatedEditOperation=b;class v{constructor(a,g,s){this.regex=a,this.wordSeparators=g,this.simpleSearch=s}}e.SearchData=v;class d{constructor(a,g,s){this.reverseEdits=a,this.changes=g,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=d;function p(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(De[150],Ie([1,0,17,96]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,I){E=(0,t.toUint32)(E);const R=this.values,k=this.prefixSum,S=I.length;return S===0?!1:(this.values=new Uint32Array(R.length+S),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E),E+S),this.values.set(I,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,I){return E=(0,t.toUint32)(E),I=(0,t.toUint32)(I),this.values[E]===I?!1:(this.values[E]=I,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,I){E=(0,t.toUint32)(E),I=(0,t.toUint32)(I);const R=this.values,k=this.prefixSum;if(E>=R.length)return!1;const S=R.length-E;return I>=S&&(I=S),I===0?!1:(this.values=new Uint32Array(R.length-I),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E+I),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,t.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),E>=this.values.length&&(E=this.values.length-1);for(let R=I;R<=E;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let I=0,R=this.values.length-1,k=0,S=0,T=0;for(;I<=R;)if(k=I+(R-I)/2|0,S=this.prefixSum[k],T=S-this.values[k],E<T)R=k-1;else if(E>=S)I=k+1;else break;return new _(k,E-T)}}e.PrefixSumComputer=D;class P{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const I=this._indexBySum[E],R=I>0?this._prefixSum[I-1]:0;return new _(I,E-R)}removeValues(E,I){this._values.splice(E,I),this._invalidate(E)}insertValues(E,I){this._values=(0,l.arrayInsert)(this._values,E,I),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,I=this._values.length;E<I;E++){const R=this._values[E],k=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=k+R;for(let S=0;S<R;S++)this._indexBySum[k+S]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,I){this._values[E]!==I&&(this._values[E]=I,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=P;class _{constructor(E,I){this.index=E,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=I}}e.PrefixSumIndexOfResult=_}),define(De[151],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[152],Ie([1,0,151]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,P=D*24,_=P*7,y=P*30,E=P*365;function I(k,S,T){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,l.localize)(0,null,I(new Date().getTime()+w*1e3,!1));if(w<30)return(0,l.localize)(1,null);let b;return w<t?(b=w,S?b===1?T?(0,l.localize)(2,null,b):(0,l.localize)(3,null,b):T?(0,l.localize)(4,null,b):(0,l.localize)(5,null,b):b===1?T?(0,l.localize)(6,null,b):(0,l.localize)(7,null,b):T?(0,l.localize)(8,null,b):(0,l.localize)(9,null,b)):w<D?(b=Math.floor(w/t),S?b===1?T?(0,l.localize)(10,null,b):(0,l.localize)(11,null,b):T?(0,l.localize)(12,null,b):(0,l.localize)(13,null,b):b===1?T?(0,l.localize)(14,null,b):(0,l.localize)(15,null,b):T?(0,l.localize)(16,null,b):(0,l.localize)(17,null,b)):w<P?(b=Math.floor(w/D),S?b===1?T?(0,l.localize)(18,null,b):(0,l.localize)(19,null,b):T?(0,l.localize)(20,null,b):(0,l.localize)(21,null,b):b===1?T?(0,l.localize)(22,null,b):(0,l.localize)(23,null,b):T?(0,l.localize)(24,null,b):(0,l.localize)(25,null,b)):w<_?(b=Math.floor(w/P),S?b===1?(0,l.localize)(26,null,b):(0,l.localize)(27,null,b):b===1?(0,l.localize)(28,null,b):(0,l.localize)(29,null,b)):w<y?(b=Math.floor(w/_),S?b===1?T?(0,l.localize)(30,null,b):(0,l.localize)(31,null,b):T?(0,l.localize)(32,null,b):(0,l.localize)(33,null,b):b===1?T?(0,l.localize)(34,null,b):(0,l.localize)(35,null,b):T?(0,l.localize)(36,null,b):(0,l.localize)(37,null,b)):w<E?(b=Math.floor(w/y),S?b===1?T?(0,l.localize)(38,null,b):(0,l.localize)(39,null,b):T?(0,l.localize)(40,null,b):(0,l.localize)(41,null,b):b===1?T?(0,l.localize)(42,null,b):(0,l.localize)(43,null,b):T?(0,l.localize)(44,null,b):(0,l.localize)(45,null,b)):(b=Math.floor(w/E),S?b===1?T?(0,l.localize)(46,null,b):(0,l.localize)(47,null,b):T?(0,l.localize)(48,null,b):(0,l.localize)(49,null,b):b===1?T?(0,l.localize)(50,null,b):(0,l.localize)(51,null,b):T?(0,l.localize)(52,null,b):(0,l.localize)(53,null,b))}e.fromNow=I;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[153],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,13,153]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,S){return S&&(k.stack||k.stacktrace)?D.localize(0,null,y(k),_(k.stack)||_(k.stacktrace)):y(k)}function _(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function E(k=null,S=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const T=l.coalesce(k),w=E(T[0],S);return T.length>1?D.localize(4,null,w,T.length):w}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,S);if(T.exception)return P(T.exception,S)}return k.stack?P(k,S):k.message?k.message:D.localize(5,null)}e.toErrorMessage=E;function I(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=I;function R(k,S){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=S,T}e.createErrorWithActions=R}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,154]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,P=!1,_=!1,y=!1,E=!1,I=!1,R=!1,k=!1,S=!1,T,w=t,b,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const p=typeof d?.versions?.electron=="string",f=p&&d?.type==="renderer";if(typeof navigator=="object"&&!f)v=navigator.userAgent,D=v.indexOf("Windows")>=0,P=v.indexOf("Macintosh")>=0,k=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=v.indexOf("Linux")>=0,I=!0,T=l.getConfiguredDefaultLocale(l.localize(0,null))||t,w=T;else if(typeof d=="object"){D=d.platform==="win32",P=d.platform==="darwin",_=d.platform==="linux",y=_&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,R=p,S=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=t,w=t;const c=d.env.VSCODE_NLS_CONFIG;if(c)try{const h=JSON.parse(c),m=h.availableLanguages["*"];T=h.locale,w=m||t,b=h._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var a;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function g(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let s=0;P?s=1:D?s=3:_&&(s=2),e.isWindows=D,e.isMacintosh=P,e.isLinux=_,e.isLinuxSnap=y,e.isNative=E,e.isElectron=R,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=S,e.platform=s,e.userAgent=v,e.language=w;var u;(function(c){function h(){return e.language}c.value=h;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=m;function C(){return e.language==="en"}c.isDefault=C})(u=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let C=0,L=c.length;C<L;C++){const U=c[C];if(U.id===m.data.vscodeScheduleAsyncWork){c.splice(C,1),U.callback();return}}});let h=0;return m=>{const C=++h;c.push({id:C,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return c=>setTimeout(c)})();var o;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||k?2:D?1:3;let i=!0,r=!1;function n(){if(!r){r=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,i=new Uint16Array(c.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[40],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const D=l.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,40]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,P=90,_=122,y=46,E=47,I=92,R=58,k=63;class S extends Error{constructor(a,g,s){let u;typeof g=="string"&&g.indexOf("not ")===0?(u="must not be",g=g.replace(/^not /,"")):u="must be";const o=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${o} ${u} of type ${g}`;i+=`. Received type ${typeof s}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function T(f,a){if(typeof f!="string")throw new S(a,"string",f)}function w(f){return f===E||f===I}function b(f){return f===E}function v(f){return f>=t&&f<=P||f>=D&&f<=_}function d(f,a,g,s){let u="",o=0,i=-1,r=0,n=0;for(let c=0;c<=f.length;++c){if(c<f.length)n=f.charCodeAt(c);else{if(s(n))break;n=E}if(s(n)){if(!(i===c-1||r===1))if(r===2){if(u.length<2||o!==2||u.charCodeAt(u.length-1)!==y||u.charCodeAt(u.length-2)!==y){if(u.length>2){const h=u.lastIndexOf(g);h===-1?(u="",o=0):(u=u.slice(0,h),o=u.length-1-u.lastIndexOf(g)),i=c,r=0;continue}else if(u.length!==0){u="",o=0,i=c,r=0;continue}}a&&(u+=u.length>0?`${g}..`:"..",o=2)}else u.length>0?u+=`${g}${f.slice(i+1,c)}`:u=f.slice(i+1,c),o=c-i-1;i=c,r=0}else n===y&&r!==-1?++r:r=-1}return u}function p(f,a){if(a===null||typeof a!="object")throw new S("pathObject","Object",a);const g=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return g?g===a.root?`${g}${s}`:`${g}${f}${s}`:s}e.win32={resolve(...f){let a="",g="",s=!1;for(let u=f.length-1;u>=-1;u--){let o;if(u>=0){if(o=f[u],T(o,"path"),o.length===0)continue}else a.length===0?o=l.cwd():(o=l.env[`=${a}`]||l.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===I)&&(o=`${a}\\`));const i=o.length;let r=0,n="",c=!1;const h=o.charCodeAt(0);if(i===1)w(h)&&(r=1,c=!0);else if(w(h))if(c=!0,w(o.charCodeAt(1))){let m=2,C=m;for(;m<i&&!w(o.charCodeAt(m));)m++;if(m<i&&m!==C){const L=o.slice(C,m);for(C=m;m<i&&w(o.charCodeAt(m));)m++;if(m<i&&m!==C){for(C=m;m<i&&!w(o.charCodeAt(m));)m++;(m===i||m!==C)&&(n=`\\\\${L}\\${o.slice(C,m)}`,r=m)}}}else r=1;else v(h)&&o.charCodeAt(1)===R&&(n=o.slice(0,2),r=2,i>2&&w(o.charCodeAt(2))&&(c=!0,r=3));if(n.length>0)if(a.length>0){if(n.toLowerCase()!==a.toLowerCase())continue}else a=n;if(s){if(a.length>0)break}else if(g=`${o.slice(r)}\\${g}`,s=c,c&&a.length>0)break}return g=d(g,!s,"\\",w),s?`${a}\\${g}`:`${a}${g}`||"."},normalize(f){T(f,"path");const a=f.length;if(a===0)return".";let g=0,s,u=!1;const o=f.charCodeAt(0);if(a===1)return b(o)?"\\":f;if(w(o))if(u=!0,w(f.charCodeAt(1))){let r=2,n=r;for(;r<a&&!w(f.charCodeAt(r));)r++;if(r<a&&r!==n){const c=f.slice(n,r);for(n=r;r<a&&w(f.charCodeAt(r));)r++;if(r<a&&r!==n){for(n=r;r<a&&!w(f.charCodeAt(r));)r++;if(r===a)return`\\\\${c}\\${f.slice(n)}\\`;r!==n&&(s=`\\\\${c}\\${f.slice(n,r)}`,g=r)}}}else g=1;else v(o)&&f.charCodeAt(1)===R&&(s=f.slice(0,2),g=2,a>2&&w(f.charCodeAt(2))&&(u=!0,g=3));let i=g<a?d(f.slice(g),!u,"\\",w):"";return i.length===0&&!u&&(i="."),i.length>0&&w(f.charCodeAt(a-1))&&(i+="\\"),s===void 0?u?`\\${i}`:i:u?`${s}\\${i}`:`${s}${i}`},isAbsolute(f){T(f,"path");const a=f.length;if(a===0)return!1;const g=f.charCodeAt(0);return w(g)||a>2&&v(g)&&f.charCodeAt(1)===R&&w(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,g;for(let o=0;o<f.length;++o){const i=f[o];T(i,"path"),i.length>0&&(a===void 0?a=g=i:a+=`\\${i}`)}if(a===void 0)return".";let s=!0,u=0;if(typeof g=="string"&&w(g.charCodeAt(0))){++u;const o=g.length;o>1&&w(g.charCodeAt(1))&&(++u,o>2&&(w(g.charCodeAt(2))?++u:s=!1))}if(s){for(;u<a.length&&w(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return e.win32.normalize(a)},relative(f,a){if(T(f,"from"),T(a,"to"),f===a)return"";const g=e.win32.resolve(f),s=e.win32.resolve(a);if(g===s||(f=g.toLowerCase(),a=s.toLowerCase(),f===a))return"";let u=0;for(;u<f.length&&f.charCodeAt(u)===I;)u++;let o=f.length;for(;o-1>u&&f.charCodeAt(o-1)===I;)o--;const i=o-u;let r=0;for(;r<a.length&&a.charCodeAt(r)===I;)r++;let n=a.length;for(;n-1>r&&a.charCodeAt(n-1)===I;)n--;const c=n-r,h=i<c?i:c;let m=-1,C=0;for(;C<h;C++){const U=f.charCodeAt(u+C);if(U!==a.charCodeAt(r+C))break;U===I&&(m=C)}if(C!==h){if(m===-1)return s}else{if(c>h){if(a.charCodeAt(r+C)===I)return s.slice(r+C+1);if(C===2)return s.slice(r+C)}i>h&&(f.charCodeAt(u+C)===I?m=C:C===2&&(m=3)),m===-1&&(m=0)}let L="";for(C=u+m+1;C<=o;++C)(C===o||f.charCodeAt(C)===I)&&(L+=L.length===0?"..":"\\..");return r+=m,L.length>0?`${L}${s.slice(r,n)}`:(s.charCodeAt(r)===I&&++r,s.slice(r,n))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===I){if(a.charCodeAt(1)===I){const g=a.charCodeAt(2);if(g!==k&&g!==y)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(v(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===I)return`\\\\?\\${a}`;return f},dirname(f){T(f,"path");const a=f.length;if(a===0)return".";let g=-1,s=0;const u=f.charCodeAt(0);if(a===1)return w(u)?f:".";if(w(u)){if(g=s=1,w(f.charCodeAt(1))){let r=2,n=r;for(;r<a&&!w(f.charCodeAt(r));)r++;if(r<a&&r!==n){for(n=r;r<a&&w(f.charCodeAt(r));)r++;if(r<a&&r!==n){for(n=r;r<a&&!w(f.charCodeAt(r));)r++;if(r===a)return f;r!==n&&(g=s=r+1)}}}}else v(u)&&f.charCodeAt(1)===R&&(g=a>2&&w(f.charCodeAt(2))?3:2,s=g);let o=-1,i=!0;for(let r=a-1;r>=s;--r)if(w(f.charCodeAt(r))){if(!i){o=r;break}}else i=!1;if(o===-1){if(g===-1)return".";o=g}return f.slice(0,o)},basename(f,a){a!==void 0&&T(a,"ext"),T(f,"path");let g=0,s=-1,u=!0,o;if(f.length>=2&&v(f.charCodeAt(0))&&f.charCodeAt(1)===R&&(g=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let i=a.length-1,r=-1;for(o=f.length-1;o>=g;--o){const n=f.charCodeAt(o);if(w(n)){if(!u){g=o+1;break}}else r===-1&&(u=!1,r=o+1),i>=0&&(n===a.charCodeAt(i)?--i===-1&&(s=o):(i=-1,s=r))}return g===s?s=r:s===-1&&(s=f.length),f.slice(g,s)}for(o=f.length-1;o>=g;--o)if(w(f.charCodeAt(o))){if(!u){g=o+1;break}}else s===-1&&(u=!1,s=o+1);return s===-1?"":f.slice(g,s)},extname(f){T(f,"path");let a=0,g=-1,s=0,u=-1,o=!0,i=0;f.length>=2&&f.charCodeAt(1)===R&&v(f.charCodeAt(0))&&(a=s=2);for(let r=f.length-1;r>=a;--r){const n=f.charCodeAt(r);if(w(n)){if(!o){s=r+1;break}continue}u===-1&&(o=!1,u=r+1),n===y?g===-1?g=r:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||u===-1||i===0||i===1&&g===u-1&&g===s+1?"":f.slice(g,u)},format:p.bind(null,"\\"),parse(f){T(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const g=f.length;let s=0,u=f.charCodeAt(0);if(g===1)return w(u)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(w(u)){if(s=1,w(f.charCodeAt(1))){let m=2,C=m;for(;m<g&&!w(f.charCodeAt(m));)m++;if(m<g&&m!==C){for(C=m;m<g&&w(f.charCodeAt(m));)m++;if(m<g&&m!==C){for(C=m;m<g&&!w(f.charCodeAt(m));)m++;m===g?s=m:m!==C&&(s=m+1)}}}}else if(v(u)&&f.charCodeAt(1)===R){if(g<=2)return a.root=a.dir=f,a;if(s=2,w(f.charCodeAt(2))){if(g===3)return a.root=a.dir=f,a;s=3}}s>0&&(a.root=f.slice(0,s));let o=-1,i=s,r=-1,n=!0,c=f.length-1,h=0;for(;c>=s;--c){if(u=f.charCodeAt(c),w(u)){if(!n){i=c+1;break}continue}r===-1&&(n=!1,r=c+1),u===y?o===-1?o=c:h!==1&&(h=1):o!==-1&&(h=-1)}return r!==-1&&(o===-1||h===0||h===1&&o===r-1&&o===i+1?a.base=a.name=f.slice(i,r):(a.name=f.slice(i,o),a.base=f.slice(i,r),a.ext=f.slice(o,r))),i>0&&i!==s?a.dir=f.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",g=!1;for(let s=f.length-1;s>=-1&&!g;s--){const u=s>=0?f[s]:l.cwd();T(u,"path"),u.length!==0&&(a=`${u}/${a}`,g=u.charCodeAt(0)===E)}return a=d(a,!g,"/",b),g?`/${a}`:a.length>0?a:"."},normalize(f){if(T(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===E,g=f.charCodeAt(f.length-1)===E;return f=d(f,!a,"/",b),f.length===0?a?"/":g?"./":".":(g&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return T(f,"path"),f.length>0&&f.charCodeAt(0)===E},join(...f){if(f.length===0)return".";let a;for(let g=0;g<f.length;++g){const s=f[g];T(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(T(f,"from"),T(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const g=1,s=f.length,u=s-g,o=1,i=a.length-o,r=u<i?u:i;let n=-1,c=0;for(;c<r;c++){const m=f.charCodeAt(g+c);if(m!==a.charCodeAt(o+c))break;m===E&&(n=c)}if(c===r)if(i>r){if(a.charCodeAt(o+c)===E)return a.slice(o+c+1);if(c===0)return a.slice(o+c)}else u>r&&(f.charCodeAt(g+c)===E?n=c:c===0&&(n=0));let h="";for(c=g+n+1;c<=s;++c)(c===s||f.charCodeAt(c)===E)&&(h+=h.length===0?"..":"/..");return`${h}${a.slice(o+n)}`},toNamespacedPath(f){return f},dirname(f){if(T(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===E;let g=-1,s=!0;for(let u=f.length-1;u>=1;--u)if(f.charCodeAt(u)===E){if(!s){g=u;break}}else s=!1;return g===-1?a?"/":".":a&&g===1?"//":f.slice(0,g)},basename(f,a){a!==void 0&&T(a,"ext"),T(f,"path");let g=0,s=-1,u=!0,o;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let i=a.length-1,r=-1;for(o=f.length-1;o>=0;--o){const n=f.charCodeAt(o);if(n===E){if(!u){g=o+1;break}}else r===-1&&(u=!1,r=o+1),i>=0&&(n===a.charCodeAt(i)?--i===-1&&(s=o):(i=-1,s=r))}return g===s?s=r:s===-1&&(s=f.length),f.slice(g,s)}for(o=f.length-1;o>=0;--o)if(f.charCodeAt(o)===E){if(!u){g=o+1;break}}else s===-1&&(u=!1,s=o+1);return s===-1?"":f.slice(g,s)},extname(f){T(f,"path");let a=-1,g=0,s=-1,u=!0,o=0;for(let i=f.length-1;i>=0;--i){const r=f.charCodeAt(i);if(r===E){if(!u){g=i+1;break}continue}s===-1&&(u=!1,s=i+1),r===y?a===-1?a=i:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||s===-1||o===0||o===1&&a===s-1&&a===g+1?"":f.slice(a,s)},format:p.bind(null,"/"),parse(f){T(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const g=f.charCodeAt(0)===E;let s;g?(a.root="/",s=1):s=0;let u=-1,o=0,i=-1,r=!0,n=f.length-1,c=0;for(;n>=s;--n){const h=f.charCodeAt(n);if(h===E){if(!r){o=n+1;break}continue}i===-1&&(r=!1,i=n+1),h===y?u===-1?u=n:c!==1&&(c=1):u!==-1&&(c=-1)}if(i!==-1){const h=o===0&&g?1:o;u===-1||c===0||c===1&&u===i-1&&u===o+1?a.base=a.name=f.slice(h,i):(a.name=f.slice(h,u),a.base=f.slice(h,i),a.ext=f.slice(u,i))}return o>0?a.dir=f.slice(0,o-1):g&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[100],Ie([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const k=(0,l.extname)(R),S=t[k.toLowerCase()];return S!==void 0?S:_(R)}e.getMediaOrTextMime=P;function _(R){const k=(0,l.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=_;function y(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=y;const E=/^(.+)\/(.+?)(;.+)?$/;function I(R,k){const S=E.exec(R);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:R}e.normalizeMimeType=I}),define(De[101],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(y,...E){const I=E.reduce((S,T)=>(S[T]=!0,S),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(S=>!I[S]).forEach(S=>{for(let T=0;T<R.length;T++)if(S.search(R[T])!==-1){delete y[S];break}})}e.sanitizeProcessEnvironment=P;function _(y){!y||(delete y.DEBUG,l.isMacintosh&&delete y.DYLD_LIBRARY_PATH,l.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(De[51],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class D{constructor(_){this._highResolution=t&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new D(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=D}),define(De[4],Ie([1,0,10,59,6,79,51]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,E=!1;var I;(function(n){n.None=()=>D.Disposable.None;function c(pe){if(E){const{onListenerDidAdd:be}=pe,ke=w.create();let Le=0;pe.onListenerDidAdd=()=>{++Le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function h(pe){return(be,ke=null,Le)=>{let We=!1,oe;return oe=pe(ue=>{if(!We)return oe?oe.dispose():We=!0,be.call(ke,ue)},null,Le),We&&oe.dispose(),oe}}n.once=h;function m(pe,be,ke){return M((Le,We=null,oe)=>pe(ue=>Le.call(We,be(ue)),null,oe),ke)}n.map=m;function C(pe,be,ke){return M((Le,We=null,oe)=>pe(ue=>{be(ue),Le.call(We,ue)},null,oe),ke)}n.forEach=C;function L(pe,be,ke){return M((Le,We=null,oe)=>pe(ue=>be(ue)&&Le.call(We,ue),null,oe),ke)}n.filter=L;function U(pe){return pe}n.signal=U;function B(...pe){return(be,ke=null,Le)=>(0,D.combinedDisposable)(...pe.map(We=>We(oe=>be.call(ke,oe),null,Le)))}n.any=B;function A(pe,be,ke,Le){let We=ke;return m(pe,oe=>(We=be(We,oe),We),Le)}n.reduce=A;function M(pe,be){let ke;const Le={onFirstListenerAdd(){ke=pe(We.fire,We)},onLastListenerRemove(){ke?.dispose()}};be||c(Le);const We=new v(Le);return be?.add(We),We.event}function $(pe,be,ke=100,Le=!1,We,oe){let ue,fe,Z,ae=0;const ee={leakWarningThreshold:We,onFirstListenerAdd(){ue=pe(F=>{ae++,fe=be(fe,F),Le&&!Z&&(ie.fire(fe),fe=void 0),clearTimeout(Z),Z=setTimeout(()=>{const H=fe;fe=void 0,Z=void 0,(!Le||ae>1)&&ie.fire(H),ae=0},ke)})},onLastListenerRemove(){ue.dispose()}};oe||c(ee);const ie=new v(ee);return oe?.add(ie),ie.event}n.debounce=$;function N(pe,be=(Le,We)=>Le===We,ke){let Le=!0,We;return L(pe,oe=>{const ue=Le||!be(oe,We);return Le=!1,We=oe,ue},ke)}n.latch=N;function K(pe,be,ke){return[n.filter(pe,be,ke),n.filter(pe,Le=>!be(Le),ke)]}n.split=K;function z(pe,be=!1,ke=[]){let Le=ke.slice(),We=pe(fe=>{Le?Le.push(fe):ue.fire(fe)});const oe=()=>{Le?.forEach(fe=>ue.fire(fe)),Le=null},ue=new v({onFirstListenerAdd(){We||(We=pe(fe=>ue.fire(fe)))},onFirstListenerDidAdd(){Le&&(be?setTimeout(oe):oe())},onLastListenerRemove(){We&&We.dispose(),We=null}});return ue.event}n.buffer=z;class O{constructor(be){this.event=be,this.disposables=new D.DisposableStore}map(be){return new O(m(this.event,be,this.disposables))}forEach(be){return new O(C(this.event,be,this.disposables))}filter(be){return new O(L(this.event,be,this.disposables))}reduce(be,ke){return new O(A(this.event,be,ke,this.disposables))}latch(){return new O(N(this.event,void 0,this.disposables))}debounce(be,ke=100,Le=!1,We){return new O($(this.event,be,ke,Le,We,this.disposables))}on(be,ke,Le){return this.event(be,ke,Le)}once(be,ke,Le){return h(this.event)(be,ke,Le)}dispose(){this.disposables.dispose()}}function x(pe){return new O(pe)}n.chain=x;function V(pe,be,ke=Le=>Le){const Le=(...fe)=>ue.fire(ke(...fe)),We=()=>pe.on(be,Le),oe=()=>pe.removeListener(be,Le),ue=new v({onFirstListenerAdd:We,onLastListenerRemove:oe});return ue.event}n.fromNodeEventEmitter=V;function q(pe,be,ke=Le=>Le){const Le=(...fe)=>ue.fire(ke(...fe)),We=()=>pe.addEventListener(be,Le),oe=()=>pe.removeEventListener(be,Le),ue=new v({onFirstListenerAdd:We,onLastListenerRemove:oe});return ue.event}n.fromDOMEventEmitter=q;function Y(pe){return new Promise(be=>h(pe)(be))}n.toPromise=Y;function Q(pe,be){return be(void 0),pe(ke=>be(ke))}n.runAndSubscribe=Q;function he(pe,be){let ke=null;function Le(oe){ke?.dispose(),ke=new D.DisposableStore,be(oe,ke)}Le(void 0);const We=pe(oe=>Le(oe));return(0,D.toDisposable)(()=>{We.dispose(),ke?.dispose()})}n.runAndSubscribeWithStore=he;class ve{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Le={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||c(Le),this.emitter=new v(Le),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ne(pe,be){return new ve(pe,be).emitter.event}n.fromObservable=ne})(I=e.Event||(e.Event={}));class R{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${R._idPool++}`}start(c){this._stopWatch=new _.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let k=-1;function S(n){const c=k;return k=n,{dispose(){k=c}}}e.setGlobalLeakWarningThreshold=S;class T{constructor(c,h=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,h){let m=k;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),m<=0||h<m)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let L,U=0;for(const[B,A]of this._stacks)(!L||U<A)&&(L=B,U=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${U}):`),console.warn(L)}return()=>{const L=this._stacks.get(c.value)||0;this._stacks.set(c.value,L-1)}}}class w{constructor(c){this.value=c}static create(){return new w(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,h,m){this.callback=c,this.callbackThis=h,this.stack=m,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class v{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const h of c)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,h,m)=>{this._listeners||(this._listeners=new P.LinkedList);const C=this._listeners.isEmpty();C&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,U;this._leakageMon&&this._listeners.size>=30&&(U=w.create(),L=this._leakageMon.check(U,this._listeners.size+1)),y&&(U=U??w.create());const B=new b(c,h,U),A=this._listeners.push(B);C&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,h);const M=B.subscription.set(()=>{L?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return m instanceof D.DisposableStore?m.add(M):Array.isArray(m)&&m.push(M),M}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const h of this._listeners)this._deliveryQueue.push(this,h,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class d{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(c,h,m){this._queue.push(new f(c,h,m))}clear(c){const h=new P.LinkedList;for(const m of this._queue)m.emitter!==c&&h.push(m);this._queue=h}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(h){(0,l.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=d;class p extends d{clear(c){this._queue.clear()}}class f{constructor(c,h,m){this.emitter=c,this.listener=h,this.event=m}}class a extends v{async fireAsync(c,h,m){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,c]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[C,L]=this._asyncDeliveryQueue.shift(),U=[],B={...L,token:h,waitUntil:A=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");m&&(A=m(A,C.callback)),U.push(A)}};try{C.invoke(B)}catch(A){(0,l.onUnexpectedError)(A);continue}Object.freeze(U),await Promise.allSettled(U).then(A=>{for(const M of A)M.status==="rejected"&&(0,l.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=a;class g extends v{constructor(c){super(c),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=g;class s extends g{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=s;class u extends v{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){!this.hasListeners()||(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const h={event:c,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const m=()=>{this.hasListeners&&this.unhook(h);const C=this.events.indexOf(h);this.events.splice(C,1)};return(0,D.toDisposable)((0,t.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(h=>this.emitter.fire(h))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class i{constructor(){this.buffers=[]}wrapEvent(c){return(h,m,C)=>c(L=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>h.call(m,L)):h.call(m,L)},void 0,C)}bufferEvents(c){const h=[];this.buffers.push(h);const m=c();return this.buffers.pop(),h.forEach(C=>C()),m}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(De[21],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,E){const I=setTimeout(y.bind(E),0);return{dispose(){clearTimeout(I)}}});var D;(function(y){function E(I){return I===y.None||I===y.Cancelled||I instanceof P?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}y.isCancellationToken=E,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=_}),define(De[155],Ie([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new l.CancellationTokenSource,E=this.task(y.token);return this.result={promise:E,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class D{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const E=JSON.stringify(y);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=D;class P{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const E=this.fn(y);return this._map.set(y,E),E}}e.CachedFunction=P}),define(De[8],Ie([1,0,155,78]),function(J,e,l,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(de){return!de||typeof de!="string"?!0:de.trim().length===0}e.isFalsyOrWhitespace=P;const _=/{(\d+)}/g;function y(de,...Te){return Te.length===0?de:de.replace(_,function(Ne,Be){const ze=parseInt(Be,10);return isNaN(ze)||ze<0||ze>=Te.length?Ne:Te[ze]})}e.format=y;const E=/{([^}]+)}/g;function I(de,Te){return de.replace(E,(Ne,Be)=>Te[Be]??Ne)}e.format2=I;function R(de){return de.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.escape=R;function k(de){return de.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S(de,Te){let Ne=0;const Be=Te.charCodeAt(0);for(let ze=de.length-1;ze>=0;ze--)de.charCodeAt(ze)===Be&&Ne++;return Ne}e.count=S;function T(de,Te,Ne="\u2026"){return de.length<=Te?de:`${de.substr(0,Te)}${Ne}`}e.truncate=T;function w(de,Te=" "){const Ne=b(de,Te);return v(Ne,Te)}e.trim=w;function b(de,Te){if(!de||!Te)return de;const Ne=Te.length;if(Ne===0||de.length===0)return de;let Be=0;for(;de.indexOf(Te,Be)===Be;)Be=Be+Ne;return de.substring(Be)}e.ltrim=b;function v(de,Te){if(!de||!Te)return de;const Ne=Te.length,Be=de.length;if(Ne===0||Be===0)return de;let ze=Be,Xe=-1;for(;Xe=de.lastIndexOf(Te,ze-1),!(Xe===-1||Xe+Ne!==ze);){if(Xe===0)return"";ze=Xe}return de.substring(0,ze)}e.rtrim=v;function d(de){return de.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function p(de){return de.replace(/\*/g,"")}e.stripWildcards=p;function f(de,Te,Ne={}){if(!de)throw new Error("Cannot create regex from empty string");Te||(de=k(de)),Ne.wholeWord&&(/\B/.test(de.charAt(0))||(de="\\b"+de),/\B/.test(de.charAt(de.length-1))||(de=de+"\\b"));let Be="";return Ne.global&&(Be+="g"),Ne.matchCase||(Be+="i"),Ne.multiline&&(Be+="m"),Ne.unicode&&(Be+="u"),new RegExp(de,Be)}e.createRegExp=f;function a(de){return de.source==="^"||de.source==="^$"||de.source==="$"||de.source==="^\\s*$"?!1:!!(de.exec("")&&de.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function g(de){return!!de.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function s(de){return(de.global?"g":"")+(de.ignoreCase?"i":"")+(de.multiline?"m":"")+(de.unicode?"u":"")}e.regExpFlags=s;function u(de){return de.split(/\r\n|\r|\n/)}e.splitLines=u;function o(de){for(let Te=0,Ne=de.length;Te<Ne;Te++){const Be=de.charCodeAt(Te);if(Be!==32&&Be!==9)return Te}return-1}e.firstNonWhitespaceIndex=o;function i(de,Te=0,Ne=de.length){for(let Be=Te;Be<Ne;Be++){const ze=de.charCodeAt(Be);if(ze!==32&&ze!==9)return de.substring(Te,Be)}return de.substring(Te,Ne)}e.getLeadingWhitespace=i;function r(de,Te=de.length-1){for(let Ne=Te;Ne>=0;Ne--){const Be=de.charCodeAt(Ne);if(Be!==32&&Be!==9)return Ne}return-1}e.lastNonWhitespaceIndex=r;function n(de,Te,Ne){const Be=[];let ze=0;for(const Xe of de.matchAll(Te)){if(Be.push(de.slice(ze,Xe.index)),Xe.index===void 0)throw new Error("match.index should be defined");ze=Xe.index+Xe[0].length,Be.push(Ne(Xe[0],...Xe.slice(1),Xe.index,de,Xe.groups))}return Be.push(de.slice(ze)),Promise.all(Be).then(Xe=>Xe.join(""))}e.replaceAsync=n;function c(de,Te){return de<Te?-1:de>Te?1:0}e.compare=c;function h(de,Te,Ne=0,Be=de.length,ze=0,Xe=Te.length){for(;Ne<Be&&ze<Xe;Ne++,ze++){const st=de.charCodeAt(Ne),et=Te.charCodeAt(ze);if(st<et)return-1;if(st>et)return 1}const nt=Be-Ne,ct=Xe-ze;return nt<ct?-1:nt>ct?1:0}e.compareSubstring=h;function m(de,Te){return C(de,Te,0,de.length,0,Te.length)}e.compareIgnoreCase=m;function C(de,Te,Ne=0,Be=de.length,ze=0,Xe=Te.length){for(;Ne<Be&&ze<Xe;Ne++,ze++){let st=de.charCodeAt(Ne),et=Te.charCodeAt(ze);if(st===et)continue;if(st>=128||et>=128)return h(de.toLowerCase(),Te.toLowerCase(),Ne,Be,ze,Xe);U(st)&&(st-=32),U(et)&&(et-=32);const gt=st-et;if(gt!==0)return gt}const nt=Be-Ne,ct=Xe-ze;return nt<ct?-1:nt>ct?1:0}e.compareSubstringIgnoreCase=C;function L(de){return de>=48&&de<=57}e.isAsciiDigit=L;function U(de){return de>=97&&de<=122}e.isLowerAsciiLetter=U;function B(de){return de>=65&&de<=90}e.isUpperAsciiLetter=B;function A(de,Te){return de.length===Te.length&&C(de,Te)===0}e.equalsIgnoreCase=A;function M(de,Te){const Ne=Te.length;return Te.length>de.length?!1:C(de,Te,0,Ne)===0}e.startsWithIgnoreCase=M;function $(de,Te){const Ne=Math.min(de.length,Te.length);let Be;for(Be=0;Be<Ne;Be++)if(de.charCodeAt(Be)!==Te.charCodeAt(Be))return Be;return Ne}e.commonPrefixLength=$;function N(de,Te){const Ne=Math.min(de.length,Te.length);let Be;const ze=de.length-1,Xe=Te.length-1;for(Be=0;Be<Ne;Be++)if(de.charCodeAt(ze-Be)!==Te.charCodeAt(Xe-Be))return Be;return Ne}e.commonSuffixLength=N;function K(de){return 55296<=de&&de<=56319}e.isHighSurrogate=K;function z(de){return 56320<=de&&de<=57343}e.isLowSurrogate=z;function O(de,Te){return(de-55296<<10)+(Te-56320)+65536}e.computeCodePoint=O;function x(de,Te,Ne){const Be=de.charCodeAt(Ne);if(K(Be)&&Ne+1<Te){const ze=de.charCodeAt(Ne+1);if(z(ze))return O(Be,ze)}return Be}e.getNextCodePoint=x;function V(de,Te){const Ne=de.charCodeAt(Te-1);if(z(Ne)&&Te>1){const Be=de.charCodeAt(Te-2);if(K(Be))return O(Be,Ne)}return Ne}class q{constructor(Te,Ne=0){this._str=Te,this._len=Te.length,this._offset=Ne}get offset(){return this._offset}setOffset(Te){this._offset=Te}prevCodePoint(){const Te=V(this._str,this._offset);return this._offset-=Te>=65536?2:1,Te}nextCodePoint(){const Te=x(this._str,this._len,this._offset);return this._offset+=Te>=65536?2:1,Te}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class Y{constructor(Te,Ne=0){this._iterator=new q(Te,Ne)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Te=je.getInstance(),Ne=this._iterator,Be=Ne.offset;let ze=Te.getGraphemeBreakType(Ne.nextCodePoint());for(;!Ne.eol();){const Xe=Ne.offset,nt=Te.getGraphemeBreakType(Ne.nextCodePoint());if(ye(ze,nt)){Ne.setOffset(Xe);break}ze=nt}return Ne.offset-Be}prevGraphemeLength(){const Te=je.getInstance(),Ne=this._iterator,Be=Ne.offset;let ze=Te.getGraphemeBreakType(Ne.prevCodePoint());for(;Ne.offset>0;){const Xe=Ne.offset,nt=Te.getGraphemeBreakType(Ne.prevCodePoint());if(ye(nt,ze)){Ne.setOffset(Xe);break}ze=nt}return Be-Ne.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function Q(de,Te){return new Y(de,Te).nextGraphemeLength()}e.nextCharLength=Q;function he(de,Te){return new Y(de,Te).prevGraphemeLength()}e.prevCharLength=he;function ve(de,Te){Te>0&&z(de.charCodeAt(Te))&&Te--;const Ne=Te+Q(de,Te);return[Ne-he(de,Ne),Ne]}e.getCharContainingOffset=ve;let ne;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(de){return ne||(ne=pe()),ne.test(de)}e.containsRTL=be;const ke=/^[\t\n\r\x20-\x7E]*$/;function Le(de){return ke.test(de)}e.isBasicASCII=Le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(de){return e.UNUSUAL_LINE_TERMINATORS.test(de)}e.containsUnusualLineTerminators=We;function oe(de){return de>=11904&&de<=55215||de>=63744&&de<=64255||de>=65281&&de<=65374}e.isFullWidthCharacter=oe;function ue(de){return de>=127462&&de<=127487||de===8986||de===8987||de===9200||de===9203||de>=9728&&de<=10175||de===11088||de===11093||de>=127744&&de<=128591||de>=128640&&de<=128764||de>=128992&&de<=129008||de>=129280&&de<=129535||de>=129648&&de<=129782}e.isEmojiImprecise=ue;function fe(de,Te){if(de.length<Te)return de;const Ne=/\b/g;let Be=0;for(;Ne.test(de)&&!(de.length-Ne.lastIndex<Te);)Be=Ne.lastIndex,Ne.lastIndex+=1;return de.substring(Be).replace(/^\s/,"")}e.lcut=fe;const Z=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ie(de){return de&&(de=de.replace(Z,""),de=de.replace(ae,""),de=de.replace(ee,"")),de}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(de){return!!(de&&de.length>0&&de.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function H(de){return F(de)?de.substr(1):de}e.stripUTF8BOM=H;function G(de,Te){if(!de||!Te||de.length<Te.length)return!1;const Ne=Te.length,Be=de.toLowerCase();let ze=0,Xe=-1;for(;ze<Ne;){const nt=Be.indexOf(Te[ze],Xe+1);if(nt<0)return!1;Xe=nt,ze++}return!0}e.fuzzyContains=G;function X(de,Te=!1){return de?(Te&&(de=de.replace(/\\./g,"")),de.toLowerCase()!==de):!1}e.containsUppercaseCharacter=X;function me(de){return de.charAt(0).toUpperCase()+de.slice(1)}e.uppercaseFirstLetter=me;function we(de,Te=1){if(Te===0)return"";let Ne=-1;do Ne=de.indexOf(`
`,Ne+1),Te--;while(Te>0&&Ne>=0);return Ne===-1?de:(de[Ne-1]==="\r"&&Ne--,de.substr(0,Ne))}e.getNLines=we;function le(de){return de=de%(2*26),de<26?String.fromCharCode(97+de):String.fromCharCode(65+de-26)}e.singleLetterHash=le;function Ce(de){return je.getInstance().getGraphemeBreakType(de)}e.getGraphemeBreakType=Ce;function ye(de,Te){return de===0?Te!==5&&Te!==7:de===2&&Te===3?!1:de===4||de===2||de===3||Te===4||Te===2||Te===3?!0:!(de===8&&(Te===8||Te===9||Te===11||Te===12)||(de===11||de===9)&&(Te===9||Te===10)||(de===12||de===10)&&Te===10||Te===5||Te===13||Te===7||de===1||de===13&&Te===14||de===6&&Te===6)}var $e;(function(de){de[de.Other=0]="Other",de[de.Prepend=1]="Prepend",de[de.CR=2]="CR",de[de.LF=3]="LF",de[de.Control=4]="Control",de[de.Extend=5]="Extend",de[de.Regional_Indicator=6]="Regional_Indicator",de[de.SpacingMark=7]="SpacingMark",de[de.L=8]="L",de[de.V=9]="V",de[de.T=10]="T",de[de.LV=11]="LV",de[de.LVT=12]="LVT",de[de.ZWJ=13]="ZWJ",de[de.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class je{constructor(){this._data=Ze()}static getInstance(){return je._INSTANCE||(je._INSTANCE=new je),je._INSTANCE}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const Ne=this._data,Be=Ne.length/3;let ze=1;for(;ze<=Be;)if(Te<Ne[3*ze])ze=2*ze;else if(Te>Ne[3*ze+1])ze=2*ze+1;else return Ne[3*ze+2];return 0}}je._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(de,Te){if(de===0)return 0;const Ne=Oe(de,Te);if(Ne!==void 0)return Ne;const Be=new q(Te,de);return Be.prevCodePoint(),Be.offset}e.getLeftDeleteOffset=Ye;function Oe(de,Te){const Ne=new q(Te,de);let Be=Ne.prevCodePoint();for(;ot(Be)||Be===65039||Be===8419;){if(Ne.offset===0)return;Be=Ne.prevCodePoint()}if(!ue(Be))return;let ze=Ne.offset;return ze>0&&Ne.prevCodePoint()===8205&&(ze=Ne.offset),ze}function ot(de){return 127995<=de&&de<=127999}var re;(function(de){de[de.zwj=8205]="zwj",de[de.emojiVariantSelector=65039]="emojiVariantSelector",de[de.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class se{constructor(Te){this.confusableDictionary=Te}static getInstance(Te){return se.cache.get(Array.from(Te))}static getLocales(){return se._locales.getValue()}isAmbiguous(Te){return this.confusableDictionary.has(Te)}getPrimaryConfusable(Te){return this.confusableDictionary.get(Te)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,D=se,se.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new l.LRUCachedFunction(de=>{function Te(et){const gt=new Map;for(let wt=0;wt<et.length;wt+=2)gt.set(et[wt],et[wt+1]);return gt}function Ne(et,gt){const wt=new Map(et);for(const[Dt,ft]of gt)wt.set(Dt,ft);return wt}function Be(et,gt){if(!et)return gt;const wt=new Map;for(const[Dt,ft]of et)gt.has(Dt)&&wt.set(Dt,ft);return wt}const ze=D.ambiguousCharacterData.getValue();let Xe=de.filter(et=>!et.startsWith("_")&&et in ze);Xe.length===0&&(Xe=["_default"]);let nt;for(const et of Xe){const gt=Te(ze[et]);nt=Be(nt,gt)}const ct=Te(ze._common),st=Ne(ct,nt);return new se(st)}),se._locales=new t.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(de=>!de.startsWith("_")));class Ee{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ee.getRawData())),this._data}static isInvisibleCharacter(Te){return Ee.getData().has(Te)}static get codePoints(){return Ee.getData()}}e.InvisibleCharacters=Ee,Ee._data=void 0}),define(De[31],Ie([1,0,9,11,8,13]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function y(r){return r.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=y;function E(r){return r.indexOf("/")===-1&&(r=y(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function I(r,n=l.posix.sep){if(!r)return"";const c=r.length,h=r.charCodeAt(0);if(_(h)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let C=3;const L=C;for(;C<c&&!_(r.charCodeAt(C));C++);if(L!==C&&!_(r.charCodeAt(C+1))){for(C+=1;C<c;C++)if(_(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,n)}}return n}else if(d(h)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(_(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=I;function R(r){if(!t.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let c=2;const h=c;for(;c<r.length&&(n=r.charCodeAt(c),n!==92);c++);return!(h===c||(n=r.charCodeAt(c+1),isNaN(n)||n===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(r,n=t.isWindows){const c=n?k:S;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||n&&T.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=w;function b(r,n,c){const h=r===n;return!c||h?h:!r||!n?!1:(0,D.equalsIgnoreCase)(r,n)}e.isEqual=b;function v(r,n,c,h=l.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let C=n.length;return n.charAt(n.length-1)===h&&C--,r.charAt(C)===h}return n.charAt(n.length-1)!==h&&(n+=h),r.indexOf(n)===0}e.isEqualOrParent=v;function d(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=d;function p(r,n){return t.isWindows&&r.endsWith(":")&&(r+=l.sep),(0,l.isAbsolute)(r)||(r=(0,l.join)(n,r)),r=(0,l.normalize)(r),t.isWindows?(r=(0,D.rtrim)(r,l.sep),r.endsWith(":")&&(r+=l.sep)):(r=(0,D.rtrim)(r,l.sep),r||(r=l.sep)),r}e.sanitizeFilePath=p;function f(r){const n=(0,l.normalize)(r);return t.isWindows?r.length>3?!1:a(n)&&(r.length===2||n.charCodeAt(2)===92):n===l.posix.sep}e.isRootOrDriveLetter=f;function a(r,n=t.isWindows){return n?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function g(r){return a(r)?r[0]:void 0}e.getDriveLetter=g;function s(r,n,c){return n.length>r.length?-1:r===n?0:(c&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=s;function u(r){const n=r.split(":");let c,h,m;for(const C of n){const L=Number(C);(0,P.isNumber)(L)?h===void 0?h=L:m===void 0&&(m=L):c=c?[c,C].join(":"):C}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,n,c=8){let h="";for(let C=0;C<c;C++)h+=o.charAt(Math.floor(Math.random()*o.length));let m;return n?m=`${n}-${h}`:m=h,r?(0,l.join)(r,m):m}e.randomPath=i}),define(De[61],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return D(d,0)}e.hash=t;function D(d,p){switch(typeof d){case"object":return d===null?P(349,p):Array.isArray(d)?E(d,p):I(d,p);case"string":return y(d,p);case"boolean":return _(d,p);case"number":return P(d,p);case"undefined":return P(937,p);default:return P(617,p)}}e.doHash=D;function P(d,p){return(p<<5)-p+d|0}e.numberHash=P;function _(d,p){return P(d?433:863,p)}function y(d,p){p=P(149417,p);for(let f=0,a=d.length;f<a;f++)p=P(d.charCodeAt(f),p);return p}e.stringHash=y;function E(d,p){return p=P(104579,p),d.reduce((f,a)=>D(a,f),p)}function I(d,p){return p=P(181387,p),Object.keys(d).sort().reduce((f,a)=>(f=y(a,f),D(d[a],f)),p)}class R{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=D(p,this._value),this._value}}e.Hasher=R;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(d,p,f=32){const a=f-p,g=~((1<<a)-1);return(d<<p|(g&d)>>>a)>>>0}function T(d,p=0,f=d.byteLength,a=0){for(let g=0;g<f;g++)d[p+g]=a}function w(d,p,f="0"){for(;d.length<p;)d=f+d;return d}function b(d,p=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(f=>f.toString(16).padStart(2,"0")).join(""):w((d>>>0).toString(16),p/4)}e.toHexString=b;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const f=p.length;if(f===0)return;const a=this._buff;let g=this._buffLen,s=this._leftoverHighSurrogate,u,o;for(s!==0?(u=s,o=-1,s=0):(u=p.charCodeAt(0),o=0);;){let i=u;if(l.isHighSurrogate(u))if(o+1<f){const r=p.charCodeAt(o+1);l.isLowSurrogate(r)?(o++,i=l.computeCodePoint(u,r)):i=65533}else{s=u;break}else l.isLowSurrogate(u)&&(i=65533);if(g=this._push(a,g,i),o++,o<f)u=p.charCodeAt(o);else break}this._buffLen=g,this._leftoverHighSurrogate=s}_push(p,f,a){return a<128?p[f++]=a:a<2048?(p[f++]=192|(a&1984)>>>6,p[f++]=128|(a&63)>>>0):a<65536?(p[f++]=224|(a&61440)>>>12,p[f++]=128|(a&4032)>>>6,p[f++]=128|(a&63)>>>0):(p[f++]=240|(a&1835008)>>>18,p[f++]=128|(a&258048)>>>12,p[f++]=128|(a&4032)>>>6,p[f++]=128|(a&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=v._bigBlock32,f=this._buffDV;for(let c=0;c<64;c+=4)p.setUint32(c,f.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,S(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let a=this._h0,g=this._h1,s=this._h2,u=this._h3,o=this._h4,i,r,n;for(let c=0;c<80;c++)c<20?(i=g&s|~g&u,r=1518500249):c<40?(i=g^s^u,r=1859775393):c<60?(i=g&s|g&u|s&u,r=2400959708):(i=g^s^u,r=3395469782),n=S(a,5)+i+o+r+p.getUint32(c*4,!1)&4294967295,o=u,u=s,s=S(g,30),g=a,a=n;this._h0=this._h0+a&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[25],Ie([1,0,17,8]),function(J,e,l,t){"use strict";var D,P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(o,i,r){let n=o.get(i);return n===void 0&&(n=r,o.set(i,n)),n}e.getOrSet=y;function E(o){const i=[];return o.forEach((r,n)=>{i.push(`${n} => ${r}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=E;function I(o){const i=[];return o.forEach(r=>{i.push(r)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=I;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class S{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const n=this._value.charCodeAt(r);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var T;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(T||(T={}));class w{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(v||(v={}));class d{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new d(new w(i,r))}static forPaths(i=!1){return new d(new S(void 0,!i))}static forStrings(){return new d(new R)}static forConfigKeys(){return new d(new k)}clear(){this._root=void 0}fill(i,r){if(r){const n=r.slice(0);(0,l.shuffle)(n);for(const c of n)this.set(c,i)}else{const n=i.slice(0);(0,l.shuffle)(n);for(const c of n)this.set(c[0],c[1])}}set(i,r){const n=this._iter.reset(i);let c;this._root||(this._root=new b,this._root.segment=n.value());const h=[];for(c=this._root;;){const C=n.cmp(c.segment);if(C>0)c.left||(c.left=new b,c.left.segment=n.value()),h.push([-1,c]),c=c.left;else if(C<0)c.right||(c.right=new b,c.right.segment=n.value()),h.push([1,c]),c=c.right;else if(n.hasNext())n.next(),c.mid||(c.mid=new b,c.mid.segment=n.value()),h.push([0,c]),c=c.mid;else break}const m=c.value;c.value=r,c.key=i;for(let C=h.length-1;C>=0;C--){const L=h[C][1];L.updateHeight();const U=L.balanceFactor();if(U<-1||U>1){const B=h[C][0],A=h[C+1][0];if(B===1&&A===1)h[C][1]=L.rotateLeft();else if(B===-1&&A===-1)h[C][1]=L.rotateRight();else if(B===1&&A===-1)L.right=h[C+1][1]=h[C+1][1].rotateRight(),h[C][1]=L.rotateLeft();else if(B===-1&&A===1)L.left=h[C+1][1]=h[C+1][1].rotateLeft(),h[C][1]=L.rotateRight();else throw new Error;if(C>0)switch(h[C-1][0]){case-1:h[C-1][1].left=h[C][1];break;case 1:h[C-1][1].right=h[C][1];break;case 0:h[C-1][1].mid=h[C][1];break}else this._root=h[0][1]}}return m}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const c=r.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const n=this._iter.reset(i),c=[];let h=this._root;for(;h;){const m=n.cmp(h.segment);if(m>0)c.push([-1,h]),h=h.left;else if(m<0)c.push([1,h]),h=h.right;else if(n.hasNext())n.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this._min(h.right),{key:C,value:L,segment:U}=m;this._delete(m.key,!1),h.key=C,h.value=L,h.segment=U}else{const m=h.left??h.right;if(c.length>0){const[C,L]=c[c.length-1];switch(C){case-1:L.left=m;break;case 0:L.mid=m;break;case 1:L.right=m;break}}else this._root=m}for(let m=c.length-1;m>=0;m--){const C=c[m][1];C.updateHeight();const L=C.balanceFactor();if(L>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),c[m][1]=C.rotateLeft()):L<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),c[m][1]=C.rotateRight()),m>0)switch(c[m-1][0]){case-1:c[m-1][1].left=c[m][1];break;case 1:c[m-1][1].right=c[m][1];break;case 0:c[m-1][1].mid=c[m][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let n=this._root,c;for(;n;){const h=r.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(r.hasNext())r.next(),c=n.value||c,n=n.mid;else break}return n&&n.value||c}findSuperstr(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const c=r.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[r,n]of this)i(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const n=r.balanceFactor();return n<-1||n>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=d;class p{constructor(i,r){this.uri=i,this.value=r}}class f{constructor(i,r){this[D]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=r??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new p(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[n,c]of this.map)i(c.value,c.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=o=>o.toString();class a{constructor(i,r){this[P]="ResourceSet",!i||typeof i=="function"?this._map=new f(i):(this._map=new f(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((n,c)=>i.call(r,c,c,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=a;var g;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class s{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const n=this._map.get(i);if(!!n)return r!==0&&this.touch(n,r),n.value}set(i,r,n=0){let c=this._map.get(i);if(c)c.value=r,n!==0&&this.touch(c,n);else{switch(c={key:i,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const n=this._state;let c=this._head;for(;c;){if(r?i.bind(r)(c.value,c.key,this):i(c.value,c.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,r=this._state;let n=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.key,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return c}values(){const i=this,r=this._state;let n=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.value,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return c}entries(){const i=this,r=this._state;let n=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:[n.key,n.value],done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return c}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>i;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,n=i.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const n=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(n.previous=c,c.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const n=i.next,c=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=c,c.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,n)=>{i.push([n,r])}),i}fromJSON(i){this.clear();for(const[r,n]of i)this.set(r,n)}}e.LinkedMap=s;class u extends s{constructor(i,r=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(De[102],Ie([1,0,25,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ee){return function(ie,F){for(let H=0,G=ee.length;H<G;H++){const X=ee[H](ie,F);if(X)return X}return null}}e.or=D,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ee,ie,F){if(!F||F.length<ie.length)return null;let H;return ee?H=t.startsWithIgnoreCase(F,ie):H=F.indexOf(ie)===0,H?ie.length>0?[{start:0,end:ie.length}]:[]:null}function _(ee,ie){const F=ie.toLowerCase().indexOf(ee.toLowerCase());return F===-1?null:[{start:F,end:F+ee.length}]}e.matchesContiguousSubString=_;function y(ee,ie){return E(ee.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=y;function E(ee,ie,F,H){if(F===ee.length)return[];if(H===ie.length)return null;if(ee[F]===ie[H]){let G=null;return(G=E(ee,ie,F+1,H+1))?d({start:H,end:H+1},G):null}return E(ee,ie,F,H+1)}function I(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function k(ee){return 48<=ee&&ee<=57}function S(ee){return ee===32||ee===9||ee===10||ee===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>T.add(ee.charCodeAt(0)));function w(ee){return S(ee)||T.has(ee)}function b(ee,ie){return ee===ie||w(ee)&&w(ie)}function v(ee){return I(ee)||R(ee)||k(ee)}function d(ee,ie){return ie.length===0?ie=[ee]:ee.end===ie[0].start?ie[0].start=ee.start:ie.unshift(ee),ie}function p(ee,ie){for(let F=ie;F<ee.length;F++){const H=ee.charCodeAt(F);if(R(H)||k(H)||F>0&&!v(ee.charCodeAt(F-1)))return F}return ee.length}function f(ee,ie,F,H){if(F===ee.length)return[];if(H===ie.length)return null;if(ee[F]!==ie[H].toLowerCase())return null;{let G=null,X=H+1;for(G=f(ee,ie,F+1,H+1);!G&&(X=p(ie,X))<ie.length;)G=f(ee,ie,F+1,X),X++;return G===null?null:d({start:H,end:H+1},G)}}function a(ee){let ie=0,F=0,H=0,G=0,X=0;for(let ye=0;ye<ee.length;ye++)X=ee.charCodeAt(ye),R(X)&&ie++,I(X)&&F++,v(X)&&H++,k(X)&&G++;const me=ie/ee.length,we=F/ee.length,le=H/ee.length,Ce=G/ee.length;return{upperPercent:me,lowerPercent:we,alphaPercent:le,numericPercent:Ce}}function g(ee){const{upperPercent:ie,lowerPercent:F}=ee;return F===0&&ie>.6}function s(ee){const{upperPercent:ie,lowerPercent:F,alphaPercent:H,numericPercent:G}=ee;return F>.2&&ie<.8&&H>.6&&G<.2}function u(ee){let ie=0,F=0,H=0,G=0;for(let X=0;X<ee.length;X++)H=ee.charCodeAt(X),R(H)&&ie++,I(H)&&F++,S(H)&&G++;return(ie===0||F===0)&&G===0?ee.length<=30:ie<=5}function o(ee,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!u(ee)||ie.length>60)return null;const F=a(ie);if(!s(F)){if(!g(F))return null;ie=ie.toLowerCase()}let H=null,G=0;for(ee=ee.toLowerCase();G<ie.length&&(H=f(ee,ie,0,G))===null;)G=p(ie,G+1);return H}e.matchesCamelCase=o;function i(ee,ie,F=!1){if(!ie||ie.length===0)return null;let H=null,G=0;for(ee=ee.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(H=r(ee,ie,0,G,F))===null;)G=n(ie,G+1);return H}e.matchesWords=i;function r(ee,ie,F,H,G){if(F===ee.length)return[];if(H===ie.length)return null;if(b(ee.charCodeAt(F),ie.charCodeAt(H))){let X=null,me=H+1;if(X=r(ee,ie,F+1,H+1,G),!G)for(;!X&&(me=n(ie,me))<ie.length;)X=r(ee,ie,F+1,me,G),me++;return X?ee.charCodeAt(F)!==ie.charCodeAt(H)?X:d({start:H,end:H+1},X):null}else return null}function n(ee,ie){for(let F=ie;F<ee.length;F++)if(w(ee.charCodeAt(F))||F>0&&w(ee.charCodeAt(F-1)))return F;return ee.length}const c=D(e.matchesPrefix,o,_),h=D(e.matchesPrefix,o,y),m=new l.LRUCache(1e4);function C(ee,ie,F=!1){if(typeof ee!="string"||typeof ie!="string")return null;let H=m.get(ee);H||(H=new RegExp(t.convertSimple2RegExpPattern(ee),"i"),m.set(ee,H));const G=H.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:F?h(ee,ie):c(ee,ie)}e.matchesFuzzy=C;function L(ee,ie){const F=Le(ee,ee.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?B(F):null}e.matchesFuzzy2=L;function U(ee,ie,F,H,G,X){const me=Math.min(13,ee.length);for(;F<me;F++){const we=Le(ee,ie,F,H,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=U;function B(ee){if(typeof ee>"u")return[];const ie=[],F=ee[1];for(let H=ee.length-1;H>1;H--){const G=ee[H]+F,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=B;const A=128;function M(){const ee=[],ie=[];for(let F=0;F<=A;F++)ie[F]=0;for(let F=0;F<=A;F++)ee.push(ie.slice(0));return ee}function $(ee){const ie=[];for(let F=0;F<=ee;F++)ie[F]=0;return ie}const N=$(2*A),K=$(2*A),z=M(),O=M(),x=M(),V=!1;function q(ee,ie,F,H,G){function X(we,le,Ce=" "){for(;we.length<le;)we=Ce+we;return we}let me=` |   |${H.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=F;we++)we===0?me+=" |":me+=`${ie[we-1]}|`,me+=ee[we].slice(0,G+1).map(le=>X(le.toString(),3)).join("|")+`
`;return me}function Y(ee,ie,F,H){ee=ee.substr(ie),F=F.substr(H),console.log(q(O,ee,ee.length,F,F.length)),console.log(q(x,ee,ee.length,F,F.length)),console.log(q(z,ee,ee.length,F,F.length))}function Q(ee,ie){if(ie<0||ie>=ee.length)return!1;const F=ee.codePointAt(ie);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(F)}}function he(ee,ie){if(ie<0||ie>=ee.length)return!1;switch(ee.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ve(ee,ie,F){return ie[ee]!==F[ee]}function ne(ee,ie,F,H,G,X,me=!1){for(;ie<F&&G<X;)ee[ie]===H[G]&&(me&&(N[ie]=G),ie+=1),G+=1;return ie===F}e.isPatternInWord=ne;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var be;(function(ee){ee.Default=[-100,0];function ie(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}ee.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,F){this.firstMatchCanBeWeak=ie,this.boostFullMatch=F}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Le(ee,ie,F,H,G,X,me=ke.default){const we=ee.length>A?A:ee.length,le=H.length>A?A:H.length;if(F>=we||X>=le||we-F>le-X||!ne(ie,F,we,G,X,le,!0))return;We(we,le,F,X,ie,G);let Ce=1,ye=1,$e=F,je=X;const Ze=[!1];for(Ce=1,$e=F;$e<we;Ce++,$e++){const se=N[$e],Ee=K[$e],de=$e+1<we?K[$e+1]:le;for(ye=se-X+1,je=se;je<de;ye++,je++){let Te=Number.MIN_SAFE_INTEGER,Ne=!1;je<=Ee&&(Te=oe(ee,ie,$e,F,H,G,je,le,X,z[Ce-1][ye-1]===0,Ze));let Be=0;Te!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Be=Te+O[Ce-1][ye-1]);const ze=je>se,Xe=ze?O[Ce][ye-1]+(z[Ce][ye-1]>0?-5:0):0,nt=je>se+1&&z[Ce][ye-1]>0,ct=nt?O[Ce][ye-2]+(z[Ce][ye-2]>0?-5:0):0;if(nt&&(!ze||ct>=Xe)&&(!Ne||ct>=Be))O[Ce][ye]=ct,x[Ce][ye]=3,z[Ce][ye]=0;else if(ze&&(!Ne||Xe>=Be))O[Ce][ye]=Xe,x[Ce][ye]=2,z[Ce][ye]=0;else if(Ne)O[Ce][ye]=Be,x[Ce][ye]=1,z[Ce][ye]=z[Ce-1][ye-1]+1;else throw new Error("not possible")}}if(V&&Y(ee,F,H,X),!Ze[0]&&!me.firstMatchCanBeWeak)return;Ce--,ye--;const Ye=[O[Ce][ye],X];let Oe=0,ot=0;for(;Ce>=1;){let se=ye;do{const Ee=x[Ce][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Oe>1&&ie[F+Ce-1]===G[X+ye-1]&&!ve(se+X-1,H,G)&&Oe+1>z[Ce][se]&&(se=ye),se===ye?Oe++:Oe=1,ot||(ot=se),Ce--,ye=se-1,Ye.push(ye)}le===we&&me.boostFullMatch&&(Ye[0]+=2);const re=ot-we;return Ye[0]-=re,Ye}e.fuzzyScore=Le;function We(ee,ie,F,H,G,X){let me=ee-1,we=ie-1;for(;me>=F&&we>=H;)G[me]===X[we]&&(K[me]=we,me--),we--}function oe(ee,ie,F,H,G,X,me,we,le,Ce,ye){if(ie[F]!==X[me])return Number.MIN_SAFE_INTEGER;let $e=1,je=!1;return me===F-H?$e=ee[F]===G[me]?7:5:ve(me,G,X)&&(me===0||!ve(me-1,G,X))?($e=ee[F]===G[me]?7:5,je=!0):Q(X,me)&&(me===0||!Q(X,me-1))?$e=5:(Q(X,me-1)||he(X,me-1))&&($e=5,je=!0),$e>1&&F===H&&(ye[0]=!0),je||(je=ve(me,G,X)||Q(X,me-1)||he(X,me-1)),F===H?me>le&&($e-=je?3:5):Ce?$e+=je?2:0:$e+=je?0:1,me+1===we&&($e-=je?3:5),$e}function ue(ee,ie,F,H,G,X,me){return Z(ee,ie,F,H,G,X,!0,me)}e.fuzzyScoreGracefulAggressive=ue;function fe(ee,ie,F,H,G,X,me){return Z(ee,ie,F,H,G,X,!1,me)}e.fuzzyScoreGraceful=fe;function Z(ee,ie,F,H,G,X,me,we){let le=Le(ee,ie,F,H,G,X,we);if(le&&!me)return le;if(ee.length>=3){const Ce=Math.min(7,ee.length-1);for(let ye=F+1;ye<Ce;ye++){const $e=ae(ee,ye);if($e){const je=Le($e,$e.toLowerCase(),F,H,G,X,we);je&&(je[0]-=3,(!le||je[0]>le[0])&&(le=je))}}}return le}function ae(ee,ie){if(ie+1>=ee.length)return;const F=ee[ie],H=ee[ie+1];if(F!==H)return ee.slice(0,ie)+H+F+ee.slice(ie+2)}}),define(De[156],Ie([1,0,76,102,8]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(l.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${P.source}`,"g");function E(v){return v.replace(y,(d,p)=>p?d:`\\${d}`)}e.escapeIcons=E;const I=new RegExp(`\\\\${P.source}`,"g");function R(v){return v.replace(I,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(k,(d,p,f,a)=>f?d:p||a||"")}e.stripIcons=S;function T(v){const d=v.indexOf(e.iconStartMarker);return d===-1?{text:v}:w(v,d)}e.parseLabelWithIcons=T;function w(v,d){const p=[];let f="";function a(c){if(c){f+=c;for(const h of c)p.push(u)}}let g=-1,s="",u=0,o,i,r=d;const n=v.length;for(a(v.substr(0,d));r<n;)o=v[r],i=v[r+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(g=r,a(s),s=e.iconStartMarker,r++):o===")"&&g!==-1?(u+=r-g+1,g=-1,s=""):g!==-1?_.test(o)?s+=o:(a(s),g=-1,s=""):a(o),r++;return a(s),{text:f,iconOffsets:p}}function b(v,d,p=!1){const{text:f,iconOffsets:a}=d;if(!a||a.length===0)return(0,t.matchesFuzzy)(v,f,p);const g=(0,D.ltrim)(f," "),s=f.length-g.length,u=(0,t.matchesFuzzy)(v,g,p);if(u)for(const o of u){const i=a[o.start+s]+s;o.start+=i,o.end+=i}return u}e.matchesFuzzyIconAware=b}),define(De[80],Ie([1,0,25]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function D(I){return E(I,"NFC",t)}e.normalizeNFC=D;const P=new l.LRUCache(1e4);function _(I){return E(I,"NFD",P)}e.normalizeNFD=_;const y=/[^\u0000-\u0080]/;function E(I,R,k){if(!I)return I;const S=k.get(I);if(S)return S;let T;return y.test(I)?T=I.normalize(R):T=I,k.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(R){return _(R).replace(I,"")}}()}),define(De[41],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const P="error",_="warning",y="warn",E="info",I="ignore";function R(S){return S?l.equalsIgnoreCase(P,S)?D.Error:l.equalsIgnoreCase(_,S)||l.equalsIgnoreCase(y,S)?D.Warning:l.equalsIgnoreCase(E,S)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(S){switch(S){case D.Error:return P;case D.Warning:return _;case D.Info:return E;default:return I}}D.toString=k}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,P=/^\//,_=/^\/\//;function y(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(o,i){return!o&&!i?"file":o}function I(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const R="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(i,r,n,c,h,m=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=E(i,m),this.authority=r||R,this.path=I(this.scheme,n||R),this.query=c||R,this.fragment=h||R,y(this,m))}static isUri(i){return i instanceof T?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:n,path:c,query:h,fragment:m}=i;return r===void 0?r=this.scheme:r===null&&(r=R),n===void 0?n=this.authority:n===null&&(n=R),c===void 0?c=this.path:c===null&&(c=R),h===void 0?h=this.query:h===null&&(h=R),m===void 0?m=this.fragment:m===null&&(m=R),r===this.scheme&&n===this.authority&&c===this.path&&h===this.query&&m===this.fragment?this:new b(r,n,c,h,m)}static parse(i,r=!1){const n=S.exec(i);return n?new b(n[2]||R,u(n[4]||R),u(n[5]||R),u(n[7]||R),u(n[9]||R),r):new b(R,R,R,R,R)}static file(i){let r=R;if(t.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const n=i.indexOf(k,2);n===-1?(r=i.substring(2),i=k):(r=i.substring(2,n),i=i.substring(n)||k)}return new b("file",r,i,R,R)}static from(i){const r=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return y(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return t.isWindows&&i.scheme==="file"?n=T.file(l.win32.join(f(i,!0),...r)).path:n=l.posix.join(i.path,...r),i.with({path:n})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof T)return i;{const r=new b(i);return r._formatted=i.external,r._fsPath=i._sep===w?i.fsPath:null,r}}else return i}}e.URI=T;const w=t.isWindows?1:void 0;class b extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=w),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(o,i){let r,n=-1;for(let c=0;c<o.length;c++){const h=o.charCodeAt(c);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)n!==-1&&(r+=encodeURIComponent(o.substring(n,c)),n=-1),r!==void 0&&(r+=o.charAt(c));else{r===void 0&&(r=o.substr(0,c));const m=v[h];m!==void 0?(n!==-1&&(r+=encodeURIComponent(o.substring(n,c)),n=-1),r+=m):n===-1&&(n=c)}}return n!==-1&&(r+=encodeURIComponent(o.substring(n))),r!==void 0?r:o}function p(o){let i;for(let r=0;r<o.length;r++){const n=o.charCodeAt(r);n===35||n===63?(i===void 0&&(i=o.substr(0,r)),i+=v[n]):i!==void 0&&(i+=o[r])}return i!==void 0?i:o}function f(o,i){let r;return o.authority&&o.path.length>1&&o.scheme==="file"?r=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?r=o.path.substr(1):r=o.path[1].toLowerCase()+o.path.substr(2):r=o.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=f;function a(o,i){const r=i?p:d;let n="",{scheme:c,authority:h,path:m,query:C,fragment:L}=o;if(c&&(n+=c,n+=":"),(h||c==="file")&&(n+=k,n+=k),h){let U=h.indexOf("@");if(U!==-1){const B=h.substr(0,U);h=h.substr(U+1),U=B.indexOf(":"),U===-1?n+=r(B,!1):(n+=r(B.substr(0,U),!1),n+=":",n+=r(B.substr(U+1),!1)),n+="@"}h=h.toLowerCase(),U=h.indexOf(":"),U===-1?n+=r(h,!1):(n+=r(h.substr(0,U),!1),n+=h.substr(U))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const U=m.charCodeAt(1);U>=65&&U<=90&&(m=`/${String.fromCharCode(U+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const U=m.charCodeAt(0);U>=65&&U<=90&&(m=`${String.fromCharCode(U+32)}:${m.substr(2)}`)}n+=r(m,!0)}return C&&(n+="?",n+=r(C,!1)),L&&(n+="#",n+=i?L:d(L,!1)),n}function g(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+g(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(o){return o.match(s)?o.replace(s,i=>g(i)):o}}),define(De[62],Ie([1,0,23,8,2]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(I){return JSON.stringify(I,y)}e.stringify=P;function _(I){let R=JSON.parse(I);return R=E(R),R}e.parse=_;function y(I,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function E(I,R=0){if(!I||R>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof l.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=E(I[k],R+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=E(I[k],R+1))}return I}e.revive=E}),define(De[12],Ie([1,0,11,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${D.vscodeRemoteResource}`}set(E,I,R){this._hosts[E]=I,this._ports[E]=R}setConnectionToken(E,I){this._connectionTokens[E]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const I=E.authority;let R=this._hosts[I];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const k=this._ports[I],S=this._connectionTokens[I];let T=`path=${encodeURIComponent(E.path)}`;return typeof S=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${R}:${k}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new P;class _{asBrowserUri(E,I){const R=this.toUri(E,I);return R.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===D.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${D.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?R.with({scheme:D.vscodeFileResource,authority:R.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,I){const R=this.toUri(E,I);return R.scheme===D.vscodeFileResource?R.with({scheme:D.file,authority:R.authority!==_.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,I){return t.URI.isUri(E)?E:t.URI.parse(I.toUrl(E))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _}),define(De[22],Ie([1,0,31,12,9,11,8,2]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,y.uriToFsPath)(T,!0)}e.originalFSPath=E;class I{constructor(w){this._ignorePathCasing=w}compare(w,b,v=!1){return w===b?0:(0,_.compare)(this.getComparisonKey(w,v),this.getComparisonKey(b,v))}isEqual(w,b,v=!1){return w===b?!0:!w||!b?!1:this.getComparisonKey(w,v)===this.getComparisonKey(b,v)}getComparisonKey(w,b=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,b,v=!1){if(w.scheme===b.scheme){if(w.scheme===t.Schemas.file)return l.isEqualOrParent(E(w),E(b),this._ignorePathCasing(w))&&w.query===b.query&&(v||w.fragment===b.fragment);if((0,e.isEqualAuthority)(w.authority,b.authority))return l.isEqualOrParent(w.path,b.path,this._ignorePathCasing(w),"/")&&w.query===b.query&&(v||w.fragment===b.fragment)}return!1}joinPath(w,...b){return y.URI.joinPath(w,...b)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return D.posix.basename(w.path)}extname(w){return D.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let b;return w.scheme===t.Schemas.file?b=y.URI.file(D.dirname(E(w))).path:(b=D.posix.dirname(w.path),w.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),b="/")),w.with({path:b})}normalizePath(w){if(!w.path.length)return w;let b;return w.scheme===t.Schemas.file?b=y.URI.file(D.normalize(E(w))).path:b=D.posix.normalize(w.path),w.with({path:b})}relativePath(w,b){if(w.scheme!==b.scheme||!(0,e.isEqualAuthority)(w.authority,b.authority))return;if(w.scheme===t.Schemas.file){const p=D.relative(E(w),E(b));return P.isWindows?l.toSlashes(p):p}let v=w.path||"/";const d=b.path||"/";if(this._ignorePathCasing(w)){let p=0;for(const f=Math.min(v.length,d.length);p<f&&!(v.charCodeAt(p)!==d.charCodeAt(p)&&v.charAt(p).toLowerCase()!==d.charAt(p).toLowerCase());p++);v=d.substr(0,p)+v.substr(p)}return D.posix.relative(v,d)}resolvePath(w,b){if(w.scheme===t.Schemas.file){const v=y.URI.file(D.resolve(E(w),b));return w.with({authority:v.authority,path:v.path})}return b=l.toPosixPath(b),w.with({path:D.posix.resolve(w.path,b)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,b){return w===b||w!==void 0&&b!==void 0&&(0,_.equalsIgnoreCase)(w,b)}hasTrailingPathSeparator(w,b=D.sep){if(w.scheme===t.Schemas.file){const v=E(w);return v.length>l.getRoot(v).length&&v[v.length-1]===b}else{const v=w.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,b=D.sep){return(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,b=D.sep){let v=!1;if(w.scheme===t.Schemas.file){const d=E(w);v=d!==void 0&&d.length===l.getRoot(d).length&&d[d.length-1]===b}else{b="/";const d=w.path;v=d.length===1&&d.charCodeAt(d.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path+"/"}):w}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(T,w){const b=[];for(let v=0;v<T.length;v++){const d=w(T[v]);T.some((p,f)=>f===v?!1:(0,e.isEqualOrParent)(d,w(p)))||b.push(T[v])}return b}e.distinctParents=R;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function w(b){const v=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,g]=f.split(":");a&&g&&v.set(a,g)});const p=b.path.substring(0,b.path.indexOf(";"));return p&&v.set(T.META_DATA_MIME,p),v}T.parseMetaData=w})(k=e.DataUri||(e.DataUri={}));function S(T,w,b){if(w){let v=T.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),T.with({scheme:b,authority:w,path:v})}return T.with({scheme:b})}e.toLocalResource=S}),define(De[18],Ie([1,0,21,10,4,6,22,11]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=E;function I(ve){const ne=new l.CancellationTokenSource,pe=ve(ne.token),be=new Promise((ke,Le)=>{const We=ne.token.onCancellationRequested(()=>{We.dispose(),ne.dispose(),Le(new t.CancellationError)});Promise.resolve(pe).then(oe=>{We.dispose(),ne.dispose(),ke(oe)},oe=>{We.dispose(),ne.dispose(),Le(oe)})});return new class{cancel(){ne.cancel()}then(ke,Le){return be.then(ke,Le)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=I;function R(ve,ne,pe){return new Promise((be,ke)=>{const Le=ne.onCancellationRequested(()=>{Le.dispose(),be(pe)});ve.then(be,ke).finally(()=>Le.dispose())})}e.raceCancellation=R;function k(ve,ne){return new Promise((pe,be)=>{const ke=ne.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});ve.then(pe,be).finally(()=>ke.dispose())})}e.raceCancellationError=k;async function S(ve){let ne=-1;const pe=ve.map((ke,Le)=>ke.then(We=>(ne=Le,We))),be=await Promise.race(pe);return ve.forEach((ke,Le)=>{Le!==ne&&ke.cancel()}),be}e.raceCancellablePromises=S;function T(ve,ne,pe){let be;const ke=setTimeout(()=>{be?.(void 0),pe?.()},ne);return Promise.race([ve.finally(()=>clearTimeout(ke)),new Promise(Le=>be=Le)])}e.raceTimeout=T;function w(ve){return new Promise((ne,pe)=>{const be=ve();E(be)?be.then(ne,pe):ne(be)})}e.asPromise=w;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(pe,pe).then(be)})}return new Promise((pe,be)=>{this.queuedPromise.then(pe,be)})}return this.activePromise=ne(),new Promise((pe,be)=>{this.activePromise.then(ke=>{this.activePromise=null,pe(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=b;class v{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=v;class d{constructor(){this.promiseMap=new Map}queue(ne,pe){const ke=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(ne)===ke&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,ke),ke}}e.SequencerByKey=d;const p=(ve,ne)=>{let pe=!0;const be=setTimeout(()=>{pe=!1,ne()},ve);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(be),pe=!1}}},f=ve=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,ve())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,pe=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Le)=>{this.doResolve=ke,this.doReject=Le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?f(be):p(pe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class g{constructor(ne){this.delayer=new a(ne),this.throttler=new b}trigger(ne,pe){return this.delayer.trigger(()=>this.throttler.queue(ne),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class s{constructor(){this._isOpen=!1,this._promise=new Promise((ne,pe)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o(ve,ne){return ne?new Promise((pe,be)=>{const ke=setTimeout(()=>{Le.dispose(),pe()},ve),Le=ne.onCancellationRequested(()=>{clearTimeout(ke),Le.dispose(),be(new t.CancellationError)})}):I(pe=>o(ve,pe))}e.timeout=o;function i(ve,ne=0){const pe=setTimeout(ve,ne);return(0,P.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=i;function r(ve){const ne=[];let pe=0;const be=ve.length;function ke(){return pe<be?ve[pe++]():null}function Le(We){We!=null&&ne.push(We);const oe=ke();return oe?oe.then(Le):Promise.resolve(ne)}return Promise.resolve(null).then(Le)}e.sequence=r;function n(ve,ne=be=>!!be,pe=null){let be=0;const ke=ve.length,Le=()=>{if(be>=ke)return Promise.resolve(pe);const We=ve[be++];return Promise.resolve(We()).then(ue=>ne(ue)?Promise.resolve(ue):Le())};return Le()}e.first=n;function c(ve,ne=be=>!!be,pe=null){if(ve.length===0)return Promise.resolve(pe);let be=ve.length;const ke=()=>{be=-1;for(const Le of ve)Le.cancel?.()};return new Promise((Le,We)=>{for(const oe of ve)oe.then(ue=>{--be>=0&&ne(ue)?(ke(),Le(ue)):be===0&&Le(pe)}).catch(ue=>{--be>=0&&(ke(),We(ue))})})}e.firstParallel=c;class h{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((pe,be)=>{this.outstandingPromises.push({factory:ne,c:pe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const pe=ne.factory();pe.then(ne.c,ne.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class m extends h{constructor(){super(1)}}e.Queue=m;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new x;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,pe=_.extUri){const be=pe.getComparisonKey(ne);let ke=this.queues.get(be);return ke||(ke=new m,D.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class L{constructor(ne,pe){this._token=-1,typeof ne=="function"&&typeof pe=="number"&&this.setIfNotSet(ne,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},pe)}setIfNotSet(ne,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},pe))}}e.TimeoutTimer=L;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setInterval(()=>{ne()},pe)}}e.IntervalTimer=U;class B{constructor(ne,pe){this.timeoutToken=-1,this.runner=ne,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class A{constructor(ne,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class M extends B{constructor(ne,pe){super(ne,pe),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class $ extends P.Disposable{constructor(ne,pe){super(),this.options=ne,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,y.setTimeout0)(()=>{if(ne)return;const pe=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(ve,ne)=>{const pe=requestIdleCallback(ve,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(pe))}}}}();class N{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function K(ve,ne,pe){let be;for(let ke=0;ke<pe;ke++)try{return await ve()}catch(Le){be=Le,await o(ne)}throw be}e.retry=K;class z{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,pe,be){return this._pending={taskId:ne,cancel:()=>be?.(),promise:pe},pe.then(()=>this.donePending(ne),()=>this.donePending(ne)),pe}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let pe,be;const ke=new Promise((Le,We)=>{pe=Le,be=We});this._next={run:ne,promise:ke,promiseResolve:pe,promiseReject:be}}return this._next.promise}}e.TaskSequentializer=z;class O{constructor(ne,pe=()=>Date.now()){this.interval=ne,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,pe)=>{this.completeCallback=ne,this.errorCallback=pe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(pe=>{this.completeCallback(ne),this.resolved=!0,pe()})}error(ne){return new Promise(pe=>{this.errorCallback(ne),this.rejected=!0,pe()})}cancel(){new Promise(ne=>{this.errorCallback(new t.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=x;var V;(function(ve){async function ne(be){let ke;const Le=await Promise.all(be.map(We=>We.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Le}ve.settled=ne;function pe(be){return new Promise(async(ke,Le)=>{try{await be(ke,Le)}catch(We){Le(We)}})}ve.withAsyncBody=pe})(V=e.Promises||(e.Promises={}));var q;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(q||(q={}));class Y{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const pe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(ne(pe)),this.resolve()}catch(be){this.reject(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}static fromArray(ne){return new Y(pe=>{pe.emitMany(ne)})}static fromPromise(ne){return new Y(async pe=>{pe.emitMany(await ne)})}static fromPromises(ne){return new Y(async pe=>{await Promise.all(ne.map(async be=>pe.emitOne(await be)))})}static merge(ne){return new Y(async pe=>{await Promise.all(ne.map(async be=>{for await(const ke of be)pe.emitOne(ke)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,pe){return new Y(async be=>{for await(const ke of ne)be.emitOne(pe(ke))})}map(ne){return Y.map(this,ne)}static filter(ne,pe){return new Y(async be=>{for await(const ke of ne)pe(ke)&&be.emitOne(ke)})}filter(ne){return Y.filter(this,ne)}static coalesce(ne){return Y.filter(ne,pe=>!!pe)}coalesce(){return Y.coalesce(this)}static async toPromise(ne){const pe=[];for await(const be of ne)pe.push(be);return pe}toPromise(){return Y.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class Q extends Y{constructor(ne,pe){super(pe),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function he(ve){const ne=new l.CancellationTokenSource,pe=ve(ne.token);return new Q(ne,async be=>{const ke=ne.token.onCancellationRequested(()=>{ke.dispose(),ne.dispose(),be.reject(new t.CancellationError)});try{for await(const Le of pe){if(ne.token.isCancellationRequested)return;be.emitOne(Le)}ke.dispose(),ne.dispose()}catch(Le){ke.dispose(),ne.dispose(),be.reject(Le)}})}e.createCancelableAsyncIterable=he}),define(De[103],Ie([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new l.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(m,C,L=!1){const U=m||"",B=C||"",A=D.value.collator.compare(U,B);return D.value.collatorIsNumeric&&A===0&&U!==B?U<B?-1:1:A}e.compareFileNames=y;function E(m,C){const L=P.value.collator;return m=m||"",C=C||"",g(L,m,C)}e.compareFileNamesDefault=E;function I(m,C){const L=P.value.collator;return m=m||"",C=C||"",i(m,C)||g(L,m,C)}e.compareFileNamesUpper=I;function R(m,C){const L=P.value.collator;return m=m||"",C=C||"",o(m,C)||g(L,m,C)}e.compareFileNamesLower=R;function k(m,C){return m=m||"",C=C||"",m===C?0:m<C?-1:1}e.compareFileNamesUnicode=k;function S(m,C,L=!1){L||(m=m&&m.toLowerCase(),C=C&&C.toLowerCase());const[U,B]=f(m),[A,M]=f(C);return U!==A?U<A?-1:1:B===M?0:B<M?-1:1}e.noIntlCompareFileNames=S;function T(m,C){const[L,U]=f(m),[B,A]=f(C);let M=D.value.collator.compare(U,A);if(M===0){if(D.value.collatorIsNumeric&&U!==A)return U<A?-1:1;if(M=D.value.collator.compare(L,B),D.value.collatorIsNumeric&&M===0&&L!==B)return L<B?-1:1}return M}e.compareFileExtensions=T;function w(m,C){m=m||"",C=C||"";const L=a(m),U=a(C),B=P.value.collator,A=_.value.collator;return g(A,L,U)||g(B,m,C)}e.compareFileExtensionsDefault=w;function b(m,C){m=m||"",C=C||"";const L=a(m),U=a(C),B=P.value.collator,A=_.value.collator;return g(A,L,U)||i(m,C)||g(B,m,C)}e.compareFileExtensionsUpper=b;function v(m,C){m=m||"",C=C||"";const L=a(m),U=a(C),B=P.value.collator,A=_.value.collator;return g(A,L,U)||o(m,C)||g(B,m,C)}e.compareFileExtensionsLower=v;function d(m,C){m=m||"",C=C||"";const L=a(m).toLowerCase(),U=a(C).toLowerCase();return L!==U?L<U?-1:1:m!==C?m<C?-1:1:0}e.compareFileExtensionsUnicode=d;const p=/^(.*?)(\.([^.]*))?$/;function f(m,C=!1){const L=m?p.exec(m):[];let U=[L&&L[1]||"",L&&L[3]||""];return C&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function a(m){const C=m?p.exec(m):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function g(m,C,L){const U=m.compare(C,L);return U!==0?U:C.length!==L.length?C.length<L.length?-1:1:0}function s(m){const C=m.charAt(0);return C.toLocaleUpperCase()!==C}function u(m){const C=m.charAt(0);return C.toLocaleLowerCase()!==C}function o(m,C){return s(m)&&u(C)?-1:u(m)&&s(C)?1:0}function i(m,C){return u(m)&&s(C)?-1:s(m)&&u(C)?1:0}function r(m,C,L=!1){return L||(m=m&&m.toLowerCase(),C=C&&C.toLowerCase()),m===C?0:m<C?-1:1}function n(m,C,L=!1){const U=m.split(t.sep),B=C.split(t.sep),A=U.length-1,M=B.length-1;let $,N;for(let K=0;;K++){if($=A===K,N=M===K,$&&N)return y(U[K],B[K],L);if($)return-1;if(N)return 1;const z=r(U[K],B[K],L);if(z!==0)return z}}e.comparePaths=n;function c(m,C,L){const U=m.toLowerCase(),B=C.toLowerCase(),A=h(m,C,L);if(A)return A;const M=U.endsWith(L),$=B.endsWith(L);if(M!==$)return M?-1:1;const N=y(U,B);return N!==0?N:U.localeCompare(B)}e.compareAnything=c;function h(m,C,L){const U=m.toLowerCase(),B=C.toLowerCase(),A=U.startsWith(L),M=B.startsWith(L);if(A!==M)return A?-1:1;if(A&&M){if(U.length<B.length)return-1;if(U.length>B.length)return 1}return 0}e.compareByPrefix=h}),define(De[104],Ie([1,0,103,102,61,9,11,8]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,I=[E,[]];function R(z,O,x,V){if(!z||!O)return I;const q=z.length,Y=O.length;if(q<Y)return I;const Q=z.toLowerCase();return k(O,x,Y,z,Q,q,V)}e.scoreFuzzy=R;function k(z,O,x,V,q,Y,Q){const he=[],ve=[];for(let ke=0;ke<x;ke++){const Le=ke*Y,We=Le-Y,oe=ke>0,ue=z[ke],fe=O[ke];for(let Z=0;Z<Y;Z++){const ae=Z>0,ee=Le+Z,ie=ee-1,F=We+Z-1,H=ae?he[ie]:0,G=oe&&ae?he[F]:0,X=oe&&ae?ve[F]:0;let me;!G&&oe?me=0:me=S(ue,fe,V,q,Z,X),me&&G+me>=H&&(Q||oe||q.startsWith(O,Z))?(ve[ee]=X+1,he[ee]=G+me):(ve[ee]=E,he[ee]=H)}}const ne=[];let pe=x-1,be=Y-1;for(;pe>=0&&be>=0;){const ke=pe*Y+be;ve[ke]===E||(ne.push(be),pe--),be--}return[he[x*Y-1],ne.reverse()]}function S(z,O,x,V,q,Y){let Q=0;if(!T(O,V[q]))return Q;if(Q+=1,Y>0&&(Q+=Y*5),z===x[q]&&(Q+=1),q===0)Q+=8;else{const he=w(x.charCodeAt(q-1));he?Q+=he:(0,t.isUpper)(x.charCodeAt(q))&&Y===0&&(Q+=2)}return Q}function T(z,O){return z===O?!0:z==="/"||z==="\\"?O==="/"||O==="\\":!1}function w(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function v(z,O,x=0,V=0){const q=O;return q.values&&q.values.length>1?d(z,q.values,x,V):p(z,O,x,V)}e.scoreFuzzy2=v;function d(z,O,x,V){let q=0;const Y=[];for(const Q of O){const[he,ve]=p(z,Q,x,V);if(typeof he!="number")return b;q+=he,Y.push(...ve)}return[q,h(Y)]}function p(z,O,x,V){const q=(0,t.fuzzyScore)(O.original,O.originalLowercase,x,z,z.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,t.createMatches)(q)]:b}const f=Object.freeze({score:0}),a=1<<18,g=1<<17,s=1<<16;function u(z,O,x,V){const q=V.values?V.values:[V];return(0,D.hash)({[V.normalized]:{values:q.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:z,description:O,allowNonContiguousMatches:x}})}function o(z,O,x,V,q){if(!z||!O.normalized)return f;const Y=V.getItemLabel(z);if(!Y)return f;const Q=V.getItemDescription(z),he=u(Y,Q,x,O),ve=q[he];if(ve)return ve;const ne=i(Y,Q,V.getItemPath(z),O,x);return q[he]=ne,ne}e.scoreItemFuzzy=o;function i(z,O,x,V,q){const Y=!x||!V.containsPathSeparator;return x&&(_.isLinux?V.pathNormalized===x:(0,y.equalsIgnoreCase)(V.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:z.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:V.values&&V.values.length>1?r(z,O,x,V.values,Y,q):n(z,O,x,V,Y,q)}function r(z,O,x,V,q,Y){let Q=0;const he=[],ve=[];for(const ne of V){const{score:pe,labelMatch:be,descriptionMatch:ke}=n(z,O,x,ne,q,Y);if(pe===E)return f;Q+=pe,be&&he.push(...be),ke&&ve.push(...ke)}return{score:Q,labelMatch:h(he),descriptionMatch:h(ve)}}function n(z,O,x,V,q,Y){if(q||!O){const[Q,he]=R(z,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(Q){const ve=(0,t.matchesPrefix)(V.normalized,z);let ne;return ve?(ne=g,ne+=Math.round(V.normalized.length/z.length*100)):ne=s,{score:ne+Q,labelMatch:ve||c(he)}}}if(O){let Q=O;x&&(Q=`${O}${P.sep}`);const he=Q.length,ve=`${Q}${z}`,[ne,pe]=R(ve,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(ne){const be=c(pe),ke=[],Le=[];return be.forEach(We=>{We.start<he&&We.end>he?(ke.push({start:0,end:We.end-he}),Le.push({start:We.start,end:he})):We.start>=he?ke.push({start:We.start-he,end:We.end-he}):Le.push(We)}),{score:ne,labelMatch:ke,descriptionMatch:Le}}}return f}function c(z){const O=[];if(!z)return O;let x;for(const V of z)x&&x.end===V?x.end+=1:(x={start:V,end:V+1},O.push(x));return O}function h(z){const O=z.sort((q,Y)=>q.start-Y.start),x=[];let V;for(const q of O)!V||!m(V,q)?(V=q,x.push(q)):(V.start=Math.min(V.start,q.start),V.end=Math.max(V.end,q.end));return x}function m(z,O){return!(z.end<O.start||O.end<z.start)}function C(z,O,x,V,q,Y){const Q=o(z,x,V,q,Y),he=o(O,x,V,q,Y),ve=Q.score,ne=he.score;if((ve===a||ne===a)&&ve!==ne)return ve===a?-1:1;if(ve>s||ne>s){if(ve!==ne)return ve>ne?-1:1;if(ve<g&&ne<g){const ue=U(Q.labelMatch,he.labelMatch);if(ue!==0)return ue}const We=q.getItemLabel(z)||"",oe=q.getItemLabel(O)||"";if(We.length!==oe.length)return We.length-oe.length}if(ve!==ne)return ve>ne?-1:1;const pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,be=Array.isArray(he.labelMatch)&&he.labelMatch.length>0;if(pe&&!be)return-1;if(be&&!pe)return 1;const ke=L(z,Q,q),Le=L(O,he,q);return ke&&Le&&ke!==Le?Le>ke?-1:1:B(z,O,x,q)}e.compareItemsByFuzzyScore=C;function L(z,O,x){let V=-1,q=-1;if(O.descriptionMatch&&O.descriptionMatch.length?V=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(V=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(q=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const Y=x.getItemDescription(z);Y&&(q+=Y.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(q=O.descriptionMatch[O.descriptionMatch.length-1].end);return q-V}function U(z,O){if(!z&&!O||(!z||!z.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!z||!z.length)return 1;const x=z[0].start,q=z[z.length-1].end-x,Y=O[0].start,he=O[O.length-1].end-Y;return q===he?0:he<q?1:-1}function B(z,O,x,V){const q=V.getItemLabel(z)||"",Y=V.getItemLabel(O)||"",Q=V.getItemDescription(z),he=V.getItemDescription(O),ve=q.length+(Q?Q.length:0),ne=Y.length+(he?he.length:0);if(ve!==ne)return ve-ne;const pe=V.getItemPath(z),be=V.getItemPath(O);return pe&&be&&pe.length!==be.length?pe.length-be.length:q!==Y?(0,l.compareAnything)(q,Y,x.normalized):Q&&he&&Q!==he?(0,l.compareAnything)(Q,he,x.normalized):pe&&be&&pe!==be?(0,l.compareAnything)(pe,be,x.normalized):0}function A(z){return z.startsWith('"')&&z.endsWith('"')}const M=" ";function $(z){typeof z!="string"&&(z="");const O=z.toLowerCase(),{pathNormalized:x,normalized:V,normalizedLowercase:q}=N(z),Y=x.indexOf(P.sep)>=0,Q=A(z);let he;const ve=z.split(M);if(ve.length>1)for(const ne of ve){const pe=A(ne),{pathNormalized:be,normalized:ke,normalizedLowercase:Le}=N(ne);ke&&(he||(he=[]),he.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Le,expectContiguousMatch:pe}))}return{original:z,originalLowercase:O,pathNormalized:x,normalized:V,normalizedLowercase:q,values:he,containsPathSeparator:Y,expectContiguousMatch:Q}}e.prepareQuery=$;function N(z){let O;_.isWindows?O=z.replace(/\//g,P.sep):O=z.replace(/\\/g,P.sep);const x=(0,y.stripWildcards)(O).replace(/\s|"/g,"");return{pathNormalized:O,normalized:x,normalizedLowercase:x.toLowerCase()}}function K(z){return Array.isArray(z)?$(z.map(O=>O.original).join(M)):$(z.original)}e.pieceToQuery=K}),define(De[36],Ie([1,0,17,18,31,25,9,11,8]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",S=/\//g;function T(x,V){switch(x){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${V?`|${R}${k}+`:""})*?`}}function w(x,V){if(!x)return[];const q=[];let Y=!1,Q=!1,he="";for(const ve of x){switch(ve){case V:if(!Y&&!Q){q.push(he),he="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}he+=ve}return he&&q.push(he),q}e.splitGlobAware=w;function b(x){if(!x)return"";let V="";const q=w(x,e.GLOB_SPLIT);if(q.every(Y=>Y===e.GLOBSTAR))V=".*";else{let Y=!1;q.forEach((Q,he)=>{if(Q===e.GLOBSTAR){if(Y)return;V+=T(2,he===q.length-1)}else{let ve=!1,ne="",pe=!1,be="";for(const ke of Q){if(ke!=="}"&&ve){ne+=ke;continue}if(pe&&(ke!=="]"||!be)){let Le;ke==="-"?Le=ke:(ke==="^"||ke==="!")&&!be?Le="^":ke===e.GLOB_SPLIT?Le="":Le=(0,E.escapeRegExpCharacters)(ke),be+=Le;continue}switch(ke){case"{":ve=!0;continue;case"[":pe=!0;continue;case"}":{V+=`(?:${w(ne,",").map(oe=>b(oe)).join("|")})`,ve=!1,ne="";break}case"]":{V+="["+be+"]",pe=!1,be="";break}case"?":V+=k;continue;case"*":V+=T(1);continue;default:V+=(0,E.escapeRegExpCharacters)(ke)}}he<q.length-1&&(q[he+1]!==e.GLOBSTAR||he+2<q.length)&&(V+=R)}Y=Q===e.GLOBSTAR})}return V}const v=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new P.LRUCache(1e4),u=function(){return!1},o=function(){return null};function i(x,V){if(!x)return o;let q;typeof x!="string"?q=x.pattern:q=x,q=q.trim();const Y=`${q}_${!!V.trimForExclusions}`;let Q=s.get(Y);if(Q)return r(Q,x);let he;return v.test(q)?Q=c(q.substr(4),q):(he=d.exec(n(q,V)))?Q=h(he[1],q):(V.trimForExclusions?f:p).test(q)?Q=m(q,V):(he=a.exec(n(q,V)))?Q=C(he[1].substr(1),q,!0):(he=g.exec(n(q,V)))?Q=C(he[1],q,!1):Q=L(q),s.set(Y,Q),r(Q,x)}function r(x,V){if(typeof V=="string")return x;const q=function(Y,Q){return(0,D.isEqualOrParent)(Y,V.base,!y.isLinux)?x(Y.substr(V.base.length+1),Q):null};return q.allBasenames=x.allBasenames,q.allPaths=x.allPaths,q.basenames=x.basenames,q.patterns=x.patterns,q}function n(x,V){return V.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function c(x,V){return function(q,Y){return typeof q=="string"&&q.endsWith(x)?V:null}}function h(x,V){const q=`/${x}`,Y=`\\${x}`,Q=function(ve,ne){return typeof ve!="string"?null:ne?ne===x?V:null:ve===x||ve.endsWith(q)||ve.endsWith(Y)?V:null},he=[x];return Q.basenames=he,Q.patterns=[V],Q.allBasenames=he,Q}function m(x,V){const q=z(x.slice(1,-1).split(",").map(ne=>i(ne,V)).filter(ne=>ne!==o),x),Y=q.length;if(!Y)return o;if(Y===1)return q[0];const Q=function(ne,pe){for(let be=0,ke=q.length;be<ke;be++)if(q[be](ne,pe))return x;return null},he=q.find(ne=>!!ne.allBasenames);he&&(Q.allBasenames=he.allBasenames);const ve=q.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Q.allPaths=ve),Q}function C(x,V,q){const Y=_.sep===_.posix.sep,Q=Y?x:x.replace(S,_.sep),he=_.sep+Q,ve=_.posix.sep+x;let ne;return q?ne=function(pe,be){return typeof pe=="string"&&(pe===Q||pe.endsWith(he)||!Y&&(pe===x||pe.endsWith(ve)))?V:null}:ne=function(pe,be){return typeof pe=="string"&&(pe===Q||!Y&&pe===x)?V:null},ne.allPaths=[(q?"*/":"./")+x],ne}function L(x){try{const V=new RegExp(`^${b(x)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?x:null}}catch{return o}}function U(x,V,q){return!x||typeof V!="string"?!1:B(x)(V,void 0,q)}e.match=U;function B(x,V={}){if(!x)return u;if(typeof x=="string"||A(x)){const q=i(x,V);if(q===o)return u;const Y=function(Q,he){return!!q(Q,he)};return q.allBasenames&&(Y.allBasenames=q.allBasenames),q.allPaths&&(Y.allPaths=q.allPaths),Y}return N(x,V)}e.parse=B;function A(x){const V=x;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=A;function M(x){return x.allBasenames||[]}e.getBasenameTerms=M;function $(x){return x.allPaths||[]}e.getPathTerms=$;function N(x,V){const q=z(Object.getOwnPropertyNames(x).map(ne=>K(ne,x[ne],V)).filter(ne=>ne!==o)),Y=q.length;if(!Y)return o;if(!q.some(ne=>!!ne.requiresSiblings)){if(Y===1)return q[0];const ne=function(ke,Le){let We;for(let oe=0,ue=q.length;oe<ue;oe++){const fe=q[oe](ke,Le);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(We||(We=[]),We.push(fe))}return We?(async()=>{for(const oe of We){const ue=await oe;if(typeof ue=="string")return ue}return null})():null},pe=q.find(ke=>!!ke.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const be=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return be.length&&(ne.allPaths=be),ne}const Q=function(ne,pe,be){let ke,Le;for(let We=0,oe=q.length;We<oe;We++){const ue=q[We];ue.requiresSiblings&&be&&(pe||(pe=(0,_.basename)(ne)),ke||(ke=pe.substr(0,pe.length-(0,_.extname)(ne).length)));const fe=ue(ne,pe,ke,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Le||(Le=[]),Le.push(fe))}return Le?(async()=>{for(const We of Le){const oe=await We;if(typeof oe=="string")return oe}return null})():null},he=q.find(ne=>!!ne.allBasenames);he&&(Q.allBasenames=he.allBasenames);const ve=q.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Q.allPaths=ve),Q}function K(x,V,q){if(V===!1)return o;const Y=i(x,q);if(Y===o)return o;if(typeof V=="boolean")return Y;if(V){const Q=V.when;if(typeof Q=="string"){const he=(ve,ne,pe,be)=>{if(!be||!Y(ve,ne))return null;const ke=Q.replace("$(basename)",pe),Le=be(ke);return(0,t.isThenable)(Le)?Le.then(We=>We?x:null):Le?x:null};return he.requiresSiblings=!0,he}}return Y}function z(x,V){const q=x.filter(ne=>!!ne.basenames);if(q.length<2)return x;const Y=q.reduce((ne,pe)=>{const be=pe.basenames;return be?ne.concat(be):ne},[]);let Q;if(V){Q=[];for(let ne=0,pe=Y.length;ne<pe;ne++)Q.push(V)}else Q=q.reduce((ne,pe)=>{const be=pe.patterns;return be?ne.concat(be):ne},[]);const he=function(ne,pe){if(typeof ne!="string")return null;if(!pe){let ke;for(ke=ne.length;ke>0;ke--){const Le=ne.charCodeAt(ke-1);if(Le===47||Le===92)break}pe=ne.substr(ke)}const be=Y.indexOf(pe);return be!==-1?Q[be]:null};he.basenames=Y,he.patterns=Q,he.allBasenames=Y;const ve=x.filter(ne=>!ne.basenames);return ve.push(he),ve}function O(x,V){return(0,l.equals)(x,V,(q,Y)=>typeof q=="string"&&typeof Y=="string"?q===Y:typeof q!="string"&&typeof Y!="string"?q.base===Y.base&&q.pattern===Y.pattern:!1)}e.patternsEquals=O}),define(De[105],Ie([1,0,10,156,22,8,2]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",p=!1){if(this.value=d,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(d,p=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(f,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,p){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(d,p,f){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(d),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(d,p){const f=new RegExp((0,P.escapeRegExpCharacters)(p),"g");return d.replace(f,(a,g)=>d.charAt(g-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=E;function I(v){return R(v)?!v.value:Array.isArray(v)?v.every(I):!0}e.isEmptyMarkdownString=I;function R(v){return v instanceof E?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(v,d){return v===d?!0:!v||!d?!1:v.value===d.value&&v.isTrusted===d.isTrusted&&v.supportThemeIcons===d.supportThemeIcons&&v.supportHtml===d.supportHtml&&(v.baseUri===d.baseUri||!!v.baseUri&&!!d.baseUri&&(0,D.isEqual)(_.URI.from(v.baseUri),_.URI.from(d.baseUri)))}e.markdownStringEqual=k;function S(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function T(v){return v.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function w(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function b(v){const d=[],p=v.split("|").map(a=>a.trim());v=p[0];const f=p[1];if(f){const a=/height=(\d+)/.exec(f),g=/width=(\d+)/.exec(f),s=a?a[1]:"",u=g?g[1]:"",o=isFinite(parseInt(u)),i=isFinite(parseInt(s));o&&d.push(`width="${u}"`),i&&d.push(`height="${s}"`)}return{href:v,dimensions:d}}e.parseHrefAndDimensions=b}),define(De[106],Ie([1,0,17,31,9,11,22,8]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(o,i){const{os:r,tildify:n,relative:c}=i;if(c){const C=I(o,c,r);if(typeof C=="string")return C}let h=o.fsPath;if(r===1&&!P.isWindows?h=h.replace(/\//g,"\\"):r!==1&&P.isWindows&&(h=h.replace(/\\/g,"/")),r!==1&&n?.userHome){const C=n.userHome.fsPath;let L;o.scheme!==n.userHome.scheme&&o.path.startsWith(D.posix.sep)?L=n.userHome.with({path:o.path}).fsPath:L=o.fsPath,h=S(L,C,r)}return(r===1?D.win32:D.posix).normalize(R(h,r===1))}e.getPathLabel=E;function I(o,i,r){const n=r===1?D.win32:D.posix,c=r===3?_.extUri:_.extUriIgnorePathCase,h=i.getWorkspace(),m=(0,l.firstOrDefault)(h.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(D.posix.sep)&&(o=m.uri.with({path:o.path}));const C=i.getWorkspaceFolder(o);if(!C)return;let L;if(c.isEqual(C.uri,o)?L="":L=c.relativePath(C.uri,o)??"",L&&(L=n.normalize(L)),h.folders.length>1&&!i.noPrefix){const U=C.name?C.name:c.basenameOrAuthority(C.uri);L=L?`${U} \u2022 ${L}`:U}return L}function R(o,i=P.isWindows){return(0,t.hasDriveLetter)(o,i)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=R;let k=Object.create(null);function S(o,i,r=P.OS){if(r===1||!o||!i)return o;let n=k.original===i?k.normalized:void 0;n||(n=i,P.isWindows&&(n=(0,t.toSlashes)(n)),n=`${(0,y.rtrim)(n,D.posix.sep)}${D.posix.sep}`,k={original:i,normalized:n});let c=o;return P.isWindows&&(c=(0,t.toSlashes)(c)),(r===3?c.startsWith(n):(0,y.startsWithIgnoreCase)(c,n))?`~/${c.substr(n.length)}`:o}e.tildify=S;function T(o,i){return o.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const w="\u2026",b="\\\\",v="~";function d(o,i=D.sep){const r=new Array(o.length);let n=!1;for(let c=0;c<o.length;c++){const h=o[c];if(h===""){r[c]=`.${i}`;continue}if(!h){r[c]=h;continue}n=!0;let m="",C=h;C.indexOf(b)===0?(m=C.substr(0,C.indexOf(b)+b.length),C=C.substr(C.indexOf(b)+b.length)):C.indexOf(i)===0?(m=C.substr(0,C.indexOf(i)+i.length),C=C.substr(C.indexOf(i)+i.length)):C.indexOf(v)===0&&(m=C.substr(0,C.indexOf(v)+v.length),C=C.substr(C.indexOf(v)+v.length));const L=C.split(i);for(let U=1;n&&U<=L.length;U++)for(let B=L.length-U;n&&B>=0;B--){n=!1;let A=L.slice(B,B+U).join(i);for(let M=0;!n&&M<o.length;M++)if(M!==c&&o[M]&&o[M].indexOf(A)>-1){const $=B+U===L.length,N=B>0&&o[M].indexOf(i)>-1?i+A:A,K=o[M].endsWith(N);n=!$||K}if(!n){let M="";(L[0].endsWith(":")||m!=="")&&(B===1&&(B=0,U++,A=L[0]+i+A),B>0&&(M=L[0]+i),M=m+M),B>0&&(M=M+w+i),M=M+A,B+U<L.length&&(M=M+i+w),r[c]=M}}n&&(r[c]=h)}return r}e.shorten=d;var p;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function f(o,i=Object.create(null)){const r=[];let n=!1,c="";for(const h of o)if(h==="$"||n&&h==="{")c&&r.push({value:c,type:p.TEXT}),c="",n=!0;else if(h==="}"&&n){const m=i[c];if(typeof m=="string")m.length&&r.push({value:m,type:p.VARIABLE});else if(m){const C=r[r.length-1];(!C||C.type!==p.SEPARATOR)&&r.push({value:m.label,type:p.SEPARATOR})}c="",n=!1}else c+=h;return c&&!n&&r.push({value:c,type:p.TEXT}),r.filter((h,m)=>{if(h.type===p.SEPARATOR){const C=r[m-1],L=r[m+1];return[C,L].every(U=>U&&(U.type===p.VARIABLE||U.type===p.TEXT)&&U.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=f;function a(o,i){return P.isMacintosh||i?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):o.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function g(o,i){return P.isMacintosh||i?o.replace(/\(&&\w\)|&&/g,""):P.isWindows?o.replace(/&&|&/g,r=>r==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(o){const i=o.indexOf("/")!==-1?D.posix:D.win32,r=i.basename(o),n=i.dirname(o);return r.length?{name:r,parentPath:n}:{name:n,parentPath:""}}e.splitName=u}),define(De[107],Ie([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const S=this._uriTransformer.transformIncoming(k);return S===k?k:t(l.URI.from(S))}transformOutgoing(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:t(l.URI.from(S))}transformOutgoingURI(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:l.URI.from(S)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,k,S){if(!R||S>200)return null;if(typeof R=="object"){if(R instanceof l.URI)return k.transformOutgoing(R);for(const T in R)if(Object.hasOwnProperty.call(R,T)){const w=P(R[T],k,S+1);w!==null&&(R[T]=w)}}return null}function _(R,k){const S=P(R,k,0);return S===null?R:S}e.transformOutgoingURIs=_;function y(R,k,S,T){if(!R||T>200)return null;if(typeof R=="object"){if(R.$mid===1)return S?l.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const w in R)if(Object.hasOwnProperty.call(R,w)){const b=y(R[w],k,S,T+1);b!==null&&(R[w]=b)}}return null}function E(R,k){const S=y(R,k,!1,0);return S===null?R:S}e.transformIncomingURIs=E;function I(R,k){const S=y(R,k,!0,0);return S===null?R:S}e.transformAndReviveIncomingURIs=I}),define(De[29],Ie([1,0,63,81,301,18,31,80,9,11,22,2]),function(J,e,l,t,D,P,_,y,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function T(N,K=S.UNLINK){if((0,_.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return K===S.UNLINK?b(N):w(N)}async function w(N){try{const K=(0,_.randomPath)((0,t.tmpdir)());try{await l.promises.rename(N,K)}catch{return b(N)}b(K).catch(z=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function b(N){return(0,D.promisify)(l.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function v(N){if((0,_.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function d(N,K){return a(await(K?p(N):(0,D.promisify)(l.readdir)(N)))}async function p(N){try{return await(0,D.promisify)(l.readdir)(N,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const K=[],z=await d(N);for(const O of z){let x=!1,V=!1,q=!1;try{const Y=await e.Promises.lstat((0,E.join)(N,O));x=Y.isFile(),V=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}K.push({name:O,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>q})}return K}function f(N){return a(l.readdirSync(N))}e.readdirSync=f;function a(N){return N.map(K=>typeof K=="string"?I.isMacintosh?(0,y.normalizeNFC)(K):K:(K.name=I.isMacintosh?(0,y.normalizeNFC)(K.name):K.name,K))}async function g(N){const K=await d(N),z=[];for(const O of K)await u.existsDirectory((0,E.join)(N,O))&&z.push(O);return z}function s(N,K=1e3){return new Promise(z=>{let O=!1;const x=setInterval(()=>{O||(O=!0,l.access(N,V=>{O=!1,V&&(clearInterval(x),z(void 0))}))},K)})}e.whenDeleted=s;var u;(function(N){async function K(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Y}throw q}}N.stat=K;async function z(x){try{const{stat:V,symbolicLink:q}=await N.stat(x);return V.isFile()&&q?.dangling!==!0}catch{}return!1}N.existsFile=z;async function O(x){try{const{stat:V,symbolicLink:q}=await N.stat(x);return V.isDirectory()&&q?.dangling!==!0}catch{}return!1}N.existsDirectory=O})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function i(N,K,z){return o.queueFor(k.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const O=m(z);return new Promise((x,V)=>c(N,K,O,q=>q?V(q):x()))})}let r=!0;function n(N){r=N}e.configureFlushOnWrite=n;function c(N,K,z,O){if(!r)return l.writeFile(N,K,{mode:z.mode,flag:z.flag},O);l.open(N,z.flag,z.mode,(x,V)=>{if(x)return O(x);l.writeFile(V,K,q=>{if(q)return l.close(V,()=>O(q));l.fdatasync(V,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),n(!1)),l.close(V,Q=>O(Q))))})})}function h(N,K,z){const O=m(z);if(!r)return l.writeFileSync(N,K,{mode:O.mode,flag:O.flag});const x=l.openSync(N,O.flag,O.mode);try{l.writeFileSync(x,K);try{l.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),n(!1)}}finally{l.closeSync(x)}}e.writeFileSync=h;function m(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function C(N,K){if(N!==K)try{await e.Promises.rename(N,K)}catch(z){if(N.toLowerCase()!==K.toLowerCase()&&z.code==="EXDEV"||N.endsWith("."))await L(N,K,{preserveSymlinks:!1}),await T(N,S.MOVE);else throw z}}async function L(N,K,z){return B(N,K,{root:{source:N,target:K},options:z,handledSourcePaths:new Set})}const U=511;async function B(N,K,z){if(z.handledSourcePaths.has(N))return;z.handledSourcePaths.add(N);const{stat:O,symbolicLink:x}=await u.stat(N);if(x){if(z.options.preserveSymlinks)try{return await $(N,K,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return O.isDirectory()?A(N,K,O.mode&U,z):M(N,K,O.mode&U)}async function A(N,K,z,O){await e.Promises.mkdir(K,{recursive:!0,mode:z});const x=await d(N);for(const V of x)await B((0,E.join)(N,V),(0,E.join)(K,V),O)}async function M(N,K,z){await e.Promises.copyFile(N,K),await e.Promises.chmod(K,z)}async function $(N,K,z){let O=await e.Promises.readlink(N);(0,_.isEqualOrParent)(O,z.root.source,!I.isLinux)&&(O=(0,E.join)(z.root.target,O.substr(z.root.source.length+1))),await e.Promises.symlink(O,K)}e.Promises=new class{get access(){return(0,D.promisify)(l.access)}get stat(){return(0,D.promisify)(l.stat)}get lstat(){return(0,D.promisify)(l.lstat)}get utimes(){return(0,D.promisify)(l.utimes)}get read(){return(N,K,z,O,x)=>new Promise((V,q)=>{l.read(N,K,z,O,x,(Y,Q,he)=>Y?q(Y):V({bytesRead:Q,buffer:he}))})}get readFile(){return(0,D.promisify)(l.readFile)}get write(){return(N,K,z,O,x)=>new Promise((V,q)=>{l.write(N,K,z,O,x,(Y,Q,he)=>Y?q(Y):V({bytesWritten:Q,buffer:he}))})}get appendFile(){return(0,D.promisify)(l.appendFile)}get fdatasync(){return(0,D.promisify)(l.fdatasync)}get truncate(){return(0,D.promisify)(l.truncate)}get rename(){return(0,D.promisify)(l.rename)}get copyFile(){return(0,D.promisify)(l.copyFile)}get open(){return(0,D.promisify)(l.open)}get close(){return(0,D.promisify)(l.close)}get symlink(){return(0,D.promisify)(l.symlink)}get readlink(){return(0,D.promisify)(l.readlink)}get chmod(){return(0,D.promisify)(l.chmod)}get mkdir(){return(0,D.promisify)(l.mkdir)}get unlink(){return(0,D.promisify)(l.unlink)}get rmdir(){return(0,D.promisify)(l.rmdir)}get realpath(){return(0,D.promisify)(l.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return g}get writeFile(){return i}get rm(){return T}get move(){return C}get copy(){return L}}}),define(De[108],Ie([1,0,63,9,11,8,29]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(S){if(D.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const w=((0,t.basename)(S)||S).toLowerCase();try{const v=(0,_.readdirSync)(T).filter(d=>d.toLowerCase()===w);if(v.length===1){const d=y(T);if(d)return(0,t.join)(d,v[0])}else if(v.length>1){const d=v.indexOf(w);if(d>=0){const p=y(T);if(p)return(0,t.join)(p,v[d])}}}catch{}return null}e.realcaseSync=y;async function E(S){if(D.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const w=((0,t.basename)(S)||S).toLowerCase();try{const v=(await _.Promises.readdir(T)).filter(d=>d.toLowerCase()===w);if(v.length===1){const d=await E(T);if(d)return(0,t.join)(d,v[0])}else if(v.length>1){const d=v.indexOf(w);if(d>=0){const p=await E(T);if(p)return(0,t.join)(p,v[d])}}}catch{}return null}e.realcase=E;async function I(S){try{return await _.Promises.realpath(S)}catch{const w=k(S);return await _.Promises.access(w,l.constants.R_OK),w}}e.realpath=I;function R(S){try{return l.realpathSync(S)}catch{const w=k(S);return l.accessSync(w,l.constants.R_OK),w}}e.realpathSync=R;function k(S){return(0,P.rtrim)((0,t.normalize)(S),t.sep)}}),define(De[109],Ie([1,0,9,11,40,101,13,29]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function E(k=D.env){return k.comspec||"cmd.exe"}e.getWindowsShell=E;function I(k){let S=[],T=!1;const w=function(b){if(T){S.push(b);return}(!k.send(b,d=>{if(d&&console.error(d),T=!1,S.length>0){const p=S.slice(0);S=[],p.forEach(f=>w(f))}})||t.isWindows)&&(T=!0)};return{send:w}}e.createQueuedSender=I;var R;(function(k){async function S(T,w,b){if(l.isAbsolute(T))return T;if(w===void 0&&(w=D.cwd()),l.dirname(T)!=="."||(b===void 0&&_.isString(D.env.PATH)&&(b=D.env.PATH.split(l.delimiter)),b===void 0||b.length===0))return l.join(w,T);async function d(p){if(await y.Promises.exists(p)){let f;try{f=await y.Promises.stat(p)}catch(a){a.message.startsWith("EACCES")&&(f=await y.Promises.lstat(p))}return f?!f.isDirectory():!1}return!1}for(const p of b){let f;if(l.isAbsolute(p)?f=l.join(p,T):f=l.join(w,p,T),await d(f))return f;let a=f+".com";if(await d(a)||(a=f+".exe",await d(a)))return a}return l.join(w,T)}k.findExecutable=S})(R=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(J,e,l,t){var D=arguments.length,P=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var y=J.length-1;y>=0;y--)(_=J[y])&&(P=(D<3?_(P):D>3?_(e,l,P):_(e,l))||P);return D>3&&P&&Object.defineProperty(e,l,P),P};define(De[110],Ie([1,0,17,18,23,21,58,10,4,6,62,8,13]),function(J,e,l,t,D,P,_,y,E,I,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function w(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function v(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(d||(d={}));class p{constructor(V){this.buffer=V,this.pos=0}read(V){const q=this.buffer.slice(this.pos,this.pos+V);return this.pos+=q.byteLength,q}}class f{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(a||(a={}));function g(x){const V=D.VSBuffer.alloc(4);return V.writeUInt32BE(x,0),V}function s(x){return x.read(4).readUInt32BE(0)}function u(x){const V=D.VSBuffer.alloc(1);return V.writeUInt8(x,0),V}const o={Undefined:u(a.Undefined),String:u(a.String),Buffer:u(a.Buffer),VSBuffer:u(a.VSBuffer),Array:u(a.Array),Object:u(a.Object)},i=typeof Buffer<"u";function r(x,V){if(typeof V>"u")x.write(o.Undefined);else if(typeof V=="string"){const q=D.VSBuffer.fromString(V);x.write(o.String),x.write(g(q.byteLength)),x.write(q)}else if(i&&Buffer.isBuffer(V)){const q=D.VSBuffer.wrap(V);x.write(o.Buffer),x.write(g(q.byteLength)),x.write(q)}else if(V instanceof D.VSBuffer)x.write(o.VSBuffer),x.write(g(V.byteLength)),x.write(V);else if(Array.isArray(V)){x.write(o.Array),x.write(g(V.length));for(const q of V)r(x,q)}else{const q=D.VSBuffer.fromString(JSON.stringify(V));x.write(o.Object),x.write(g(q.byteLength)),x.write(q)}}function n(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(s(x)).toString();case a.Buffer:return x.read(s(x)).buffer;case a.VSBuffer:return x.read(s(x));case a.Array:{const q=s(x),Y=[];for(let Q=0;Q<q;Q++)Y.push(n(x));return Y}case a.Object:return JSON.parse(x.read(s(x)).toString())}}class c{constructor(V,q,Y=null,Q=1e3){this.protocol=V,this.ctx=q,this.logger=Y,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(he=>this.onRawMessage(he)),this.sendResponse({type:200})}registerChannel(V,q){this.channels.set(V,q),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const q=this.send([V.type]);this.logger?.logOutgoing(q,0,1,v(V.type));return}case 201:case 202:case 204:case 203:{const q=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(q,V.id,1,v(V.type),V.data);return}}}send(V,q=void 0){const Y=new f;return r(Y,V),r(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const q=new p(V),Y=n(q),Q=n(q),he=Y[0];switch(he){case 100:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${w(he)}: ${Y[2]}.${Y[3]}`,Q),this.onPromise({type:he,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 102:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${w(he)}: ${Y[2]}.${Y[3]}`,Q),this.onEventListen({type:he,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 101:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${w(he)}`),this.disposeActiveRequest({type:he,id:Y[1]});case 103:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${w(he)}`),this.disposeActiveRequest({type:he,id:Y[1]})}}onPromise(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=new P.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,V.name,V.arg,Y.token)}catch(ne){Q=Promise.reject(ne)}const he=V.id;Q.then(ne=>{this.sendResponse({id:he,data:ne,type:201}),this.activeRequests.delete(V.id)},ne=>{ne instanceof Error?this.sendResponse({id:he,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:he,data:ne,type:203}),this.activeRequests.delete(V.id)});const ve=(0,I.toDisposable)(()=>Y.cancel());this.activeRequests.set(V.id,ve)}onEventListen(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=V.id,he=q.listen(this.ctx,V.name,V.arg)(ve=>this.sendResponse({id:Y,data:ve,type:204}));this.activeRequests.set(V.id,he)}disposeActiveRequest(V){const q=this.activeRequests.get(V.id);q&&(q.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let q=this.pendingRequests.get(V.channelName);q||(q=[],this.pendingRequests.set(V.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:V,timeoutTimer:Y})}flushPendingRequests(V){const q=this.pendingRequests.get(V);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(V,q=null){this.protocol=V,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=q}getChannel(V){const q=this;return{call(Y,Q,he){return q.isDisposed?Promise.reject(new y.CancellationError):q.requestPromise(V,Y,Q,he)},listen(Y,Q){return q.isDisposed?E.Event.None:q.requestEvent(V,Y,Q)}}}requestPromise(V,q,Y,Q=P.CancellationToken.None){const he=this.lastRequestId++,ne={id:he,type:100,channelName:V,name:q,arg:Y};if(Q.isCancellationRequested)return Promise.reject(new y.CancellationError);let pe;return new Promise((ke,Le)=>{if(Q.isCancellationRequested)return Le(new y.CancellationError);const We=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(he),ke(ae.data);break;case 202:{this.handlers.delete(he);const ee=new Error(ae.data.message);ee.stack=ae.data.stack,ee.name=ae.data.name,Le(ee);break}case 203:this.handlers.delete(he),Le(ae.data);break}};this.handlers.set(he,Z),this.sendRequest(ne)};let oe=null;this.state===d.Idle?We():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,We()}));const ue=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:he,type:101}),Le(new y.CancellationError)},fe=Q.onCancellationRequested(ue);pe=(0,I.combinedDisposable)((0,I.toDisposable)(ue),fe),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent(V,q,Y){const Q=this.lastRequestId++,ve={id:Q,type:102,channelName:V,name:q,arg:Y};let ne=null;const pe=new E.Emitter({onFirstListenerAdd:()=>{ne=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(pe),this.sendRequest(ve)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(pe),this.sendRequest({id:Q,type:103}))}}),be=ke=>pe.fire(ke.data);return this.handlers.set(Q,be),pe.event}sendRequest(V){switch(V.type){case 100:case 102:{const q=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(q,V.id,0,`${w(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const q=this.send([V.type,V.id]);this.logger?.logOutgoing(q,V.id,0,w(V.type));return}}}send(V,q=void 0){const Y=new f;return r(Y,V),r(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const q=new p(V),Y=n(q),Q=n(q),he=Y[0];switch(he){case 200:return this.logger?.logIncoming(V.byteLength,0,0,v(he)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,Y[1],0,v(he),Q),this.onResponse({type:Y[0],id:Y[1],data:Q})}}onResponse(V){if(V.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}qe([_.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class C{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:q,onDidClientDisconnect:Y})=>{E.Event.once(q.onMessage)(he=>{const ve=new p(he),ne=n(ve),pe=new c(q,ne),be=new m(q);this.channels.forEach((Le,We)=>pe.registerChannel(We,Le));const ke={channelServer:pe,channelClient:be,ctx:ne};this._connections.add(ke),this._onDidAddConnection.fire(ke),Y(()=>{pe.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const V=[];return this._connections.forEach(q=>V.push(q)),V}getChannel(V,q){const Y=this;return{call(Q,he,ve){let ne;if((0,S.isFunction)(q)){const be=(0,l.getRandomElement)(Y.connections.filter(q));ne=be?Promise.resolve(be):E.Event.toPromise(E.Event.filter(Y.onDidAddConnection,q))}else ne=q.routeCall(Y,Q,he);const pe=ne.then(be=>be.channelClient.getChannel(V));return U(pe).call(Q,he,ve)},listen(Q,he){if((0,S.isFunction)(q))return Y.getMulticastEvent(V,q,Q,he);const ve=q.routeEvent(Y,Q,he).then(ne=>ne.channelClient.getChannel(V));return U(ve).listen(Q,he)}}}getMulticastEvent(V,q,Y,Q){const he=this;let ve=new I.DisposableStore;const ne=new E.Emitter({onFirstListenerAdd:()=>{ve=new I.DisposableStore;const pe=new E.EventMultiplexer,be=new Map,ke=We=>{const ue=We.channelClient.getChannel(V).listen(Y,Q),fe=pe.add(ue);be.set(We,fe)},Le=We=>{const oe=be.get(We);!oe||(oe.dispose(),be.delete(We))};he.connections.filter(q).forEach(ke),E.Event.filter(he.onDidAddConnection,q)(ke,void 0,ve),he.onDidRemoveConnection(Le,void 0,ve),pe.event(ne.fire,ne,ve),ve.add(pe)},onLastListenerRemove:()=>{ve.dispose()}});return ne.event}registerChannel(V,q){this.channels.set(V,q),this._connections.forEach(Y=>{Y.channelServer.registerChannel(V,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class L{constructor(V,q,Y=null){const Q=new f;r(Q,q),V.send(Q.buffer),this.channelClient=new m(V,Y),this.channelServer=new c(V,q,Y)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,q){this.channelServer.registerChannel(V,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function U(x){return{call(V,q,Y){return x.then(Q=>Q.call(V,q,Y))},listen(V,q){const Y=new E.Relay;return x.then(Q=>Y.input=Q.listen(V,q)),Y.event}}}e.getDelayedChannel=U;function B(x){let V=!1;return{call(q,Y,Q){return V?x.call(q,Y,Q):(0,t.timeout)(0).then(()=>V=!0).then(()=>x.call(q,Y,Q))},listen(q,Y){if(V)return x.listen(q,Y);const Q=new E.Relay;return(0,t.timeout)(0).then(()=>V=!0).then(()=>Q.input=x.listen(q,Y)),Q.event}}}e.getNextTickChannel=B;class A{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const q of V.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=A;var M;(function(x){function V(he,ve){const ne=he,pe=ve&&ve.disableMarshalling,be=new Map;for(const ke in ne)Y(ke)&&be.set(ke,E.Event.buffer(ne[ke],!0));return new class{listen(ke,Le,We){const oe=be.get(Le);if(oe)return oe;if(Q(Le)){const ue=ne[Le];if(typeof ue=="function")return ue.call(ne,We)}throw new Error(`Event not found: ${Le}`)}call(ke,Le,We){const oe=ne[Le];if(typeof oe=="function"){if(!pe&&Array.isArray(We))for(let ue=0;ue<We.length;ue++)We[ue]=(0,R.revive)(We[ue]);return oe.apply(ne,We)}throw new Error(`Method not found: ${Le}`)}}}x.fromService=V;function q(he,ve){const ne=ve&&ve.disableMarshalling;return new Proxy({},{get(pe,be){if(typeof be=="string")return ve?.properties?.has(be)?ve.properties.get(be):Q(be)?function(ke){return he.listen(be,ke)}:Y(be)?he.listen(be):async function(...ke){let Le;ve&&!(0,S.isUndefinedOrNull)(ve.context)?Le=[ve.context,...ke]:Le=ke;const We=await he.call(be,Le);return ne?We:(0,R.revive)(We)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=q;function Y(he){return he[0]==="o"&&he[1]==="n"&&k.isUpperAsciiLetter(he.charCodeAt(2))}function Q(he){return/^onDynamic/.test(he)&&k.isUpperAsciiLetter(he.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const V=x.toString();if(V!=="[object Object]")return V}return x}function K(x){return Array.isArray(x)?x.map(N):N(x)}function z(x,V,q,Y,Q,he,ve){ve=K(ve);const ne=$[Q],pe=ne[Y%ne.length];let be=[`%c[${x}]%c[${String(V).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${he}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(he)?(be=be.concat(ve),be.push(")")):be.push(ve),console.log.apply(console,be)}e.logWithColors=z;class O{constructor(V,q){this._outgoingPrefix=V,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,q,Y,Q,he){this._totalOutgoing+=V,z(this._outgoingPrefix,this._totalOutgoing,V,q,Y,Q,he)}logIncoming(V,q,Y,Q,he){this._totalIncoming+=V,z(this._incomingPrefix,this._totalIncoming,V,q,Y,Q,he)}}e.IPCLogger=O}),define(De[111],Ie([1,0,23,4,6,110]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(_=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let n=0;function c(m,C){if(!r.has(m)){const L=String(++n);r.set(m,L)}return r.get(m)}function h(m,C,L,U){if(!i.enableDiagnostics)return;const B=c(m,C);if(U instanceof l.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const A=l.VSBuffer.alloc(U.byteLength);A.set(U),i.records.push({timestamp:Date.now(),id:B,label:C,type:L,buff:A})}else i.records.push({timestamp:Date.now(),id:B,label:C,type:L,data:U})}i.traceSocketEvent=h})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function R(){return I||(I=l.VSBuffer.alloc(0)),I}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,n){if(r===0)return R();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const C=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=r),C}if(this._chunks[0].byteLength>r){const C=this._chunks[0].slice(0,r);return n&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),C}const c=l.VSBuffer.alloc(r);let h=0,m=0;for(;r>0;){const C=this._chunks[m];if(C.byteLength>r){const L=C.slice(0,r);c.set(L,h),h+=r,n&&(this._chunks[m]=C.slice(r),this._totalLength-=r),r-=r}else c.set(C,h),h+=C.byteLength,n?(this._chunks.shift(),this._totalLength-=C.byteLength):m++,r-=C.byteLength}return c}}e.ChunkStream=k;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function T(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(r,n,c,h){this.type=r,this.id=n,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(r){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,h=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new b(c,h,m,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=l.VSBuffer.alloc(13);n.writeUInt8(r.type,0),n.writeUInt32BE(r.id,1),n.writeUInt32BE(r.ack,5),n.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(n,r.data)}_bufferAdd(r,n){const c=this._totalLength===0;return this._data.push(r,n),this._totalLength+=r.byteLength+n.byteLength,c}_bufferTake(){const r=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,n){this._bufferAdd(r,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class p extends D.Disposable{constructor(r){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new b(1,0,0,r))}}e.Protocol=p;class f extends P.IPCClient{constructor(r,n,c=null){super(r,n,c),this.protocol=r}static fromSocket(r,n){return new f(new p(r),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=f;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class g{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let r=0,n=this._first;for(;n;)n=n.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let n=0,c=this._first;for(;c;)r[n++]=c.data,c=c.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const n=new g(r);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class u{constructor(){this.lastRuns=[];const r=Date.now();for(let n=0;n<u._HISTORY_LENGTH;n++)this.lastRuns[n]=r-1e3*n;setInterval(()=>{for(let n=u._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const r=Date.now(),n=(1+u._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<u._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=n&&c++;return 1-c/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class o{constructor(r,n=null,c=u.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),n&&this._socketReader.acceptChunk(n),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new b(5,0,0,R());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new b(7,0,0,R());this._socketWriter.write(r)}sendResume(){const r=new b(8,0,0,R());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,n){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,R());this._socketWriter.write(r);const n=this._outgoingUnackMsg.toArray();for(let c=0,h=n.length;c<h;c++)this._socketWriter.write(n[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new b(6,0,0,R())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let c=0,h=n.length;c<h;c++)this._socketWriter.write(n[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new b(1,n,this._incomingAckId,r);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(r){const n=new b(2,0,0,r);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),n=Date.now()-r.writtenTime,c=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&c>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:n,timeSinceLastReceivedSomeData:c});return}const m=Math.max(2e4-n,2e4-c,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,R());this._socketWriter.write(r)}_sendKeepAlive(){const r=new b(9,0,0,R());this._socketWriter.write(r)}}e.PersistentProtocol=o}),define(De[112],Ie([1,0,23,10,4,6,9,11,34,110,111]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class S{constructor(c,h=""){this.debugLabel=h,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}traceSocketEvent(c,h){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,h)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const h=m=>{this.traceSocketEvent("read",m),c(l.VSBuffer.wrap(m))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(c){const h=m=>{this.traceSocketEvent("close",{hadError:m}),c({type:0,hadError:m,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(c){const h=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=S;var T;(function(n){n[n.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var w;(function(n){n[n.PeekHeader=1]="PeekHeader",n[n.ReadHeader=2]="ReadHeader",n[n.ReadBody=3]="ReadBody",n[n.Fin=4]="Fin"})(w||(w={}));class b extends P.Disposable{constructor(c,h,m,C){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:m?.byteLength||0,recordInflateBytes:C}),this._flowManager=this._register(new v(this,h,m,C,this._onData,(L,U)=>this._write(L,U))),this._register(this._flowManager.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,h){this.socket.traceSocketEvent(c,h)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,h){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let m=2;c.byteLength<126?m+=0:c.byteLength<2**16?m+=2:m+=8;const C=l.VSBuffer.alloc(m);if(h?C.writeUInt8(194,0):C.writeUInt8(130,0),c.byteLength<126)C.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){C.writeUInt8(126,1);let L=1;C.writeUInt8(c.byteLength>>>8&255,++L),C.writeUInt8(c.byteLength>>>0&255,++L)}else{C.writeUInt8(127,1);let L=1;C.writeUInt8(0,++L),C.writeUInt8(0,++L),C.writeUInt8(0,++L),C.writeUInt8(0,++L),C.writeUInt8(c.byteLength>>>24&255,++L),C.writeUInt8(c.byteLength>>>16&255,++L),C.writeUInt8(c.byteLength>>>8&255,++L),C.writeUInt8(c.byteLength>>>0&255,++L)}this.socket.write(l.VSBuffer.concat([C,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),m=h.readUInt8(0),C=(m&128)>>>7,L=(m&64)>>>6,U=h.readUInt8(1),B=(U&128)>>>7,A=U&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=C,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(C),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),m=h.readUInt8(1),C=(m&128)>>>7;let L=m&127,U=1;L===126?L=h.readUInt8(++U)*2**8+h.readUInt8(++U):L===127&&(L=h.readUInt8(++U)*0+h.readUInt8(++U)*0+h.readUInt8(++U)*0+h.readUInt8(++U)*0+h.readUInt8(++U)*2**24+h.readUInt8(++U)*2**16+h.readUInt8(++U)*2**8+h.readUInt8(++U));let B=0;C&&(B=h.readUInt8(++U)*2**24+h.readUInt8(++U)*2**16+h.readUInt8(++U)*2**8+h.readUInt8(++U)),this._state.state=3,this._state.readLen=L,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),f(h,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(h,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class v extends P.Disposable{constructor(c,h,m,C,L,U){super(),this._tracer=c,this._onData=L,this._writeFn=U,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,h?(this._zlibInflateStream=this._register(new d(this._tracer,C,m,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const h=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(h,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,h){return new Promise((m,C)=>{c.write(h),c.flush(L=>m(L))})}acceptFrame(c,h,m){this._readQueue.push({data:c,isCompressed:h,isLastFrameOfMessage:m}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const h=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(h)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,h,m){return new Promise((C,L)=>{c.write(h),m&&c.write(l.VSBuffer.fromByteArray([0,0,255,255])),c.flush(U=>C(U))})}}class d extends P.Disposable{constructor(c,h,m,C){super(),this._tracer=c,this._recordInflateBytes=h,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(C),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(l.VSBuffer.wrap(L))}),m&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const h=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(h)})}}class p extends P.Disposable{constructor(c,h){super(),this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",m=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this._onError.fire(m)}),this._zlibDeflate.on("data",m=>{this._tracer.traceSocketEvent("zlibDeflateData",m),this._pendingDeflateData.push(l.VSBuffer.wrap(m))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let h=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.byteLength-4),c(h)})}}function f(n,c){if(c===0)return;const h=n.byteLength>>>2;for(let A=0;A<h;A++){const M=n.readUInt32BE(A*4);n.writeUInt32BE(M^c,A*4)}const m=h*4,C=n.byteLength-m,L=c>>>24&255,U=c>>>16&255,B=c>>>8&255;C>=1&&n.writeUInt8(n.readUInt8(m)^L,m),C>=2&&n.writeUInt8(n.readUInt8(m+1)^U,m+1),C>=3&&n.writeUInt8(n.readUInt8(m+2)^B,m+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const a={[2]:107,[1]:103};function g(){const n=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${n}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${n}.sock`):c=(0,_.join)(k().os.tmpdir(),`vscode-ipc-${n}.sock`),u(c),c}e.createRandomIPCHandle=g;function s(n,c,h){const m=k().crypto.createHash("md5").update(n).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${h}-${c}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${h}-${c}.sock`):C=(0,_.join)(n,`${h}-${c}.sock`),u(C),C}e.createStaticIPCHandle=s;function u(n){const c=a[y.platform];typeof c=="number"&&n.length>=c&&console.warn(`WARNING: IPC handle "${n}" is longer than ${c} chars, try a shorter --user-data-dir`)}class o extends I.IPCServer{constructor(c){super(o.toClientConnectionEvent(c)),this.server=c}static toClientConnectionEvent(c){const h=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(h,m=>({protocol:new R.Protocol(new S(m,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function i(n){return new Promise((c,h)=>{const m=k().net.createServer();m.on("error",h),m.listen(n,()=>{m.removeListener("error",h),c(new o(m))})})}e.serve=i;function r(n,c){return new Promise((h,m)=>{const C=k().net.createConnection(n,()=>{C.removeListener("error",m),h(R.Client.fromSocket(new S(C,`ipc-client${c}`),c))});C.once("error",m)})}e.connect=r}),define(De[157],Ie([1,0,36,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(P,_,y,E,I,R){if(Array.isArray(P)){let k=0;for(const S of P){const T=D(S,_,y,E,I,R);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return E?P==="*"?5:P===y?10:0:0;if(P){const{language:k,pattern:S,scheme:T,hasAccessToAllModels:w,notebookType:b}=P;if(!E&&!w)return 0;b&&I&&(_=I);let v=0;if(T)if(T===_.scheme)v=10;else if(T==="*")v=5;else return 0;if(k)if(k===y)v=10;else if(k==="*")v=Math.max(v,5);else return 0;if(b)if(b===R)v=10;else if(b==="*"&&R!==void 0)v=Math.max(v,5);else return 0;if(S){let d;if(typeof S=="string"?d=S:d={...S,base:(0,t.normalize)(S.base)},d===_.fsPath||(0,l.match)(d,_.fsPath))v=10;else return 0}return v}else return 0}}e.score=D}),define(De[158],Ie([1,0,8,49,150]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(y,E,I,R){this._uri=y,this._lines=E,this._eol=I,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const E=y.changes;for(const I of E)this._acceptDeleteRange(I.range),this._acceptInsertText(new t.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,E=this._lines.length,I=new Uint32Array(E);for(let R=0;R<E;R++)I[R]=this._lines[R].length+y;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(y,E){this._lines[y]=E,this._lineStarts&&this._lineStarts.setValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,E){if(E.length===0)return;const I=(0,l.splitLines)(E);if(I.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}I[I.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]);const R=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this._lines.splice(y.lineNumber+k-1,0,I[k]),R[k-1]=I[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,R)}}e.MirrorTextModel=P}),define(De[159],Ie([1,0,8,147,49,35,99]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class E{constructor(p,f,a,g){this.searchString=p,this.isRegex=f,this.matchCase=a,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=I(this.searchString):p=this.searchString.indexOf(`
`)>=0;let f=null;try{f=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!f)return null;let a=!this.isRegex&&!p;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new _.SearchData(f,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=E;function I(d){if(!d||d.length===0)return!1;for(let p=0,f=d.length;p<f;p++){const a=d.charCodeAt(p);if(a===10)return!0;if(a===92){if(p++,p>=f)break;const g=d.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=I;function R(d,p,f){if(!f)return new _.FindMatch(d,null);const a=[];for(let g=0,s=p.length;g<s;g++)a[g]=p[g];return new _.FindMatch(d,a)}e.createFindMatch=R;class k{constructor(p){const f=[];let a=0;for(let g=0,s=p.length;g<s;g++)p.charCodeAt(g)===10&&(f[a++]=g);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(p){const f=this._lineFeedsOffsets;let a=0,g=f.length-1;if(g===-1||p<=f[0])return 0;for(;a<g;){const s=a+((g-a)/2>>0);f[s]>=p?g=s-1:f[s+1]>=p?(a=s,g=s):a=s+1}return a+1}}class S{static findMatches(p,f,a,g,s){const u=f.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(p,a,new v(u.wordSeparators,u.regex),g,s):this._doFindMatchesLineByLine(p,a,u,g,s):[]}static _getMultilineMatchRange(p,f,a,g,s,u){let o,i=0;g?(i=g.findLineFeedCountBeforeOffset(s),o=f+s+i):o=f+s;let r;if(g){const m=g.findLineFeedCountBeforeOffset(s+u.length)-i;r=o+u.length+m}else r=o+u.length;const n=p.getPositionAt(o),c=p.getPositionAt(r);return new P.Range(n.lineNumber,n.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(p,f,a,g,s){const u=p.getOffsetAt(f.getStartPosition()),o=p.getValueInRange(f,1),i=p.getEOL()===`\r
`?new k(o):null,r=[];let n=0,c;for(a.reset(0);c=a.next(o);)if(r[n++]=R(this._getMultilineMatchRange(p,u,o,i,c.index,c[0]),c,g),n>=s)return r;return r}static _doFindMatchesLineByLine(p,f,a,g,s){const u=[];let o=0;if(f.startLineNumber===f.endLineNumber){const r=p.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return o=this._findMatchesInLine(a,r,f.startLineNumber,f.startColumn-1,o,u,g,s),u}const i=p.getLineContent(f.startLineNumber).substring(f.startColumn-1);o=this._findMatchesInLine(a,i,f.startLineNumber,f.startColumn-1,o,u,g,s);for(let r=f.startLineNumber+1;r<f.endLineNumber&&o<s;r++)o=this._findMatchesInLine(a,p.getLineContent(r),r,0,o,u,g,s);if(o<s){const r=p.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);o=this._findMatchesInLine(a,r,f.endLineNumber,0,o,u,g,s)}return u}static _findMatchesInLine(p,f,a,g,s,u,o,i){const r=p.wordSeparators;if(!o&&p.simpleSearch){const h=p.simpleSearch,m=h.length,C=f.length;let L=-m;for(;(L=f.indexOf(h,L+m))!==-1;)if((!r||b(r,f,C,L,m))&&(u[s++]=new _.FindMatch(new P.Range(a,L+1+g,a,L+1+m+g),null),s>=i))return s;return s}const n=new v(p.wordSeparators,p.regex);let c;n.reset(0);do if(c=n.next(f),c&&(u[s++]=R(new P.Range(a,c.index+1+g,a,c.index+1+c[0].length+g),c,o),s>=i))return s;while(c);return s}static findNextMatch(p,f,a,g){const s=f.parseSearchRequest();if(!s)return null;const u=new v(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(p,a,u,g):this._doFindNextMatchLineByLine(p,a,u,g)}static _doFindNextMatchMultiline(p,f,a,g){const s=new D.Position(f.lineNumber,1),u=p.getOffsetAt(s),o=p.getLineCount(),i=p.getValueInRange(new P.Range(s.lineNumber,s.column,o,p.getLineMaxColumn(o)),1),r=p.getEOL()===`\r
`?new k(i):null;a.reset(f.column-1);const n=a.next(i);return n?R(this._getMultilineMatchRange(p,u,i,r,n.index,n[0]),n,g):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(p,new D.Position(1,1),a,g):null}static _doFindNextMatchLineByLine(p,f,a,g){const s=p.getLineCount(),u=f.lineNumber,o=p.getLineContent(u),i=this._findFirstMatchInLine(a,o,u,f.column,g);if(i)return i;for(let r=1;r<=s;r++){const n=(u+r-1)%s,c=p.getLineContent(n+1),h=this._findFirstMatchInLine(a,c,n+1,1,g);if(h)return h}return null}static _findFirstMatchInLine(p,f,a,g,s){p.reset(g-1);const u=p.next(f);return u?R(new P.Range(a,u.index+1,a,u.index+1+u[0].length),u,s):null}static findPreviousMatch(p,f,a,g){const s=f.parseSearchRequest();if(!s)return null;const u=new v(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(p,a,u,g):this._doFindPreviousMatchLineByLine(p,a,u,g)}static _doFindPreviousMatchMultiline(p,f,a,g){const s=this._doFindMatchesMultiline(p,new P.Range(1,1,f.lineNumber,f.column),a,g,10*y);if(s.length>0)return s[s.length-1];const u=p.getLineCount();return f.lineNumber!==u||f.column!==p.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(p,new D.Position(u,p.getLineMaxColumn(u)),a,g):null}static _doFindPreviousMatchLineByLine(p,f,a,g){const s=p.getLineCount(),u=f.lineNumber,o=p.getLineContent(u).substring(0,f.column-1),i=this._findLastMatchInLine(a,o,u,g);if(i)return i;for(let r=1;r<=s;r++){const n=(s+u-r-1)%s,c=p.getLineContent(n+1),h=this._findLastMatchInLine(a,c,n+1,g);if(h)return h}return null}static _findLastMatchInLine(p,f,a,g){let s=null,u;for(p.reset(0);u=p.next(f);)s=R(new P.Range(a,u.index+1,a,u.index+1+u[0].length),u,g);return s}}e.TextModelSearch=S;function T(d,p,f,a,g){if(a===0)return!0;const s=p.charCodeAt(a-1);if(d.get(s)!==0||s===13||s===10)return!0;if(g>0){const u=p.charCodeAt(a);if(d.get(u)!==0)return!0}return!1}function w(d,p,f,a,g){if(a+g===f)return!0;const s=p.charCodeAt(a+g);if(d.get(s)!==0||s===13||s===10)return!0;if(g>0){const u=p.charCodeAt(a+g-1);if(d.get(u)!==0)return!0}return!1}function b(d,p,f,a,g){return T(d,p,f,a,g)&&w(d,p,f,a,g)}e.isValidMatch=b;class v{constructor(p,f){this._wordSeparators=p,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const f=p.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(a=this._searchRegex.exec(p),!a))return null;const g=a.index,s=a[0].length;if(g===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){l.getNextCodePoint(p,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=g,this._prevMatchLength=s,!this._wordSeparators||b(this._wordSeparators,p,f,g,s))return a}while(a);return null}}e.Searcher=v}),define(De[113],Ie([1,0,23,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function P(k){for(let S=0,T=k.length;S<T;S+=4){const w=k[S+0],b=k[S+1],v=k[S+2],d=k[S+3];k[S+0]=d,k[S+1]=v,k[S+2]=b,k[S+3]=w}}function _(k){const S=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(S),l.VSBuffer.wrap(S)}function y(k){const S=k.buffer;if(t.isLittleEndian()||P(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const T=new Uint8Array(S.byteLength);return T.set(S),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(k){const S=new Uint32Array(I(k));let T=0;if(S[T++]=k.id,k.type==="full")S[T++]=1,S[T++]=k.data.length,S.set(k.data,T),T+=k.data.length;else{S[T++]=2,S[T++]=k.deltas.length;for(const w of k.deltas)S[T++]=w.start,S[T++]=w.deleteCount,w.data?(S[T++]=w.data.length,S.set(w.data,T),T+=w.data.length):S[T++]=0}return _(S)}e.encodeSemanticTokensDto=E;function I(k){let S=0;if(S+=1+1,k.type==="full")S+=1+k.data.length;else{S+=1,S+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(S+=T.data.length)}return S}function R(k){const S=y(k);let T=0;const w=S[T++];if(S[T++]===1){const p=S[T++],f=S.subarray(T,T+p);return T+=p,{id:w,type:"full",data:f}}const v=S[T++],d=[];for(let p=0;p<v;p++){const f=S[T++],a=S[T++],g=S[T++];let s;g>0&&(s=S.subarray(T,T+g),T+=g),d[p]={start:f,deleteCount:a,data:s}}return{id:w,type:"delta",deltas:d}}e.decodeSemanticTokensDto=R}),define(De[160],Ie([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,E){return this._map.set(y,E),this.fire([y]),(0,t.toDisposable)(()=>{this._map.get(y)===E&&(this._map.delete(y),this.fire([y]))})}registerFactory(y,E){this._factories.get(y)?.dispose();const I=new P(this,y,E);return this._factories.set(y,I),(0,t.toDisposable)(()=>{const R=this._factories.get(y);!R||R!==I||(this._factories.delete(y),R.dispose())})}async getOrCreate(y){const E=this.get(y);if(E)return E;const I=this._factories.get(y);return!I||I.isResolved?null:(await I.resolve(),this.get(y))}get(y){return this._map.get(y)||null}isResolved(y){if(this.get(y))return!0;const I=this._factories.get(y);return!!(!I||I.isResolved)}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class P extends t.Disposable{constructor(y,E,I){super(),this._registry=y,this._languageId=E,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const y=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,y&&!this._isDisposed&&this._register(this._registry.register(this._languageId,y))}}}),define(De[64],Ie([1,0,76,2,35,160]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(m,C,L){this._tokenBrand=void 0,this.offset=m,this.type=C,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class y{constructor(m,C){this._tokenizationResultBrand=void 0,this.tokens=m,this.endState=C}}e.TokenizationResult=y;class E{constructor(m,C){this._encodedTokenizationResultBrand=void 0,this.tokens=m,this.endState=C}}e.EncodedTokenizationResult=E;var I;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(h){const m=new Map;m.set(0,l.Codicon.symbolMethod),m.set(1,l.Codicon.symbolFunction),m.set(2,l.Codicon.symbolConstructor),m.set(3,l.Codicon.symbolField),m.set(4,l.Codicon.symbolVariable),m.set(5,l.Codicon.symbolClass),m.set(6,l.Codicon.symbolStruct),m.set(7,l.Codicon.symbolInterface),m.set(8,l.Codicon.symbolModule),m.set(9,l.Codicon.symbolProperty),m.set(10,l.Codicon.symbolEvent),m.set(11,l.Codicon.symbolOperator),m.set(12,l.Codicon.symbolUnit),m.set(13,l.Codicon.symbolValue),m.set(15,l.Codicon.symbolEnum),m.set(14,l.Codicon.symbolConstant),m.set(15,l.Codicon.symbolEnum),m.set(16,l.Codicon.symbolEnumMember),m.set(17,l.Codicon.symbolKeyword),m.set(27,l.Codicon.symbolSnippet),m.set(18,l.Codicon.symbolText),m.set(19,l.Codicon.symbolColor),m.set(20,l.Codicon.symbolFile),m.set(21,l.Codicon.symbolReference),m.set(22,l.Codicon.symbolCustomColor),m.set(23,l.Codicon.symbolFolder),m.set(24,l.Codicon.symbolTypeParameter),m.set(25,l.Codicon.account),m.set(26,l.Codicon.issues);function C(B){let A=m.get(B);return A||(console.info("No codicon found for CompletionItemKind "+B),A=l.Codicon.symbolProperty),A}h.toIcon=C;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function U(B,A){let M=L.get(B);return typeof M>"u"&&!A&&(M=9),M}h.fromString=U})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(h){h[h.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(h){return h&&t.URI.isUri(h.uri)&&D.Range.isIRange(h.range)&&(D.Range.isIRange(h.originSelectionRange)||D.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=p;var f;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var a;(function(h){h[h.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var g;(function(h){const m=new Map;m.set(0,l.Codicon.symbolFile),m.set(1,l.Codicon.symbolModule),m.set(2,l.Codicon.symbolNamespace),m.set(3,l.Codicon.symbolPackage),m.set(4,l.Codicon.symbolClass),m.set(5,l.Codicon.symbolMethod),m.set(6,l.Codicon.symbolProperty),m.set(7,l.Codicon.symbolField),m.set(8,l.Codicon.symbolConstructor),m.set(9,l.Codicon.symbolEnum),m.set(10,l.Codicon.symbolInterface),m.set(11,l.Codicon.symbolFunction),m.set(12,l.Codicon.symbolVariable),m.set(13,l.Codicon.symbolConstant),m.set(14,l.Codicon.symbolString),m.set(15,l.Codicon.symbolNumber),m.set(16,l.Codicon.symbolBoolean),m.set(17,l.Codicon.symbolArray),m.set(18,l.Codicon.symbolObject),m.set(19,l.Codicon.symbolKey),m.set(20,l.Codicon.symbolNull),m.set(21,l.Codicon.symbolEnumMember),m.set(22,l.Codicon.symbolStruct),m.set(23,l.Codicon.symbolEvent),m.set(24,l.Codicon.symbolOperator),m.set(25,l.Codicon.symbolTypeParameter);function C(L){let U=m.get(L);return U||(console.info("No codicon found for SymbolKind "+L),U=l.Codicon.symbolProperty),U}h.toIcon=C})(g=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(m){this.value=m}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(h){function m(C){return!C||typeof C!="object"?!1:typeof C.id=="string"&&typeof C.title=="string"}h.is=m})(u=e.Command||(e.Command={}));var o;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(h){h[h.Unresolved=0]="Unresolved",h[h.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var n;(function(h){h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(n=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var c;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[161],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[114],Ie([1,0,161,11,98,17,24,146]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=I;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(se,Ee,de,Te){this.id=se,this.name=Ee,this.defaultValue=de,this.schema=Te}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,de){return de}}class S{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=S;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new S(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const de=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new S(se,!de)}let Ee=!1;for(const de in se)if(se.hasOwnProperty(de)){const Te=T(re[de],se[de]);Te.didChange&&(re[de]=Te.newValue,Ee=!0)}return new S(re,Ee)}class w{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class b{constructor(se,Ee,de,Te){this.id=se,this.name=Ee,this.defaultValue=de,this.schema=Te}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,de){return de}}function v(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=v;class d extends b{constructor(se,Ee,de,Te=void 0){typeof Te<"u"&&(Te.type="boolean",Te.default=de),super(se,Ee,de,Te)}validate(se){return v(se,this.defaultValue)}}function p(re,se,Ee,de){if(typeof re>"u")return se;let Te=parseInt(re,10);return isNaN(Te)?se:(Te=Math.max(Ee,Te),Te=Math.min(de,Te),Te|0)}e.clampedInt=p;class f extends b{constructor(se,Ee,de,Te,Ne,Be=void 0){typeof Be<"u"&&(Be.type="integer",Be.default=de,Be.minimum=Te,Be.maximum=Ne),super(se,Ee,de,Be),this.minimum=Te,this.maximum=Ne}static clampedInt(se,Ee,de,Te){return p(se,Ee,de,Te)}validate(se){return f.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class a extends b{constructor(se,Ee,de,Te,Ne){typeof Ne<"u"&&(Ne.type="number",Ne.default=de),super(se,Ee,de,Ne),this.validationFn=Te}static clamp(se,Ee,de){return se<Ee?Ee:se>de?de:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const de=parseFloat(se);return isNaN(de)?Ee:de}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class g extends b{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,de,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.default=de),super(se,Ee,de,Te)}validate(se){return g.string(se,this.defaultValue)}}function s(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=s;class u extends b{constructor(se,Ee,de,Te,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=Te,Ne.default=de),super(se,Ee,de,Ne),this._allowedValues=Te}validate(se){return s(se,this.defaultValue,this._allowedValues)}}class o extends k{constructor(se,Ee,de,Te,Ne,Be,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.enum=Ne,ze.default=Te),super(se,Ee,de,ze),this._allowedValues=Ne,this._convert=Be}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function i(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,de){return de===0?se.accessibilitySupport:de}}class n extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:v(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(re){switch(re){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function L(re){switch(re){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class U extends w{constructor(){super(130)}compute(se,Ee,de){const Te=["monaco-editor"];return Ee.get(34)&&Te.push(Ee.get(34)),se.extraEditorClassName&&Te.push(se.extraEditorClassName),Ee.get(67)==="default"?Te.push("mouse-default"):Ee.get(67)==="copy"&&Te.push("mouse-copy"),Ee.get(101)&&Te.push("showUnused"),Ee.get(128)&&Te.push("showDeprecated"),Te.join(" ")}}class B extends d{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Ee,de){return de&&se.emptySelectionClipboard}}class A extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:v(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(Ee.loop,this.defaultValue.loop)}}}class M extends k{constructor(){super(46,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.ON:se:Boolean(se)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class $ extends w{constructor(){super(45)}compute(se,Ee,de){return se.fontInfo}}class N extends b{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Ee=a.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ee,6,100)}compute(se,Ee,de){return se.fontInfo.fontSize}}class K extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(f.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class z extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},de=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:de,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:de,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:de,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:de,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:de,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class O extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),delay:f.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:v(Ee.sticky,this.defaultValue.sticky),above:v(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class V extends w{constructor(){super(133)}compute(se,Ee,de){return V.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,de=se.scrollBeyondLastLine?Ee-1:0,Te=(se.viewLineCount+de)/(se.pixelRatio*se.height),Ne=Math.floor(se.viewLineCount/Te);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:de,desiredRatio:Te,minimapLineCount:Ne}}static _computeMinimapLayout(se,Ee){const de=se.outerWidth,Te=se.outerHeight,Ne=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*Te),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Te};const Be=Ee.stableMinimapLayoutInput,ze=Be&&se.outerHeight===Be.outerHeight&&se.lineHeight===Be.lineHeight&&se.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&se.pixelRatio===Be.pixelRatio&&se.scrollBeyondLastLine===Be.scrollBeyondLastLine&&se.minimap.enabled===Be.minimap.enabled&&se.minimap.side===Be.minimap.side&&se.minimap.size===Be.minimap.size&&se.minimap.showSlider===Be.minimap.showSlider&&se.minimap.renderCharacters===Be.minimap.renderCharacters&&se.minimap.maxColumn===Be.minimap.maxColumn&&se.minimap.scale===Be.minimap.scale&&se.verticalScrollbarWidth===Be.verticalScrollbarWidth&&se.isViewportWrapping===Be.isViewportWrapping,Xe=se.lineHeight,nt=se.typicalHalfwidthCharacterWidth,ct=se.scrollBeyondLastLine,st=se.minimap.renderCharacters;let et=Ne>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const gt=se.minimap.maxColumn,wt=se.minimap.size,Dt=se.minimap.side,ft=se.verticalScrollbarWidth,It=se.viewLineCount,Mt=se.remainingWidth,Ot=se.isViewportWrapping,Ge=st?2:3;let Ft=Math.floor(Ne*Te);const At=Ft/Ne;let Nt=!1,vt=!1,kt=Ge*et,Pe=et/Ne,Re=1;if(wt==="fill"||wt==="fit"){const{typicalViewportLineCount:Je,extraLinesBeyondLastLine:ut,desiredRatio:Tt,minimapLineCount:Et}=V.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:ct,height:Te,lineHeight:Xe,pixelRatio:Ne});if(It/Et>1)Nt=!0,vt=!0,et=1,kt=1,Pe=et/Ne;else{let yt=!1,pt=et+1;if(wt==="fit"){const Ct=Math.ceil((It+ut)*kt);Ot&&ze&&Mt<=Ee.stableFitRemainingWidth?(yt=!0,pt=Ee.stableFitMaxMinimapScale):yt=Ct>Ft}if(wt==="fill"||yt){Nt=!0;const Ct=et;kt=Math.min(Xe*Ne,Math.max(1,Math.floor(1/Tt))),Ot&&ze&&Mt<=Ee.stableFitRemainingWidth&&(pt=Ee.stableFitMaxMinimapScale),et=Math.min(pt,Math.max(1,Math.floor(kt/Ge))),et>Ct&&(Re=Math.min(2,et/Ct)),Pe=et/Ne/Re,Ft=Math.ceil(Math.max(Je,It+ut)*kt),Ot?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Mt,Ee.stableFitMaxMinimapScale=et):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(gt*Pe),te=Math.min(_e,Math.max(0,Math.floor((Mt-ft-2)*Pe/(nt+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ne*te);const Ve=Fe/Ne;Fe=Math.floor(Fe*Re);const it=st?1:2,Ke=Dt==="left"?0:de-te-ft;return{renderMinimap:it,minimapLeft:Ke,minimapWidth:te,minimapHeightIsEditorHeight:Nt,minimapIsSampling:vt,minimapScale:et,minimapLineHeight:kt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:At}}static computeLayout(se,Ee){const de=Ee.outerWidth|0,Te=Ee.outerHeight|0,Ne=Ee.lineHeight|0,Be=Ee.lineNumbersDigitCount|0,ze=Ee.typicalHalfwidthCharacterWidth,Xe=Ee.maxDigitWidth,nt=Ee.pixelRatio,ct=Ee.viewLineCount,st=se.get(125),et=st==="inherit"?se.get(124):st,gt=et==="inherit"?se.get(120):et,wt=se.get(123),Dt=se.get(2),ft=Ee.isDominatedByLongLines,It=se.get(51),Mt=se.get(61).renderType!==0,Ot=se.get(62),Ge=se.get(95),Ft=se.get(66),At=se.get(93),Nt=At.verticalScrollbarSize,vt=At.verticalHasArrows,kt=At.arrowSize,Pe=At.horizontalScrollbarSize,Re=se.get(59),_e=se.get(38),te=se.get(100)!=="never";let Fe;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const Ht=parseFloat(Re.substr(0,Re.length-2));Fe=f.clampedInt(Ht*ze,0,0,1e3)}else Fe=f.clampedInt(Re,0,0,1e3);_e&&te&&(Fe+=16);let Ve=0;if(Mt){const Ht=Math.max(Be,Ot);Ve=Math.round(Ht*Xe)}let it=0;It&&(it=Ne);let Ke=0,Je=Ke+it,ut=Je+Ve,Tt=ut+Fe;const Et=de-it-Ve-Fe;let _t=!1,yt=!1,pt=-1;Dt!==2&&(et==="inherit"&&ft?(_t=!0,yt=!0):gt==="on"||gt==="bounded"?yt=!0:gt==="wordWrapColumn"&&(pt=wt));const Ct=V._computeMinimapLayout({outerWidth:de,outerHeight:Te,lineHeight:Ne,typicalHalfwidthCharacterWidth:ze,pixelRatio:nt,scrollBeyondLastLine:Ge,minimap:Ft,verticalScrollbarWidth:Nt,viewLineCount:ct,remainingWidth:Et,isViewportWrapping:yt},Ee.memory||new R);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Ke+=Ct.minimapWidth,Je+=Ct.minimapWidth,ut+=Ct.minimapWidth,Tt+=Ct.minimapWidth);const Qt=Et-Ct.minimapWidth,bt=Math.max(1,Math.floor((Qt-Nt-2)/ze)),qt=vt?kt:0;return yt&&(pt=Math.max(1,bt),gt==="bounded"&&(pt=Math.min(pt,wt))),{width:de,height:Te,glyphMarginLeft:Ke,glyphMarginWidth:it,lineNumbersLeft:Je,lineNumbersWidth:Ve,decorationsLeft:ut,decorationsWidth:Fe,contentLeft:Tt,contentWidth:Qt,minimap:Ct,viewportColumn:bt,isWordWrapMinified:_t,isViewportWrapping:yt,wrappingColumn:pt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:Pe,overviewRuler:{top:qt,width:Nt,height:Te-2*qt,right:0}}}}e.EditorLayoutInfoComputer=V;class q extends k{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}class Y extends k{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Q extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:v(Ee.padding,this.defaultValue.padding)}}}class he extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Ee,de){return se.fontInfo.lineHeight}}class ve extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),autohide:v(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Ee.scale,1,1,3),maxColumn:f.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:f.clampedInt(Ee.top,0,0,1e3),bottom:f.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends k{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),cycle:v(Ee.cycle,this.defaultValue.cycle)}}}class ke extends w{constructor(){super(131)}compute(se,Ee,de){return se.pixelRatio}}class Le extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:l.localize(74,null)},other:{anyOf:Ee,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const nt=se?"on":"off";return{comments:nt,strings:nt,other:nt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:de,strings:Te}=se,Ne=["on","inline","off"];let Be,ze,Xe;return typeof Ee=="boolean"?Be=Ee?"on":"off":Be=s(Ee,this.defaultValue.other,Ne),typeof de=="boolean"?ze=de?"on":"off":ze=s(de,this.defaultValue.comments,Ne),typeof Te=="boolean"?Xe=Te?"on":"off":Xe=s(Te,this.defaultValue.strings,Ne),{other:Be,comments:ze,strings:Xe}}}var We;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,de=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,de=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:de}}}function ue(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=ue;class fe extends k{constructor(){const se=[],Ee={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const de of se)if(typeof de=="number")Ee.push({column:f.clampedInt(de,0,0,1e4),color:null});else if(de&&typeof de=="object"){const Te=de;Ee.push({column:f.clampedInt(Te.column,0,0,1e4),color:Te.color})}return Ee.sort((de,Te)=>de.column-Te.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,de=f.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Te=f.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:v(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:de,horizontalSliderSize:f.clampedInt(Ee.horizontalSliderSize,de,0,1e3),verticalScrollbarSize:Te,verticalSliderSize:f.clampedInt(Ee.verticalSliderSize,Te,0,1e3),scrollByPage:v(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Ee){let de=!1;Ee.allowedCharacters&&se&&(_.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},de=!0)),Ee.allowedLocales&&se&&(_.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},de=!0));const Te=super.applyUpdate(se,Ee);return de?new S(Te.newValue,!0):Te}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:G(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const de={};for(const[Te,Ne]of Object.entries(se))Ne===!0&&(de[Te]=!0);return de}}class ie extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class F extends k{constructor(){const se={enabled:y.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:y.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:G(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(re,se,Ee){const de=Ee.indexOf(re);return de===-1?se:Ee[de]}class X extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:v(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:v(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(Ee.showMethods,this.defaultValue.showMethods),showFunctions:v(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:v(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:v(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:v(Ee.showFields,this.defaultValue.showFields),showVariables:v(Ee.showVariables,this.defaultValue.showVariables),showClasses:v(Ee.showClasses,this.defaultValue.showClasses),showStructs:v(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:v(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:v(Ee.showModules,this.defaultValue.showModules),showProperties:v(Ee.showProperties,this.defaultValue.showProperties),showEvents:v(Ee.showEvents,this.defaultValue.showEvents),showOperators:v(Ee.showOperators,this.defaultValue.showOperators),showUnits:v(Ee.showUnits,this.defaultValue.showUnits),showValues:v(Ee.showValues,this.defaultValue.showValues),showConstants:v(Ee.showConstants,this.defaultValue.showConstants),showEnums:v(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:v(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(Ee.showKeywords,this.defaultValue.showKeywords),showWords:v(Ee.showWords,this.defaultValue.showWords),showColors:v(Ee.showColors,this.defaultValue.showColors),showFiles:v(Ee.showFiles,this.defaultValue.showFiles),showReferences:v(Ee.showReferences,this.defaultValue.showReferences),showFolders:v(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:v(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:v(Ee.showUsers,this.defaultValue.showUsers),showIssues:v(Ee.showIssues,this.defaultValue.showIssues)}}}class me extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends w{constructor(){super(132)}compute(se,Ee,de){return Ee.get(82)?!0:se.tabFocusMode}}var le;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(le=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends w{constructor(){super(134)}compute(se,Ee,de){const Te=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Te.isWordWrapMinified,isViewportWrapping:Te.isViewportWrapping,wrappingColumn:Te.wrappingColumn}}}class $e extends k{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}const je="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(re){return e.editorOptionsRegistry[re.id]=re,re}var ot;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Oe(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Oe(new r),accessibilityPageSize:Oe(new f(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null)})),ariaLabel:Oe(new g(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Oe(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Oe(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Oe(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Oe(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Oe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Oe(new d(10,"automaticLayout",!1)),autoSurround:Oe(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Oe(new F),bracketPairGuides:Oe(new H),stickyTabStops:Oe(new d(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Oe(new d(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Oe(new g(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Oe(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Oe(new d(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Oe(new d(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Oe(new n),contextmenu:Oe(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new d(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Oe(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Oe(new d(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Oe(new o(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:l.localize(199,null)})),cursorSurroundingLines:Oe(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Oe(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Oe(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Oe(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new d(30,"domReadOnly",!1)),dragAndDrop:Oe(new d(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Oe(new B),dropIntoEditor:Oe(new $e),stickyScroll:Oe(new Y),extraEditorClassName:Oe(new g(34,"extraEditorClassName","")),fastScrollSensitivity:Oe(new a(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Oe(new A),fixedOverflowWidgets:Oe(new d(37,"fixedOverflowWidgets",!1)),folding:Oe(new d(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Oe(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Oe(new d(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Oe(new d(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Oe(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Oe(new d(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Oe(new g(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Oe(new $),fontLigatures2:Oe(new M),fontSize:Oe(new N),fontWeight:Oe(new K),formatOnPaste:Oe(new d(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Oe(new d(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Oe(new d(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Oe(new z),hideCursorInOverviewRuler:Oe(new d(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Oe(new O),inDiffEditor:Oe(new d(55,"inDiffEditor",!1)),letterSpacing:Oe(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>a.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Oe(new q),lineDecorationsWidth:Oe(new b(59,"lineDecorationsWidth",10)),lineHeight:Oe(new he),lineNumbers:Oe(new oe),lineNumbersMinChars:Oe(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new d(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Oe(new d(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Oe(new u(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Oe(new ve),mouseStyle:Oe(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new a(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Oe(new d(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Oe(new d(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Oe(new o(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Oe(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Oe(new d(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Oe(new d(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Oe(new f(75,"overviewRulerLanes",3,0,3)),padding:Oe(new pe),parameterHints:Oe(new be),peekWidgetDefaultFocus:Oe(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Oe(new d(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Oe(new Le),quickSuggestionsDelay:Oe(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Oe(new d(82,"readOnly",!1)),renameOnType:Oe(new d(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Oe(new d(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Oe(new d(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Oe(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Oe(new d(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Oe(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Oe(new f(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new d(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Oe(new fe),scrollbar:Oe(new ae),scrollBeyondLastColumn:Oe(new f(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Oe(new d(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Oe(new d(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Oe(new d(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Oe(new d(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Oe(new d(99,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Oe(new d(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Oe(new d(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Oe(new Q),snippetSuggestions:Oe(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Oe(new me),smoothScrolling:Oe(new d(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Oe(new f(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new X),inlineSuggest:Oe(new ie),suggestFontSize:Oe(new f(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new f(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new d(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Oe(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Oe(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Oe(new f(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new ee),unusualLineTerminators:Oe(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Oe(new d(117,"useShadowDOM",!0)),useTabStops:Oe(new d(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Oe(new g(119,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Oe(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Oe(new g(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new g(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new f(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Oe(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new o(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Oe(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Oe(new U),pixelRatio:Oe(new ke),tabFocusMode:Oe(new we),layoutInfo:Oe(new V),wrappingInfo:Oe(new ye)}}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[187],Ie([1,0,22,41,164,302]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||_.test(d)}e.isValidVersionStr=E;function I(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=d.match(_);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function R(d){if(!d)return null;const p=d.majorBase,f=d.majorMustEqual,a=d.minorBase;let g=d.minorMustEqual;const s=d.patchBase;let u=d.patchMustEqual;d.hasCaret&&(p===0||(g=!1),u=!1);let o=0;if(d.preRelease){const i=y.exec(d.preRelease);if(i){const[,r,n,c]=i;o=Date.UTC(Number(r),Number(n)-1,Number(c))}}return{majorBase:p,majorMustEqual:f,minorBase:a,minorMustEqual:g,patchBase:s,patchMustEqual:u,isMinimum:d.hasGreaterEquals,notBefore:o}}e.normalizeVersion=R;function k(d,p,f){let a;typeof d=="string"?a=R(I(d)):a=d;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let s;if(typeof f=="string"?s=R(I(f)):s=f,!a||!s)return!1;const u=a.majorBase,o=a.minorBase,i=a.patchBase;let r=s.majorBase,n=s.minorBase,c=s.patchBase;const h=s.notBefore;let m=s.majorMustEqual,C=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?u>r?!0:u<r?!1:o>n?!0:o<n||g&&g<h?!1:i>=c:(u===1&&r===0&&(!m||!C||!L)&&(r=1,n=0,c=0,m=!0,C=!1,L=!1),u<r?!1:u>r?!m:o<n?!1:o>n?!C:i<c?!1:i>c?!L:!(g&&g<h))}e.isValidVersion=k;function S(d,p,f,a,g){const s=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return s.push([t.default.Error,D.localize(0,null)]),s;if(typeof a.name!="string")return s.push([t.default.Error,D.localize(1,null,"name")]),s;if(typeof a.version!="string")return s.push([t.default.Error,D.localize(2,null,"version")]),s;if(!a.engines)return s.push([t.default.Error,D.localize(3,null,"engines")]),s;if(typeof a.engines.vscode!="string")return s.push([t.default.Error,D.localize(4,null,"engines.vscode")]),s;if(typeof a.extensionDependencies<"u"&&!v(a.extensionDependencies))return s.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),s;if(typeof a.activationEvents<"u"){if(!v(a.activationEvents))return s.push([t.default.Error,D.localize(6,null,"activationEvents")]),s;if(typeof a.main>"u"&&typeof a.browser>"u")return s.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),s}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&s.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return s.push([t.default.Error,D.localize(9,null,"main")]),s;{const i=(0,l.joinPath)(f,a.main);(0,l.isEqualOrParent)(i,f)||s.push([t.default.Warning,D.localize(10,null,i.path,f.path)])}if(typeof a.activationEvents>"u")return s.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),s}if(typeof a.browser<"u"){if(typeof a.browser!="string")return s.push([t.default.Error,D.localize(12,null,"browser")]),s;{const i=(0,l.joinPath)(f,a.browser);(0,l.isEqualOrParent)(i,f)||s.push([t.default.Warning,D.localize(13,null,i.path,f.path)])}if(typeof a.activationEvents>"u")return s.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),s}if(!P.valid(a.version))return s.push([t.default.Error,D.localize(15,null)]),s;const u=[];if(!T(d,p,a,g,u))for(const i of u)s.push([t.default.Error,i]);return s}e.validateExtensionManifest=S;function T(d,p,f,a,g){return a||typeof f.main>"u"&&typeof f.browser>"u"?!0:b(d,p,f.engines.vscode,g)}e.isValidExtensionVersion=T;function w(d,p,f){return d==="*"||b(p,f,d)}e.isEngineValid=w;function b(d,p,f,a=[]){const g=R(I(f));if(!g)return a.push(D.localize(16,null,f)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return a.push(D.localize(17,null,f)),!1}else if(!g.majorMustEqual)return a.push(D.localize(18,null,f)),!1;return k(d,p,g)?!0:(a.push(D.localize(19,null,d,f)),!1)}function v(d){if(!Array.isArray(d))return!1;for(let p=0,f=d.length;p<f;p++)if(typeof d[p]!="string")return!1;return!0}}),define(De[115],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(D,P=[],_=!1){this.ctor=D,this.staticArguments=P,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=l}),define(De[82],Ie([1,0,115]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(_,y,E){y instanceof l.SyncDescriptor||(y=new l.SyncDescriptor(y,[],E)),t.push([_,y])}e.registerSingleton=D;function P(){return t}e.getSingletonServiceDescriptors=P}),define(De[188],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const _ of this._nodes.values())_.outgoing.size===0&&P.push(_);return P}insertEdge(P,_){const y=this.lookupOrInsertNode(P),E=this.lookupOrInsertNode(_);y.outgoing.set(this._hashFn(_),E),E.incoming.set(this._hashFn(P),y)}removeNode(P){const _=this._hashFn(P);this._nodes.delete(_);for(const y of this._nodes.values())y.outgoing.delete(_),y.incoming.delete(_)}lookupOrInsertNode(P){const _=this._hashFn(P);let y=this._nodes.get(_);return y||(y=new l(P),this._nodes.set(_,y)),y}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[_,y]of this._nodes)P.push(`${_}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(const[P,_]of this._nodes){const y=new Set([P]),E=this._findCycle(_,y);if(E)return E}}_findCycle(P,_){for(const[y,E]of P.outgoing){if(_.has(y))return[..._,y].join(" -> ");_.add(y);const I=this._findCycle(E,_);if(I)return I;_.delete(y)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function y(E){return E[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=y})(l=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(_,y,E){y[l.DI_TARGET]===y?y[l.DI_DEPENDENCIES].push({id:_,index:E}):(y[l.DI_DEPENDENCIES]=[{id:_,index:E}],y[l.DI_TARGET]=y)}function D(_){if(l.serviceIds.has(_))return l.serviceIds.get(_);const y=function(E,I,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,E,R)};return y.toString=()=>_,l.serviceIds.set(_,y),y}e.createDecorator=D;function P(_){return _}e.refineServiceDecorator=P}),define(De[83],Ie([1,0,13,2,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function P(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=P;function _(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=_;var y;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function I(d,p){const f=Object.create(null);for(const a in d)R(f,a,d[a],p);return f}e.toValuesTree=I;function R(d,p,f,a){const g=p.split("."),s=g.pop();let u=d;for(let o=0;o<g.length;o++){const i=g[o];let r=u[i];switch(typeof r){case"undefined":r=u[i]=Object.create(null);break;case"object":break;default:a(`Ignoring ${p} as ${g.slice(0,o+1).join(".")} is ${JSON.stringify(r)}`);return}u=r}if(typeof u=="object"&&u!==null)try{u[s]=f}catch{a(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(u)}`)}else a(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=R;function k(d,p){const f=p.split(".");S(d,f)}e.removeFromValueTree=k;function S(d,p){const f=p.shift();if(p.length===0){delete d[f];return}if(Object.keys(d).indexOf(f)!==-1){const a=d[f];typeof a=="object"&&!Array.isArray(a)&&(S(a,p),Object.keys(a).length===0&&delete d[f])}}function T(d,p,f){function a(u,o){let i=u;for(const r of o){if(typeof i!="object"||i===null)return;i=i[r]}return i}const g=p.split("."),s=a(d,g);return typeof s>"u"?f:s}e.getConfigurationValue=T;function w(d,p,f){Object.keys(p).forEach(a=>{a!=="__proto__"&&(a in d?l.isObject(d[a])&&l.isObject(p[a])?w(d[a],p[a],f):f&&(d[a]=p[a]):d[a]=p[a])})}e.merge=w;function b(d,p,f){const a=d.inspect(p),g=d.inspect(f);return typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:a.defaultValue}e.getMigratedSettingValue=b;function v(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(De[52],Ie([1,0,11,8,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const _=Object.prototype.hasOwnProperty;var y;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return k.INSTANCE}static true(){return S.INSTANCE}static has(A){return T.create(A)}static equals(A,M){return w.create(A,M)}static notEquals(A,M){return d.create(A,M)}static regex(A,M){return o.create(A,M)}static in(A,M){return b.create(A,M)}static notIn(A,M){return v.create(A,M)}static not(A){return p.create(A)}static and(...A){return n.create(A,null)}static or(...A){return c.create(A,null,!0)}static greater(A,M){return a.create(A,M)}static greaterEquals(A,M){return g.create(A,M)}static smaller(A,M){return s.create(A,M)}static smallerEquals(A,M){return u.create(A,M)}static deserialize(A,M=!1){if(!!A)return this._deserializeOrExpression(A,M)}static _deserializeOrExpression(A,M){const $=A.split("||");return c.create($.map(N=>this._deserializeAndExpression(N,M)),null,!0)}static _deserializeAndExpression(A,M){const $=A.split("&&");return n.create($.map(N=>this._deserializeOne(N,M)),null)}static _deserializeOne(A,M){if(A=A.trim(),A.indexOf("!=")>=0){const $=A.split("!=");return d.create($[0].trim(),this._deserializeValue($[1],M))}if(A.indexOf("==")>=0){const $=A.split("==");return w.create($[0].trim(),this._deserializeValue($[1],M))}if(A.indexOf("=~")>=0){const $=A.split("=~");return o.create($[0].trim(),this._deserializeRegexValue($[1],M))}if(A.indexOf(" not in ")>=0){const $=A.split(" not in ");return v.create($[0].trim(),$[1].trim())}if(A.indexOf(" in ")>=0){const $=A.split(" in ");return b.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const $=A.split(">=");return g.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const $=A.split(">");return a.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const $=A.split("<=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const $=A.split("<");return s.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(A)?p.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,M){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const $=/^'([^']*)'$/.exec(A);return $?$[1].trim():A}static _deserializeRegexValue(A,M){if((0,t.isFalsyOrWhitespace)(A)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=A.indexOf("/"),N=A.lastIndexOf("/");if($===N||$<0){if(M)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const K=A.slice($+1,N),z=A[N+1]==="i"?"i":"";try{return new RegExp(K,z)}catch(O){if(M)throw new Error(`bad regexp-value '${A}', parse error: ${O}`);return console.warn(`bad regexp-value '${A}', parse error: ${O}`),null}}}e.ContextKeyExpr=E;function I(B,A){const M=B?B.substituteConstants():void 0,$=A?A.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function R(B,A){return B.cmp(A)}class k{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class S{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class T{constructor(A,M){this.key=A,this.negated=M,this.type=2}static create(A,M=null){const $=P.get(A);return typeof $=="boolean"?$?S.INSTANCE:k.INSTANCE:new T(A,M)}cmp(A){return A.type!==this.type?this.type-A.type:m(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?S.INSTANCE:k.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class w{constructor(A,M,$){this.key=A,this.value=M,this.negated=$,this.type=4}static create(A,M,$=null){if(typeof M=="boolean")return M?T.create(A,$):p.create(A,$);const N=P.get(A);return typeof N=="boolean"?M===(N?"true":"false")?S.INSTANCE:k.INSTANCE:new w(A,M,$)}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const M=A?"true":"false";return this.value===M?S.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class b{constructor(A,M){this.key=A,this.valueKey=M,this.type=10,this.negated=null}static create(A,M){return new b(A,M)}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const M=A.getValue(this.valueKey),$=A.getValue(this.key);return Array.isArray(M)?M.includes($):typeof $=="string"&&typeof M=="object"&&M!==null?_.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=b;class v{constructor(A,M){this.key=A,this.valueKey=M,this.type=11,this._negated=b.create(A,M)}static create(A,M){return new v(A,M)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class d{constructor(A,M,$){this.key=A,this.value=M,this.negated=$,this.type=5}static create(A,M,$=null){if(typeof M=="boolean")return M?p.create(A,$):T.create(A,$);const N=P.get(A);return typeof N=="boolean"?M===(N?"true":"false")?k.INSTANCE:S.INSTANCE:new d(A,M,$)}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const M=A?"true":"false";return this.value===M?k.INSTANCE:S.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class p{constructor(A,M){this.key=A,this.negated=M,this.type=3}static create(A,M=null){const $=P.get(A);return typeof $=="boolean"?$?k.INSTANCE:S.INSTANCE:new p(A,M)}cmp(A){return A.type!==this.type?this.type-A.type:m(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:S.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function f(B,A){if(typeof B=="string"){const M=parseFloat(B);isNaN(M)||(B=M)}return typeof B=="string"||typeof B=="number"?A(B):k.INSTANCE}class a{constructor(A,M,$){this.key=A,this.value=M,this.negated=$,this.type=12}static create(A,M,$=null){return f(M,N=>new a(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class g{constructor(A,M,$){this.key=A,this.value=M,this.negated=$,this.type=13}static create(A,M,$=null){return f(M,N=>new g(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class s{constructor(A,M,$){this.key=A,this.value=M,this.negated=$,this.type=14}static create(A,M,$=null){return f(M,N=>new s(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{constructor(A,M,$){this.key=A,this.value=M,this.negated=$,this.type=15}static create(A,M,$=null){return f(M,N=>new u(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class o{constructor(A,M){this.key=A,this.regexp=M,this.type=7,this.negated=null}static create(A,M){return new o(A,M)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const M=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return M<$?-1:M>$?1:0}equals(A){if(A.type===this.type){const M=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return this.key===A.key&&M===$}return!1}substituteConstants(){return this}evaluate(A){const M=A.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class i{constructor(A){this._actual=A,this.type=8}static create(A){return new i(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new i(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(B){let A=null;for(let M=0,$=B.length;M<$;M++){const N=B[M].substituteConstants();if(B[M]!==N&&A===null){A=[];for(let K=0;K<M;K++)A[K]=B[K]}A!==null&&(A[M]=N)}return A===null?B:A}class n{constructor(A,M){this.expr=A,this.negated=M,this.type=6}static create(A,M){return n._normalizeArr(A,M)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const N=R(this.expr[M],A.expr[M]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(A.expr[M]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:n.create(A,this.negated)}evaluate(A){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(A))return!1;return!0}static _normalizeArr(A,M){const $=[];let N=!1;for(const K of A)if(!!K){if(K.type===1){N=!0;continue}if(K.type===0)return k.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&N)return S.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const z=$.pop(),O=$.length===0,x=c.create(K.expr.map(V=>n.create([V,z],null)),null,O);x&&($.push(x),$.sort(R))}return $.length===1?$[0]:new n($,M)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const M of this.expr)A.push(...M.keys());return A}map(A){return new n(this.expr.map(M=>M.map(A)),null)}negate(){if(!this.negated){const A=[];for(const M of this.expr)A.push(M.negate());this.negated=c.create(A,this,!0)}return this.negated}}class c{constructor(A,M){this.expr=A,this.negated=M,this.type=9}static create(A,M,$){return c._normalizeArr(A,M,$)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const N=R(this.expr[M],A.expr[M]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(A.expr[M]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:c.create(A,this.negated,!1)}evaluate(A){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(A))return!0;return!1}static _normalizeArr(A,M,$){let N=[],K=!1;if(A){for(let z=0,O=A.length;z<O;z++){const x=A[z];if(!!x){if(x.type===0){K=!0;continue}if(x.type===1)return S.INSTANCE;if(x.type===9){N=N.concat(x.expr);continue}N.push(x)}}if(N.length===0&&K)return k.INSTANCE;N.sort(R)}if(N.length!==0){if(N.length===1)return N[0];for(let z=1;z<N.length;z++)N[z-1].equals(N[z])&&(N.splice(z,1),z--);if(N.length===1)return N[0];if($){for(let z=0;z<N.length;z++)for(let O=z+1;O<N.length;O++)L(N[z],N[O])&&(N.splice(O,1),O--);if(N.length===1)return N[0]}return new c(N,M)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const M of this.expr)A.push(...M.keys());return A}map(A){return new c(this.expr.map(M=>M.map(A)),null)}negate(){if(!this.negated){const A=[];for(const M of this.expr)A.push(M.negate());for(;A.length>1;){const M=A.shift(),$=A.shift(),N=[];for(const z of U(M))for(const O of U($))N.push(n.create([z,O],null));const K=A.length===0;A.unshift(c.create(N,null,K))}this.negated=A[0]}return this.negated}}class h extends T{constructor(A,M,$){super(A,null),this._defaultValue=M,typeof $=="object"?h._info.push({...$,key:A}):$!==!0&&h._info.push({key:A,description:$,type:M!=null?typeof M:void 0})}static all(){return h._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return w.create(this.key,A)}notEqualsTo(A){return d.create(this.key,A)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(B,A){return B<A?-1:B>A?1:0}function C(B,A,M,$){return B<M?-1:B>M?1:A<$?-1:A>$?1:0}function L(B,A){if(A.type===6&&B.type!==9&&B.type!==6){for(const N of A.expr)if(B.equals(N))return!0}const M=B.negate(),$=U(M).concat(U(A));$.sort(R);for(let N=0;N<$.length;N++){const z=$[N].negate();for(let O=N+1;O<$.length;O++){const x=$[O];if(z.equals(x))return!0}}return!1}e.implies=L;function U(B){return B.type===9?B.expr:[B]}}),define(De[189],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(De[84],Ie([1,0,163,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function P(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function _(d,p){switch(d){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function y(d,p){return p==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function E(d,p,f){return y(p,f)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===f?!0:I(f).includes(d)}e.isTargetPlatformCompatible=E;function I(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var T;(function(d){d.Install="install",d.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var w;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(p,f){super(p),this.code=f,this.name=f}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(De[190],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(De[191],Ie([1,0,44,12,9,11,101,29,109,165,190]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends S{openTerminal(a,g){return this.spawnTerminal(l,a,E.getWindowsShell(),g)}spawnTerminal(a,g,s,u){const o=g.windowsExec||T.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=D.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(o,u?[u]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return o.indexOf(" ")>=0&&r.push('""'),r.push(o),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((n,c)=>{const h=v(process),m=a.spawn(s,r,{cwd:u,env:h});m.on("error",c),m.on("exit",()=>n())})}runInTerminal(a,g,s,u,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:T.getDefaultTerminalWindows();return new Promise((r,n)=>{const c=`"${g} - ${k}"`,h=`""${s.join('" "')}" & pause"`,m=["/c","start",c,"/wait",i,"/c",h],C=Object.assign({},v(process),u);Object.keys(C).filter(B=>C[B]===null).forEach(B=>delete C[B]);const L={cwd:g,env:C,windowsVerbatimArguments:!0};l.spawn(T.CMD,m,L).on("error",B=>{n(d(B))}),r(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class w extends S{openTerminal(a,g){return this.spawnTerminal(l,a,g)}runInTerminal(a,g,s,u,o){const i=o.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{if(i===R.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const c=i===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,J).fsPath,"-t",a||k,"-w",g];for(const U of s)m.push("-a"),m.push(U);if(u){const U=Object.assign({},v(process),u);for(const B in U){const A=U[B];A===null?(m.push("-u"),m.push(B)):(m.push("-e"),m.push(`${B}=${A}`))}}let C="";const L=l.spawn(w.OSASCRIPT,m);L.on("error",U=>{n(d(U))}),L.stderr.on("data",U=>{C+=U.toString()}),L.on("exit",U=>{if(U===0)r(void 0);else if(C){const B=C.split(`
`,1);n(new Error(B[0]))}else n(new Error(I.localize(1,null,c,U)))})}else n(new Error(I.localize(2,null,i)))})}spawnTerminal(a,g,s){const u=g.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const r=["-a",u];s&&r.push(s);const n=v(process),c=a.spawn("/usr/bin/open",r,{cwd:s,env:n});c.on("error",i),c.on("exit",()=>o())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class b extends S{openTerminal(a,g){return this.spawnTerminal(l,a,g)}runInTerminal(a,g,s,u,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{const c=[];i.then(h=>{h.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const m=`${p(s)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;c.push(`''${m}''`);const C=Object.assign({},v(process),u);Object.keys(C).filter(A=>C[A]===null).forEach(A=>delete C[A]);const L={cwd:g,env:C};let U="";const B=l.spawn(h,c,L);B.on("error",A=>{n(d(A))}),B.stderr.on("data",A=>{U+=A.toString()}),B.on("exit",A=>{if(A===0)r(void 0);else if(U){const M=U.split(`
`,1);n(new Error(M[0]))}else n(new Error(I.localize(4,null,h,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await y.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{a?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,g,s){const u=g.linuxExec?Promise.resolve(g.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{u.then(r=>{const n=v(process),c=a.spawn(r,[],{cwd:s,env:n});c.on("error",i),c.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=I.localize(3,null);function v(f){const a={...f.env};return(0,_.sanitizeProcessEnvironment)(a),a}function d(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(I.localize(5,null,f.path)):f}function p(f){let a="";for(const g of f)g.indexOf(" ")>=0?a+='"'+g+'"':a+=g,a+=" ";return a}}),define(De[42],Ie([1,0,25,9,8,13,2,166,3]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function I(z){return z.create===!0}e.isFileOpenForWriteOptions=I;var R;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(z){z[z.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var S;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=T;function w(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=w;function b(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=b;function v(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function d(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=d;function p(z){return T(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var f;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(O,x){super(O),this.code=x}}e.FileSystemProviderError=a;function g(z,O){const x=new a(z.toString(),O);return u(x,O),x}e.createFileSystemProviderError=g;function s(z){return z||g((0,y.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=s;function u(z,O){return z.name=O?`${O} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=u;function o(z){if(!z)return f.Unknown;if(z instanceof a)return z.code;const O=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!O)return f.Unknown;switch(O[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=o;function i(z){if(z instanceof C)return z.fileOperationResult;switch(o(z)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(O,x,V){this.resource=O,this.operation=x,this.target=V}isOperation(O){return this.operation===O}}e.FileOperationEvent=n;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class h{constructor(O,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const V=new Map;for(const q of O){const Y=V.get(q.type);switch(Y?Y.push([q.resource,q]):V.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,Y]of V)switch(q){case 1:this.added=l.TernarySearchTree.forUris(()=>x),this.added.fill(Y);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>x),this.updated.fill(Y);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>x),this.deleted.fill(Y);break}}contains(O,...x){return this.doContains(O,{includeChildren:!1},...x)}affects(O,...x){return this.doContains(O,{includeChildren:!0},...x)}doContains(O,x,...V){if(!O)return!1;const q=V.length>0;return!!((!q||V.includes(1))&&(this.added?.get(O)||x.includeChildren&&this.added?.findSuperstr(O))||(!q||V.includes(0))&&(this.updated?.get(O)||x.includeChildren&&this.updated?.findSuperstr(O))||(!q||V.includes(2))&&(this.deleted?.findSubstr(O)||x.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function m(z,O,x){return!z||!O||z===O||O.length>z.length?!1:(O.charAt(O.length-1)!==t.sep&&(O+=t.sep),x?(0,D.startsWithIgnoreCase)(z,O):z.indexOf(O)===0)}e.isParent=m;class C extends Error{constructor(O,x,V){super(O),this.fileOperationResult=x,this.options=V}}e.FileOperationError=C;class L extends C{constructor(O,x,V){super(O,2,V),this.stat=x}}e.NotModifiedSinceFileOperationError=L;var U;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=A;async function M(z,O){if(!O.hasProvider(_.URI.from({scheme:z.scheme})))return new Promise(x=>{const V=O.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===z.scheme&&q.added&&(V.dispose(),x())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(O){return(0,P.isNumber)(O)||(O=0),O<$.KB?(0,y.localize)(1,null,O.toFixed(0)):O<$.MB?(0,y.localize)(2,null,(O/$.KB).toFixed(2)):O<$.GB?(0,y.localize)(3,null,(O/$.MB).toFixed(2)):O<$.TB?(0,y.localize)(4,null,(O/$.GB).toFixed(2)):(0,y.localize)(5,null,(O/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var N;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function K(z){return{maxFileSize:z===0?300*$.MB:16*$.GB,maxHeapSize:z===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=K}),define(De[85],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...D){this._entries=new Map;for(const[P,_]of D)this.set(P,_)}set(D,P){const _=this._entries.get(D);return this._entries.set(D,P),_}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=l}),define(De[192],Ie([1,0,18,10,115,188,3,85]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class I extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class R{constructor(w=new y.ServiceCollection,b=!1,v){this._activeInstantiations=new Set,this._services=w,this._strict=b,this._parent=v,this._services.set(_.IInstantiationService,this)}createChild(w){return new R(w,this._strict,this)}invokeFunction(w,...b){const v=S.traceInvocation(w);let d=!1;try{return w({get:f=>{if(d)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,v);if(!a)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...b)}finally{d=!0,v.stop()}}createInstance(w,...b){let v,d;return w instanceof D.SyncDescriptor?(v=S.traceCreation(w.ctor),d=this._createInstance(w.ctor,w.staticArguments.concat(b),v)):(v=S.traceCreation(w),d=this._createInstance(w,b,v)),v.stop(),d}_createInstance(w,b=[],v){const d=_._util.getServiceDependencies(w).sort((a,g)=>a.index-g.index),p=[];for(const a of d){const g=this._getOrCreateServiceInstance(a.id,v);g||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${a.id}.`,!1),p.push(g)}const f=d.length>0?d[0].index:b.length;if(b.length!==f){console.trace(`[createInstance] First service dependency of ${w.name} at position ${f+1} conflicts with ${b.length} static arguments`);const a=f-b.length;a>0?b=b.concat(new Array(a)):b=b.slice(0,f)}return new w(...b,...p)}_setServiceInstance(w,b){if(this._services.get(w)instanceof D.SyncDescriptor)this._services.set(w,b);else if(this._parent)this._parent._setServiceInstance(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const b=this._services.get(w);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):b}_getOrCreateServiceInstance(w,b){const v=this._getServiceInstanceOrDescriptor(w);return v instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,v,b.branch(w,!0)):(b.branch(w,!1),v)}_safeCreateAndCacheServiceInstance(w,b,v){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,b,v)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,b,v){const d=new P.Graph(a=>a.id.toString());let p=0;const f=[{id:w,desc:b,_trace:v}];for(;f.length;){const a=f.pop();if(d.lookupOrInsertNode(a),p++>1e3)throw new I(d);for(const g of _._util.getServiceDependencies(a.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(g.id);if(s||this._throwIfStrict(`[createInstance] ${w} depends on ${g.id} which is NOT registered.`,!0),s instanceof D.SyncDescriptor){const u={id:g.id,desc:s,_trace:a._trace.branch(g.id,!0)};d.insertEdge(a,u),f.push(u)}}}for(;;){const a=d.roots();if(a.length===0){if(!d.isEmpty())throw new I(d);break}for(const{data:g}of a){if(this._getServiceInstanceOrDescriptor(g.id)instanceof D.SyncDescriptor){const u=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,u)}d.removeNode(g)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,b,v=[],d,p){if(this._services.get(w)instanceof D.SyncDescriptor)return this._createServiceInstance(b,v,d,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,b,v,d,p);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(w,b=[],v,d){if(v){const p=new l.IdleValue(()=>this._createInstance(w,b,d));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];const g=p.value;let s=g[a];return typeof s!="function"||(s=s.bind(g),f[a]=s),s},set(f,a,g){return p.value[a]=g,!0}})}else return this._createInstance(w,b,d)}_throwIfStrict(w,b){if(b&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=R;var k;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(k||(k={}));class S{constructor(w,b){this.type=w,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return E?new S(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(w){return E?new S(0,w.name):S._None}branch(w,b){const v=new S(2,w.toString());return this._dep.push([w,b,v]),v}stop(){const w=Date.now()-this._start;S._totals+=w;let b=!1;function v(p,f){const a=[],g=new Array(p+1).join("	");for(const[s,u,o]of f._dep)if(u&&o){b=!0,a.push(`${g}CREATES -> ${s}`);const i=v(p+1,o);i&&a.push(i)}else a.push(`${g}uses -> ${s}`);return a.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(w>2||b)&&console.log(d.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(De[14],Ie([1,0,50,4,6,11,3]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function y(){return new Date().toISOString()}var E;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function I(u,o,i){switch(o){case E.Trace:u.trace(i);break;case E.Debug:u.debug(i);break;case E.Info:u.info(i);break;case E.Warning:u.warn(i);break;case E.Error:u.error(i);break;case E.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function R(u){let o="";for(let i=0;i<u.length;i++){let r=u[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}o+=(i>0?" ":"")+r}return o}e.format=R;class k extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class S extends k{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([o,...i]))}debug(o,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([o,...i]))}info(o,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,R([o,...i]))}warn(o,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([o,...i]))}error(o,...i){if(this.checkLogLevel(E.Error))if(o instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=o.stack,this.log(E.Error,R(r))}else this.log(E.Error,R([o,...i]))}critical(o,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([o,...i]))}flush(){}}e.AbstractMessageLogger=S;class T extends k{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!P.isWindows}trace(o,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,o,...i):console.log(`[main ${y()}]`,o,...i))}debug(o,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,o,...i):console.log(`[main ${y()}]`,o,...i))}info(o,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,o,...i):console.log(`[main ${y()}]`,o,...i))}warn(o,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,o,...i):console.warn(`[main ${y()}]`,o,...i))}error(o,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,o,...i):console.error(`[main ${y()}]`,o,...i))}critical(o,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${y()}]\x1B[0m`,o,...i):console.error(`[main ${y()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class w extends k{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=w;class b extends k{constructor(o,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,l.toErrorMessage)(o,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class v extends k{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const r of this.logServices)r.trace(o,...i)}debug(o,...i){for(const r of this.logServices)r.debug(o,...i)}info(o,...i){for(const r of this.logServices)r.info(o,...i)}warn(o,...i){for(const r of this.logServices)r.warn(o,...i)}error(o,...i){for(const r of this.logServices)r.error(o,...i)}critical(o,...i){for(const r of this.logServices)r.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=v;class d extends D.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=d;class p extends D.Disposable{constructor(o,i){super(),this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let r=this.loggers.get(o.toString());return r||(r=this.doCreateLogger(o,i?.always?E.Trace:this.logLevel,i),this.loggers.set(o.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return E.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=f;function a(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const o=g(u.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function g(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=g;function s(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=s}),define(De[193],Ie([1,0,42,14]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(y,E,I,R,k){try{const S=await new Promise((w,b)=>{J(["spdlog"],w,b)});S.setFlushOn(t.LogLevel.Trace);const T=await S.createAsyncRotatingLogger(y,E,I,R);return k&&T.clearFormatters(),T}catch(S){console.error(S)}return null}function P(y,E,I){switch(E){case t.LogLevel.Trace:y.trace(I);break;case t.LogLevel.Debug:y.debug(I);break;case t.LogLevel.Info:y.info(I);break;case t.LogLevel.Warning:y.warn(I);break;case t.LogLevel.Error:y.error(I);break;case t.LogLevel.Critical:y.critical(I);break;default:throw new Error("Invalid log level")}}class _ extends t.AbstractMessageLogger{constructor(E,I,R,k,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(E,I,R,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(E,I,R,k){const S=R?6:1,T=30/S*l.ByteSize.MB,w=await D(E,I,T,S,k);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:b,message:v}of this.buffer)P(this._logger,b,v);this.buffer=[]}}log(E,I){this._logger?P(this._logger,E,I):this.getLevel()<=E&&this.buffer.push({level:E,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(De[116],Ie([1,0,41,167,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var _;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function I(w,b){return b-w}E.compare=I;const R=Object.create(null);R[E.Error]=(0,t.localize)(0,null),R[E.Warning]=(0,t.localize)(1,null),R[E.Info]=(0,t.localize)(2,null);function k(w){return R[w]||""}E.toString=k;function S(w){switch(w){case l.default.Error:return E.Error;case l.default.Warning:return E.Warning;case l.default.Info:return E.Info;case l.default.Ignore:return E.Hint}}E.fromSeverity=S;function T(w){switch(w){case E.Error:return l.default.Error;case E.Warning:return l.default.Warning;case E.Info:return l.default.Info;case E.Hint:return l.default.Ignore}}E.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(E){const I="";function R(S){return k(S,!0)}E.makeKey=R;function k(S,T){const w=[I];return S.source?w.push(S.source.replace("\xA6","\\\xA6")):w.push(I),S.code?typeof S.code=="string"?w.push(S.code.replace("\xA6","\\\xA6")):w.push(S.code.value.replace("\xA6","\\\xA6")):w.push(I),S.severity!==void 0&&S.severity!==null?w.push(_.toString(S.severity)):w.push(I),S.message&&T?w.push(S.message.replace("\xA6","\\\xA6")):w.push(I),S.startLineNumber!==void 0&&S.startLineNumber!==null?w.push(S.startLineNumber.toString()):w.push(I),S.startColumn!==void 0&&S.startColumn!==null?w.push(S.startColumn.toString()):w.push(I),S.endLineNumber!==void 0&&S.endLineNumber!==null?w.push(S.endLineNumber.toString()):w.push(I),S.endColumn!==void 0&&S.endColumn!==null?w.push(S.endColumn.toString()):w.push(I),w.push(I),w.join("\xA6")}E.makeKeyOptionalMessage=k})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(De[194],Ie([1,0,4,41,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new E,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=y;class E{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=E}),define(De[117],Ie([1,0,6,8,2,3]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function _(R,k){return D.URI.isUri(R)?(0,t.equalsIgnoreCase)(R.scheme,k):(0,t.startsWithIgnoreCase)(R,k+":")}e.matchesScheme=_;function y(R,...k){return k.some(S=>_(R,S))}e.matchesSomeScheme=y;function E(R,k){return R.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=E;function I(R){let k;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return S&&(k={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},R=R.with({fragment:""})),{selection:k,uri:R}}e.extractSelection=I}),define(De[195],Ie([1,0,12,11,40,22]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const y=t.globals.vscode.context.configuration();if(y)_=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const y=(0,P.dirname)(l.FileAccess.asFileUri("",J));_=J.__$__nodeRequire((0,P.joinPath)(y,"product.json").fsPath);const E=J.__$__nodeRequire((0,P.joinPath)(y,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),Object.assign(_,{version:E.version})}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(De[196],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(De[118],Ie([1,0,18,21,6,3]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var _;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let E=class extends D.Disposable{constructor(k,S){super(),this.deferred=new l.DeferredPromise,S.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};E=qe([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class I extends D.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const S=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:T.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,13]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(_,y){l.ok(t.isString(_)),l.ok(t.isObject(y)),l.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,y)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new D}),define(De[119],Ie([1,0,4,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,I){this.schemasById[D(E)]=I,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new P;t.Registry.add(e.Extensions.JSONContribution,_)}),define(De[120],Ie([1,0,17,4,13,162,83,119,43]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=E.Registry.as(y.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const o=this.doRegisterConfigurations(s,u);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const o=[];o.push(...this.doDeregisterConfigurations(u)),o.push(...this.doRegisterConfigurations(s,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(o)})}registerDefaultConfigurations(s){const u=[],o=[];for(const{overrides:i,source:r}of s)for(const n in i)if(u.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const c=this.configurationDefaultsOverrides.get(n),h=c?.valuesSources??new Map;if(r)for(const U of Object.keys(i[n]))h.set(U,r);const m={...c?.value||{},...i[n]};this.configurationDefaultsOverrides.set(n,{source:r,value:m,valuesSources:h});const C=(0,_.getLanguageTagSettingPlainKey)(n),L={type:"object",default:m,description:P.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:D.isString(r)?void 0:r,defaultValueSource:r};o.push(...b(n)),this.configurationProperties[n]=L,this.defaultLanguageConfigurationOverridesNode.properties[n]=L}else{this.configurationDefaultsOverrides.set(n,{value:i[n],source:r});const c=this.configurationProperties[n];c&&(this.updatePropertyDefaultValue(n,c),this.updateSchema(n,c))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:o,source:i}of s)for(const r in o){const n=this.configurationDefaultsOverrides.get(r),c=D.isString(i)?i:i?.id,h=D.isString(n?.source)?n?.source:n?.source?.id;if(c===h)if(u.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const m=this.configurationProperties[r];m&&(this.updatePropertyDefaultValue(r,m),this.updateSchema(r,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const o=[];return s.forEach(i=>{o.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),o}doDeregisterConfigurations(s){const u=[],o=i=>{if(i.properties)for(const r in i.properties){u.push(r);const n=this.configurationProperties[r];n?.policy?.name&&this.policyConfigurations.delete(n.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>o(r))};for(const i of s){o(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return u}validateAndRegisterProperties(s,u=!0,o,i,r=3){r=D.isUndefinedOrNull(s.scope)?r:s.scope;const n=[],c=s.properties;if(c)for(const m in c){const C=c[m];if(u&&f(m,C)){delete c[m];continue}if(C.source=o,C.defaultDefaultValue=c[m].default,this.updatePropertyDefaultValue(m,C),e.OVERRIDE_PROPERTY_REGEX.test(m)?C.scope=void 0:(C.scope=D.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=D.isUndefinedOrNull(C.restricted)?!!i?.includes(m):C.restricted),c[m].hasOwnProperty("included")&&!c[m].included){this.excludedConfigurationProperties[m]=c[m],delete c[m];continue}else this.configurationProperties[m]=c[m],c[m].policy?.name&&this.policyConfigurations.set(c[m].policy.name,m);!c[m].deprecationMessage&&c[m].markdownDeprecationMessage&&(c[m].deprecationMessage=c[m].markdownDeprecationMessage),n.push(m)}const h=s.allOf;if(h)for(const m of h)n.push(...this.validateAndRegisterProperties(m,u,o,i,r));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=o=>{const i=o.properties;if(i)for(const n in i)this.updateSchema(n,i[n]);o.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,o),e.allSettings.properties[u]=o,e.applicationSettings.properties[u]=o,e.machineSettings.properties[u]=o,e.machineOverridableSettings.properties[u]=o,e.windowSettings.properties[u]=o,e.resourceSettings.properties[u]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const o=this.configurationDefaultsOverrides.get(s);let i=o?.value,r=o?.source;D.isUndefined(i)&&(i=u.defaultDefaultValue,r=void 0),D.isUndefined(i)&&(i=d(u.type)),u.default=i,u.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",w=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(g){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let u=w.exec(g);for(;u?.length;){const o=u[1].trim();o&&s.push(o),u=w.exec(g)}}return(0,l.distinct)(s)}e.overrideIdentifiersFromKey=b;function v(g){return g.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=v;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const p=new S;E.Registry.add(e.Extensions.Configuration,p);function f(g,s){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?P.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?P.localize(8,null,g):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?P.localize(9,null,g,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:P.localize(6,null)}e.validateProperty=f;function a(){const g=[],s=p.getConfigurationProperties();for(const u of Object.keys(s))g.push([u,s[u].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=a}),define(De[197],Ie([1,0,17,4,143,6,25,24,13,2,83,120,43]),function(J,e,l,t,D,P,_,y,E,I,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(s={},u=[],o=[]){this._contents=s,this._keys=u,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,u){const o=this.getContentsForOverrideIdentifer(u);return o?s?(0,R.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const u=[];for(const o of this.overrides)o.identifiers.includes(s)&&u.push(...o.keys);return l.distinct(u)}getAllOverrideIdentifiers(){const s=[];for(const u of this.overrides)s.push(...u.identifiers);return l.distinct(s)}override(s){let u=this.overrideConfigurations.get(s);return u||(u=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,u)),u}merge(...s){const u=y.deepClone(this.contents),o=y.deepClone(this.overrides),i=[...this.keys];for(const r of s)if(!r.isEmpty()){this.mergeContents(u,r.contents);for(const n of r.overrides){const[c]=o.filter(h=>l.equals(h.identifiers,n.identifiers));c?(this.mergeContents(c.contents,n.contents),c.keys.push(...n.keys),c.keys=l.distinct(c.keys)):o.push(y.deepClone(n))}for(const n of r.keys)i.indexOf(n)===-1&&i.push(n)}return new T(u,i,o)}freeze(){return this.frozen=!0,this}clone(){return new T(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(s){const u=this.getContentsForOverrideIdentifer(s);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const o={};for(const i of l.distinct([...Object.keys(this.contents),...Object.keys(u)])){let r=this.contents[i];const n=u[i];n&&(typeof r=="object"&&typeof n=="object"?(r=y.deepClone(r),this.mergeContents(r,n)):r=n),o[i]=r}return new T(o,this.keys,this.overrides)}mergeContents(s,u){for(const o of Object.keys(u)){if(o in s&&E.isObject(s[o])&&E.isObject(u[o])){this.mergeContents(s[o],u[o]);continue}s[o]=y.deepClone(u[o])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?y.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let u=null,o=null;const i=r=>{r&&(o?this.mergeContents(o,r):o=y.deepClone(r))};for(const r of this.overrides)l.equals(r.identifiers,[s])?u=r.contents:r.identifiers.includes(s)&&i(r.contents);return i(u),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,u){this.addKey(s),(0,R.addToValueTree)(this.contents,s,u,o=>{throw new Error(o)})}removeValue(s){this.removeKey(s)&&(0,R.removeFromValueTree)(this.contents,s)}addKey(s){let u=this.keys.length;for(let o=0;o<u;o++)s.indexOf(this.keys[o])===0&&(u=o);this.keys.splice(u,1,s)}removeKey(s){const u=this.keys.indexOf(s);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=T;class w{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,u){if(!E.isUndefinedOrNull(s)){const o=this.doParseContent(s);this.parseRaw(o,u)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,u){this._raw=s;const{contents:o,keys:i,overrides:r,restricted:n}=this.doParseRaw(s,u);this._configurationModel=new T(o,i,r),this._restrictedConfigurations=n||[]}doParseContent(s){let u={},o=null,i=[];const r=[],n=[];function c(m){Array.isArray(i)?i.push(m):o!==null&&(i[o]=m)}const h={onObjectBegin:()=>{const m={};c(m),r.push(i),i=m,o=null},onObjectProperty:m=>{o=m},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const m=[];c(m),r.push(i),i=m,o=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:c,onError:(m,C,L)=>{n.push({error:m,offset:C,length:L})}};if(s)try{D.visit(s,h),u=i[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return u}doParseRaw(s,u){const o=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(s,o,!0,u);s=i.raw;const r=(0,R.toValuesTree)(s,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),n=Object.keys(s),c=this.toOverrides(s,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:r,keys:n,overrides:c,restricted:i.restricted}}filter(s,u,o,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:s,restricted:[]};const r={},n=[];for(const c in s)if(k.OVERRIDE_PROPERTY_REGEX.test(c)&&o){const h=this.filter(s[c],u,!1,i);r[c]=h.raw,n.push(...h.restricted)}else{const h=u[c],m=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&n.push(c),(m===void 0||i.scopes===void 0||i.scopes.includes(m))&&(i.skipRestricted&&h?.restricted||(r[c]=s[c]))}return{raw:r,restricted:n}}toOverrides(s,u){const o=[];for(const i of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(i)){const r={};for(const n in s[i])r[n]=s[i][n];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(i),keys:Object.keys(r),contents:(0,R.toValuesTree)(r,u)})}return o}}e.ConfigurationModelParser=w;class b extends P.Disposable{constructor(s,u,o,i){super(),this.userSettingsResource=s,this.scopes=u,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class v{constructor(s,u,o,i,r=new T,n=new T,c=new _.ResourceMap,h=new T,m=new _.ResourceMap,C=!0){this._defaultConfiguration=s,this._policyConfiguration=u,this._applicationConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(s,u,o){return this.getConsolidatedConfigurationModel(s,u,o).getValue(s)}updateValue(s,u,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new T,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,u===void 0?i.removeValue(s):i.setValue(s,u),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,u,o){const i=this.getConsolidatedConfigurationModel(s,u,o),r=this.getFolderConfigurationModelForResource(u.resource,o),n=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,c=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(s),m=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(s),C=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),L=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),U=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),B=o?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,A=r?u.overrideIdentifier?r.freeze().override(u.overrideIdentifier).getValue(s):r.freeze().getValue(s):void 0,M=u.overrideIdentifier?n.override(u.overrideIdentifier).getValue(s):n.getValue(s),$=i.getValue(s),N=l.distinct(i.overrides.map(K=>K.identifiers).flat()).filter(K=>i.getOverrideValue(s,K)!==void 0);return{defaultValue:c,policyValue:h,applicationValue:m,userValue:C,userLocalValue:L,userRemoteValue:U,workspaceValue:B,workspaceFolderValue:A,memoryValue:M,value:$,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,application:m!==void 0?{value:m,override:u.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:r?.freeze().getValue(s),override:u.overrideIdentifier?r?.freeze().getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:n.getValue(s),override:u.overrideIdentifier?n.getOverrideValue(s,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(s){const u=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,u){this._folderConfigurations.set(s,u),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,u){const o=[];if(!u){const{added:i,updated:r,removed:n}=f(this._defaultConfiguration,s);u=[...i,...r,...n]}for(const i of u)for(const r of(0,k.overrideIdentifiersFromKey)(i)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(r),c=s.getKeysForOverrideIdentifier(r),h=[...c.filter(m=>n.indexOf(m)===-1),...n.filter(m=>c.indexOf(m)===-1),...n.filter(m=>!y.equals(this._defaultConfiguration.override(r).getValue(m),s.override(r).getValue(m)))];o.push([r,h])}return this.updateDefaultConfiguration(s),{keys:u,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:u,updated:o,removed:i}=f(this._policyConfiguration,s),r=[...u,...o,...i];return r.length&&this.updatePolicyConfiguration(s),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:u,updated:o,removed:i,overrides:r}=f(this.applicationConfiguration,s),n=[...u,...o,...i];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:u,updated:o,removed:i,overrides:r}=f(this.localUserConfiguration,s),n=[...u,...o,...i];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:r}}compareAndUpdateRemoteUserConfiguration(s){const{added:u,updated:o,removed:i,overrides:r}=f(this.remoteUserConfiguration,s),n=[...u,...o,...i];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:r}}compareAndUpdateWorkspaceConfiguration(s){const{added:u,updated:o,removed:i,overrides:r}=f(this.workspaceConfiguration,s),n=[...u,...o,...i];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:r}}compareAndUpdateFolderConfiguration(s,u){const o=this.folderConfigurations.get(s),{added:i,updated:r,removed:n,overrides:c}=f(o,u),h=[...i,...r,...n];return(h.length||!o)&&this.updateFolderConfiguration(s,u),{keys:h,overrides:c}}compareAndDeleteFolderConfiguration(s){const u=this.folderConfigurations.get(s);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:i,removed:r,overrides:n}=f(u,void 0);return{keys:[...o,...i,...r],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,u,o){let i=this.getConsolidatedConfigurationModelForResource(u,o);return u.overrideIdentifier&&(i=i.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:s},u){let o=this.getWorkspaceConsolidatedConfiguration();if(u&&s){const i=u.getFolder(s);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const r=this._memoryConfigurationByResource.get(s);r&&(o=o.merge(r))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let u=this._foldersConsolidatedConfigurations.get(s);if(!u){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(s);i?(u=o.merge(i),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(s,u)):u=o}return u}getFolderConfigurationModelForResource(s,u){if(u&&s){const o=u.getFolder(s);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,u)=>{const{contents:o,overrides:i,keys:r}=this._folderConfigurations.get(u);return s.push([u,{contents:o,overrides:i,keys:r}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>s.add(u)),this.userConfiguration.freeze().keys.forEach(u=>s.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>s.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(o=>s.add(o))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>s.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>s.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>u.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>u.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>u.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(i=>u.add(i))),[...u.values()]}static parse(s){const u=this.parseConfigurationModel(s.defaults),o=this.parseConfigurationModel(s.policy),i=this.parseConfigurationModel(s.application),r=this.parseConfigurationModel(s.user),n=this.parseConfigurationModel(s.workspace),c=s.folders.reduce((h,m)=>(h.set(I.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new _.ResourceMap);return new v(u,o,i,r,new T,n,c,new T,new _.ResourceMap,!1)}static parseConfigurationModel(s){return new T(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=v;function d(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const s=new Set,u=new Map;for(const i of g)i.keys.forEach(r=>s.add(r)),i.overrides.forEach(([r,n])=>{const c=(0,_.getOrSet)(u,r,new Set);n.forEach(h=>c.add(h))});const o=[];return u.forEach((i,r)=>o.push([r,[...i.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=d;class p{constructor(s,u,o,i){this.change=s,this.previous=u,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const r=new Set;s.keys.forEach(c=>r.add(c)),s.overrides.forEach(([,c])=>c.forEach(h=>r.add(h))),this.affectedKeys=[...r.values()];const n=new T;this.affectedKeys.forEach(c=>n.setValue(c,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(u){const o=this.previousConfiguration?this.previousConfiguration.getValue(s,u,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(s,u,this.currentWorkspace);return!y.equals(o,i)}return!0}return!1}doesAffectedKeysTreeContains(s,u){let o=(0,R.toValuesTree)({[u]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(s=s[i],!s)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=p;function f(g,s){const{added:u,removed:o,updated:i}=a(s,g),r=[],n=g?.getAllOverrideIdentifiers()||[],c=s?.getAllOverrideIdentifiers()||[];if(s){const h=c.filter(m=>!n.includes(m));for(const m of h)r.push([m,s.getKeysForOverrideIdentifier(m)])}if(g){const h=n.filter(m=>!c.includes(m));for(const m of h)r.push([m,g.getKeysForOverrideIdentifier(m)])}if(s&&g){for(const h of n)if(c.includes(h)){const m=a({contents:g.getOverrideValue(void 0,h)||{},keys:g.getKeysForOverrideIdentifier(h)},{contents:s.getOverrideValue(void 0,h)||{},keys:s.getKeysForOverrideIdentifier(h)});r.push([h,[...m.added,...m.removed,...m.updated]])}}return{added:u,removed:o,updated:i,overrides:r}}function a(g,s){const u=g?s?g.keys.filter(r=>s.keys.indexOf(r)===-1):[...g.keys]:[],o=s?g?s.keys.filter(r=>g.keys.indexOf(r)===-1):[...s.keys]:[],i=[];if(g&&s){for(const r of s.keys)if(g.keys.indexOf(r)!==-1){const n=(0,R.getConfigurationValue)(s.contents,r),c=(0,R.getConfigurationValue)(g.contents,r);y.equals(n,c)||i.push(r)}}return{added:u,removed:o,updated:i}}}),define(De[121],Ie([1,0,10,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{constructor(y,E=D.Unknown,I){super(y),this._message=y,this._code=E,this._detail=I,this.isHandled=E===D.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(y){return y instanceof P&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof P&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof P&&y.isHandled}}e.RemoteAuthorityResolverError=P}),define(De[122],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(I){return I.scheme===l.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=t;function D(I){if(!I)return;const R=I.indexOf("+");return R<0?I:I.substr(0,R)}e.getRemoteName=D;function P(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=P;function _(I){const{host:R,port:k}=E(I);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=_;function y(I,R){let{host:k,port:S}=E(I);return typeof S>"u"&&(S=R),{host:k,port:S}}e.parseAuthorityWithOptionalPort=y;function E(I){const R=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=I.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:I,port:void 0}}}),define(De[27],Ie([1,0,8,3,122]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function _(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var E;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,v){if(typeof b>"u"||b===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof b=="string"||typeof v=="string"){const d=typeof b=="string"?b:b.value,p=typeof v=="string"?v:v.value;return l.equalsIgnoreCase(d,p)}return b._lower===v._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=I;function R(w){return k(w)}e.isApplicationScopedExtension=R;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function S(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function T(w,b){if(b){const v=`onResolveRemoteAuthority:${(0,D.getRemoteName)(b)}`;return w.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[198],Ie([1,0,8,84,27,11,2,10,40]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,l.compareIgnoreCase)(u.id,o.id)===0}e.areSameExtensions=I;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(o,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=o.id}static create(o){const i=o.manifest?o.manifest.version:o.version,r=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new k(o.identifier,i,r)}static parse(o){const i=R.exec(o);return i&&i[1]&&i[2]?new k({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof k?I(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=k;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(u){const o=S.exec(u);return o&&o[1]?[b(o[1]),o[2]]:[b(u),void 0]}e.getIdAndVersion=T;function w(u,o){return`${u}.${o}`}e.getExtensionId=w;function b(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function v(u,o){return b(w(u,o))}e.getGalleryExtensionId=v;function d(u,o){const i=[],r=n=>{for(const c of i)if(c.some(h=>I(o(h),o(n))))return c;return null};for(const n of u){const c=r(n);c?c.push(n):i.push([n])}return i}e.groupByExtension=d;function p(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function f(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function a(u,o){const i=[],r=o.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const n=r.shift();if(n&&i.every(c=>!I(c.identifier,{id:n}))){const c=u.filter(h=>I(h.identifier,{id:n}));c.length===1&&(i.push(c[0]),r.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=a;async function g(u,o){if(!P.isLinux)return!1;let i;try{i=(await u.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await u.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){o.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(n))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=g;async function s(u,o){const i=await g(u,o),r=(0,t.getTargetPlatform)(i?"alpine":P.platform,E.arch);return o.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(De[199],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((D,P)=>J(["vsda"],D,P))}async createNewMessage(D){try{const P=await this.vsda(),_=new P.validator;if(_){const y=String(l._nextId++);return this.validators.set(y,_),{id:y,data:_.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,P){if(!D.id)return!0;const _=this.validators.get(D.id);if(!_)return!1;this.validators.delete(D.id);try{return _.validate(P)==="ok"}catch{return!1}}async sign(D){try{const P=await this.vsda(),_=new P.signer;if(_)return _.sign(D)}catch{}return D}}e.SignService=l,l._nextId=1}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,P,_=5){const y=P(E=>{const I=typeof E=="string"?E:E.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(D),_);R={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),y.dispose()}},this._terminalBufferMap.set(D,R)});return y}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const P=this._terminalBufferMap.get(D);P&&(this._terminalBufferMap.delete(D),this._callback(D,P.data.join("")))}}e.TerminalDataBufferer=l}),define(De[201],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=D}),define(De[86],Ie([1,0,76,4,6,3,43,201]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var E;(function(v){function d(p){return p&&typeof p=="object"&&typeof p.id=="string"}v.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var R;(function(v){function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||E.isThemeColor(i.color))}v.isThemeIcon=d;const p=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function f(i){const r=p.exec(i);if(!r)return;const[,n]=r;return{id:n}}v.fromString=f;function a(i){return{id:i}}v.fromId=a;function g(i,r){let n=i.id;const c=n.lastIndexOf("~");return c!==-1&&(n=n.substring(0,c)),r&&(n=`${n}~${r}`),{id:n}}v.modify=g;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}v.getModifier=s;function u(i,r){return i.id===r.id&&i.color?.id===r.color?.id}v.isEqual=u;function o(i,r){return{id:i.id,color:r?I(r):void 0}}v.asThemeIcon=o,v.asClassNameArray=l.CSSIcon.asClassNameArray,v.asClassName=l.CSSIcon.asClassName,v.asCSSSelector=l.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function k(v){switch(v){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,D.toDisposable)(()=>{const p=this.themingParticipants.indexOf(d);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new S;_.Registry.add(e.Extensions.ThemingContribution,T);function w(v){return T.onColorThemeChange(v)}e.registerThemingParticipant=w;class b extends D.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,p){let f=this.theme.getColor(d);return f&&p&&(f=p(f,this.theme)),f?f.toString():null}}e.Themable=b}),define(De[123],Ie([1,0,4,11,3,14]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var _;(function(b){b.Http="http",b.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=k;function S(b,v){return v?v!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=S;class T{constructor(v,d,p){this.remoteAddress=v,this.localAddress=d,this._dispose=p,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let w=class{constructor(v){this.logService=v,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],d=Array.from(this._tunnels.values());for(const p of d){const f=Array.from(p.values());for(const a of f){const g=await a.value;g&&v.push(g)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:d}of v.values())await d.then(p=>p?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,d,p,f,a=!1,g,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${p} on local port ${f}.`),!v)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(v,d,p,f,a,g,s);return u?u.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const d=this._tunnels.get(v.tunnelRemoteHost);if(d){const p=d.get(v.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,p))}}}}async tryDisposeTunnel(v,d,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${d}.`);const f=p.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(d),f}}async closeTunnel(v,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${d} `);const p=this._tunnels.get(v);if(p&&p.has(d)){const f=p.get(d);f.refcount=0,await this.tryDisposeTunnel(v,d,f)}}addTunnelToMap(v,d,p){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(d,{refcount:1,value:p})}async removeEmptyTunnelFromMap(v,d){const p=this._tunnels.get(v);p&&(await p.get(d)||p.delete(d),p.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,d){const p=[v];R(v)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):k(v)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const f=p.map(a=>this._tunnels.get(a));for(const a of f){const g=a?.get(d);if(g)return g}}canTunnel(v){return!!I(v)}createWithProvider(v,d,p,f,a,g,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${p} on local port ${f}.`);const u=p;this._factoryInProgress.add(u);const i={elevationRequired:a?S(f===void 0?p:f):!1},r={remoteAddress:{host:d,port:p},localAddressPort:f,privacy:g,public:g?g!==y.Private:void 0,protocol:s},n=v.forwardPort(r,i);return n?(this.addTunnelToMap(d,p,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),n}};w=qe([xe(0,P.ILogService)],w),e.AbstractTunnelService=w}),define(De[202],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(E){return E.scheme!==l.Schemas.file&&E.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function D(E){if(E.folders.length)return E.folders.every(I=>t(I.uri))?E.folders[0].uri:void 0;if(E.configuration&&t(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=D;function P(E){return D(E)?.scheme}e.getVirtualWorkspaceScheme=P;function _(E){return D(E)?.authority}e.getVirtualWorkspaceAuthority=_;function y(E){return D(E)!==void 0}e.isVirtualWorkspace=y}),define(De[45],Ie([1,0,168,9,25,22,2,3,12]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function I(o){const i=o;return typeof i?.id=="string"&&_.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=I;function R(o){if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(o){const i=o;return typeof i?.id=="string"&&_.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=k;function S(o){const i=o;if(i?.uri)return{id:i.id,uri:_.URI.revive(i.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var T;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function w(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=w;function b(o){const i=o;return!!(i&&typeof i=="object"&&_.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=b;class v{constructor(i,r,n,c,h){this._id=i,this._transient=n,this._configuration=c,this._ignorePathCasing=h,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class d{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,P.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function p(o){return new d({uri:o,index:0,name:(0,P.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(o,i){return P.extUriBiasedIgnorePathCase.isEqualOrParent(o,i.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function g(o){let i;return _.URI.isUri(o)?i=o:i=o.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=g;function s(o,i){return!a(o,i)&&!g(o)}e.isSavedWorkspace=s;function u(o){return(typeof o=="string"?(0,t.extname)(o):(0,P.extname)(o))===f}e.hasWorkspaceFileExtension=u}),define(De[87],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const P=this._idPool++;return this._data.set(P,D),this.logDebugInfo(),P}get(D,P){return this._data.has(D)?this._data.get(D)[P]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(De[46],Ie([1,0,12,22,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(y=>{const E=this._providerInfo.get(y.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(y,E){E===null?this._providerInfo.delete(y.scheme):this._providerInfo.set(y.scheme,E)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(De[203],Ie([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(_,y,E){this._deferredPromises=new Map,this._id=_,this._shared=y,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of I.values())R.complete()}catch(R){for(const k of I.values())k.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,y){let E=this._value[_];return typeof E>"u"&&(E=y),E}update(_,y){this._value[_]=y;const E=this._deferredPromises.get(_);if(E!==void 0)return E.p;const I=new l.DeferredPromise;return this._deferredPromises.set(_,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class D extends t{constructor(_,y){super(_.identifier.value,!0,y),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=D}),define(De[204],Ie([1,0,4,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,y,E,I){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptModelChanged(y.value,E,I);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(_,y){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptDirty(y)}$acceptModelSaved(_){const y=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(De[15],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[205],Ie([1,0,27,4]),function(J,e,l,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(y,E){D.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(y.identifier),tt(this,D,E,"f"),Ue(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(y){return Ue(this,D,"f").get(this._id,y)}store(y,E){return Ue(this,D,"f").store(this._id,y,E)}delete(y){return Ue(this,D,"f").delete(this._id,y)}}e.ExtensionSecrets=P,D=new WeakMap}),define(De[124],Ie([1,0,3,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,y){this._level=_,this._productConfig=y||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(De[53],Ie([1,0,3,123,4,15]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(E){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}E.fromApiTunnel=I;function R(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}E.fromServiceTunnel=R})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let y=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,R){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,R){return{dispose:()=>{}}}async $providePortAttributes(I,R,k,S,T){return[]}async $forwardPort(I,R){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([xe(0,P.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,10,105,25,100,8,13,2,34,42,121]),function(J,e,l,t,D,P,_,y,E,I,R,k,S){"use strict";var T,w,b,v,d,p,f,a,g,s,u,o,i,r,n,c,h,m,C,L,U,B,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function M(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let $=p=class{constructor(W){T.set(this,void 0),tt(this,T,W,"f")}static from(...W){let ce=W;return new p(function(){if(ce){for(const Ae of ce)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();ce=void 0}})}dispose(){typeof Ue(this,T,"f")=="function"&&(Ue(this,T,"f").call(this),tt(this,T,void 0,"f"))}};T=new WeakMap,$=p=qe([M],$),e.Disposable=$;let N=f=class{constructor(W,ce){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(ce<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=ce}static Min(...W){if(W.length===0)throw new TypeError;let ce=W[0];for(let Ae=1;Ae<W.length;Ae++){const Qe=W[Ae];Qe.isBefore(ce)&&(ce=Qe)}return ce}static Max(...W){if(W.length===0)throw new TypeError;let ce=W[0];for(let Ae=1;Ae<W.length;Ae++){const Qe=W[Ae];Qe.isAfter(ce)&&(ce=Qe)}return ce}static isPosition(W){if(!W)return!1;if(W instanceof f)return!0;const{line:ce,character:Ae}=W;return typeof ce=="number"&&typeof Ae=="number"}static of(W){if(W instanceof f)return W;if(this.isPosition(W))return new f(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ce=0){if(W===null||ce===null)throw(0,t.illegalArgument)();let Ae;return typeof W>"u"?Ae=0:typeof W=="number"?Ae=W:(Ae=typeof W.lineDelta=="number"?W.lineDelta:0,ce=typeof W.characterDelta=="number"?W.characterDelta:0),Ae===0&&ce===0?this:new f(this.line+Ae,this.character+ce)}with(W,ce=this.character){if(W===null||ce===null)throw(0,t.illegalArgument)();let Ae;return typeof W>"u"?Ae=this.line:typeof W=="number"?Ae=W:(Ae=typeof W.line=="number"?W.line:this.line,ce=typeof W.character=="number"?W.character:this.character),Ae===this.line&&ce===this.character?this:new f(Ae,ce)}toJSON(){return{line:this.line,character:this.character}}};N=f=qe([M],N),e.Position=N;let K=a=class{constructor(W,ce,Ae,Qe){let rt,lt;if(typeof W=="number"&&typeof ce=="number"&&typeof Ae=="number"&&typeof Qe=="number"?(rt=new N(W,ce),lt=new N(Ae,Qe)):N.isPosition(W)&&N.isPosition(ce)&&(rt=N.of(W),lt=N.of(ce)),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange(W){return W instanceof a?!0:W?N.isPosition(W.start)&&N.isPosition(W.end):!1}static of(W){if(W instanceof a)return W;if(this.isRange(W))return new a(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return a.isRange(W)?this.contains(W.start)&&this.contains(W.end):N.isPosition(W)?!(N.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ce=N.Max(W.start,this._start),Ae=N.Min(W.end,this._end);if(!ce.isAfter(Ae))return new a(ce,Ae)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ce=N.Min(W.start,this._start),Ae=N.Max(W.end,this.end);return new a(ce,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ce=this.end){if(W===null||ce===null)throw(0,t.illegalArgument)();let Ae;return W?N.isPosition(W)?Ae=W:(Ae=W.start||this.start,ce=W.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&ce.isEqual(this.end)?this:new a(Ae,ce)}toJSON(){return[this.start,this.end]}};K=a=qe([M],K),e.Range=K;let z=g=class extends K{constructor(W,ce,Ae,Qe){let rt,lt;if(typeof W=="number"&&typeof ce=="number"&&typeof Ae=="number"&&typeof Qe=="number"?(rt=new N(W,ce),lt=new N(Ae,Qe)):N.isPosition(W)&&N.isPosition(ce)&&(rt=N.of(W),lt=N.of(ce)),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt),this._anchor=rt,this._active=lt}static isSelection(W){return W instanceof g?!0:W?K.isRange(W)&&N.isPosition(W.anchor)&&N.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=g=qe([M],z),e.Selection=z;class O{constructor(W,ce,Ae){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,t.illegalArgument)("port");if(typeof Ae<"u"&&(typeof Ae!="string"||Ae.length===0||!/^[0-9A-Za-z\-]+$/.test(Ae)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ce),this.connectionToken=Ae}}e.ResolvedAuthority=O;class x extends Error{constructor(W,ce=S.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(W),this._message=W,this._code=ce,this._detail=Ae,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(W,ce){return new x(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(W){return new x(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var V;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=s=class{constructor(W,ce){this._range=W,this._newText=ce}static isTextEdit(W){return W instanceof s?!0:W?K.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ce){return new s(W,ce)}static insert(W,ce){return s.replace(new K(W,W),ce)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const ce=new s(new K(new N(0,0),new N(0,0)),"");return ce.newEol=W,ce}get range(){return this._range}set range(W){if(W&&!K.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Y=s=qe([M],Y),e.TextEdit=Y;let Q=u=class{constructor(W,ce){this.range=W,this.newCells=ce}static isNotebookCellEdit(W){return W instanceof u?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ce){return new u(W,ce)}static insertCells(W,ce){return new u(new Vt(W,W),ce)}static deleteCells(W){return new u(W,[])}static updateCellMetadata(W,ce){const Ae=new u(new Vt(W,W),[]);return Ae.newCellMetadata=ce,Ae}static updateNotebookMetadata(W){const ce=new u(new Vt(0,0),[]);return ce.newNotebookMetadata=W,ce}};Q=u=qe([M],Q),e.NotebookEdit=Q;var he;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(he=e.FileEditType||(e.FileEditType={}));let ve=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ce,Ae,Qe){this._edits.push({_type:1,from:W,to:ce,options:Ae,metadata:Qe})}createFile(W,ce,Ae){this._edits.push({_type:1,from:void 0,to:W,options:ce,metadata:Ae})}deleteFile(W,ce,Ae){this._edits.push({_type:1,from:W,to:void 0,options:ce,metadata:Ae})}replaceNotebookMetadata(W,ce,Ae){this._edits.push({_type:3,metadata:Ae,uri:W,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(W,ce,Ae,Qe){const rt=ce.start,lt=ce.end;(rt!==lt||Ae.length>0)&&this._edits.push({_type:5,uri:W,index:rt,count:lt-rt,cells:Ae,metadata:Qe})}replaceNotebookCellMetadata(W,ce,Ae,Qe){this._edits.push({_type:3,metadata:Qe,uri:W,edit:{editType:8,index:ce,metadata:Ae}})}replace(W,ce,Ae,Qe){typeof Ae=="string"?this._edits.push({_type:2,uri:W,edit:new Y(ce,Ae),metadata:Qe}):this._edits.push({_type:6,uri:W,range:ce,edit:Ae,metadata:Qe})}insert(W,ce,Ae,Qe){this.replace(W,new K(ce,ce),Ae,Qe)}delete(W,ce,Ae){this.replace(W,ce,"",Ae)}has(W){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===W.toString())}set(W,ce){if(ce)for(const Ae of ce)Ae&&(Q.isNotebookCellEdit(Ae)?Ae.newCellMetadata?this.replaceNotebookCellMetadata(W,Ae.range.start,Ae.newCellMetadata):Ae.newNotebookMetadata?this.replaceNotebookMetadata(W,Ae.newNotebookMetadata):this.replaceNotebookCells(W,Ae.range,Ae.newCells):this._edits.push({_type:2,uri:W,edit:Ae}));else{for(let Ae=0;Ae<this._edits.length;Ae++){const Qe=this._edits[Ae];Qe._type===2&&Qe.uri.toString()===W.toString()&&(this._edits[Ae]=void 0)}(0,l.coalesceInPlace)(this._edits)}}get(W){const ce=[];for(const Ae of this._edits)Ae._type===2&&Ae.uri.toString()===W.toString()&&ce.push(Ae.edit);return ce}entries(){const W=new P.ResourceMap;for(const ce of this._edits)if(ce._type===2){let Ae=W.get(ce.uri);Ae||(Ae=[ce.uri,[]],W.set(ce.uri,Ae)),Ae[1].push(ce.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ve=qe([M],ve),e.WorkspaceEdit=ve;let ne=o=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=o._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ce=this._tabstop++){if(typeof W=="function"){const Ae=new o;Ae._tabstop=this._tabstop,W(Ae),this._tabstop=Ae._tabstop,W=Ae.value}else W=o._escape(W);return this.value+="${",this.value+=ce,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ce=this._tabstop++){const Ae=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(W,ce){if(typeof ce=="function"){const Ae=new o;Ae._tabstop=this._tabstop,ce(Ae),this._tabstop=Ae._tabstop,ce=Ae.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ne=o=qe([M],ne),e.SnippetString=ne;var pe;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(pe=e.DiagnosticTag||(e.DiagnosticTag={}));var be;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(be=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=i=class{constructor(W,ce){if(this.uri=W,ce)if(K.isRange(ce))this.range=K.of(ce);else if(N.isPosition(ce))this.range=new K(ce,ce);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof i?!0:W?K.isRange(W.range)&&I.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ke=i=qe([M],ke),e.Location=ke;let Le=class{constructor(W,ce){this.location=W,this.message=ce}static is(W){return W?typeof W.message=="string"&&W.location&&K.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}static isEqual(W,ce){return W===ce?!0:!W||!ce?!1:W.message===ce.message&&W.location.range.isEqual(ce.location.range)&&W.location.uri.toString()===ce.location.uri.toString()}};Le=qe([M],Le),e.DiagnosticRelatedInformation=Le;let We=class{constructor(W,ce,Ae=be.Error){if(!K.isRange(W))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=W,this.message=ce,this.severity=Ae}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ce){return W===ce?!0:!W||!ce?!1:W.message===ce.message&&W.severity===ce.severity&&W.code===ce.code&&W.severity===ce.severity&&W.source===ce.source&&W.range.isEqual(ce.range)&&(0,l.equals)(W.tags,ce.tags)&&(0,l.equals)(W.relatedInformation,ce.relatedInformation,Le.isEqual)}};We=qe([M],We),e.Diagnostic=We;let oe=class{constructor(W,ce){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ce}};oe=qe([M],oe),e.Hover=oe;var ue;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let fe=class{constructor(W,ce=ue.Text){this.range=W,this.kind=ce}toJSON(){return{range:this.range,kind:ue[this.kind]}}};fe=qe([M],fe),e.DocumentHighlight=fe;var Z;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Z=e.SymbolKind||(e.SymbolKind={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(W,ce,Ae,Qe,rt){this.name=W,this.kind=ce,this.containerName=rt,typeof Ae=="string"&&(this.containerName=Ae),Qe instanceof ke?this.location=Qe:Ae instanceof K&&(this.location=new ke(Qe,Ae)),r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Z[this.kind],location:this.location,containerName:this.containerName}}};ee=r=qe([M],ee),e.SymbolInformation=ee;let ie=n=class{constructor(W,ce,Ae,Qe,rt){this.name=W,this.detail=ce,this.kind=Ae,this.range=Qe,this.selectionRange=rt,this.children=[],n.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}};ie=n=qe([M],ie),e.DocumentSymbol=ie;var F;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let H=class{constructor(W,ce){this.title=W,this.kind=ce}};H=qe([M],H),e.CodeAction=H;let G=c=class{constructor(W){this.value=W}append(W){return new c(this.value?this.value+c.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+c.sep)}};G.sep=".",G=c=qe([M],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let X=class{constructor(W,ce){if(this.range=W,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};X=qe([M],X),e.SelectionRange=X;class me{constructor(W,ce,Ae,Qe,rt,lt){this.kind=W,this.name=ce,this.detail=Ae,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=me;class we{constructor(W,ce){this.fromRanges=ce,this.from=W}}e.CallHierarchyIncomingCall=we;class le{constructor(W,ce){this.fromRanges=ce,this.to=W}}e.CallHierarchyOutgoingCall=le;var Ce;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ce=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ye=class{constructor(W,ce){this.range=W,this.command=ce}get isResolved(){return!!this.command}};ye=qe([M],ye),e.CodeLens=ye;let $e=h=class{constructor(W,ce=!1){w.set(this,void 0),tt(this,w,new D.MarkdownString(W,{supportThemeIcons:ce}),"f")}static isMarkdownString(W){return W instanceof h?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Ue(this,w,"f").value}set value(W){Ue(this,w,"f").value=W}get isTrusted(){return Ue(this,w,"f").isTrusted}set isTrusted(W){Ue(this,w,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,w,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,w,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,w,"f").supportHtml}set supportHtml(W){Ue(this,w,"f").supportHtml=W}get baseUri(){return Ue(this,w,"f").baseUri}set baseUri(W){Ue(this,w,"f").baseUri=W}appendText(W){return Ue(this,w,"f").appendText(W),this}appendMarkdown(W){return Ue(this,w,"f").appendMarkdown(W),this}appendCodeblock(W,ce){return Ue(this,w,"f").appendCodeblock(ce??"",W),this}};w=new WeakMap,$e=h=qe([M],$e),e.MarkdownString=$e;let je=class{constructor(W,ce){this.label=W,this.documentation=ce}};je=qe([M],je),e.ParameterInformation=je;let Ze=class{constructor(W,ce){this.label=W,this.documentation=ce,this.parameters=[]}};Ze=qe([M],Ze),e.SignatureInformation=Ze;let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ye=qe([M],Ye),e.SignatureHelp=Ye;var Oe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ot;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ot=e.InlayHintKind||(e.InlayHintKind={}));let re=class{constructor(W){this.value=W}};re=qe([M],re),e.InlayHintLabelPart=re;let se=class{constructor(W,ce,Ae){this.position=W,this.label=ce,this.kind=Ae}};se=qe([M],se),e.InlayHint=se;var Ee;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ee=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var de;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(de=e.CompletionItemKind||(e.CompletionItemKind={}));var Te;(function(j){j[j.Deprecated=1]="Deprecated"})(Te=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(W,ce){this.label=W,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&de[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=qe([M],Ne),e.CompletionItem=Ne;let Be=class{constructor(W=[],ce=!1){this.items=W,this.isIncomplete=ce}};Be=qe([M],Be),e.CompletionList=Be;let ze=class{constructor(W,ce,Ae){this.insertText=W,this.range=ce,this.command=Ae}};ze=qe([M],ze),e.InlineSuggestion=ze;let Xe=class{constructor(W){this.commands=void 0,this.items=W}};Xe=qe([M],Xe),e.InlineSuggestionList=Xe;let nt=class{constructor(W,ce,Ae){this.insertText=W,this.range=ce,this.command=Ae}};nt=qe([M],nt),e.InlineSuggestionNew=nt;let ct=class{constructor(W,ce){this.items=W,this.commands=ce}};ct=qe([M],ct),e.InlineSuggestionsNew=ct;var st;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var et;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(et=e.StatusBarAlignment||(e.StatusBarAlignment={}));var gt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(gt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Dt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Dt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var It;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(It=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Mt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Mt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(ce){switch(ce){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(W,ce){if(ce&&!I.URI.isUri(ce))throw(0,t.illegalArgument)("target");if(!K.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=ce}};Ot=qe([M],Ot),e.DocumentLink=Ot;let Ge=class{constructor(W,ce,Ae,Qe){this.red=W,this.green=ce,this.blue=Ae,this.alpha=Qe}};Ge=qe([M],Ge),e.Color=Ge;let Ft=class{constructor(W,ce){if(ce&&!(ce instanceof Ge))throw(0,t.illegalArgument)("color");if(!K.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=ce}};Ft=qe([M],Ft),e.ColorInformation=Ft;let At=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};At=qe([M],At),e.ColorPresentation=At;var Nt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var vt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(vt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var kt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(kt=e.TerminalExitReason||(e.TerminalExitReason={}));class Pe{constructor(W,ce,Ae){if(this.startIndex=W,this.length=ce,this.tooltip=Ae,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,t.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Pe;var Re;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Re=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var te;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=m=class{constructor(W,ce){if(this.label=ce,typeof W!="string"||typeof ce!="string")throw(0,t.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};Ve.Clean=new m("clean","Clean"),Ve.Build=new m("build","Build"),Ve.Rebuild=new m("rebuild","Rebuild"),Ve.Test=new m("test","Test"),Ve=m=qe([M],Ve),e.TaskGroup=Ve;function it(j){let W="";for(let ce=0;ce<j.length;ce++)W+=j[ce].replace(/,/g,",,")+",";return W}let Ke=class{constructor(W,ce,Ae){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=Ae):this._options=ce)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ce of this._args)W.push(ce);return it(W)}};Ke=qe([M],Ke),e.ProcessExecution=Ke;let Je=class{constructor(W,ce,Ae){if(this._args=[],Array.isArray(ce)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=ce,this._options=Ae}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ce of this._args)W.push(typeof ce=="string"?ce:ce.value);return it(W)}};Je=qe([M],Je),e.ShellExecution=Je;var ut;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var Tt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Tt=e.TaskScope||(e.TaskScope={}));class Et{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Et;let _t=C=class{constructor(W,ce,Ae,Qe,rt,lt){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=Ae,this.execution=Qe,ht=rt,this.__deprecated=!0):ce===Tt.Global||ce===Tt.Workspace?(this.target=ce,this._name=this.name=Ae,this._source=this.source=Qe,this.execution=rt,ht=lt):(this.target=ce,this._name=this.name=Ae,this._source=this.source=Qe,this.execution=rt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ce=this._definition.type;(C.EmptyType===ce||C.ProcessType===ce||C.ShellType===ce||C.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};_t.ExtensionCallbackType="customExecution",_t.ProcessType="process",_t.ShellType="shell",_t.EmptyType="$empty",_t=C=qe([M],_t),e.Task=_t;var yt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));let pt=L=class{constructor(W,ce=Ct.None){this.collapsibleState=ce,I.URI.isUri(W)?this.resourceUri=W:this.label=W}static isTreeItem(W){if(W instanceof L)return!0;const ce=W;if(ce.label!==void 0&&!(0,E.isString)(ce.label)&&!ce.label?.label)return console.log("INVALID tree item, invalid label",ce.label),!1;if(ce.id!==void 0&&!(0,E.isString)(ce.id))return console.log("INVALID tree item, invalid id",ce.id),!1;if(ce.iconPath!==void 0&&!(0,E.isString)(ce.iconPath)&&!I.URI.isUri(ce.iconPath)&&(!ce.iconPath||!(0,E.isString)(ce.iconPath.id))){const Ae=ce.iconPath;if(!Ae||!(0,E.isString)(Ae.light)&&!I.URI.isUri(Ae.light)&&!(0,E.isString)(Ae.dark)&&!I.URI.isUri(Ae.dark))return console.log("INVALID tree item, invalid iconPath",ce.iconPath),!1}return ce.description!==void 0&&!(0,E.isString)(ce.description)&&typeof ce.description!="boolean"?(console.log("INVALID tree item, invalid description",ce.description),!1):ce.resourceUri!==void 0&&!I.URI.isUri(ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ce.resourceUri),!1):ce.tooltip!==void 0&&!(0,E.isString)(ce.tooltip)&&!(ce.tooltip instanceof $e)?(console.log("INVALID tree item, invalid tooltip",ce.tooltip),!1):ce.command!==void 0&&!ce.command.command?(console.log("INVALID tree item, invalid command",ce.command),!1):ce.collapsibleState!==void 0&&ce.collapsibleState<Ct.None&&ce.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ce.collapsibleState),!1):ce.contextValue!==void 0&&!(0,E.isString)(ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",ce.contextValue),!1):ce.accessibilityInformation!==void 0&&!ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ce.accessibilityInformation),!1):!0}};pt=L=qe([M],pt),e.TreeItem=pt;var Ct;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Qt=class{constructor(W){this.value=W}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Qt=qe([M],Qt),e.DataTransferItem=Qt;let bt=class{constructor(W){b.set(this,new Map);for(const[ce,Ae]of W??[]){const Qe=Ue(this,b,"f").get(ce);Qe?Qe.push(Ae):Ue(this,b,"f").set(ce,[Ae])}}get(W){return Ue(this,b,"f").get(W)?.[0]}set(W,ce){Ue(this,b,"f").set(W,[ce])}forEach(W,ce){for(const[Ae,Qe]of Ue(this,b,"f"))for(const rt of Qe)W.call(ce,rt,Ae,this)}*[(b=new WeakMap,Symbol.iterator)](){for(const[W,ce]of Ue(this,b,"f"))for(const Ae of ce)yield[W,Ae]}};bt=qe([M],bt),e.DataTransfer=bt;let qt=class{constructor(W){this.insertText=W}};qt=qe([M],qt),e.DocumentDropEdit=qt;let Ht=class{constructor(W){this.insertText=W}};Ht=qe([M],Ht),e.DocumentPasteEdit=Ht;let zt=class{constructor(W,ce){this.id=W,this.color=ce}};zt=qe([M],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let mn=class{constructor(W){this.id=W}};mn=qe([M],mn),e.ThemeColor=mn;var Rt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Rt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let sn=class{constructor(W,ce){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof ce!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ce}get base(){return this._base}set base(W){this._base=W,this._baseUri=I.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};sn=qe([M],sn),e.RelativePattern=sn;let Yt=class{constructor(W,ce,Ae,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ce=="string"&&(this.condition=ce),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Yt=qe([M],Yt),e.Breakpoint=Yt;let Jt=class extends Yt{constructor(W,ce,Ae,Qe,rt){if(super(ce,Ae,Qe,rt),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Jt=qe([M],Jt),e.SourceBreakpoint=Jt;let Zt=class extends Yt{constructor(W,ce,Ae,Qe,rt){super(ce,Ae,Qe,rt),this.functionName=W}};Zt=qe([M],Zt),e.FunctionBreakpoint=Zt;let dt=class extends Yt{constructor(W,ce,Ae,Qe,rt,lt,ht){if(super(Qe,rt,lt,ht),!ce)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=ce,this.canPersist=Ae}};dt=qe([M],dt),e.DataBreakpoint=dt;let gn=class{constructor(W,ce,Ae){this.command=W,this.args=ce||[],this.options=Ae}};gn=qe([M],gn),e.DebugAdapterExecutable=gn;let Wt=class{constructor(W,ce){this.port=W,this.host=ce}};Wt=qe([M],Wt),e.DebugAdapterServer=Wt;let Gt=class{constructor(W){this.path=W}};Gt=qe([M],Gt),e.DebugAdapterNamedPipeServer=Gt;let on=class{constructor(W){this.implementation=W}};on=qe([M],on),e.DebugAdapterInlineImplementation=on;let pn=class{constructor(W,ce){this.range=W,this.expression=ce}};pn=qe([M],pn),e.EvaluatableExpression=pn;var Cn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var An;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(An=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let an=class{constructor(W,ce){this.range=W,this.text=ce}};an=qe([M],an),e.InlineValueText=an;let en=class{constructor(W,ce,Ae=!0){this.range=W,this.variableName=ce,this.caseSensitiveLookup=Ae}};en=qe([M],en),e.InlineValueVariableLookup=en;let vn=class{constructor(W,ce){this.range=W,this.expression=ce}};vn=qe([M],vn),e.InlineValueEvaluatableExpression=vn;let nn=class{constructor(W,ce){this.frameId=W,this.stoppedLocation=ce}};nn=qe([M],nn),e.InlineValueContext=nn;var bn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(bn=e.FileChangeType||(e.FileChangeType={}));let wn=U=class extends Error{constructor(W,ce=k.FileSystemProviderErrorCode.Unknown,Ae){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Ae?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}static FileExists(W){return new U(W,k.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(W){return new U(W,k.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(W){return new U(W,k.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(W){return new U(W,k.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(W){return new U(W,k.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(W){return new U(W,k.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}};wn=U=qe([M],wn),e.FileSystemError=wn;let En=class{constructor(W,ce,Ae){this.start=W,this.end=ce,this.kind=Ae}};En=qe([M],En),e.FoldingRange=En;var rn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Rn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ln;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Ln=e.CommentMode||(e.CommentMode={}));var On;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(On=e.CommentThreadState||(e.CommentThreadState={}));class Fn{constructor(W,ce=[]){this.tokenTypes=W,this.tokenModifiers=ce}}e.SemanticTokensLegend=Fn;function Sn(j){return typeof j>"u"||(0,E.isStringArray)(j)}class cn{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ce=0,Ae=W.tokenTypes.length;ce<Ae;ce++)this._tokenTypeStrToInt.set(W.tokenTypes[ce],ce);for(let ce=0,Ae=W.tokenModifiers.length;ce<Ae;ce++)this._tokenModifierStrToInt.set(W.tokenModifiers[ce],ce)}}push(W,ce,Ae,Qe,rt){if(typeof W=="number"&&typeof ce=="number"&&typeof Ae=="number"&&typeof Qe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this._pushEncoded(W,ce,Ae,Qe,rt);if(K.isRange(W)&&typeof ce=="string"&&Sn(Ae))return this._push(W,ce,Ae);throw(0,t.illegalArgument)()}_push(W,ce,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,rt=W.start.character,lt=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(ce);let Lt=0;if(Ae)for(const Bt of Ae){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Bt);Lt|=1<<$t>>>0}this._pushEncoded(Qe,rt,lt,ht,Lt)}_pushEncoded(W,ce,Ae,Qe,rt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Bt=0,$t=0;for(let jt=0;jt<Lt;jt++){let Kt=this._data[5*jt],_n=this._data[5*jt+1];Kt===0?(Kt=Bt,_n+=$t):Kt+=Bt,this._data[5*jt]=Kt,this._data[5*jt+1]=_n,Bt=Kt,$t=_n}}let lt=W,ht=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=rt,this._prevLine=W,this._prevChar=ce}static _sortAndDeltaEncode(W){const ce=[],Ae=W.length/5|0;for(let ht=0;ht<Ae;ht++)ce[ht]=ht;ce.sort((ht,Lt)=>{const Bt=W[5*ht],$t=W[5*Lt];if(Bt===$t){const jt=W[5*ht+1],Kt=W[5*Lt+1];return jt-Kt}return Bt-$t});const Qe=new Uint32Array(W.length);let rt=0,lt=0;for(let ht=0;ht<Ae;ht++){const Lt=5*ce[ht],Bt=W[Lt+0],$t=W[Lt+1],jt=W[Lt+2],Kt=W[Lt+3],_n=W[Lt+4],Qn=Bt-rt,wi=Qn===0?$t-lt:$t,yn=5*ht;Qe[yn+0]=Qn,Qe[yn+1]=wi,Qe[yn+2]=jt,Qe[yn+3]=Kt,Qe[yn+4]=_n,rt=Bt,lt=$t}return Qe}build(W){return this._dataIsSortedAndDeltaEncoded?new ln(new Uint32Array(this._data),W):new ln(cn._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=cn;class ln{constructor(W,ce){this.resultId=ce,this.data=W}}e.SemanticTokens=ln;class He{constructor(W,ce,Ae){this.start=W,this.deleteCount=ce,this.data=Ae}}e.SemanticTokensEdit=He;class xt{constructor(W,ce){this.resultId=ce,this.edits=W}}e.SemanticTokensEdits=xt;var Dn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let mt=class{constructor(){}};mt.Back={iconPath:new zt("arrow-left")},mt=qe([M],mt),e.QuickInputButtons=mt;var Nn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Nn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Mn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Mn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var In;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(In=e.ExtensionKind||(e.ExtensionKind={}));class Un{constructor(W,ce,Ae){this.badge=W,this.tooltip=ce,this.color=Ae}static validate(W){if(W.badge){let ce=(0,y.nextCharLength)(W.badge,0);if(ce<W.badge.length&&(ce+=(0,y.nextCharLength)(W.badge,ce)),W.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Un;let tn=class{constructor(W){this.kind=W}};tn=qe([M],tn),e.ColorTheme=tn;var Bn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Bn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(W,ce){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(ce<0)throw(0,t.illegalArgument)("end must be positive");W<=ce?(this._start=W,this._end=ce):(this._start=ce,this._end=W)}static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let ce=this._start,Ae=this._end;return W.start!==void 0&&(ce=W.start),W.end!==void 0&&(Ae=W.end),ce===this._start&&Ae===this._end?this:new Vt(ce,Ae)}}e.NotebookRange=Vt;class un{constructor(W,ce,Ae,Qe,rt,lt,ht){this.kind=W,this.value=ce,this.languageId=Ae,this.mime=Qe,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ht,un.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ce=>un.isNotebookCellData(ce))}static isNotebookCellData(W){return!0}}e.NotebookCellData=un;class kn{constructor(W){this.cells=W}}e.NotebookData=kn;class Ut{constructor(W,ce){this.data=W,this.mime=ce;const Ae=(0,_.normalizeMimeType)(ce,!0);if(!Ae)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}static isNotebookCellOutputItem(W){return W instanceof Ut?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ce={name:W.name,message:W.message,stack:W.stack};return Ut.json(ce,"application/vnd.code.notebook.error")}static stdout(W){return Ut.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Ut.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ce="application/octet-stream"){return new Ut(W,ce)}static text(W,ce=_.Mimes.text){const Ae=Ue(Ut,v,"f",d).encode(String(W));return new Ut(Ae,ce)}static json(W,ce="text/x-json"){const Ae=JSON.stringify(W,void 0,"	");return Ut.text(Ae,ce)}}e.NotebookCellOutputItem=Ut,v=Ut,d={value:new TextEncoder};class dn{constructor(W,ce,Ae){this.items=dn.ensureUniqueMimeTypes(W,!0),typeof ce=="string"?(this.id=ce,this.metadata=Ae):(this.id=(0,R.generateUuid)(),this.metadata=ce??Ae)}static isNotebookCellOutput(W){return W instanceof dn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ce=!1){const Ae=new Set,Qe=new Set;for(let rt=0;rt<W.length;rt++){const lt=W[rt],ht=(0,_.normalizeMimeType)(lt.mime);if(!Ae.has(ht)){Ae.add(ht);continue}Qe.add(rt),ce&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Qe.size===0?W:W.filter((rt,lt)=>!Qe.has(lt))}}e.NotebookCellOutput=dn;var zn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(zn=e.NotebookCellKind||(e.NotebookCellKind={}));var Wn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Wn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var $n;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})($n=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ge;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ge=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Se{constructor(W,ce){this.text=W,this.alignment=ce}}e.NotebookCellStatusBarItem=Se;var Me;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Me=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class at{constructor(W,ce=[]){this.uri=W,this.provides=(0,l.asArray)(ce)}}e.NotebookRendererScript=at;let St=class{constructor(W,ce){this.label=W,this.timestamp=ce}};St=qe([M],St),e.TimelineItem=St;var Pt;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Pt=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(W,ce){this.ranges=W,this.wordPattern=ce}}e.LinkedEditingRanges=ni;class ii{constructor(W,ce){this._port=W,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ii;var ri;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hn=class{constructor(W=void 0,ce=void 0,Ae=void 0){this.include=W,this.exclude=ce,this.profile=Ae}};Hn=qe([M],Hn),e.TestRunRequest=Hn;let xn=B=class{constructor(W){this.message=W}static diff(W,ce,Ae){const Qe=new B(W);return Qe.expectedOutput=ce,Qe.actualOutput=Ae,Qe}};xn=B=qe([M],xn),e.TestMessage=xn;let Vn=class{constructor(W){this.id=W}};Vn=qe([M],Vn),e.TestTag=Vn;let hn=class{constructor(W,ce){this.covered=W,this.total=ce}};hn=qe([M],hn),e.CoveredCount=hn;let jn=A=class{constructor(W,ce,Ae,Qe){this.uri=W,this.statementCoverage=ce,this.branchCoverage=Ae,this.functionCoverage=Qe}static fromDetails(W,ce){const Ae=new hn(0,0),Qe=new hn(0,0),rt=new hn(0,0);for(const ht of ce)if("branches"in ht){Ae.total+=1,Ae.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)Qe.total+=1,Qe.covered+=Lt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const lt=new A(W,Ae,Qe.total>0?Qe:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ce,lt}};jn=A=qe([M],jn),e.FileCoverage=jn;let qn=class{constructor(W,ce,Ae=[]){this.executionCount=W,this.location=ce,this.branches=Ae}};qn=qe([M],qn),e.StatementCoverage=qn;let Gn=class{constructor(W,ce){this.executionCount=W,this.location=ce}};Gn=qe([M],Gn),e.BranchCoverage=Gn;let Kn=class{constructor(W,ce){this.executionCount=W,this.location=ce}};Kn=qe([M],Kn),e.FunctionCoverage=Kn;var oi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ci;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class li{constructor(W,ce,Ae,Qe,rt,lt){this.kind=W,this.name=ce,this.detail=Ae,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=li;class ui{constructor(W){this.uri=W}}e.TextTabInput=ui;class di{constructor(W,ce){this.original=W,this.modified=ce}}e.TextDiffTabInput=di;class hi{constructor(W,ce,Ae,Qe){this.base=W,this.input1=ce,this.input2=Ae,this.result=Qe}}e.TextMergeTabInput=hi;class fi{constructor(W,ce){this.uri=W,this.viewType=ce}}e.CustomEditorTabInput=fi;class mi{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=mi;class gi{constructor(W,ce){this.uri=W,this.notebookType=ce}}e.NotebookEditorTabInput=gi;class pi{constructor(W,ce,Ae){this.original=W,this.modified=ce,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=pi;class vi{constructor(){}}e.TerminalEditorTabInput=vi;class bi{constructor(W,ce){this.uri=W,this.inputBoxUri=ce}}e.InteractiveWindowInput=bi}),define(De[125],Ie([1,0,48,12,8,158,98,7,17]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function R(w,b){b?I.set(w,b):I.delete(w)}e.setWordDefinitionFor=R;function k(w){return I.get(w)}e.getWordDefinitionFor=k;class S extends P.MirrorTextModel{constructor(b,v,d,p,f,a,g,s){super(v,d,p,f),this._proxy=b,this._languageId=a,this._isDirty=g,this.notebook=s,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(b){return(0,E.equals)(this._lines,b)}get document(){if(!this._document){const b=this;this._document={get uri(){return b._uri},get fileName(){return b._uri.fsPath},get isUntitled(){return b._uri.scheme===t.Schemas.untitled},get languageId(){return b._languageId},get version(){return b._versionId},get isClosed(){return b._isDisposed},get isDirty(){return b._isDirty},save(){return b._save()},getText(v){return v?b._getTextInRange(v):b.getText()},get eol(){return b._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return b._lines.length},lineAt(v){return b._lineAt(v)},offsetAt(v){return b._offsetAt(v)},positionAt(v){return b._positionAt(v)},validateRange(v){return b._validateRange(v)},validatePosition(v){return b._validatePosition(v)},getWordRangeAtPosition(v,d){return b._getWordRangeAtPosition(v,d)}}}return Object.freeze(this._document)}_acceptLanguageId(b){(0,l.ok)(!this._isDisposed),this._languageId=b}_acceptIsDirty(b){(0,l.ok)(!this._isDisposed),this._isDirty=b}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(b){const v=this._validateRange(b);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const d=this._eol,p=v.start.line,f=v.end.line,a=[];a.push(this._lines[p].substring(v.start.character));for(let g=p+1;g<f;g++)a.push(this._lines[g]);return a.push(this._lines[f].substring(0,v.end.character)),a.join(d)}_lineAt(b){let v;if(b instanceof y.Position?v=b.line:typeof b=="number"&&(v=b),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new T(v,this._lines[v],v===this._lines.length-1)}_offsetAt(b){return b=this._validatePosition(b),this._ensureLineStarts(),this._lineStarts.getPrefixSum(b.line-1)+b.character}_positionAt(b){b=Math.floor(b),b=Math.max(0,b),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(b),d=this._lines[v.index].length;return new y.Position(v.index,Math.min(v.remainder,d))}_validateRange(b){if(!(b instanceof y.Range))throw new Error("Invalid argument");const v=this._validatePosition(b.start),d=this._validatePosition(b.end);return v===b.start&&d===b.end?b:new y.Range(v.line,v.character,d.line,d.character)}_validatePosition(b){if(!(b instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return b.with(0,0);let{line:v,character:d}=b,p=!1;if(v<0)v=0,d=0,p=!0;else if(v>=this._lines.length)v=this._lines.length-1,d=this._lines[v].length,p=!0;else{const f=this._lines[v].length;d<0?(d=0,p=!0):d>f&&(d=f,p=!0)}return p?new y.Position(v,d):b}_getWordRangeAtPosition(b,v){const d=this._validatePosition(b);if(!v)v=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const p=(0,_.getWordAtText)(d.character+1,(0,_.ensureValidWordDefinition)(v),this._lines[d.line],0);if(p)return new y.Range(d.line,p.startColumn-1,d.line,p.endColumn-1)}}e.ExtHostDocumentData=S;class T{constructor(b,v,d){this._line=b,this._text=v,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[206],Ie([1,0,7,15,4]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(y){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let E;switch(y){case"light":E=l.ColorThemeKind.Light;break;case"hcDark":E=l.ColorThemeKind.HighContrast;break;case"hcLight":E=l.ColorThemeKind.HighContrastLight;break;default:E=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[54],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=t}),define(De[207],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(E){let I=this.buffers.indexOf(E);return I<0&&(I=this.buffers.length,this.buffers.push(E)),I}}function D(y,E){if(E.serializeBuffersForPostMessage){const I=new t,R=(T,w)=>{if(w instanceof ArrayBuffer){const b=I.add(w);return{$$vscode_array_buffer_reference$$:!0,index:b}}else if(ArrayBuffer.isView(w)){const b=P(w);if(b){const v=I.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:b,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},k=JSON.stringify(y,R),S=I.buffers.map(T=>{const w=new Uint8Array(T);return l.VSBuffer.wrap(w)});return{message:k,buffers:S}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=D;function P(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(y,E){const I=E.map(S=>{const T=new ArrayBuffer(S.byteLength);return new Uint8Array(T).set(S.buffer),T}),R=E.length?(S,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const w=T,{index:b}=w,v=I[b];if(w.view)switch(w.view.type){case 1:return new Int8Array(v,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return T}:void 0;return{message:JSON.parse(y,R),arrayBuffers:I}}e.deserializeWebviewMessage=_}),define(De[208],Ie([1,0,107]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:P,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function D(P){return new l.URITransformer(t(P))}e.createURITransformer=D}),define(De[126],Ie([1,0,178,13,2,6,3,43,42,17,12]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(O){const x=O;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=T;function w(O,x,V){for(const q of V.visibleEditorPanes)if(q.group.id===x&&O.matches(q.input))return q.getViewState()}e.findViewStateForEditor=w;function b(O){if(i(O))return!1;const x=O;return D.URI.isUri(x?.resource)}e.isResourceEditorInput=b;function v(O){if(i(O))return!1;const x=O;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=v;function d(O){if(i(O)||v(O))return!1;const x=O;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function p(O){if(i(O))return!1;const x=O;return x?x.resource===void 0||x.resource.scheme===R.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;function f(O){if(i(O))return!1;const x=O;return D.URI.isUri(x?.base?.resource)&&D.URI.isUri(x?.input1?.resource)&&D.URI.isUri(x?.input2?.resource)&&D.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=f;var a;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var g;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,V){let q=this.mapIdToSaveSource.get(x);return q||(q={source:x,label:V},this.mapIdToSaveSource.set(x,q)),q.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new s;var u;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends P.Disposable{}e.AbstractEditorInput=o;function i(O){return O instanceof o}e.isEditorInput=i;function r(O){const x=O;return D.URI.isUri(x?.preferredResource)}function n(O){const x=O;return i(x?.primary)&&i(x?.secondary)}e.isSideBySideEditorInput=n;function c(O){const x=O;return i(x?.modified)&&i(x?.original)}e.isDiffEditorInput=c;function h(O){return i(O?.editor)}e.isEditorInputWithOptions=h;function m(O){const x=O;return h(O)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function C(O){const x=O;return typeof x?.groupId=="number"&&i(x.editor)}e.isEditorIdentifier=C;var L;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(L=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(x,V){if(!x)return;if(f(x))return e.EditorResourceAccessor.getOriginalUri(x.result,V);if(V?.supportSideBySide){const{primary:Y,secondary:Q}=this.getSideEditors(x);if(Y&&Q){if(V?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===B.ANY)return this.getOriginalUri(Y,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===B.PRIMARY?Y:Q}}if(v(x)||d(x)||f(x))return;const q=r(x)?x.preferredResource:x.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}getSideEditors(x){return n(x)||d(x)?{primary:x.primary,secondary:x.secondary}:c(x)||v(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,V){if(!x)return;if(f(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,V);if(V?.supportSideBySide){const{primary:Y,secondary:Q}=this.getSideEditors(x);if(Y&&Q){if(V?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===B.ANY)return this.getCanonicalUri(Y,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===B.PRIMARY?Y:Q}}if(v(x)||d(x)||f(x))return;const q=x.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}filterUri(x,V){if(Array.isArray(V)){if(V.some(q=>x.scheme===q))return x}else if(V===x.scheme)return x}}e.EditorResourceAccessor=new A;var M;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const V=this.instantiationService=x.get(_.IInstantiationService);for(const[q,Y]of this.editorSerializerConstructors)this.createEditorSerializer(q,Y,V);this.editorSerializerConstructors.clear()}createEditorSerializer(x,V,q){const Y=q.createInstance(V);this.editorSerializerInstances.set(x,Y)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,V){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,V,this.instantiationService):this.editorSerializerConstructors.set(x,V),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new $);async function N(O,x){if(!O||!O.length)return[];const V=await Promise.all(O.map(async q=>{const Y=D.URI.revive(q.fileUri);if(!Y||!await x.canHandleResource(Y))return;let he=q.exists,ve=q.type;if(typeof he!="boolean"||typeof ve!="number")try{ve=(await x.stat(Y)).isDirectory?E.FileType.Directory:E.FileType.Unknown,he=!0}catch{he=!1}if(!he&&q.openOnlyIfExists||ve===E.FileType.Directory)return;const ne={...q.options,pinned:!0};let pe;return he?pe={resource:Y,options:ne}:pe={resource:Y,options:ne,forceUntitled:!0},pe}));return(0,I.coalesce)(V)}e.pathsToEditors=N;var K;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function z(O){const x=O;if(!x)return!1;const V=x;if(V.modified)return z(V.modified);const q=x;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=z}),define(De[88],Ie([1,0,12,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(y,E){return y.scheme===l.Schemas.http||y.scheme===l.Schemas.https?y:(E&&E.authority&&E.isRemote&&y.scheme===l.Schemas.file&&(y=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:E.authority,path:y.path})),t.URI.from({scheme:l.Schemas.https,authority:`${y.scheme}+${P(y.authority)}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=D;function P(y){return y.replace(/./g,E=>{const I=E.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?E:"-"+I.toString(16).padStart(4,"0")})}function _(y){return y.replace(/-([0-9a-f]{4})/g,(E,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=_}),define(De[209],Ie([1,0,4,6,88]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(y,E,I){this._proxy=y,this._editors=E,this._remoteInfo=I,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const k of this._insets.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,E,I,R,k){let S;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===y){S=f;break}if(!S)throw new Error("not a visible editor");const T=this,w=this._handlePool++,b=new l.Emitter,v=new l.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,D.asWebviewUri)(f,T._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(f){this._options=f,T._proxy.$setOptions(w,f)}get options(){return this._options}set html(f){this._html=f,T._proxy.$setHtml(w,f)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(f){return T._proxy.$postMessage(w,f)}},p=new class{constructor(){this.editor=y,this.line=E,this.height=I,this.webview=d,this.onDidDispose=v.event}dispose(){T._insets.has(w)&&(T._insets.delete(w),T._proxy.$disposeEditorInset(w),v.fire(),v.dispose(),b.dispose())}};return this._proxy.$createEditorInset(w,S.id,S.value.document.uri,E+1,I,R||{},k.identifier,k.extensionLocation),this._insets.set(w,{editor:y,inset:p,onDidReceiveMessage:b}),p}$onDidDispose(y){const E=this._insets.get(y);E&&E.inset.dispose()}$onDidReceiveMessage(y,E){this._insets.get(y)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=P}),define(De[127],Ie([1,0,4,18,179]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,E,I,R){const k={command:y};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.internalSend("request",k),typeof R=="number"){const S=setTimeout(()=>{clearTimeout(S);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:y,message:(0,D.localize)(0,null,R,y)};T(w)}},R)}return I&&this.pendingRequests.set(k.seq,I),k.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,E){return y.type!=="event"||E.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,t.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback?.(y);break;case"request":this.requestCallback?.(y);break;case"response":{const E=y,I=this.pendingRequests.get(E.request_seq);I&&(this.pendingRequests.delete(E.request_seq),I(E));break}}}}internalSend(y,E){E.type=y,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((E,I)=>y.set(I,E)),await(0,t.timeout)(500),y.forEach((E,I)=>{E({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[210],Ie([1,0,180,52,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=S=>l.localize(51,null,S);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var _;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(_=e.State||(e.State={}));function y(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=y;var E;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[211],Ie([1,0,8,2,9,24,12]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function E(o,i,r){return o.replace(y,function(n,c){return i&&c.length>0&&c[0]!=="_"?n:r&&r.hasOwnProperty(c)?r[c]:n})}e.formatPII=E;function I(o){const i={};for(const r of Object.keys(o))r.startsWith("!")||(i[r]=o[r]);return i}e.filterExceptionsFromTelemetry=I;function R(o){return o.configuration.request==="attach"&&!k(o)&&(!o.parentSession||R(o.parentSession))}e.isSessionAttach=R;function k(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(i,"extensionhost")||(0,l.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?k(o.parentSession):void 0}e.getExtensionHostDebugSession=k;function S(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=S;function T(o,i,r){let n,c=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=h.exec(o);){const C=m.index+1,L=C+m[0].length;if(C<=i&&L>=r){n=m[0],c=C;break}}if(n){const C=/\w+/g;let L=null;for(;(L=C.exec(n))&&!(L.index+1+c+L[0].length>=r););L&&(n=n.substring(0,C.lastIndex))}return n?{start:c,end:c+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(o){return!!(o&&o.match(w))}e.isUri=b;function v(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(b(o.path))return t.URI.parse(o.path);if((0,D.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function d(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===_.Schemas.file?i.fsPath:i.toString()}return o.path}function p(o,i){const r=i?v:d,n=(0,P.deepClone)(o);return a(n,(c,h)=>{c&&h&&(h.path=r(h))}),n}e.convertToDAPaths=p;function f(o,i){const r=i?v:d,n=(0,P.deepClone)(o);return a(n,(c,h)=>{!c&&h&&(h.path=r(h))}),n}e.convertToVSCPaths=f;function a(o,i){switch(o.type){case"event":{const r=o;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=o;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(n=>i(!1,n));break;default:break}break}case"response":{const r=o;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(n=>i(!1,n.source));break;case"loadedSources":r.body.sources.forEach(n=>i(!1,n));break;case"scopes":r.body.scopes.forEach(n=>i(!1,n.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(n=>i(!1,n.source));break;case"setBreakpoints":r.body.breakpoints.forEach(n=>i(!1,n.source));break;case"disassemble":r.body?.instructions.forEach(c=>i(!1,c.location));break;default:break}break}}}function g(o){return o.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):s(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function s(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function u(o,i){const r=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const n=i.activeEditorPane;n&&n.input.resource?.scheme===_.Schemas.untitled&&await i.save({editor:n.input,groupId:n.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(De[212],Ie([1,0,29,44,181,213,9,8,24,11,84,127]),function(J,e,l,t,D,P,_,y,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class S extends k.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",a=>this.handleData(a))}sendMessage(p){if(this.outputStream){const f=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${S.TWO_CRLF}${f}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+f))}continue}}else{const f=this.rawData.indexOf(S.TWO_CRLF);if(f!==-1){const g=this.rawData.toString("utf8",0,f).split(S.HEADER_LINESEPARATOR);for(const s of g){const u=s.split(S.HEADER_FIELDSEPARATOR);u[0]==="Content-Length"&&(this.contentLength=Number(u[1]))}this.rawData=this.rawData.slice(f+S.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=S,S.TWO_CRLF=`\r
\r
`,S.HEADER_LINESEPARATOR=/\r?\n/,S.HEADER_FIELDSEPARATOR=/: */;class T extends S{startSession(){return new Promise((p,f)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",g=>{a?this._onError.fire(g):f(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class w extends T{constructor(p){super(),this.adapterServer=p}createConnection(p){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=w;class b extends T{constructor(p){super(),this.adapterServer=p}createConnection(p){return P.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=b;class v extends S{constructor(p,f,a){super(),this.adapterExecutable=p,this.debugType=f,this.outputService=a}async startSession(){const p=this.adapterExecutable.command,f=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(p)if(_.isAbsolute(p)){if(!await l.Promises.exists(p))throw new Error(D.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let g=process.env;if(a.env&&Object.keys(a.env).length>0&&(g=E.mixin(E.deepClone(process.env),a.env)),p==="node")if(Array.isArray(f)&&f.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:g,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(o.cwd=a.cwd);const i=t.fork(f[0],f.slice(1),o);if(!i.pid)throw new Error(D.localize(2,null,f[0]));this.serverProcess=i}else throw new Error(D.localize(3,null));else{const u={env:g};a.cwd&&(u.cwd=a.cwd),this.serverProcess=t.spawn(p,f,u)}this.serverProcess.on("error",u=>{this._onError.fire(u)}),this.serverProcess.on("exit",(u,o)=>{this._onExit.fire(u)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stdin.on("error",u=>{this._onError.fire(u)});const s=this.outputService;if(s){const u=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{s.getChannel(R.ExtensionsChannelId)?.append(u(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((p,f)=>{const a=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,s,u){if(g)return f(g)});a.on("exit",p),a.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,f){if(!p)return;const a=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?a.runtime=_.join(f,p.runtime):a.runtime=p.runtime),p.runtimeArgs&&(a.runtimeArgs=p.runtimeArgs),p.program&&(_.isAbsolute(p.program)?a.program=p.program:a.program=_.join(f,p.program)),p.args&&(a.args=p.args);const g=p;return g.win&&(a.win=v.extract(g.win,f)),g.winx86&&(a.winx86=v.extract(g.winx86,f)),g.windows&&(a.windows=v.extract(g.windows,f)),g.osx&&(a.osx=v.extract(g.osx,f)),g.linux&&(a.linux=v.extract(g.linux,f)),a}static platformAdapterExecutable(p,f){let a=Object.create(null);f=f.toLowerCase();for(const r of p)if(r.contributes){const n=r.contributes.debuggers;n&&n.length>0&&n.filter(c=>typeof c.type=="string"&&y.equalsIgnoreCase(c.type,f)).forEach(c=>{const h=v.extract(c,r.extensionLocation.fsPath);a=E.mixin(a,h,r.isBuiltin)})}let g;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=a.winx86||a.win||a.windows:I.isWindows?g=a.win||a.windows:I.isMacintosh?g=a.osx:I.isLinux&&(g=a.linux),g=g||a;const s=g.program||a.program,u=g.args||a.args,o=g.runtime||a.runtime,i=g.runtimeArgs||a.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof s=="string"?[s]:[]).concat(u||[])};if(s)return{type:"executable",command:s,args:u||[]}}}e.ExecutableDebugAdapter=v}),define(De[214],Ie([1,0,44,31,11]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(I,R){return new Promise((k,S)=>{let T="";const w=l.spawn(I,R);w.pid&&w.stdout.on("data",b=>{T+=b.toString()}),w.on("error",b=>{S(b)}),w.on("close",b=>{k(T)})})}async function _(I){if(I)if(D.isWindows){const R=await new Promise((k,S)=>{J(["windows-process-tree"],k,S)});return new Promise(k=>{R.getProcessTree(I,S=>{k(!!S&&S.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(I)]).then(R=>{const k=R.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=_;var y;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(y||(y={}));function E(I,R,k,S,T){I=I.trim().toLowerCase();let w;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?w=1:I.indexOf("cmd.exe")>=0?w=0:I.indexOf("bash")>=0?w=2:D.isWindows?w=0:w=2;let b,v=" ";switch(w){case 1:if(b=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),S){const d=(0,t.getDriveLetter)(S);d&&(v+=`${d}:; `),v+=`cd ${b(S)}; `}if(T)for(const d in T){const p=T[d];p===null?v+=`Remove-Item env:${d}; `:v+=`\${env:${d}}='${p}'; `}if(R.length>0){const d=R.shift(),p=k?d:b(d);v+=p[0]==="'"?`& ${p} `:`${p} `;for(const f of R)v+=f==="<"||f===">"||k?f:b(f),v+=" "}break;case 0:if(b=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>d.includes(p))||d.length===0?`"${d}"`:d),S){const d=(0,t.getDriveLetter)(S);d&&(v+=`${d}: && `),v+=`cd ${b(S)} && `}if(T){v+='cmd /C "';for(const d in T){let p=T[d];p===null?v+=`set "${d}=" && `:(p=p.replace(/[&^|<>]/g,f=>`^${f}`),v+=`set "${d}=${p}" && `)}}for(const d of R)v+=d==="<"||d===">"||k?d:b(d),v+=" ";T&&(v+='"');break;case 2:{b=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const d=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(S&&(v+=`cd ${b(S)} ; `),T){v+="/usr/bin/env";for(const p in T){const f=T[p];f===null?v+=` -u ${d(p)}`:v+=` ${d(`${p}=${f}`)}`}v+=" "}for(const p of R)v+=p==="<"||p===">"||k?p:b(p),v+=" ";break}}return v}e.prepareCommand=E}),define(De[128],Ie([1,0,23,36,60,100,12,9,11,52]),function(J,e,l,t,D,P,_,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var b;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(b=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var p;(function(n){n.scheme=_.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${c.join("")}]+`),m=7;function C(N,K){const z=K.toString(m),x=`${z.length<c.length?c[z.length-1]:"z"}${z}s${(0,l.encodeBase64)(l.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:n.scheme,fragment:x})}n.generate=C;function L(N){if(N.scheme!==n.scheme)return;const K=N.fragment.indexOf("s");if(K<0)return;const z=parseInt(N.fragment.substring(0,K).replace(h,""),m),O=(0,l.decodeBase64)(N.fragment.substring(K+1)).toString();if(!isNaN(z))return{handle:z,notebook:N.with({scheme:O,fragment:null})}}n.parse=L;const U=/^(\d{8,})(\w[\w\d+.-]*)$/;function B(N,K){return N.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${N.scheme!==_.Schemas.file?N.scheme:""}`})}n.generateCellOutputUri=B;function A(N){if(N.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!K)return;const z=K[1]&&K[1]!==""?K[1]:void 0,O=K[2];return{outputId:z,notebook:N.with({scheme:O||_.Schemas.file,fragment:null})}}n.parseCellOutputUri=A;function M(N,K,z){return N.with({scheme:z,fragment:`ch${K.toString().padStart(7,"0")}${N.scheme!==_.Schemas.file?N.scheme:""}`})}n.generateCellUri=M;function $(N,K){if(N.scheme!==K)return;const z=U.exec(N.fragment);return z?{handle:Number(z[1]),notebook:N.with({scheme:N.fragment.substring(z[0].length)||_.Schemas.file,fragment:null})}:void 0}n.parseCellUri=$})(p=e.CellUri||(e.CellUri={}));const f=n=>E.isWindows?n.replace(/\//g,"\\"):n;class a{constructor(c=[],h=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=h,this.order=[...new Set(c)].map(m=>({pattern:m,matches:t.parse(f(m))}))}sort(c){const h=new Map(D.Iterable.map(c,C=>[C,f(C)]));let m=[];for(const{matches:C}of this.order)for(const[L,U]of h)if(C(U)){m.push(L),h.delete(L);break}return h.size&&(m=m.concat([...h.keys()].sort((C,L)=>this.defaultOrder.indexOf(C)-this.defaultOrder.indexOf(L)))),m}prioritize(c,h){const m=this.findIndex(c);if(m===-1){this.order.unshift({pattern:c,matches:t.parse(f(c))});return}const C=new Set(h.map(U=>this.findIndex(U,m)));C.delete(-1);const L=Array.from(C).sort();this.order.splice(m+1,0,...L.map(U=>this.order[U]));for(let U=L.length-1;U>=0;U--)this.order.splice(L[U],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,h=this.order.length){const m=f(c);for(let C=0;C<h;C++)if(this.order[C].matches(m))return C;return-1}}e.MimeTypeDisplayOrder=a;function g(n,c,h,m=(C,L)=>C===L){const C=[];function L(A,M,$){if(M===0&&$.length===0)return;const N=C[C.length-1];N&&N.start+N.deleteCount===A?(N.deleteCount+=M,N.toInsert.push(...$)):C.push({start:A,deleteCount:M,toInsert:$})}let U=0,B=0;for(;;){if(U===n.length){L(U,0,c.slice(B));break}if(B===c.length){L(U,n.length-U,[]);break}const A=n[U],M=c[B];if(m(A,M)){U+=1,B+=1;continue}h(M)?(L(U,1,[]),U+=1):(L(U,0,[M]),B+=1)}return C}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(n){n.default="default",n.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(n){const c=n;return!!((typeof c.include=="string"||t.isRelativePattern(c.include))&&(typeof c.exclude=="string"||t.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=u;function o(n,c,h){if(Array.isArray(n.viewType)&&n.viewType.indexOf(c)>=0||n.viewType===c)return!0;if(n.filenamePattern){const m=u(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,C=u(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(t.match(m,(0,y.basename)(h.fsPath).toLowerCase()))return!(C&&t.match(C,(0,y.basename)(h.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(c){return`${r._prefix}${c}`}static parse(c){if(c.startsWith(r._prefix))return c.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(De[215],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(De[216],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=l;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t;function D(_){return Array.from(_.entries()).map(y=>[y[0],l(y[1].map)])}e.serializeEnvironmentVariableCollections=D;function P(_){return new Map(_.map(y=>[y[0],{map:t(y[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[65],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(_,y=_.length){if(this.path=_,this.viewEnd=y,_.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,y,E=_.parent){if(_.id===y)return new D([y]);const I=[_.id];for(let R=E;R&&R.id!==y;R=R.parent)I.push(R.id);return I.push(y),new D(I.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const y=_.indexOf("\0");return y===-1?_:_.slice(0,y)}static fromString(_){return new D(_.split("\0"))}static join(_,y){return new D([..._.path,y])}static joinToString(_,y){return _.toString()+"\0"+y}static compare(_,y){return _===y?0:y.startsWith(_+"\0")?2:_.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new D(this.path,_)}compare(_){if(typeof _=="string")return D.compare(this.toString(),_);for(let y=0;y<_.viewEnd&&y<this.viewEnd;y++)if(_.path[y]!==this.path[y])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=D}),define(De[66],Ie([1,0,2,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(r){r.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),r.deserialize=n=>({range:t.Range.lift(n.range),uri:l.URI.revive(n.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var y;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var E;(function(r){r.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&_.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&_.deserialize(n.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(r){r.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&_.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&_.deserialize(n.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(r){r.serialize=n=>n.type===0?E.serialize(n):I.serialize(n),r.deserialize=n=>n.type===0?E.deserialize(n):I.deserialize(n)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(r){r.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),r.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.serialize)}),r.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",T=(r,n)=>r+S+n;e.namespaceTestTag=T;const w=r=>{const n=r.indexOf(S);return{ctrlId:r.slice(0,n),tagId:r.slice(n+1)}};e.denamespaceTestTag=w;var b;(function(r){r.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),r.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?l.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(b=e.ITestItem||(e.ITestItem={}));var v;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var d;(function(r){r.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:b.serialize(n.item)}),r.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:b.deserialize(n.item)})})(d=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=n=>{let c;return n.item&&(c={},n.item.label!==void 0&&(c.label=n.item.label),n.item.tags!==void 0&&(c.tags=n.item.tags),n.item.busy!==void 0&&(c.busy=n.item.busy),n.item.uri!==void 0&&(c.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(c.range=n.item.range?.toJSON()),n.item.description!==void 0&&(c.description=n.item.description),n.item.error!==void 0&&(c.error=n.item.error),n.item.sortText!==void 0&&(c.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:c,docv:n.docv}},r.deserialize=n=>{let c;return n.item&&(c={},n.item.label!==void 0&&(c.label=n.item.label),n.item.tags!==void 0&&(c.tags=n.item.tags),n.item.busy!==void 0&&(c.busy=n.item.busy),n.item.range!==void 0&&(c.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(c.description=n.item.description),n.item.error!==void 0&&(c.error=n.item.error),n.item.sortText!==void 0&&(c.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:c,docv:n.docv}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(r,n)=>{n.expand!==void 0&&(r.expand=n.expand),n.item!==void 0&&(r.item=r.item?Object.assign(r.item,n.item):n.item)};e.applyTestItemUpdate=f;var a;(function(r){r.serializeWithoutMessages=n=>({...d.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serializeWithoutMessages),retired:n.retired}),r.serialize=n=>({...d.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serialize),retired:n.retired})})(a=e.TestResultItem||(e.TestResultItem={}));var g;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(g=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(r){r.deserialize=n=>n.op===0?{op:n.op,item:d.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n,r.serialize=n=>n.op===0?{op:n.op,item:d.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(n){}update(n){}remove(n,c){}complete(){}}e.IncrementalChangeCollector=o;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const c=this.createChangeCollector();for(const h of n)switch(h.op){case 0:{const m=d.deserialize(h.item);if(m.parent){if(this.items.has(m.parent)){const C=this.items.get(m.parent);C.children.add(m.item.extId);const L=this.createItem(m,C);this.items.set(m.item.extId,L),c.add(L)}}else{const C=this.createItem(m);this.roots.add(C),this.items.set(m.item.extId,C),c.add(C)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=p.deserialize(h.item),C=this.items.get(m.extId);if(!C)break;m.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,m),c.update(C);break}case 2:{const m=this.items.get(h.itemId);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m);const C=[[h.itemId]];for(;C.length;)for(const L of C.pop()){const U=this.items.get(L);U&&(C.push(U.children),this.items.delete(L),c.remove(U,U!==m),U.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h.itemId);break;case 3:this.updatePendingRoots(h.amount);break;case 5:this._tags.set(h.tag.id,h.tag);break;case 6:this._tags.delete(h.id);break}c.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=i}),define(De[89],Ie([1,0,18,4,6,48,66,65]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(d,p)=>d===p,R={range:(d,p)=>d===p?!0:!d||!p?!1:d.equalsRange(p),busy:I,label:I,description:I,error:I,tags:(d,p)=>!(d.length!==p.length||d.some(f=>!p.includes(f)))},k=(d,p)=>{let f;for(const[a,g]of Object.entries(R))g(d[a],p[a])||(f?f[a]=p[a]:f={[a]:p[a]});return f};class S extends D.Disposable{constructor(p){super(),this.options=p,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(p){this._resolveHandler=p;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const f=this.diff[this.diff.length-1];if(f&&p.op===1){if(f.op===1&&f.item.extId===p.item.extId){(0,_.applyTestItemUpdate)(f.item,p.item);return}if(f.op===0&&f.item.item.extId===p.item.extId){(0,_.applyTestItemUpdate)(f.item,p.item);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,f){const a=this.tree.get(p);if(!!a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const g=this.resolveChildren(a);return g.isOpen()?this.expandChildren(a,f-1):g.wait().then(()=>this.expandChildren(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,f-1)):this.expandChildren(a,f-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,f){switch(f.op){case 3:this.removeItem(y.TestId.joinToString(p.fullId,f.id));break;case 0:this.upsertItem(f.item,p);break;case 5:for(const a of f.ops)this.onTestItemEvent(p,a);break;case 1:this.diffTagRefs(f.new,f.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:f.update,docv:this.options.getDocumentVersion(p.actual.uri)}});break;default:(0,P.assertNever)(f)}}upsertItem(p,f){const a=y.TestId.fromExtHostTestItem(p,this.root.id,f?.actual),g=this.options.getApiFor(p);g.parent&&g.parent!==f?.actual&&this.options.getChildren(g.parent).delete(p.id);let s=this.tree.get(a.toString());if(!s){s={fullId:a,actual:p,parent:f?a.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(p,f),this.pushDiff({op:0,item:{parent:s.parent&&s.parent.toString(),controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,s,f);return}if(s.actual===p){this.connectItem(p,s,f);return}const u=this.options.getChildren(s.actual),o=s.actual,i=k(this.options.toITestItem(o),this.options.toITestItem(p));this.options.getApiFor(o).listener=void 0,s.actual=p,s.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,o.tags,a.toString()),delete i.tags),this.onTestItemEvent(s,{op:4,update:i})),this.connectItemAndChildren(p,s,f);for(const[r,n]of u)this.options.getChildren(p).get(n.id)||this.removeItem(y.TestId.joinToString(a,n.id))}diffTagRefs(p,f,a){const g=new Set(f.map(s=>s.id));for(const s of p)g.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:a,item:{tags:p.map(s=>(0,_.namespaceTestTag)(this.options.controllerId,s.id))}}}),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const f=this.tags.get(p.id);f?f.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const f=this.tags.get(p);f&&!--f.refCount&&(this.tags.delete(p),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,f){this.options.getApiFor(p).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(p,f,a){this.setItemParent(p,a);const g=this.options.getApiFor(p);g.parent=a?.actual,g.listener=s=>this.onTestItemEvent(f,s),this.updateExpandability(f)}connectItemAndChildren(p,f,a){this.connectItem(p,f,a);for(const[g,s]of this.options.getChildren(p))this.upsertItem(s,f)}updateExpandability(p){let f;this._resolveHandler?p.resolveBarrier?f=p.resolveBarrier.isOpen()?3:2:f=p.actual.canResolveChildren?1:0:f=0,f!==p.expand&&(p.expand=f,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:f}}),f===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,f){if(f<0)return;const a=[];for(const[g,s]of this.options.getChildren(p.actual)){const u=this.expand(y.TestId.joinToString(p.fullId,s.id),f);(0,l.isThenable)(u)&&a.push(u)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const s=new l.Barrier;return s.open(),s}p.expand=2,this.pushExpandStateUpdate(p);const f=p.resolveBarrier=new l.Barrier,a=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let g;try{g=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(s){a(s)}return(0,l.isThenable)(g)?g.catch(a).then(()=>{f.open(),this.updateExpandability(p)}):(f.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const f=this.tree.get(p);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:p});const a=[f];for(;a.length;){const g=a.pop();if(!!g){this.options.getApiFor(g.actual).listener=void 0;for(const s of g.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(g.fullId.toString());for(const[s,u]of this.options.getChildren(g.actual))a.push(this.tree.get(y.TestId.joinToString(g.fullId,u.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=S;class T extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=T;class w extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class b extends Error{constructor(p,f,a){super(`TestItem with ID "${p}" is from controller "${f}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=b;const v=(d,p,f)=>{let a=new Map;return{get size(){return a.size},forEach(g,s){for(const u of a.values())g.call(s,u,this)},[Symbol.iterator](){return a.entries()},replace(g){const s=new Map,u=new Set(a.keys()),o={op:5,ops:[]};for(const i of g){if(!(i instanceof f))throw new w(i.id);const r=p(i).controllerId;if(r!==d.controllerId)throw new b(i.id,r,d.controllerId);if(s.has(i.id))throw new T(i.id);s.set(i.id,i),u.delete(i.id),o.ops.push({op:0,item:i})}for(const i of u.keys())o.ops.push({op:3,id:i});d.listener?.(o),a=s},add(g){if(!(g instanceof f))throw new w(g.id);a.set(g.id,g),d.listener?.({op:0,item:g})},delete(g){a.delete(g)&&d.listener?.({op:3,id:g})},get(g){return a.get(g)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=v}),define(De[129],Ie([1,0,89]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(_,y)=>{const E={controllerId:y};return t.set(_,E),E};e.createPrivateApiFor=D;const P=_=>{const y=t.get(_);if(!y)throw new l.InvalidTestItemError(_?.id||"<unknown>");return y};e.getPrivateApiFor=P}),define(De[217],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(_,y){super(y),this.variable=_}}e.VariableError=D}),define(De[218],Ie([1,0,9,40,13,24,11,106,184,217,8]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,w,b,v){this._contributedVariables=new Map,this._context=T,this._labelService=w,this._userHomePromise=b,v&&(this._envVariablesPromise=v.then(d=>this.prepareEnv(d)))}prepareEnv(T){if(_.isWindows){const w=Object.create(null);return Object.keys(T).forEach(b=>{w[b.toLowerCase()]=T[b]}),w}return T}resolveWithEnvironment(T,w,b){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},w?w.uri:void 0,b)}async resolveAsync(T,w){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,T?T.uri:void 0,w)}async resolveAnyBase(T,w,b,v){const d=P.deepClone(w);_.isWindows&&d.windows?Object.keys(d.windows).forEach(f=>d[f]=d.windows[f]):_.isMacintosh&&d.osx?Object.keys(d.osx).forEach(f=>d[f]=d.osx[f]):_.isLinux&&d.linux&&Object.keys(d.linux).forEach(f=>d[f]=d.linux[f]),delete d.windows,delete d.osx,delete d.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,T?T.uri:void 0,d,b,v)}async resolveAnyAsync(T,w,b){return this.resolveAnyBase(T,w,b)}async resolveAnyMap(T,w,b){const v=new Map;return{newConfig:await this.resolveAnyBase(T,w,b,v),resolvedVariables:v}}resolveWithInteractionReplace(T,w,b,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,w,b,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,w){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,w)}async recursiveResolve(T,w,b,v,d){if(D.isString(b))return this.resolveString(T,w,b,v,d);if(Array.isArray(b))return Promise.all(b.map(p=>this.recursiveResolve(T,w,p,v,d)));if(D.isObject(b)){const p=Object.create(null),f=await Promise.all(Object.keys(b).map(async a=>[await this.resolveString(T,w,a,v,d),await this.recursiveResolve(T,w,b[a],v,d)]));for(const[a,g]of f)p[a]=g;return p}return b}resolveString(T,w,b,v,d){return(0,R.replaceAsync)(b,k.VARIABLE_REGEXP,async(p,f)=>{if(f.includes(k.VARIABLE_LHS))return p;let a=await this.evaluateSingleVariable(T,p,f,w,v);return d?.set(f,a),a!==p&&D.isString(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.resolveString(T,w,a,v,d)),a})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,w,b,v,d){let p;const f=b.split(":");f.length>1&&(b=f[0],p=f[1]);const a=u=>{const o=this._context.getFilePath();if(o)return o;throw new I.VariableError(u,(0,E.localize)(0,null,w))},g=u=>{const o=a(u);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new I.VariableError(u,(0,E.localize)(1,null,w,l.basename(o)))},s=u=>{if(p){const o=this._context.getFolderUri(p);if(o)return o;throw new I.VariableError(u,(0,E.localize)(2,null,w,p))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new I.VariableError(u,(0,E.localize)(3,null,w)):new I.VariableError(u,(0,E.localize)(4,null,w))};switch(b){case"env":if(p){if(T.env){const u=T.env[_.isWindows?p.toLowerCase():p];if(D.isString(u))return u}return""}throw new I.VariableError(I.VariableKind.Env,(0,E.localize)(5,null,w));case"config":if(p){const u=this._context.getConfigurationValue(v,p);if(D.isUndefinedOrNull(u))throw new I.VariableError(I.VariableKind.Config,(0,E.localize)(6,null,w,p));if(D.isObject(u))throw new I.VariableError(I.VariableKind.Config,(0,E.localize)(7,null,w,p));return u}throw new I.VariableError(I.VariableKind.Config,(0,E.localize)(8,null,w));case"command":return this.resolveFromMap(I.VariableKind.Command,w,p,d,"command");case"input":return this.resolveFromMap(I.VariableKind.Input,w,p,d,"input");case"extensionInstallFolder":if(p){const u=await this._context.getExtension(p);if(!u)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,w,p));return this.fsPath(u.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,w));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(s(I.VariableKind.WorkspaceFolder)));case"cwd":return v||p?(0,y.normalizeDriveLetter)(this.fsPath(s(I.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(s(I.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,E.localize)(11,null,w))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new I.VariableError(I.VariableKind.LineNumber,(0,E.localize)(12,null,w))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new I.VariableError(I.VariableKind.SelectedText,(0,E.localize)(13,null,w))}case"file":return a(I.VariableKind.File);case"fileWorkspaceFolder":return g(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return v||p?l.relative(this.fsPath(s(I.VariableKind.RelativeFile)),a(I.VariableKind.RelativeFile)):a(I.VariableKind.RelativeFile);case"relativeFileDirname":{const u=l.dirname(a(I.VariableKind.RelativeFileDirname));if(v||p){const o=l.relative(this.fsPath(s(I.VariableKind.RelativeFileDirname)),u);return o.length===0?".":o}return u}case"fileDirname":return l.dirname(a(I.VariableKind.FileDirname));case"fileExtname":return l.extname(a(I.VariableKind.FileExtname));case"fileBasename":return l.basename(a(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=l.basename(a(I.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-l.extname(u).length)}case"fileDirnameBasename":return l.basename(l.dirname(a(I.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||w}case"execInstallFolder":{const u=this._context.getAppRoot();return u||w}case"pathSeparator":return l.sep;default:try{const u=p?`${b}:${p}`:b;return this.resolveFromMap(I.VariableKind.Unknown,w,u,d,void 0)}catch{return w}}}}resolveFromMap(T,w,b,v,d){if(b&&v){const p=d===void 0?v[b]:v[d+":"+b];if(typeof p=="string")return p;throw new I.VariableError(T,(0,E.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[130],Ie([1,0,3,126]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var y;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function I(w){const b=w;return(0,t.isEditorInput)(b?.editor)&&(0,t.isEditorInput)(b?.replacement)}e.isEditorReplacement=I;var R;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(w){const b=w;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=S;function T(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[219],Ie([1,0,3,130]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(P){const _=P;return typeof P=="number"||(0,t.isEditorGroup)(_)}e.isPreferredGroup=D}),define(De[16],Ie([1,0,17,23,105,25,144,62,24,13,2,35,64,116,129,126,128,65,66,219,7,59]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Pe){function Re(te){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:it,positionColumn:Ke}=te,Je=new a.Position(Fe-1,Ve-1),ut=new a.Position(it-1,Ke-1);return new a.Selection(Je,ut)}Pe.to=Re;function _e(te){const{anchor:Fe,active:Ve}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Pe.from=_e})(s=e.Selection||(e.Selection={}));var u;(function(Pe){function Re(te){if(!te)return;const{start:Fe,end:Ve}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Pe.from=Re;function _e(te){if(!te)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:it,endColumn:Ke}=te;return new a.Range(Fe-1,Ve-1,it-1,Ke-1)}Pe.to=_e})(u=e.Range||(e.Range={}));var o;(function(Pe){function Re(_e){switch(_e){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Pe.to=Re})(o=e.TokenType||(e.TokenType={}));var i;(function(Pe){function Re(te){return new a.Position(te.lineNumber-1,te.column-1)}Pe.to=Re;function _e(te){return{lineNumber:te.line+1,column:te.character+1}}Pe.from=_e})(i=e.Position||(e.Position={}));var r;(function(Pe){function Re(Fe,Ve){return(0,l.coalesce)((0,l.asArray)(Fe).map(it=>_e(it,Ve)))}Pe.from=Re;function _e(Fe,Ve){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,Ve),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Pe){function Re(te){switch(te){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Pe.from=Re;function _e(te){switch(te){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Pe){function Re(te){let Fe;return te.code&&((0,I.isString)(te.code)||(0,I.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...u.from(te.range),message:te.message,source:te.source,code:Fe,severity:m.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(h.from),tags:Array.isArray(te.tags)?(0,l.coalesce)(te.tags.map(n.from)):void 0}}Pe.from=Re;function _e(te){const Fe=new a.Diagnostic(u.to(te),te.message,m.to(te.severity));return Fe.source=te.source,Fe.code=(0,I.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(h.to),Fe.tags=te.tags&&(0,l.coalesce)(te.tags.map(n.to)),Fe}Pe.to=_e})(c=e.Diagnostic||(e.Diagnostic={}));var h;(function(Pe){function Re(te){return{...u.from(te.location.range),message:te.message,resource:te.location.uri}}Pe.from=Re;function _e(te){return new a.DiagnosticRelatedInformation(new a.Location(te.resource,u.to(te)),te.message)}Pe.to=_e})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(Pe){function Re(te){switch(te){case a.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Pe.from=Re;function _e(te){switch(te){case T.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Pe.to=_e})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(Pe){function Re(te){return typeof te=="number"&&te>=a.ViewColumn.One?te-1:te===a.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Pe.from=Re;function _e(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(C=e.ViewColumn||(e.ViewColumn={}));function L(Pe){return typeof Pe.range<"u"}function U(Pe){return Pe.length===0?!0:!!L(Pe[0])}e.isDecorationOptionsArr=U;var B;(function(Pe){function Re(Ke){return Ke.map(Pe.from)}Pe.fromMany=Re;function _e(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function te(Ke){let Je;if(_e(Ke)){const{language:_t,value:yt}=Ke;Je={value:"```"+_t+`
`+yt+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ke)?Je={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?Je={value:Ke}:Je={value:""};const ut=Object.create(null);Je.uris=ut;const Tt=_t=>{try{let yt=R.URI.parse(_t,!0);yt=yt.with({query:Fe(yt.query,ut)}),ut[_t]=yt}catch{}return""},Et=new _.marked.Renderer;return Et.link=Tt,Et.image=_t=>typeof _t=="string"?Tt(D.parseHrefAndDimensions(_t).href):"",(0,_.marked)(Je.value,{renderer:Et}),Je}Pe.from=te;function Fe(Ke,Je){if(!Ke)return Ke;let ut;try{ut=(0,y.parse)(Ke)}catch{}if(!ut)return Ke;let Tt=!1;return ut=(0,E.cloneAndChange)(ut,Et=>{if(R.URI.isUri(Et)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[_t]=Et,Tt=!0,_t}else return}),Tt?JSON.stringify(ut):Ke}function Ve(Ke){const Je=new a.MarkdownString(Ke.value,Ke.supportThemeIcons);return Je.isTrusted=Ke.isTrusted,Je.supportHtml=Ke.supportHtml,Je.baseUri=Ke.baseUri?R.URI.from(Ke.baseUri):void 0,Je}Pe.to=Ve;function it(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Pe.from(Ke)}Pe.fromStrict=it})(B=e.MarkdownString||(e.MarkdownString={}));function A(Pe){return U(Pe)?Pe.map(Re=>({range:u.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?B.fromMany(Re.hoverMessage):Re.hoverMessage?B.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):Pe.map(Re=>({range:u.from(Re)}))}e.fromRangeOrRangeWithMessage=A;function M(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?R.URI.file(Pe):Pe}e.pathOrURIToURI=M;var $;(function(Pe){function Re(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?M(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Re})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Pe){function Re(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?M(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?$.from(_e.before):void 0,after:_e.after?$.from(_e.after):void 0}}Pe.from=Re})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Pe){function Re(_e){if(typeof _e>"u")return _e;switch(_e){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Re})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(Pe){function Re(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?K.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?M(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?$.from(_e.before):void 0,after:_e.after?$.from(_e.after):void 0}}Pe.from=Re})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(Pe){function Re(te){return{text:te.newText,eol:te.newEol&&Ye.from(te.newEol),range:u.from(te.range)}}Pe.from=Re;function _e(te){const Fe=new a.TextEdit(u.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Ye.to(te.eol),Fe}Pe.to=_e})(O=e.TextEdit||(e.TextEdit={}));var x;(function(Pe){function Re(te,Fe,Ve){const it={edits:[]};if(te instanceof a.WorkspaceEdit){const Ke=new P.ResourceSet;for(const Je of te._allEntries())Je._type===1&&R.URI.isUri(Je.to)&&Je.from===void 0&&Ke.add(Je.to);for(const Je of te._allEntries())if(Je._type===1)it.edits.push({oldResource:Je.from,newResource:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2)it.edits.push({resource:Je.uri,textEdit:O.from(Je.edit),versionId:Ke.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata});else if(Je._type===6){if(!Ve){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Je);continue}it.edits.push({resource:Je.uri,textEdit:{range:u.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ke.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata})}else Je._type===3?it.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&it.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(nt.from)}})}return it}Pe.from=Re;function _e(te){const Fe=new a.WorkspaceEdit;for(const Ve of te.edits)Ve.textEdit?Fe.replace(R.URI.revive(Ve.resource),u.to(Ve.textEdit.range),Ve.textEdit.text):Fe.renameFile(R.URI.revive(Ve.oldResource),R.URI.revive(Ve.newResource),Ve.options);return Fe}Pe.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Pe){const Re=Object.create(null);Re[a.SymbolKind.File]=0,Re[a.SymbolKind.Module]=1,Re[a.SymbolKind.Namespace]=2,Re[a.SymbolKind.Package]=3,Re[a.SymbolKind.Class]=4,Re[a.SymbolKind.Method]=5,Re[a.SymbolKind.Property]=6,Re[a.SymbolKind.Field]=7,Re[a.SymbolKind.Constructor]=8,Re[a.SymbolKind.Enum]=9,Re[a.SymbolKind.Interface]=10,Re[a.SymbolKind.Function]=11,Re[a.SymbolKind.Variable]=12,Re[a.SymbolKind.Constant]=13,Re[a.SymbolKind.String]=14,Re[a.SymbolKind.Number]=15,Re[a.SymbolKind.Boolean]=16,Re[a.SymbolKind.Array]=17,Re[a.SymbolKind.Object]=18,Re[a.SymbolKind.Key]=19,Re[a.SymbolKind.Null]=20,Re[a.SymbolKind.EnumMember]=21,Re[a.SymbolKind.Struct]=22,Re[a.SymbolKind.Event]=23,Re[a.SymbolKind.Operator]=24,Re[a.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Re[Fe]=="number"?Re[Fe]:6}Pe.from=_e;function te(Fe){for(const Ve in Re)if(Re[Ve]===Fe)return Number(Ve);return a.SymbolKind.Property}Pe.to=te})(V=e.SymbolKind||(e.SymbolKind={}));var q;(function(Pe){function Re(te){switch(te){case a.SymbolTag.Deprecated:return 1}}Pe.from=Re;function _e(te){switch(te){case 1:return a.SymbolTag.Deprecated}}Pe.to=_e})(q=e.SymbolTag||(e.SymbolTag={}));var Y;(function(Pe){function Re(te){return{name:te.name,kind:V.from(te.kind),tags:te.tags&&te.tags.map(q.from),containerName:te.containerName,location:pe.from(te.location)}}Pe.from=Re;function _e(te){const Fe=new a.SymbolInformation(te.name,V.to(te.kind),te.containerName,pe.to(te.location));return Fe.tags=te.tags&&te.tags.map(q.to),Fe}Pe.to=_e})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Pe){function Re(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:u.from(te.range),selectionRange:u.from(te.selectionRange),kind:V.from(te.kind),tags:te.tags?.map(q.from)??[]};return te.children&&(Fe.children=te.children.map(Re)),Fe}Pe.from=Re;function _e(te){const Fe=new a.DocumentSymbol(te.name,te.detail,V.to(te.kind),u.to(te.range),u.to(te.selectionRange));return(0,l.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(q.to)),te.children&&(Fe.children=te.children.map(_e)),Fe}Pe.to=_e})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var he;(function(Pe){function Re(te){const Fe=new a.CallHierarchyItem(V.to(te.kind),te.name,te.detail||"",R.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Re;function _e(te,Fe,Ve){if(Fe=Fe??te._sessionId,Ve=Ve??te._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:te.name,detail:te.detail,kind:V.from(te.kind),uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(q.from)}}Pe.from=_e})(he=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ve;(function(Pe){function Re(_e){return new a.CallHierarchyIncomingCall(he.to(_e.from),_e.fromRanges.map(te=>u.to(te)))}Pe.to=Re})(ve=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Pe){function Re(_e){return new a.CallHierarchyOutgoingCall(he.to(_e.to),_e.fromRanges.map(te=>u.to(te)))}Pe.to=Re})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(Pe){function Re(te){return{range:te.range&&u.from(te.range),uri:te.uri}}Pe.from=Re;function _e(te){return new a.Location(R.URI.revive(te.uri),u.to(te.range))}Pe.to=_e})(pe=e.location||(e.location={}));var be;(function(Pe){function Re(te){const Fe=te,Ve=te;return{originSelectionRange:Fe.originSelectionRange?u.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:u.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?u.from(Fe.targetSelectionRange):void 0}}Pe.from=Re;function _e(te){return{targetUri:R.URI.revive(te.uri),targetRange:u.to(te.range),targetSelectionRange:te.targetSelectionRange?u.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?u.to(te.originSelectionRange):void 0}}Pe.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Pe){function Re(te){return{range:u.from(te.range),contents:B.fromMany(te.contents)}}Pe.from=Re;function _e(te){return new a.Hover(te.contents.map(B.to),u.to(te.range))}Pe.to=_e})(ke=e.Hover||(e.Hover={}));var Le;(function(Pe){function Re(te){return{range:u.from(te.range),expression:te.expression}}Pe.from=Re;function _e(te){return new a.EvaluatableExpression(u.to(te.range),te.expression)}Pe.to=_e})(Le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(Pe){function Re(te){if(te instanceof a.InlineValueText)return{type:"text",range:u.from(te.range),text:te.text};if(te instanceof a.InlineValueVariableLookup)return{type:"variable",range:u.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Re;function _e(te){switch(te.type){case"text":return{range:u.to(te.range),text:te.text};case"variable":return{range:u.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:u.to(te.range),expression:te.expression}}}Pe.to=_e})(We=e.InlineValue||(e.InlineValue={}));var oe;(function(Pe){function Re(te){return{frameId:te.frameId,stoppedLocation:u.from(te.stoppedLocation)}}Pe.from=Re;function _e(te){return new a.InlineValueContext(te.frameId,u.to(te.stoppedLocation))}Pe.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var ue;(function(Pe){function Re(te){return{range:u.from(te.range),kind:te.kind}}Pe.from=Re;function _e(te){return new a.DocumentHighlight(u.to(te.range),te.kind)}Pe.to=_e})(ue=e.DocumentHighlight||(e.DocumentHighlight={}));var fe;(function(Pe){function Re(_e){switch(_e){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Pe.to=Re})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Re(_e){return{triggerKind:fe.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Re})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Pe){function Re(te){switch(te){case a.CompletionItemTag.Deprecated:return 1}}Pe.from=Re;function _e(te){switch(te){case 1:return a.CompletionItemTag.Deprecated}}Pe.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Pe){const Re=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function _e(Ve){return Re.get(Ve)??9}Pe.from=_e;const te=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(Ve){return te.get(Ve)??a.CompletionItemKind.Property}Pe.to=Fe})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Pe){function Re(_e,te){const Fe=new a.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ee.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=D.isMarkdownString(_e.documentation)?B.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=u.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:u.to(_e.range.insert),replacing:u.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new a.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof a.Range?new a.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(Ve=>O.to(Ve))),Fe.command=te&&_e.command?te.fromInternal(_e.command):void 0,Fe}Pe.to=Re})(ie=e.CompletionItem||(e.CompletionItem={}));var F;(function(Pe){function Re(te){return{label:te.label,documentation:B.fromStrict(te.documentation)}}Pe.from=Re;function _e(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?B.to(te.documentation):te.documentation}}Pe.to=_e})(F=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(Pe){function Re(te){return{label:te.label,documentation:B.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(F.from):[],activeParameter:te.activeParameter}}Pe.from=Re;function _e(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?B.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(F.to):[],activeParameter:te.activeParameter}}Pe.to=_e})(H=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Pe){function Re(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(H.from):[]}}Pe.from=Re;function _e(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(H.to):[]}}Pe.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Re(_e,te){const Fe=new a.InlayHint(i.to(te.position),typeof te.label=="string"?te.label:te.label.map(me.to.bind(void 0,_e)),te.kind&&we.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(O.to),Fe.tooltip=D.isMarkdownString(te.tooltip)?B.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Pe.to=Re})(X=e.InlayHint||(e.InlayHint={}));var me;(function(Pe){function Re(_e,te){const Fe=new a.InlayHintLabelPart(te.label);return Fe.tooltip=D.isMarkdownString(te.tooltip)?B.to(te.tooltip):te.tooltip,S.Command.is(te.command)&&(Fe.command=_e.fromInternal(te.command)),te.location&&(Fe.location=pe.to(te.location)),Fe}Pe.to=Re})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Pe){function Re(te){return te}Pe.from=Re;function _e(te){return te}Pe.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var le;(function(Pe){function Re(te){return{range:u.from(te.range),url:te.target,tooltip:te.tooltip}}Pe.from=Re;function _e(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?R.URI.parse(te.url,!0):R.URI.revive(te.url)}catch{}return new a.DocumentLink(u.to(te.range),Fe)}Pe.to=_e})(le=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Pe){function Re(te){const Fe=new a.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=O.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(Ve=>O.to(Ve))),Fe}Pe.to=Re;function _e(te){return{label:te.label,textEdit:te.textEdit?O.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>O.from(Fe)):void 0}}Pe.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Pe){function Re(te){return new a.Color(te[0],te[1],te[2],te[3])}Pe.to=Re;function _e(te){return[te.red,te.green,te.blue,te.alpha]}Pe.from=_e})(ye=e.Color||(e.Color={}));var $e;(function(Pe){function Re(te){return{range:u.from(te.range)}}Pe.from=Re;function _e(te){return new a.SelectionRange(u.to(te.range))}Pe.to=_e})($e=e.SelectionRange||(e.SelectionRange={}));var je;(function(Pe){function Re(_e){switch(_e){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Pe.to=Re})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Pe){function Re(te){switch(te){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Re;function _e(te){switch(te){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Pe.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Re(te){if(te===a.EndOfLine.CRLF)return 1;if(te===a.EndOfLine.LF)return 0}Pe.from=Re;function _e(te){if(te===1)return a.EndOfLine.CRLF;if(te===0)return a.EndOfLine.LF}Pe.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(Pe){function Re(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Re})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var ot;(function(Pe){function Re(_e){const te={start:_e.start+1,end:_e.end+1};return _e.kind&&(te.kind=re.from(_e.kind)),te}Pe.from=Re})(ot=e.FoldingRange||(e.FoldingRange={}));var re;(function(Pe){function Re(_e){if(_e)switch(_e){case a.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Pe.from=Re})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Pe){function Re(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?u.from(_e.selection):void 0,override:typeof _e.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Re})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Pe){function Re(Ve){return Ve instanceof a.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:_e(Ve)||te(Ve)?new a.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Pe.from=Re;function _e(Ve){const it=Ve;return it?R.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function te(Ve){const it=Ve;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new a.RelativePattern(R.URI.revive(Ve.baseUri),Ve.pattern)}Pe.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var de;(function(Pe){function Re(_e){if(_e){if(Array.isArray(_e))return _e.map(Re);if(typeof _e=="string")return _e;{const te=_e;return{language:te.language,scheme:te.scheme,pattern:Ee.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Pe.from=Re})(de=e.LanguageSelector||(e.LanguageSelector={}));var Te;(function(Pe){function Re(te){return{start:te.start,end:te.end}}Pe.from=Re;function _e(te){return new a.NotebookRange(te.start,te.end)}Pe.to=_e})(Te=e.NotebookRange||(e.NotebookRange={}));var Ne;(function(Pe){function Re(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Pe.to=Re;function _e(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Pe.from=_e})(Ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Pe){function Re(_e){if(_e===v.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(_e===v.NotebookCellExecutionState.Pending)return;if(_e===v.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Re})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Pe){function Re(te){switch(te){case a.NotebookCellKind.Markup:return v.CellKind.Markup;case a.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Re;function _e(te){switch(te){case v.CellKind.Markup:return a.NotebookCellKind.Markup;case v.CellKind.Code:default:return a.NotebookCellKind.Code}}Pe.to=_e})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Xe;(function(Pe){function Re(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const Ve of te.cells)a.NotebookCellData.validate(Ve),Fe.cells.push(nt.from(Ve));return Fe}Pe.from=Re;function _e(te){const Fe=new a.NotebookData(te.cells.map(nt.to));return(0,I.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Pe.to=_e})(Xe=e.NotebookData||(e.NotebookData={}));var nt;(function(Pe){function Re(te){return{cellKind:ze.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ne.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(st.from):[]}}Pe.from=Re;function _e(te){return new a.NotebookCellData(ze.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(st.to):void 0,te.metadata,te.internalMetadata?Ne.to(te.internalMetadata):void 0)}Pe.to=_e})(nt=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(Pe){function Re(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Pe.from=Re;function _e(te){return new a.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Pe.to=_e})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var st;(function(Pe){function Re(te){return{outputId:te.id,items:te.items.map(ct.from),metadata:te.metadata}}Pe.from=Re;function _e(te){const Fe=te.items.map(ct.to);return new a.NotebookCellOutput(Fe,te.outputId,te.metadata)}Pe.to=_e})(st=e.NotebookCellOutput||(e.NotebookCellOutput={}));var et;(function(Pe){function Re(Fe){return te(Fe)?{include:(0,I.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,I.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,I.withNullAsUndefined)(Ee.from(Fe))}Pe.from=Re;function _e(Fe){return te(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Pe.to=_e;function te(Fe){const Ve=Fe;return Ve?!(0,I.isUndefinedOrNull)(Ve.include)&&!(0,I.isUndefinedOrNull)(Ve.exclude):!1}})(et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var gt;(function(Pe){function Re(_e,te,Fe){const Ve=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Ve,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Re})(gt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var wt;(function(Pe){function Re(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{}}}Pe.from=Re})(wt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Dt;(function(Pe){function Re(te){return{uri:te.uri,provides:te.provides}}Pe.from=Re;function _e(te){return new a.NotebookRendererScript(R.URI.revive(te.uri),te.provides)}Pe.to=_e})(Dt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Re(te){return{message:B.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:u.from(te.location.range),uri:te.location.uri}}}Pe.from=Re;function _e(te){const Fe=new a.TestMessage(typeof te.message=="string"?te.message:B.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?pe.to(te.location):void 0,Fe}Pe.to=_e})(ft=e.TestMessage||(e.TestMessage={}));var It;(function(Pe){Pe.namespace=p.namespaceTestTag,Pe.denamespace=p.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var Mt;(function(Pe){function Re(te){const Fe=(0,w.getPrivateApiFor)(te).controllerId;return{extId:d.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:R.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ve=>It.namespace(Fe,Ve.id)),range:k.Range.lift(u.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&B.fromStrict(te.error)||null}}Pe.from=Re;function _e(te){return{parent:void 0,error:void 0,id:d.TestId.fromString(te.extId).localId,label:te.label,uri:R.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:Ve}=It.denamespace(Fe);return new a.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Pe.toPlain=_e})(Mt=e.TestItem||(e.TestItem={})),function(Pe){function Re(te){return{id:te.id}}Pe.from=Re;function _e(te){return new a.TestTag(te.id)}Pe.to=_e}(It=e.TestTag||(e.TestTag={}));var Ot;(function(Pe){const Re=(te,Fe)=>{const Ve=[];for(const[Ke,Je]of Fe)d.TestId.compare(Je.item.extId,Ke)===2&&(Fe.delete(Ke),Ve.push(Je));const it={...Mt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(Je=>Je.type===0).map(ft.to)})),children:Ve.map(Ke=>Re(Ke,Fe))};for(const Ke of it.children)Ke.parent=it;return it};function _e(te){const Fe=[],Ve=new Map;for(const it of te.items)Ve.set(it.item.extId,it),te.request.targets.some(Ke=>Ke.controllerId===it.controllerId&&Ke.testIds.includes(it.item.extId))&&Fe.push(it);return{completedAt:te.completedAt,results:Fe.map(it=>Re(it,Ve))}}Pe.to=_e})(Ot=e.TestResults||(e.TestResults={}));var Ge;(function(Pe){function Re(Ve){return{covered:Ve.covered,total:Ve.covered}}function _e(Ve){return"line"in Ve?i.from(Ve):u.from(Ve)}function te(Ve){return"branches"in Ve?{count:Ve.executionCount,location:_e(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(it=>({count:it.executionCount,location:it.location&&_e(it.location)})):void 0}:{type:0,count:Ve.executionCount,location:_e(Ve.location)}}Pe.fromDetailed=te;function Fe(Ve){return{uri:Ve.uri,statement:Re(Ve.statementCoverage),branch:Ve.branchCoverage&&Re(Ve.branchCoverage),function:Ve.functionCoverage&&Re(Ve.functionCoverage),details:Ve.detailedCoverage?.map(te)}}Pe.fromFile=Fe})(Ge=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(Pe){function Re(_e){switch(_e){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Pe.to=Re})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(Pe){function Re(te){const Fe=new a.TypeHierarchyItem(V.to(te.kind),te.name,te.detail||"",R.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Re;function _e(te,Fe,Ve){if(Fe=Fe??te._sessionId,Ve=Ve??te._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:V.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(q.from)}}Pe.from=_e})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Nt;(function(Pe){function Re(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Re})(Nt=e.ViewBadge||(e.ViewBadge={}));var vt;(function(Pe){function Re(_e,te){const Fe=_e.fileData;return Fe?new class extends a.DataTransferItem{asFile(){return{name:Fe.name,uri:R.URI.revive(Fe.uri),data:(0,g.once)(()=>te())}}}(""):new a.DataTransferItem(_e.asString)}Pe.toDataTransferItem=Re})(vt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(Pe){function Re(te,Fe){const Ve=te.items.map(([it,Ke],Je)=>[it,vt.toDataTransferItem(Ke,()=>Fe(Je))]);return new a.DataTransfer(Ve)}Pe.toDataTransfer=Re;async function _e(te){const Fe={items:[]},Ve=[];return te.forEach((it,Ke)=>{Ve.push((async()=>{const Je=await it.asString(),ut=it.asFile();Fe.items.push([Ke,{asString:Je,fileData:ut?{name:ut.name,uri:ut.uri}:void 0}])})())}),await Promise.all(Ve),Fe}Pe.toDataTransferDTO=_e})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(De[220],Ie([1,0,2,10,7,16,79]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(I,R,k,S={timeout:1500,errors:3}){this._logService=I,this._documents=R,this._mainThreadBulkEdits=k,this._thresholds=S,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(R,k,S)=>{const w={dispose:this._callbacks.push([R,k,I])};return Array.isArray(S)&&S.push(w),w}}async $participateInSave(I,R){const k=l.URI.revive(I);let S=!1;const T=setTimeout(()=>S=!0,this._thresholds.timeout),w=[];try{for(const b of[...this._callbacks]){if(S)break;const v=this._documents.getDocument(k),d=await this._deliverEventAsyncAndBlameBadListeners(b,{document:v,reason:P.TextDocumentSaveReason.to(R)});w.push(d)}}finally{clearTimeout(T)}return w}_deliverEventAsyncAndBlameBadListeners([I,R,k],S){const T=this._badListeners.get(I);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,I,R,S).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const b=this._badListeners.get(I);this._badListeners.set(I,b?b+1:1),typeof b=="number"&&b>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,R,k,S){const T=[],w=Date.now(),{document:b,reason:v}=S,{version:d}=b,p=Object.freeze({document:b,reason:v,waitUntil(f){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(f))}});try{R.apply(k,[p])}catch(f){return Promise.reject(f)}return Object.freeze(T),new Promise((f,a)=>{const g=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(g),f(s)}).catch(s=>{clearTimeout(g),a(s)})}).then(f=>{const a={edits:[]};for(const g of f)if(Array.isArray(g)&&g.every(s=>s instanceof D.TextEdit))for(const{newText:s,newEol:u,range:o}of g)a.edits.push({resource:b.uri,versionId:void 0,textEdit:{range:o&&P.Range.from(o),text:s,eol:u&&P.EndOfLine.from(u)}});if(a.edits.length!==0)return d===b.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(De[221],Ie([1,0,12,2,16,7,128]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(k,S,T,w){this.start=k,this.deletedCount=S,this.deletedItems=T,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{constructor(k,S,T){this.notebook=k,this._extHostDocument=S,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(k,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return k._mime},set mime(w){k._mime=w},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(D.NotebookCellOutput.to)}setOutputItems(k,S,T){const w=T.map(D.NotebookCellOutputItem.to),b=this._outputs.find(v=>v.id===k);b&&(S||(b.items.length=0),b.items.push(...w))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=E;class I{constructor(k,S,T,w,b){this._proxy=k,this._textDocumentsAndEditors=S,this._textDocuments=T,this.uri=w,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0,void 0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,S={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===l.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(b=>b.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(S)}return this._notebook}updateBackup(k){this._backup?.delete(),this._backup=k}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,S,T){this._versionId=k.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:T});const w={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},b=[];for(const d of k.rawEvents)d.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,w.contentChanges):d.kind===_.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx,w.contentChanges):d.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),b.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),b.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),b.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===_.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),b.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),b.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const v=new Map;for(let d=0;d<b.length;d++){const p=b[d],f=v.get(p.cell);if(f===void 0){const a=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});v.set(p.cell,a-1)}else w.cellChanges[f]={...w.cellChanges[f],...p}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let S=k.start|0,T=k.end|0;return S<0&&(S=0),T>this._cells.length&&(T=this._cells.length),k.with({start:S,end:T})}_getCells(k){k=this._validateRange(k);const S=[];for(let T=k.start;T<k.end;T++)S.push(this._cells[T]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,S,T){if(this._disposed)return;const w=[],b=[],v=[];if(k.reverse().forEach(d=>{const f=d[2].map(s=>{const u=new E(this,this._textDocumentsAndEditors,s);return S||b.push(E.asModelAddData(this.apiNotebook,s)),u}),a=new y(d[0],d[1],[],f),g=this._cells.splice(d[0],d[1],...f);for(const s of g)v.push(s.uri),a.deletedItems.push(s.apiCell);w.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:v}),T)for(const d of w)T.push(d.asApiEvent())}_moveCell(k,S,T){const w=this._cells.splice(k,1);this._cells.splice(S,0,...w);const b=[new y(k,1,w.map(v=>v.apiCell),[]),new y(S,0,[],w)];for(const v of b)T.push(v.asApiEvent())}_setCellOutputs(k,S){this._cells[k].setOutputs(S)}_setCellOutputItems(k,S,T,w){this._cells[k].setOutputItems(S,T,w)}_changeCellLanguage(k,S){const T=this._cells[k];T.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(T.uri,S)}_changeCellMime(k,S){const T=this._cells[k];T.apiCell.mime=S}_changeCellMetadata(k,S){this._cells[k].setMetadata(S)}_changeCellInternalMetadata(k,S){this._cells[k].setInternalMetadata(S)}getCellFromApiCell(k){return this._cells.find(S=>S.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(S=>S.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(De[131],Ie([1,0,10,16,7]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(y,E,I,R,k,S){this.id=y,this._proxy=E,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=R,this._viewColumn=S}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get notebook(){return y.notebookData.apiNotebook},get selection(){return y._selections[0]},set selection(E){this.selections=[E]},get selections(){return y._selections},set selections(E){if(!Array.isArray(E)||!E.every(D.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");y._selections=E,y._trySetSelections(E)},get visibleRanges(){return y._visibleRanges},revealRange(E,I){y._proxy.$tryRevealRange(y.id,t.NotebookRange.from(E),I??D.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(t.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[222],Ie([1,0,4,14,16]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(y,E){this._logService=y,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,E);const I=this._notebooksAndEditors.getEditorById(y);E.visibleRanges&&I._acceptVisibleRanges(E.visibleRanges.ranges.map(D.NotebookRange.to)),E.selections&&I._acceptSelections(E.selections.selections.map(D.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const E in y)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(D.ViewColumn.to(y[E]))}};P=qe([xe(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[223],Ie([1,0,16,118,171,21,58,10]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,T,w){const b=this._handles++,{title:v,location:d,cancellable:p}=T,f={label:(0,D.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(b,{location:l.ProgressLocation.from(d),title:v,source:f,cancellable:p},S.isUnderDevelopment?void 0:S.identifier.value).catch(y.onUnexpectedExternalError),this._withProgress(b,w,!!p)}_withProgress(S,T,w){let b;w&&(b=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,b));const v=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),b?.dispose()};let d;try{d=T(new R(this._proxy,S),w&&b?b.token:P.CancellationToken.None)}catch(p){throw v(S),p}return d.then(p=>v(S),p=>v(S)),d}$acceptProgressCanceled(S){const T=this._mapHandleToCancellationSource.get(S);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=E;function I(k,S){return k.message=S.message,typeof S.increment=="number"&&(typeof k.increment=="number"?k.increment+=S.increment:k.increment=S.increment),k}class R extends t.Progress{constructor(S,T){super(w=>this.throttledReport(w)),this._proxy=S,this._handle=T}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}qe([(0,_.throttle)(100,(k,S)=>I(k,S),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[132],Ie([1,0,35,129,65,89,66,16,2]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(f,a,g,s)=>{let u=a;return{enumerable:!0,configurable:!1,get(){return u},set(o){if(!g(u,o)){const i=u;u=o,f.listener?.(s(o,i))}}}},R=(f,a)=>f===a,k={range:(f,a)=>f===a?!0:!f||!a?!1:f.isEqual(a),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,a)=>!(f.length!==a.length||f.some(g=>!a.find(s=>g.id===s.id)))},S=f=>a=>({op:4,update:f(a)}),T=(f,a)=>({range:I(f,void 0,k.range,S(g=>({range:l.Range.lift(y.Range.from(g))}))),label:I(f,a,k.label,S(g=>({label:g}))),description:I(f,void 0,k.description,S(g=>({description:g}))),sortText:I(f,void 0,k.sortText,S(g=>({sortText:g}))),canResolveChildren:I(f,!1,k.canResolveChildren,g=>({op:2,state:g})),busy:I(f,!1,k.busy,S(g=>({busy:g}))),error:I(f,void 0,k.error,S(g=>({error:y.MarkdownString.fromStrict(g)||null}))),tags:I(f,[],k.tags,(g,s)=>({op:1,new:g.map(y.TestTag.from),old:s.map(y.TestTag.from)}))}),w=f=>{const a=D.TestId.fromString(f.extId),g=new v(a.controllerId,a.localId,f.label,E.URI.revive(f.uri)||void 0);return g.range=y.Range.to(f.range||void 0),g.description=f.description||void 0,g.sortText=f.sortText||void 0,g.tags=f.tags.map(s=>y.TestTag.to({id:(0,_.denamespaceTestTag)(s).tagId})),g},b=f=>{let a;for(const g of f.tests){const s=w(g.item);(0,t.getPrivateApiFor)(s).parent=a,a=s}return a};e.toItemFromContext=b;class v{constructor(a,g,s,u){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const o=(0,t.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof d?void 0:o.parent}},children:{value:(0,P.createTestItemChildren)(o,t.getPrivateApiFor,v),enumerable:!0,writable:!1},...T(o,s)})}}e.TestItemImpl=v;class d extends v{constructor(a,g){super(a,a,g,void 0)}}e.TestItemRootImpl=d;class p extends P.TestItemCollection{constructor(a,g,s){super({controllerId:a,getDocumentVersion:u=>s.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new d(a,g),toITestItem:y.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(De[133],Ie([1,0,48,10,93,16,7]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(S,T,w){const b=y._Keys.nextId();S.$registerTextEditorDecorationType(T.identifier,b,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:b,dispose(){S.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=y,y._Keys=new D.IdGenerator("TextEditorDecorationType");class E{constructor(S,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,T){this._throwIfFinalized();let w=null;if(S instanceof _.Position)w=new _.Range(S,S);else if(S instanceof _.Range)w=S;else throw new Error("Unrecognized location");this._pushEdit(w,T,!1)}insert(S,T){this._throwIfFinalized(),this._pushEdit(new _.Range(S,S),T,!0)}delete(S){this._throwIfFinalized();let T=null;if(S instanceof _.Range)T=S;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(S,T,w){const b=this._document.validateRange(S);this._collectedEdits.push({range:b,text:T,forceMoveMarkers:w})}setEndOfLine(S){if(this._throwIfFinalized(),S!==_.EndOfLine.LF&&S!==_.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=E;class I{constructor(S,T,w,b){this._proxy=S,this._id=T,this._accept(w),this._logService=b;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(d){v._setTabSize(d)},get insertSpaces(){return v._insertSpaces},set insertSpaces(d){v._setInsertSpaces(d)},get cursorStyle(){return v._cursorStyle},set cursorStyle(d){v._setCursorStyle(d)},get lineNumbers(){return v._lineNumbers},set lineNumbers(d){v._setLineNumbers(d)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const T=Math.floor(S);return T>0?T:null}if(typeof S=="string"){const T=parseInt(S,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(S){const T=this._validateTabSize(S);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const T=this._validateInsertSpaces(S);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(S)})))}assign(S){const T={};let w=!1;if(typeof S.tabSize<"u"){const b=this._validateTabSize(S.tabSize);b==="auto"?(w=!0,T.tabSize=b):typeof b=="number"&&this._tabSize!==b&&(this._tabSize=b,w=!0,T.tabSize=b)}if(typeof S.insertSpaces<"u"){const b=this._validateInsertSpaces(S.insertSpaces);b==="auto"?(w=!0,T.insertSpaces=b):this._insertSpaces!==b&&(this._insertSpaces=b,w=!0,T.insertSpaces=b)}typeof S.cursorStyle<"u"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,w=!0,T.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,w=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(S.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(S,T){T.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=I;class R{constructor(S,T,w,b,v,d,p,f){this.id=S,this._proxy=T,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new I(this._proxy,this.id,d,w),this._visibleRanges=p,this._viewColumn=f;const a=this;this.value=Object.freeze({get document(){return b.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(g){if(!(g instanceof _.Selection))throw(0,t.illegalArgument)("selection");a._selections=[g],a._trySetSelection()},get selections(){return a._selections},set selections(g){if(!Array.isArray(g)||g.some(s=>!(s instanceof _.Selection)))throw(0,t.illegalArgument)("selections");a._selections=g,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return a._options.value},set options(g){a._disposed||a._options.assign(g)},get viewColumn(){return a._viewColumn},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,s={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new E(b.getValue(),s);return g(u),a._applyEdit(u)},insertSnippet(g,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!s||Array.isArray(s)&&s.length===0)o=a._selections.map(i=>P.Range.from(i));else if(s instanceof _.Position){const{lineNumber:i,column:r}=P.Position.from(s);o=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(s instanceof _.Range)o=[P.Range.from(s)];else{o=[];for(const i of s)if(i instanceof _.Range)o.push(P.Range.from(i));else{const{lineNumber:r,column:n}=P.Position.from(i);o.push({startLineNumber:r,startColumn:n,endLineNumber:r,endColumn:n})}}return T.$tryInsertSnippet(S,b.getValue().version,g.value,o,u)},setDecorations(g,s){const u=s.length===0;u&&!a._hasDecorationsForKey.has(g.key)||(u?a._hasDecorationsForKey.delete(g.key):a._hasDecorationsForKey.add(g.key),a._runOnProxy(()=>{if(P.isDecorationOptionsArr(s))return T.$trySetDecorations(S,g.key,P.fromRangeOrRangeWithMessage(s));{const o=new Array(4*s.length);for(let i=0,r=s.length;i<r;i++){const n=s[i];o[4*i]=n.start.line+1,o[4*i+1]=n.start.character+1,o[4*i+2]=n.end.line+1,o[4*i+3]=n.end.character+1}return T.$trySetDecorationsFast(S,g.key,o)}}))},revealRange(g,s){a._runOnProxy(()=>T.$tryRevealRange(S,P.Range.from(g),s||_.TextEditorRevealType.Default))},show(g){T.$tryShowEditor(S,P.ViewColumn.from(g))},hide(){T.$tryHideEditor(S)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,l.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,l.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,l.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,l.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const T=S.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const w=T.edits.map(v=>v.range);w.sort((v,d)=>v.end.line===d.end.line?v.end.character===d.end.character?v.start.line===d.start.line?v.start.character-d.start.character:v.start.line-d.start.line:v.end.character-d.end.character:v.end.line-d.end.line);for(let v=0,d=w.length-1;v<d;v++){const p=w[v].end;if(w[v+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=T.edits.map(v=>({range:P.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,b,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=R}),define(De[224],Ie([1,0,3,189]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(De[225],Ie([1,0,27,4,9]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class _{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let S of k.activationEvents)S==="onUri"&&(S=`onUri:${l.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,S){this._extensionDescriptions=I(this._extensionDescriptions,S),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,T.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,p){this.addNode(d),this.addNode(p),this._arcs.has(d)?this._arcs.get(d).push(p):this._arcs.set(d,[p])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,p){const f=S.getArcs(d);for(let a=0;a<f.length;a++)if(!p.has(f[a]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const d of k){const p=l.ExtensionIdentifier.toKey(d.identifier);if(T.set(p,d),d.extensionDependencies)for(const f of d.extensionDependencies){const a=l.ExtensionIdentifier.toKey(f);S.addArc(p,a)}}const w=new Set;S.getNodes().filter(d=>S.getArcs(d).length===0).forEach(d=>w.add(d));const b=S.getNodes().filter(d=>!w.has(d));let v;do{v=!1;for(let d=0;d<b.length;d++){const p=b[d];S.hasOnlyGoodArcs(p,w)&&(b.splice(d,1),d--,w.add(p),v=!0)}}while(v);return b.map(d=>T.get(d))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const S=this._activationMap.get(k);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const S=this._extensionsMap.get(l.ExtensionIdentifier.toKey(k));return S||void 0}getExtensionDescriptionByUUID(k){for(const S of this._extensionsArr)if(S.uuid===k)return S}getExtensionDescriptionByIdOrUUID(k,S){return this.getExtensionDescription(k)??(S?this.getExtensionDescriptionByUUID(S):void 0)}}e.ExtensionDescriptionRegistry=_;var y;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(y||(y={}));function E(R,k){const S=R.isBuiltin?0:R.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(S!==T)return S-T;const w=D.posix.basename(R.extensionLocation.path),b=D.posix.basename(k.extensionLocation.path);return w<b?-1:w>b?1:0}function I(R,k){const S=new Set;return k.forEach(T=>S.add(l.ExtensionIdentifier.toKey(T))),R.filter(T=>!S.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[226],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function _(R){delete R[t.ENV_KEY],delete R[D.ENV_KEY],delete R[P.ENV_KEY]}function y(R,k){_(k),R.serialize(k)}e.writeExtHostConnection=y;function E(R){if(R[t.ENV_KEY])return I(R,new t(R[t.ENV_KEY]));if(R[D.ENV_KEY])return I(R,new D);if(R[P.ENV_KEY])return I(R,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function I(R,k){return _(R),k}}),define(De[134],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function _(I){const R=l.VSBuffer.alloc(1);switch(I){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=_;function y(I,R){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=y;var E;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[28],Ie([1,0,4,2,3,27,198]),function(J,e,l,t,D,P,_){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class E{constructor(n){this.affinity=n,this.kind=1}equals(n){return this.kind===n.kind&&this.affinity===n.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class I{constructor(){this.kind=2,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=I;class R{constructor(){this.kind=3,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(n){this.dependency=n}}e.MissingExtensionDependency=k;var S;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(n,c){const h=[],m=[],C=[],L=[],U=d(this._allExtensions),B=d(n),A=(K,z)=>K.extensionLocation.toString()===z.extensionLocation.toString()||K.isBuiltin===z.isBuiltin||K.isUserBuiltin===z.isUserBuiltin||K.isUnderDevelopment===z.isUnderDevelopment;for(const K of this._allExtensions){const z=B.get(P.ExtensionIdentifier.toKey(K.identifier));if(!z){h.push(K.identifier),U.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}if(!A(K,z)){h.push(K.identifier),U.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of n){const z=U.get(P.ExtensionIdentifier.toKey(K.identifier));if(!z){m.push(K);continue}if(!A(z,K)){h.push(z.identifier),U.delete(P.ExtensionIdentifier.toKey(z.identifier));continue}}const M=v(this._myExtensions),$=v(c);for(const K of this._myExtensions)$.has(P.ExtensionIdentifier.toKey(K))||C.push(K);for(const K of c)M.has(P.ExtensionIdentifier.toKey(K))||L.push(K);const N={toRemove:h,toAdd:m,myToRemove:C,myToAdd:L};return this.delta(N),N}delta(n){const{toRemove:c,toAdd:h,myToRemove:m,myToAdd:C}=n,L=v(c),U=v(m);for(let B=0;B<this._allExtensions.length;B++)L.has(P.ExtensionIdentifier.toKey(this._allExtensions[B].identifier))&&(this._allExtensions.splice(B,1),B--);for(let B=0;B<this._myExtensions.length;B++)U.has(P.ExtensionIdentifier.toKey(this._myExtensions[B]))&&(this._myExtensions.splice(B,1),B--);for(const B of h)this._allExtensions.push(B);for(const B of C)this._myExtensions.push(B)}containsExtension(n){for(const c of this._myExtensions)if(P.ExtensionIdentifier.equals(c,n))return!0;return!1}}e.ExtensionHostExtensions=w;class b{constructor(n){if(this[y]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,n)for(const c of n)this.add(c)}get size(){return this._map.size}add(n){return this._map.set(this._toKey(n),n),this}clear(){this._map.clear()}delete(n){return this._map.delete(this._toKey(n))}has(n){return this._map.has(this._toKey(n))}forEach(n,c){this._map.forEach(h=>n.call(c,h,h,this))}*entries(){for(const[n,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=b;function v(r){const n=new Set;for(const c of r)n.add(P.ExtensionIdentifier.toKey(c));return n}e.extensionIdentifiersArrayToSet=v;function d(r){const n=new Map;for(const c of r)n.set(P.ExtensionIdentifier.toKey(c.identifier),c);return n}function p(r,n){return r.enabledApiProposals?r.enabledApiProposals.includes(n):!1}e.isProposedApiEnabled=p;function f(r,n){if(!p(r,n))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=f;class a{constructor(n,c,h,m){this.codeLoadingTime=n,this.activateCallTime=c,this.activateResolvedTime=h,this.activationReason=m}}e.ActivationTimes=a;class g{constructor(n,c){this.description=n,this.value=c}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function o(r,n){return{identifier:new P.ExtensionIdentifier((0,_.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!n,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=o;class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None}activateByEvent(n){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(n,c){return Promise.resolve(0)}getInspectPorts(n,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(n,c){return Promise.resolve()}}e.NullExtensionService=i}),define(De[227],Ie([1,0,10,27,28,14,18]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(v,d,p,f){this.startup=v,this.codeLoadingTime=d,this.activateCallTime=p,this.activateResolvedTime=f}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class E{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,d){return v===-1||d===-1?-1:d-v}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class I{constructor(v,d,p,f,a,g){this.activationFailed=v,this.activationFailedError=d,this.activationTimes=p,this.module=f,this.exports=a,this.subscriptions=g}}e.ActivatedExtension=I;class R extends I{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class k extends I{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class S extends I{constructor(v){super(!0,v,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let T=class{constructor(v,d,p,f,a){this._logService=a,this._registry=v,this._resolvedExtensionsSet=new Set,d.forEach(g=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(g))),this._externalExtensionsMap=new Map,p.forEach(g=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(g),g)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,d]of this._operations)d.dispose()}isActivated(v){const d=this._operations.get(t.ExtensionIdentifier.toKey(v));return Boolean(d&&d.value)}getActivatedExtension(v){const d=this._operations.get(t.ExtensionIdentifier.toKey(v));if(!d||!d.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return d.value}async activateByEvent(v,d){if(this._alreadyActivatedEvents[v])return;const p=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(p.map(f=>({id:f.identifier,reason:{startup:d,extensionId:f.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,d){const p=this._registry.getExtensionDescription(v);if(!p)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:p.identifier,reason:d}])}async _activateExtensions(v){const d=v.filter(p=>!this.isActivated(p.id)).map(p=>this._handleActivationRequest(p));await Promise.all(d.map(p=>p.wait()))}_handleActivationRequest(v){if(this._operations.has(t.ExtensionIdentifier.toKey(v.id)))return this._operations.get(t.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const d=this._registry.getExtensionDescription(v.id);if(!d){const a=new Error(`Cannot activate unknown extension '${v.id.value}'`),g=this._createAndSaveOperation(v,null,[],new S(a));return this._host.onExtensionActivationError(v.id,a,new D.MissingExtensionDependency(v.id.value)),g}const p=[],f=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const a of f){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(a)))continue;const g=this._operations.get(t.ExtensionIdentifier.toKey(a));if(g){p.push(g);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(a))){p.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(a)),reason:v.reason}));continue}const s=this._registry.getExtensionDescription(a);if(s){if(!s.main&&!s.browser)continue;p.push(this._handleActivationRequest({id:s.identifier,reason:v.reason}));continue}const u=d.displayName||d.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${a}'`),i=this._createAndSaveOperation(v,d.displayName,[],new S(o));return this._host.onExtensionActivationError(d.identifier,o,new D.MissingExtensionDependency(a)),i}return this._createAndSaveOperation(v,d.displayName,p,null)}_createAndSaveOperation(v,d,p,f){const a=new w(v.id,d,v.reason,p,f,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(v.id),a),a}};T=qe([xe(4,P.ILogService)],T),e.ExtensionsActivator=T;let w=class{constructor(v,d,p,f,a,g,s){this._id=v,this._displayName=d,this._reason=p,this._deps=f,this._value=a,this._host=g,this._logService=s,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const d=this._deps[v];if(d.value&&!d.value.activationFailed){this._deps.splice(v,1),v--;continue}if(d.value&&d.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);p.detail=d.value.activationFailedError,this._value=new S(p),this._host.onExtensionActivationError(this._id,p,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const d=new Error;if(v&&v.name&&(d.name=v.name),v&&v.message?d.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(d.stack=v.stack),this._value=new S(d),this._isDisposed&&l.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};w=qe([xe(6,P.ILogService)],w)}),define(De[228],Ie([1,0,14,26,28]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(y,E){super(y.createLogger(E.logFile,{name:D.ExtensionHostLogFileName}))}};P=qe([xe(0,l.ILoggerService),xe(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(De[229],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[230],Ie([1,0,185,10,41,84,119,43,27,229,196]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=y.Registry.as(_.Extensions.JSONContribution);class S{constructor(a,g,s){this._messageHandler=a,this._extension=g,this._extensionPointId=s}_msg(a,g){this._messageHandler({type:a,message:g,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(D.default.Error,a)}warn(a){this._msg(D.default.Warning,a)}info(a){this._msg(D.default.Info,a)}}e.ExtensionMessageCollector=S;class T{constructor(a,g){this.added=a,this.removed=g}static _toSet(a){const g=new Set;for(let s=0,u=a.length;s<u;s++)g.add(E.ExtensionIdentifier.toKey(a[s].description.identifier));return g}static compute(a,g){if(!a||!a.length)return new T(g,[]);if(!g||!g.length)return new T([],a);const s=this._toSet(a),u=this._toSet(g),o=g.filter(r=>!s.has(E.ExtensionIdentifier.toKey(r.description.identifier))),i=a.filter(r=>!u.has(E.ExtensionIdentifier.toKey(r.description.identifier)));return new T(o,i)}}e.ExtensionPointUserDelta=T;class w{constructor(a,g){this.name=a,this.defaultExtensionKind=g,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=T.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,t.onUnexpectedError)(a)}}}e.ExtensionPoint=w;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},v="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const g=new w(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,g),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,k.registerSchema(v,e.schema),g}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const p={ExtensionsRegistry:"ExtensionsRegistry"};y.Registry.add(p.ExtensionsRegistry,new d),e.ExtensionsRegistry=y.Registry.as(p.ExtensionsRegistry),k.registerSchema(v,e.schema),k.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(De[231],Ie([1,0,182,13,24,230,52,4]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var I;(function(S){function T(w,b,v){if(!w)return;const d=t.isString(w.type)?w.type:void 0;if(!d||d.length===0){v.error(l.localize(3,null));return}const p=[];if(Array.isArray(w.required))for(const f of w.required)t.isString(f)&&p.push(f);return{extensionId:b.value,taskType:d,required:p,properties:w.properties?D.deepClone(w.properties):{},when:w.when?_.ContextKeyExpr.deserialize(w.when):void 0}}S.from=T})(I||(I={}));const R=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:E}});class k{constructor(){this._onDefinitionsChanged=new y.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,w)=>{R.setHandler((b,v)=>{this._schema=void 0;try{for(const d of v.removed){const p=d.value;for(const f of p)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const d of v.added){const p=d.value;for(const f of p){const a=I.from(f,d.description.identifier,d.collector);a&&(this.taskTypes[a.taskType]=a)}}(v.removed.length>0||v.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const w of this.all()){const b={type:"object",additionalProperties:!1};w.required.length>0&&(b.required=w.required.slice(0)),w.properties!==void 0?b.properties=D.deepClone(w.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[w.taskType]},T.push(b)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(De[232],Ie([1,0,183,13,22,24,52,231]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var E;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function K(z){if(!z)return N.Strong;switch(z.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(N){function K(z){switch(z.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=K}(R=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function K(z){switch(z.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=K}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(N){function K(z){switch(z.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=K}(S=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(N){function K(O){switch(O.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=K;function z(O){switch(O){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=z}(w=e.RuntimeType||(e.RuntimeType={}));var b;(function(N){function K(z){return t.isString(z)?z:z.value}N.value=K})(b=e.CommandString||(e.CommandString={}));var v;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function K(O){return O===N.Clean._id||O===N.Build._id||O===N.Rebuild._id||O===N.Test._id}N.is=K;function z(O){if(O!==void 0)return t.isString(O)?K(O)?{_id:O,isDefault:!1}:void 0:O}N.from=z})(v=e.TaskGroup||(e.TaskGroup={}));var d;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var p;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function K(z){switch(z){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=K})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(N){N.parallel="parallel",N.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var a;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class s{constructor(K,z,O,x,V,q){this._label="",this._id=K,z&&(this._label=z),O&&(this.type=O),this.runOptions=x,this.configurationProperties=V,this._source=q}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,z=!1){if(K===void 0)return!1;if(t.isString(K))return K===this._label||K===this.configurationProperties.identifier||z&&K===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(K,z,O,x,V,q,Y,Q){super(K,O,void 0,Y,Q,z),this.command={},this._source=z,this.hasDefinedMatchers=q,V&&(this.command=V)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case w.Shell:z="shell";break;case w.Process:z="process";break;case w.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(K){return K instanceof u}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:z};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new u(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=u;class o extends s{constructor(K,z,O,x,V,q,Y){super(K,O,x,q,Y,z),this._source=z,this.configures=V}static is(K){return K instanceof o}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:z};return JSON.stringify(O)}}e.ConfiguringTask=o;class i extends s{constructor(K,z,O,x,V,q,Y,Q,he){super(K,O,x,Q,he,z),this.defines=V,this.hasDefinedMatchers=Y,this.command=q,this.icon=he.icon,this.hide=he.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof i}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new i(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=i;class r extends s{constructor(K,z,O,x,V,q){super(K,O,x,V,q,z),this._source=z}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new r(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=r;var n;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(n=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(n=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(K){this._order=new Map;for(let z=0;z<K.length;z++)this._order.set(K[z].uri.toString(),z)}compare(K,z){const O=K.getWorkspaceFolder(),x=z.getWorkspaceFolder();if(O&&x){let V=this._order.get(O.uri.toString());V=V===void 0?0:V+1;let q=this._order.get(x.uri.toString());return q=q===void 0?0:q+1,V===q?K._label.localeCompare(z._label):V-q}else return!O&&x?-1:O&&!x?1:0}}e.TaskSorter=h;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(N){N.SingleRun="singleRun",N.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var L;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var U;(function(N){function K(z,O,x,V,q){if(O){const Y={kind:z,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:O};return z==="start"?(Y.terminalId=x,Y.resolvedVariables=V):z==="processStarted"?Y.processId=x:z==="processEnded"&&(Y.exitCode=x),Object.freeze(Y)}else return Object.freeze({kind:"changed"})}N.create=K})(U=e.TaskEvent||(e.TaskEvent={}));var B;(function(N){function K(O){const x=Object.keys(O).sort();let V="";for(const q of x){let Y=O[q];Y instanceof Object?Y=K(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),V+=q+","+Y+","}return V}function z(O){const V={_key:K(O),type:O.taskType};return Object.assign(V,O),V}N.create=z})(B=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(N){function K(z,O){const x=y.TaskDefinitionRegistry.get(z.type);if(x===void 0){const Q=P.deepClone(z);return delete Q._key,B.create(Q)}const V=Object.create(null);V.type=x.taskType;const q=new Set;x.required.forEach(Q=>q.add(Q));const Y=x.properties;for(const Q of Object.keys(Y)){const he=z[Q];if(he!=null)V[Q]=he;else if(q.has(Q)){const ve=Y[Q];if(ve.default!==void 0)V[Q]=P.deepClone(ve.default);else switch(ve.type){case"boolean":V[Q]=!1;break;case"number":case"integer":V[Q]=0;break;case"string":V[Q]="";break;default:O.error(l.localize(2,null,JSON.stringify(z,void 0,0),Q));return}}}return B.create(V)}N.createTaskIdentifier=K})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[233],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,y)=>{this._actualOk=_,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,l.onUnexpectedError)(_))}then(_,y){return this._ensureActual().then(_,y)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=t;class D extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=D}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function D(y){const E=new l(y);return t[E.nid]=E,E}e.createProxyIdentifier=D;function P(y){return t[y].sid}e.getStringIdentifierForProxy=P;class _{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=_}),define(De[5],Ie([1,0,62,55]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(P=e.TabInputKind||(e.TabInputKind={}));var _;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(_=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(p){return p._id=S._n++,p}}e.IdObject=S,S._n=0;var T;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(T=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function b(d){return d&&d.edits&&(0,l.revive)(d),d}e.reviveWorkspaceEditDto=b;var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,t.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,t.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,t.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,t.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,t.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,t.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,t.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,t.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,t.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,t.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,t.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,t.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,t.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,t.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,t.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,t.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,t.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,t.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,t.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,t.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,t.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,t.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,t.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,t.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,t.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,t.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,t.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,t.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,t.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,t.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,t.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,t.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,t.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,t.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,t.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,t.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,t.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,t.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,t.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,t.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,t.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,t.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,t.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,t.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,t.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,t.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,t.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,t.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,t.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,t.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,t.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,t.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,t.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,t.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,t.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,t.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,t.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,t.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,t.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,t.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,t.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,t.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[67],Ie([1,0,3,14,5,15]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(E,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(D.MainContext.MainThreadTelemetry)}report(E,I,R){const k=this.getUsageKey(E,I);this._reportedUsages.has(k)||(this._reportedUsages.add(k),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:E}))}getUsageKey(E,I){return`${E}-${I.identifier.value}`}};_=qe([xe(0,P.IExtHostRpcService),xe(1,t.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(y,E,I){}})}),define(De[234],Ie([1,0,4,5,7,27]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,I,R,k={}){const S=P.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(S)||[],w=[...R].sort().join(" ");let b=T.find(v=>v.providerId===I&&v.scopes===w);if(b)return b.result;{const v=this._getSession(E,S,I,R,k);b={providerId:I,scopes:w,result:v},T.push(b),this._inFlightRequests.set(S,T);try{await v}finally{const d=T.findIndex(p=>p.providerId===I&&p.scopes===w);d>-1&&(T.splice(d),this._inFlightRequests.set(S,T))}return v}}async _getSession(E,I,R,k,S={}){await this._proxy.$ensureProvider(R);const T=E.displayName||E.name;return this._proxy.$getSession(R,k,I,T,S)}async removeSession(E,I){const R=this._authenticationProviders.get(E);return R?R.provider.removeSession(I):this._proxy.$removeSession(E,I)}registerAuthenticationProvider(E,I,R,k){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:I,provider:R,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:I});const S=R.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,I,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(w=>w.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,I){return this._onDidChangeSessions.fire({provider:{id:E,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(De[235],Ie([1,0,5,15,16,28]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(E,I){this._proxy=E.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>I.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,I){const R=(0,P.isProposedApiEnabled)(I,"snippetWorkspaceEdit"),k=D.WorkspaceEdit.from(E,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(k)}};_=qe([xe(0,t.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(De[236],Ie([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const _=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(y){return _.$writeText(y)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[37],Ie([1,0,13,7,16,24,5,17,14,62,35,49,2,6,3,15,132,23,55,50]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f){"use strict";var a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(c,h){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,g.set(this,void 0),tt(this,a,c.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=h,tt(this,g,c.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,m=>{const C=this._apiCommands.get(m);return C?.result===i.Void?C:void 0},h),this._argumentProcessors=[{processArgument(m){return(0,I.revive)(m)}},{processArgument(m){return(0,P.cloneAndChange)(m,function(C){if(R.Range.isIRange(C))return D.Range.to(C);if(k.Position.isIPosition(C))return D.Position.to(C);if(R.Range.isIRange(C.range)&&S.URI.isUri(C.uri))return D.location.to(C);if(C instanceof d.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const h=this.registerCommand(!1,c.id,async(...m)=>{const C=c.args.map((U,B)=>{if(!U.validate(m[B]))throw new Error(`Invalid argument '${U.name}' when running '${c.id}', received: ${m[B]}`);return U.convert(m[B])}),L=await this.executeCommand(c.internalId,...C);return c.result.convert(L,m,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{h.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,h,m,C,L,U){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:m,thisArg:C,description:L,extension:U}),c&&Ue(this,a,"f").$registerCommand(h),new t.Disposable(()=>{this._commands.delete(h)&&c&&Ue(this,a,"f").$unregisterCommand(h)})}executeCommand(c,...h){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,h,!0)}async _doExecuteCommand(c,h,m){if(this._commands.has(c))return Ue(this,a,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,h,!1);{let C=!1;const L=(0,P.cloneAndChange)(h,function(U){if(U instanceof t.Position)return D.Position.from(U);if(U instanceof t.Range)return D.Range.from(U);if(U instanceof t.Location)return D.location.from(U);if(t.NotebookRange.isNotebookRange(U))return D.NotebookRange.from(U);if(U instanceof ArrayBuffer)return C=!0,d.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return C=!0,d.VSBuffer.wrap(U);if(U instanceof d.VSBuffer)return C=!0,U;if(!Array.isArray(U))return U});try{const U=await Ue(this,a,"f").$executeCommand(c,C?new p.SerializableObjectWithBuffers(L):L,m);return(0,I.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(c,h,!1);throw U}}}async _executeContributedCommand(c,h,m){const C=this._commands.get(c);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,c);const{callback:L,thisArg:U,description:B}=C;if(B)for(let A=0;A<B.args.length;A++)try{(0,l.validateConstraint)(h[A],B.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${B.args[A].name}' - ${B.args[A].description}`)}try{return await L.apply(U,h)}catch(A){if(c===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...h);M&&(c=M.command)}throw this._logService.error(A,c,C.extension?.identifier),m?new class extends Error{constructor(){super((0,f.toErrorMessage)(A)),this.id=c,this.source=C.extension?.displayName??C.extension?.name}}:A}}_reportTelemetry(c,h){!c.extension||c.extension.isBuiltin||Ue(this,g,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:h})}$executeContributedCommand(c,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(h=h.map(m=>this._argumentProcessors.reduce((C,L)=>L.processArgument(C),m)),this._executeContributedCommand(c,h,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Ue(this,a,"f").$getCommands().then(h=>(c&&(h=h.filter(m=>m[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[h,m]of this._commands){const{description:C}=m;C&&(c[h]=C)}return Promise.resolve(c)}};a=new WeakMap,g=new WeakMap,s=qe([xe(0,b.IExtHostRpcService),xe(1,E.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class u{constructor(c,h,m){this._commands=c,this._lookupApiCommand=h,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,h){if(!c)return;const m={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return m;const C=this._lookupApiCommand(c.command);if(C)m.id=C.internalId,m.arguments=C.args.map((L,U)=>L.convert(c.arguments&&c.arguments[U]));else if((0,y.isNonEmptyArray)(c.arguments)){const L=++this._cachIdPool;this._cache.set(L,c),h.add((0,T.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),m.$ident=L,m.id=this.delegatingCommandId,m.arguments=[L],this._logService.trace("CommandsConverter#CREATE",c.command,L)}return m}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const h=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class o{constructor(c,h,m,C){this.name=c,this.description=h,this.validate=m,this.convert=C}optional(){return new o(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,h){return new o(c??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",n=>S.URI.isUri(n),n=>n),o.Position=new o("position","A position in a text document",n=>t.Position.isPosition(n),D.Position.from),o.Range=new o("range","A range in a text document",n=>t.Range.isRange(n),D.Range.from),o.Selection=new o("selection","A selection in a text document",n=>t.Selection.isSelection(n),D.Selection.from),o.Number=new o("number","",n=>typeof n=="number",n=>n),o.String=new o("string","",n=>typeof n=="string",n=>n),o.CallHierarchyItem=new o("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",n=>n instanceof v.TestItemImpl,D.TestItem.from);class i{constructor(c,h){this.description=c,this.convert=h}}e.ApiCommandResult=i,i.Void=new i("no result",n=>n);class r{constructor(c,h,m,C,L){this.id=c,this.internalId=h,this.description=m,this.args=C,this.result=L}}e.ApiCommand=r}),define(De[237],Ie([1,0,2,16,7,64,37,17,113,117,12]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(b,v)=>{if((0,y.isFalsyOrEmpty)(b))return;class d extends D.SymbolInformation{static to(f){const a=new d(f.name,t.SymbolKind.to(f.kind),f.containerName||"",new D.Location(v[0],t.Range.to(f.range)));return a.detail=f.detail,a.range=a.location.range,a.selectionRange=t.Range.to(f.selectionRange),a.children=f.children?f.children.map(d.to):[],a}}return b.map(d.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",b=>typeof b=="string",b=>b),new _.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",b=>Array.isArray(b)&&b.every(v=>D.Position.isPosition(v)),b=>b.map(t.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",b=>b.map(v=>{let d;for(const p of v.reverse())d=new D.SelectionRange(t.Range.to(p),d);return d}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",b=>b.map(t.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",b=>{if(!!b)return{range:t.Range.to(b.range),placeholder:b.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",b=>{if(!!b){if(b.rejectReason)throw new Error(b.rejectReason);return t.WorkspaceEdit.to(b)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",b=>b.map(t.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new D.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const v=(0,E.decodeSemanticTokensDto)(b);if(v.type==="full")return new D.SemanticTokens(v.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new D.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const v=(0,E.decodeSemanticTokensDto)(b);if(v.type==="full")return new D.SemanticTokens(v.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(b,v,d)=>{if(!b)return new D.CompletionList([]);const p=b.suggestions.map(f=>t.CompletionItem.to(f,d));return new D.CompletionList(p,b.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",b=>{if(b)return t.SignatureHelp.to(b)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(b,v,d)=>T(p=>new D.CodeLens(t.Range.to(p.range),p.command&&d.fromInternal(p.command)))(b))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",b=>D.Range.isRange(b),b=>D.Selection.isSelection(b)?t.Selection.from(b):t.Range.from(b)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(b,v,d)=>T(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(p.command)}else{const f=new D.CodeAction(p.title,p.kind?new D.CodeActionKind(p.kind):void 0);return p.edit&&(f.edit=t.WorkspaceEdit.to(p.edit)),p.command&&(f.command=d.fromInternal(p.command)),f.isPreferred=p.isPreferred,f}})(b))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",b=>b?b.map(v=>new D.ColorInformation(t.Range.to(v.range),t.Color.to(v.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",b=>b instanceof D.Color,t.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",b=>!0,b=>({uri:b.uri,range:t.Range.from(b.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",b=>b?b.map(t.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(b,v,d)=>b.map(t.InlayHint.to.bind(void 0,d)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(b=>({viewType:b.viewType,displayName:b.displayName,options:{transientOutputs:b.options.transientOutputs,transientCellMetadata:b.options.transientCellMetadata,transientDocumentMetadata:b.options.transientDocumentMetadata},filenamePattern:b.filenamePattern.map(v=>t.NotebookExclusiveDocumentPattern.to(v))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",b=>b.map(t.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",b=>l.URI.isUri(b)||typeof b=="string"&&(0,I.matchesSomeScheme)(b,R.Schemas.http,R.Schemas.https),b=>b),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[t.ViewColumn.from(b),void 0]:[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[t.ViewColumn.from(b),void 0]:[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="object",b=>b&&[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class S{static register(v){k.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=S;function T(b){return v=>{if(Array.isArray(v))return v.map(b)}}function w(b){if(!Array.isArray(b))return;const v=[];for(const d of b)P.isLocationLink(d)?v.push(t.DefinitionLink.to(d)):v.push(t.location.to(d));return v}}),define(De[238],Ie([1,0,18,58,4,6,2,64,27,16,7,28,5]),function(J,e,l,t,D,P,_,y,E,I,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(w,b,v){const d=w.getProxy(S.MainContext.MainThreadComments);class p{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const c=this._commentControllers.get(n.handle);return c?c.value:n}else if(n&&n.$mid===7){const c=this._commentControllers.get(n.commentControlHandle);if(!c)return n;const h=c.getCommentThread(n.commentThreadHandle);return h?h.value:n}else if(n&&n.$mid===8){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const h=c.getCommentThread(n.thread.commentThreadHandle);return h?{thread:h.value,text:n.text}:n}else if(n&&n.$mid===9){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const h=c.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;const m=n.commentUniqueId,C=h.getCommentByUniqueId(m);return C||n}else if(n&&n.$mid===10){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const h=c.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;const m=n.text,C=n.commentUniqueId,L=h.getCommentByUniqueId(C);return L?(typeof L.body=="string"?L.body=m:L.body.value=m,L):n}return n}})}createCommentController(n,c,h){const m=p.handlePool++,C=new a(n,m,c,h);this._commentControllers.set(C.handle,C);const L=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(n.identifier))||[];return L.push(C),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(n.identifier),L),C.value}$createCommentThreadTemplate(n,c,h){const m=this._commentControllers.get(n);!m||m.$createCommentThreadTemplate(c,h)}async $updateCommentThreadTemplate(n,c,h){const m=this._commentControllers.get(n);!m||m.$updateCommentThreadTemplate(c,h)}$deleteCommentThread(n,c){this._commentControllers.get(n)?.$deleteCommentThread(c)}$provideCommentingRanges(n,c,h){const m=this._commentControllers.get(n);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const C=v.getDocument(_.URI.revive(c));return(0,l.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(C,h)).then(L=>L?L.map(U=>I.Range.from(U)):void 0)}$toggleReaction(n,c,h,m,C){const L=this._commentControllers.get(n);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const U=L.getCommentThread(c);if(U){const B=U.getCommentByUniqueId(m.uniqueIdInThread);if(L!==void 0&&B&&L.reactionHandler)return L.reactionHandler(B,u(C))}return Promise.resolve(void 0)})}dispose(){}}p.handlePool=0;class f{constructor(n,c,h,m,C,L,U,B){this._commentControllerHandle=c,this._id=h,this._uri=m,this._range=C,this._comments=L,this.extensionDescription=U,this._isTemplate=B,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),d.$createCommentThread(c,this.handle,this._id,this._uri,I.Range.from(this._range),U.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(M){A.range=M},get comments(){return A.comments},set comments(M){A.comments=M},get collapsibleState(){return A.collapsibleState},set collapsibleState(M){A.collapsibleState=M},get canReply(){return A.canReply},set canReply(M){A.canReply=M},get contextValue(){return A.contextValue},set contextValue(M){A.contextValue=M},get label(){return A.label},set label(M){A.label=M},get state(){return A.state},set state(M){A.state=M},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(n){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=n,this.modifications.state=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const n=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),c={};n("range")&&(c.range=I.Range.from(this._range)),n("label")&&(c.label=this.label),n("contextValue")&&(c.contextValue=this.contextValue??null),n("comments")&&(c.comments=this._comments.map(h=>g(this,h,this._commentsMap))),n("collapsibleState")&&(c.collapseState=o(this._collapseState)),n("canReply")&&(c.canReply=this.canReply),n("state")&&(c.state=i(this._state)),n("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(n){for(const c of this._commentsMap){const h=c[0],m=c[1];if(n===m)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}f._handlePool=0,qe([(0,t.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(n,c,h,m){this._extension=n,this._handle=c,this._id=h,this._label=m,this._threads=new Map,d.$registerCommentController(this.handle,h,m);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(L){C.options=L},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(L){C.commentingRangeProvider=L},get reactionHandler(){return C.reactionHandler},set reactionHandler(L){C.reactionHandler=L},createCommentThread(L,U,B){return C.createCommentThread(L,U,B).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,c,h,m){if(typeof n=="string"){const C=new f(this.id,this.handle,n,c,h,m,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new f(this.id,this.handle,void 0,n,c,h,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(n,c){const h=new f(this.id,this.handle,void 0,_.URI.revive(n),I.Range.to(c),[],this._extension,!0);return h.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(n,c){const h=this._threads.get(n);h&&(h.range=I.Range.to(c))}$deleteCommentThread(n){this._threads.get(n)?.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function g(r,n,c){let h=c.get(n);h||(h=++r.commentHandle,c.set(n,h));const m=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:h,body:typeof n.body=="string"?n.body:I.MarkdownString.from(n.body),userName:n.author.name,userIconPath:m,label:n.label,commentReactions:n.reactions?n.reactions.map(C=>s(C)):void 0,timestamp:n.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function u(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?_.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function o(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return y.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return y.CommentThreadState.Resolved}return y.CommentThreadState.Unresolved}return new p}e.createExtHostComments=T}),define(De[239],Ie([1,0,24,5,26,15]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(R,k){this._mainThreadConsole=R.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,k){const S=this,T=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){S._handleConsoleCall(R,k,T,arguments)}})}_handleConsoleCall(R,k,S,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,S,T)}};_=qe([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const y=1e5;function E(I,R){const k=[];if(I.length)for(let S=0;S<I.length;S++){let T=I[S];if(typeof T>"u")T="undefined";else if(T instanceof Error){const w=T;w.stack?T=w.stack:T=w.toString()}k.push(T)}if(R){const S=new Error().stack;S&&k.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,l.safeStringify)(k);return S.length>y?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[135],Ie([1,0,2,5,7,3,15,14,17,8,9]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class Tn{constructor(T,w){this._logService=w,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,w){const b=Tn._handlePool++;this._provider.set(b,{provider:T,extensionId:w}),this._proxy.$registerDecorationProvider(b,w.value);const v=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(b,null);return}const p=(0,E.asArray)(d);if(p.length<=Tn._maxEventSize){this._proxy.$onDidChange(b,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,p.length);const f=p.map(s=>({uri:s,rank:(0,I.count)(s.path,"/")})),a=(0,E.groupBy)(f,(s,u)=>s.rank-u.rank||(0,I.compare)(s.uri.path,u.uri.path)),g=[];e:for(const s of a){let u;for(const o of s){const i=(0,R.dirname)(o.uri.path);if(u!==i&&(u=i,g.push(o.uri)>=Tn._maxEventSize))break e}}this._proxy.$onDidChange(b,g)});return new D.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(b),this._provider.delete(b)})}async $provideDecorations(T,w,b){if(!this._provider.has(T))return Object.create(null);const v=Object.create(null),{provider:d,extensionId:p}=this._provider.get(T);return await Promise.all(w.map(async f=>{try{const{uri:a,id:g}=f,s=await Promise.resolve(d.provideFileDecoration(l.URI.revive(a),b));if(!s)return;try{D.FileDecoration.validate(s),v[g]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${p.value}': ${u}`)}}catch(a){this._logService.error(a)}})),v}};k._handlePool=0,k._maxEventSize=250,k=qe([xe(0,_.IExtHostRpcService),xe(1,y.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[240],Ie([1,0,169,116,2,5,7,16,4,14,25,46]),function(J,e,l,t,D,P,_,y,E,I,R,k){"use strict";var S,T,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{constructor(p,f,a,g,s,u){this._name=p,this._owner=f,this._maxDiagnosticsPerFile=a,S.set(this,void 0),T.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,tt(this,w,new R.ResourceMap(o=>g.getComparisonKey(o)),"f"),tt(this,S,s,"f"),tt(this,T,u,"f")}dispose(){this._isDisposed||(Ue(this,T,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,S,"f")?.$clear(this._owner),Ue(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,f){if(!p){this.clear();return}this._checkDisposed();let a=[];if(D.URI.isUri(p)){if(!f){this.delete(p);return}Ue(this,w,"f").set(p,f.slice()),a=[p]}else if(Array.isArray(p)){a=[];let s;p=[...p].sort(b._compareIndexedTuplesByUri);for(const u of p){const[o,i]=u;if((!s||o.toString()!==s.toString())&&(s&&Ue(this,w,"f").get(s).length===0&&Ue(this,w,"f").delete(s),s=o,a.push(o),Ue(this,w,"f").set(o,[])),i)Ue(this,w,"f").get(o)?.push(...i);else{const r=Ue(this,w,"f").get(o);r&&(r.length=0)}}}if(Ue(this,T,"f").fire(a),!Ue(this,S,"f"))return;const g=[];for(const s of a){let u=[];const o=Ue(this,w,"f").get(s);if(o)if(o.length>this._maxDiagnosticsPerFile){u=[];const i=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const n of o)if(n.severity===i[r]&&u.push(y.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=o.map(i=>y.Diagnostic.from(i));g.push([s,u])}Ue(this,S,"f").$changeMany(this._owner,g)}delete(p){this._checkDisposed(),Ue(this,T,"f").fire([p]),Ue(this,w,"f").delete(p),Ue(this,S,"f")?.$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Ue(this,T,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,w,"f").clear(),Ue(this,S,"f")?.$clear(this._owner)}forEach(p,f){this._checkDisposed();for(const[a,g]of this)p.call(f,a,g,this)}*[(S=new WeakMap,T=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const p of Ue(this,w,"f").keys())yield[p,this.get(p)]}get(p){this._checkDisposed();const f=Ue(this,w,"f").get(p);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Ue(this,w,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,f){return p[0].toString()<f[0].toString()?-1:p[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=b;let v=class fn{constructor(p,f,a){this._logService=f,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,fn._mapper),this._proxy=p.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(p){const f=new R.ResourceMap;for(const a of p)f.set(a,a);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(p,f){const{_collections:a,_proxy:g,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:o}=this,i=new class{$changeMany(c,h){g.$changeMany(c,h),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,c,h.length===0?"CLEARING":h)}$clear(c){g.$clear(c),u.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,c)}dispose(){g.dispose()}};let r;if(!f)f="_generated_diagnostic_collection_name_#"+fn._idPool++,r=f;else if(!a.has(f))r=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do r=f+fn._idPool++;while(a.has(r))}return new class extends b{constructor(){super(f,r,fn._maxDiagnosticsPerFile,o.extUri,i,s),a.set(r,this)}dispose(){super.dispose(),a.delete(r)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const f=new Map,a=[];for(const g of this._collections.values())g.forEach((s,u)=>{let o=f.get(s.toString());typeof o>"u"&&(o=a.length,f.set(s.toString(),o),a.push([s,[]])),a[o][1]=a[o][1].concat(...u)});return a}}_getDiagnostics(p){let f=[];for(const a of this._collections.values())a.has(p)&&(f=f.concat(a.get(p)));return f}$acceptMarkersChange(p){if(!this._mirrorCollection){const f="_generated_mirror",a=new b(f,f,fn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,a),this._mirrorCollection=a}for(const[f,a]of p)this._mirrorCollection.set(D.URI.revive(f),a.map(y.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=qe([xe(1,I.ILogService),xe(2,k.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(De[241],Ie([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(_){this._proxy=_.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(y=>y?y.map(E=>l.URI.revive(E)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(y=>y?l.URI.revive(y):void 0)}}e.ExtHostDialogs=D}),define(De[242],Ie([1,0,10,2,7,5,12,21,8]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,S,T){this._documentsAndEditors=S,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,S){if(Object.keys(_.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=I._handlePool++;this._documentContentProviders.set(T,S),this._proxy.$registerTextContentProvider(T,k);let w;return typeof S.onDidChange=="function"&&(w=S.onDidChange(b=>{if(b.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(b)&&this.$provideTextDocumentContent(T,b).then(v=>{if(!v&&typeof v!="string")return;const d=this._documentsAndEditors.getDocument(b);if(!d)return;const p=(0,E.splitLines)(v);if(!d.equalLines(p))return this._proxy.$onVirtualDocumentChange(b,v)},l.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,S){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(S),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(De[243],Ie([1,0,4,6,2,5,125,16,13,24,7]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,w){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(b=>{for(const v of b)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(b=>{for(const v of b)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const w=this._documentsAndEditors.getDocument(T);if(w)return w}getDocument(T){const w=this.getDocumentData(T);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return w.document}ensureDocumentData(T){const w=this._documentsAndEditors.getDocument(T);if(w)return Promise.resolve(w);let b=this._documentLoader.get(T.toString());return b||(b=this._proxy.$tryOpenDocument(T).then(v=>{this._documentLoader.delete(T.toString());const d=D.URI.revive(v);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(d))},v=>(this._documentLoader.delete(T.toString()),Promise.reject(v))),this._documentLoader.set(T.toString(),b)),b}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(w=>D.URI.revive(w))}$acceptModelLanguageChanged(T,w){const b=D.URI.revive(T),v=this._documentsAndEditors.getDocument(b);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(w),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(T){const w=D.URI.revive(T),b=this._documentsAndEditors.getDocument(w);if(!b)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(b.document)}$acceptDirtyStateChanged(T,w){const b=D.URI.revive(T),v=this._documentsAndEditors.getDocument(b);if(!v)throw new Error("unknown document");v._acceptIsDirty(w),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,w,b){const v=D.URI.revive(T),d=this._documentsAndEditors.getDocument(v);if(!d)throw new Error("unknown document");d._acceptIsDirty(b),d.onEvents(w);let p;w.isUndoing?p=R.TextDocumentChangeReason.Undo:w.isRedoing&&(p=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:d.document,contentChanges:w.changes.map(f=>({range:y.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:p}))}setWordDefinitionFor(T,w){(0,_.setWordDefinitionFor)(T,w)}}e.ExtHostDocuments=k}),define(De[56],Ie([1,0,48,4,6,2,3,5,125,15,133,16,14,25,12,60,78]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let p=class{constructor(a,g){this._extHostRpc=a,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const g=[],s=[],u=[];if(a.removedDocuments)for(const o of a.removedDocuments){const i=P.URI.revive(o),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),g.push(r.value))}if(a.addedDocuments)for(const o of a.addedDocuments){const i=P.URI.revive(o.uri);let r=this._documents.get(i);if(r&&i.scheme!==w.Schemas.vscodeNotebookCell&&i.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new d(new E.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,r),s.push(r.value)),r.ref()}if(a.removedEditors)for(const o of a.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&u.push(i)}if(a.addedEditors)for(const o of a.addedEditors){const i=P.URI.revive(o.documentUri);l.ok(this._documents.has(i),`document '${i}' does not exist`),l.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const r=this._documents.get(i).value,n=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(c=>k.Range.to(c)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,n)}a.newActiveEditor!==void 0&&(l.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,D.dispose)(g),(0,D.dispose)(u),a.removedDocuments&&this._onDidRemoveDocuments.fire(g),a.addedDocuments&&this._onDidAddDocuments.fire(s),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return b.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return a?g:g?.value}allEditors(){return[...this._editors.values()]}};p=qe([xe(0,I.IExtHostRpcService),xe(1,S.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[57],Ie([1,0,16,5,2,4,3,7,15,13,77]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class k{constructor(v,d,p){this._activeTabIdGetter=p,this._parentGroup=d,this.acceptDtoUpdate(v)}get apiObject(){if(!this._apiObject){const v=this,d={get isActive(){return v._dto.id===v._activeTabIdGetter()},get label(){return v._dto.label},get input(){return v._input},get isDirty(){return v._dto.isDirty},get isPinned(){return v._dto.isPinned},get isPreview(){return v._dto.isPreview},get group(){return v._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(v){this._dto=v,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new y.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new y.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new y.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new y.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new y.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new y.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new y.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new y.TerminalEditorTabInput;case 9:return new y.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class S{constructor(v,d){this._tabs=[],this._activeTabId="",this._dto=v,this._activeGroupIdGetter=d;for(const p of v.tabs)p.isActive&&(this._activeTabId=p.id),this._tabs.push(new k(p,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const v=this,d={get isActive(){return v._dto.groupId===v._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(v._dto.viewColumn)},get activeTab(){return v._tabs.find(p=>p.tabId===v._activeTabId)?.apiObject},get tabs(){return Object.freeze(v._tabs.map(p=>p.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(v){this._dto=v}acceptTabOperation(v){if(v.kind===0){const p=new k(v.tabDto,this,()=>this.activeTabId());return this._tabs.splice(v.index,0,p),v.tabDto.isActive&&(this._activeTabId=p.tabId),p}else if(v.kind===1){const p=this._tabs.splice(v.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${v.index} which does not exist`);return p.tabId===this._activeTabId&&(this._activeTabId=""),p}else if(v.kind===3){if(v.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this._tabs.splice(v.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${v.oldIndex} which does not exist`);return this._tabs.splice(v.index,0,p),p}const d=this._tabs.find(p=>p.tabId===v.tabDto.id);if(!d)throw new Error("INVALID tab");return v.tabDto.isActive?this._activeTabId=v.tabDto.id:this._activeTabId===v.tabDto.id&&!v.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(v.tabDto),d}activeTabId(){return this._activeTabId}}let T=class{constructor(v){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=v.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const v=this,d={onDidChangeTabGroups:v._onDidChangeTabGroups.event,onDidChangeTabs:v._onDidChangeTabs.event,get all(){return Object.freeze(v._extHostTabGroups.map(p=>p.apiObject))},get activeTabGroup(){const p=v._activeGroupId;return(0,I.assertIsDefined)(v._extHostTabGroups.find(a=>a.groupId===p)?.apiObject)},close:async(p,f)=>{const a=Array.isArray(p)?p:[p];return a.length?w(a[0])?this._closeGroups(a,f):this._closeTabs(a,f):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(v){const d=new Set(this._extHostTabGroups.map(o=>o.groupId)),p=new Set(v.map(o=>o.groupId)),f=(0,R.diffSets)(d,p),a=this._extHostTabGroups.filter(o=>f.removed.includes(o.groupId)).map(o=>o.apiObject),g=[],s=[];this._extHostTabGroups=v.map(o=>{const i=new S(o,()=>this._activeGroupId);return f.added.includes(i.groupId)?g.push(i.apiObject):s.push(i.apiObject),i});const u=(0,I.assertIsDefined)(v.find(o=>o.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:g,closed:a,changed:s}))}$acceptTabGroupUpdate(v){const d=this._extHostTabGroups.find(p=>p.groupId===v.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(v),v.isActive&&(this._activeGroupId=v.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(v){const d=this._extHostTabGroups.find(f=>f.groupId===v.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const p=d.acceptTabOperation(v);switch(v.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}_findExtHostTabFromApi(v){for(const d of this._extHostTabGroups)for(const p of d.tabs)if(p.apiObject===v)return p}_findExtHostTabGroupFromApi(v){return this._extHostTabGroups.find(d=>d.apiObject===v)}async _closeTabs(v,d){const p=[];for(const f of v){const a=this._findExtHostTabFromApi(f);if(!a)throw new Error("Tab close: Invalid tab not found!");p.push(a.tabId)}return this._proxy.$closeTab(p,d)}async _closeGroups(v,d){const p=[];for(const f of v){const a=this._findExtHostTabGroupFromApi(f);if(!a)throw new Error("Group close: Invalid group not found!");p.push(a.groupId)}return this._proxy.$closeGroup(p,d)}};T=qe([xe(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function w(b){return b.tabs!==void 0}}),define(De[244],Ie([1,0,2,5,6,7,16,149,8,23,28]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const b=this._schemes.indexOf(w);b>=0&&(this._schemes.splice(b,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),b=[];let v,d,p=14,f=14;for(const a of w){let g=v?(0,E.commonPrefixLength)(v,a):0;for(g===0?d=1:d=f;g<a.length;g++)g+1===a.length?(p=f,f=9):f+=1,b.push([d,a.toUpperCase().charCodeAt(g),f]),b.push([d,a.toLowerCase().charCodeAt(g),f]),d=f;v=a,f=p}b.push([9,58,10]),b.push([10,47,12]),this._stateMachine=new y.StateMachine(b)}}provideDocumentLinks(w){this._initStateMachine();const b=[],v=y.LinkComputer.computeLinks({getLineContent(d){return w.lineAt(d-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const d of v){const p=_.DocumentLink.to(d);p.target&&b.push(p)}return b}}class S{constructor(w,b){this._extHostLanguageFeatures=b,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,b,v,d={}){if(this._registeredSchemes.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(b),this._registeredSchemes.add(b),this._fsProvider.set(p,v);let f=2;d.isCaseSensitive&&(f+=1024),d.isReadonly&&(f+=2048),typeof v.copy=="function"&&(f+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,R.checkProposedApiEnabled)(w,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(p,b,f).catch(g=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${b}`),console.error(g)});const a=v.onDidChangeFile(g=>{const s=[];for(const u of g){const{uri:o,type:i}=u;if(o.scheme!==b)continue;let r;switch(i){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:o,type:r})}this._proxy.$onFileSystemChange(p,s)});return(0,D.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(b),this._registeredSchemes.delete(b),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(w){const{type:b,ctime:v,mtime:d,size:p,permissions:f}=w;return{type:b,ctime:v,mtime:d,size:p,permissions:f}}$stat(w,b){return Promise.resolve(this._getFsProvider(w).stat(l.URI.revive(b))).then(v=>S._asIStat(v))}$readdir(w,b){return Promise.resolve(this._getFsProvider(w).readDirectory(l.URI.revive(b)))}$readFile(w,b){return Promise.resolve(this._getFsProvider(w).readFile(l.URI.revive(b))).then(v=>I.VSBuffer.wrap(v))}$writeFile(w,b,v,d){return Promise.resolve(this._getFsProvider(w).writeFile(l.URI.revive(b),v.buffer,d))}$delete(w,b,v){return Promise.resolve(this._getFsProvider(w).delete(l.URI.revive(b),v))}$rename(w,b,v,d){return Promise.resolve(this._getFsProvider(w).rename(l.URI.revive(b),l.URI.revive(v),d))}$copy(w,b,v,d){const p=this._getFsProvider(w);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(l.URI.revive(b),l.URI.revive(v),d))}$mkdir(w,b){return Promise.resolve(this._getFsProvider(w).createDirectory(l.URI.revive(b)))}$watch(w,b,v,d){const p=this._getFsProvider(w).watch(l.URI.revive(v),d);this._watches.set(b,p)}$unwatch(w,b){const v=this._watches.get(b);v&&(v.dispose(),this._watches.delete(b))}$open(w,b,v){const d=this._getFsProvider(w);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(l.URI.revive(b),v))}$close(w,b){const v=this._getFsProvider(w);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(b))}$read(w,b,v,d){const p=this._getFsProvider(w);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const f=I.VSBuffer.alloc(d);return Promise.resolve(p.read(b,v,f.buffer,0,d)).then(a=>f.slice(0,a))}$write(w,b,v,d){const p=this._getFsProvider(w);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(b,v,d.buffer,0,d.byteLength))}_getFsProvider(w){const b=this._fsProvider.get(w);if(!b){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return b}}e.ExtHostFileSystem=S}),define(De[68],Ie([1,0,5,42,7,23,3,15,46,6]),function(J,e,l,t,D,P,_,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Xt{constructor(S,T){this._fileSystemProvider=new Map,this._proxy=S.getProxy(l.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(b){try{const v=w._fileSystemProvider.get(b.scheme);if(!v)return await w._proxy.$stat(b);await w._proxy.$ensureActivation(b.scheme);const d=await v.stat(b);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(v){Xt._handleError(v)}},async readDirectory(b){try{const v=w._fileSystemProvider.get(b.scheme);return v?(await w._proxy.$ensureActivation(b.scheme),(await v.readDirectory(b)).slice()):await w._proxy.$readdir(b)}catch(v){return Xt._handleError(v)}},async createDirectory(b){try{return await w._proxy.$mkdir(b)}catch(v){return Xt._handleError(v)}},async readFile(b){try{const v=w._fileSystemProvider.get(b.scheme);return v?(await w._proxy.$ensureActivation(b.scheme),(await v.readFile(b)).slice()):(await w._proxy.$readFile(b)).buffer}catch(v){return Xt._handleError(v)}},async writeFile(b,v){try{return await w._proxy.$writeFile(b,P.VSBuffer.wrap(v))}catch(d){return Xt._handleError(d)}},async delete(b,v){try{const d=w._fileSystemProvider.get(b.scheme);return d?(await w._proxy.$ensureActivation(b.scheme),await d.delete(b,{recursive:!1,...v})):await w._proxy.$delete(b,{recursive:!1,useTrash:!1,...v})}catch(d){return Xt._handleError(d)}},async rename(b,v,d){try{return await w._proxy.$rename(b,v,{overwrite:!1,...d})}catch(p){return Xt._handleError(p)}},async copy(b,v,d){try{return await w._proxy.$copy(b,v,{overwrite:!1,...d})}catch(p){return Xt._handleError(p)}},isWritableFileSystem(b){const v=T.getCapabilities(b);if(typeof v=="number")return!(v&2048)}})}static _handleError(S){if(S instanceof D.FileSystemError)throw S;if(!(S instanceof Error))throw new D.FileSystemError(String(S));if(S.name==="ENOPRO")throw D.FileSystemError.Unavailable(S.message);switch(S.name){case t.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(S.message);case t.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(S.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(S.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(S.message);case t.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(S.message);case t.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(S.message);default:throw new D.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,T){return this._fileSystemProvider.set(S,T),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(S))}};R=qe([xe(0,y.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(De[245],Ie([1,0,4,36,2,5,16,7,28]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(S,T,w,b,v,d,p,f){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const a=this.ensureWatching(S,w,v);this._config=0,d&&(this._config+=1),p&&(this._config+=2),f&&(this._config+=4);const g=(0,t.parse)(v),s=typeof v=="string",u=b(o=>{if(!d)for(const i of o.created){const r=D.URI.revive(i);g(r.fsPath)&&(!s||T.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!p)for(const i of o.changed){const r=D.URI.revive(i);g(r.fsPath)&&(!s||T.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!f)for(const i of o.deleted){const r=D.URI.revive(i);g(r.fsPath)&&(!s||T.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=y.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(S,T,w){const b=y.Disposable.from();if(typeof w=="string")return b;const v=S.getProxy(P.MainContext.MainThreadFileSystem);let d=!1;(w.pattern.includes(t.GLOBSTAR)||w.pattern.includes(t.GLOB_SPLIT))&&(d=!0);const p=Math.random();return v.$watch(T.identifier.value,p,w.baseUri,{recursive:d,excludes:[]}),y.Disposable.from({dispose:()=>v.$unwatch(p)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(S,T,w){this._mainContext=S,this._logService=T,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,T,w,b,v,d){return new I(this._mainContext,S,T,this._onFileSystemEvent.event,_.GlobPattern.from(w),b,v,d)}$onFileEvent(S){this._onFileSystemEvent.fire(S)}$onDidRunFileOperation(S,T){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(w=>({oldUri:D.URI.revive(w.source),newUri:D.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(w=>D.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(w=>D.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,T){return(w,b,v)=>{const d=function(f){w.call(b,f)};return d.extension=S,T.event(d,void 0,v)}}async $onWillRunFileOperation(S,T,w,b){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(v=>({oldUri:D.URI.revive(v.source),newUri:D.URI.revive(v.target)}))},w,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(v=>D.URI.revive(v.target))},w,b);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(v=>D.URI.revive(v.target))},w,b)}}async _fireWillEvent(S,T,w,b){const v=new Set,d=[];if(await S.fireAsync(T,b,async(f,a)=>{const g=Date.now(),s=await Promise.resolve(f);s instanceof y.WorkspaceEdit&&(d.push([a.extension,s]),v.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-g>w&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),b.isCancellationRequested||d.length===0)return;const p={edits:[]};for(const[f,a]of d){const{edits:g}=_.WorkspaceEdit.from(a,{getTextDocumentVersion:s=>this._extHostDocumentsAndEditors.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(f,"snippetWorkspaceEdit"));p.edits=p.edits.concat(g)}return{edit:p,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=R}),define(De[246],Ie([1,0,2,37]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(_,y,E,I,R){this._extHostNotebooks=y,this._textDocumentsAndEditors=E,this._commands=I;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new t.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new t.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new t.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new t.ApiCommandResult("Notebook and input URI",S=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(S.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri),notebookEditor:T.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(_,y,E,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],languageId:E,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=D}),define(De[247],Ie([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(_){this._handlePool=0,this._proxy=_.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,_),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=D}),define(De[248],Ie([1,0,2,24,16,7,64,5,8,35,17,13,145,21,6,113,93,87,51,10,18,28]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentSymbols(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideDocumentSymbols(G,H);if(!(0,R.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(D.DocumentSymbol.from):s._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((X,me)=>{let we=X.location.range.start.compareTo(me.location.range.start);return we===0&&(we=me.location.range.end.compareTo(X.location.range.end)),we});const H=[],G=[];for(const X of F){const me={name:X.name||"!!MISSING: name!!",kind:D.SymbolKind.from(X.kind),tags:X.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:D.Range.from(X.location.range),selectionRange:D.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(me),H.push(me);break}const we=G[G.length-1];if(I.Range.containsRange(we.range,me.range)&&!I.Range.equalsRange(we.range,me.range)){we.children?.push(me),G.push(me);break}G.pop()}}return H}}class u{constructor(F,H,G){this._documents=F,this._commands=H,this._provider=G,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideCodeLenses(G,H);if(!X||H.isCancellationRequested)return;const me=this._cache.add(X),we=new w.DisposableStore;this._disposables.set(me,we);const le={cacheId:me,lenses:[]};for(let Ce=0;Ce<X.length;Ce++)le.lenses.push({cacheId:[me,Ce],range:D.Range.from(X[Ce].range),command:this._commands.toInternal(X[Ce].command,we)});return le}async resolveCodeLens(F,H){const G=F.cacheId&&this._cache.get(...F.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,H),X||(X=G),H.isCancellationRequested)return;const me=F.cacheId&&this._disposables.get(F.cacheId[0]);if(!!me)return F.command=this._commands.toInternal(X.command??u._badCmd,me),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(ie){return Array.isArray(ie)?ie.map(D.DefinitionLink.from):ie?[D.DefinitionLink.from(ie)]:[]}class i{constructor(F,H){this._documents=F,this._provider=H}async provideDefinition(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideDefinition(X,me,G);return o(we)}}class r{constructor(F,H){this._documents=F,this._provider=H}async provideDeclaration(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideDeclaration(X,me,G);return o(we)}}class n{constructor(F,H){this._documents=F,this._provider=H}async provideImplementation(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideImplementation(X,me,G);return o(we)}}class c{constructor(F,H){this._documents=F,this._provider=H}async provideTypeDefinition(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideTypeDefinition(X,me,G);return o(we)}}class h{constructor(F,H){this._documents=F,this._provider=H}async provideHover(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideHover(X,me,G);if(!(!we||(0,R.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(me)),we.range||(we.range=new P.Range(me,me)),D.Hover.from(we)}}class m{constructor(F,H){this._documents=F,this._provider=H}async provideEvaluatableExpression(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideEvaluatableExpression(X,me,G);if(we)return D.EvaluatableExpression.from(we)}}class C{constructor(F,H){this._documents=F,this._provider=H}async provideInlineValues(F,H,G,X){const me=this._documents.getDocument(F),we=await this._provider.provideInlineValues(me,D.Range.to(H),D.InlineValueContext.to(G),X);if(Array.isArray(we))return we.map(le=>D.InlineValue.from(le))}}class L{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentHighlights(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideDocumentHighlights(X,me,G);if(Array.isArray(we))return we.map(D.DocumentHighlight.from)}}class U{constructor(F,H){this._documents=F,this._provider=H}async provideLinkedEditingRanges(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.provideLinkedEditingRanges(X,me,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,R.coalesce)(we.ranges.map(D.Range.from)),wordPattern:we.wordPattern}}}class B{constructor(F,H){this._documents=F,this._provider=H}async provideReferences(F,H,G,X){const me=this._documents.getDocument(F),we=D.Position.to(H),le=await this._provider.provideReferences(me,we,G,X);if(Array.isArray(le))return le.map(D.location.from)}}class A{constructor(F,H,G,X,me,we,le){this._documents=F,this._commands=H,this._diagnostics=G,this._provider=X,this._logService=me,this._extension=we,this._apiDeprecation=le,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,H,G,X){const me=this._documents.getDocument(F),we=S.Selection.isISelection(H)?D.Selection.to(H):D.Range.to(H),le=[];for(const Ye of this._diagnostics.getDiagnostics(F))if(we.intersection(Ye.range)&&le.push(Ye)>A._maxCodeActionsPerFile)break;const Ce={diagnostics:le,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:D.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(me,we,Ce,X);if(!(0,R.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const $e=this._cache.add(ye),je=new w.DisposableStore;this._disposables.set($e,je);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Oe=ye[Ye];!Oe||(A._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,je)})):(Ce.only&&(Oe.kind?Ce.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,Ye],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,je),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(D.Diagnostic.from),edit:Oe.edit&&D.WorkspaceEdit.from(Oe.edit,void 0,(0,g.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(F,H){const[G,X]=F,me=this._cache.get(G,X);if(!me||A._isCommand(me)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(me,H)??me;return we?.edit?D.WorkspaceEdit.from(we.edit,void 0,(0,g.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}A._maxCodeActionsPerFile=1e3;class M{constructor(F,H,G,X){this._proxy=F,this._documents=H,this._provider=G,this._handle=X}async prepareDocumentPaste(F,H,G,X){if(!this._provider.prepareDocumentPaste)return;const me=this._documents.getDocument(F),we=H.map(Ce=>D.Range.to(Ce)),le=D.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(me,we,le,X),D.DataTransfer.toDataTransferDTO(le)}async providePasteEdits(F,H,G,X,me){const we=this._documents.getDocument(H),le=G.map($e=>D.Range.to($e)),Ce=D.DataTransfer.toDataTransfer(X,async $e=>(await this._proxy.$resolvePasteFileData(this._handle,F,$e)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,le,Ce,me);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class ${constructor(F,H){this._documents=F,this._provider=H}async provideDocumentFormattingEdits(F,H,G){const X=this._documents.getDocument(F),me=await this._provider.provideDocumentFormattingEdits(X,H,G);if(Array.isArray(me))return me.map(D.TextEdit.from)}}class N{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentRangeFormattingEdits(F,H,G,X){const me=this._documents.getDocument(F),we=D.Range.to(H),le=await this._provider.provideDocumentRangeFormattingEdits(me,we,G,X);if(Array.isArray(le))return le.map(D.TextEdit.from)}}class K{constructor(F,H){this._documents=F,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,G,X,me){const we=this._documents.getDocument(F),le=D.Position.to(H),Ce=await this._provider.provideOnTypeFormattingEdits(we,le,G,X,me);if(Array.isArray(Ce))return Ce.map(D.TextEdit.from)}}class z{constructor(F,H){this._provider=F,this._logService=H,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const G=await this._provider.provideWorkspaceSymbols(F,H);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),me={cacheId:X,symbols:[]};for(let we=0;we<G.length;we++){const le=G[we];if(!le||!le.name){this._logService.warn("INVALID SymbolInformation",le);continue}me.symbols.push({...D.WorkspaceSymbol.from(le),cacheId:[X,we]})}return me}async resolveWorkspaceSymbol(F,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this._cache.get(...F.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,H);return X&&(0,t.mixin)(F,D.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class O{constructor(F,H,G){this._documents=F,this._provider=H,this._logService=G}static supportsResolving(F){return typeof F.prepareRename=="function"}async provideRenameEdits(F,H,G,X){const me=this._documents.getDocument(F),we=D.Position.to(H);try{const le=await this._provider.provideRenameEdits(me,we,G,X);return le?D.WorkspaceEdit.from(le):void 0}catch(le){const Ce=O._asMessage(le);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(le)}}async resolveRenameLocation(F,H,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(F),me=D.Position.to(H);try{const we=await this._provider.prepareRename(X,me,G);let le,Ce;if(P.Range.isRange(we)?(le=we,Ce=X.getText(we)):(0,k.isObject)(we)&&(le=we.range,Ce=we.placeholder),!le||!Ce)return;if(le.start.line>me.line||le.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(le),text:Ce}}catch(we){const le=O._asMessage(we);return le?{rejectReason:le,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class x{constructor(F,H){this.resultId=F,this.tokens=H}}class V{constructor(F,H){this._documents=F,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,H,G){const X=this._documents.getDocument(F),me=H!==0?this._previousResults.get(H):null;let we=typeof me?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,me.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return me&&this._previousResults.delete(H),we?(we=V._fixProvidedSemanticTokens(we),this._send(V._convertToEdits(me,we),we)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return V._isSemanticTokens(F)?V._isCorrectSemanticTokens(F)?F:new P.SemanticTokens(new Uint32Array(F.data),F.resultId):V._isSemanticTokensEdits(F)?V._isCorrectSemanticTokensEdits(F)?F:new P.SemanticTokensEdits(F.edits.map(H=>new P.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,H){if(!V._isSemanticTokens(H)||!F||!F.tokens)return H;const G=F.tokens,X=G.length,me=H.data,we=me.length;let le=0;const Ce=Math.min(X,we);for(;le<Ce&&G[le]===me[le];)le++;if(le===X&&le===we)return new P.SemanticTokensEdits([],H.resultId);let ye=0;const $e=Ce-le;for(;ye<$e&&G[X-ye-1]===me[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:le,deleteCount:X-le-ye,data:me.subarray(le,we-ye)}],H.resultId)}_send(F,H){if(V._isSemanticTokens(F)){const G=this._nextResultId++;return this._previousResults.set(G,new x(F.resultId,F.data)),(0,b.encodeSemanticTokensDto)({id:G,type:"full",data:F.data})}if(V._isSemanticTokensEdits(F)){const G=this._nextResultId++;return V._isSemanticTokens(H)?this._previousResults.set(G,new x(H.resultId,H.data)):this._previousResults.set(G,new x(F.resultId)),(0,b.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(F.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class q{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentRangeSemanticTokens(F,H,G){const X=this._documents.getDocument(F),me=await this._provider.provideDocumentRangeSemanticTokens(X,D.Range.to(H),G);return me?this._send(me):null}_send(F){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}e.DocumentRangeSemanticTokensAdapter=q;class Y{constructor(F,H,G,X,me){this._documents=F,this._commands=H,this._provider=G,this._apiDeprecation=X,this._extension=me,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}async provideCompletionItems(F,H,G,X){const me=this._documents.getDocument(F),we=D.Position.to(H),le=me.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=le.with({end:we}),ye=new p.StopWatch(!0),$e=await this._provider.provideCompletionItems(me,we,X,D.CompletionContext.to(G));if(!$e||X.isCancellationRequested)return;const je=Array.isArray($e)?new P.CompletionList($e):$e,Ze=Y.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Ye=new w.DisposableStore;this._disposables.set(Ze,Ye);const Oe=[],ot={x:Ze,b:Oe,a:{replace:D.Range.from(le),insert:D.Range.from(Ce)},c:je.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<je.items.length;re++){const se=je.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ce,le);Oe.push(Ee)}return ot}async resolveCompletionItem(F,H){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...F);if(!G)return;const X=await this._provider.resolveCompletionItem(G,H);if(!!X)return this._convertCompletionItem(X,F)}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,H,G,X){const me=this._disposables.get(H[0]);if(!me)throw Error("DisposableStore is missing...");const we={x:H,a:F.label,b:F.kind!==void 0?D.CompletionItemKind.from(F.kind):void 0,n:F.tags&&F.tags.map(D.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:D.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters,l:F.additionalTextEdits&&F.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(F.command,me)};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=F.textEdit.newText):typeof F.insertText=="string"?we.h=F.insertText:F.insertText instanceof P.SnippetString&&(we.h=F.insertText.value,we.i|=4);let le;return F.textEdit?le=F.textEdit.range:F.range&&(le=F.range),P.Range.isRange(le)?we.j=D.Range.from(le):le&&(!G?.isEqual(le.inserting)||!X?.isEqual(le.replacing))&&(we.j={insert:D.Range.from(le.inserting),replace:D.Range.from(le.replacing)}),we}}class Q{async provideInlineCompletions(F,H,G,X){}disposeCompletions(F){}handleDidShowCompletionItem(F,H){}}class he extends Q{constructor(F,H,G,X){super(),this._extension=F,this._documents=H,this._provider=G,this._commands=X,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(F,H,G,X){const me=this._documents.getDocument(F),we=D.Position.to(H),le=await this._provider.provideInlineCompletionItems(me,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!le||X.isCancellationRequested)return;const Ce=Array.isArray(le)?le:le.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(le)?[]:le.commands||[]:[];let $e;return{pid:this._references.createReferenceId({dispose(){$e?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Oe;Ze.command&&($e||($e=new w.DisposableStore),Oe=this._commands.toInternal(Ze.command,$e));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?D.Range.from(Ze.range):void 0,command:Oe,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>($e||($e=new w.DisposableStore),this._commands.toInternal(Ze,$e)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const G=this._references.get(F)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ve extends Q{constructor(F,H,G,X){super(),this.extension=F,this._documents=H,this._provider=G,this._commands=X,this._references=new ne,this.isAdditionProposedApiEnabled=(0,g.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(F,H,G,X){const me=this._documents.getDocument(F),we=D.Position.to(H),le=await this._provider.provideInlineCompletionItems(me,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!le||X.isCancellationRequested)return;const Ce=Array.isArray(le)?le:le.items,ye=Array.isArray(le)?[]:le.commands||[];let $e;return{pid:this._references.createReferenceId({dispose(){$e?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Oe;Ze.command&&($e||($e=new w.DisposableStore),Oe=this._commands.toInternal(Ze.command,$e));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?D.Range.from(Ze.range):void 0,command:Oe,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>($e||($e=new w.DisposableStore),this._commands.toInternal(Ze,$e)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const G=this._references.get(F)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const H=this._idPool++;return this._references.set(H,F),H}disposeReferenceId(F){const H=this._references.get(F);return this._references.delete(F),H}get(F){return this._references.get(F)}}class pe{constructor(F,H){this._documents=F,this._provider=H,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(F,H,G,X){const me=this._documents.getDocument(F),we=D.Position.to(H),le=this.reviveContext(G),Ce=await this._provider.provideSignatureHelp(me,we,X,le);if(Ce){const ye=this._cache.add([Ce]);return{...D.SignatureHelp.from(Ce),id:ye}}}reviveContext(F){let H;if(F.activeSignatureHelp){const G=D.SignatureHelp.to(F.activeSignatureHelp),X=this._cache.get(F.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=G.activeSignature,H.activeParameter=G.activeParameter):H=G}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this._cache.delete(F)}}class be{constructor(F,H,G,X,me){this._documents=F,this._commands=H,this._provider=G,this._logService=X,this._extension=me,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,H,G){const X=this._documents.getDocument(F),me=D.Range.to(H),we=await this._provider.provideInlayHints(X,me,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${H}`);return}if(G.isCancellationRequested)return;const le=this._cache.add(we);this._disposables.set(le,new w.DisposableStore);const Ce={hints:[],cacheId:le};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],me)&&Ce.hints.push(this._convertInlayHint(we[ye],[le,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${H}`),Ce}async resolveInlayHint(F,H){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...F);if(!G)return;const X=await this._provider.resolveInlayHint(G,H);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}_convertInlayHint(F,H){const G=this._disposables.get(H[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:D.MarkdownString.fromStrict(F.tooltip),position:D.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(D.TextEdit.from),kind:F.kind&&D.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?X.label=F.label:X.label=F.label.map(me=>{const we={label:me.value};return we.tooltip=D.MarkdownString.fromStrict(me.tooltip),P.Location.isLocation(me.location)&&(we.location=D.location.from(me.location)),me.command&&(we.command=this._commands.toInternal(me.command,G)),we}),X}}class ke{constructor(F,H){this._documents=F,this._provider=H,this._cache=new d.Cache("DocumentLink")}async provideLinks(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideDocumentLinks(G,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(D.DocumentLink.from)};{const me=this._cache.add(X),we={links:[],cacheId:me};for(let le=0;le<X.length;le++){if(!ke._validateLink(X[le]))continue;const Ce=D.DocumentLink.from(X[le]);Ce.cacheId=[me,le],we.links.push(Ce)}return we}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...F);if(!G)return;const X=await this._provider.resolveDocumentLink(G,H);if(!(!X||!ke._validateLink(X)))return D.DocumentLink.from(X)}releaseLinks(F){this._cache.delete(F)}}class Le{constructor(F,H){this._documents=F,this._provider=H}async provideColors(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideDocumentColors(G,H);return Array.isArray(X)?X.map(we=>({color:D.Color.from(we.color),range:D.Range.from(we.range)})):[]}async provideColorPresentations(F,H,G){const X=this._documents.getDocument(F),me=D.Range.to(H.range),we=D.Color.to(H.color),le=await this._provider.provideColorPresentations(we,{document:X,range:me},G);if(!!Array.isArray(le))return le.map(D.ColorPresentation.from)}}class We{constructor(F,H){this._documents=F,this._provider=H}async provideFoldingRanges(F,H,G){const X=this._documents.getDocument(F),me=await this._provider.provideFoldingRanges(X,H,G);if(!!Array.isArray(me))return me.map(D.FoldingRange.from)}}class oe{constructor(F,H,G){this._documents=F,this._provider=H,this._logService=G}async provideSelectionRanges(F,H,G){const X=this._documents.getDocument(F),me=H.map(D.Position.to),we=await this._provider.provideSelectionRanges(X,me,G);if(!(0,R.isNonEmptyArray)(we))return[];if(we.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const le=[];for(let Ce=0;Ce<me.length;Ce++){const ye=[];le.push(ye);let $e=me[Ce],je=we[Ce];for(;;){if(!je.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(D.SelectionRange.from(je)),!je.parent)break;$e=je.range,je=je.parent}}return le}}class ue{constructor(F,H){this._documents=F,this._provider=H,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.prepareCallHierarchy(X,me,G);if(!we)return;const le=this._idPool.nextId();return this._cache.set(le,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(le,Ce)):[this._cacheAndConvertItem(le,we)]}async provideCallsTo(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!me)return me.map(we=>({from:this._cacheAndConvertItem(F,we.from),fromRanges:we.fromRanges.map(le=>D.Range.from(le))}))}async provideCallsFrom(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!me)return me.map(we=>({to:this._cacheAndConvertItem(F,we.to),fromRanges:we.fromRanges.map(le=>D.Range.from(le))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,H){const G=this._cache.get(F),X=D.CallHierarchyItem.from(H,F,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(F,H){return this._cache.get(F)?.get(H)}}class fe{constructor(F,H){this._documents=F,this._provider=H,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(F,H,G){const X=this._documents.getDocument(F),me=D.Position.to(H),we=await this._provider.prepareTypeHierarchy(X,me,G);if(!we)return;const le=this._idPool.nextId();return this._cache.set(le,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(le,Ce)):[this._cacheAndConvertItem(le,we)]}async provideSupertypes(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!me)return me.map(we=>this._cacheAndConvertItem(F,we))}async provideSubtypes(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!me)return me.map(we=>this._cacheAndConvertItem(F,we))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,H){const G=this._cache.get(F),X=D.TypeHierarchyItem.from(H,F,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(F,H){return this._cache.get(F)?.get(H)}}class Z{constructor(F,H,G,X){this._proxy=F,this._documents=H,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(F,H,G,X,me){const we=this._documents.getDocument(H),le=D.Position.to(G),Ce=D.DataTransfer.toDataTransfer(X,async $e=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,$e)).buffer),ye=await this._provider.provideDocumentDropEdits(we,le,Ce,me);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class ae{constructor(F,H){this.adapter=F,this.extension=H}}class ee{constructor(F,H,G,X,me,we,le){this._adapter=new Map,this._uriTransformer=H,this._proxy=F.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=me,this._logService=we,this._apiDeprecation=le}_transformDocumentSelector(F){return D.DocumentSelector.from(F,this._uriTransformer)}_createDisposable(F){return new P.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return ee._handlePool++}async _withAdapter(F,H,G,X,me,we=!1){const le=this._adapter.get(F);if(!le||!(le.adapter instanceof H))return X;const Ce=Date.now();we||this._logService.trace(`[${le.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(le.adapter,le.extension);return Promise.resolve(ye).catch($e=>{(0,f.isCancellationError)($e)||(this._logService.error(`[${le.extension.identifier.value}] provider FAILED`),this._logService.error($e))}).finally(()=>{we||this._logService.trace(`[${le.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(me)?(0,a.raceCancellationError)(ye,me):ye}_addNewAdapter(F,H){const G=this._nextHandle();return this._adapter.set(G,new ae(F,H)),G}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,G,X){const me=this._addNewAdapter(new s(this._documents,G),F),we=X&&X.label||ee._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(H),we),this._createDisposable(me)}$provideDocumentSymbols(F,H,G){return this._withAdapter(F,s,X=>X.provideDocumentSymbols(l.URI.revive(H),G),void 0,G)}registerCodeLensProvider(F,H,G){const X=this._nextHandle(),me=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new u(this._documents,this._commands.converter,G),F)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(H),me);let we=this._createDisposable(X);if(me!==void 0){const le=G.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(me));we=P.Disposable.from(we,le)}return we}$provideCodeLenses(F,H,G){return this._withAdapter(F,u,X=>X.provideCodeLenses(l.URI.revive(H),G),void 0,G)}$resolveCodeLens(F,H,G){return this._withAdapter(F,u,X=>X.resolveCodeLens(H,G),void 0,void 0)}$releaseCodeLenses(F,H){this._withAdapter(F,u,G=>Promise.resolve(G.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,G){const X=this._addNewAdapter(new i(this._documents,G),F);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDefinition(F,H,G,X){return this._withAdapter(F,i,me=>me.provideDefinition(l.URI.revive(H),G,X),[],X)}registerDeclarationProvider(F,H,G){const X=this._addNewAdapter(new r(this._documents,G),F);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDeclaration(F,H,G,X){return this._withAdapter(F,r,me=>me.provideDeclaration(l.URI.revive(H),G,X),[],X)}registerImplementationProvider(F,H,G){const X=this._addNewAdapter(new n(this._documents,G),F);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideImplementation(F,H,G,X){return this._withAdapter(F,n,me=>me.provideImplementation(l.URI.revive(H),G,X),[],X)}registerTypeDefinitionProvider(F,H,G){const X=this._addNewAdapter(new c(this._documents,G),F);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideTypeDefinition(F,H,G,X){return this._withAdapter(F,c,me=>me.provideTypeDefinition(l.URI.revive(H),G,X),[],X)}registerHoverProvider(F,H,G,X){const me=this._addNewAdapter(new h(this._documents,G),F);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(H)),this._createDisposable(me)}$provideHover(F,H,G,X){return this._withAdapter(F,h,me=>me.provideHover(l.URI.revive(H),G,X),void 0,X)}registerEvaluatableExpressionProvider(F,H,G,X){const me=this._addNewAdapter(new m(this._documents,G),F);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(H)),this._createDisposable(me)}$provideEvaluatableExpression(F,H,G,X){return this._withAdapter(F,m,me=>me.provideEvaluatableExpression(l.URI.revive(H),G,X),void 0,X)}registerInlineValuesProvider(F,H,G,X){const me=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new C(this._documents,G),F);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(H),me);let le=this._createDisposable(we);if(me!==void 0){const Ce=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(me));le=P.Disposable.from(le,Ce)}return le}$provideInlineValues(F,H,G,X,me){return this._withAdapter(F,C,we=>we.provideInlineValues(l.URI.revive(H),G,X,me),void 0,me)}registerDocumentHighlightProvider(F,H,G){const X=this._addNewAdapter(new L(this._documents,G),F);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentHighlights(F,H,G,X){return this._withAdapter(F,L,me=>me.provideDocumentHighlights(l.URI.revive(H),G,X),void 0,X)}registerLinkedEditingRangeProvider(F,H,G){const X=this._addNewAdapter(new U(this._documents,G),F);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideLinkedEditingRanges(F,H,G,X){return this._withAdapter(F,U,async me=>{const we=await me.provideLinkedEditingRanges(l.URI.revive(H),G,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ee._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(F,H,G){const X=this._addNewAdapter(new B(this._documents,G),F);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideReferences(F,H,G,X,me){return this._withAdapter(F,B,we=>we.provideReferences(l.URI.revive(H),G,X,me),void 0,me)}registerCodeActionProvider(F,H,G,X){const me=new w.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,G,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(H),{providedKinds:X?.providedCodeActionKinds?.map(le=>le.value),documentation:X?.documentation?.map(le=>({kind:le.kind.value,command:this._commands.converter.toInternal(le.command,me)}))},ee._extLabel(F),Boolean(G.resolveCodeAction)),me.add(this._createDisposable(we)),me}$provideCodeActions(F,H,G,X,me){return this._withAdapter(F,A,we=>we.provideCodeActions(l.URI.revive(H),G,X,me),void 0,me)}$resolveCodeAction(F,H,G){return this._withAdapter(F,A,X=>X.resolveCodeAction(H,G),void 0,void 0)}$releaseCodeActions(F,H){this._withAdapter(F,A,G=>Promise.resolve(G.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,G){const X=this._addNewAdapter(new $(this._documents,G),F);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(H),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentFormattingEdits(F,H,G,X){return this._withAdapter(F,$,me=>me.provideDocumentFormattingEdits(l.URI.revive(H),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(F,H,G){const X=this._addNewAdapter(new N(this._documents,G),F);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(H),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(F,H,G,X,me){return this._withAdapter(F,N,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(H),G,X,me),void 0,me)}registerOnTypeFormattingEditProvider(F,H,G,X){const me=this._addNewAdapter(new K(this._documents,G),F);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(H),X,F.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(F,H,G,X,me,we){return this._withAdapter(F,K,le=>le.provideOnTypeFormattingEdits(l.URI.revive(H),G,X,me,we),void 0,we)}registerWorkspaceSymbolProvider(F,H){const G=this._addNewAdapter(new z(H,this._logService),F);return this._proxy.$registerNavigateTypeSupport(G,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(F,H,G){return this._withAdapter(F,z,X=>X.provideWorkspaceSymbols(H,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,H,G){return this._withAdapter(F,z,X=>X.resolveWorkspaceSymbol(H,G),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this._withAdapter(F,z,G=>G.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,G){const X=this._addNewAdapter(new O(this._documents,G,this._logService),F);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(H),O.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(F,H,G,X,me){return this._withAdapter(F,O,we=>we.provideRenameEdits(l.URI.revive(H),G,X,me),void 0,me)}$resolveRenameLocation(F,H,G,X){return this._withAdapter(F,O,me=>me.resolveRenameLocation(l.URI.revive(H),G,X),void 0,X)}registerDocumentSemanticTokensProvider(F,H,G,X){const me=this._addNewAdapter(new V(this._documents,G),F),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(H),X,we);let le=this._createDisposable(me);if(we){const Ce=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));le=P.Disposable.from(le,Ce)}return le}$provideDocumentSemanticTokens(F,H,G,X){return this._withAdapter(F,V,me=>me.provideDocumentSemanticTokens(l.URI.revive(H),G,X),null,X)}$releaseDocumentSemanticTokens(F,H){this._withAdapter(F,V,G=>G.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,G,X){const me=this._addNewAdapter(new q(this._documents,G),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(H),X),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(F,H,G,X){return this._withAdapter(F,q,me=>me.provideDocumentRangeSemanticTokens(l.URI.revive(H),G,X),null,X)}registerCompletionItemProvider(F,H,G,X){const me=this._addNewAdapter(new Y(this._documents,this._commands.converter,G,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(me,this._transformDocumentSelector(H),X,Y.supportsResolving(G),`${F.identifier.value}(${X.join("")})`),this._createDisposable(me)}$provideCompletionItems(F,H,G,X,me){return this._withAdapter(F,Y,we=>we.provideCompletionItems(l.URI.revive(H),G,X,me),void 0,me)}$resolveCompletionItem(F,H,G){return this._withAdapter(F,Y,X=>X.resolveCompletionItem(H,G),void 0,G)}$releaseCompletionItems(F,H){this._withAdapter(F,Y,G=>G.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,G){const X=new he(F,this._documents,G,this._commands.converter),me=this._addNewAdapter(X,F);return this._proxy.$registerInlineCompletionsSupport(me,this._transformDocumentSelector(H),X.supportsHandleDidShowCompletionItem),this._createDisposable(me)}registerInlineCompletionsProviderNew(F,H,G){const X=this._addNewAdapter(new ve(F,this._documents,G,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(H),!0),this._createDisposable(X)}$provideInlineCompletions(F,H,G,X,me){return this._withAdapter(F,Q,we=>we.provideInlineCompletions(l.URI.revive(H),G,X,me),void 0,me)}$handleInlineCompletionDidShow(F,H,G){this._withAdapter(F,Q,async X=>{X.handleDidShowCompletionItem(H,G)},void 0,void 0)}$freeInlineCompletionsList(F,H){this._withAdapter(F,Q,async G=>{G.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,G,X){const me=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new pe(this._documents,G),F);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(H),me),this._createDisposable(we)}$provideSignatureHelp(F,H,G,X,me){return this._withAdapter(F,pe,we=>we.provideSignatureHelp(l.URI.revive(H),G,X,me),void 0,me)}$releaseSignatureHelp(F,H){this._withAdapter(F,pe,G=>G.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new be(this._documents,this._commands.converter,G,this._logService,F),F);this._proxy.$registerInlayHintsProvider(me,this._transformDocumentSelector(H),typeof G.resolveInlayHint=="function",X,ee._extLabel(F));let we=this._createDisposable(me);if(X!==void 0){const le=G.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,le)}return we}$provideInlayHints(F,H,G,X){return this._withAdapter(F,be,me=>me.provideInlayHints(l.URI.revive(H),G,X),void 0,X)}$resolveInlayHint(F,H,G){return this._withAdapter(F,be,X=>X.resolveInlayHint(H,G),void 0,G)}$releaseInlayHints(F,H){this._withAdapter(F,be,G=>G.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,G){const X=this._addNewAdapter(new ke(this._documents,G),F);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(H),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(F,H,G){return this._withAdapter(F,ke,X=>X.provideLinks(l.URI.revive(H),G),void 0,G,H.scheme==="output")}$resolveDocumentLink(F,H,G){return this._withAdapter(F,ke,X=>X.resolveLink(H,G),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this._withAdapter(F,ke,G=>G.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,G){const X=this._addNewAdapter(new Le(this._documents,G),F);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentColors(F,H,G){return this._withAdapter(F,Le,X=>X.provideColors(l.URI.revive(H),G),[],G)}$provideColorPresentations(F,H,G,X){return this._withAdapter(F,Le,me=>me.provideColorPresentations(l.URI.revive(H),G,X),void 0,X)}registerFoldingRangeProvider(F,H,G){const X=this._nextHandle(),me=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new We(this._documents,G),F)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(H),me);let we=this._createDisposable(X);if(me!==void 0){const le=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));we=P.Disposable.from(we,le)}return we}$provideFoldingRanges(F,H,G,X){return this._withAdapter(F,We,me=>me.provideFoldingRanges(l.URI.revive(H),G,X),void 0,X)}registerSelectionRangeProvider(F,H,G){const X=this._addNewAdapter(new oe(this._documents,G,this._logService),F);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideSelectionRanges(F,H,G,X){return this._withAdapter(F,oe,me=>me.provideSelectionRanges(l.URI.revive(H),G,X),[],X)}registerCallHierarchyProvider(F,H,G){const X=this._addNewAdapter(new ue(this._documents,G),F);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareCallHierarchy(F,H,G,X){return this._withAdapter(F,ue,me=>Promise.resolve(me.prepareSession(l.URI.revive(H),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(F,H,G,X){return this._withAdapter(F,ue,me=>me.provideCallsTo(H,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(F,H,G,X){return this._withAdapter(F,ue,me=>me.provideCallsFrom(H,G,X),void 0,X)}$releaseCallHierarchy(F,H){this._withAdapter(F,ue,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,G){const X=this._addNewAdapter(new fe(this._documents,G),F);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareTypeHierarchy(F,H,G,X){return this._withAdapter(F,fe,me=>Promise.resolve(me.prepareSession(l.URI.revive(H),G,X)),void 0,X)}$provideTypeHierarchySupertypes(F,H,G,X){return this._withAdapter(F,fe,me=>me.provideSupertypes(H,G,X),void 0,X)}$provideTypeHierarchySubtypes(F,H,G,X){return this._withAdapter(F,fe,me=>me.provideSubtypes(H,G,X),void 0,X)}$releaseTypeHierarchy(F,H){this._withAdapter(F,fe,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,G,X),F)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentOnDropEdits(F,H,G,X,me,we){return this._withAdapter(F,Z,le=>Promise.resolve(le.provideDocumentOnDropEdits(H,l.URI.revive(G),X,me,we)),void 0,void 0)}registerDocumentPasteEditProvider(F,H,G,X){const me=this._nextHandle();return this._adapter.set(me,new ae(new M(this._proxy,this._documents,G,me),F)),this._proxy.$registerPasteEditProvider(me,this._transformDocumentSelector(H),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(me)}$prepareDocumentPaste(F,H,G,X,me){return this._withAdapter(F,M,we=>we.prepareDocumentPaste(l.URI.revive(H),G,X,me),void 0,me)}$providePasteEdits(F,H,G,X,me,we){return this._withAdapter(F,M,le=>le.providePasteEdits(H,l.URI.revive(G),X,me,we),void 0,we)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,E.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:ee._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ee._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ee._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:ee._serializeRegExp(F.beforeText),afterText:F.afterText?ee._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?ee._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(ee._serializeOnEnterRule)}setLanguageConfiguration(F,H,G){const{wordPattern:X}=G;if(X&&(0,E.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(H,X):this._documents.setWordDefinitionFor(H,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const me=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ee._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ee._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ee._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,H,we),this._createDisposable(me)}$setWordDefinitions(F){for(const H of F)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(De[249],Ie([1,0,5,16,7,41,18,6]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(R,k,S,T){this._documents=k,this._commands=S,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,k){await this._proxy.$changeLanguage(R,k);const S=this._documents.getDocumentData(R);if(!S)throw new Error(`document '${R.toString()}' NOT found`);return S.document}async tokenAtPosition(R,k){const S=R.version,T=t.Position.from(k),w=await this._proxy.$tokensAtPosition(R.uri,T),b={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(k)??new D.Range(k.line,k.character,k.line,k.character)};if(!w)return b;const v={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!v.range.contains(k)||S!==R.version?b:v}createLanguageStatusItem(R,k,S){const T=this._handlePool++,w=this._proxy,b=this._ids,v=`${R.identifier.value}/${k}`;if(b.has(v))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);b.add(v);const d={selector:S,id:k,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const f=new y.DisposableStore,a=()=>{p?.dispose(),p=(0,_.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(T,{id:v,name:d.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===D.LanguageStatusSeverity.Error?P.default.Error:d.severity===D.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:d.command&&this._commands.toInternal(d.command,f),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},g={dispose(){f.dispose(),p?.dispose(),w.$removeLanguageStatus(T),b.delete(v)},get id(){return d.id},get name(){return d.name},set name(s){d.name=s,a()},get selector(){return d.selector},set selector(s){d.selector=s,a()},get text(){return d.text},set text(s){d.text=s,a()},get detail(){return d.detail},set detail(s){d.detail=s,a()},get severity(){return d.severity},set severity(s){d.severity=s,a()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(s){d.accessibilityInformation=s,a()},get command(){return d.command},set command(s){d.command=s,a()},get busy(){return d.busy},set busy(s){d.busy=s,a()}};return a(),g}}e.ExtHostLanguages=E}),define(De[136],Ie([1,0,14,5,26,15,4]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends l.AbstractLoggerService{constructor(R,k){const S=new _.Emitter;super(k.logLevel,S.event),this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,k,S){return new E(this._proxy,R,k,S)}};y=qe([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class E extends l.AbstractMessageLogger{constructor(R,k,S,T){super(T?.always),this.proxy=R,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(k,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,k){const S=[[R,k]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(R){this.proxy.$log(this.file,R)}}}),define(De[250],Ie([1,0,5,14,28]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(y){return y&&y.title}let _=class{constructor(E,I){this._logService=I,this._proxy=E.getProxy(l.MainContext.MainThreadMessageService)}showMessage(E,I,R,k,S){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let w;typeof k=="string"||P(k)?w=[k,...S]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,w=S),T.useCustom&&(0,D.checkProposedApiEnabled)(E,"resolvers");const b=[];for(let v=0;v<w.length;v++){const d=w[v];if(typeof d=="string")b.push({title:d,handle:v,isCloseAffordance:!1});else if(typeof d=="object"){const{title:p,isCloseAffordance:f}=d;b.push({title:p,isCloseAffordance:!!f,handle:v})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(I,R,T,b).then(v=>{if(typeof v=="number")return w[v]})}};_=qe([xe(1,t.ILogService)],_),e.ExtHostMessageService=_}),define(De[251],Ie([1,0,23,4,61,6,25,8,13,2,87,5,37,16,7,55,221,131]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class p{constructor(a,g,s,u,o){this._textDocumentsAndEditors=s,this._textDocuments=u,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new _.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const r=i.notebookEditor?.notebookUri,n=i.cell.handle,h=this._documents.get(r)?.getCell(n);if(h)return h.apiCell}return i}}),p._registerApiCommands(g)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const g=this._editors.get(a);if(!g)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(a){for(const[g,s]of this._editors)if(s.apiEditor===a)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,g){const s=this._documents.get(a);if(!s&&!g)throw new Error(`NO notebook document for '${a}'`);return s}_getProviderData(a){const g=this._notebookContentProviders.get(a);if(!g)throw new Error(`NO provider for '${a}'`);return g}registerNotebookContentProvider(a,g,s,u,o){if((0,y.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:a,provider:s});let i;return s.onDidChangeNotebookContentOptions&&(i=s.onDidChangeNotebookContentOptions(()=>{const r=T.NotebookDocumentContentOptions.from(s.options);this._notebookProxy.$updateNotebookProviderOptions(g,r)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},g,T.NotebookDocumentContentOptions.from(u),p._convertNotebookRegistrationData(a,o)),new w.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(a,g){if(!g)return;const s=g.filenamePattern.map(u=>T.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(g.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:g.displayName,filenamePattern:s,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,g,s){const u=p._notebookStatusBarItemProviderHandlePool++,o=typeof s.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,s),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,o,g);let i;return o!==void 0&&(i=s.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(o))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,o),i?.dispose()})}async createNotebookDocument(a){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&T.NotebookData.from(a.content)});return I.URI.revive(g)}async openNotebookDocument(a){const g=this._documents.get(a);if(g)return g.apiNotebook;const s=await this._notebookDocumentsProxy.$tryOpenNotebook(a),u=this._documents.get(I.URI.revive(s));return(0,E.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(a,g){I.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let s;typeof g=="object"?s={position:T.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(T.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:s={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,s),o=u&&this._editors.get(u)?.apiEditor;if(o)return o;throw u?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,g,s,u){const o=this._notebookStatusBarItemProviders.get(a),i=I.URI.revive(g),r=this._documents.get(i);if(!r||!o)return;const n=r.getCellFromIndex(s);if(!n)return;const c=await o.provideCellStatusBarItems(n.apiCell,u);if(!c)return;const h=new P.DisposableStore,m=this._statusBarCache.add([h]),L=(Array.isArray(c)?c:[c]).map(U=>T.NotebookStatusBarItem.from(U,this._commandsConverter,h));return{cacheId:m,items:L}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,g,s,u,o){if((0,y.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,s),this._notebookProxy.$registerNotebookSerializer(i,{id:a.identifier,location:a.extensionLocation},g,T.NotebookDocumentContentOptions.from(u),p._convertNotebookRegistrationData(a,o)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(a,g,s){const u=this._notebookSerializer.get(a);if(!u)throw new Error("NO serializer found");const o=await u.deserializeNotebook(g.buffer,s);return new b.SerializableObjectWithBuffers(T.NotebookData.from(o))}async $notebookToData(a,g,s){const u=this._notebookSerializer.get(a);if(!u)throw new Error("NO serializer found");const o=await u.serializeNotebook(T.NotebookData.to(g.value),s);return l.VSBuffer.wrap(o)}async $openNotebook(a,g,s,u,o){const{provider:i}=this._getProviderData(a),r=await i.openNotebook(I.URI.revive(g),{backupId:s,untitledDocumentData:u?.buffer},o);return new b.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(T.NotebookCellData.from)})}async $saveNotebook(a,g,s){const u=this.getNotebookDocument(I.URI.revive(g)),{provider:o}=this._getProviderData(a);return await o.saveNotebook(u.apiNotebook,s),!0}async $saveNotebookAs(a,g,s,u){const o=this.getNotebookDocument(I.URI.revive(g)),{provider:i}=this._getProviderData(a);return await i.saveNotebookAs(I.URI.revive(s),o.apiNotebook,u),!0}async $backupNotebook(a,g,s){const u=this.getNotebookDocument(I.URI.revive(g)),o=this._getProviderData(a),i=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension),r=String((0,D.hash)([u.uri.toString(),this._backupIdPool++])),n=I.URI.joinPath(i,r),c=await o.provider.backupNotebook(u.apiNotebook,{destination:n},s);return u.updateBackup(c),c.id}_createExtHostEditor(a,g,s){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const u=new d.ExtHostNotebookEditor(g,this._notebookEditorsProxy,a,s.visibleRanges.map(T.NotebookRange.to),s.selections.map(T.NotebookRange.to),typeof s.viewColumn=="number"?T.ViewColumn.to(s.viewColumn):void 0);this._editors.set(g,u)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const s of a.value.removedDocuments){const u=I.URI.revive(s),o=this._documents.get(u);o&&(o.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(o.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===u.toString()&&this._editors.delete(i.id)}if(a.value.addedDocuments){const s=[];for(const u of a.value.addedDocuments){const o=I.URI.revive(u.uri);if(this._documents.has(o))throw new Error(`adding EXISTING notebook ${o} `);const i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,o,u);s.push(...u.cells.map(r=>v.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(o)?.dispose(),this._documents.set(o,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const s of a.value.addedEditors){if(this._editors.has(s.id))return;const u=I.URI.revive(s.documentUri),o=this._documents.get(u);o&&this._createExtHostEditor(o,s.id,s)}const g=[];if(a.value.removedEditors)for(const s of a.value.removedEditors){const u=this._editors.get(s);u&&(this._editors.delete(s),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),g.push(u))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const s=new Set;this._visibleNotebookEditors.forEach(u=>s.add(u.id));for(const u of this._editors.values()){const o=s.has(u.id);u._acceptVisibility(o)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const g=S.ApiCommandArgument.String.with("notebookType","A notebook type"),s=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new S.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>l.VSBuffer.wrap(o))],new S.ApiCommandResult("Notebook Data",o=>T.NotebookData.to(o.value))),u=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new b.SerializableObjectWithBuffers(T.NotebookData.from(o)))],new S.ApiCommandResult("Bytes",o=>o.buffer));a.registerApiCommand(s),a.registerApiCommand(u)}}e.ExtHostNotebookController=p,p._notebookStatusBarItemProviderHandlePool=0}),define(De[252],Ie([1,0,17,18,21,4,6,25,2,27,14,5,37,16,7,88,215,28,55]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(i,r,n,c,h){this._initData=r,this._extHostNotebook=n,this._commands=c,this._logService=h,this._activeExecutions=new y.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(k.MainContext.MainThreadNotebookKernels);const m=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const L=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:L}}else if(C&&"notebookEditor"in C){const L=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return C})],S.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(i,r,n,c,h,m){for(const Y of this._kernelData.values())if(Y.controller.id===r&&I.ExtensionIdentifier.equals(i.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,L=this;this._logService.trace(`NotebookController[${C}], CREATED by ${i.identifier.value}, ${r}`);const U=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${i.identifier}'`);let B=!1;const A=new _.DisposableStore,M=new P.Emitter,$=new P.Emitter,N={id:u(i.identifier,r),notebookType:n,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:c||i.identifier.value,preloads:m?m.map(T.NotebookRendererScript.from):[]};let K=h??U,z;this._proxy.$addKernel(C,N).catch(Y=>{console.log(Y),B=!0});let O=0;const x=()=>{if(B)return;const Y=++O;Promise.resolve().then(()=>{Y===O&&this._proxy.$updateKernel(C,N)})},V=new y.ResourceMap,q={get id(){return r},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return N.label},set label(Y){N.label=Y??i.displayName??i.name,x()},get detail(){return N.detail??""},set detail(Y){N.detail=Y,x()},get description(){return N.description??""},set description(Y){N.description=Y,x()},get kind(){return(0,d.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind??""},set kind(Y){(0,d.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind=Y,x()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(Y){N.supportedLanguages=Y,x()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){N.supportsExecutionOrder=Y,x()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(Y){K=Y??U},get interruptHandler(){return z},set interruptHandler(Y){z=Y,N.supportsInterrupt=Boolean(Y),x()},createNotebookCellExecution(Y){if(B)throw new Error("notebook controller is DISPOSED");if(!V.has(Y.notebook.uri))throw L._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return L._createNotebookCellExecution(Y,u(i.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${C}], DISPOSED`),B=!0,this._kernelData.delete(C),A.dispose(),M.dispose(),$.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(Y,Q){L._proxy.$updateNotebookPriority(C,Y.uri,Q)},onDidReceiveMessage:$.event,postMessage(Y,Q){return(0,d.checkProposedApiEnabled)(i,"notebookMessaging"),L._proxy.$postMessage(C,Q&&L._extHostNotebook.getIdByEditor(Q),Y)},asWebviewUri(Y){return(0,d.checkProposedApiEnabled)(i,"notebookMessaging"),(0,b.asWebviewUri)(Y,L._initData.remote)}};return this._kernelData.set(C,{extensionId:i.identifier,controller:q,onDidReceiveMessage:$,onDidChangeSelection:M,associatedNotebooks:V}),q}getIdByController(i){for(const[r,n]of this._kernelData)if(n.controller===i)return u(n.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,n){const c=this._kernelData.get(i);if(c){const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));n?c.associatedNotebooks.set(h.uri,!0):c.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,h.uri.toString(),n),c.onDidChangeSelection.fire({selected:n,notebook:h.apiNotebook})}}async $executeCells(i,r,n){const c=this._kernelData.get(i);if(!c)return;const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)),m=[];for(const C of n){const L=h.getCell(C);L&&m.push(L.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,h.uri.toString(),m.length),await c.controller.executeHandler.call(c.controller,m,h.apiNotebook,c.controller)}catch(C){this._logService.error(`NotebookController[${i}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(i,r,n){const c=this._kernelData.get(i);if(!c)return;const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,h.apiNotebook);else for(const m of n){const C=h.getCell(m);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,n){const c=this._kernelData.get(i);if(!c)return;const h=this._extHostNotebook.getEditorById(r);c.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:n}))}$cellExecutionChanged(i,r,n){const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)).getCell(r);if(h){const m=n?T.NotebookCellExecutionState.to(n):w.NotebookCellExecutionState.Idle;m!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:m})}}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const h=new g(r,c,this._proxy);this._activeExecutions.set(c.uri,h);const m=h.onDidChangeState(()=>{h.state===a.Resolved&&(h.dispose(),m.dispose(),this._activeExecutions.delete(c.uri))});return h.asApiObject()}};f=qe([xe(4,R.ILogService)],f),e.ExtHostNotebookKernels=f;var a;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(a||(a={}));class g extends _.Disposable{constructor(i,r,n){super(),this._cell=r,this._proxy=n,this._handle=g.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new s(10,c=>this.update(c)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new p.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const n=w.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return n===r.items?T.NotebookCellOutput.from(r):T.NotebookCellOutput.from({items:n,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,n){const c=this.cellIndexToHandle(r),h=this.validateAndConvertOutputs((0,l.asArray)(i));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,cellHandle:c,append:n,outputs:h})}async updateOutputItems(i,r,n){return i=w.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(i),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:r.id,append:n})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(n){i._executionOrder=n,i.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(n){if(i._state===a.Resolved||i._state===a.Started)throw new Error("Cannot call start again");i._state=a.Started,i._onDidChangeState.fire(),i.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,c){if(i._state===a.Resolved)throw new Error("Cannot call resolve twice");i._state=a.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new p.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:n}))},clearOutput(n){return i.verifyStateForOutput(),i.updateOutputs([],n,!1)},appendOutput(n,c){return i.verifyStateForOutput(),i.updateOutputs(n,c,!0)},replaceOutput(n,c){return i.verifyStateForOutput(),i.updateOutputs(n,c,!1)},appendOutputItems(n,c){return i.verifyStateForOutput(),i.updateOutputItems(n,c,!0)},replaceOutputItems(n,c){return i.verifyStateForOutput(),i.updateOutputItems(n,c,!1)}})}}g.HANDLE=0;class s{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function u(o,i){return`${o.value}/${i}`}e.createKernelId=u}),define(De[253],Ie([1,0,4,5,131]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(y,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,E,I){const R=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(E)?.fire({editor:R.apiEditor,message:I})}createRendererMessaging(y,E){if(!y.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,k,S)=>this.getOrCreateEmitterFor(E).event(R,k,S),postMessage:(R,k)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const S=k&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(S?.id,E,R)}}}getOrCreateEmitterFor(y){let E=this._rendererMessageEmitters.get(y);return E||(E=new l.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,E),E)}}e.ExtHostNotebookRenderers=P}),define(De[254],Ie([1,0,21,4,6,5,2,7,10,17,41,86]),function(J,e,l,t,D,P,_,y,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(T,w,b){const v=T.getProxy(P.MainContext.MainThreadQuickOpen);class d{constructor(r,n){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=n}showQuickPick(r,n,c=l.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(r),m=++this._instances,C=v.$show(m,{title:n?.title,placeHolder:n?.placeHolder,matchOnDescription:n?.matchOnDescription,matchOnDetail:n?.matchOnDetail,ignoreFocusLost:n?.ignoreFocusOut,canPickMany:n?.canPickMany},c),L={},U=C.then(()=>L);return Promise.race([U,h]).then(B=>{if(B!==L)return h.then(A=>{const M=[];for(let $=0;$<A.length;$++){const N=A[$];typeof N=="string"?M.push({label:N,handle:$}):N.kind===y.QuickPickItemKind.Separator?M.push({type:"separator",label:N.label}):M.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:$})}return n&&typeof n.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{n.onDidSelectItem(A[$])}),v.$setItems(m,M),C.then($=>{if(typeof $=="number")return A[$];if(Array.isArray($))return $.map(N=>A[N])})})}).then(void 0,B=>{if(!(0,E.isCancellationError)(B))return v.$setError(m,B),Promise.reject(B)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,n=l.CancellationToken.None){return this._validateInput=r?.validateInput,v.$input(r,typeof this._validateInput=="function",n).then(void 0,c=>{if(!(0,E.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(r){if(!this._validateInput)return;const n=await this._validateInput(r);if(!n||typeof n=="string")return n;let c;switch(n.severity){case y.InputBoxValidationSeverity.Info:c=R.default.Info;break;case y.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case y.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=n.message?R.default.Error:R.default.Ignore;break}return{content:n.message,severity:c}}async showWorkspaceFolderPick(r,n=l.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!c)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(m=>m.uri.toString()===c.uri.toString())}createQuickPick(r){const n=new u(r,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}createInputBox(r){const n=new o(r,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}$onDidChangeValue(r,n){this._sessions.get(r)?._fireDidChangeValue(n)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,n){const c=this._sessions.get(r);c instanceof u&&c._fireDidChangeActive(n)}$onDidChangeSelection(r,n){const c=this._sessions.get(r);c instanceof u&&c._fireDidChangeSelection(n)}$onDidTriggerButton(r,n){this._sessions.get(r)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(r,n,c){const h=this._sessions.get(r);h instanceof u&&h._fireDidTriggerItemButton(n,c)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class p{constructor(r,n){this._extensionId=r,this._onDidDispose=n,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((n,c)=>{const h=n===y.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(h,n)}),this.update({buttons:r.map((n,c)=>({...s(n),tooltip:n.tooltip,handle:n===y.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const n=this._handlesToButtons.get(r);n&&this._onDidTriggerButtonEmitter.fire(n)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(r){if(!this._disposed){for(const n of Object.keys(r)){const c=r[n];this._pendingUpdate[n]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function f(i){if(i instanceof y.ThemeIcon)return{id:i.id};const r=g(i),n=a(i);return{dark:typeof r=="string"?_.URI.file(r):r,light:typeof n=="string"?_.URI.file(n):n}}function a(i){return typeof i=="object"&&"light"in i?i.light:i}function g(i){return typeof i=="object"&&"dark"in i?i.dark:i}function s(i){const r=f(i.iconPath);let n,c;return"id"in r?c=k.ThemeIcon.asClassName(r):n=r,{iconPath:n,iconClass:c}}class u extends p{constructor(r,n){super(r.identifier,n),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,h)=>{this._handlesToItems.set(h,c),this._itemsToHandles.set(c,h)});const n=[];for(let c=0;c<r.length;c++){const h=r[c];h.kind===y.QuickPickItemKind.Separator?n.push({type:"separator",label:h.label}):n.push({handle:c,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((m,C)=>({...s(m),tooltip:m.tooltip,handle:C}))})}this.update({items:n})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(n=>this._itemsToHandles.has(n)),this.update({activeItems:this._activeItems.map(n=>this._itemsToHandles.get(n))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(n=>this._itemsToHandles.has(n)),this.update({selectedItems:this._selectedItems.map(n=>this._itemsToHandles.get(n))})}_fireDidChangeActive(r){const n=(0,I.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._activeItems=n,this._onDidChangeActiveEmitter.fire(n)}_fireDidChangeSelection(r){const n=(0,I.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._selectedItems=n,this._onDidChangeSelectionEmitter.fire(n)}_fireDidTriggerItemButton(r,n){const c=this._handlesToItems.get(r);if(!c||!c.buttons||!c.buttons.length)return;const h=c.buttons[n];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:c})}}class o extends p{constructor(r,n){super(r.identifier,n),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.message,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new d(w,b)}e.createExtHostQuickOpen=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[255],Ie([1,0,2,4,58,6,18,5,17,103,14,27,86,16,28]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w){"use strict";var b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(h){if(h)return typeof h.iconPath=="string"?l.URI.file(h.iconPath):l.URI.isUri(h.iconPath)||S.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function p(h,m){if(!h.iconPath&&!m.iconPath)return 0;if(h.iconPath){if(!m.iconPath)return 1}else return-1;const C=typeof h.iconPath=="string"?h.iconPath:l.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,L=typeof m.iconPath=="string"?m.iconPath:l.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,I.comparePaths)(C,L)}function f(h,m){let C=0;if(h.strikeThrough!==m.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==m.faded)return h.faded?1:-1;if(h.tooltip!==m.tooltip)return(h.tooltip||"").localeCompare(m.tooltip||"");if(C=p(h,m),C!==0)return C;if(h.light&&m.light)C=p(h.light,m.light);else{if(h.light)return 1;if(m.light)return-1}if(C!==0)return C;if(h.dark&&m.dark)C=p(h.dark,m.dark);else{if(h.dark)return 1;if(m.dark)return-1}return C}function a(h,m){if(h.command!==m.command)return h.command<m.command?-1:1;if(h.title!==m.title)return h.title<m.title?-1:1;if(h.tooltip!==m.tooltip){if(h.tooltip!==void 0&&m.tooltip!==void 0)return h.tooltip<m.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(h.arguments===m.arguments)return 0;if(h.arguments)if(m.arguments){if(h.arguments.length!==m.arguments.length)return h.arguments.length-m.arguments.length}else return 1;else return-1;for(let C=0;C<h.arguments.length;C++){const L=h.arguments[C],U=m.arguments[C];if(L!==U)return L<U?-1:1}return 0}function g(h,m){let C=(0,I.comparePaths)(h.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(C!==0)return C;if(h.command&&m.command)C=a(h.command,m.command);else{if(h.command)return 1;if(m.command)return-1}if(C!==0)return C;if(h.decorations&&m.decorations)C=f(h.decorations,m.decorations);else{if(h.decorations)return 1;if(m.decorations)return-1}return C}function s(h,m){for(let C=0;C<h.length;C++)if(h[C]!==m[C])return!1;return!0}function u(h,m){return h.command===m.command&&h.title===m.title&&h.tooltip===m.tooltip&&(h.arguments&&m.arguments?s(h.arguments,m.arguments):h.arguments===m.arguments)}function o(h,m){return(0,E.equals)(h,m,u)}class i{constructor(m,C,L){this._extension=m,this._sourceControlHandle=L,b.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,b,C,"f")}get value(){return this._value}set value(m){m=m??"",Ue(this,b,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){Ue(this,b,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,Ue(this,b,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get enabled(){return this._enabled}set enabled(m){m=!!m,this._enabled!==m&&(this._enabled=m,Ue(this,b,"f").$setInputBoxEnablement(this._sourceControlHandle,m))}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,Ue(this,b,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,C){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,b,"f").$showValidationMessage(this._sourceControlHandle,m,C)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=i,b=new WeakMap;class r{constructor(m,C,L,U,B){this._proxy=m,this._commands=C,this._sourceControlHandle=L,this._id=U,this._label=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,C){const L=this._resourceStatesCommandsMap.get(m);return L?(0,_.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(g),L=(0,E.sortedDiff)(this._resourceSnapshot,m,g).map(A=>{const M=A.toInsert.map($=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,$);const K=$.resourceUri;let z;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const pe=new P.DisposableStore;z=this._commands.converter.toInternal($.command,pe),this._resourceStatesDisposablesMap.set(N,pe)}else this._resourceStatesCommandsMap.set(N,$.command);const O=d($.decorations),x=$.decorations&&d($.decorations.light)||O,V=$.decorations&&d($.decorations.dark)||O,q=[x,V],Y=$.decorations&&$.decorations.tooltip||"",Q=$.decorations&&!!$.decorations.strikeThrough,he=$.decorations&&!!$.decorations.faded,ve=$.contextValue||"";return{rawResource:[N,K,q,Y,Q,he,ve,z],handle:N}});return{start:A.start,deleteCount:A.deleteCount,toInsert:M}}),U=L.map(({start:A,deleteCount:M,toInsert:$})=>[A,M,$.map(N=>N.rawResource)]),B=L.reverse();for(const{start:A,deleteCount:M,toInsert:$}of B){const N=$.map(z=>z.handle),K=this._handlesSnapshot.splice(A,M,...N);for(const z of K)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=m,U}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class n{constructor(m,C,L,U,B,A){this._extension=m,this._commands=L,this._id=U,this._label=B,this._rootUri=A,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,v,C,"f"),this._inputBox=new i(m,Ue(this,v,"f"),this.handle),Ue(this,v,"f").$registerSourceControl(this.handle,U,B,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,Ue(this,v,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,Ue(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,Ue(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=m;const C=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);Ue(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=m;const C=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),secondaryCommands:m.secondaryCommands?.map(L=>L.map(U=>this._commands.converter.toInternal(U,this._actionButtonDisposables.value))),description:m.description,enabled:m.enabled}:void 0;Ue(this,v,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&o(this._statusBarCommands,m))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=m;const C=(m||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Ue(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(m,C){const L=new r(Ue(this,v,"f"),this._commands,this.handle,m,C),U=t.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,U),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const m=[],C=[];for(const[L,U]of this.createdResourceGroups){U.dispose();const B=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),B.dispose(),this._groups.delete(L.handle),Ue(this,v,"f").$unregisterGroup(this.handle,L.handle)}),m.push([L.handle,L.id,L.label,L.features]);const A=L._takeResourceStateSnapshot();A.length>0&&C.push([L.handle,A]),this._groups.set(L.handle,L)}Ue(this,v,"f").$registerGroups(this.handle,m,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(C=>{const L=C._takeResourceStateSnapshot();L.length!==0&&m.push([C.handle,L])}),m.length>0&&Ue(this,v,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),Ue(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,n._handlePool=0,qe([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let c=class Yn{constructor(m,C,L){this._commands=C,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=m.getProxy(y.MainContext.MainThreadSCM),this._telemetry=m.getProxy(y.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const B=this._sourceControls.get(U.sourceControlHandle);if(!B)return U;const A=B.getResourceGroup(U.groupHandle);return A?A.getResourceState(U.handle):U}else if(U&&U.$mid===4){const B=this._sourceControls.get(U.sourceControlHandle);return B?B.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const B=this._sourceControls.get(U.handle);return B||U}return U}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,C,L,U){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,C,L,U),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const B=Yn._handlePool++,A=new n(m,this._proxy,this._commands,C,L,U);this._sourceControls.set(B,A);const M=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(m.identifier))||[];return M.push(A),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(m.identifier),M),A}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const C=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(m.identifier)),L=C&&C[C.length-1];return L&&L.inputBox}$provideOriginalResource(m,C,L){const U=l.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,U.toString());const B=this._sourceControls.get(m);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>B.quickDiffProvider.provideOriginalResource(U,L)).then(A=>A||null)}$onInputBoxValueChange(m,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const L=this._sourceControls.get(m);return L&&L.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(m,C,L,U){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,C,L);const B=this._sourceControls.get(m);if(!B)return Promise.resolve(void 0);const A=B.getResourceGroup(C);return A?A.$executeResourceCommand(L,U):Promise.resolve(void 0)}$validateInput(m,C,L){this.logService.trace("ExtHostSCM#$validateInput",m);const U=this._sourceControls.get(m);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>U.inputBox.validateInput(C,L)).then(B=>{if(!B)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(B.message);return A?Promise.resolve([A,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};c._handlePool=0,c=qe([xe(2,R.ILogService)],c),e.ExtHostSCM=c}),define(De[90],Ie([1,0,5,4,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(y){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,E){return this._proxy.$getPassword(y,E)}store(y,E,I){return this._proxy.$setPassword(y,E,I)}delete(y,E){return this._proxy.$deletePassword(y,E)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[256],Ie([1,0,7,5,172,6,16,13]),function(J,e,l,t,D,P,_,y){"use strict";var E,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(w,b,v,d,p=l.StatusBarAlignment.Left,f){E.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,E,w,"f"),tt(this,I,b,"f"),this._entryId=R.ID_GEN++,this._extension=v,this._id=d,this._alignment=p,this._priority=this.validatePriority(f)}validatePriority(w){if(!!(0,y.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!R.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Ue(this,I,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Ue(this,I,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let b;this._name?b=this._name:b=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=_.MarkdownString.fromStrict(this._tooltip);Ue(this,E,"f").$setEntry(this._entryId,w,b,this._text,d,this._command?.internal,v,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,E=new WeakMap,I=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const b={message:w};return this._messages.unshift(b),this._update(),new l.Disposable(()=>{const v=this._messages.indexOf(b);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(w,b){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=b,this._statusMessage=new k(this)}createStatusBarEntry(w,b,v,d){return new R(this._proxy,this._commands,w,b,v,d)}setStatusBarMessage(w,b){const v=this._statusMessage.setMessage(w);let d;return typeof b=="number"?d=setTimeout(()=>v.dispose(),b):typeof b<"u"&&b.then(()=>v.dispose(),()=>v.dispose()),new l.Disposable(()=>{v.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=S}),define(De[91],Ie([1,0,5,4,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(y){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,E){this._proxy.$registerExtensionStorageKeysToSync(y,E)}initializeExtensionStorage(y,E,I){return this._proxy.$initializeExtensionStorage(y,E).then(R=>R||I)}setValue(y,E,I){return this._proxy.$setValue(y,E,I)}$acceptValue(y,E,I){this._onDidChangeStorage.fire({shared:y,key:E,value:I})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(De[69],Ie([1,0,3,26,14,68,2]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let y=class{constructor(I,R,k){this._logService=R,this._extHostFileSystem=k,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(I){return _.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,R=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this._value)return _.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return _.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=qe([xe(0,t.IExtHostInitDataService),xe(1,D.ILogService),xe(2,P.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(De[137],Ie([1,0,3,5,15]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,l.createDecorator)("IExtHostTelemetryLogService");let P=class{constructor(y){this._telemetryShape=y.getProxy(t.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(y,E,I){this._telemetryShape.$logTelemetryToOutputChannel(`${y.identifier.value}/${E}`,I)}};P=qe([xe(0,D.IExtHostRpcService)],P),e.ExtHostTelemetryLogService=P}),define(De[38],Ie([1,0,4,5,3,2,15,6,7,173,10,216,21,34,200,86,13,18]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class p{constructor(n,c,h,m){this._proxy=n,this._id=c,this._creationOptions=h,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(L,U=!0){C._checkDisposed(),C._proxy.$sendText(C._id,L,U)},show(L){C._checkDisposed(),C._proxy.$show(C._id,L)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(n,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,v.withNullAsUndefined)(n.shellPath),shellArgs:(0,v.withNullAsUndefined)(n.shellArgs),cwd:(0,v.withNullAsUndefined)(n.cwd),env:(0,v.withNullAsUndefined)(n.env),icon:(0,v.withNullAsUndefined)(o(n.iconPath)),color:b.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,v.withNullAsUndefined)(n.message),strictEnv:(0,v.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(n.location,c?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,c,h,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:b.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(n,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,c){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,c){this._exitStatus=Object.freeze({code:n,reason:c})}setDimensions(n,c){return n===this._cols&&c===this._rows||n===0||c===0?!1:(this._cols=n,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=p;class f{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,c){this._pty.setDimensions?.({columns:n,rows:c})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let a=1,g=class extends y.Disposable{constructor(n,c){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[h,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,c){const h=new p(this._proxy,(0,T.generateUuid)(),n,n.name),m=new f(n.pty);return h.createExtensionTerminal(n.location,this._serializeParentTerminal(n,c).resolvedExtHostIdentifier,o(n.iconPath),i(n.color)).then(C=>{const L=this._setupExtHostProcessListeners(C,m);this._terminalProcessDisposables[C]=L}),this._terminals.push(h),h.value}_serializeParentTerminal(n,c){if(c=c||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const h=n.location.parentTerminal;if(h){const m=this._terminals.find(C=>C.value===h);m&&(c.resolvedExtHostIdentifier=m._id)}}else n.location&&typeof n.location!="object"?c.location=n.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(n,c){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const m=new f(c),C=this._setupExtHostProcessListeners(n,m);this._terminalProcessDisposables[n]=C}async $acceptActiveTerminalChanged(n){const c=this._activeTerminal;if(n===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(n);h&&(this._activeTerminal=h,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,c){const h=this._getTerminalById(n);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(n,c,h){const m=this._getTerminalById(n);m&&m.setDimensions(c,h)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(n,c,h){this._terminalProcesses.get(n)?.resize(c,h)}async $acceptTerminalTitleChange(n,c){const h=this._getTerminalById(n);h&&(h.name=c)}async $acceptTerminalClosed(n,c,h){const m=this._getTerminalObjectIndexById(this._terminals,n);if(m!==null){const C=this._terminals.splice(m,1)[0];C.setExitStatus(c,h),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(n,c,h,m){if(c){const U=this._getTerminalObjectIndexById(this._terminals,c);if(U!==null){this._terminals[U]._id=n,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const C={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:P.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},L=new p(this._proxy,n,C,h);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(n,c){this._getTerminalById(n)?._setProcessId(c)}async $startExtensionTerminal(n,c){const h=this._getTerminalById(n);if(!h)return{message:(0,I.localize)(0,null,n)};h.isOpen||await new Promise(C=>{const L=this.onDidOpenTerminal(async U=>{U===h.value&&(L.dispose(),C())})});const m=this._terminalProcesses.get(n);m?m.startSendingEvents(c):this._extensionTerminalAwaitingStart[n]={initialDimensions:c}}_setupExtHostProcessListeners(n,c){const h=new y.DisposableStore;h.add(c.onProcessReady(C=>this._proxy.$sendProcessReady(n,C.pid,C.cwd))),h.add(c.onDidChangeProperty(C=>this._proxy.$sendProcessProperty(n,C))),this._bufferer.startBuffering(n,c.onProcessData),h.add(c.onProcessExit(C=>this._onProcessExit(n,C))),this._terminalProcesses.set(n,c);const m=this._extensionTerminalAwaitingStart[n];return m&&c instanceof f&&(c.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),h}$acceptProcessAckDataEvent(n,c){this._terminalProcesses.get(n)?.acknowledgeDataEvent(c)}$acceptProcessInput(n,c){this._terminalProcesses.get(n)?.input(c)}$acceptTerminalInteraction(n){const c=this._getTerminalById(n);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(n,c,h){try{this._terminalProcesses.get(n)?.resize(c,h)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(n,c){this._terminalProcesses.get(n)?.shutdown(c)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(c=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:c}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,c,h){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,h),this._proxy.$registerProfileProvider(c,n.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(n,c){const h=new S.CancellationTokenSource().token;let m=await this._profileProviders.get(n)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,c);return}this.createTerminalFromOptions(m.options,c)}}async $provideLinks(n,c){const h=this._getTerminalById(n);if(!h)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const C=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,C);const L=[],U={terminal:h.value,line:c},B=[];for(const $ of this._linkProviders)B.push(d.Promises.withAsyncBody(async N=>{C.token.onCancellationRequested(()=>N({provider:$,links:[]}));const K=await $.provideTerminalLinks(U,C.token)||[];C.token.isCancellationRequested||N({provider:$,links:K})}));const A=await Promise.all(B);if(C.token.isCancellationRequested)return[];const M=new Map;for(const $ of A)$&&$.links.length>0&&L.push(...$.links.map(N=>{const K={id:a++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return M.set(K.id,{provider:$.provider,link:N}),K}));return this._terminalLinkCache.set(n,M),L}$activateLink(n,c){const h=this._terminalLinkCache.get(n)?.get(c);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(n,c){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const h=this._terminalProcessDisposables[n];h&&(h.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,c)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,c){const h=this._getTerminalObjectIndexById(n,c);return h!==null?n[h]:null}_getTerminalObjectIndexById(n,c){let h=null;return n.some((m,C)=>m._id===c?(h=C,!0):!1),h}getEnvironmentVariableCollection(n){let c=this._environmentVariableCollections.get(n.identifier.value);return c||(c=new s,this._setEnvironmentVariableCollection(n.identifier.value,c)),c}_syncEnvironmentVariableCollection(n,c){const h=(0,k.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(n,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(n){n.forEach(c=>{const h=c[0],m=new s(c[1]);this._setEnvironmentVariableCollection(h,m)})}$acceptDefaultProfile(n,c){this._defaultProfile=n,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(n,c){this._environmentVariableCollections.set(n,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,c)})}};g=qe([xe(1,_.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class s{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,c){this._setIfDiffers(n,{value:c,type:E.EnvironmentVariableMutatorType.Replace})}append(n,c){this._setIfDiffers(n,{value:c,type:E.EnvironmentVariableMutatorType.Append})}prepend(n,c){this._setIfDiffers(n,{value:c,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,c){const h=this.map.get(n);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(n,c),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,c){this.map.forEach((h,m)=>n.call(c,m,h,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let u=class extends g{constructor(n){super(!1,n)}createTerminal(n,c,h){throw new R.NotSupportedError}createTerminalFromOptions(n,c){throw new R.NotSupportedError}};u=qe([xe(0,_.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function o(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return b.ThemeColor.isThemeColor(r)?r:void 0}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[257],Ie([1,0,17,23,21,4,59,61,6,24,13,34,5,15,132,16,7,65,89,66]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f){"use strict";var a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(B,A,M){this.editors=M,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(S.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new o(this.proxy),A.registerArgumentProcessor({processArgument:$=>$?.$mid===13?(0,w.toItemFromContext)($):$})}createTestController(B,A,M){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const $=new E.DisposableStore,N=$.add(new w.ExtHostTestItemCollection(B,A,this.editors));N.root.label=A;const K=new Map,z=this.proxy,O={items:N.root.children,get label(){return A},set label(V){A=V,N.root.label=V,z.$updateController(B,{label:A})},get refreshHandler(){return M},set refreshHandler(V){M=V,z.$updateController(B,{canRefresh:!!V})},get id(){return B},createRunProfile:(V,q,Y,Q,he)=>{let ve=(0,y.hash)(V);for(;K.has(ve);)ve++;return new C(this.proxy,K,B,ve,V,q,Y,Q,he)},createTestItem(V,q,Y){return new w.TestItemImpl(B,V,q,Y)},createTestRun:(V,q,Y=!0)=>this.runTracker.createTestRun(B,N,V,q,Y),set resolveHandler(V){N.resolveHandler=V},get resolveHandler(){return N.resolveHandler},dispose:()=>{$.dispose()}};z.$registerTestController(B,A,!!M),$.add((0,E.toDisposable)(()=>z.$unregisterTestController(B)));const x={controller:O,collection:N,profiles:K};return this.controllers.set(B,x),$.add((0,E.toDisposable)(()=>this.controllers.delete(B))),$.add(N.onDidGenerateDiff(V=>z.$publishDiff(B,V.map(f.TestsDiffOp.serialize)))),O}createTestObserver(){return this.observer.checkout()}async runTests(B,A=D.CancellationToken.None){const M=i(B);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(M.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(N=>d.TestId.fromExtHostTestItem(N,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:L[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:B.exclude?.map(N=>N.id)},A)}$provideFileCoverage(B,A,M){return(0,l.mapFind)(this.runTracker.trackers,N=>N.id===B?N.getCoverage(A):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(B,A,M,$){return(0,l.mapFind)(this.runTracker.trackers,K=>K.id===B?K.getCoverage(A):void 0)?.resolveFileCoverage(M,$)??Promise.resolve([])}$configureRunProfile(B,A){this.controllers.get(B)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(B,A){await this.controllers.get(B)?.controller.refreshHandler?.(A)}$publishTestResults(B){this.results=Object.freeze(B.map(A=>(0,I.deepFreeze)(b.TestResults.to(A))).concat(this.results).sort((A,M)=>M.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,A){const M=this.controllers.get(d.TestId.fromString(B).controllerId)?.collection;M&&(await M.expand(B,A<0?1/0:A),M.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(f.TestsDiffOp.deserialize))}async $runControllerTests(B,A){return Promise.all(B.map(M=>this.runControllerTestRequest(M,A)))}async runControllerTestRequest(B,A){const M=this.controllers.get(B.controllerId);if(!M)return{};const{collection:$,profiles:N}=M,K=N.get(B.profileId);if(!K)return{};const z=B.testIds.map(q=>$.tree.get(q)).filter(R.isDefined),O=B.excludeExtIds.map(q=>M.collection.tree.get(q)).filter(R.isDefined).filter(q=>z.some(Y=>Y.fullId.compare(q.fullId)===2));if(!z.length)return{};const x=new v.TestRunRequest(z.some(q=>q.actual instanceof w.TestItemRootImpl)?void 0:z.map(q=>q.actual),O.map(q=>q.actual),K),V=this.runTracker.prepareForMainThreadTestRun(x,r.fromInternal(B,M.collection),A);try{return await K.runHandler(x,A),{}}catch(q){return{error:String(q)}}finally{V.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};s=qe([xe(0,T.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends E.Disposable{constructor(B,A,M){super(),this.dto=B,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(M)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const A=this.dto.id,M=this.dto.controllerId,$=(0,k.generateUuid)(),N=new n(this.proxy,A,$),K=V=>(q,...Y)=>{if(O){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),V(q,...Y))},z=(V,q)=>{const Y=q instanceof Array?q.map(b.TestMessage.from):[b.TestMessage.from(q)];if(V.uri&&V.range){const Q={range:b.Range.from(V.range),uri:V.uri};for(const he of Y)he.location=he.location||Q}this.proxy.$appendTestMessagesInRun(A,$,d.TestId.fromExtHostTestItem(V,M).toString(),Y)};let O=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return N.coverageProvider},set coverageProvider(V){N.coverageProvider=V},enqueued:K(V=>{this.proxy.$updateTestStateInRun(A,$,d.TestId.fromExtHostTestItem(V,M).toString(),1)}),skipped:K(V=>{this.proxy.$updateTestStateInRun(A,$,d.TestId.fromExtHostTestItem(V,M).toString(),5)}),started:K(V=>{this.proxy.$updateTestStateInRun(A,$,d.TestId.fromExtHostTestItem(V,M).toString(),2)}),errored:K((V,q,Y)=>{z(V,q),this.proxy.$updateTestStateInRun(A,$,d.TestId.fromExtHostTestItem(V,M).toString(),6,Y)}),failed:K((V,q,Y)=>{z(V,q),this.proxy.$updateTestStateInRun(A,$,d.TestId.fromExtHostTestItem(V,M).toString(),4,Y)}),passed:K((V,q)=>{this.proxy.$updateTestStateInRun(A,$,d.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,q)}),appendOutput:(V,q,Y)=>{O||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(A,$,t.VSBuffer.fromString(V),q&&b.location.from(q),Y&&d.TestId.fromExtHostTestItem(Y,M).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(A,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:x,coverage:N}),this.proxy.$startedTestRunTask(A,{id:$,name:B,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(B){if(!(B instanceof w.TestItemImpl))throw new p.InvalidTestItemError(B.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const A=[],M=this.dto.colllection.root;for(;;){const $=b.TestItem.from(B);if(A.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),B===M))break;B=B.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class o{constructor(B){this.proxy=B,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(B,A,M){return this.getTracker(B,A,M)}cancelRunById(B){for(const A of this.tracked.values())if(A.id===B){A.dispose();return}}cancelAllRuns(){for(const B of this.tracked.values())B.dispose()}createTestRun(B,A,M,$,N){const K=this.tracked.get(M);if(K)return K.createRun($);const z=r.fromPublic(B,A,M,N),O=i(M);this.proxy.$startedExtensionTestRun({controllerId:B,profile:O&&{group:L[O.kind],id:O.profileId},exclude:M.exclude?.map(V=>d.TestId.fromExtHostTestItem(V,A.root.id).toString())??[],id:z.id,include:M.include?.map(V=>d.TestId.fromExtHostTestItem(V,A.root.id).toString())??[A.root.id],persist:N});const x=this.getTracker(M,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun($)}getTracker(B,A,M){const $=new u(A,this.proxy,M);return this.tracked.set(B,$),$.onEnd(()=>this.tracked.delete(B)),$}}e.TestRunCoordinator=o;const i=U=>{if(!!U.profile){if(!(U.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class r{constructor(B,A,M,$,N,K){this.controllerId=B,this.id=A,this.isPersisted=N,this.colllection=K,this.includePrefix=M.map(z=>z+"\0"),this.excludePrefix=$.map(z=>z+"\0")}static fromPublic(B,A,M,$){return new r(B,(0,k.generateUuid)(),M.include?.map(N=>d.TestId.fromExtHostTestItem(N,B).toString())??[B],M.exclude?.map(N=>d.TestId.fromExtHostTestItem(N,B).toString())??[],$,A)}static fromInternal(B,A){return new r(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,A)}isIncluded(B){const A=d.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(A===M||A.startsWith(M))return!1;for(const M of this.includePrefix)if(A===M||A.startsWith(M))return!0;return!1}}e.TestRunDto=r;class n{constructor(B,A,M){this.proxy=B,this.runId=A,this.taskId=M}set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(b.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(B,A){const M=await this.fileCoverage;let $=M?.[B];return!this._coverageProvider||!M||!$?[]:($.detailedCoverage||($=M[B]=await this._coverageProvider.resolveFileCoverage?.($,A)??$),$.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class c extends f.IncrementalChangeCollector{constructor(B){super(),this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(B){this.added.add(B)}update(B){Object.assign(B.revived,b.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}if(this.updated.delete(B),B.parent&&this.alreadyRemoved.has(B.parent)){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:A,removed:M}=this;return{get added(){return[...B].map($=>$.revived)},get updated(){return[...A].map($=>$.revived)},get removed(){return[...M].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,A){return{...B,revived:b.TestItem.toPlain(B.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=h;class m{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(A=>A.revived)},dispose:(0,_.once)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}class C{constructor(B,A,M,$,N,K,z,O=!1,x=void 0){this.controllerId=M,this.profileId=$,this._label=N,this.kind=K,this.runHandler=z,this._isDefault=O,this._tag=x,a.set(this,void 0),g.set(this,void 0),tt(this,a,B,"f"),tt(this,g,A,"f"),A.set($,this);const V=L[K];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Ue(this,a,"f").$publishTestRunProfile({profileId:$,controllerId:M,tag:x?b.TestTag.namespace(this.controllerId,x.id):null,label:N,group:V,isDefault:O,hasConfigurationHandler:!1})}get label(){return this._label}set label(B){B!==this._label&&(this._label=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get isDefault(){return this._isDefault}set isDefault(B){B!==this._isDefault&&(this._isDefault=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?b.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}dispose(){Ue(this,g,"f")?.delete(this.profileId)&&(tt(this,g,void 0,"f"),Ue(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,a=new WeakMap,g=new WeakMap;const L={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(De[258],Ie([1,0,17,4,5,133,16,7]),function(J,e,l,t,D,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(R,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const k=this._extHostDocumentsAndEditors.allEditors();return R?k:k.map(S=>S.value)}async showTextDocument(R,k,S){let T;typeof k=="number"?T={position:_.ViewColumn.from(k),preserveFocus:S}:typeof k=="object"?T={position:_.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?_.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(R.uri,T),b=w&&this._extHostDocumentsAndEditors.getEditor(w);if(b)return b.value;throw w?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new P.TextEditorDecorationType(this._proxy,R,k).value}$acceptEditorPropertiesChanged(R,k){const S=this._extHostDocumentsAndEditors.getEditor(R);if(!S)throw new Error("unknown text editor");if(k.options&&S._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(_.Selection.to);S._acceptSelections(T)}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(_.Range.to));S._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...k.options,lineNumbers:_.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=y.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:w,kind:T})}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:T})}}$acceptEditorPositionData(R){for(const k in R){const S=this._extHostDocumentsAndEditors.getEditor(k);if(!S)throw new Error("Unknown text editor");const T=_.ViewColumn.to(R[k]);S.value.viewColumn!==T&&(S._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:T}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=E}),define(De[259],Ie([1,0,2,3,5,6,7,16,13]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(S,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(D.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const b=w.uri===void 0?void 0:l.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(R(b))?.get(w.handle)}return w}})}async $getTimeline(S,T,w,b){return this._providers.get(S)?.provideTimeline(l.URI.revive(T),w,b)}registerTimelineProvider(S,T,w,b){const v=new P.DisposableStore,d=this.convertTimelineItem(T.id,b,v).bind(this);let p;T.onDidChange&&(p=T.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:T.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:S,onDidChange:void 0,async provideTimeline(a,g,s){g?.resetCache&&(v.clear(),f.get(T.id)?.clear());const u=await T.provideTimeline(a,g,s);if(u==null)return;const o=d(a,g);return{...u,source:T.id,items:u.items.map(o)}},dispose(){for(const a of f.values())a.get(T.id)?.clear();p?.dispose(),v.dispose()}})}convertTimelineItem(S,T,w){return(b,v)=>{let d;if(v?.cacheResults){let p=this._itemsBySourceAndUriMap.get(S);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(S,p));const f=R(b);d=p.get(f),d===void 0&&(d=new Map,p.set(f,d))}return p=>{const{iconPath:f,...a}=p,g=`${S}|${p.id??p.timestamp}`;d?.set(g,p);let s,u,o;p.iconPath&&(f instanceof _.ThemeIcon?o={id:f.id,color:f.color}:l.URI.isUri(f)?(s=f,u=f):{light:s,dark:u}=f);let i;return _.MarkdownString.isMarkdownString(a.tooltip)?i=y.MarkdownString.from(a.tooltip):(0,E.isString)(a.tooltip)?i=a.tooltip:_.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=y.MarkdownString.from(a.detail)):(0,E.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=a.detail),{...a,id:a.id??void 0,handle:g,source:S,command:p.command?T.toInternal(p.command,w):void 0,icon:s,iconDark:u,themeIcon:o,tooltip:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=I;function R(k){return k?.toString()}}),define(De[260],Ie([1,0,6,12,2,5]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(E){this._openers=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,I,R,k){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const S=k.schemes.find(T=>!_.supportedSchemes.has(T));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,R),this._proxy.$registerUriOpener(I,k.schemes,E,k.label),(0,l.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(E,I,R){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const S=D.URI.revive(I);return k.canOpenExternalUri(S,R)}async $openUri(E,I,R){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},R)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[261],Ie([1,0,5,2,6,10,27]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(I,R){if(this.handles.has(_.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=y.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(I)),this.handlers.set(k,R),this._proxy.$registerUriHandler(k,I),(0,D.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(I)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(I,R){const k=this.handlers.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(R))}catch(S){(0,P.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(I){return t.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=y,y.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[70],Ie([1,0,4,12,2,187,207,88,5]),function(J,e,l,t,D,P,_,y,E){"use strict";var I,R,k,S,T,w,b,v,d,p,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(h,m,C,L,U,B,A){I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,""),v.set(this,void 0),d.set(this,!1),p.set(this,!1),f.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new l.Emitter),this._onDidDispose=Ue(this,a,"f").event,tt(this,I,h,"f"),tt(this,R,m,"f"),tt(this,v,C,"f"),tt(this,S,L,"f"),tt(this,T,U,"f"),tt(this,w,B,"f"),tt(this,f,s(B),"f"),tt(this,k,A,"f")}dispose(){tt(this,d,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return tt(this,p,!0,"f"),(0,y.asWebviewUri)(h,Ue(this,S,"f"))}get cspSource(){const h=Ue(this,w,"f").extensionLocation;if(h.scheme===t.Schemas.https||h.scheme===t.Schemas.http){let m=h.toString();return m.endsWith("/")||(m+="/"),m+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,b,"f")}set html(h){this.assertNotDisposed(),Ue(this,b,"f")!==h&&(tt(this,b,h,"f"),!Ue(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(tt(this,p,!0,"f"),Ue(this,k,"f").report("Webview vscode-resource: uris",Ue(this,w,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,R,"f").$setHtml(Ue(this,I,"f"),h))}get options(){return this.assertNotDisposed(),Ue(this,v,"f")}set options(h){this.assertNotDisposed(),Ue(this,R,"f").$setOptions(Ue(this,I,"f"),i(Ue(this,w,"f"),Ue(this,T,"f"),h)),tt(this,v,h,"f")}async postMessage(h){if(Ue(this,d,"f"))return!1;const m=(0,_.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ue(this,f,"f")});return Ue(this,R,"f").$postMessage(Ue(this,I,"f"),m.message,...m.buffers)}assertNotDisposed(){if(Ue(this,d,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,I=new WeakMap,R=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,d=new WeakMap,p=new WeakMap,f=new WeakMap,a=new WeakMap;function s(c){try{const h=(0,P.normalizeVersion)((0,P.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class u{constructor(h,m,C,L,U){this.remoteInfo=m,this.workspace=C,this._logService=L,this._deprecationService=U,this._webviews=new Map,this._webviewProxy=h.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(h,m,C){const L=this.getWebview(h);if(L){const{message:U}=(0,_.deserializeWebviewMessage)(m,C.value);L._onMessageEmitter.fire(U)}}$onMissingCsp(h,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,m,C){const L=new g(h,this._webviewProxy,r(m),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(h,L),L._onDidDispose(()=>{this._webviews.delete(h)}),L}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=u;function o(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=o;function i(c,h,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||n(c,h)}}e.serializeWebviewOptions=i;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(h=>D.URI.from(h))}}e.reviveOptions=r;function n(c,h){return[...(h?.getWorkspaceFolders()||[]).map(m=>m.uri),c.extensionLocation]}}),define(De[262],Ie([1,0,21,61,6,12,22,2,16,70,87,5,7]),function(J,e,l,t,D,P,_,y,E,I,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(s,u){this.document=s,this._storagePath=u,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,u){await this.getEdit(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.getEdit(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=a(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const u=this._edits.get(s,0);if(!u)throw new Error("No edit found");return u}}class w{constructor(){this._documents=new Map}get(s,u){return this._documents.get(this.key(s,u))}add(s,u,o){const i=this.key(s,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const r=new T(u,o);return this._documents.set(i,r),r}delete(s,u){const o=this.key(s,u.uri);this._documents.delete(o)}key(s,u){return`${s}@@@${u}`}}var b;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(b||(b={}));class v{constructor(){this._providers=new Map}addTextProvider(s,u,o){return this.add(0,s,u,o)}addCustomProvider(s,u,o){return this.add(1,s,u,o)}get(s){return this._providers.get(s)}add(s,u,o,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:s,extension:o,provider:i}),new S.Disposable(()=>this._providers.delete(u))}}class d{constructor(s,u,o,i,r){this._extHostDocuments=u,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new w,this._proxy=s.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,o,i){const r=new D.DisposableStore;return p(o)?(r.add(this._editorProviders.addTextProvider(u,s,o)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(s),u,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(s))):(r.add(this._editorProviders.addCustomProvider(u,s,o)),this.supportEditing(o)&&r.add(o.onDidChangeCustomDocument(n=>{const c=this.getCustomDocumentEntry(u,n.document.uri);if(f(n)){const h=c.addEdit(n);this._proxy.$onDidEdit(n.document.uri,u,h,n.label)}else this._proxy.$onContentChange(n.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(s),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(s))),S.Disposable.from(r,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,o,i,r){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${u}'`);const c=y.URI.revive(s),h=await n.provider.openCustomDocument(c,{backupId:o,untitledDocumentData:i?.buffer},r);let m;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(u,h,m),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(s,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=y.URI.revive(s),{document:r}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,r),r.dispose()}async $resolveWebviewEditor(s,u,o,i,r,n){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);const h=E.ViewColumn.to(r),m=this._extHostWebview.createNewWebview(u,i.webviewOptions,c.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(u,o,i.title,h,i.panelOptions,m,!0),L=y.URI.revive(s);switch(c.type){case 1:{const{document:U}=this.getCustomDocumentEntry(o,L);return c.provider.resolveCustomEditor(U,C,n)}case 0:{const U=this._extHostDocuments.getDocument(L);return c.provider.resolveCustomTextEditor(U,C,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,o){this.getCustomDocumentEntry(u,s).disposeEdits(o)}async $onMoveCustomEditor(s,u,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const r=this._extHostWebviewPanels.getWebviewPanel(s);if(!r)throw new Error("No webview found");const n=y.URI.revive(u),c=this._extHostDocuments.getDocument(n);await i.provider.moveCustomTextEditor(c,r,l.CancellationToken.None)}async $undo(s,u,o,i){return this.getCustomDocumentEntry(u,s).undo(o,i)}async $redo(s,u,o,i){return this.getCustomDocumentEntry(u,s).redo(o,i)}async $revert(s,u,o){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(s,u,o){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(s,u,o,i){const r=this.getCustomDocumentEntry(u,s);return this.getCustomEditorProvider(u).saveCustomDocumentAs(r.document,y.URI.revive(o),i)}async $backup(s,u,o){const i=this.getCustomDocumentEntry(u,s),n=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(n),n.id}getCustomDocumentEntry(s,u){const o=this._documents.get(s,y.URI.revive(u));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(s){const o=this._editorProviders.get(s)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=d;function p(g){return typeof g.resolveCustomTextEditor=="function"}function f(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function a(g){const s=g.scheme===P.Schemas.file||g.scheme===P.Schemas.untitled?g.fsPath:g.toString();return(0,t.hash)(s)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[263],Ie([1,0,4,6,2,34,16,70,5,7]),function(J,e,l,t,D,P,_,y,E,I){"use strict";var R,k,S,T,w,b,v,d,p,f,a,g,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(n,c,h,m){super(),R.set(this,void 0),k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,void 0),v.set(this,void 0),d.set(this,void 0),p.set(this,!0),f.set(this,void 0),a.set(this,!1),g.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,g,"f").event,s.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Ue(this,s,"f").event,tt(this,R,n,"f"),tt(this,k,c,"f"),tt(this,T,h,"f"),tt(this,S,m.viewType,"f"),tt(this,w,m.panelOptions,"f"),tt(this,d,m.viewColumn,"f"),tt(this,b,m.title,"f"),tt(this,f,m.active,"f")}dispose(){Ue(this,a,"f")||(tt(this,a,!0,"f"),Ue(this,g,"f").fire(),Ue(this,k,"f").$disposeWebview(Ue(this,R,"f")),Ue(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,S,"f")}get title(){return this.assertNotDisposed(),Ue(this,b,"f")}set title(n){this.assertNotDisposed(),Ue(this,b,"f")!==n&&(tt(this,b,n,"f"),Ue(this,k,"f").$setTitle(Ue(this,R,"f"),n))}get iconPath(){return this.assertNotDisposed(),Ue(this,v,"f")}set iconPath(n){this.assertNotDisposed(),Ue(this,v,"f")!==n&&(tt(this,v,n,"f"),Ue(this,k,"f").$setIconPath(Ue(this,R,"f"),D.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Ue(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,d,"f")=="number"&&Ue(this,d,"f")<0))return Ue(this,d,"f")}get active(){return this.assertNotDisposed(),Ue(this,f,"f")}get visible(){return this.assertNotDisposed(),Ue(this,p,"f")}_updateViewState(n){Ue(this,a,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(tt(this,f,n.active,"f"),tt(this,p,n.visible,"f"),tt(this,d,n.viewColumn,"f"),Ue(this,s,"f").fire({webviewPanel:this}))}reveal(n,c){this.assertNotDisposed(),Ue(this,k,"f").$reveal(Ue(this,R,"f"),{viewColumn:typeof n>"u"?void 0:_.ViewColumn.from(n),preserveFocus:!!c})}assertNotDisposed(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,d=new WeakMap,p=new WeakMap,f=new WeakMap,a=new WeakMap,g=new WeakMap,s=new WeakMap;class o{constructor(n,c,h){this.webviews=c,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(n,c,h,m,C={}){const L=typeof m=="object"?m.viewColumn:m,U={viewColumn:_.ViewColumn.from(L),preserveFocus:typeof m=="object"&&!!m.preserveFocus},B=(0,y.shouldSerializeBuffersForPostMessage)(n),A=o.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(n),A,c,{title:h,panelOptions:i(C),webviewOptions:(0,y.serializeWebviewOptions)(n,this.workspace,C),serializeBuffersForPostMessage:B},U);const M=this.webviews.createNewWebview(A,C,n);return this.createNewWebviewPanel(A,c,h,L,C,M,!0)}$onDidChangeWebviewPanelViewStates(n){const c=Object.keys(n);c.sort((h,m)=>{const C=n[h],L=n[m];return C.active?1:L.active?-1:+C.visible-+L.visible});for(const h of c){const m=this.getWebviewPanel(h);if(!m)continue;const C=n[h];m._updateViewState({active:C.active,visible:C.visible,viewColumn:_.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,c,h){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:h,extension:n}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(n)}),new I.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(n,c,h,m){const C=this._serializers.get(c);if(!C)throw new Error(`No serializer found for '${c}'`);const{serializer:L,extension:U}=C,B=this.webviews.createNewWebview(n,h.webviewOptions,U),A=this.createNewWebviewPanel(n,c,h.title,m,h.panelOptions,B,h.active);await L.deserializeWebviewPanel(A,h.state)}createNewWebviewPanel(n,c,h,m,C,L,U){const B=new u(n,this._proxy,L,{viewType:c,title:h,viewColumn:m,panelOptions:C,active:U});return this._webviewPanels.set(n,B),B}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=o;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[264],Ie([1,0,4,6,70,16,5,7]),function(J,e,l,t,D,P,_,y){"use strict";var E,I,R,k,S,T,w,b,v,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends t.Disposable{constructor(s,u,o,i,r,n,c){super(),E.set(this,void 0),I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),S.set(this,!1),T.set(this,void 0),w.set(this,void 0),b.set(this,void 0),v.set(this,void 0),d.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Ue(this,d,"f").event,p.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,p,"f").event,tt(this,R,o,"f"),tt(this,w,i,"f"),tt(this,E,s,"f"),tt(this,I,u,"f"),tt(this,k,r,"f"),tt(this,T,c,"f")}dispose(){Ue(this,S,"f")||(tt(this,S,!0,"f"),Ue(this,p,"f").fire(),Ue(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,w,"f")}set title(s){this.assertNotDisposed(),Ue(this,w,"f")!==s&&(tt(this,w,s,"f"),Ue(this,I,"f").$setWebviewViewTitle(Ue(this,E,"f"),s))}get description(){return this.assertNotDisposed(),Ue(this,b,"f")}set description(s){this.assertNotDisposed(),Ue(this,b,"f")!==s&&(tt(this,b,s,"f"),Ue(this,I,"f").$setWebviewViewDescription(Ue(this,E,"f"),s))}get visible(){return Ue(this,T,"f")}get webview(){return Ue(this,k,"f")}get viewType(){return Ue(this,R,"f")}_setVisible(s){s===Ue(this,T,"f")||Ue(this,S,"f")||(tt(this,T,s,"f"),Ue(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),Ue(this,v,"f")}set badge(s){this.assertNotDisposed(),!(s?.value===Ue(this,v,"f")?.value&&s?.tooltip===Ue(this,v,"f")?.tooltip)&&(tt(this,v,P.ViewBadge.from(s),"f"),Ue(this,I,"f").$setWebviewViewBadge(Ue(this,E,"f"),s))}show(s){this.assertNotDisposed(),Ue(this,I,"f").$show(Ue(this,E,"f"),!!s)}assertNotDisposed(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,I=new WeakMap,R=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,d=new WeakMap,p=new WeakMap;class a{constructor(s,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,u,o,i){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:o,extension:s}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(s),u,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(s)}),new y.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(s,u,o,i,r){const n=this._viewProviders.get(u);if(!n)throw new Error(`No view provider found for '${u}'`);const{provider:c,extension:h}=n,m=this._extHostWebview.createNewWebview(s,{},h),C=new f(s,this._proxy,u,o,m,h,!0);this._webviewViews.set(s,C),await c.resolveWebviewView(C,{state:i},r)}async $onDidChangeWebviewViewVisibility(s,u){this.getWebviewView(s)._setVisible(u)}async $disposeWebviewView(s){const u=this.getWebviewView(s);this._webviewViews.delete(s),u.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const u=this._webviewViews.get(s);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=a}),define(De[138],Ie([1,0,4,5,2,12,8,3,15]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Jn{constructor(k){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Jn.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,S){let T;if(typeof k=="string"){T=k;try{k=D.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,_.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,S)}async asExternalUri(k,S){if((0,_.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,S);return D.URI.from(T)}};I.InitialState={focused:!0},I=qe([xe(0,E.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(De[265],Ie([1,0,112,266,63,37,2,14,45]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(S,T,w){this._commands=S,this.logService=T,this._ipcHandlePath=w,this._server=t.createServer((b,v)=>this.onRequest(b,v)),this.setup().catch(b=>(T.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,T){const w=(v,d)=>{T.writeHead(v,{"content-type":"application/json"}),T.end(JSON.stringify(d||null),p=>p&&this.logService.error(p))},b=[];S.setEncoding("utf8"),S.on("data",v=>b.push(v)),S.on("end",async()=>{try{const v=JSON.parse(b.join(""));let d;switch(v.type){case"open":d=await this.open(v);break;case"openExternal":d=await this.openExternal(v);break;case"status":d=await this.getStatus(v);break;case"extensionManagement":d=await this.manageExtensions(v);break;default:w(404,`Unknown message type: ${v.type}`);break}w(200,d)}catch(v){const d=v instanceof Error?v.message:JSON.stringify(v);w(500,d),this.logService.error("Error while processing pipe request",v)}})}async open(S){const{fileURIs:T,folderURIs:w,forceNewWindow:b,diffMode:v,mergeMode:d,addMode:p,forceReuseWindow:f,gotoLineMode:a,waitMarkerFilePath:g,remoteAuthority:s}=S,u=[];if(Array.isArray(w))for(const n of w)try{u.push({folderUri:_.URI.parse(n)})}catch{}if(Array.isArray(T))for(const n of T)try{(0,E.hasWorkspaceFileExtension)(n)?u.push({workspaceUri:_.URI.parse(n)}):u.push({fileUri:_.URI.parse(n)})}catch{}const o=g?_.URI.file(g):void 0,r={forceNewWindow:b,diffMode:v,mergeMode:d,addMode:p,gotoLineMode:a,forceReuseWindow:f,preferNewWindow:!f&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:s};return this._commands.executeCommand("_remoteCLI.windowOpen",u,r),""}async openExternal(S){for(const T of S.uris){const w=_.URI.parse(T),b=w.scheme==="file"?w:T;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(S){const T=b=>b?.map(v=>/\.vsix$/i.test(v)?_.URI.parse(v):v),w={list:S.list,install:T(S.install),uninstall:T(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let R=class extends I{constructor(S,T){super(S,T,(0,l.createRandomIPCHandle)())}};R=qe([xe(0,P.IExtHostCommands),xe(1,y.ILogService)],R),e.CLIServer=R}),define(De[267],Ie([1,0,239,26,15]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let _=class extends l.AbstractExtHostConsoleForwarder{constructor(E,I){super(E,I),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(E,I,R){const k=E==="error"||E==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,R),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(E,I){const R=process[E],k=R.write;let S="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(T,w,b)=>{if(!this._isMakingConsoleCall){S+=T.toString(w);const v=S.length>P?S.length:S.lastIndexOf(`
`);v!==-1&&(console[I](S.slice(0,v)),S=S.slice(v+1))}k.call(R,T,w,b)}})}};_=qe([xe(0,D.IExtHostRpcService),xe(1,t.IExtHostInitDataService)],_),e.ExtHostConsoleForwarder=_}),define(De[268],Ie([1,0,9,81,34,37,6,5,2,15]),function(J,e,l,t,D,P,_,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends _.Disposable{constructor(S,T){super();const w=S.getProxy(y.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async b=>{const v=E.URI.file((0,l.join)((0,t.tmpdir)(),(0,D.generateUuid)()));return await w.$download(b,v),v})}};R=qe([xe(0,I.IExtHostRpcService),xe(1,P.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(De[269],Ie([1,0,136,12,193,34]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class _ extends l.ExtHostLoggerService{doCreateLogger(E,I,R){return E.scheme===t.Schemas.file?new D.SpdLogLogger(R?.name||(0,P.generateUuid)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,I):super.doCreateLogger(E,I,R)}}e.ExtHostLoggerService=_}),define(De[270],Ie([1,0,63,9,2,69,6,12,18,29]),function(J,e,l,t,D,P,_,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const u=await super._getWorkspaceStorageURI(s);if(u.scheme!==y.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const o=u.fsPath;let i=0;do{let r;i===0?r=o:r=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await k(r);const n=t.join(r,"vscode.lock"),c=await b(this._logService,n,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),D.URI.file(r);i++}while(i<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function k(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const S=1e3,T=10*60*1e3;class w extends _.Disposable{constructor(s,u){super(),this.logService=s,this.filename=u,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await v(s,u);(!o||o.pid!==process.pid)&&(s.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(u,new Date,new Date)}catch(i){s.error(i),s.info(`Lock '${u}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+s};await I.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function b(g,s,u){try{const i={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(s,JSON.stringify(i),{flag:"wx"})}catch(i){g.error(i)}const o=await v(g,s);return!o||o.pid!==process.pid?u?(g.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),f(g,s)):(g.info(`Lock '${s}': Lock acquired.`),new w(g,s))}async function v(g,s){let u;try{u=await I.Promises.readFile(s)}catch(o){return g.error(o),null}try{return JSON.parse(String(u))}catch(o){return g.error(o),null}}async function d(g,s){let u;try{u=await I.Promises.stat(s)}catch(o){return g.error(o),0}return u.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function f(g,s){const u=await v(g,s);if(!u)return g.info(`Lock '${s}': Could not read pid of lock holder.`),a(g,s);if(u.willReleaseAt){let c=u.willReleaseAt-Date.now();if(c<5e3){for(c>0?g.info(`Lock '${s}': The lockfile is scheduled to be released in ${c} ms.`):g.info(`Lock '${s}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,E.timeout)(Math.min(100,c)),await d(g,s)===0)return a(g,s);c=u.willReleaseAt-Date.now()}return a(g,s)}}if(!p(u.pid))return g.info(`Lock '${s}': The pid ${u.pid} appears to be gone.`),a(g,s);const o=await d(g,s),i=Date.now()-o;if(i<=T)return g.info(`Lock '${s}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;g.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const r=await d(g,s),n=Date.now()-r;return n<=T?(g.info(`Lock '${s}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(g.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),a(g,s))}async function a(g,s){g.info(`Lock '${s}': Deleting a stale lock.`);try{await I.Promises.unlink(s)}catch{}return b(g,s,!0)}}),define(De[271],Ie([1,0,34,15,38]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends D.BaseExtHostTerminalService{constructor(y){super(!0,y)}createTerminal(y,E,I){return this.createTerminalFromOptions({name:y,shellPath:E,shellArgs:I})}createTerminalFromOptions(y,E){const I=new D.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),y,y.name);return this._terminals.push(I),I.create(y,this._serializeParentTerminal(y,E)),I.value}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[272],Ie([1,0,5,15,177,6,26,2,44,22,29,7,11,53,4,123,94,14]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p extends b.DisposableTunnel{}function f(c){const h=c.trim().split(`
`),m=[];return h.forEach(L=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);U&&U.length>=3&&m.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),m.reduce((L,U)=>(L[U.socket]=U,L),{})}e.getSockets=f;function a(...c){const h=[].concat(...c.map(s));return[...new Map(h.filter(m=>m.st==="0A").map(m=>{const C=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:g(C[0]),port:parseInt(C[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=a;function g(c){let h="";if(c.length===8)for(let m=c.length-2;m>=0;m-=2)h+=parseInt(c.substr(m,2),16),m!==0&&(h+=".");else for(let m=c.length-4;m>=0;m-=4)h+=parseInt(c.substr(m,4),16).toString(16),m!==0&&(h+=":");return h}e.parseIpAddress=g;function s(c){const h=c.trim().split(`
`),m=h.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return h.map(L=>L.trim().split(/\s+/).reduce((U,B,A)=>(U[m[A]||A]=B,U),{}))}e.loadConnectionTable=s;function u(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function o(c){const h=c.trim().split(`
`),m=[];return h.forEach(C=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(C);L&&L.length>=4&&m.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),m}e.getRootProcesses=o;async function i(c,h,m){const C=m.reduce((U,B)=>(U[B.pid]=B,U),{}),L=[];return c.forEach(({socket:U,ip:B,port:A})=>{const M=h[U]?h[U].pid:void 0,$=M?C[M]?.cmd:void 0;M&&$&&!u($)&&L.push({host:B,port:A,detail:$,pid:M})}),L}e.findPorts=i;function r(c,h,m){const C=new Map,L=o(h);for(const U of c){const B=m.get(U.port);if(B){C.set(U.port,B);continue}const A=L.find(M=>M.cmd.includes(`${U.port}`));if(A){let M=A,$;do $=L.find(N=>N.ppid===M.pid),$&&(M=$);while($);C.set(U.port,{host:U.ip,port:U.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else C.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return C}e.tryFindRootPorts=r;let n=class extends P.Disposable{constructor(h,m,C){super(),this.logService=C,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(l.MainContext.MainThreadTunnelService),S.isLinux&&m.remote.isRemote&&m.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const C=await this._proxy.$openTunnel(m,h.displayName);if(C){const L=new p(C.remoteAddress,C.localAddress,()=>this._proxy.$closeTunnel(C.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,m){const C=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(C,{selector:h,provider:m}),this._proxy.$registerPortsAttributesProvider(h,C),new k.Disposable(()=>{this._portAttributesProviders.delete(C),this._proxy.$unregisterPortsAttributesProvider(C)})}async $providePortAttributes(h,m,C,L,U){const B=[];for(const M of h){const $=this._portAttributesProviders.get(M);if(!$)return[];B.push(...await Promise.all(m.map(async N=>$.provider.providePortAttributes(N,C,L,U))))}const A=B.filter(M=>!!M);return A.length>0?A.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;const m=new v.MovingAverage;let C;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),U=(await this.findCandidatePorts()).filter(A=>(0,b.isLocalhost)(A.host)||(0,b.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(A=>A.port).join(", ")}`);const B=new Date().getTime()-L;m.update(B),(!C||JSON.stringify(C)!==JSON.stringify(U))&&(C=U,await this._proxy.$onFoundNewCandidates(C)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(m.value)))}}async setTunnelFactory(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let m=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const C=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:m}:void 0;this._proxy.$setTunnelProvider(C)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,m){if(this._extensionTunnels.has(h.host)){const C=this._extensionTunnels.get(h.host);C.has(h.port)&&(m&&C.get(h.port).disposeListener.dispose(),await C.get(h.port).tunnel.dispose(),C.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const C=this._forwardPortProvider(h,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),C!==void 0){const L=await C;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const U=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:L,disposeListener:U}),T.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const m=await Promise.all(h.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),C=h.filter((L,U)=>m[U]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(L=>L.port).join(", ")} to ${C.map(L=>L.port).join(", ")}`),C}async findCandidatePorts(){let h="",m="";try{h=await R.Promises.readFile("/proc/net/tcp","utf8"),m=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const C=a(h,m),L=await new Promise(z=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,x,V)=>{z(x)})}),U=f(L),B=await R.Promises.readdir("/proc"),A=[];for(const z of B)try{const O=Number(z),x=I.joinPath(y.URI.file("/proc"),z);if((await R.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(O)){const q=await R.Promises.readlink(I.joinPath(x,"cwd").fsPath),Y=await R.Promises.readFile(I.joinPath(x,"cmdline").fsPath,"utf8");A.push({pid:O,cwd:q,cmd:Y})}}catch{}const M=[],$=C.filter(z=>{const O=U[z.socket];return O||M.push(z),O}),N=i($,U,A);let K;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(O=>{(0,E.exec)("ps -F -A -l | grep root",(x,V,q)=>{O(V)})});this._foundRootPorts=r(M,z,this._foundRootPorts),K=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.join(", ")}`)}return N.then(z=>K?z.concat(K):z)}};n=qe([xe(0,t.IExtHostRpcService),xe(1,_.IExtHostInitDataService),xe(2,d.ILogService)],n),e.ExtHostTunnelService=n}),define(De[273],Ie([1,0,18,23,21,10,4,6,107,233,55]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(C,L){try{return JSON.stringify(C,L)}catch{return"null"}}const T="$$ref$$",w={[T]:-1};class b{constructor(L,U){this.jsonString=L,this.referencedBuffers=U}}function v(C,L=null,U=!1){const B=[];return{jsonString:(U?S:JSON.stringify)(C,(M,$)=>{if(typeof $>"u")return w;if(typeof $=="object"){if($ instanceof t.VSBuffer){const N=B.push($)-1;return{[T]:N}}if(L)return L(M,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=v;function d(C,L,U){return JSON.parse(C,(B,A)=>{if(A){const M=A[T];if(typeof M=="number")return L[M];if(U&&A.$mid===1)return U.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=d;function p(C,L){return JSON.stringify(C,L)}function f(C){return C?(L,U)=>U&&U.$mid===1?C.transformOutgoing(U):U:null}var a;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends y.Disposable{constructor(L,U=null,B=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=U,this._uriTransformer=B,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,M=R.ProxyIdentifier.count;A<M;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,E.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:U,sid:B}=L;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,B)),this._proxies[U]}_createProxy(L,U){const B={get:(A,M)=>(typeof M=="string"&&!A[M]&&M.charCodeAt(0)===36&&(A[M]=(...$)=>this._remoteCall(L,M,$)),M===o?U:A[M])};return new Proxy(Object.create(null),B)}set(L,U){return this._locals[L.nid]=U,U}assertRegistered(L){for(let U=0,B=L.length;U<B;U++){const A=L[U];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const U=L.byteLength,B=r.read(L,0),A=B.readUInt8(),M=B.readUInt32();switch(A){case 1:case 2:{let{rpcId:$,method:N,args:K}=c.deserializeRequestJSONArgs(B);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(U,M,$,N,K,A===2);break}case 3:case 4:{let{rpcId:$,method:N,args:K}=c.deserializeRequestMixedArgs(B);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(U,M,$,N,K,A===4);break}case 5:{this._logger?.logIncoming(U,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(U,M);break}case 7:{this._receiveReply(U,M,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(U,M,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(U,M,$);break}case 8:{const $=c.deserializeReplyOKVSBuffer(B);this._receiveReply(U,M,$);break}case 11:{let $=c.deserializeReplyErrError(B);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(U,M,$);break}case 12:{this._receiveReplyErr(U,M,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,U,B,A,M,$){this._logger?.logIncoming(L,U,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(B)}.${A}(`,M);const N=String(U);let K,z;if($){const x=new D.CancellationTokenSource;M.push(x.token),K=this._invokeHandler(B,A,M),z=()=>x.cancel()}else K=this._invokeHandler(B,A,M),z=s;this._cancelInvokedHandlers[N]=z;const O=c.serializeAcknowledged(U);this._logger?.logOutgoing(O.byteLength,U,1,"ack"),this._protocol.send(O),K.then(x=>{delete this._cancelInvokedHandlers[N];const V=c.serializeReplyOK(U,x,this._uriReplacer);this._logger?.logOutgoing(V.byteLength,U,1,"reply:",x),this._protocol.send(V)},x=>{delete this._cancelInvokedHandlers[N];const V=c.serializeReplyErr(U,x);this._logger?.logOutgoing(V.byteLength,U,1,"replyErr:",x),this._protocol.send(V)})}_receiveCancel(L,U){this._logger?.logIncoming(L,U,1,"receiveCancel");const B=String(U);this._cancelInvokedHandlers[B]?.()}_receiveReply(L,U,B){this._logger?.logIncoming(L,U,0,"receiveReply:",B);const A=String(U);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const M=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],M.resolveOk(B)}_receiveReplyErr(L,U,B){this._logger?.logIncoming(L,U,0,"receiveReplyErr:",B);const A=String(U);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const M=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),M.resolveErr($)}_invokeHandler(L,U,B){try{return Promise.resolve(this._doInvokeHandler(L,U,B))}catch(A){return Promise.reject(A)}}_doInvokeHandler(L,U,B){const A=this._locals[L];if(!A)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const M=A[U];if(typeof M!="function")throw new Error("Unknown method "+U+" on actor "+(0,R.getStringIdentifierForProxy)(L));return M.apply(A,B)}_remoteCall(L,U,B){if(this._isDisposed)return new I.CanceledLazyPromise;let A=null;if(B.length>0&&D.CancellationToken.isCancellationToken(B[B.length-1])&&(A=B.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const M=c.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,N=String($),K=new I.LazyPromise;A&&A.onCancellationRequested(()=>{const O=c.serializeCancel($);this._logger?.logOutgoing(O.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[N]=K,this._onWillSendRequest($);const z=c.serializeRequest($,L,U,M,!!A);return this._logger?.logOutgoing(z.byteLength,$,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${U}(`,B),this._protocol.send(z),K}}e.RPCProtocol=i,k=u,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(L,U){this._buff=L,this._offset=U}static alloc(L,U,B){const A=new r(t.VSBuffer.alloc(B+1+4),0);return A.writeUInt8(L),A.writeUInt32(U),A}static read(L,U){return new r(L,U)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,B}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,B}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,U}static sizeMixedArray(L){let U=0;U+=1;for(let B=0,A=L.length;B<A;B++){const M=L[B];switch(U+=1,M.type){case 1:U+=this.sizeLongString(M.value);break;case 2:U+=this.sizeVSBuffer(M.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(M.value);for(let $=0;$<M.buffers.length;++$)U+=this.sizeVSBuffer(M.buffers[$]);break;case 4:break}}return U}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let U=0,B=L.length;U<B;U++){const A=L[U];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let M=0;M<A.buffers.length;++M)this.writeBuffer(A.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const U=new Array(L);for(let B=0;B<L;B++)switch(this.readUInt8()){case 1:U[B]=this.readLongString();break;case 2:U[B]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),$=this.readLongString(),N=[];for(let K=0;K<M;++K)N.push(this.readVSBuffer());U[B]=new R.SerializableObjectWithBuffers(d($,N,null));break}case 4:U[B]=void 0;break}return U}}r.sizeUInt32=4;var n;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(n||(n={}));class c{static _useMixedArgSerialization(L){for(let U=0,B=L.length;U<B;U++)if(L[U]instanceof t.VSBuffer||L[U]instanceof R.SerializableObjectWithBuffers||typeof L[U]>"u")return!0;return!1}static serializeRequestArguments(L,U){if(this._useMixedArgSerialization(L)){const B=[];for(let A=0,M=L.length;A<M;A++){const $=L[A];if($ instanceof t.VSBuffer)B[A]={type:2,value:$};else if(typeof $>"u")B[A]={type:4};else if($ instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:K}=v($.value,U);B[A]={type:3,value:t.VSBuffer.fromString(N),buffers:K}}else B[A]={type:1,value:t.VSBuffer.fromString(p($,U))}}return{type:1,args:B}}return{type:0,args:p(L,U)}}static serializeRequest(L,U,B,A,M){switch(A.type){case 0:return this._requestJSONArgs(L,U,B,A.args,M);case 1:return this._requestMixedArgs(L,U,B,A.args,M)}}static _requestJSONArgs(L,U,B,A,M){const $=t.VSBuffer.fromString(B),N=t.VSBuffer.fromString(A);let K=0;K+=r.sizeUInt8(),K+=r.sizeShortString($),K+=r.sizeLongString(N);const z=r.alloc(M?2:1,L,K);return z.writeUInt8(U),z.writeShortString($),z.writeLongString(N),z.buffer}static deserializeRequestJSONArgs(L){const U=L.readUInt8(),B=L.readShortString(),A=L.readLongString();return{rpcId:U,method:B,args:JSON.parse(A)}}static _requestMixedArgs(L,U,B,A,M){const $=t.VSBuffer.fromString(B);let N=0;N+=r.sizeUInt8(),N+=r.sizeShortString($),N+=r.sizeMixedArray(A);const K=r.alloc(M?4:3,L,N);return K.writeUInt8(U),K.writeShortString($),K.writeMixedArray(A),K.buffer}static deserializeRequestMixedArgs(L){const U=L.readUInt8(),B=L.readShortString(),A=L.readMixedArray(),M=new Array(A.length);for(let $=0,N=A.length;$<N;$++){const K=A[$];typeof K=="string"?M[$]=JSON.parse(K):M[$]=K}return{rpcId:U,method:B,args:M}}static serializeAcknowledged(L){return r.alloc(5,L,0).buffer}static serializeCancel(L){return r.alloc(6,L,0).buffer}static serializeReplyOK(L,U,B){if(typeof U>"u")return this._serializeReplyOKEmpty(L);if(U instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(L,U);if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:M}=v(U.value,B,!0);return this._serializeReplyOKJSONWithBuffers(L,A,M)}else return this._serializeReplyOKJSON(L,S(U,B))}static _serializeReplyOKEmpty(L){return r.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,U){let B=0;B+=r.sizeVSBuffer(U);const A=r.alloc(8,L,B);return A.writeVSBuffer(U),A.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,U){const B=t.VSBuffer.fromString(U);let A=0;A+=r.sizeLongString(B);const M=r.alloc(9,L,A);return M.writeLongString(B),M.buffer}static _serializeReplyOKJSONWithBuffers(L,U,B){const A=t.VSBuffer.fromString(U);let M=0;M+=r.sizeUInt32,M+=r.sizeLongString(A);for(const N of B)M+=r.sizeVSBuffer(N);const $=r.alloc(10,L,M);$.writeUInt32(B.length),$.writeLongString(A);for(const N of B)$.writeBuffer(N);return $.buffer}static deserializeReplyOKJSON(L){const U=L.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(L,U){const B=L.readUInt32(),A=L.readLongString(),M=[];for(let $=0;$<B;++$)M.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(d(A,M,U))}static serializeReplyErr(L,U){const B=U?S(P.transformErrorForSerialization(U),null):void 0;if(typeof B!="string")return this._serializeReplyErrEmpty(L);const A=t.VSBuffer.fromString(B);let M=0;M+=r.sizeLongString(A);const $=r.alloc(11,L,M);return $.writeLongString(A),$.buffer}static deserializeReplyErrError(L){const U=L.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(L){return r.alloc(12,L,0).buffer}}var h;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var m;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(m||(m={}))}),define(De[274],Ie([1,0,4,43,52,3,42,10,18]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(b=>w.push(b)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new R);function k(T,w,b,v,d){return(0,E.createCancelablePromise)(async p=>{await(0,_.whenProviderRegistered)(b,v);const f=t.Registry.as(e.Extensions.OutputChannels);try{await S(b,1,v,d,p),f.registerChannel({id:T,label:w,file:b,log:!0})}catch(a){(0,y.isCancellationError)(a)||d.error("Error while registering log channel",b.toString(),(0,y.getErrorMessage)(a))}})}e.registerLogChannel=k;async function S(T,w,b,v,d){if(!await b.exists(T)){if(d.isCancellationRequested)throw new y.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");v.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,d),await S(T,w+1,b,v,d)}}}),define(De[139],Ie([1,0,5,6,3,15,14,274,68,26,46,152,23,13]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends t.Disposable{constructor(d,p,f,a){super(),this.id=d,this.name=p,this.logger=f,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Clear,d)}replace(d){const p=this.offset;this.write(d),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Replace,p),this.visible&&this.logger.flush()}show(d,p){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:p))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=S.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let b=class{constructor(d,p,f,a,g){this.extHostFileSystem=f,this.extHostFileSystemInfo=a,this.loggerService=g,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(p.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[p,f]of this.channels)f.visible=p===this.visibleChannelId}createOutputChannel(d,p,f){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(d,p,f);return a.then(g=>{this.channels.set(g.id,g),g.visible=g.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,a)}async doCreateOutputChannel(d,p,f){const a=await this.createOutputDirectory(),g=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(g,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(d,!1,g,p,f.identifier.value);return new w(u,d,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,p){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return d},append(g){a(),p.then(s=>s.append(g))},appendLine(g){a(),p.then(s=>s.appendLine(g))},clear(){a(),p.then(g=>g.clear())},replace(g){a(),p.then(s=>s.replace(g))},show(g,s){a(),p.then(u=>u.show(g,s))},hide(){a(),p.then(g=>g.hide())},dispose(){f=!0,p.then(g=>g.dispose())}}}};b=qe([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,R.IExtHostFileSystemInfo),xe(4,_.ILoggerService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(De[275],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(De[276],Ie([1,0,31,12,9,11,22,2,3,202,45,224,275]),function(J,e,l,t,D,P,_,y,E,I,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class Zn{constructor(b,v,d,p){this.localUserHome=b,this.remoteAgentService=v,this.environmentService=d,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??b})()}hasValidBasename(b,v,d){return typeof v=="string"||typeof v>"u"?this.resolveOS.then(p=>this.doHasValidBasename(b,p,v)):this.doHasValidBasename(b,v,d)}doHasValidBasename(b,v,d){return b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(d??(0,_.basename)(b),v===1):!0}get defaultUriScheme(){return Zn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,v){if(b.remoteAuthority)return t.Schemas.vscodeRemote;const d=(0,I.getVirtualWorkspaceScheme)(v.getWorkspace());if(d)return d;const p=v.getWorkspace().folders[0];if(p)return p.uri.scheme;const f=v.getWorkspace().configuration;return f?f.scheme:t.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?D.win32:D.posix)}async fileURI(b){let v="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const p=b.indexOf("/",2);p===-1?(v=b.substring(2),b="/"):(v=b.substring(2,p),b=b.substring(p)||"/")}return y.URI.from({scheme:t.Schemas.file,authority:v,path:b,query:"",fragment:""})}};T=qe([xe(1,S.IRemoteAgentService),xe(2,k.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[71],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(_,y){this.line=_,this.character=y}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,y){return new l(0,0)}with(_){return new l(0,0)}}e.Position=l;class t{constructor(_,y,E,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(_,y),this.end=new l(E,I)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new t(0,0,0,0)}with(_){return new t(0,0,0,0)}}e.Range=t;var D;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,36,24,31,8,3,9,10,71,18]),function(J,e,l,t,D,P,_,y,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",T=" characters skipped \u27EB",w=(S.length+T.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var b;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(b=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function d(q){return!!q.preview}e.resultIsMatch=d;function p(q){return!!q.resource}e.isFileMatch=p;function f(q){return!!q.message}e.isProgressMessage=f;var a;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(Y){this.resource=Y,this.results=[]}}e.FileMatch=g;class s{constructor(Y,Q,he){this.ranges=Q;const ve=Array.isArray(Q)?Q:[Q];if(he&&he.matchLines===1&&u(ve)){Y=(0,_.getNLines)(Y,he.matchLines);let ne="",pe=0,be=0;const ke=Math.floor(he.charsPerLine/5),Le=[];for(const We of ve){const oe=Math.max(We.startColumn-ke,0),ue=We.startColumn+he.charsPerLine;if(oe>be+ke+w){const fe=S+(oe-be)+T;ne+=fe+Y.slice(oe,ue),pe+=oe-(be+fe.length)}else ne+=Y.slice(be,ue);Le.push(new i(0,We.startColumn-pe,We.endColumn-pe)),be=ue}this.preview={text:ne,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const ne=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:Y,matches:(0,l.mapArrayOrNot)(Q,pe=>new o(pe.startLineNumber-ne,pe.startColumn,pe.endLineNumber-ne,pe.endColumn))}}}}e.TextSearchMatch=s;function u(q){const Y=q[0].startLineNumber;for(const Q of q)if(Q.startLineNumber!==Y||Q.endLineNumber!==Y)return!1;return!0}class o{constructor(Y,Q,he,ve){this.startLineNumber=Y,this.startColumn=Q,this.endLineNumber=he,this.endColumn=ve}}e.SearchRange=o;class i extends o{constructor(Y,Q,he){super(Y,Q,Y,he)}}e.OneLineRange=i;var r;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function n(q,Y=!0){const Q=q&&q.files&&q.files.exclude,he=Y&&q&&q.search&&q.search.exclude;if(!Q&&!he)return;if(!Q||!he)return Q||he;let ve=Object.create(null);return ve=D.mixin(ve,D.deepClone(Q)),ve=D.mixin(ve,D.deepClone(he),!0),ve}e.getExcludes=n;function c(q,Y){return q.excludePattern&&t.match(q.excludePattern,Y)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&t.match(q.includePattern,Y)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Q=>{const he=Q.folder.fsPath;if(P.isEqualOrParent(Y,he)){const ve=E.relative(he,Y);return!Q.includePattern||!!t.match(Q.includePattern,ve)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(Y,Q){super(Y),this.code=Q}}e.SearchError=m;function C(q){const Y=q.message;if((0,I.isCancellationError)(q))return new m(Y,h.canceled);try{const Q=JSON.parse(Y);return new m(Q.message,Q.code)}catch{return new m(Y,h.other)}}e.deserializeSearchError=C;function L(q){const Y={message:q.message,code:q.code};return new Error(JSON.stringify(Y))}e.serializeSearchError=L;function U(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=U;function B(q){return q.type==="success"}e.isSerializedSearchSuccess=B;function A(q){return!!q.path}e.isSerializedFileMatch=A;function M(q,Y){const Q=q.searchPath?q.searchPath:q.relativePath;return(0,_.fuzzyContains)(Q,Y)}e.isFilePatternMatch=M;class ${constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function N(q,Y){const Q={...q||{},...Y||{}};return Object.keys(Q).filter(he=>{const ve=Q[he];return typeof ve=="boolean"&&ve})}e.resolvePatternsForProvider=N;class K{constructor(Y,Q){this._parsedIncludeExpression=null,this._excludeExpression={...Y.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=Y.includePattern;Q.includePattern&&(he?he={...he,...Q.includePattern}:he=Q.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(Y,Q,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,Q,he))}includedInQuerySync(Y,Q,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,Q,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Y,Q,he))}includedInQuery(Y,Q,he){const ve=this._parsedExcludeExpression(Y,Q,he),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Y,Q,he):!0;return(0,k.isThenable)(ve)?ve.then(pe=>pe?!1:ne()):ne()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=K;function z(q){for(const Y in q)if(typeof q[Y]!="boolean")return!0;return!1}function O(q){if(!q)return;let Y;return Q=>(Y||(Y=(q()||Promise.resolve([])).then(he=>he?V(he):{})),Y.then(he=>!!he[Q]))}e.hasSiblingPromiseFn=O;function x(q){if(!q)return;let Y;return Q=>{if(!Y){const he=q();Y=he?V(he):{}}return!!Y[Q]}}e.hasSiblingFn=x;function V(q){const Y={};for(const Q of q)Y[Q]=!0;return Y}}),define(De[32],Ie([1,0,17,18,21,4,6,25,12,94,22,8,13,2,175,3,14,194,45,46,26,15,16,7,54,30,5]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a,g,s,u,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(A,M,$){return new R.ExtUri(N=>C(N,$)).isEqual(A,M)}function c(A,M,$){return n(A.uri,M.uri,$)?0:(0,k.compare)(A.uri.toString(),M.uri.toString())}function h(A,M,$){return A.index!==M.index?A.index<M.index?-1:1:n(A.uri,M.uri,$)?(0,k.compare)(A.name,M.name):(0,k.compare)(A.uri.toString(),M.uri.toString())}function m(A,M,$,N){const K=A.slice(0).sort((O,x)=>$(O,x,N)),z=M.slice(0).sort((O,x)=>$(O,x,N));return(0,l.delta)(K,z,(O,x)=>$(O,x,N))}function C(A,M){const $=M.getCapabilities(A.scheme);return!($&&$&1024)}class L extends p.Workspace{constructor(M,$,N,K,z,O,x){super(M,N.map(V=>new p.WorkspaceFolder(V)),K,z,x),this._name=$,this._isUntitled=O,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(x),N.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(M,$,N,K){if(!M)return{workspace:null,added:[],removed:[]};const{id:z,name:O,folders:x,configuration:V,transient:q,isUntitled:Y}=M,Q=[],he=$;$?x.forEach((be,ke)=>{const Le=T.URI.revive(be.uri),We=L._findFolder(N||$,Le,K);We?(We.name=be.name,We.index=be.index,Q.push(We)):Q.push({uri:Le,name:be.name,index:ke})}):Q.push(...x.map(({uri:be,name:ke,index:Le})=>({uri:T.URI.revive(be),name:ke,index:Le}))),Q.sort((be,ke)=>be.index<ke.index?-1:1);const ve=new L(z,O,Q,!!q,V?T.URI.revive(V):null,!!Y,be=>C(be,K)),{added:ne,removed:pe}=m(he?he.workspaceFolders:[],ve.workspaceFolders,c,K);return{workspace:ve,added:ne,removed:pe}}static _findFolder(M,$,N){for(let K=0;K<M.folders.length;K++){const z=M.workspaceFolders[K];if(n(z.uri,$,N))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,$){return $&&this._structure.get(M)&&(M=(0,R.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let U=class{constructor(M,$,N,K,z){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=N,this._uriTransformerService=z,this._requestIdProvider=new I.Counter,this._barrier=new t.Barrier,this._proxy=M.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(r.MainContext.MainThreadMessageService);const O=$.workspace;this._confirmedWorkspace=O?new L(O.id,O.name,[],!!O.transient,O.configuration?T.URI.revive(O.configuration):null,!!O.isUntitled,x=>C(x,N)):void 0}$initializeWorkspace(M,$){this._trusted=$,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:E.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,$,N,...K){const z=[];if(Array.isArray(K)&&K.forEach(Y=>{T.URI.isUri(Y.uri)&&!z.some(Q=>n(Q.uri,Y.uri,this._extHostFileSystemInfo))&&z.push({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri)})}),this._unconfirmedWorkspace||[$,N].some(Y=>typeof Y!="number"||Y<0)||N===0&&z.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+N>O.length)return!1;const x=O.slice(0);x.splice($,N,...z.map(Y=>({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<x.length;Y++){const Q=x[Y];if(x.some((he,ve)=>ve!==Y&&n(Q.uri,he.uri,this._extHostFileSystemInfo)))return!1}x.forEach((Y,Q)=>Y.index=Q);const{added:V,removed:q}=m(O,x,h,this._extHostFileSystemInfo);if(V.length===0&&q.length===0)return!1;if(this._proxy){const Y=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(Y,$,N,z).then(void 0,Q=>{this._unconfirmedWorkspace=void 0;const he={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(d.Severity.Error,(0,w.localize)(0,null,Y,Q.toString()),he,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(M,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,$)}async getWorkspaceFolder2(M,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,$)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,$){let N,K="";if(typeof M=="string"?(N=T.URI.file(M),K=M):typeof M<"u"&&(N=M,K=M.fsPath),!N)return K;const z=this.getWorkspaceFolder(N,!0);if(!z)return K;typeof $>"u"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let O=(0,R.relativePath)(z.uri,N);return $&&z.name&&(O=`${z.name}/${O}`),O}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:$,added:N,removed:K}=L.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:K}))}findFiles(M,$,N,K,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let O;if($===null?O=!1:$&&(typeof $=="string"?O=$:O=$.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:V}=B(s.GlobPattern.from(M));return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(x),(0,S.withUndefinedAsNull)(V),(0,S.withUndefinedAsNull)(O),(0,S.withUndefinedAsNull)(N),z).then(q=>Array.isArray(q)?q.map(Y=>T.URI.revive(Y)):[])}async findTextInFiles(M,$,N,K,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),x=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:V,folder:q}=B(s.GlobPattern.from($.include)),Y=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,Q={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:x,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:V,excludePattern:Y},he=!1;if(this._activeSearchCallbacks[O]=ve=>{if(he)return;const ne=T.URI.revive(ve.resource);ve.results.forEach(pe=>{(0,i.resultIsMatch)(pe)?N({uri:ne,preview:{text:pe.preview.text,matches:(0,l.mapArrayOrNot)(pe.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(pe.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:ne,text:pe.text,lineNumber:pe.lineNumber})})},z.isCancellationRequested)return{};try{const ve=await this._proxy.$startTextSearch(M,(0,S.withUndefinedAsNull)(q),Q,O,z);return delete this._activeSearchCallbacks[O],ve||{}}catch(ve){throw delete this._activeSearchCallbacks[O],ve}}$handleTextSearchResult(M,$){this._activeSearchCallbacks[$]?.(M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(M,$){if(this._editSessionIdentityProviders.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this._editSessionIdentityProviders.set(M,$);const N=this._uriTransformerService.transformOutgoingScheme(M),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,N),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(M),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(M,$){this._logService.info("Getting edit session identifier for workspaceFolder",M);const N=await this.resolveWorkspaceFolder(T.URI.revive(M));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const K=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!K),!K)return;const z=await K.provideEditSessionIdentity(N,$);if(this._logService.info("Provider returned edit session identifier: ",z),!!z)return z}};U=qe([xe(0,g.IExtHostRpcService),xe(1,a.IExtHostInitDataService),xe(2,f.IExtHostFileSystemInfo),xe(3,v.ILogService),xe(4,o.IURITransformerService)],U),e.ExtHostWorkspace=U,e.IExtHostWorkspace=(0,b.createDecorator)("IExtHostWorkspace");function B(A){let M,$;return A&&(typeof A=="string"?M=A:(M=A.pattern,$=T.URI.revive(A.baseUri))),{includePattern:M,folder:$}}}),define(De[33],Ie([1,0,24,4,32,5,7,197,120,13,18,3,15,14,2]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(u,o){if(o){const i=o.split(".");let r=u;for(let n=0;r&&n<i.length;n++)r=r[i[n]];return r}}function v(u){return u instanceof w.URI}function d(u){return u&&u.uri instanceof w.URI&&u.languageId&&typeof u.languageId=="string"}function p(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function f(u){return u&&u.uri instanceof w.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function a(u){if(v(u))return{resource:u};if(d(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(p(u))return{overrideIdentifier:u.languageId};if(f(u))return{resource:u.uri};if(u===null)return{resource:null}}let g=class{constructor(o,i,r){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new s(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(o,i))}};g=qe([xe(0,S.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,T.ILogService)],g),e.ExtHostConfiguration=g;class s{constructor(o,i,r,n){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=n,this._extHostWorkspace=i,this._configuration=y.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(o,i,r){const n=a(i)||{},c=this._toReadonlyValue(o?b(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,n,r?.identifier);function h(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(C){return typeof b(c,C)<"u"},get:(C,L)=>{this._validateConfigurationAccess(o?`${o}.${C}`:C,n,r?.identifier);let U=b(c,C);if(typeof U>"u")U=L;else{let B;const A=(M,$)=>{let N;const K=()=>{B=B||(0,l.deepClone)(c),N=N||b(B,$)};return(0,I.isObject)(M)?new Proxy(M,{get:(z,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return K(),()=>N;if(B)return N=N||b(B,$),N[O];const x=z[O];return typeof O=="string"?A(x,`${$}.${O}`):x},set:(z,O,x)=>(K(),N&&(N[O]=x),!0),deleteProperty:(z,O)=>(K(),N&&delete N[O],!0),defineProperty:(z,O,x)=>(K(),N&&Object.defineProperty(N,O,x),!0)}):M};U=A(U,C)}return U},update:(C,L,U,B)=>{C=o?`${o}.${C}`:C;const A=h(U);return L!==void 0?this._proxy.$updateConfigurationOption(A,C,L,n,B):this._proxy.$removeConfigurationOption(A,C,n,B)},inspect:C=>{C=o?`${o}.${C}`:C;const L=(0,l.deepClone)(this._configuration.inspect(C,n,this._extHostWorkspace.workspace));if(L)return{key:C,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof c=="object"&&(0,l.mixin)(m,c,!1),Object.freeze(m)}_toReadonlyValue(o){const i=r=>(0,I.isObject)(r)?new Proxy(r,{get:(n,c)=>i(n[c]),set:(n,c,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(n,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(n,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(o)}_validateConfigurationAccess(o,i,r){const n=E.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),c=r?`[${r.value}] `:"";if(n===4){typeof i?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const r=new y.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,c)=>r.affectsConfiguration(n,a(c))})}_toMap(o){return o.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[72],Ie([1,0,2,18,4,5,7,32,56,33,21,38,15,26,3,12,11,14,67,232,10]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function($){function N(z){if(z!=null)return z}$.from=N;function K(z){if(z!=null)return z}$.to=K})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function($){function N(z){if(z!=null)return z}$.from=N;function K(z){if(z!=null)return z}$.to=K})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function($){function N(z){if(z!=null)return z}$.from=N;function K(z){if(z!=null)return z}$.to=K})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function($){function N(O){if(O){const x=O;return x&&!!x.process}else return!1}$.is=N;function K(O){if(O==null)return;const x={process:O.process,args:O.args};return O.options&&(x.options=o.from(O.options)),x}$.from=K;function z(O){if(O!=null)return new _.ProcessExecution(O.process,O.args,O.options)}$.to=z})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function($){function N(z){if(z!=null)return z}$.from=N;function K(z){if(z!=null)return z}$.to=K})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function($){function N(O){if(O){const x=O;return x&&(!!x.commandLine||!!x.command)}else return!1}$.is=N;function K(O){if(O==null)return;const x={};return O.commandLine!==void 0?x.commandLine=O.commandLine:(x.command=O.command,x.args=O.args),O.options&&(x.options=r.from(O.options)),x}$.from=K;function z(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new _.ShellExecution(O.commandLine,O.options):new _.ShellExecution(O.command,O.args?O.args:[],O.options)}$.to=z})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function N(O){if(O){const x=O;return x&&x.customExecution==="customExecution"}else return!1}$.is=N;function K(O){return{customExecution:"customExecution"}}$.from=K;function z(O,x){return x.get(O)}$.to=z})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function($){function N(K,z){let O;return K.scope!==void 0&&typeof K.scope!="number"?O=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===_.TaskScope.Workspace&&z&&z.workspaceFile?O=z.workspaceFile:O=f.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:O}}$.from=N})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function($){function N(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}$.from=N})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function($){function N(O,x){if(O==null)return[];const V=[];for(const q of O){const Y=K(q,x);Y&&V.push(Y)}return V}$.fromMany=N;function K(O,x){if(O==null)return;let V;O.execution instanceof _.ProcessExecution?V=i.from(O.execution):O.execution instanceof _.ShellExecution?V=n.from(O.execution):O.execution&&O.execution instanceof _.CustomExecution&&(V=c.from(O.execution));const q=s.from(O.definition);let Y;return O.scope?typeof O.scope=="number"?Y=O.scope:Y=O.scope.uri:Y=_.TaskScope.Workspace,!q||!Y?void 0:{_id:O._id,definition:q,name:O.name,source:{extensionId:x.identifier.value,label:O.source,scope:Y},execution:V,isBackground:O.isBackground,group:m.from(O.group),presentationOptions:u.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}$.from=K;async function z(O,x,V){if(O==null)return;let q;i.is(O.execution)?q=i.to(O.execution):n.is(O.execution)?q=n.to(O.execution):c.is(O.execution)&&(q=c.to(O._id,V));const Y=s.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await x.resolveWorkspaceFolder(l.URI.revive(O.source.scope)):Q=_.TaskScope.Workspace),!Y||!Q)return;const he=new _.Task(Y,Q,O.name,O.source.label,q,O.problemMatchers);return O.isBackground!==void 0&&(he.isBackground=O.isBackground),O.group!==void 0&&(he.group=_.TaskGroup.from(O.group._id),he.group&&O.group.isDefault&&(he.group=new _.TaskGroup(he.group.id,he.group.label),O.group.isDefault===!0&&(he.group.isDefault=O.group.isDefault))),O.presentationOptions&&(he.presentationOptions=u.to(O.presentationOptions)),O._id&&(he._id=O._id),O.detail&&(he.detail=O.detail),he}$.to=z})(C=e.TaskDTO||(e.TaskDTO={}));var L;(function($){function N(z){return z}$.from=N;function K(z){if(!!z)return Object.assign(Object.create(null),z)}$.to=K})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(N,K,z){this._id=K,this._task=z,g.set(this,void 0),tt(this,g,N,"f")}get task(){return this._task}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}g=new WeakMap;var B;(function($){function N(K){return{id:K._id,task:void 0}}$.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(N,K,z,O,x,V,q,Y){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=O,this._configurationService=x,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,K,z){if(!z)return new _.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:K,provider:z,extension:N}),this._proxy.$registerTaskProvider(O,K),new _.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(N,K){this._proxy.$registerTaskSystem(N,K)}fetchTasks(N){return this._proxy.$fetchTasks(L.from(N)).then(async K=>{const z=[];for(const O of K){const x=await C.to(O,this._workspaceProvider,this._providedCustomExecutions2);x&&z.push(x)}return z})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(K=>N.push(K)),N}terminateTask(N){if(!(N instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,K,z){const O=this._providedCustomExecutions2.get(N.id);O&&(this._activeCustomExecutions2.set(N.id,O),this._terminalService.attachPtyToTerminal(K,await O.callback(z))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const K=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:K,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:N.exitCode})}$provideTasks(N,K){const z=this._handlers.get(N);if(!z)return Promise.reject(new Error("no handler found"));const O=[],x=(0,t.asPromise)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(V=>this.provideTasksInternal(K,O,z,V));return new Promise(V=>{x.then(q=>{Promise.all(O).then(()=>{V(q)})})})}async $resolveTask(N,K){const z=this._handlers.get(N);if(!z)return Promise.reject(new Error("no handler found"));if(K.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${z.type}].`);const O=await C.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const x=await z.provider.resolveTask(O,R.CancellationToken.None);if(!x)return;this.checkDeprecation(x,z);const V=C.from(x,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(V.execution)&&await this.addCustomExecution(V,x,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,K,z){const O=await this._proxy.$createTaskId(N);!z&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,K.execution)),this._providedCustomExecutions2.set(O,K.execution)}async getTaskExecution(N,K){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}const z=this._taskExecutionPromises.get(N.id);if(z)return z;const O=new Promise((x,V)=>{function q(Y,Q,he){he?x(new U(Y,Q.id,he)):V("Unexpected: Task does not exist.")}K?q(this,N,K):C.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>q(this,N,Y))});return this._taskExecutionPromises.set(N.id,O),O.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,K){N._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const z=this._notProvidedCustomExecutions.values();let O=z.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=z.next()}};A=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,y.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,d.ILogService),xe(7,p.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let M=class extends A{constructor(N,K,z,O,x,V,q,Y){super(N,K,z,O,x,V,q,Y),this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(N,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const z=C.from(K,N);if(z===void 0)throw new Error("Task is not valid");if(c.is(z.execution))await this.addCustomExecution(z,K,!1);else throw new a.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),K);return this._proxy.$executeTask(z).catch(x=>{throw new Error(x)}),O}provideTasksInternal(N,K,z,O){const x=[];if(O)for(const V of O){this.checkDeprecation(V,z),(!V.definition||!N[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const q=C.from(V,z.extension);q&&c.is(q.execution)?(x.push(q),K.push(this.addCustomExecution(q,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:z.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,K,z){}};M=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,y.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,d.ILogService),xe(7,p.IExtHostApiDeprecationService)],M),e.WorkerExtHostTask=M,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(De[277],Ie([1,0,9,21,50,36,22,51,30]),function(J,e,l,t,D,P,_,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(S,T,w){this.config=S,this.provider=T,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&P.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&P.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const T=this.config.folderQueries||[];return new Promise((w,b)=>{const v=d=>{this.resultCount++,S(d)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const p=d.toString(),f=l.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,f)||this.matchFile(v,{base:d,basename:f})}),Promise.all(T.map(d=>this.searchInFolder(d,v))).then(d=>{w({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{b(new Error((0,D.toErrorMessage)(d)))})})}async searchInFolder(S,T){const w=new t.CancellationTokenSource,b=this.getSearchOptionsForFolder(S),v=this.initDirectoryTree(),d=new E.QueryGlobTester(this.config,S),p=!d.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(w),f=y.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,w.token),g=f.elapsed(),s=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(u=>{const o=l.posix.relative(S.folder.path,u.path);if(p){const i=l.basename(u.path);this.matchFile(T,{base:S.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(v,S.folder,o,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,d,T),{providerTime:g,postProcessTime:s.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(S){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),w=(0,E.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:w,includes:T,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},T,w,b){if(w===this.filePattern){const d=l.basename(this.filePattern);this.matchFile(b,{base:T,relativePath:this.filePattern,basename:d})}function v(d){const p=l.basename(d),f=l.dirname(d);let a=S[f];a||(a=S[f]=[],v(f)),a.push({base:T,relativePath:d,basename:p})}v(w)}matchDirectoryTree({rootEntries:S,pathToEntries:T},w,b){const v=this,d=this.filePattern;function p(f){const a=(0,E.hasSiblingFn)(()=>f.map(g=>g.basename));for(let g=0,s=f.length;g<s;g++){const u=f[g],{relativePath:o,basename:i}=u;if(w.matchesExcludesSync(o,i,d!==i?a:void 0))continue;const r=T[o];if(r)p(r);else{if(o===d)continue;v.matchFile(b,u)}if(v.isLimitHit)break}}p(S)}matchFile(S,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(T))}}class R{constructor(){this.sessions=new Map}fileSearch(S,T,w,b){const v=this.getSessionTokenSource(S.cacheKey),d=new I(S,T,v&&v.token);let p=0;const f=a=>{p+=a.length,w(a.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(d,R.BATCH_SIZE,f,b).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:a.stats}}))}clearCache(S){this.getSessionTokenSource(S)?.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new t.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:_.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,T,w,b){b.onCancellationRequested(()=>{S.cancel()});const v=p=>{p&&(d.push(p),T>0&&d.length>=T&&(w(d),d=[]))};let d=[];return S.search(v).then(p=>(d.length&&w(d),p),p=>(d.length&&w(d),Promise.reject(p)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(De[278],Ie([1,0,17,77,36,106,25,12,9,22,8,13,2,159,186,83,14,45,130,276,30]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(m,C,L,U,B){this.configurationService=m,this.workspaceContextService=C,this.editorGroupsService=L,this.logService=U,this.pathService=B}text(m,C,L={}){m=this.getContentPattern(m,L);const U=this.configurationService.getValue(),B=C&&C.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(C?.map(d.toWorkspaceFolder),L),type:2,contentPattern:m,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:U.search.usePCRE2||B||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(m,C){const L=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const U={...m,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(m,C)&&(U.isCaseSensitive=!0),this.isMultiline(m)&&(U.isMultiline=!0),U}file(m,C={}){return{...this.commonQuery(m,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(m,C){return m?(m=Array.isArray(m)?m.map(r):r(m),C?this.parseSearchPaths(m):{pattern:u(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],C={}){const L=this.handleIncludeExclude(C.includePattern,C.expandPatterns),U=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),B=m.length>1,A=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,C,U)):m.map(N=>this.getFolderQueryForRoot(N,C,U,B))).filter(N=>!!N),M={_reason:C._reason,folderQueries:A,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:U.pattern,includePattern:L.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const N=l.coalesce(l.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const K=N.filter(O=>(0,a.pathIncludedInQuery)(M,O.fsPath)),z=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...M,...z}}const $=C.extraFileResources&&C.extraFileResources.filter(N=>(0,a.pathIncludedInQuery)(M,N.fsPath));return M.extraFileResources=$&&$.length?$:void 0,M}commonQueryFromFileList(m){const C=[],L=new _.ResourceMap,U={};let B=!1;return m.forEach(A=>{if(A.scheme===y.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const $=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:E.dirname(A.fsPath)});let N=L.get($);N||(B=!0,N={folder:$,includePattern:{}},C.push(N),L.set($,N));const K=E.relative($.fsPath,A.fsPath);(0,k.assertIsDefined)(N.includePattern)[K.replace(/\\/g,"/")]=!0}else A.fsPath&&(B=!0,U[A.fsPath]=!0)}),{folderQueries:C,includePattern:U,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(m,C){if(C.isSmartCase){if(m.isRegExp){if(R.containsUppercaseCharacter(m.pattern,!0))return!0}else if(R.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,T.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const C=z=>E.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),U=(Array.isArray(m)?m:o(m)).map(z=>{const O=this.pathService.resolvedUserHome;return O?(0,P.untildify)(z,O.scheme===y.Schemas.file?O.fsPath:O.path):z}),B=t.groupBy(U,z=>C(z)?"searchPaths":"exprSegments"),A=(B.exprSegments||[]).map(z=>R.rtrim(z,"/")).map(z=>R.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),i(z))),M={},$=this.expandSearchPathPatterns(B.searchPaths||[]);$&&$.length&&(M.searchPaths=$);const N=l.flatten(A),K=u(...N);return K&&(M.pattern=K),M}getExcludesForFolder(m,C){return C.disregardExcludeSettings?void 0:(0,a.getExcludes)(m,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const C=l.flatten(m.map(U=>{let{pathPortion:B,globPortion:A}=s(U);A&&(A=n(A));const M=this.expandOneSearchPath(B);return l.flatten(M.map($=>this.resolveOneSearchPathPattern($,A)))})),L=new Map;return C.forEach(U=>{const B=U.searchPath.toString(),A=L.get(B);A?U.pattern&&(A.pattern=A.pattern||{},A.pattern[U.pattern]=!0):L.set(B,{searchPath:U.searchPath,pattern:U.pattern?u(U.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(m){if(E.isAbsolute(m)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==y.Schemas.file?[{searchPath:C[0].uri.with({path:m})}]:[{searchPath:S.URI.file(E.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=r(m),m.startsWith("../")||m===".."){const U=E.posix.resolve(C.path,m);return[{searchPath:C.with({path:U})}]}const L=n(m);return[{searchPath:C,pattern:L}]}else{if(m==="./"||m===".\\")return[];{const C=m.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(B=>{const A=C.match(new RegExp(`^${R.escapeRegExpCharacters(B.name)}(?:/(.*)|$)`));return A?{match:A,folder:B}:null}).filter(k.isDefined);if(U.length)return U.map(B=>{const A=B.match[1];return{searchPath:B.folder.uri,pattern:A&&n(A)}});{const B=m.match(/\.[\/\\](.+)[\/\\]?/),A=B?B[1]:m,M=w.localize(0,null,A);throw new Error(M)}}}}resolveOneSearchPathPattern(m,C){const L=m.pattern&&C?`${m.pattern}/${C}`:m.pattern||C,U=[{searchPath:m.searchPath,pattern:L}];return L&&!L.endsWith("**")&&U.push({searchPath:m.searchPath,pattern:L+"/**"}),U}getFolderQueryForSearchPath(m,C,L){const U=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(m.searchPath),C,L,!1);return U?{...U,includePattern:m.pattern}:null}getFolderQueryForRoot(m,C,L,U){let B;const A=S.URI.isUri(m)?m:m.uri;if(L.searchPaths){const z=L.searchPaths.filter(O=>(0,I.isEqual)(O.searchPath,A))[0];if(z&&!z.pattern)return null;z&&(B=z.pattern)}const M=this.configurationService.getValue({resource:A}),N={...this.getExcludesForFolder(M,C)||{},...B||{}},K=S.URI.isUri(m)?(0,I.basename)(m):m.name;return{folder:A,folderName:U?K:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!M.search.followSymlinks}}};g=qe([xe(0,b.IConfigurationService),xe(1,d.IWorkspaceContextService),xe(2,p.IEditorGroupsService),xe(3,v.ILogService),xe(4,f.IPathService)],g),e.QueryBuilder=g;function s(h){const m=h.match(/[\*\{\}\(\)\[\]\?]/);if(m){const C=m.index,L=h.substr(0,C).match(/[/|\\][^/\\]*$/);if(L){let U=h.substr(0,L.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function u(...h){return h.length?h.reduce((m,C)=>(m[C]=!0,m),Object.create(null)):void 0}function o(h){return D.splitGlobAware(h,",").map(m=>m.trim()).filter(m=>!!m.length)}function i(h){return[`**/${h}/**`,`**/${h}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function r(h){return h.replace(/\\/g,"/")}function n(h){return r(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(h,m){h=l.distinct(h,U=>U.toString());const C=[],L=m.getWorkspace();return h&&h.forEach(U=>{let B;if(m.getWorkbenchState()===2)B=(0,I.relativePath)(L.folders[0].uri,U),B&&B!=="."&&(B="./"+B);else{const A=m.getWorkspaceFolder(U);if(A){const M=A.name;if(L.folders.filter(N=>N.name===M).length===1){const N=(0,I.relativePath)(A.uri,U);N===""?B=`./${A.name}`:B=`./${A.name}/${N}`}else B=U.fsPath}}B&&C.push(B)}),C}e.resolveResourcesForSearchIncludes=c}),define(De[279],Ie([1,0,22,2,21,10,3,278,30,45]),function(J,e,l,t,D,P,_,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function k(b,v){const d=v.activationEvents;if(!d)return Promise.resolve(void 0);const p=[],f=[];for(const i of d)if(/^workspaceContains:/.test(i)){const r=i.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||b.forceUsingSearch?f.push(r):p.push(r)}if(p.length===0&&f.length===0)return Promise.resolve(void 0);let a;const g=new Promise((i,r)=>{a=i}),s=i=>a({activationEvent:i}),u=Promise.all(p.map(i=>S(b,i,s))).then(()=>{}),o=T(b,v.identifier,f,s);return Promise.all([u,o]).then(()=>{a(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function S(b,v,d){for(const p of b.folders)if(await b.exists(l.joinPath(t.URI.revive(p),v))){d(`workspaceContains:${v}`);return}}async function T(b,v,d,p){if(d.length===0)return Promise.resolve(void 0);const f=new D.CancellationTokenSource,a=b.checkExists(b.folders,d,f.token),g=setTimeout(async()=>{f.cancel(),b.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},R);let s=!1;try{s=await a}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}f.dispose(),clearTimeout(g),s&&p(`workspaceContains:${d.join(",")}`)}function w(b,v,d,p){const f=b.get(_.IInstantiationService),a=b.get(E.ISearchService),s=f.createInstance(y.QueryBuilder).file(v.map(u=>(0,I.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:d,exists:!0});return a.fileSearch(s,p).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=w});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[39],Ie([1,0,170,9,73,22,18,6,25,2,14,5,33,227,91,32,28,225,10,27,23,203,7,121,3,26,69,15,85,53,38,4,279,90,205,12]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a,g,s,u,o,i,r,n,c,h,m,C,L,U,B,A){"use strict";var M,$,N;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let K=class Pn extends y.Disposable{constructor(Q,he,ve,ne,pe,be,ke,Le,We,oe){super(),this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=ve,this._initData=ke,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=be,this._extHostTunnelService=We,this._extHostTerminalService=oe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new d.ExtensionDescriptionRegistry(this._initData.allExtensions);const ue=(0,v.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(x(this._globalRegistry,ue)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=Q.createChild(new c.ServiceCollection([w.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));let fe=[],Z=[];this._initData.remote.isRemote&&(fe=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),Z=this._initData.allExtensions.filter(ee=>!ue.has(f.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const ae=(0,v.extensionIdentifiersArrayToSet)(Z);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,fe,Z,{onExtensionActivationError:(ee,ie,F)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,p.transformErrorForSerialization(ie),F)},actualActivateExtension:async(ee,ie)=>{if(ae.has(f.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ie),new T.HostExtension;const F=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(F,ie)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){p.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch{}await Promise.all(Q)}terminate(Q,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),p.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const ve=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),ve]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const he=await this._mainThreadExtensionsProxy.$getExtension(Q);let ve;if(he?.browserNlsBundleUris){ve={};for(const ne of Object.keys(he.browserNlsBundleUris))ve[ne]=I.URI.revive(he.browserNlsBundleUris[ne])}return he&&{...he,identifier:new f.ExtensionIdentifier(he.identifier.value),extensionLocation:I.URI.revive(he.extensionLocation),browserNlsBundleUris:ve}}_activateByEvent(Q,he){return this._activator.activateByEvent(Q,he)}_activateById(Q,he){return this._activator.activateById(Q,he)}activateByIdWithErrors(Q,he){return this._activateById(Q,he).then(()=>{const ve=this._activator.getActivatedExtension(Q);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==A.Schemas.file)return Q;const he=await this._hostUtils.realpath(Q.fsPath);return I.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new q(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const he=E.TernarySearchTree.forUris(ve=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ve));return await Promise.all(Q.map(async ve=>{if(this._getEntryPoint(ve)){const ne=await this._realPathExtensionUri(ve.extensionLocation);he.set(ne,ve)}})),he}_deactivate(Q){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return he;const ve=this._activator.getActivatedExtension(Q);if(!ve)return he;try{typeof ve.module.deactivate=="function"&&(he=Promise.resolve(ve.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(ne)}try{(0,y.dispose)(ve.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(ne)}return he}async _activateExtension(Q,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,he).then(ve=>{const ne=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,he),this._logExtensionActivationTimes(Q,he,"success",ne),ve},ve=>{throw this._logExtensionActivationTimes(Q,he,"failure"),ve})}_logExtensionActivationTimes(Q,he,ve,ne){const pe=z(Q,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...ne||{},outcome:ve})}_doActivateExtension(Q,he){const ve=z(Q,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const ne=this._getEntryPoint(Q);if(!ne)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${Q.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const pe=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(Q,(0,P.joinPath)(Q.extensionLocation,ne),pe),this._loadExtensionContext(Q)]).then(be=>(D.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Pn._callActivate(this._logService,Q.identifier,be[0],be[1],pe))).then(be=>(D.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),be))}_loadExtensionContext(Q){const he=new g.ExtensionGlobalMemento(Q,this._storage),ve=new g.ExtensionMemento(Q.identifier.value,!1,this._storage),ne=new B.ExtensionSecrets(Q,this._secretState),pe=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,be=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([he.whenReady,ve.whenReady,this._storagePath.whenReady]).then(()=>{const ke=this;let Le,We;const oe=(0,v.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:ve,secrets:ne,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(ue){return t.join(Q.extensionLocation.fsPath,ue)},get storagePath(){return ke._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return ke._storagePath.globalValue(Q).fsPath},get logPath(){return t.join(ke._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return I.URI.joinPath(ke._initData.logsLocation,Q.identifier.value)},get storageUri(){return ke._storagePath.workspaceValue(Q)},get globalStorageUri(){return ke._storagePath.globalValue(Q)},get extensionMode(){return pe},get extension(){return Le===void 0&&(Le=new O(ke,Q.identifier,Q,be,!1)),Le},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(Q,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!We){if(!oe)return;const ue=C.Event.buffer(C.Event.fromDOMEventEmitter(oe,"message",fe=>fe.data));oe.start(),We={onDidReceiveMessage:ue,postMessage:oe.postMessage.bind(oe)}}return We}})})}static _callActivate(Q,he,ve,ne,pe){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,he,ve,ne,pe).then(be=>new T.ActivatedExtension(!1,null,pe.build(),ve,be,ne.subscriptions))}static _callActivateOptional(Q,he,ve,ne,pe){if(typeof ve.activate=="function")try{pe.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${he.value}`);const be=typeof global=="object"?global:self,ke=ve.activate.apply(be,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ke).then(Le=>(pe.activateResolveStop(),Le))}catch(be){return Promise.reject(be)}else return Promise.resolve(ve)}_activateOneStartupFinished(Q,he){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:he}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const he of Q.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(Q,he)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(he),ne=Promise.all([Q,ve]).then(()=>{});return Promise.race([ne,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(Q,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,he){if(this.isActivated(he.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:Q.map(be=>be.uri),forceUsingSearch:ve,exists:be=>this._hostUtils.exists(be.fsPath),checkExists:(be,ke,Le)=>this._mainThreadWorkspaceProxy.$checkExists(be,ke,Le)},pe=await(0,L.checkActivateWorkspaceContainsExtension)(ne,he);if(!!pe)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:pe.activationEvent}).then(void 0,be=>this._logService.error(be))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:he}=this._initData.environment;if(!Q||!he)throw new Error(l.localize(0,null));const ve=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(l.localize(1,null,he.toString()));return new Promise((ne,pe)=>{const be=(We,oe)=>{We?pe(We):ne(typeof oe=="number"&&oe>0?1:0)},ke=(0,P.originalFSPath)(he),Le=ve.run(ke,be);Le&&Le.then&&Le.then(()=>{ne(0)}).catch(We=>{pe(We instanceof Error&&We.stack?We.stack:String(We))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,he){return this._resolvers[Q]=he,(0,y.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const he=Q.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const ve=Q.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(Q,he){this._logService.info(`$resolveAuthority invoked for authority (${V(Q)})`);const{authorityPrefix:ve,resolver:ne}=await this._activateAndGetResolver(Q);if(!ne)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),D.mark(`code/extHost/willResolveAuthority/${ve}`);const pe=await ne.resolve(Q,{resolveAttempt:he});D.mark(`code/extHost/didResolveAuthorityOK/${ve}`);const be={authority:Q,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},ke={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:be,options:ke,tunnelInformation:{environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures}}}}catch(pe){if(D.mark(`code/extHost/didResolveAuthorityError/${ve}`),pe instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}async $getCanonicalURI(Q,he){this._logService.info(`$getCanonicalURI invoked for authority (${V(Q)})`);const{resolver:ve}=await this._activateAndGetResolver(Q);if(!ve)return null;const ne=I.URI.revive(he);if(typeof ve.getCanonicalURI>"u")return ne;const pe=await(0,_.asPromise)(()=>ve.getCanonicalURI(ne));return pe||ne}static _applyExtensionsDelta(Q,he,ve){const ne=new d.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());ne.deltaExtensions(ve.toAdd,ve.toRemove);const pe=(0,v.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of ve.myToRemove)pe.delete(f.ExtensionIdentifier.toKey(ke));for(const ke of ve.myToAdd)pe.add(f.ExtensionIdentifier.toKey(ke));const be=x(ne,pe);return{globalRegistry:ne,myExtensions:be}}$startExtensionHost(Q){Q.toAdd.forEach(ne=>ne.extensionLocation=I.URI.revive(ne.extensionLocation));const{globalRegistry:he,myExtensions:ve}=Pn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(ve),this._startExtensionHost()}$activateByEvent(Q,he){return he===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(Q,!1))}async $activate(Q,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,he),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(be=>be.extensionLocation=I.URI.revive(be.extensionLocation));const{globalRegistry:he,myExtensions:ve}=Pn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),ne=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(ve),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const he=a.VSBuffer.alloc(Q),ve=Math.random()%256;for(let ne=0;ne<Q;ne++)he.writeUInt8(ve,ne);return he}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};K=qe([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,n.IExtHostRpcService),xe(3,b.IExtHostWorkspace),xe(4,S.IExtHostConfiguration),xe(5,R.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,h.IExtHostTunnelService),xe(9,m.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function z(Y,Q){return{id:Y.identifier.value,name:Y.name,extensionVersion:Y.version,publisherDisplayName:Y.publisher,activationEvents:Y.activationEvents?Y.activationEvents.join(","):null,isBuiltin:Y.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class O{constructor(Q,he,ve,ne,pe){M.set(this,void 0),$.set(this,void 0),N.set(this,void 0),tt(this,M,Q,"f"),tt(this,$,he,"f"),tt(this,N,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=ne,this.isFromDifferentExtensionHost=pe}get isActive(){return Ue(this,M,"f").isActivated(Ue(this,N,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,M,"f").getExtensionExports(Ue(this,N,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,M,"f").activateByIdWithErrors(Ue(this,N,"f"),{startup:!1,extensionId:Ue(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=O,M=new WeakMap,$=new WeakMap,N=new WeakMap;function x(Y,Q){return Y.getAllExtensionDescriptions().filter(he=>Q.has(f.ExtensionIdentifier.toKey(he.identifier)))}function V(Y){const Q=Y.indexOf("+");return Q===-1?Y:Y.substring(0,Q)}class q{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=q}),define(De[280],Ie([1,0,73,2,5,33,28,27,15,26,3,39,40,14,8]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=class{constructor(g,s,u,o,i,r,n){this._apiFactory=g,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=o,this._extHostExtensionService=i,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,s,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(p,s)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,s,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const s of g.nodeModuleName)this._factories.set(s,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(s=>g.alternativeModuleName(s))}};b=qe([xe(2,R.IInstantiationService),xe(3,P.IExtHostConfiguration),xe(4,k.IExtHostExtensionService),xe(5,I.IExtHostInitDataService),xe(6,T.ILogService)],b),e.RequireInterceptor=b;let v=class Xn{constructor(g){if(g.environment.appRoot&&Xn.aliased.size){const s=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),u="[a-z0-9_.-]",o=`@${u}+\\/${u}+|${u}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(g));if(!s)return;const[,u,o,i]=s,r=Xn.aliased.get(o);if(r!==void 0)return console.warn(`${o} as been renamed to ${r}, please update your imports`),u+r+i}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=qe([xe(0,I.IExtHostInitDataService)],v);class d{constructor(g,s,u,o,i){this._apiFactory=g,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=o,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,s){const u=this._extensionPaths.findSubstr(s);if(u){let o=this._extApiImpl.get(y.ExtensionIdentifier.toKey(u.identifier));return o||(o=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(u.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((i,r)=>o+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(g,s,u){this._extensionPaths=g,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(D.MainContext.MainThreadTelemetry);const{environment:o}=u,i=s.getProxy(D.MainContext.MainThreadKeytar);if(o.appRoot){let r=o.appRoot.fsPath;S.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>i.$getPassword(r,n),setPassword:(r,n,c)=>i.$setPassword(r,n,c),deletePassword:(r,n)=>i.$deletePassword(r,n),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(g,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(g){const s=g.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((g.charAt(u)==="/"||g.charAt(u)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}};p=qe([xe(1,E.IExtHostRpcService),xe(2,I.IExtHostInitDataService)],p);let f=class{constructor(g,s,u){this._extensionPaths=g,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(D.MainContext.MainThreadTelemetry);const o=u.getProxy(D.MainContext.MainThreadWindow);this._impl=(i,r)=>{const n=t.URI.parse(i);return r?this.callOriginal(i,r):n.scheme==="http"||n.scheme==="https"?o.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?o.$openUri(n,i,{}):this.callOriginal(i,r)}}load(g,s,u){const o=this._extensionPaths.findSubstr(s);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=u(g),this._impl}callOriginal(g,s){return this.sendNoForwardTelemetry(),this._original(g,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=qe([xe(2,E.IExtHostRpcService)],f)}),define(De[47],Ie([1,0,78,6,9,40,3,56,57,39,7,32,218,33]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class w extends S.AbstractVariableResolverService{constructor(d,p,f,a,g,s,u){function o(){if(f){const i=f.activeEditor();if(i)return i.document.uri;const r=a.tabGroups.all.find(n=>n.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=s.folders.filter(n=>n.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(i,r)=>g.getConfiguration(void 0,i).get(r),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=o();if(i)return D.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const i=o();if(i){const r=p.getWorkspaceFolder(i);if(r)return D.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(f){const i=f.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(f){const i=f.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>d.getExtension(i)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let b=class extends t.Disposable{constructor(d,p,f,a,g){super(),this.extensionService=d,this.workspaceService=p,this.editorService=f,this.configurationService=a,this.editorTabs=g,this._resolver=new l.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),o={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{o.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,o,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};b=qe([xe(0,I.IExtHostExtensionService),xe(1,k.IExtHostWorkspace),xe(2,y.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],b),e.ExtHostVariableResolverProviderService=b}),define(De[74],Ie([1,0,18,4,13,2,3,5,57,39,15,7,32,127,211,33,47]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let d=class{constructor(o,i,r,n,c,h){this._workspaceService=i,this._extensionService=r,this._configurationService=n,this._editorTabs=c,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=o.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(m=>{m.onDidChange(C=>{this.registerAllDebugTypes(m)}),this.registerAllDebugTypes(m)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,i){const r=o;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let n=`debug:${encodeURIComponent(r.path||"")}`,c="?";return i&&(n+=`${c}session=${encodeURIComponent(i.id)}`,c="&"),n+=`${c}ref=${r.sourceReference}`,P.URI.parse(n)}else{if(r.path)return P.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const i=[];for(const r of o.getAllExtensionDescriptions())if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0)for(const c of n)(0,w.isDebuggerMainContribution)(c)&&i.push(c.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(i=>o.push(i)),o}addBreakpoints(o){this.startBreakpoints();const i=o.filter(c=>{const h=c.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,c),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],n=new Map;for(const c of i)if(c instanceof k.SourceBreakpoint){let h=n.get(c.location.uri.toString());h||(h={type:"sourceMulti",uri:c.location.uri,lines:[]},n.set(c.location.uri.toString(),h),r.push(h)),h.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof k.FunctionBreakpoint&&r.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(o){this.startBreakpoints();const i=o.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(h=>h instanceof k.SourceBreakpoint).map(h=>h.id),n=i.filter(h=>h instanceof k.FunctionBreakpoint).map(h=>h.id),c=i.filter(h=>h instanceof k.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(r,n,c)}startDebugging(o,i,r){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,i,r){if(!i)return new k.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:n,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,n),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(o,i,r){if(!r)return new k.Disposable(()=>{});if(!this.definesDebugType(o,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:n,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,n),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(o,i){if(!i)return new k.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:r,factory:i}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==i)})}async $runInTerminal(o,i){return Promise.resolve(void 0)}async $substituteVariables(o,i){let r;const n=await this.getFolder(o);return n&&(r={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(o,i){if(o.type==="implementation")return new g(o.implementation)}createSignService(){}async $startDASession(o,i){const r=this,n=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const h=this.convertToDto(c),m=this.createDebugAdapter(h,n);if(!m)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const C=m;return this._debugAdapters.set(o,C),this.getDebugAdapterTrackers(n).then(L=>(L&&this._debugAdaptersTrackers.set(o,L),C.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const B=U,A={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(B.arguments.value);A.body={signature:M},C.sendResponse(A)}else throw new Error("no signer")}catch(M){A.success=!1,A.message=M.message,C.sendResponse(A)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(U),U=(0,w.convertToVSCPaths)(U,!0),r._debugServiceProxy.$acceptDAMessage(o,U)}),C.onError(U=>{L&&L.onError&&L.onError(U),this._debugServiceProxy.$acceptDAError(o,U.name,U.message,U.stack)}),C.onExit(U=>{L&&L.onExit&&L.onExit((0,D.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,D.withNullAsUndefined)(U),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),C.startSession()))})}$sendDAMessage(o,i){i=(0,w.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(o);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(o)?.sendMessage(i)}$stopDASession(o){const i=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(o);return this._debugAdapters.delete(o),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const i=[],r=[],n=[];if(o.added)for(const c of o.added){const h=c.id;if(h&&!this._breakpoints.has(h)){let m;if(c.type==="function")m=new k.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")m=new k.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const C=P.URI.revive(c.uri);m=new k.SourceBreakpoint(new k.Location(C,new k.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}m._id=h,this._breakpoints.set(h,m),i.push(m)}}if(o.removed)for(const c of o.removed){const h=this._breakpoints.get(c);h&&(this._breakpoints.delete(c),r.push(h))}if(o.changed){for(const c of o.changed)if(c.id){const h=this._breakpoints.get(c.id);if(h){if(h instanceof k.FunctionBreakpoint&&c.type==="function"){const m=h;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.functionName=c.functionName}else if(h instanceof k.SourceBreakpoint&&c.type==="source"){const m=h;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.location=new k.Location(P.URI.revive(c.uri),new k.Position(c.line,c.character))}n.push(h)}}}this.fireBreakpointChanges(i,r,n)}$provideDebugConfigurations(o,i,r){return(0,l.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(i);return n.provideDebugConfigurations(c,r)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(o,i,r,n){return(0,l.asPromise)(async()=>{const c=this.getConfigProviderByHandle(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(i);return c.resolveDebugConfiguration(h,r,n)})}$resolveDebugConfigurationWithSubstitutedVariables(o,i,r,n){return(0,l.asPromise)(async()=>{const c=this.getConfigProviderByHandle(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(i);return c.resolveDebugConfigurationWithSubstitutedVariables(h,r,n)})}async $provideDebugAdapter(o,i){const r=this.getAdapterDescriptorFactoryByHandle(o);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(i);return this.getAdapterDescriptor(r,n).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(o){const i=await this.getSession(o);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(o){const i=await this.getSession(o);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,i){(await this.getSession(o))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(o,i){const n={session:await this.getSession(o),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const i=this._adapterFactories.filter(r=>r.type===o);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(o){const i=this._adapterFactories.filter(r=>r.handle===o);if(i.length>0)return i[0].factory}getConfigProviderByHandle(o){const i=this._configProviders.filter(r=>r.handle===o);if(i.length>0)return i[0].provider}definesDebugType(o,i){if(o.contributes){const r=o.contributes.debuggers;if(r&&r.length>0){for(const n of r)if(n.label&&n.type&&n.type===i)return!0}}return!1}getDebugAdapterTrackers(o){const r=o.configuration.type,n=this._trackerFactories.filter(c=>c.type===r||c.type==="*").map(c=>(0,l.asPromise)(()=>c.factory.createDebugAdapterTracker(o)).then(h=>h,h=>null));return Promise.race([Promise.all(n).then(c=>{const h=c.filter(m=>!!m);if(h.length>0)return new a(h)}),new Promise((c,h)=>{const m=setTimeout(()=>{clearTimeout(m),h(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(o,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new k.DebugAdapterServer(r));if(o){const c=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>o.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,c))).then(h=>{if(h)return h})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,n))}daExecutableFromPackage(o,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,i,r){(o.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:i,changed:r}))}async getSession(o){if(o)if(typeof o=="string"){const i=this._debugSessions.get(o);if(i)return i}else{let i=this._debugSessions.get(o.id);if(!i){const r=await this.getFolder(o.folderUri),n=o.parent?this._debugSessions.get(o.parent):void 0;i=new p(this._debugServiceProxy,o.id,o.type,o.name,r,o.configuration,n),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(o){if(o){const i=P.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};d=qe([xe(0,R.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,b.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class p{constructor(o,i,r,n,c,h,m){this._debugServiceProxy=o,this._id=i,this._type=r,this._name=n,this._workspaceFolder=c,this._configuration=h,this._parentSession=m}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,i)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=p;class f{constructor(o){this.value=Object.freeze({append(i){o.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=f;class a{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(i=>i.onError?i.onError(o):void 0)}onExit(o,i){this.trackers.forEach(r=>r.onExit?r.onExit(o,i):void 0)}}class g extends T.AbstractDebugAdapter{constructor(o){super(),this.implementation=o,o.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends d{constructor(o,i,r,n,c,h){super(o,i,r,n,c,h)}};s=qe([xe(0,R.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,b.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(De[281],Ie([1,0,10,73,2,5,273,14,82,85,26,192,15,54,39]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(d,p,f,a,g){this._hostUtils=f,this._rpcProtocol=new _.RPCProtocol(d,null,a),p=b._transform(p,this._rpcProtocol);const s=new I.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:g}),s.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),s.set(T.IURITransformerService,new T.URITransformerService(a)),s.set(w.IHostUtils,f);const u=new k.InstantiationService(s,!0);this._logService=u.invokeFunction(n=>n.get(y.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",p),this._extensionService=u.invokeFunction(n=>n.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(n=>{Error.prepareStackTrace=(c,h)=>{let m="",C,L;for(const U of h)m+=`
	at ${U.toString()}`,L=U.getFileName(),!C&&L&&(C=n.findSubstr(D.URI.file(L)));return o.set(c,C),`${c.name||"Error"}: ${c.message||""}${m}`}});const i=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(n=>{const c=l.transformErrorForSerialization(n),h=o.get(n);h?i.$onExtensionRuntimeError(h.identifier,c):r.$onUnexpectedError(c)})}async asBrowserUri(d){const p=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return D.URI.revive(await p.$asBrowserUri(d))}terminate(d){this._extensionService.terminate(d)}static _transform(d,p){d.allExtensions.forEach(a=>{a.extensionLocation=D.URI.revive(p.transformIncomingURIs(a.extensionLocation));const g={};a.browserNlsBundleUris&&(Object.keys(a.browserNlsBundleUris).forEach(s=>g[s]=D.URI.revive(p.transformIncomingURIs(a.browserNlsBundleUris[s]))),a.browserNlsBundleUris=g)}),d.environment.appRoot=D.URI.revive(p.transformIncomingURIs(d.environment.appRoot));const f=d.environment.extensionDevelopmentLocationURI;return f&&(d.environment.extensionDevelopmentLocationURI=f.map(a=>D.URI.revive(p.transformIncomingURIs(a)))),d.environment.extensionTestsLocationURI=D.URI.revive(p.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=D.URI.revive(p.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=D.URI.revive(p.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=D.URI.revive(p.transformIncomingURIs(d.logsLocation)),d.logFile=D.URI.revive(p.transformIncomingURIs(d.logFile)),d.workspace=p.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=b}),define(De[282],Ie([1,0,18,11,176,191,199,74,57,39,15,38,7,47,32,212,214,33]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let p=class extends y.ExtHostDebugServiceBase{constructor(u,o,i,r,n,c,h){super(u,o,i,r,c,h),this._terminalService=n,this._integratedTerminalInstances=new g}createDebugAdapter(u,o){switch(u.type){case"server":return new b.SocketDebugAdapter(u);case"pipeServer":return new b.NamedPipeDebugAdapter(u);case"executable":return new b.ExecutableDebugAdapter(u,o.type)}return super.createDebugAdapter(u,o)}daExecutableFromPackage(u,o){const i=b.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),u.type);if(i)return new S.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new _.SignService}async $runInTerminal(u,o){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const i=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),c=u.title||D.localize(0,null),h=JSON.stringify({shell:r,shellArgs:n});let m=await this._integratedTerminalInstances.checkout(h,c),C,L=!1;if(m)C=u.cwd;else{const M={shellPath:r,shellArgs:n,cwd:u.cwd,name:c,iconPath:new S.ThemeIcon("debug")};L=!0,m=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(m,h)}m.show(!0);const U=await m.processId;L?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?m.sendText("cls"):r.indexOf("bash")>=0?m.sendText("clear"):t.isWindows?m.sendText("cls"):m.sendText("clear"));const B=(0,v.prepareCommand)(r,u.args,!!u.argsCanBeInterpretedByShell,C,u.env);m.sendText(B);const A=this.onDidTerminateDebugSession(M=>{M.id===o&&(this._integratedTerminalInstances.free(m),A.dispose())});return U}else if(u.kind==="external")return a(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,o)}};p=qe([xe(0,R.IExtHostRpcService),xe(1,w.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,d.IExtHostConfiguration),xe(4,k.IExtHostTerminalService),xe(5,E.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let f;function a(s,u){if(!f)if(t.isWindows)f=new P.WindowsExternalTerminalService;else if(t.isMacintosh)f=new P.MacExternalTerminalService;else if(t.isLinux)f=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=u.getConfiguration("terminal");return f.runInTerminal(s.title,s.cwd,s.args,s.env||{},o.external||{})}e.runInExternalTerminal=a;class g{constructor(){this._terminalInstances=new Map}async checkout(u,o){const r=[...this._terminalInstances.entries()].map(([n,c])=>(0,l.createCancelablePromise)(async h=>{if(n.name!==o||c.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await n.processId))return null;const m=Date.now();return c.lastUsedAt+g.minUseDelay>m||h.isCancellationRequested||c.config!==u?null:(c.lastUsedAt=m,n)}));return await(0,l.firstParallel)(r,n=>!!n)}insert(u,o){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:o})}free(u){const o=this._terminalInstances.get(u);o&&(o.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}g.minUseDelay=1e3}),define(De[283],Ie([1,0,9,2,109,32,56,33,45,38,15,26,72,12,14,67,22,81,47]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends S.ExtHostTaskBase{constructor(g,s,u,o,i,r,n,c,h){super(g,s,u,o,i,r,n,c),this.workspaceService=u,this.variableResolver=h,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,s){const u=s;if(!s.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const o=S.TaskHandleDTO.from(u,this.workspaceService),i=await this._proxy.$getTaskExecution(o);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(i,s);return this._proxy.$executeTask(o).catch(()=>{}),r}else{const o=S.TaskDTO.from(s,g);if(o===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,s,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),s);return this._proxy.$executeTask(o).catch(()=>{}),i}}provideTasksInternal(g,s,u,o){const i=[];if(o)for(const r of o){this.checkDeprecation(r,u),(!r.definition||!g[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const n=S.TaskDTO.from(r,u.extension);n&&(i.push(n),S.CustomExecutionDTO.is(n.execution)&&s.push(this.addCustomExecution(n,r,!0)))}return{tasks:i,extension:u.extension}}async resolveTaskInternal(g){return g}async getAFolder(g){let s=g&&g.length>0?g[0]:void 0;if(!s){const u=t.URI.file((0,d.homedir)());s=new E.WorkspaceFolder({uri:u,name:v.basename(u),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,s){const u=t.URI.revive(g),o={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(u),r=await this._workspaceProvider.getWorkspaceFolders2()??[],n=await this.variableResolver.getResolver(),c=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const h of s.variables)o.variables[h]=await n.resolveAsync(c,h);if(s.process!==void 0){let h;if(s.process.path!==void 0){h=s.process.path.split(l.delimiter);for(let m=0;m<h.length;m++)h[m]=await n.resolveAsync(c,h[m])}o.process=await D.win32.findExecutable(await n.resolveAsync(c,s.process.name),s.process.cwd!==void 0?await n.resolveAsync(c,s.process.cwd):void 0,h)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(g,s,u){return D.win32.findExecutable(g,s,u)}};f=qe([xe(0,R.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,_.IExtHostDocumentsAndEditors),xe(4,y.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,w.ILogService),xe(7,b.IExtHostApiDeprecationService),xe(8,p.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(De[284],Ie([1,0,81,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(De[140],Ie([1,0,17,18,21,50,12,9,22,2,30]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(p,f,a,g){this.query=p,this.provider=f,this.fileUtils=a,this.processType=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(p,f){const a=this.query.folderQueries||[],g=new D.CancellationTokenSource;return f.onCancellationRequested(()=>g.cancel()),new Promise((s,u)=>{this.collector=new T(p);let o=!1;const i=(r,n)=>{if(!o&&!this.isLimitHit){const c=this.resultSize(r);b(r)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,o=!0,g.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const h=this.resultSize(r);this.resultCount+=h,(h>0||!b(r))&&this.collector.add(r,n)}};Promise.all(a.map((r,n)=>this.searchInFolder(r,c=>i(c,n),g.token))).then(r=>{g.dispose(),this.collector.flush();const n=r.some(c=>!!c&&!!c.limitHit);s({limitHit:this.isLimitHit||n,messages:(0,l.flatten)(r.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},r=>{g.dispose();const n=(0,P.toErrorMessage)(r);u(new Error(n))})})}resultSize(p){return b(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}trimResultToSize(p,f){const a=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:a.slice(0,f),preview:{matches:g.slice(0,f),text:p.preview.text},uri:p.uri}}async searchInFolder(p,f,a){const g=new R.QueryGlobTester(this.query,p),s=[],u={report:r=>{if(!this.validateProviderResult(r))return;const n=p.folder.scheme===_.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(r.uri))):void 0,c=E.relativePath(p.folder,r.uri);if(c){const h=g.includedInQuery(c,y.basename(c),n);(0,t.isThenable)(h)?s.push(h.then(m=>{m&&f(r)})):h&&f(r)}}},o=this.getSearchOptionsForFolder(p),i=await this.provider.provideTextSearchResults(S(this.query.contentPattern),o,u,a);return s.length&&await Promise.all(s),i}validateProviderResult(p){if(b(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(p){const f=(0,R.resolvePatternsForProvider)(this.query.includePattern,p.includePattern),a=(0,R.resolvePatternsForProvider)(this.query.excludePattern,p.excludePattern),g={folder:I.URI.from(p.folder),excludes:a,includes:f,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.fileUtils.toCanonicalName(p.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return g.usePCRE2=this.query.usePCRE2,g}}e.TextSearchManager=k;function S(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class T{constructor(p){this._onResult=p,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,f=>this.sendItems(f))}add(p,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!E.isEqual(this._currentUri,p.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:p.uri,results:[]}),this._currentFileMatch.results.push(w(p))}pushToCollector(){const p=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,p)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(p){this._onResult(p)}}e.TextSearchResultsCollector=T;function w(d){return b(d)?{preview:{matches:(0,l.mapArrayOrNot)(d.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:d.preview.text},ranges:(0,l.mapArrayOrNot)(d.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function b(d){return!!d.preview}e.extensionResultIsMatch=b;class v{constructor(p,f){this.maxBatchSize=p,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(p,f){!p||this.addItemToBatch(p,f)}addItems(p,f){!p||this.addItemsToBatch(p,f)}addItemToBatch(p,f){this.batch.push(p),this.batchSize+=f,this.onUpdate()}addItemsToBatch(p,f){this.batch=this.batch.concat(p),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(De[75],Ie([1,0,6,5,3,277,15,54,14,2,140]),function(J,e,l,t,D,P,_,y,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(b,v,d){this.extHostRpc=b,this._uriTransformer=v,this._logService=d,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}registerTextSearchProvider(b,v){if(this._textSearchUsedSchemes.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this._textSearchUsedSchemes.add(b);const d=this._handlePool++;return this._textSearchProvider.set(d,v),this._proxy.$registerTextSearchProvider(d,this._transformScheme(b)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(b),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(b,v){if(this._fileSearchUsedSchemes.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this._fileSearchUsedSchemes.add(b);const d=this._handlePool++;return this._fileSearchProvider.set(d,v),this._proxy.$registerFileSearchProvider(d,this._transformScheme(b)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(b),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(b,v,d,p){const f=S(d),a=this._fileSearchProvider.get(b);if(a)return this._fileSearchManager.fileSearch(f,a,g=>{this._proxy.$handleFileMatch(b,v,g.map(s=>s.resource))},p);throw new Error("unknown provider: "+b)}$clearCache(b){return this._fileSearchManager.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,v,d,p){const f=this._textSearchProvider.get(b);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const a=S(d);return this.createTextSearchManager(a,f).search(s=>this._proxy.$handleTextMatch(b,v,s),p)}$enableExtensionHostSearch(){}createTextSearchManager(b,v){return new R.TextSearchManager(b,v,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};k=qe([xe(0,_.IExtHostRpcService),xe(1,y.IURITransformerService),xe(2,E.ILogService)],k),e.ExtHostSearch=k;function S(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(T),extraFileResources:w.extraFileResources&&w.extraFileResources.map(b=>I.URI.revive(b))}}e.reviveQuery=S;function T(w){return{...w,folder:I.URI.revive(w.folder)}}}),define(De[285],Ie([1,0,82,139,32,135,33,37,56,38,72,74,75,91,53,67,138,68,46,90,124,57,136,14,228,47,137]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a,g,s,u,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService,!0),(0,l.registerSingleton)(u.ILogService,o.ExtHostLogService,!0),(0,l.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands,!1),(0,l.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,l.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,!0),(0,l.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,l.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,l.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow,!1),(0,l.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,!1),(0,l.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,!1),(0,l.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,!1),(0,l.registerSingleton)(r.IExtHostTelemetryLogService,r.ExtHostTelemetryLogService,!1),(0,l.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,!1),(0,l.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(De[92],Ie([1,0,17,14,30,71]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function _(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=_;function y(k,S,T,w){const b=(0,l.mapArrayOrNot)(T,E),v=new D.TextSearchMatch(S,b,w),d=v.preview.matches;return{ranges:(0,l.mapArrayOrNot)(b,I),uri:k,preview:{text:v.preview.text,matches:(0,l.mapArrayOrNot)(d,I)}}}e.createTextSearchResult=y;function E(k){return new D.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let R=class{constructor(S,T){this.prefix=S,this.logService=T}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};R=qe([xe(1,t.ILogService)],R),e.OutputChannel=R}),define(De[286],Ie([1,0,44,9,80,31,11,8,92,287]),function(J,e,l,t,D,P,_,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(f,a,g,s){const u=S(f,a,g,s),o=a.folder.fsPath;return{cmd:l.spawn(R,u.args,{cwd:o}),rgDiskPath:R,siblingClauses:u.siblingClauses,rgArgs:u,cwd:o}}e.spawnRipgrepCmd=k;function S(f,a,g,s){const u=["--files","--hidden","--case-sensitive"];w([a],g,!1).forEach(i=>{const r=(0,E.anchorGlob)(i);if(u.push("-g",r),_.isMacintosh){const n=(0,D.normalizeNFD)(r);n!==r&&u.push("-g",n)}});const o=T([a],s,void 0,!1);return o.globArgs.forEach(i=>{const r=`!${(0,E.anchorGlob)(i)}`;if(u.push("-g",r),_.isMacintosh){const n=(0,D.normalizeNFD)(r);n!==r&&u.push("-g",n)}}),a.disregardIgnoreFiles!==!1?u.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),a.ignoreSymlinks||u.push("--follow"),f.exists&&u.push("--quiet"),u.push("--no-config"),a.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:o.siblingClauses}}function T(f,a,g,s=!0){const u=[];let o={};return f.forEach(i=>{const r=Object.assign({},i.excludePattern||{},a||{}),n=b(r,s?i.folder.fsPath:void 0,g);u.push(...n.globArgs),n.siblingClauses&&(o=Object.assign(o,n.siblingClauses))}),{globArgs:u,siblingClauses:o}}e.foldersToRgExcludeGlobs=T;function w(f,a,g=!0){const s=[];return f.forEach(u=>{const o=Object.assign({},a||{},u.includePattern||{}),i=b(o,g?u.folder.fsPath:void 0);s.push(...i.globArgs)}),s}e.foldersToIncludeGlobs=w;function b(f,a,g){const s=[],u={};return Object.keys(f).forEach(o=>{if(g&&g.has(o)||!o)return;const i=f[o];o=d(a?v(a,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),s.push(p(o))):i&&i.when&&(u[o]=i)}),{globArgs:s,siblingClauses:u}}function v(f,a){return t.isAbsolute(a)?a:t.join(f,a)}e.getAbsoluteGlob=v;function d(f){return f=y.rtrim(f,"\\"),y.rtrim(f,"/")}function p(f){return P.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=p}),define(De[288],Ie([1,0,44,63,9,289,17,50,36,80,31,11,51,8,13,29,30,286,104]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(o=>o())});class a{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&E.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&E.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const n=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),c=r.folder.fsPath;i.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==c).forEach(h=>{(0,R.isEqualOrParent)(h,c)&&(n[D.relative(c,h)]=!0)}),this.folderExcludePatterns.set(c,new s(n,c))})}cancel(){this.isCanceled=!0,f.forEach(i=>i())}walk(i,r,n,c,h){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);r.forEach(m=>{const C=D.basename(m.fsPath);this.globalExcludePattern&&this.globalExcludePattern(m.fsPath,C)||this.matchFile(n,{relativePath:m.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(i,(m,C)=>{this.call(this.cmdTraversal,this,m,n,c,L=>{if(L){const U=(0,y.toErrorMessage)(L);console.error(U),this.errors.push(U),C(L,void 0)}else C(null,void 0)})},(m,C)=>{this.fileWalkSW.stop();const L=m?_.coalesce(m)[0]:null;h(L,this.isLimitHit)})}parallel(i,r,n){const c=new Array(i.length),h=new Array(i.length);let m=!1,C=0;if(i.length===0)return n(null,[]);i.forEach((L,U)=>{r(L,(B,A)=>{if(B?(m=!0,c[U]=null,h[U]=B):(c[U]=A,h[U]=null),++C===i.length)return n(m?h:null,c)})})}call(i,r,...n){try{i.apply(r,n)}catch(c){n[n.length-1](c)}}cmdTraversal(i,r,n,c){const h=i.folder.fsPath,m=k.isMacintosh,C=()=>M&&M.kill();f.add(C);let L=z=>{f.delete(C),L=()=>{},c(z)},U="";const B=this.initDirectoryTree(),A=(0,d.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),M=A.cmd,$=!Object.keys(A.siblingClauses).length,N=A.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let K=`${A.rgDiskPath} ${N}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),n({message:K}),this.cmdResultCount=0,this.collectStdout(M,"utf8",n,(z,O,x)=>{if(z){L(z);return}if(this.isLimitHit){L();return}const q=(U+(m?I.normalizeNFC(O||""):O)).split(`
`);if(x){const Y=q.length;q[Y-1]=q[Y-1].trim(),q[Y-1]||q.pop()}else U=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,$){for(const Y of q)if(this.matchFile(r,{base:h,relativePath:Y,searchPath:this.getSearchPath(i,Y)}),this.isLimitHit){C();break}(x||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,B,h,q,r),x&&(this.matchDirectoryTree(B,h,r),L())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),n=r.getBasenameTerms(),c=r.getPathTerms(),h=["-L","."];if(n.length||c.length){h.push("-not","(","(");for(const m of n)h.push("-name",m),h.push("-o");for(const m of c)h.push("-path",m),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),l.spawn("find",h,{cwd:i.folder.fsPath})}readStdout(i,r,n){let c="";this.collectStdout(i,r,()=>{},(h,m,C)=>{if(h){n(h);return}c+=m,C&&n(null,c)})}collectStdout(i,r,n,c){let h=(L,U,B)=>{(L||B)&&(h=()=>{},this.cmdSW?.stop()),c(L,U,B)},m=!1;i.stdout?(this.forwardData(i.stdout,r,h),i.stdout.once("data",()=>m=!0)):n({message:"stdout is null"});let C;i.stderr?C=this.collectData(i.stderr):n({message:"stderr is null"}),i.on("error",L=>{h(L)}),i.on("close",L=>{let U;!m&&(U=this.decodeData(C,r))&&u(U)?h(new Error(`command failed with error code ${L}: ${this.decodeData(C,r)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(i,r,n){const c=new P.StringDecoder(r);return i.on("data",h=>{n(null,c.write(h))}),c}collectData(i){const r=[];return i.on("data",n=>{r.push(n)}),r}decodeData(i,r){const n=new P.StringDecoder(r);return i.map(c=>n.write(c)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},n,c,h){c.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const m=C=>{const L=D.basename(C),U=D.dirname(C);let B=r[U];B||(B=r[U]=[],m(U)),B.push({base:n,relativePath:C,basename:L,searchPath:this.getSearchPath(i,C)})};c.forEach(m)}matchDirectoryTree({rootEntries:i,pathToEntries:r},n,c){const h=this,m=this.folderExcludePatterns.get(n),C=this.filePattern;function L(U){h.directoriesWalked++;const B=(0,v.hasSiblingFn)(()=>U.map(A=>A.basename));for(let A=0,M=U.length;A<M;A++){const $=U[A],{relativePath:N,basename:K}=$;if(m.test(N,K,C!==K?B:void 0))continue;const z=r[N];if(z)L(z);else{if(h.filesWalked++,N===C)continue;h.matchFile(c,$)}if(h.isLimitHit)break}}L(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,n,c,h){const m=i.folder,C=(0,v.hasSiblingFn)(()=>n);this.parallel(n,(L,U)=>{if(this.isCanceled||this.isLimitHit)return U(null);const B=r?[r,L].join(D.sep):L;if(this.folderExcludePatterns.get(i.folder.fsPath).test(B,L,this.config.filePattern!==L?C:void 0))return U(null);const A=[m.fsPath,B].join(D.sep);t.lstat(A,(M,$)=>{if(M||this.isCanceled||this.isLimitHit)return U(null);this.statLinkIfNeeded(A,$,(N,K)=>N||this.isCanceled||this.isLimitHit?U(null):K.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,$,(z,O)=>z||this.isCanceled||this.isLimitHit||(O=O||"",this.walkedPaths[O])?U(null):(this.walkedPaths[O]=!0,b.Promises.readdir(A).then(x=>{if(this.isCanceled||this.isLimitHit)return U(null);this.doWalk(i,B,x,c,V=>U(V||null))},x=>{U(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&w.isNumber(K.size)&&K.size>this.maxFilesize||this.matchFile(c,{base:m.fsPath,relativePath:B,searchPath:this.getSearchPath(i,B)}),U(null,void 0)))})},L=>{const U=L&&_.coalesce(L);return h(U&&U.length>0?U[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,D.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,n){return r.isSymbolicLink()?t.stat(i,n):n(null,r)}realPathIfNeeded(i,r,n){return r.isSymbolicLink()?t.realpath(i,(c,h)=>c?n(c):n(null,h)):n(null,i)}getSearchPath(i,r){return i.folderName?D.join(i.folderName,r):r}}e.FileWalker=a;class g{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new a(i)}search(i,r,n){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(c,h)=>{n(c,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class s{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,n;Object.keys(i).filter(c=>i[c]).forEach(c=>{D.isAbsolute(c)?(r=r||E.getEmptyExpression(),r[c]=i[c]):(n=n||E.getEmptyExpression(),n[c]=i[c])}),this.absoluteParsedExpr=r&&E.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=n&&E.parse(n,{trimForExclusions:!0})}test(i,r,n){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,i),r,n)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...E.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...E.getPathTerms(this.relativeParsedExpr)),i}}function u(o){const i=o.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return T.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=u}),define(De[290],Ie([1,0,95,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===o)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,_=512,y=512*8,E=512*128;var I;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(i,r){super(i),this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class k{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((c,h)=>{J(["@vscode/iconv-lite-umd"],c,h)})).getDecoder(b(i));else{const n=new TextDecoder;r={write(c){return n.decode(c,{stream:!0})},end(){return n.decode()}}}return new k(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function S(o,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?y:_;return new Promise((n,c)=>{const h=(0,l.newWriteableStream)(A=>A.join("")),m=[];let C=0,L,U;const B=async()=>{try{const A=await u({buffer:t.VSBuffer.concat(m),bytesRead:C},i.guessEncoding);if(A.seemsBinary&&i.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);A.encoding=await i.overwriteEncoding(A.encoding),L=await k.create(A.encoding);const M=L.write(t.VSBuffer.concat(m).buffer);h.write(M),m.length=0,C=0,n({stream:h,detected:A})}catch(A){U?.dispose(),h.destroy(),c(A)}};U=(0,l.listenStream)(o,{onData:async A=>{L?h.write(L.write(A.buffer)):(m.push(A),C+=A.byteLength,C>=r&&(o.pause(),await B(),setTimeout(()=>o.resume())))},onError:A=>h.error(A),onEnd:async()=>{L||await B(),h.end(L?.end())}})})}e.toDecodeStream=S;async function T(o,i,r){const c=(await new Promise((C,L)=>{J(["@vscode/iconv-lite-umd"],C,L)})).getEncoder(b(i),r);let h=!1,m=!1;return{read(){if(m)return null;const C=o.read();if(typeof C!="string"){if(m=!0,!h&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=c.end();return L&&L.length>0?(h=!0,t.VSBuffer.wrap(L)):null}return h=!0,t.VSBuffer.wrap(c.write(C))}}}e.toEncodeReadable=T;async function w(o){return(await new Promise((r,n)=>{J(["@vscode/iconv-lite-umd"],r,n)})).encodingExists(b(o))}e.encodingExists=w;function b(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=b;function v(o,i){if(!o||i<e.UTF16be_BOM.length)return null;const r=o.readUInt8(0),n=o.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const c=o.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const d=["ascii","utf-16","utf-32"];async function p(o){const i=await new Promise((m,C)=>{J(["jschardet"],m,C)}),r=o.slice(0,E),n=g(r.buffer),c=i.detect(n);if(!c||!c.encoding)return null;const h=c.encoding.toLowerCase();return 0<=d.indexOf(h)?null:a(c.encoding)}const f={ibm866:"cp866",big5:"cp950"};function a(o){const i=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[i]||i}function g(o){let i="";for(let r=0;r<o.length;r++)i+=String.fromCharCode(o[r]);return i}function s(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=o.match(/windows(\d+)/);return i?"windows-"+i[1]:o}}}e.toCanonicalName=s;function u({buffer:o,bytesRead:i},r){let n=v(o,i),c=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&o){let h=!0,m=!0,C=!1;for(let L=0;L<i&&L<P;L++){const U=L%2===1,B=o.readUInt8(L)===0;if(B&&(C=!0),h&&(U&&!B||!U&&B)&&(h=!1),m&&(U&&B||!U&&!B)&&(m=!1),B&&!h&&!m)break}C&&(h?n=e.UTF16le:m?n=e.UTF16be:c=!0)}return r&&!c&&!n&&o?p(o.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:c,encoding:n}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[141],Ie([1,0,290,29,140]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends D.TextSearchManager{constructor(y,E,I=t,R="searchProcess"){super(y,E,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,l.toCanonicalName)(k)},R)}}e.NativeTextSearchManager=P}),define(De[291],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,P){this._renderedElements.set(D,P)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=l}),define(De[292],Ie([1,0,174,7,22,2,4,6,18,7,13,17,16,21,291]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function b(p,f){if((0,R.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let a;return Array.isArray(p.highlights)&&(a=p.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),a=a.length?a:void 0),{label:p.label,highlights:a}}}class v{constructor(f,a,g){this._proxy=f,this.commands=a,this.logService=g,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function s(u){return u&&u.$treeViewId&&u.$treeItemHandle}a.registerArgumentProcessor({processArgument:u=>s(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(o=>s(o)?this.convertArgument(o):o):u})}registerTreeDataProvider(f,a,g){const s=this.createTreeView(f,{treeDataProvider:a},g);return{dispose:()=>s.dispose()}}createTreeView(f,a,g){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=a.dragAndDropController?.dropMimeTypes??[],u=a.dragAndDropController?.dragMimeTypes??[],o=!!a.dragAndDropController?.handleDrag,i=!!a.dragAndDropController?.handleDrop,r=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dropMimeTypes:s,dragMimeTypes:u,hasHandleDrag:o,hasHandleDrop:i}),n=this.createExtHostTreeView(f,a,g);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(c){n.message=c},get title(){return n.title},set title(c){n.title=c},get description(){return n.description},set description(c){n.description=c},get badge(){return n.badge},set badge(c){n.badge=c},reveal:(c,h)=>n.reveal(c,h),dispose:async()=>{await r,this.treeViews.delete(f),n.dispose()}}}$getChildren(f,a){const g=this.treeViews.get(f);return g?g.getChildren(a):Promise.reject(new Error((0,l.localize)(0,null,f)))}async $handleDrop(f,a,g,s,u,o,i,r){const n=this.treeViews.get(f);if(!n)return Promise.reject(new Error((0,l.localize)(1,null,f)));const c=S.DataTransfer.toDataTransfer(g,async h=>(await this._proxy.$resolveDropFileData(f,a,h)).buffer);return i===f&&r&&await this.addAdditionalTransferItems(c,n,r,u,o),n.onDrop(c,s,u)}async addAdditionalTransferItems(f,a,g,s,u){const o=this.treeDragAndDropService.removeDragOperationTransfer(u);if(o)(await o)?.forEach((i,r)=>{i&&f.set(r,i)});else if(u&&a.handleDrag){const i=a.handleDrag(g,f,s);this.treeDragAndDropService.addDragOperationTransfer(u,i),await i}return f}async $handleDrag(f,a,g,s){const u=this.treeViews.get(f);if(!u)return Promise.reject(new Error((0,l.localize)(2,null,f)));const o=await this.addAdditionalTransferItems(new t.DataTransfer,u,a,s,g);if(!!o)return S.DataTransfer.toDataTransferDTO(o)}async $hasResolve(f){const a=this.treeViews.get(f);if(!a)throw new Error((0,l.localize)(3,null,f));return a.hasResolve}$resolve(f,a,g){const s=this.treeViews.get(f);if(!s)throw new Error((0,l.localize)(4,null,f));return s.resolveTreeItem(a,g)}$setExpanded(f,a,g){const s=this.treeViews.get(f);if(!s)throw new Error((0,l.localize)(5,null,f));s.setExpanded(a,g)}$setSelection(f,a){const g=this.treeViews.get(f);if(!g)throw new Error((0,l.localize)(6,null,f));g.setSelection(a)}$setVisible(f,a){const g=this.treeViews.get(f);if(!g)throw new Error((0,l.localize)(7,null,f));g.setVisible(a)}createExtHostTreeView(f,a,g){const s=new d(f,a,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(f,s),s}convertArgument(f){const a=this.treeViews.get(f.$treeViewId);return a?a.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=v;class d extends y.Disposable{constructor(f,a,g,s,u,o){if(super(),this.viewId=f,this.proxy=g,this.commands=s,this.logService=u,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,o.contributes&&o.contributes.views)for(const n in o.contributes.views)for(const c of o.contributes.views[n])c.id===f&&(this._title=c.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,r;this._register(_.Event.debounce(this._onDidChangeData.event,(n,c)=>(n||(n={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(h=>r=h),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(c.element)?n.elements.push(...c.element):n.elements.push(c.element)),c.message&&(n.message=!0),n),200,!0)(({message:n,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=r;return i=null,this.refresh(c).then(()=>h())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,R.isUndefinedOrNull)(f))}async getChildren(f){const a=f?this.getExtensionElement(f):void 0;if(f&&!a)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(f);return g||(g=await this.fetchChildrenNodes(a)),g?g.map(s=>s.item):void 0}getExtensionElement(f){return this.elements.get(f)}reveal(f,a){a=a||{select:!0,focus:!1};const g=(0,R.isUndefinedOrNull)(a.select)?!0:a.select,s=(0,R.isUndefinedOrNull)(a.focus)?!1:a.focus,u=(0,R.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(o=>this.resolveTreeNode(f,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(r=>r.item)},{select:g,focus:s,expand:u})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:s,expand:u})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}get badge(){return this._badge}set badge(f){this._badge?.value===f?.value&&this._badge?.tooltip===f?.tooltip||(this._badge=S.ViewBadge.from(f),this.proxy.$setBadge(this.viewId,f))}setExpanded(f,a){const g=this.getExtensionElement(f);g&&(a?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(f){(0,k.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(f,a,g){const s=[];for(const u of f){const o=this.getExtensionElement(u);o&&s.push(o)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,a,g),a}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(f,a,g){const s=a?this.getExtensionElement(a):void 0;if(!(!s&&a||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,f,g):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,a){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(f);if(g){const s=this.nodes.get(g);if(s){const u=await this.dataProvider.resolveTreeItem(s.extensionItem,g,a)??s.extensionItem;return this.validateTreeItem(u),s.item.tooltip=this.getTooltip(u.tooltip),s.item.command=this.getCommand(s.disposableStore,u.command),s.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(a=>a?this.resolveUnknownParentChain(a).then(g=>this.resolveTreeNode(a,g[g.length-1]).then(s=>(g.push(s),g))):Promise.resolve([]))}resolveParent(f){const a=this.nodes.get(f);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,a){const g=this.nodes.get(f);return g?Promise.resolve(g):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(s=>this.createHandle(f,s,a,!0)).then(s=>this.getChildren(a?a.item.handle:void 0).then(()=>{const u=this.getExtensionElement(s);if(u){const o=this.nodes.get(u);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(f){if(f){let a;if(typeof f=="string"){const g=this.getExtensionElement(f);a=g?this.nodes.get(g):void 0}else a=f;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const a=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=f?this.nodes.get(f):void 0,s=await this.dataProvider.getChildren(f);if(a.token.isCancellationRequested)return;const u=await Promise.all((0,k.coalesce)(s||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,g):null}));return a.token.isCancellationRequested?void 0:(0,k.coalesce)(u)}finally{a.dispose()}}refresh(f){if(f.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(f);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const a=new Set,g=f.map(u=>this.nodes.get(u));for(const u of g)if(u&&!a.has(u.item.handle)){let o=u;for(;o&&o.parent&&g.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&a.add(u.item.handle)}const s=[];return a.forEach(u=>{const o=this.elements.get(u);if(o){const i=this.nodes.get(o);i&&(!i.parent||!a.has(i.parent.item.handle))&&s.push(u)}}),s}refreshHandles(f){const a={};return Promise.all(f.map(g=>this.refreshNode(g).then(s=>{s&&(a[g]=s.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(f){const a=this.getExtensionElement(f);if(a){const g=this.nodes.get(a);if(g)return this.clearChildren(a),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(s=>{if(s){const u=this.createTreeNode(a,s,g.parent);return this.updateNodeCache(a,u,g,g.parent),g.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,a,g){const s=this.createTreeNode(f,a,g);if(a.id&&this.elements.has(s.item.handle))throw new Error((0,l.localize)(8,null,a.id));return this.addNodeToCache(f,s),this.addNodeToParentCache(s,g),s}getTooltip(f){return I.MarkdownString.isMarkdownString(f)?S.MarkdownString.from(f):f}getCommand(f,a){return a?{...this.commands.toInternal(a,f),originalId:a.command}:void 0}validateTreeItem(f){if(!I.TreeItem.isTreeItem(f))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(f,a,g){this.validateTreeItem(a);const s=new y.DisposableStore,u=this.createHandle(f,a,g),o=this.getLightIconPath(a);return{item:{handle:u,parentHandle:g?g.item.handle:void 0,label:b(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(s,a.command),contextValue:a.contextValue,icon:o,iconDark:this.getDarkIconPath(a)||o,themeIcon:this.getThemeIcon(a),collapsibleState:(0,R.isUndefinedOrNull)(a.collapsibleState)?I.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:g,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(f){return f.iconPath instanceof I.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:a,label:g,resourceUri:s},u,o){if(a)return`${d.ID_HANDLE_PREFIX}/${a}`;const i=b(g,this.extension),r=u?u.item.handle:d.LABEL_HANDLE_PREFIX;let n=i?i.label:s?(0,D.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const c=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,h=this.getChildrenNodes(u)||[];let m,C=0;do{if(m=`${r}/${C}:${n}`,o||!this.elements.has(m)||c===m)break;C++}while(C<=h.length);return m}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof I.ThemeIcon))return typeof f.iconPath=="string"||P.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof I.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return P.URI.isUri(f)?f:P.URI.file(f)}addNodeToCache(f,a){this.elements.set(a.item.handle,f),this.nodes.set(f,a)}updateNodeCache(f,a,g,s){this.elements.delete(a.item.handle),this.nodes.delete(f),a.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(f,a);const u=this.getChildrenNodes(s)||[],o=u.filter(i=>i.item.handle===g.item.handle)[0];o&&u.splice(u.indexOf(o),1,a)}addNodeToParentCache(f,a){a?(a.children||(a.children=[]),a.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const a=this.nodes.get(f);if(a){if(a.children)for(const g of a.children){const s=this.elements.get(g.item.handle);s&&this.clear(s)}a.children=void 0}}else this.clearAll()}clear(f){const a=this.nodes.get(f);if(a){if(a.children)for(const g of a.children){const s=this.elements.get(g.item.handle);s&&this.clear(s)}this.nodes.delete(f),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(De[293],Ie([1,0,21,10,4,41,2,114,99,148,157,42,5,134,237,236,37,238,33,240,241,242,220,243,56,39,244,245,248,249,250,139,223,254,255,256,91,38,258,292,16,7,261,70,138,32,209,247,122,135,72,74,75,14,54,15,26,251,206,53,67,234,259,69,68,264,262,263,235,46,257,260,90,57,124,252,71,253,12,117,222,204,246,6,28,210,137]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a,g,s,u,o,i,r,n,c,h,m,C,L,U,B,A,M,$,N,K,z,O,x,V,q,Y,Q,he,ve,ne,pe,be,ke,Le,We,oe,ue,fe,Z,ae,ee,ie,F,H,G,X,me,we,le,Ce,ye,$e,je,Ze,Ye,Oe,ot,re,se,Ee,de,Te,Ne,Be,ze,Xe,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ct(st){const et=st.get(ue.IExtHostInitDataService),gt=st.get(Ce.IExtHostFileSystemInfo),wt=st.get(G.IExtHostConsumerFileSystem),Dt=st.get(i.IExtHostExtensionService),ft=st.get(Y.IExtHostWorkspace),It=st.get(Ye.IExtHostTelemetry),Mt=st.get(p.IExtHostConfiguration),Ot=st.get(We.IURITransformerService),Ge=st.get(oe.IExtHostRpcService),Ft=st.get(M.IExtHostStorage),At=st.get(H.IExtensionStoragePaths),Nt=st.get(Le.ILoggerService),vt=st.get(Le.ILogService),kt=st.get(ae.IExtHostTunnelService),Pe=st.get(nt.IExtHostTelemetryLogService),Re=st.get(ee.IExtHostApiDeprecationService),_e=st.get(q.IExtHostWindow),te=st.get(je.IExtHostSecretState),Fe=st.get(Ze.IExtHostEditorTabs);Ge.set(S.ExtHostContext.ExtHostFileSystemInfo,gt),Ge.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Ge.set(S.ExtHostContext.ExtHostWorkspace,ft),Ge.set(S.ExtHostContext.ExtHostConfiguration,Mt),Ge.set(S.ExtHostContext.ExtHostExtensionService,Dt),Ge.set(S.ExtHostContext.ExtHostStorage,Ft),Ge.set(S.ExtHostContext.ExtHostTunnelService,kt),Ge.set(S.ExtHostContext.ExtHostWindow,_e),Ge.set(S.ExtHostContext.ExtHostSecretState,te),Ge.set(S.ExtHostContext.ExtHostTelemetry,It),Ge.set(S.ExtHostContext.ExtHostEditorTabs,Fe);const Ve=Ge.set(S.ExtHostContext.ExtHostDecorations,st.get(ne.IExtHostDecorations)),it=Ge.set(S.ExtHostContext.ExtHostDocumentsAndEditors,st.get(o.IExtHostDocumentsAndEditors)),Ke=Ge.set(S.ExtHostContext.ExtHostCommands,st.get(v.IExtHostCommands)),Je=Ge.set(S.ExtHostContext.ExtHostTerminalService,st.get($.IExtHostTerminalService)),ut=Ge.set(S.ExtHostContext.ExtHostDebugService,st.get(be.IExtHostDebugService)),Tt=Ge.set(S.ExtHostContext.ExtHostSearch,st.get(ke.IExtHostSearch)),Et=Ge.set(S.ExtHostContext.ExtHostTask,st.get(pe.IExtHostTask)),_t=Ge.set(S.ExtHostContext.ExtHostOutputService,st.get(C.IExtHostOutputService)),yt=Ge.set(S.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Ge)),pt=Ge.set(S.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ge,it)),Ct=Ge.set(S.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Ge,it,vt)),Qt=Ge.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(vt,pt,Ge.getProxy(S.MainContext.MainThreadBulkEdits))),bt=Ge.set(S.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(Ge,Ke,it,pt,At)),qt=Ge.set(S.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(bt)),Ht=Ge.set(S.ExtHostContext.ExtHostNotebookEditors,new de.ExtHostNotebookEditors(vt,bt)),zt=Ge.set(S.ExtHostContext.ExtHostNotebookKernels,new Oe.ExtHostNotebookKernels(Ge,et,bt,Ke,vt)),mn=Ge.set(S.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Ge,bt)),Rt=Ge.set(S.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ge,it)),sn=Ge.set(S.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ge.getProxy(S.MainContext.MainThreadTreeViews),Ke,vt)),Yt=Ge.set(S.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Ge.getProxy(S.MainContext.MainThreadEditorInsets),Rt,et.remote)),Jt=Ge.set(S.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Ge,vt,gt)),Zt=Ge.set(S.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ge,pt,Ke.converter,Ot)),dt=Ge.set(S.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ge,Ot,pt,Ke,Jt,vt,Re)),gn=Ge.set(S.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ge,dt)),Wt=Ge.set(S.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(Ge,vt,it)),Gt=Ge.set(S.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(Ge,ft,Ke)),on=Ge.set(S.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(Ge,Ke,vt)),pn=Ge.set(S.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ge,Ke,pt)),Cn=Ge.set(S.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ge.getProxy(S.MainContext.MainThreadProgress))),An=Ge.set(S.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(Ge)),an=Ge.set(S.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ge)),en=Ge.set(S.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Ge)),vn=Ge.set(S.ExtHostContext.ExtHostTimeline,new F.ExtHostTimeline(Ge,Ke)),nn=Ge.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ge,et.remote,ft,vt,Re)),bn=Ge.set(S.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Ge,nn,ft)),wn=Ge.set(S.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Ge,pt,At,nn,bn)),En=Ge.set(S.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Ge,nn)),rn=Ge.set(S.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Ge,Ke,it)),Rn=Ge.set(S.ExtHostContext.ExtHostUriOpeners,new $e.ExtHostUriOpeners(Ge));Ge.set(S.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Ge,bt,it,Ke,vt));const Ln=Object.values(S.ExtHostContext);Ge.assertRegistered(Ln);const On=new le.ExtHostBulkEdits(Ge,it),Fn=new b.ExtHostClipboard(Ge),Sn=new m.ExtHostMessageService(Ge,vt),cn=new a.ExtHostDialogs(Ge),ln=new A.ExtHostStatusBar(Ge,Ke.converter);return w.ExtHostApiCommands.register(Ke),function(He,xt,Dn){const mt=function(){let ge=!He.isUnderDevelopment;function Se(){ge||(vt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")Se();else{const St=at;typeof St.scheme>"u"&&Se(),typeof St.exclusive=="boolean"&&(0,ze.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Nn={getSession(ge,Se,Me){return en.getSession(He,ge,Se,Me)},async hasSession(ge,Se){return(0,ze.checkProposedApiEnabled)(He,"authSession"),!!await en.getSession(He,ge,Se,{silent:!0})},get onDidChangeSessions(){return en.onDidChangeSessions},registerAuthenticationProvider(ge,Se,Me,at){return en.registerAuthenticationProvider(ge,Se,Me,at)}},Mn={registerCommand(ge,Se,Me){return Ke.registerCommand(!0,ge,Se,Me,void 0,He)},registerTextEditorCommand(ge,Se,Me){return Ke.registerCommand(!0,ge,(...at)=>{const St=Rt.getActiveTextEditor();if(!St){vt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Pt=>{Se.apply(Me,[St,Pt,...at])}).then(Pt=>{Pt||vt.warn("Edits from command "+ge+" were not applied.")},Pt=>{vt.warn("An error occurred while running command "+ge,Pt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,Se,Me)=>((0,ze.checkProposedApiEnabled)(He,"diffCommand"),Ke.registerCommand(!0,ge,async(...at)=>{const St=it.activeEditor(!0);if(!St){vt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Pt=await Rt.getDiffInformation(St.id);Se.apply(Me,[Pt,...at])},void 0,void 0,He)),executeCommand(ge,...Se){return Ke.executeCommand(ge,...Se)},getCommands(ge=!1){return Ke.getCommands(ge)}},In={get machineId(){return et.telemetryInfo.machineId},get sessionId(){return et.telemetryInfo.sessionId},get language(){return et.environment.appLanguage},get appName(){return et.environment.appName},get appRoot(){return et.environment.appRoot?.fsPath??""},get appHost(){return et.environment.appHost},get uriScheme(){return et.environment.appUriScheme},get clipboard(){return Fn.value},get shell(){return Je.getDefaultShell(!1)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(He,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(He,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ge=Date.now()-new Date(et.telemetryInfo.firstSessionDate).getTime();return isNaN(ge)?!1:ge<1e3*60*60*24},openExternal(ge,Se){return _e.openUri(ge,{allowTunneling:!!et.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===et.environment.appUriScheme)return yt.createAppUri(ge);try{return await _e.asExternalUri(ge,{allowTunneling:!!et.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ge,se.Schemas.http)||(0,Ee.matchesScheme)(ge,se.Schemas.https))return ge;throw Se}},get remoteName(){return(0,ve.getRemoteName)(et.remote.authority)},get remoteAuthority(){return(0,ze.checkProposedApiEnabled)(He,"resolvers"),et.remote.authority},get uiKind(){return et.uiKind}};et.environment.extensionTestsLocationURI||Object.freeze(In);const Un={createTestController(ge,Se,Me){return rn.createTestController(ge,Se,Me)},createTestObserver(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),rn.createTestObserver()},runTests(ge){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),rn.runTests(ge)},get onDidChangeTestResults(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),rn.onResultsChanged},get testResults(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),rn.results}},tn=et.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Bn={getExtension(ge,Se){(0,ze.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Me=xt.mine.getExtensionDescription(ge);if(Me)return new i.Extension(Dt,He.identifier,Me,tn,!1);if(Se){const at=xt.all.getExtensionDescription(ge);if(at)return new i.Extension(Dt,He.identifier,at,tn,!0)}},get all(){const ge=[];for(const Se of xt.mine.getAllExtensionDescriptions())ge.push(new i.Extension(Dt,He.identifier,Se,tn,!1));return ge},get allAcrossExtensionHosts(){(0,ze.checkProposedApiEnabled)(He,"extensionsAny");const ge=new ze.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Se=[];for(const Me of xt.all.getAllExtensionDescriptions()){const at=!ge.has(Me.identifier);Se.push(new i.Extension(Dt,He.identifier,Me,tn,at))}return Se},get onDidChange(){return(0,ze.isProposedApiEnabled)(He,"extensionsAny")?D.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},Vt={createDiagnosticCollection(ge){return Jt.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:ge=>Jt.getDiagnostics(ge),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(ge,Se){return Zt.changeLanguage(ge.uri,Se)},match(ge,Se){const Me=pt.getDocumentData(Se.uri)?.notebook;return(0,R.score)(z.LanguageSelector.from(ge),Se.uri,Se.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Se,Me){return dt.registerCodeActionProvider(He,mt(ge),Se,Me)},registerDocumentPasteEditProvider(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,mt(ge),Se,Me)},registerCodeLensProvider(ge,Se){return dt.registerCodeLensProvider(He,mt(ge),Se)},registerDefinitionProvider(ge,Se){return dt.registerDefinitionProvider(He,mt(ge),Se)},registerDeclarationProvider(ge,Se){return dt.registerDeclarationProvider(He,mt(ge),Se)},registerImplementationProvider(ge,Se){return dt.registerImplementationProvider(He,mt(ge),Se)},registerTypeDefinitionProvider(ge,Se){return dt.registerTypeDefinitionProvider(He,mt(ge),Se)},registerHoverProvider(ge,Se){return dt.registerHoverProvider(He,mt(ge),Se,He.identifier)},registerEvaluatableExpressionProvider(ge,Se){return dt.registerEvaluatableExpressionProvider(He,mt(ge),Se,He.identifier)},registerInlineValuesProvider(ge,Se){return dt.registerInlineValuesProvider(He,mt(ge),Se,He.identifier)},registerDocumentHighlightProvider(ge,Se){return dt.registerDocumentHighlightProvider(He,mt(ge),Se)},registerLinkedEditingRangeProvider(ge,Se){return dt.registerLinkedEditingRangeProvider(He,mt(ge),Se)},registerReferenceProvider(ge,Se){return dt.registerReferenceProvider(He,mt(ge),Se)},registerRenameProvider(ge,Se){return dt.registerRenameProvider(He,mt(ge),Se)},registerDocumentSymbolProvider(ge,Se,Me){return dt.registerDocumentSymbolProvider(He,mt(ge),Se,Me)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,Se){return dt.registerDocumentFormattingEditProvider(He,mt(ge),Se)},registerDocumentRangeFormattingEditProvider(ge,Se){return dt.registerDocumentRangeFormattingEditProvider(He,mt(ge),Se)},registerOnTypeFormattingEditProvider(ge,Se,Me,...at){return dt.registerOnTypeFormattingEditProvider(He,mt(ge),Se,[Me].concat(at))},registerDocumentSemanticTokensProvider(ge,Se,Me){return dt.registerDocumentSemanticTokensProvider(He,mt(ge),Se,Me)},registerDocumentRangeSemanticTokensProvider(ge,Se,Me){return dt.registerDocumentRangeSemanticTokensProvider(He,mt(ge),Se,Me)},registerSignatureHelpProvider(ge,Se,Me,...at){return typeof Me=="object"?dt.registerSignatureHelpProvider(He,mt(ge),Se,Me):dt.registerSignatureHelpProvider(He,mt(ge),Se,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(ge,Se,...Me){return dt.registerCompletionItemProvider(He,mt(ge),Se,Me)},registerInlineCompletionItemProvider(ge,Se){return Se.handleDidShowCompletionItem&&(0,ze.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,mt(ge),Se)},registerInlineCompletionItemProviderNew(ge,Se){if((0,ze.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,ze.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,mt(ge),Se)},registerDocumentLinkProvider(ge,Se){return dt.registerDocumentLinkProvider(He,mt(ge),Se)},registerColorProvider(ge,Se){return dt.registerColorProvider(He,mt(ge),Se)},registerFoldingRangeProvider(ge,Se){return dt.registerFoldingRangeProvider(He,mt(ge),Se)},registerSelectionRangeProvider(ge,Se){return dt.registerSelectionRangeProvider(He,ge,Se)},registerCallHierarchyProvider(ge,Se){return dt.registerCallHierarchyProvider(He,ge,Se)},registerTypeHierarchyProvider(ge,Se){return dt.registerTypeHierarchyProvider(He,ge,Se)},setLanguageConfiguration:(ge,Se)=>dt.setLanguageConfiguration(He,ge,Se),getTokenInformationAtPosition(ge,Se){return(0,ze.checkProposedApiEnabled)(He,"tokenInformation"),Zt.tokenAtPosition(ge,Se)},registerInlayHintsProvider(ge,Se){return dt.registerInlayHintsProvider(He,ge,Se)},createLanguageStatusItem(ge,Se){return Zt.createLanguageStatusItem(He,ge,Se)},registerDocumentDropEditProvider(ge,Se){return dt.registerDocumentOnDropEditProvider(He,ge,Se)}},un={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return Je.activeTerminal},get terminals(){return Je.terminals},async showTextDocument(ge,Se,Me){const at=await(_.URI.isUri(ge)?Promise.resolve(kn.openTextDocument(ge)):Promise.resolve(ge));return Rt.showTextDocument(at,Se,Me)},createTextEditorDecorationType(ge){return Rt.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,Se,Me){return Rt.onDidChangeActiveTextEditor(ge,Se,Me)},onDidChangeVisibleTextEditors(ge,Se,Me){return Rt.onDidChangeVisibleTextEditors(ge,Se,Me)},onDidChangeTextEditorSelection(ge,Se,Me){return Rt.onDidChangeTextEditorSelection(ge,Se,Me)},onDidChangeTextEditorOptions(ge,Se,Me){return Rt.onDidChangeTextEditorOptions(ge,Se,Me)},onDidChangeTextEditorVisibleRanges(ge,Se,Me){return Rt.onDidChangeTextEditorVisibleRanges(ge,Se,Me)},onDidChangeTextEditorViewColumn(ge,Se,Me){return Rt.onDidChangeTextEditorViewColumn(ge,Se,Me)},onDidCloseTerminal(ge,Se,Me){return Je.onDidCloseTerminal(ge,Se,Me)},onDidOpenTerminal(ge,Se,Me){return Je.onDidOpenTerminal(ge,Se,Me)},onDidChangeActiveTerminal(ge,Se,Me){return Je.onDidChangeActiveTerminal(ge,Se,Me)},onDidChangeTerminalDimensions(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"terminalDimensions"),Je.onDidChangeTerminalDimensions(ge,Se,Me)},onDidChangeTerminalState(ge,Se,Me){return Je.onDidChangeTerminalState(ge,Se,Me)},onDidWriteTerminalData(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Je.onDidWriteTerminalData(ge,Se,Me)},get state(){return _e.state},onDidChangeWindowState(ge,Se,Me){return _e.onDidChangeWindowState(ge,Se,Me)},showInformationMessage(ge,...Se){return Sn.showMessage(He,P.default.Info,ge,Se[0],Se.slice(1))},showWarningMessage(ge,...Se){return Sn.showMessage(He,P.default.Warning,ge,Se[0],Se.slice(1))},showErrorMessage(ge,...Se){return Sn.showMessage(He,P.default.Error,ge,Se[0],Se.slice(1))},showQuickPick(ge,Se,Me){return Gt.showQuickPick(ge,Se,Me)},showWorkspaceFolderPick(ge){return Gt.showWorkspaceFolderPick(ge)},showInputBox(ge,Se){return Gt.showInput(ge,Se)},showOpenDialog(ge){return cn.showOpenDialog(ge)},showSaveDialog(ge){return cn.showSaveDialog(ge)},createStatusBarItem(ge,Se,Me){let at,St,Pt;return typeof ge=="string"?(at=ge,St=Se,Pt=Me):(St=ge,Pt=Se),ln.createStatusBarEntry(He,at,St,Pt)},setStatusBarMessage(ge,Se){return ln.setStatusBarMessage(ge,Se)},withScmProgress(ge){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),Cn.withProgress(He,{location:O.ProgressLocation.SourceControl},(Se,Me)=>ge({report(at){}}))},withProgress(ge,Se){return Cn.withProgress(He,ge,Se)},createOutputChannel(ge,Se){return _t.createOutputChannel(ge,Se,He)},createWebviewPanel(ge,Se,Me,at){return bn.createWebviewPanel(He,ge,Se,Me,at)},createWebviewTextEditorInset(ge,Se,Me,at){return(0,ze.checkProposedApiEnabled)(He,"editorInsets"),Yt.createWebviewEditorInset(ge,Se,Me,at,He)},createTerminal(ge,Se,Me){return typeof ge=="object"?"pty"in ge?Je.createExtensionTerminal(ge):Je.createTerminalFromOptions(ge):Je.createTerminal(ge,Se,Me)},registerTerminalLinkProvider(ge){return Je.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Se){return Je.registerProfileProvider(He,ge,Se)},registerTreeDataProvider(ge,Se){return sn.registerTreeDataProvider(ge,Se,He)},createTreeView(ge,Se){return sn.createTreeView(ge,Se,He)},registerWebviewPanelSerializer:(ge,Se)=>bn.registerWebviewPanelSerializer(He,ge,Se),registerCustomEditorProvider:(ge,Se,Me={})=>wn.registerCustomEditorProvider(He,ge,Se,Me),registerFileDecorationProvider(ge){return Ve.registerFileDecorationProvider(ge,He.identifier)},registerUriHandler(ge){return yt.registerUriHandler(He.identifier,ge)},createQuickPick(){return Gt.createQuickPick(He)},createInputBox(){return Gt.createInputBox(He)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme(ge,Se,Me){return an.onDidChangeActiveColorTheme(ge,Se,Me)},registerWebviewViewProvider(ge,Se,Me){return En.registerWebviewViewProvider(He,ge,Se,Me?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Se,Me){return bt.onDidChangeActiveNotebookEditor(ge,Se,Me)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Se,Me){return Ht.onDidChangeNotebookEditorSelection(ge,Se,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Se,Me){return Ht.onDidChangeNotebookEditorVisibleRanges(ge,Se,Me)},showNotebookDocument(ge,Se){return _.URI.isUri(ge)&&Re.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(ge,Se)},registerExternalUriOpener(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"externalUriOpener"),Rn.registerExternalUriOpener(He.identifier,ge,Se,Me)},get tabGroups(){return Fe.tabGroups},logTelemetryToOutputChannel(ge,Se){(0,ze.checkProposedApiEnabled)(He,"telemetryLog"),Pe.logToTelemetryOutputChannel(He,ge,Se)}},kn={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return ft.getWorkspaceFolder(ge)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ge){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,Se,...Me)=>ft.updateWorkspaceFolders(He,ge,Se||0,...Me),onDidChangeWorkspaceFolders:function(ge,Se,Me){return ft.onDidChangeWorkspace(ge,Se,Me)},asRelativePath:(ge,Se)=>ft.getRelativePath(ge,Se),findFiles:(ge,Se,Me,at)=>ft.findFiles(ge,Se,Me,He.identifier,at),findTextInFiles:(ge,Se,Me,at)=>{(0,ze.checkProposedApiEnabled)(He,"findTextInFiles");let St,Pt;return typeof Se=="object"?(St=Se,Pt=Me):(St={},Pt=Se,at=Me),ft.findTextInFiles(ge,St||{},Pt,He.identifier,at)},saveAll:ge=>ft.saveAll(ge),applyEdit(ge){return On.applyWorkspaceEdit(ge,He)},createFileSystemWatcher:(ge,Se,Me,at)=>Wt.createFileSystemWatcher(ft,He,ge,Se,Me,at),get textDocuments(){return pt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let Se;const Me=ge;if(typeof ge=="string")Se=Promise.resolve(_.URI.file(ge));else if(_.URI.isUri(ge))Se=Promise.resolve(ge);else if(!Me||typeof Me=="object")Se=pt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(at=>pt.ensureDocumentData(at).then(St=>St.document))},onDidOpenTextDocument:(ge,Se,Me)=>pt.onDidAddDocument(ge,Se,Me),onDidCloseTextDocument:(ge,Se,Me)=>pt.onDidRemoveDocument(ge,Se,Me),onDidChangeTextDocument:(ge,Se,Me)=>pt.onDidChangeDocument(ge,Se,Me),onDidSaveTextDocument:(ge,Se,Me)=>pt.onDidSaveDocument(ge,Se,Me),onWillSaveTextDocument:(ge,Se,Me)=>Qt.getOnWillSaveTextDocumentEvent(He)(ge,Se,Me),get notebookDocuments(){return bt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Se){let Me;if(_.URI.isUri(ge))Me=ge,await bt.openNotebookDocument(ge);else if(typeof ge=="string")Me=_.URI.revive(await bt.createNotebookDocument({viewType:ge,content:Se}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Se,Me){return qt.onDidSaveNotebookDocument(ge,Se,Me)},onDidChangeNotebookDocument(ge,Se,Me){return qt.onDidChangeNotebookDocument(ge,Se,Me)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Se,Me,at){return bt.registerNotebookSerializer(He,ge,Se,Me,(0,ze.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(ge,Se,Me,at)=>((0,ze.checkProposedApiEnabled)(He,"notebookContentProvider"),Re.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(He,ge,Se,Me,(0,ze.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(ge,Se,Me)=>Dn.onDidChangeConfiguration(ge,Se,Me),getConfiguration(ge,Se){return Se=arguments.length===1?void 0:Se,Dn.getConfiguration(ge,Se,He)},registerTextDocumentContentProvider(ge,Se){return Ct.registerTextDocumentContentProvider(ge,Se)},registerTaskProvider:(ge,Se)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,ge,Se)),registerFileSystemProvider(ge,Se,Me){return(0,Be.combinedDisposable)(gn.registerFileSystemProvider(He,ge,Se,Me),wt.addFileSystemProvider(ge,Se))},get fs(){return wt.value},registerFileSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"fileSearchProvider"),Tt.registerFileSearchProvider(ge,Se)),registerTextSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"textSearchProvider"),Tt.registerTextSearchProvider(ge,Se)),registerRemoteAuthorityResolver:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),Dt.registerRemoteAuthorityResolver(ge,Se)),registerResourceLabelFormatter:ge=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),An.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Se,Me)=>Wt.onDidCreateFile(ge,Se,Me),onDidDeleteFiles:(ge,Se,Me)=>Wt.onDidDeleteFile(ge,Se,Me),onDidRenameFiles:(ge,Se,Me)=>Wt.onDidRenameFile(ge,Se,Me),onWillCreateFiles:(ge,Se,Me)=>Wt.getOnWillCreateFileEvent(He)(ge,Se,Me),onWillDeleteFiles:(ge,Se,Me)=>Wt.getOnWillDeleteFileEvent(He)(ge,Se,Me),onWillRenameFiles:(ge,Se,Me)=>Wt.getOnWillRenameFileEvent(He)(ge,Se,Me),openTunnel:ge=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),kt.openTunnel(He,ge).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,ze.checkProposedApiEnabled)(He,"resolvers"),kt.getTunnels()},onDidChangeTunnels:(ge,Se,Me)=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),kt.onDidChangeTunnels(ge,Se,Me)),registerPortAttributesProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"portsAttributes"),kt.registerPortsAttributesProvider(ge,Se)),registerTimelineProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"timeline"),vn.registerTimelineProvider(ge,Se,He.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ge=>((0,ze.checkProposedApiEnabled)(He,"workspaceTrust"),ft.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Se,Me)=>ft.onDidGrantWorkspaceTrust(ge,Se,Me),registerEditSessionIdentityProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ge,Se))},Ut={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),on.getLastInputBox(He)},createSourceControl(ge,Se,Me){return on.createSourceControl(He,ge,Se,Me)}},dn={createCommentController(ge,Se){return pn.createCommentController(He,ge,Se)}},zn={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(ge,Se,Me){return ut.onDidStartDebugSession(ge,Se,Me)},onDidTerminateDebugSession(ge,Se,Me){return ut.onDidTerminateDebugSession(ge,Se,Me)},onDidChangeActiveDebugSession(ge,Se,Me){return ut.onDidChangeActiveDebugSession(ge,Se,Me)},onDidReceiveDebugSessionCustomEvent(ge,Se,Me){return ut.onDidReceiveDebugSessionCustomEvent(ge,Se,Me)},onDidChangeBreakpoints(ge,Se,Me){return ut.onDidChangeBreakpoints(ge,Se,Me)},registerDebugConfigurationProvider(ge,Se,Me){return ut.registerDebugConfigurationProvider(ge,Se,Me||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Se){return ut.registerDebugAdapterDescriptorFactory(He,ge,Se)},registerDebugAdapterTrackerFactory(ge,Se){return ut.registerDebugAdapterTrackerFactory(ge,Se)},startDebugging(ge,Se,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ut.startDebugging(ge,Se,{parentSession:Me}):ut.startDebugging(ge,Se,Me||{})},stopDebugging(ge){return ut.stopDebugging(ge)},addBreakpoints(ge){return ut.addBreakpoints(ge)},removeBreakpoints(ge){return ut.removeBreakpoints(ge)},asDebugSourceUri(ge,Se){return ut.asDebugSourceUri(ge,Se)}},Wn={registerTaskProvider:(ge,Se)=>Et.registerTaskProvider(He,ge,Se),fetchTasks:ge=>Et.fetchTasks(ge),executeTask:ge=>Et.executeTask(He,ge),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ge,Se,Me)=>Et.onDidStartTask(ge,Se,Me),onDidEndTask:(ge,Se,Me)=>Et.onDidEndTask(ge,Se,Me),onDidStartTaskProcess:(ge,Se,Me)=>Et.onDidStartTaskProcess(ge,Se,Me),onDidEndTaskProcess:(ge,Se,Me)=>Et.onDidEndTaskProcess(ge,Se,Me)},$n={createNotebookController(ge,Se,Me,at,St){return zt.createNotebookController(He,ge,Se,Me,at,(0,ze.isProposedApiEnabled)(He,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Se)=>bt.registerNotebookCellStatusBarItemProvider(He,ge,Se),createRendererMessaging(ge){return mn.createRendererMessaging(He,ge)},onDidChangeNotebookCellExecutionState(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"notebookCellExecutionState"),zt.onDidChangeNotebookCellExecutionState(ge,Se,Me)}};return{version:et.version,authentication:Nn,commands:Mn,comments:dn,debug:zn,env:In,extensions:Bn,languages:Vt,notebooks:$n,scm:Ut,tasks:Wn,tests:Un,window:un,workspace:kn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:O.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionItemNew:O.InlineSuggestionNew,InlineCompletionList:O.InlineSuggestionList,InlineCompletionListNew:O.InlineSuggestionsNew,Hover:O.Hover,IndentAction:I.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,DocumentDropEdit:O.DocumentDropEdit,DocumentPasteEdit:O.DocumentPasteEdit,InlayHint:O.InlayHint,InlayHintLabelPart:O.InlayHintLabelPart,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookEdit:O.NotebookEdit,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:ot.TextSearchCompleteMessageType,DataTransfer:O.DataTransfer,DataTransferItem:O.DataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.TextTabInput,TabInputTextDiff:O.TextDiffTabInput,TabInputTextMerge:O.TextMergeTabInput,TabInputCustom:O.CustomEditorTabInput,TabInputNotebook:O.NotebookEditorTabInput,TabInputNotebookDiff:O.NotebookDiffEditorTabInput,TabInputWebview:O.WebviewEditorTabInput,TabInputTerminal:O.TerminalEditorTabInput,TabInputInteractiveWindow:O.InteractiveWindowInput,TerminalExitReason:O.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=ct}),define(De[294],Ie([1,0,266,303,304,2,305]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(k,S,T,w,b,v){const d=v.environment.useHostProxy,p=typeof d=="boolean"?d:!v.remote.isRemote,f=(0,_.createProxyResolver)({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(g,s,...u)=>{switch(g){case _.LogLevel.Trace:w.trace(s,...u);break;case _.LogLevel.Debug:w.debug(s,...u);break;case _.LogLevel.Info:w.info(s,...u);break;case _.LogLevel.Warning:w.warn(s,...u);break;case _.LogLevel.Error:w.error(s,...u);break;case _.LogLevel.Critical:w.critical(s,...u);break;case _.LogLevel.Off:break;default:o(g,s,u);break}function o(i,r,...n){w.error("Unknown log level",i),w.error(r,...n)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),a=E(S,f);return R(T,a)}e.connectProxyResolver=y;function E(k,S){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(b=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(b=>{w.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"off"},w,!0)),on:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"on"},w,!0)),override:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"override"},w,!0)),onRequest:Object.assign({},l,(0,_.createHttpPatch)(l,S,T,w,!0)),default:Object.assign(l,(0,_.createHttpPatch)(l,S,T,w,!1))},https:{off:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"off"},w,!0)),on:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"on"},w,!0)),override:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,_.createHttpPatch)(t,S,T,w,!0)),default:Object.assign(t,(0,_.createHttpPatch)(t,S,T,w,!1))},tls:Object.assign(D,(0,_.createTlsPatch)(D))}}const I=new Map;function R(k,S){return k.getExtensionPathIndex().then(T=>{const w=J.__$__nodeRequire("module"),b=w._load;w._load=function(d,p,f){if(d==="tls")return S.tls;if(d!=="http"&&d!=="https")return b.apply(this,arguments);const a=S[d],g=T.findSubstr(P.URI.file(p.filename));let s=I.get(g);if(s||I.set(g,s={}),!s[d]){const u=a.default;s[d]={...u}}return s[d]}})}}),define(De[295],Ie([1,0,73,293,280,294,39,268,2,12,7,265,108,267]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends D.RequireInterceptor{_installInterceptor(){const d=this,p=J.__$__nodeRequire("module"),f=p._load;p._load=function(u,o,i){return u=g(u),d._factories.has(u)?d._factories.get(u).load(u,E.URI.file((0,S.realpathSync)(o.filename)),r=>f.apply(this,[r,o,i])):f.apply(this,arguments)};const a=p._resolveLookupPaths;p._resolveLookupPaths=(s,u)=>a.call(this,g(s),u);const g=s=>{for(const u of d._alternatives){const o=u(s);if(o){s=o;break}}return s}}}class b extends _.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const d=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(w,d,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(d){return d.main}_loadCommonJSModule(d,p,f){if(p.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let a=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();const g=d?.identifier.value;try{g&&l.mark(`code/extHost/willLoadExtensionCode/${g}`),a=J.__$__nodeRequire(p.fsPath)}catch(s){return Promise.reject(s)}finally{g&&l.mark(`code/extHost/didLoadExtensionCode/${g}`),f.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(d){if(!!this._initData.remote.isRemote)for(const p in d){const f=d[p];f===null?delete process.env[p]:process.env[p]=f}}}e.ExtHostExtensionService=b}),define(De[142],Ie([1,0,44,306,289,17,77,36,9,8,2,30,71,307,287,92]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(m){this.outputChannel=m}provideTextSearchResults(m,C,L,U){return this.outputChannel.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((B,A)=>{U.onCancellationRequested(()=>V());const M=u(m,C),$=C.folder.fsPath,N=M.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${v} ${N}
 - cwd: ${$}`);let K=l.spawn(v,M,{cwd:$});K.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),A((0,k.serializeSearchError)(new k.SearchError(ve&&ve.message,k.SearchErrorCode.rgProcessError)))});let z=!1;const O=new a(C.maxResults,$,C.previewOptions);O.on("result",ve=>{z=!0,Y="",L.report(ve)});let x=!1;const V=()=>{x=!0,K?.kill(),O?.cancel()};let q=!1;O.on("hitLimit",()=>{q=!0,V()});let Y="";K.stdout.on("data",ve=>{O.handleData(ve),z||(Y+=ve)});let Q=!1;K.stdout.once("data",()=>Q=!0);let he="";K.stderr.on("data",ve=>{const ne=ve.toString();this.outputChannel.appendLine(ne),he.length+ne.length<1e6&&(he+=ne)}),K.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(z?"Got result from parser":"No result from parser"),Y&&this.outputChannel.appendLine(`Got data without result: ${Y}`),this.outputChannel.appendLine(""),x)B({limitHit:q});else{O.flush(),K=null;let ve;he&&!Q&&(ve=p(he))?A((0,k.serializeSearchError)(new k.SearchError(ve.message,ve.code))):B({limitHit:q})}})})}}e.RipgrepTextSearchEngine=d;function p(h){const m=h.split(`
`),C=m[0].trim();if(m.some(U=>U.startsWith("regex parse error")))return new k.SearchError(f(m),k.SearchErrorCode.regexParseError);const L=C.match(/grep config error: unknown encoding: (.*)/);if(L)return new k.SearchError(`Unknown encoding: ${L[1]}`,k.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new k.SearchError(C.charAt(0).toUpperCase()+C.substr(1),k.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new k.SearchError(C.charAt(0).toUpperCase()+C.substr(1),k.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(C,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function f(h){const m=["Regex parse error"],C=h.filter(L=>L.startsWith("PCRE2:"));if(C.length>=1){const L=C[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const U=L.split(":")[1];m.push(":"+U)}}return m.join("")}e.buildRegexParseError=f;class a extends t.EventEmitter{constructor(m,C,L){super(),this.maxResults=m,this.rootFolder=C,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(m,C){return super.on(m,C),this}handleData(m){if(this.isDone)return;const C=typeof m=="string"?m:this.stringDecoder.write(m);this.handleDecodedData(C)}handleDecodedData(m){let C=m.indexOf(`
`);const L=this.remainder+m;if(C>=0)C+=this.remainder.length;else{this.remainder=L;return}let U=0;for(;C>=0;)this.handleLine(L.substring(U,C).trim()),U=C+1,C=L.indexOf(`
`,U);this.remainder=L.substring(U)}handleLine(m){if(this.isDone||!m)return;let C;try{C=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(C.type==="match"){const L=g(C.data.path),U=R.URI.file(E.join(this.rootFolder,L)),B=this.createTextSearchMatch(C.data,U);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const L=g(C.data.path),U=R.URI.file(E.join(this.rootFolder,L));this.createTextSearchContext(C.data,U).forEach(A=>this.onResult(A))}}createTextSearchMatch(m,C){const L=m.line_number-1,U=g(m.lines),B=Buffer.from(U);let A=0,M=0,$=L;m.submatches.length===0&&m.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(m.submatches.map((K,z)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const O=g(K.match),x=B.slice(A,K.start).toString().length,V=M+x,q=s(O),Y=$,Q=q.numLines+Y,he=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return A=K.end,M=he,$=Q,new S.Range(Y,V,Q,he)}));return(0,b.createTextSearchResult)(C,U,N,this.previewOptions)}createTextSearchContext(m,C){const L=g(m.lines),U=m.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((B,A)=>({text:B,uri:C,lineNumber:U+A}))}onResult(m){this.emit("result",m)}}e.RipgrepParser=a;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function s(h){const m=/\n/g;let C=0,L=-1,U;for(;U=m.exec(h);)C++,L=U.index;const B=L>=0?h.length-L-1:h.length;return{numLines:C,lastLineLength:B}}function u(h,m){const C=["--hidden"];C.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:U}=(0,_.groupBy)(m.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const A=new Set;U.forEach(M=>{A.add(M)}),C.push("-g","!*"),A.forEach(M=>{o(M).map(b.anchorGlob).forEach($=>{C.push("-g",$)})})}L&&L.length&&L.forEach(A=>{C.push("-g",A)}),m.excludes.map(b.anchorGlob).forEach(A=>C.push("-g",`!${A}`)),m.maxFileSize&&C.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),m.followSymlinks&&C.push("--follow"),m.encoding&&m.encoding!=="utf8"&&C.push("--encoding",m.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,I.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),m.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),C.push("--engine","auto"));let B;if(h.isWordMatch){const M=(0,I.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",M)}else if(h.isRegExp){let A=n(h.pattern);A=c(A),C.push("--regexp",A)}else B=h.pattern,C.push("--fixed-strings");return C.push("--no-config"),m.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),h.isMultiline&&C.push("--multiline"),m.beforeContext&&C.push("--before-context",m.beforeContext+""),m.afterContext&&C.push("--after-context",m.afterContext+""),C.push("--"),B&&C.push(B),C.push("."),C}function o(h){const m=(0,y.splitGlobAware)(h,"/");return m.map((C,L)=>m.slice(0,L+1).join("/"))}e.spreadGlobComponents=o;function i(h){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(m);)h=h.replace(m,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(C);)h=h.replace(C,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=i;const r=h=>h.type==="Assertion"&&h.kind==="lookbehind";function n(h){let m;try{m=new T.RegExpParser().parsePattern(h)}catch{return h}let C="",L=0;const U=(M,$,N)=>{C+=h.slice(L,M)+N,L=$},B=[];return new T.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const $=B[0];if(!$)U(M.start,M.end,"\\r?\\n");else if(!B.some(r))if($.type==="CharacterClass")if($.negate){const N=h.slice($.start+2,M.start)+h.slice(M.end,$.end-1);$.parent?.type==="Quantifier"?U($.start,$.end,N?`[^${N}]`:"."):U($.start,$.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=h.slice($.start+1,M.start)+h.slice(M.end,$.end-1);U($.start,$.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else $.type==="Quantifier"&&U(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){B.unshift(M)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(M){B.unshift(M)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(M){B.unshift(M)},onCharacterClassLeave(){B.shift()},onAssertionEnter(M){r(M)&&B.push(M)},onAssertionLeave(M){B[0]===M&&B.shift()}}).visit(m),C+=h.slice(L),C}e.fixRegexNewline=n;function c(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(De[296],Ie([1,0,21,142,118,12]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class _{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,R,k,S){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.vscodeUserData){const w={...R,folder:R.folder.with({scheme:P.Schemas.file})},b=new D.Progress(v=>k.report({...v,uri:v.uri.with({scheme:R.folder.scheme})}));return this.withToken(S,v=>T.provideTextSearchResults(I,w,b,v))}else return this.withToken(S,w=>T.provideTextSearchResults(I,R,k,w))}async withToken(I,R){const k=y(I);this.inProgress.add(k);const S=await R(k.token);return this.inProgress.delete(k),S}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=_;function y(E){const I=new l.CancellationTokenSource;return E.onCancellationRequested(()=>I.cancel()),I}}),define(De[297],Ie([1,0,29,142,141]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(E){this.query=E}search(E,I,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){R({message:T})}},S=new D.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),l);return new Promise((T,w)=>S.search(b=>{I(b.map(_))},E).then(b=>T({limitHit:b.limitHit,type:"success",stats:b.stats}),w))}}e.TextSearchEngineAdapter=P;function _(y){return{path:y.resource&&y.resource.fsPath,results:y.results,numMatches:(y.results||[]).reduce((E,I)=>{if(I.ranges){const R=I;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[298],Ie([1,0,17,18,10,4,104,9,51,2,42,30,288,297]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let g;const s=d(a),u=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(S.Engine,s,i=>u.fire(i),o)),g.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return u.event}textSearch(a){let g;const s=d(a),u=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(s,i=>u.fire(i),o)),g.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return u.event}ripgrepTextSearch(a,g,s){return a.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(a).search(s,g,g)}doFileSearch(a,g,s){return this.doFileSearchWithEngine(S.Engine,a,g,s)}doFileSearchWithEngine(a,g,s,u,o=w.BATCH_SIZE){let i=0;const r=c=>{Array.isArray(c)?(i+=c.length,s(c.map(h=>this.rawMatchToSearchItem(h)))):c.relativePath?(i++,s(this.rawMatchToSearchItem(c))):s(c)};if(g.sortByScore){let c=this.trySortedSearchFromCache(g,r,u);if(!c){const h=g.maxResults?Object.assign({},g,{maxResults:null}):g,m=new a(h);c=this.doSortedSearch(m,g,s,r,u)}return new Promise((h,m)=>{c.then(([C,L])=>{const U=L.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(U,s,o),h(C)},m)})}const n=new a(g);return this.doSearch(n,r,o,u).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,y.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,g,s,u,o){const i=new P.Emitter;let r=(0,t.createCancelablePromise)(c=>{let h=[];const m=C=>{Array.isArray(C)?h=C:(u(C),i.fire(C))};return this.doSearch(a,m,-1,c).then(C=>[C,h])}),n;if(g.cacheKey){n=this.getOrCreateCache(g.cacheKey);const c={promise:r,event:i.event,resolved:!1};n.resultsToSearchCache[g.filePattern||""]=c,r.then(()=>{c.resolved=!0},h=>{delete n.resultsToSearchCache[g.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([c,h])=>{const m=n?n.scorerCache:Object.create(null),C=(typeof g.maxResults!="number"||g.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(g,h,m,o).then(L=>{const U=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:U,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:L.length},messages:c.messages,limitHit:c.limitHit||typeof g.maxResults=="number"&&h.length>g.maxResults},L]})})}getOrCreateCache(a){const g=this.caches[a];return g||(this.caches[a]=new b)}trySortedSearchFromCache(a,g,s){const u=a.cacheKey&&this.caches[a.cacheKey];if(!u)return;const o=this.getResultsFromCache(u,a.filePattern||"",g,s);if(o)return o.then(([i,r,n])=>{const c=E.StopWatch.create(!1);return this.sortResults(a,r,u.scorerCache,s).then(h=>{const m=c.elapsed(),C={fromCache:!0,detailStats:n,type:this.processType,resultCount:r.length,sortingTime:m};return[{type:"success",limitHit:i.limitHit||typeof a.maxResults=="number"&&r.length>a.maxResults,stats:C},h]})})}sortResults(a,g,s,u){const o=(0,_.prepareQuery)(a.filePattern||""),i=(n,c)=>(0,_.compareItemsByFuzzyScore)(n,c,o,!0,v,s),r=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return l.topAsync(g,i,r,1e4,u)}sendProgress(a,g,s){if(s&&s>0)for(let u=0;u<a.length;u+=s)g(a.slice(u,u+s));else g(a)}getResultsFromCache(a,g,s,u){const o=E.StopWatch.create(!1),i=g.indexOf(y.sep)>=0;let r;for(const m in a.resultsToSearchCache)if(g.startsWith(m)){if(i&&m.indexOf(y.sep)<0&&m!=="")continue;const C=a.resultsToSearchCache[m];r={promise:this.preventCancellation(C.promise),event:C.event,resolved:C.resolved};break}if(!r)return null;const n=o.elapsed(),c=E.StopWatch.create(!1),h=r.event(s);return u&&u.onCancellationRequested(()=>{h.dispose()}),r.promise.then(([m,C])=>{if(u&&u.isCancellationRequested)throw(0,D.canceled)();const L=[],U=(0,_.prepareQuery)(g).normalizedLowercase;for(const B of C)!(0,k.isFilePatternMatch)(B,U)||L.push(B);return[m,L,{cacheWasResolved:r.resolved,cacheLookupTime:n,cacheFilterTime:c.elapsed(),cacheEntryCount:C.length}]})}doSearch(a,g,s,u){return new Promise((o,i)=>{let r=[];u?.onCancellationRequested(()=>a.cancel()),a.search(n=>{n&&(s?(r.push(n),s>0&&r.length>=s&&(g(r),r=[])):g(n))},n=>{g(n)},(n,c)=>{r.length&&g(r),n?i(n):o(c)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,s){return a.then(g,s)}catch(g){return this.then(void 0,g)}finally(g){return a.finally(g)}}}}e.SearchService=w,w.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(f){return(0,y.basename)(f.relativePath)}getItemDescription(f){return(0,y.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function d(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(a=>I.URI.revive(a))}}function p(f){return{...f,folder:I.URI.revive(f.folder)}}}),define(De[299],Ie([1,0,6,12,2,29,14,26,15,75,54,30,298,296,92,141]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends I.ExtHostSearch{constructor(p,f,a,g){super(p,a,g),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(s)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(t.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,f){const a=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(p,f,a,g){const s=(0,I.reviveQuery)(a);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,f,s,g):super.$provideFileSearchResults(p,f,a,g)}doInternalFileSearch(p,f,a,g){const s=u=>{if((0,k.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(p,f,u.map(o=>D.URI.file(o.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,s,g)}$clearCache(p){return this._internalFileSearchProvider?.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,f){return new b.NativeTextSearchManager(p,f,void 0,"textSearchProvider")}};v=qe([xe(0,E.IExtHostRpcService),xe(1,y.IExtHostInitDataService),xe(2,R.IURITransformerService),xe(3,_.ILogService)],v),e.NativeExtHostSearch=v}),define(De[300],Ie([1,0,82,271,283,282,299,295,272,74,39,75,72,38,53,69,270,269,14,284,47]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d,p,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(R.IExtHostExtensionService,y.ExtHostExtensionService,!1),(0,l.registerSingleton)(p.ILoggerService,d.ExtHostLoggerService,!0),(0,l.registerSingleton)(b.IExtensionStoragePaths,v.ExtensionStoragePaths,!1),(0,l.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(k.IExtHostSearch,_.NativeExtHostSearch,!1),(0,l.registerSingleton)(S.IExtHostTask,D.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(w.IExtHostTunnelService,E.ExtHostTunnelService,!1),(0,l.registerSingleton)(a.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService,!1)}),define(De[308],Ie([1,0,213,309,73,10,111,112,195,134,281,23,29,108,18,114,208,226,285,300]),function(J,e,l,t,D,P,_,y,E,I,R,k,S,T,w,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const p=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=J.__$__nodeRequire("module"),n=r._load;r._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const f=process.exit.bind(process);function a(r){process.exit=function(n){if(r)f(n);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(r){f()};function s(){const r=(0,d.readExtHostConnection)(process.env);if(r.type===3)return new Promise((n,c)=>{const h=m=>{const C=m[0],L=new _.BufferedEmitter;C.on("message",U=>L.fire(k.VSBuffer.wrap(U.data))),C.on("close",()=>{g("renderer closed the MessagePort")}),C.start(),n({onMessage:L.event,send:U=>C.postMessage(U.buffer)})};if(global.vscodePorts){const m=global.vscodePorts;delete global.vscodePorts,h(m)}else global.vscodePortsCallback=h});if(r.type===2)return new Promise((n,c)=>{let h=null;const m=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),C=108e5,L=3e5,U=new w.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),C),B=new w.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),L);process.on("message",(M,$)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){$.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let K;if(M.skipWebSocketFrames)K=new y.NodeSocket($,"extHost-socket");else{const z=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));K=new y.WebSocketNodeSocket(new y.NodeSocket($,"extHost-socket"),M.permessageDeflate,z,!1)}h?(U.cancel(),B.cancel(),h.beginAcceptReconnection(K,N),h.endAcceptReconnection(),h.sendResume()):(clearTimeout(m),h=new _.PersistentProtocol(K,N),h.sendResume(),h.onDidDispose(()=>g("renderer disconnected")),n(h),h.onSocketClose(()=>{U.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;U.isScheduled()&&B.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const n=r.pipeName;return new Promise((c,h)=>{const m=l.createConnection(n,()=>{m.removeListener("error",h);const C=new _.PersistentProtocol(new y.NodeSocket(m,"extHost-renderer"));C.sendResume(),c(C)});m.once("error",h),m.on("close",()=>{g("renderer closed the socket")})})}}async function u(){const r=await s();return new class{constructor(){this._onMessage=new _.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(n=>{(0,I.isMessageOfType)(n,2)?(this._terminating=!0,g("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||r.send(n)}async drain(){if(r.drain)return r.drain()}}}function o(r){return new Promise(n=>{const c=r.onMessage(h=>{c.dispose();const m=JSON.parse(h.toString()),C=m.commit,L=E.default.commit;if(C&&L&&C!==L&&f(55),m.parentPid){let U=0;setInterval(function(){try{process.kill(m.parentPid,0),U=0}catch(A){A&&A.code==="EPERM"?(U++,U>=3&&g(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):g(`parent process ${m.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let B;try{B=J.__$__nodeRequire("native-watchdog"),B.start(m.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}r.send((0,I.createMessageOfType)(0)),n({protocol:r,initData:m})});r.send((0,I.createMessageOfType)(1))})}async function i(){const r=[];process.on("unhandledRejection",(U,B)=>{r.push(B),setTimeout(()=>{const A=r.indexOf(B);A>=0&&B.catch(M=>{r.splice(A,1),(0,P.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),U&&(0,P.onUnexpectedError)(U))})},1e3)}),process.on("rejectionHandled",U=>{const B=r.indexOf(U);B>=0&&r.splice(B,1)}),process.on("uncaughtException",function(U){(0,P.onUnexpectedError)(U)}),D.mark("code/extHost/willConnectToRenderer");const n=await u();D.mark("code/extHost/didConnectToRenderer");const c=await o(n);D.mark("code/extHost/didWaitForInitData");const{initData:h}=c;a(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,h.environment.skipWorkspaceStorageLock=(0,b.boolean)(p.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(B){f(B)}exists(B){return S.Promises.exists(B)}realpath(B){return(0,T.realpath)(B)}};let C=null;h.remote.authority&&p.transformURIs&&(C=(0,v.createURITransformer)(h.remote.authority));const L=new R.ExtensionHostMain(c.protocol,h,m,C);g=U=>L.terminate(U)}e.startExtensionHostProcess=i,i().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e97a738a8376160783f53d587c2cf420815b1eb1/core/vs/workbench/api/node/extensionHostProcess.js.map
